\APRINT.XPL
\PRINTER HANDLER
\FOR GE TERMINETTE ON THE APPLE

code
RESERVE=3,CHIN=7,CHOUT=8,
REM=2,CRLF=9,NUMIN=10,
NUMOUT=11,TEXT=12,OPENIN=13,
OPENOUT=14,CLOSE=15,ABORT=16;


int
	MAXWID,	\MAXIMUM PAPER WIDTH
	COLLUM,	\CURRENT COLLUMN
	STARPG,	\STARTING PAGE NUMBER
	TEMP,	\TEMPORARY STORAGE
	CHAR,	\GLOBAL CHARACTER
	NCHAR,	\ONE CHARACTER LOOK AHEAD
	OCHAR,	\ONE CHARACTER LOOK BACK
	LINECOUNT,	\HOLDS CURRENT LINE POSITION
	TABCOUNT,	\HOLDS CURRENT LINE POSITION
	PGCTR,	\HOLDS PAGE NUMBER
	EXTRA,	\FLAGS EXTRA FORM FEED
	LMAR,	\LEFT MARGIN
	TABSIZ,	\NUMBER OF SPACES IN A TAB
	IDEV,	\INPUT DEVICE
	GAP,	\LINES BETWEEN FORMS
	PLENGTH,	\LENGTH OF PAGE
	COPCTR,	\COUNTS NUMBER OF COPIES
	COPIES,	\NUMBER OF COPIES TO PRINT
	PGFLG;	\FLAGS PAGE NUMBERS


def	\DEVICE CHANNELS
	CON=0,	\CONSOLE DEVICE
	DUMMY=7,	\THROW AWAY CHANNLE
	PRI=2;	\PRINTER CHANNEL


def	\DEFINE SOME ASCII CHARACTERS 
	SPACE=$20,
	RETURN=13,
	ESC=27,
	CTZ=26,
	FORM=12,
	TAB=9,
	FEED=10;


def	\PAGE CONSTANTS

	FLENGTH=66,	\LENGTH OF FORM
	WIDTH=65;	\PAGE WIDTH

addr
	DATE,	\HOLDS DATE STRING
	TIME;	\HOLDS BAUD RATE TIME CONSTANT



procedure EOL(CHAR);	\TEST FOR END OF LINE
integer CHAR;
return CHAR=RETURN ! CHAR=FEED;



proc YESNO;
integer X;
begin
OPENIN(CON);
return CHIN(CON)=^Y;
end;


procedure DELAY(MILSEC);
integer MILSEC;
integer I,J;
def K=3;
begin
for I:=1,MILSEC do for J:=1,K do;
end;



proc PRION;
begin
OPENOUT(PRI);
CHOUT(PRI,ESC);CHOUT(PRI,^H);
DELAY(430);
end;

proc PRIOFF;
begin
DELAY(300);
CHOUT(PRI,ESC);CHOUT(PRI,^J);
end;



procedure FILL;
begin
case of
	OCHAR=RETURN & CHAR=FEED & NCHAR=FEED:DELAY(266);
	OCHAR=FEED & CHAR=FEED:DELAY(67)
else DELAY(100);
end;


proc MARGIN;
int X;
for X:=1,LMAR do CHOUT(PRI,SPACE);



procedure SKIP;
begin
CHOUT(PRI,RETURN);
CRLF(CON);
DELAY(100);
CHOUT(PRI,FEED);
OCHAR:=RETURN;
CHAR:=FEED;
FILL;
LINECOUNT:=LINECOUNT-1;
end;


proc PAGE;
int X;
begin
PGCTR:=PGCTR+1;
MARGIN;
for X:=1,WIDTH-10 do CHOUT(PRI,SPACE);
TEXT(PRI,"PAGE ");NUMOUT(PRI,PGCTR);
SKIP;
SKIP;
end;

proc TOPFORM;
begin
SKIP;
for TEMP:=1,LINECOUNT do
	begin
	CHOUT(PRI,FEED);
	DELAY(67);
	end;
LINECOUNT:=FLENGTH;
end;



proc ZETAB;
TABCOUNT:=TABSIZ;



proc DOFORM;
begin
TOPFORM;
if PGFLG then PAGE;
ZETAB;
end;


proc GETC;
begin
OCHAR:=CHAR;
CHAR:=NCHAR;
NCHAR:=CHIN(IDEV);
if CHAR=FORM & LINECOUNT>=PLENGTH then GETC;
end;



proc GETDATE;
int X;
begin
X:=0;
loop
	begin
	CHAR:=CHIN(CON);
	if CHAR=13 ! X=20 then quit;
	DATE(X):=CHAR;
	X:=X+1;
	end;
DATE(X-1):=DATE(X-1) ! 128;
end;

proc DOTAB;
int X;
begin
for X:=1,TABCOUNT do CHOUT(PRI,SPACE);
COLLUM:=COLLUM+TABCOUNT;
ZETAB;
end;

proc SETPARM;
int X;
begin
TEXT(CON,"NUMBER OF COPIES");COPIES:=NUMIN(CON);
TEXT(CON,"TAB SIZE? ");TABSIZE:=NUMIN(CON);
IDEV:=3;
TEXT(CON,"EXTRA FORM FEED? "); EXTRA:= YESNO;
TEXT(CON,"GAP BETWEEN FORMS?");X:=NUMIN(CON);
PLENGTH:=FLENGTH-X;
TEXT(CON,"NUMBER PAGES? ");
if YESNO then
	begin
	PGFLG:=true;
	TEXT(CON,"STARTING PAGE NUMBER? ");
	STARPG:=NUMIN(CON);
	end
else PGFLG:=false;
TEXT(CON,"MAXIMUM PAPER WIDTH? ");MAXWID:=NUMIN(0);
end;


proc DEFAULT;
begin
COPIES:=1;
TABSIZE:=8;
IDEV:=3;
EXTRA:=true;
PLENGTH:=64;
PGFLG:=true;
STARPG:=1;
MAXWID:=80;
end;



procedure RESLINE;
\RESET LINE PARAMETERS
begin
if LINECOUNT<=GAP then DOFORM;
if not EOL(NCHAR) then MARGIN;
ZETAB;
COLLUMN:=0;
end;



procedure ENDLINE;
begin
DELAY(100);
CRLF(CON);
CHOUT(PRI,CHAR);
FILL;
LINECOUNT:=LINECOUNT-1;
RESLINE;
end;



proc PRINT;
begin
ZETAB;
COLLUM:=0;
PGCTR:=STARPG;
NCHAR:=0;
CHAR:=0;
OPENIN(IDEV);
GETC;
SKIP;
TEXT(PRI,"                               ");TEXT(PRI,DATE);
SKIP;
MARGIN;
repeat
	begin
	GETC;
	if CHAR#TAB then
		case of
		CHAR=FEED: ENDLINE;
		CHAR=FORM:
			begin
			DOFORM;
			if not EOL(NCHAR) then MARGIN;
			end
		else 
			begin
			CHOUT(PRI,CHAR);
			CHOUT(CON,CHAR);
			TABCOUNT:=TABCOUT-1;
			if TABCOUT<=0 then ZETAB;
			COLLUM:=COLLUM+1;
			if COLLUM>MAXWID then [SKIP;RESLINE];
			end
	else DOTAB;
	end
until CHAR=CTZ;
TOPFORM;
end;


begin	\MAIN

DATE:=RESERVE(20);
LINECOUNT:=FLENGTH;
TEXT(CON,"LEFT MARGIN?");LMAR:=NUMIN(CON);
TEXT(CON,"DATE ");
GETDATE;
TEXT(CON,"1. DEFAULTS, 2. NORMAL");
TEMP:=NUMIN(CON);
if TEMP=1 then DEFAULT else SETPARM;
ZETAB;
GAP:=FLENGTH-PLENGTH;	\GAP BETWEEN PAGES
TEXT(CON,"ALIGN FORMS, THEN TYPE RETURN ");
OPENIN(CON);
TEMP:=CHIN(CON);
PRION;
for COPCTR:=1,COPIES do PRINT;
if EXTRA=true then TOPFORM;
PRIOFF;
end;
