\required global variables:
\int COMPORT
\int LINESTAT,MDMSTAT;
\int CPUREG;
\CPUREG:=GETREG;
\char ERRCHK;

proc ERROR(TXT);
char TXT;
begin
TEXT(0,TXT);
ERRCHK:=true;
end;

proc INITCOMMPORT(BAUD,PARITY,STOPBIT,WORDLNGTH);
int BAUD,PARITY,STOPBIT,WORDLNGTH;
char COMPARAM;
begin
\INTOUT(0,COMPORT);
ERRCHK:=false;

CPUREG(0):=$0400;
CPUREG(3):=COMPORT;
SOFTINT($14);
if CPUREG(0)#$1954 then ERROR("FOSSIL DRIVER NOT PRESENT");
\HEXOUT(0,CPUREG(0));
\CH:=CHIN(1);
\-----------------------------------BAUD
case BAUD of
192:  COMPARAM:=0;
384:  COMPARAM:=32;
3:    COMPARAM:=64;
6:    COMPARAM:=96;
12:   COMPARAM:=128;
24:   COMPARAM:=160;
48:   COMPARAM:=192;
96:   COMPARAM:=224
else ERROR("INCORRECT BAUD INIT");
COMPARAM:=COMPARAM!3;
if ERRCHK then else
        begin
\        TEXT(0,"INIT COMM PORT");
        CPUREG(0):=COMPARAM;
        CPUREG(3):=COMPORT;
        SOFTINT($14);
        LINESTAT:=(CPUREG(0)&$FF00)/$100;
        MDMSTAT:=CPUREG(0)&$FF;
        end;

CPUREG(0):=$0F02;
CPUREG(3):=COMPORT;
SOFTINT($14);

CPUREG(0):=$0601;
CPUREG(3):=COMPORT;
SOFTINT($14);

CPUREG(0):=$1002;
CPUREG(3):=COMPORT;
SOFTINT($14);

end;

proc GETSTAT;
begin
CPUREG(0):=$0300;
CPUREG(3):=COMPORT;
SOFTINT($14);
LINESTAT:=(CPUREG(0)&$FF00)/$100;
MDMSTAT:=CPUREG(0)&$FF;
\LINESTAT:=PIN($3FD,8);
\MDMSTAT:=PIN($3FC,8);
end;

proc COUT(CHR);
char CHR;
begin
CPUREG(0):=$0100!CHR;
CPUREG(3):=COMPORT;
SOFTINT($14);
end;

proc CKKCOM;
if REMOTE then
begin
CPUREG(0):=$0C00;
CPUREG(3):=COMPORT;
SOFTINT($14);
if CPUREG(0)=$FFFF then return false else return true;
end;

proc CIN;
begin
CPUREG(0):=$0200;
CPUREG(3):=COMPORT;
SOFTINT($14);
return CPUREG(0);
end;

proc IOUT(INTEGER);
int INTEGER,ITMP,ITMP2;
begin
ITMP:=10000;
ITMP2:=0;
if INTEGER=0 then COUT(^0) else
loop
        begin
        loop
                begin
                if INTEGER<ITMP then quit;
                ITMP2:=ITMP2+1;
                INTEGER:=INTEGER-ITMP;
                end;
        if ITMP2#0 then COUT(48+ITMP2);
        ITMP:=ITMP/10;
        if ITMP<=1 then [COUT(48+INTEGER);quit];
        end;
end;

proc IIN;
int INTEGER,IT,CONT,IINT;
begin
IINT:=false;
INTEGER:=-1;
SETTICK(0);
GETCURSOR;
\CURSOR(0,0);
\TEXT(6,"Tick: ");
CONT:=true;
\ATTRIB($4F);
\CURSOR(0,1);
loop
        begin
        if CKKCOM then
                begin
                IT:=CIN;
                if IT>=48 & IT<=57 then quit;
                end;

\Check for timeout
        TEMP:=GETTICK;
        if TEMP>18 then [CONT:=false;quit];
        end;
if CONT then
        begin
        INTEGER:=0;
\        TEXT(6,"FIRST ONE: ");
\        HEXOUT(6,CH);
        if IT>=48 & IT<=57 then INTEGER:=INTEGER*10+IT-48;
        loop
                begin
                if CKKCOM then
                        begin
                        IT:=CIN;
\                        TEXT(6,"SECOND ONE: ");
\                        HEXOUT(6,IT);
                        if IT=$0D then quit;
                        if IT>=48 & IT<=57 then INTEGER:=INTEGER*10+IT-48;
                        if INTEGER>9999 then quit;
                        end;

\Check for timeout
                TEMP:=GETTICK;
                if TEMP>36 then [INTEGER:=-1;quit];
        \        CURSOR(6,0);
        \        INTOUT(6,TEMP);
        \        TEXT(6,"   ");
                end;
        return(INTEGER);
        end;
end;

proc FOSSTAT;
begin
CPUREG(0):=3;
CPUREG(3):=COMPORT;
SOFTINT($14);
return(CPUREG(0));
end;

proc FLUSHO;
begin
CPUREG(0):=8;
CPUREG(3):=COMPORT;
SOFTINT($14);
end;

proc OBROOM;    \does the com ports output buffer have room fore more chars?
\begin
return(RETBIT(((FOSSTAT&$FF00)/$100),5));
\end;

proc CARRIER;
begin
GETSTAT;
if RETBIT(MDMSTAT,7) then return(true) else return(false);
end;

proc COMTEXT(CSTRING);
char CSTRING;
int CMTEMP;
begin
CMTEMP:=0;
loop
        begin
        COUT(CSTRING(CMTEMP)&$7F);
        if CSTRING(CMTEMP)&$80 then quit;
        CMTEMP:=CMTEMP+1;
        if CMTEMP>=3000 then quit;
        end;
end;

proc DTR(MODE);
char MODE;
if REMOTE then
begin
CPUREG(0):=$0600+MODE;
CPUREG(3):=COMPORT;
SOFTINT($14);
end;
