\BCOUNT.XPL	SEP-03-99
\This program counts the occurrences of all bytes in the input file.
\ by Loren Blaney

\REVISION HISTORY:
\JUL-01-83, Original on Apple II
\DEC-08-91, Modified for PC
\FEB-01-93, Cleaned up for demo purposes
\SEP-03-99, Converted to byte counter
include	C:\CXPL\CODESI;

def	INTSIZE = 2;
int	COUNTERS,	\Array
	II,
	SUM;
def	EOF=$1A, SP=$20;	\ASCII characters

\Variables for DOS file I/O:
int	CPUREG,		\Pointer to system info
	PSPSEG,		\Address of PSP segment (for file I/O)
	DATASEG,	\Address of data segment (heap & stack)
	INHANDLE,	\Input file handle (= -1 if no input file)
	OUTHANDLE;	\Output file handle (= -1 if no output file)
char	INFILENAME,	\Input file name (all file names are zero terminated)
	OUTFILENAME,	\Output file name
	TMPFILENAME,	\Temporary output file name (.$$$)
	BAKFILENAME;	\Backup output file name (.BAK)
def	NAMESIZE=80;	\Maximum number of chars in a file name (incl path)

\========================== DOS I/O ROUTINES ==========================

proc	DOSOPEN(INEXT, OUTEXT);	\Open MS-DOS files
char	INEXT, OUTEXT;	\input and output extensions
int	INX;		\index into CMDLINE
char	CMDLINE;	\command line tail
def	SP=$20, CR=$0D;


	proc	COPYNAME(FROM, TO, EXT);
	\Copy file name and replace any existing extension with EXT.
	\If EXT = "@@@" then use extension from FROM.
	char	FROM, TO,	\Strings are 0 terminated
		EXT;		\Extension
	int	I, J, CH;
	begin
	I:= 0;
	loop	begin
		CH:= FROM(I);
		if CH=^. ! CH=0 then quit;
		TO(I):= CH;
		if I < NAMESIZE-1 then I:= I +1;
		end;
	TO(I):= ^.;
	if I < NAMESIZE-1 then I:= I +1;
	for J:= 0, 2 do
		begin
		CH:= EXT(J) & $7F;
		TO(I):= if CH=^@ then FROM(I) else CH;
		if I < NAMESIZE-1 then I:= I +1;
		end;
	TO(I):= 0;
	end;	\COPYNAME



	proc	GETNAME(NAME);
	\Read file name from command line and return it in NAME
	\The command line is terminated by a CR.
	char	NAME;
	int	I, CH;


		proc	GETCH;	\Get character and strip out switches
		begin
		CH:= CMDLINE(INX);
		INX:= INX +1;
		if CH=^/ then
			begin			\ignore any one-char switches
			CH:= CMDLINE(INX);
			INX:= INX +1;
			if CH # CR then		\handle wise guys
				begin
				CH:= CMDLINE(INX);
				INX:= INX +1;
				end;
			end;
		end;	\GETCH


	begin
	repeat GETCH until CH # SP;
	I:= 0;
	loop	begin
		if CH=SP ! CH=CR then CH:= 0;	\terminate NAME with 0
		NAME(I):= CH;
		if CH = 0 then quit;
		if I < NAMESIZE-1 then I:= I +1;
		GETCH;
		end;
	end;	\GETNAME


begin	\DOSOPEN
CMDLINE:= RESERVE($7F);			\get command tail from PSP
BLIT(PSPSEG, $81, DATASEG, CMDLINE, $7F);

INHANDLE:= -1;   OUTHANDLE:= -1;	\set to illegal values

INX:= 0;
if INEXT(0) # SP then
	begin				\get the input file name
	GETNAME(INFILENAME);
	COPYNAME(INFILENAME, INFILENAME, INEXT);

	INHANDLE:= FOPEN(INFILENAME, 0);
	FSET(INHANDLE, ^I);
	end;

if OUTEXT(0) # SP then
	begin				\get the output file name
	INX:= INX -1;			\backup in case of CR
	GETNAME(OUTFILENAME);
	if OUTFILENAME(0) =0 then	\if no outfile then use the infile
		COPYNAME(INFILENAME, OUTFILENAME, OUTEXT)
	else	COPYNAME(OUTFILENAME, OUTFILENAME, OUTEXT);

	COPYNAME(OUTFILENAME, TMPFILENAME, "$$$");
	COPYNAME(OUTFILENAME, BAKFILENAME, "BAK");

	OUTHANDLE:= FOPEN(TMPFILENAME, 1);
	FSET(OUTHANDLE, ^O);
	end;
end;	\DOSOPEN

\----------------------------------------------------------------------

proc	DOSCLOSE;	\Close MS-DOS files
begin
if INHANDLE # -1 then FCLOSE(INHANDLE);

if OUTHANDLE # -1 then
	begin
	FCLOSE(OUTHANDLE);

	CPUREG(\AX\0):= $4100;		\DEL OUTFILENAME.BAK
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= BAKFILENAME;
	SOFTINT($21);			\(.BAK file might not exist)

	CPUREG(\AX\0):= $5600;		\REN OUTFILENAME.EXT OUTFILENAME.BAK
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= OUTFILENAME;
	CPUREG(\ES\11):= DATASEG;
	CPUREG(\DI\4):= BAKFILENAME;
	SOFTINT($21);

	CPUREG(\AX\0):= $5600;		\REN OUTFILENAME.$$$ OUTFILENAME.EXT
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= TMPFILENAME;
	CPUREG(\ES\11):= DATASEG;
	CPUREG(\DI\4):= OUTFILENAME;
	SOFTINT($21);
	end;
end;	\DOSCLOSE

\======================================================================

begin	\MAIN
CPUREG:= GETREG;
PSPSEG:= CPUREG(11);
DATASEG:= CPUREG(12);

INFILENAME:= RESERVE(NAMESIZE);
OUTFILENAME:= RESERVE(NAMESIZE);
TMPFILENAME:= RESERVE(NAMESIZE);
BAKFILENAME:= RESERVE(NAMESIZE);

DOSOPEN("@@@", "CNT");

COUNTERS:= RESERVE($100*INTSIZE);
TEXT(0, "
-- ALL-BYTE COUNTER, VER 1.2 --
COUNTING...

");

for II:= 0, $FF do COUNTERS(II):= 0;

TRAP(false);
OPENI(3);
repeat	II:= CHIN(3);
	COUNTERS(II):= COUNTERS(II)+1;
until GETERR \#0\;
TRAP(true);
COUNTERS(EOF):= COUNTERS(EOF)-2;	\compensate for automatic EOFs

for II:= 0, $FF do
	begin
	HEXOUT(0, II);   TEXT(0, "  ");
	TEXT(0, "  ");   INTOUT(0, COUNTERS(II));
	if REM(II/5)=4 then CRLF(0)
	else TEXT(0, "   	");
	end;
CRLF(0);
CRLF(0);
TEXT(0, "Total = ");
SUM:= 0;
for II:= 0, $FF do SUM:= SUM + COUNTERS(II);
INTOUT(0, SUM);
CRLF(0);

DOSCLOSE;
end;	\MAIN
