
\PROGRAM TO HANDLE APROTEK 1000 PROM BLASTER

'CODE'

ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	HEXIN=26	HEXOUT=27
CHAIN=28	OPENF=29	WRITE=30	READ=31
RESTORE=32	SETTXT=33	SETHI=34	SETMIX=35
SETLO=36	BUTTON=37	PADDLE=38	SOUND=39
CLEAR=40	DOT=41		LINE=42		MOVE=43
SCREEN=44	BLOCK=45	FIX=50;

'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;


integer
	PSIZE,	\PROM SIZE
	ERRFLG,	\ERROR FLAG
	BPTR,	\BUFFER POINTER
	BUFSIZ,	\SIZE BUFFER RESERVE
	SLOT,	\SLOT FOR SERIAL CARD
	DSK,	\DISK CHANNEL
	BYTE,	\GLOBAL BYTE
	DC;	\GLOBAL CHAR FROM DISK

define
	KAY=1024;


define	\SUPER SERIAL CARD REGISTERS

	DATREG=$8,	\DATA REGISTER
	STAREG=$9,	\STATUS REGISTER
	COMREG=$A,	\COMMAND REGISTER
	CONREG=$B;	\CONTROL REGISTER


address
	KEY,		\KEY BOARD
	KEYCLR,		\CLEAR KEY PORT
	IOBASE;		\I-O BASE ADDRESS

address
	BUFFER;		\ROM DATA BUFFER


define	\SOME CHARACTERS

	BEL=7,		\BELL CHARACTER
	ESC=$1B,	\ESCAPE
	DEL=$7F,	\DELETE
	SP=$20,		\SPACE
	BS=8,		\BACKSPACE
	FF=$0C,		\FORM FEED
	EOF=$1A,	\END OF FILE
	CTC=3,		\CONTROL-C
	CR=$0D,		\CARRIAGE RETURN
	LF=$0A;		\LINE FEED



procedure GETDC;
DC:=CHIN(DSK);



procedure BLANK;
CHOUT(0,FF);



procedure WAIT;
integer X;
begin
TEXT(0,"HIT ANY KEY ");
X:=CHIN(1);
end;




procedure SEROUT(C);
\SEND SERIAL CHAR
integer C;
begin
repeat until (IOBASE(STAREG)&$10)#0;
IOBASE(DATREG):=C;
end;



procedure SERIN;
\GET SERIAL CHAR
begin
repeat until (IOBASE(STAREG)&$08)#0;
return IOBASE(DATREG);
end;




procedure SETSER;
\SET SERIAL CARD
begin
TEXT(0,"SERIAL CARD SLOT NUMBER");
SLOT:=INTIN(0);
IOBASE:=$C080+(16*SLOT);
IOBASE(CONREG):=$1E;
IOBASE(COMREG):=$CB;
end;



procedure NIBBLE(C);
integer C;
return if C>=^A then C-^A+10 else C-^0;



procedure GETBYT;
begin
BYTE:=NIBBLE(DC);
GETDC;
BYTE:=(16*BYTE)+NIBBLE(DC);
end;


procedure GETWRD;
integer W;
begin
GETDC;
GETBYT;
W:=BYTE;
GETDC;
GETBYT;
return SWAP(W)+BYTE;
end;



procedure BYTOUT(D,B);
integer D,B;

procedure HEXC(C);
integer C;
begin
C:=C&$F;
return if C>9 then C-10+^A else C+^0;
 end;


begin
CHOUT(D,HEXC(B/16));
CHOUT(D,HEXC(B));
end;



procedure COMTST;
integer X;
begin
repeat
	begin
	SEROUT($AA);
	X:=SERIN;
	CHOUT(0,^*);
	end
until KEY(0)>$7F;
X:=KEYCLR(0);
end;




procedure FILLBUF;
integer BASE;
begin
OPENI(DSK);
GETDC;
if DC#^* then
	begin
	TEXT(0,"!!NO BASE ADDRESS!!");
	return;
	end;
BASE:=GETWRD;
BPTR:=0;
loop
	begin
	GETDC;
	if DC=^* then
		begin
		TEXT(0,"old PTR=");
		INTOUT(0,BPTR);
		BPTR:=GETWRD-BASE;
		GETDC;
		TEXT(0,"  new PTR=");
		INTOUT(0,BPTR);CRLF(0);
		end;
	if BPTR>=BUFSIZ ! DC=EOF then quit;
	GETBYT;
	BUFFER(BPTR):=BYTE;
	BPTR:=BPTR+1;
	end;
CRLF(0);CRLF(0);
TEXT(0,"FINAL size= ");
INTOUT(0,BPTR);CRLF(0);
end;



procedure DISERR(ADD,GOOD,BAD);
integer ADD,GOOD,BAD;
begin
CURSOR(0,20);
TEXT(0,"ADDRESS=");
HEXOUT(0,ADD);
TEXT(0,"  GOOD=");
HEXOUT(0,GOOD);
TEXT(0,"BAD=");
HEXOUT(0,BAD);
CRLF(0);
end;



procedure ETEST;
integer X,C;
begin
BLANK;
TEXT(0,"
*** TEST FOR GOOD  ERASE ***

   TURN off EPROM POWER SWITCH

   SET TO read MODE

   TURN on EPROM POWER SWITCH

");
WAIT;
ERRFLG:=false;
for X:=0,PSIZE-1 do
	begin
	SEROUT($FF);
	C:=SERIN;
	if C#$FF then
		begin
		DISERR(X,$FF,C);
		ERRFLG:=true;
		end;
	CURSOR(5,18);
	INTOUT(0,X);
	end;
if ERRFLG then TEXT(0,"ERASE errors!!")
else TEXT(0,"good ERASE");
CRLF(0);

end;



procedure VERIFY;
integer X,C;
begin
BLANK;
TEXT(0,"
*** VERIFY GOOD BLAST ***

   TURN off EPROM POWER SWITCH

   SET TO read MODE

   TURN on EPROM POWER SWITCH
");
WAIT;
ERRFLG:=false;
for X:=0,PSIZE-1 do
	begin
	SEROUT($FF);
	C:=SERIN;
	if C#BUFFER(X) then
		begin
		DISERR(X,BUFFER(X),C);
		ERRFLG:=true;
		end;
	CURSOR(5,18);
	INTOUT(0,X);
	end;
CRLF(0);
if ERRFLG then TEXT(0,"BLAST errors!!")
else TEXT(0,"good BLAST");
CRLF(0);
end;





procedure BLAST;
integer X,D;
begin
BLANK;
TEXT(0,"
*** BLAST ROM ***


   TURN off EPROM POWER SWITCH

   SET TO write MODE

   TURN on EPROM POWER SWITCH

");
WAIT;
for X:=0,PSIZE-1 do
	begin
	SEROUT(BUFFER(X));
	D:=SERIN;
	CURSOR(5,18);
	INTOUT(0,X);
	end;
CRLF(0);
end;



procedure REDROM;
integer X,C;
begin
BLANK;
TEXT(0,"
*** READ ROM ***

   TURN off EPROM POWER SWITCH

   SET TO read MODE

   TURN on EPROM POWER SWITCH

");
WAIT;
for X:=0,PSIZE-1 do
	begin
	SEROUT($FF);
	C:=SERIN;
	BUFFER(X):=C;
	CURSOR(5,18);
	INTOUT(0,X);
	end;
CRLF(0);
end;



procedure PRESET;
integer X,C,V;
begin
BLANK;
TEXT(0,"
*** PRESET BUFFER ***

ENTER VALUE TO PRESET IN hex");
V:=HEXIN(0);
WAIT;
for X:=0,PSIZE-1 do BUFFER(X):=V;
CRLF(0);
end;




procedure AWRITE;
integer X,C;
begin
BLANK;
TEXT(0,"
*** WRITE ARRAY TO DISK ***
");
WAIT;
OPENO(DSK);
TEXT(DSK,"*0000");
for X:=0,PSIZE-1 do BYTOUT(DSK,BUFFER(X));
CHOUT(DSK,EOF);
CLOSE(DSK);
CRLF(0);
end;



procedure MENU;
integer COM;
begin
WAIT;
BLANK;
TEXT(0,"

**** APOTECK BLASTER ****

1) TEST ERASED
2) READ FILE FROM DISK
3) BLAST ROM
4) VERIFY BLAST

5) COMMUNICATION TEST
6) READ ROM INTO ARRAY
7) PRESET ARRAY

8) WRITE ARRAY TO DISK

select ONE 
");
COM:=INTIN(0);
case COM of
	1: ETEST;
	2: FILLBUF;
	3: BLAST;
	4: VERIFY;
	5: COMTST;
	6: REDROM;
	7: PRESET;
	8: AWRITE

else;
end;



procedure SETUP;
begin
BLANK;
SETSER;
TEXT(0,"

ENTER PROM SIZE IN K

   2716  =  2K
   2732  =  4K
   2764  =  8K
   27128 =  16K

");
PSIZE:=INTIN(0)*KAY;
end;




begin	\MAIN
KEY:=$C000;
KEYCLR:=$C010;
BUFSIZ:=16*1024;
BUFFER:=RESERVE(BUFSIZ);
SETUP;
DSK:=3;

loop MENU;
end;
 do
	begin
	SEROUT