\BLOCKADE GAME
\COPYRIGHT LARRY FISH 1981


'CODE'
ABS=0,         RAN=1,        REM=2,
RESERVE=3,     SWAP=4,       EXTEND=5,
REBEGIN=6,     CHIN=7,       CHOUT=8,
CRLF=9,        NUMIN=10,     NUMOUT=11,
TEXT=12,       OPENIN=13,     OPENOUT=14,
CLOSE=15,      ABORT=16,     TRAP=17,
SPACE=18,      RERUN=19,     GETSP=20,
SETSP=21,      ERRFLG=22,    CURSOR=23,
SCAN=24,

SETRUN=25,     FGET=26,      FASAVE=27,
FRUN=28,       FSAVE=29,     FWRITE=30,
FREAD=31,      FRESTOR=32,

SETTXT=33,     SETHI=34,     SETMIX=35,
SETLOW=36,     SWITCH=37,    PADDLE=38,
NOISE=39,      CLEAR=40,     DOT=41,
LINE=42,       MOVE=43,      SCREEN=44,
BLOCK=45;


'DEF'	\SOME STARTING PARAMETERS
	BEGLX=13,
	BEGLY=20,
	BEGRX=27,
	BEGRY=20;

'DEF'	\DEFINE SOME COLORS
	BLACK,	MAGEN,
	DBLUE,	PURPLE,
	DGREEN,	GREY1,
	MBLUE,	LBLUE,
	BROWN,	ORANGE,
	GREY2,	PINK,
	LGREEN,	YELLOW,
	AQUA,	WHITE;

'DEF'
	LEFT=0,
	RIGHT=1,
	UP=2,
	DOWN=3;


'DEF'
	ESC=$1B,	\ESCAPE
	FF=$0C;		\FORM FEED


'DEF' LIVE,DEAD;


'ADDRESS'
	KEYBOARD;


'INTEGER' 
	CIR,
	LSCORE,
	RSCORE,
	LSTAT,
	RSTAT,
	CNT,
	LCOLOR,
	RCOLOR,
	LEFTX,
	LEFTY,
	RIGHTX,
	RIGHTY,
	LPADDLE,
	RPADDLE;




'PROCEDURE' INSTRUCT;
'INTEGER' X;
'BEGIN'
CHOUT(0,FF);
TEXT(0,"
THE OBJECT IS BLOCK OFF YOUR OPPONENT
SO THAT HE CANNOT MOVE WITHOUT RUNNING
INTO YOU OR A WALL.

IF YOU RUN INTO A WALL OR ANY TRAIL
YOU LOOSE.

YOU CHANGE DIRECTION BY HITTING THE
FOLLOWING KEYS:


	left		right

	 ^		  ^
	 W		  O
       <A D>		<K ;>
	 S		  L
	 V		  V
HIT RETURN TO CONTINUE:
");
X:=CHIN(0);
'END';


'PROCEDURE' EMPTY;
'INTEGER' X,Y;
'BEGIN'
'FOR' X:=0,39 'DO'
'FOR' Y:=0,39 'DO' BLOCK(X,Y,BLACK);
'END';



'PROCEDURE' DIRECT(DIR);
'INTEGER' DIR;
'BEGIN'
'CASE' DIR 'OF'
	LEFT: CHOUT(0,^<);
	RIGHT: CHOUT(0,^>);
	DOWN: CHOUT(0,^V);
	UP: CHOUT(0,^^)
'ELSE';
'END';



'PROCEDURE' GETPAD;
'BEGIN'
'CASE' KEYBOARD(0)&$7F 'OF'
	^A: LPADDLE:=LEFT;
	^W: LPADDLE:=UP;
	^D: LPADDLE:=RIGHT;
	^S: LPADDLE:=DOWN;
	^K: RPADDLE:=LEFT;
	^O: RPADDLE:=UP;
	^;: RPADDLE:=RIGHT;
	^L: RPADDLE:=DOWN
'ELSE';
'END';



'PROCEDURE' LSTEP;
'BEGIN'
'CASE' LPADDLE 'OF'
	LEFT: LEFTX:=LEFTX-1;
	RIGHT: LEFTX:=LEFTX+1;
	DOWN: LEFTY:=LEFTY+1;
	UP: LEFTY:=LEFTY-1
'ELSE';
'IF' SCREEN(LEFTX,LEFTY)#BLACK 'THEN'
	LSTAT:=DEAD
'ELSE' BLOCK(LEFTX,LEFTY,LCOLOR);
NOISE(1,5,250);
'END';



'PROCEDURE' RSTEP;
'BEGIN'
'CASE' RPADDLE 'OF'
	LEFT: RIGHTX:=RIGHTX-1;
	RIGHT: RIGHTX:=RIGHTX+1;
	DOWN: RIGHTY:=RIGHTY+1;
	UP: RIGHTY:=RIGHTY-1
'ELSE';
'IF' SCREEN(RIGHTX,RIGHTY)# BLACK 'THEN'
	RSTAT:=DEAD
'ELSE' BLOCK(RIGHTX,RIGHTY,RCOLOR);
NOISE(1,5,500);
'END';



'PROCEDURE' BORDER;
'INTEGER' X;
'BEGIN'
'FOR' X:=0,39 'DO'
	'BEGIN'
	BLOCK(0,X,WHITE);
	BLOCK(39,X,WHITE);
	BLOCK(X,0,WHITE);
	BLOCK(X,39,WHITE);
	'END';
'END';



'PROCEDURE' START;
'INTEGER' X;
'BEGIN'
LPADDLE:=RIGHT;
RPADDLE:=LEFT;
EMPTY;
BORDER;
LEFTX:=BEGLX;
LEFTY:=BEGLY;
RIGHTX:=BEGRX;
RIGHTY:=BEGRY;
LCOLOR:=DBLUE;
RCOLOR:=YELLOW;
LSTAT:=LIVE;
RSTAT:=LIVE;

BLOCK(LEFTX,LEFTY,LCOLOR);
BLOCK(RIGHTX,RIGHTY,RCOLOR);
X:=KEYBOARD($10);
CURSOR(0,22);TEXT(0,"hit any key, ESC TO QUIT");
'REPEAT' X:=KEYBOARD(0) 'UNTIL' X>$80;
X:=X&$7F;

CURSOR(0,22);TEXT(0,"                        ");
'IF' X=ESC 'THEN' REBEGIN;
'END';



'PROCEDURE' SCORE;
'BEGIN'
'IF' RSTAT=DEAD 'THEN' LSCORE:=LSCORE+1
'ELSE' RSCORE:=RSCORE+1;
CURSOR(5,21);TEXT(0,"SCORE     LEFT: ");
NUMOUT(0,LSCORE);TEXT(0,"  RIGHT: ");
NUMOUT(0,RSCORE);
'END';



'PROCEDURE' EAT;
'INTEGER' X,Y,COLOR,SLIDE,BASE;


'PROCEDURE' MUNCH(X,Y);
'INTEGER' X,Y,C;
'BEGIN'
NOISE(1,2,SLIDE);
SLIDE:=SLIDE-5;
'IF' SLIDE<1 'THEN'
	'BEGIN'
	BASE:=BASE-50;
	'IF' BASE<1 'THEN' BASE:=250;
	SLIDE:=BASE;
	'END';
BLOCK(X,Y,BLACK);
'IF' SCREEN(X,Y-1)=COLOR 'THEN' MUNCH(X,Y-1);
'IF' SCREEN(X,Y+1)=COLOR 'THEN' MUNCH(X,Y+1);
'IF' SCREEN(X+1,Y)=COLOR 'THEN' MUNCH(X+1,Y);
'IF' SCREEN(X-1,Y)=COLOR 'THEN' MUNCH(X-1,Y);
'END';


'BEGIN'
'IF' RSTAT=DEAD 'THEN'
	'BEGIN'
	X:=BEGRX;
	Y:=BEGRY;
	COLOR:=RCOLOR;
	'END'
'ELSE'
	'BEGIN'
	X:=BEGLX;
	Y:=BEGLY;
	COLOR:=LCOLOR;
	'END';
BASE:=250;
SLIDE:=250;
MUNCH(X,Y);
'END';




'PROCEDURE' PLAY;
'INTEGER' X;
'BEGIN'
START;
'LOOP'
'FOR' CNT:=0,CIR 'DO'
	'BEGIN'
	GETPAD;
	'IF' CNT=0 'THEN'
		'BEGIN'
		LSTEP;
		'IF' LSTAT=DEAD 'THEN' 'QUIT';
		'END';
	GETPAD;
	'IF' CNT=CIR/2 'THEN'
		'BEGIN'
		RSTEP;
		'IF' RSTAT=DEAD 'THEN' 'QUIT';
		'END';
	'END';
NOISE(1,50,1000);
EAT;
SCORE;
'FOR' X:=0,2500 'DO';
'END';

'BEGIN'	\MAIN
SETTXT;
KEYBOARD:=$C000;
CHOUT(0,FF);
TEXT(0,"WHOULD YOU LIKE INSTRUCTIONS? (Y OR N)");
CRLF(0);
'IF' CHIN(1)=^Y 'THEN' INSTRUCT;
OPENIN(0);
CHOUT(0,FF);
'REPEAT'
	'BEGIN'
	TEXT(0,"ENTER SPEED (1 TO 10)");
	TEXT(0,"FOLLOW WITH RETURN ");
	CIR:=NUMIN(0);
	'END'
'UNTIL' CIR>0 & CIR<11;
CIR:='IF' CIR=10 'THEN' 1 'ELSE' (10-CIR)*10;
SETLOW;
SETMIX;
LSCORE:=0;
RSCORE:=0;
CHOUT(0,FF);
'LOOP' PLAY;
SETTXT;
'END';
