
\
\		***** B R E A K O U T *****
\
\     THE CLASSIC VIDEO GAME OF HARD KNOCKS.  THIS PROGRAM IS
\A SIMPLE ILLUSTRATION OF LORES GRAPHICS FROM AN XPL0 PROGRAM.
\

	\ DEFINE MACHINE DEPENDENT FUNCTION VALUES \

'CODE'
RAN=1,		REM=2,		RESERVE=3,
EXTEN=5,	CHOUT=8,	ADVANCE=9,
INTIN=10,	INTOUT=11,	TEXT=12,
INITI=13,	INITO=14,	ABORT=16,
PDL=38,		CURSOR=23,	NOISE=39,
SETLO=36,	BLOCK=45,	SCREEN=44,
SWITCH=37,	SETMIX=35,	SETTXT=33;


	\ GLOBAL VARIABLES \

'INTEGER'	TRUE, FALSE;		\HOLDS "TRUE" AND "FALSE" BOOLEANS
'INTEGER'	I;			\VERY TEMPORARY

'INTEGER'	IDEV, ODEV;		\I-O DEVICE NUMBERS
'INTEGER'	MAXX, MAXY;		\HOLD SCREEN DIMENSIONS
'INTEGER'	X, Y;			\TEMP POSITION HOLDERS
'INTEGER'	ONBOARD;		\INDICATES WHETHER BALL IS ON PLAYING AREA
'INTEGER'	XBALL, YBALL;		\HOLDS CURRENT POSITION OF BALL
'INTEGER'	XDIR, YDIR;		\HOLDS CURRENT BALL DIRECTION INDICATORS
'INTEGER'	SLOPE, XCOUNT;		\THESE DETERMINE SLOPE OF BALL MOVEMENT

'INTEGER'	NUMBALL, TOTBALLS;	\KEEPS TRACK OF BALLS REMAINING
'INTEGER'	SCORE;			\HOLDS CURRENT PLAYER'S SCORE
'INTEGER'	DEGREE, CURDEGREE;	\CONTROLS DEGREE OF DIFFICULTY
'INTEGER'	WARMUP;			\DETERMINES WHEN TO SWITCH DIFFICULTY FACTOR
'INTEGER'	BRKTHRU;		\DETERMINES WHETHER WE BOUNCE OFF BRICK OR NOT
'INTEGER'	SWNUM, PDLNUM;		\DETERMINE WHICH BUTTON AND PADDLE TO USE
'INTEGER'	TXTLIN;			\HOLDS WHERE FIRST LINE OF TEXT BEGINS

'INTEGER'	PADY;			\HOLDS Y COORDINATE OF PADDLE

'INTEGER'	BRKCOL;			\ARRAY HOLDING COLUMN NUMBERS OF BRICKS
'INTEGER'	NUMBRK;			\NUMBER OF COLUMNS OF BRICKS

	\ THESE VARIABLES DETERMINE COLORS \

'INTEGER'	BORDER, COLBALL, PADDLE, BRICKE, BRICKO;
'INTEGER'	BLACK, WHITE, PURPLE, BROWN, MAGENTA;



'PROCEDURE' DELAY(COUNT);
'INTEGER' COUNT, I;
'BEGIN'
'FOR' I:=1,COUNT 'DO';
'END'; \DELAY

'PROCEDURE' HLINE(BEGCOL,ENDCOL,ROW,COLOR); \PLOT HORIZ LINE
'INTEGER' BEGCOL, ENDCOL, ROW, COLOR;
'INTEGER' X;
'BEGIN'

'FOR' X:=BEGCOL,ENDCOL 'DO' [ BLOCK(X,ROW,COLOR) ];

'END'; \HLINE

'PROCEDURE' VLINE(BEGROW,ENDROW,COLUMN,COLOR); \PLOT VERT LINE
'INTEGER' BEGROW, ENDROW, COLUMN, COLOR;
'INTEGER' Y;
'BEGIN'

'FOR' Y:=BEGROW,ENDROW 'DO' [ BLOCK(COLUMN,Y,COLOR) ];

'END'; \VLINE

'PROCEDURE' MOVEPADDLE;
'INTEGER' Y;
'BEGIN'

Y:=PDL(PDLNUM)/7+1;
'IF' Y > (MAXY-7) 'THEN' Y:=MAXY-7;
'IF' Y # PADY 'THEN'
	[ VLINE(PADY,PADY+6,0,BLACK); PADY:=Y;
	  VLINE(PADY,PADY+6,0,PADDLE) ]
    'ELSE' DELAY(60); \EQUALISE TIME

'END'; \MOVEPADDLE



'FPROC' SAMESLOPE, SHALLOWER;

'PROCEDURE' STEEPER;
'BEGIN'

\REBOUND WITH STEEPER SLOPE 3/4 TIME

'IF' RAN(4)=0 'THEN' SHALLOWER
    'ELSE' [ SLOPE:=SLOPE/2;
	     'IF' SLOPE < 1 'THEN' SLOPE:=1 ];

'END'; \STEEPER

'PROCEDURE' SHALLOWER;
'BEGIN'

\REBOUND WITH SHALLOWER SLOPE 3/4 TIME

'IF' RAN(4)=0 'THEN' STEEPER
    'ELSE' [ SLOPE:=SLOPE*2;
	     'IF' SLOPE > MAXX/2 'THEN' SLOPE:=MAXX/2 ];

'END'; \SHALLOWER

'PROCEDURE' SAMESLOPE;
'INTEGER' RANNUM;
'BEGIN'

\REBOUND WITH SAME SLOPE 2/3 OF THE TIME

RANNUM:=RAN(6);
'IF' RANNUM=0 'THEN' STEEPER
    'ELSE' 'IF' RANNUM=5 'THEN' SHALLOWER;

'END'; \SAMESLOPE


'PROCEDURE' NEWBALL; \SETUP INITIAL POSITION OF BALL
'BEGIN'


CURSOR(0,TXTLIN);
TEXT(ODEV,"BALLS LEFT= ");
INTOUT(ODEV,NUMBALL);
CURSOR(0,TXTLIN+1);
TEXT(ODEV,"PUSH BUTTON #");
INTOUT(ODEV,SWNUM);
TEXT(ODEV," FOR NEW BALL");

'REPEAT' [ MOVEPADDLE ]
'UNTIL' SWITCH(SWNUM);

CURSOR(0,TXTLIN+1);
TEXT(ODEV,"                           ");

XBALL:=BRKCOL(0)-3; YBALL:=RAN(MAXY-1)+1;
XDIR:=-1; YDIR:=1;
SLOPE:=MAXX/4;
XCOUNT:=0;
ONBOARD:=TRUE;

CURDEGREE:=1;
WARMUP:=15;

'END'; \NEWBALL


'PROCEDURE' SCOREIT(COL); \ADD BRICK VALUE TO TOTAL SCORE
'INTEGER' COL;
'INTEGER' I;
'BEGIN'

'FOR' I:=0,NUMBRK-1 'DO'
	'IF' BRKCOL(I) = COL 'THEN'
		'BEGIN'
		SCORE:=SCORE+(I+1);
		CURSOR(20,TXTLIN);
		TEXT(ODEV,"YOUR SCORE= ");
		INTOUT(ODEV,SCORE);
		'END';

'END'; \SCOREIT


'PROCEDURE' SETUP; \SETUP THE PLAYING AREA
'INTEGER' X, Y;
'INTEGER' I,J;
'BEGIN'

SETTXT;

CHOUT(ODEV,12); \HOME AND ERASE SCREEN

TEXT(ODEV,"	***** B R E A K O U T *****");
ADVANCE(ODEV); ADVANCE(ODEV);
TEXT(ODEV,"ENTER DEGREE OF DIFFICULTY (1-5) ");
DEGREE:=INTIN(IDEV);

SETLO;
SETMIX;

BORDER:=WHITE;
COLBALL:=WHITE;
BRICKE:=MAGENTA;
BRICKO:=BROWN;
PADDLE:=PURPLE;

SCORE:=0;

BRKTHRU:=TRUE;

\FILL SCREEN WITH GRAPHICS BLANKS

'FOR' Y:=0,MAXY 'DO'
	[ HLINE(0,MAXX,Y,BLACK) ];

\MAKE BOX

HLINE(0,MAXX,0,BORDER);
HLINE(0,MAXX,MAXY,BORDER);
VLINE(1,MAXY-1,MAXX,BORDER);

\PLACE BRICKS

X:=(MAXX-2)-(2*NUMBRK); \COLUMN NO. OF FIRST COLUMN OF BRICKS
'FOR' I:=0,NUMBRK-1 'DO'
	'BEGIN'
	BRKCOL(I):=X;		\REMEMBER WHICH COLUMN CONTAINS BRICKS
	'FOR' J:=1,MAXY-1 'DO'	\MAKE COLUMN OF ODD & EVEN BRICKS
		'IF' REM(J/2) = 0 'THEN'
			BLOCK(X,J,BRICKE)
		'ELSE'  BLOCK(X,J,BRICKO);
	X:=X+2;
	'END';

\PLACE PADDLE

PADY:=1; \ASSUME A POSITION

'END'; \SETUP

'PROCEDURE' MOVEBALL; \MOVE THE BALL ONE CELL
'INTEGER' X, Y, CELL;
'BEGIN'

BLOCK(XBALL,YBALL,BLACK);
X:=XBALL+XDIR; Y:=YBALL;
XCOUNT:=XCOUNT+1;

'IF' XCOUNT >= SLOPE 'THEN'
	[ XCOUNT:=0; Y:=Y+YDIR ];

CELL:=SCREEN(X,Y);
'WHILE' CELL # BLACK 'DO'
	'BEGIN'

	'IF' WARMUP > 0 'THEN' WARMUP:=WARMUP-1
		'ELSE' CURDEGREE:=DEGREE;
	NOISE(1,10,15*Y);
	XCOUNT:=0;
	'IF' CELL = BORDER 'THEN'
		'BEGIN'
		'IF' X=MAXX 'THEN'
			[ XDIR:=-XDIR; X:=X+XDIR; BRKTHRU:=FALSE ];
		'IF' (Y=0) ! (Y=MAXY) 'THEN'
			[ YDIR:=-YDIR; Y:=Y+YDIR ]
		'END';

	'IF' (CELL=BRICKE) ! (CELL=BRICKO) 'THEN'
		'BEGIN'
		SCOREIT(X);
		BLOCK(X,Y,BLACK);
		'IF' XDIR > 0 'THEN'
			[ XDIR:=-XDIR; X:=X+XDIR ]
		    'ELSE' 'IF' 'NOT' BRKTHRU 'THEN'
			[ XDIR:=-XDIR; X:=X+XDIR ]
		'END';

	'IF' CELL = PADDLE 'THEN'
		'BEGIN'

		'IF' (Y=PADY+0) ! (Y=PADY+1) 'THEN' [ YDIR:=-1; STEEPER ]
		    'ELSE' 'IF' (Y=PADY+5) ! (Y=PADY+6) 'THEN' [ YDIR:=1; STEEPER ]
			'ELSE' SHALLOWER;

		XDIR:=-XDIR; X:=X+XDIR;
		BRKTHRU:=TRUE;

		'END';

	CELL:=SCREEN(X,Y); \READ NEW SCREEN CELL

	'END'; \WHILE

XBALL:=X; YBALL:=Y;
BLOCK(XBALL,YBALL,COLBALL);
'IF' XBALL=0 'THEN' ONBOARD:=FALSE; \SLIPPED PAST PADDLE?

'END'; \MOVEBALL

'BEGIN'	\MAIN PROGRAM

IDEV:=0; ODEV:=0;
INITI(IDEV); INITO(ODEV);
TRUE:=(1=1); FALSE:=(1=0);

BLACK:=0; WHITE:=15; PURPLE:=3; BROWN:=8; MAGENTA:=1;

SWNUM:=1; PDLNUM:=1;

TXTLIN:=22;

TOTBALLS:=5;
NUMBRK:=8;
BRKCOL:=RESERVE(2*NUMBRK);

MAXX:=39;
MAXY:=39;

'LOOP'
'BEGIN'

SETUP;

NUMBALL:=TOTBALLS;

'REPEAT'

	'BEGIN'
	NEWBALL;
	'WHILE' ONBOARD 'DO'
		'BEGIN'
		MOVEPADDLE;
		MOVEBALL;
		DELAY(126-25*CURDEGREE);
		'END';

	NOISE(1,100,1000);
	BLOCK(XBALL,YBALL,BLACK);
	NUMBALL:=NUMBALL-1;
	'END'

'UNTIL' NUMBALL = 0;

CURSOR(0,TXTLIN);
TEXT(ODEV,"NO BALLS LEFT");
CURSOR(0,TXTLIN+1);
TEXT(ODEV,"THANKS FOR PLAYING THE GAME...");
'FOR' I:=0,20000 'DO';
CURSOR(0,TXTLIN+1);
TEXT(ODEV,"PRESS BUTTON #");
INTOUT(ODEV,SWNUM);
TEXT(ODEV," TO START A NEW GAME");
'REPEAT' [ MOVEPADDLE ]
'UNTIL'  SWITCH(SWNUM);

'END'; \LOOP

'END'; \MAIN
