\CENTIPED.XPL	DEC-21-86	(ALSO CHANGE DATE IN "NEWGAME")
\CENTIPEDE ARCADE GAME
\BY RICHARD OTTOSEN, BILL BAILEY & LOREN BLANEY

\REVISION HISTORY:
\MAR-05-85, ORIGIONAL
\JUL-20-86, MODIFIED FOR STRIDE COMPUTER, L.B.
\JUL-24-86, 

code	RAN=1, REM=2, RESERVE=3, EXTEND=5, CHOUT=8, INTOUT=11,
	TEXT=12, OPENI=13, CURSOR=23, GETKEY=125, KEYHIT=126, SHOCUR=127;

def	TV=0, KB=0;
def	BEL=$07, FF=$0C;
def	WIDTH=40, HEIGHT=24;	\TV SCREEN DIMENSIONS
def	LENGTH=12,		\INITIAL NUMBER OF SEGMENTS IN CENTIPEDE
	ROUNDS=3,		\INITIAL NUMBER OF ROUNDS (PLAYERS)
	FIVESEC=200;		\A MEASURED NUMBER FOR 5 SECONDS OF MAIN LOOP

\CHARACTERS TO REPRESENT FIGURES:
def	HEAD=^8, SEGMENT=^Q, DEAD=^ ,
	PLAYER=^A, SHELL=^|,
	MUSH=^#, MUSH3=^=, MUSH2=^-, MUSH1=^',
	SCORP=^&, SPIDER=^^, FLEA=^@;

int	MANX, MANY, MANSHOOT;	\STRIDE STUFF

int	RIGHT,		\RIGHT-MOST COLUMN NUMBER OF SCREEN
	BOTTOM,		\BOTTOM-MOST LINE NUMBER OF SCREEN
	CENTER,		\CENTER OF SCREEN
	BOTLIMIT,	\LOWER LIMIT OF GAME CHARACTERS
	TOPLIMIT,	\UPPER LIMIT OF PLAYER, & UPWARD MOVING CENTIPEDE
	SPIDLIMIT,	\UPPER LIMIT OF SPIDER
	PLAYX, PLAYY,	\PLAYER'S COORDINATES
	SHELLX, SHELLY,	\SHELL'S COORDINATES
	DROPPING,	\FLEA IS DROPPING (WATCH OUT!)
	FLEAMAD,	\FLEA IS MAD CUZ IT'S BEEN HIT ONCE
	FLEAX, FLEAY	\FLEA'S COORDINATES
	FLEAWAS,	\HOLDS WHAT THE FLEA MOVED OVER
	SPIDRX, SPIDRY,	\SPIDER'S COORDINATES (LEFT OF THE TWO CHARS)
	SPWAS,SPWAS1,	\HOLDS MUSHROOMS, ETC. THAT SPIDER MOVED OVER
	SPIXDIR,SPIYDIR,\DIRECTION SPIDER IS CURRENTLY MOVING IN
	SCORPX,SCORPY,	\THE NASTY SCORPION'S COORDINATES
	BIT,		\BOOLEAN: SOMETHING GOT THE PLAYER
	ARMED,		\BOOLEAN: PLAYER IS ARMED WITH SHELL
	TOTAL,		\CURRENT TOTAL SCORE
	DTOTAL,		\THE HIGH-ORDER PORTION OF THE SCORE (MULTIPLES OF 10000)
	HISCORE,	\HIGHEST SCORE IN GAME SERIES
	DHISCORE,	\HIGH ORDER PART OF HI SCORE (IN 10000'S)
	MEN,		\NUMBER OF MEN REMAINING IN A GAME
	WAVE,		\NUMBER OF WAVE BEING PLAYED
	MODWAVE,	\WAVE NUMBER, MODULO LENGTH
	TAIL,		\TAIL SEGMENT NUMBER
	SEGCNT,		\CURRENT NUMBER OF SEGMENTS IN CENTIPEDE
	BIAS,		\PUSHES SPIDER
	LOOPER,		\USED TO MAKE SOME THINGS HAPPEN FASTER THAN OTHERS
	IMUSH,		\INITIAL NO. OF MUSHROOMS
	SPEED,		\USED TO SLOW THE GAME DOWN
	FULLMOON,	\COUNTER TO TIME FIVE SECONDS FOR HEAD INJECTING
	I;		\SCRATCH

\1-DIMENSIONAL ARRAYS:
int	DIRX,	\X DIRECTION OF A SEGMENT. LEFT: -1, RIGHT: +1,
	DIRY,	\Y DIRECTION OF A SEGMENT. UP: -1, DOWN: +1
	SEGX,	\X COORD. OF A SEGMENT
	SEGY,	\Y COORD. OF A SEGMENT
	SHAPE;	\HEAD OR SEGMENT (CHARACTER) OR DEAD

int	SCREEN;	\2-DIMENSIONAL ARRAY FOR HOLDING MIRROR IMAGE OF
		\ WHAT'S ON THE TV SCREEN

\============================== STRIDE ROUTINES ==============================

proc	SOUND(V,C,P);
int	V,C,P;
begin
CHOUT(TV,BEL);
end;	\SOUND



proc	BUTTON(N);
int	N;
int	I;
begin
I:= MANSHOOT;
MANSHOOT:= false;
return I;
end;	\BUTTON



proc	PADDLE(DIR);
int	DIR;		\DIRECTION: 0 = RIGHT/LEFT, 1 = UP/DOWN
begin
if KEYHIT then
	begin
	case GETKEY of
	 $08:	[MANX:= MANX -6;
		if MANX<0 then MANX:=0];
	 $15:	[MANX:= MANX +6;
		if MANX>255 then MANX:=255];
	 $0B:	[MANY:= MANY -43;
		if MANY<0 then MANY:=0];
	 $0A:	[MANY:= MANY +43;
		if MANY>255 then MANY:=255];
	 $20:	MANSHOOT:= true
	other;
	end;
return if DIR=0 then MANX else MANY;
end;	\PADDLE

\======================================================================\

proc	DELAY(N);	\DELAY "N" HUNDREDTHS OF A SECOND
int	N;
int	I, J;
begin
for J:=1,N do
	for I:=1,5000 do;
end;	\DELAY



proc	DINTOUT(HIGH,LOW);	\DISPLAY "DOUBLE PRECISION" INTEGER
int	HIGH,LOW;
begin
if HIGH #0 then
    [INTOUT(TV,HIGH);
    if LOW <1000 then CHOUT(TV,^0);
    if LOW <100 then CHOUT(TV,^0);
    if LOW <10 then CHOUT(TV,^0);
    ];
INTOUT(TV,LOW);
end;	\DINTOUT



proc	SHOWPLAYERS;		\SHOW THE WAITING PLAYERS
int	I;
begin
CURSOR(3,BOTTOM); TEXT(TV,"            ");
CURSOR(3,BOTTOM); for I:= 2,MEN do CHOUT(TV,PLAYER);
end;	\SHOWPLAYERS



proc	BUMPSCORE(POINTS);	\INCREMENT "TOTAL" BY "POINTS" AND SHOW IT
int	POINTS;
int	I;
begin
TOTAL:= TOTAL +POINTS;
if TOTAL >=10000 then
    [DTOTAL:= DTOTAL +1;
    TOTAL:= TOTAL -10000;
    MEN:= MEN +1;
    SHOWPLAYERS;
    DELAY(10);	\PAUSE BETWEEN LAST SCORE'S SOUND AND NEW MAN SOUND
    for I:= 0,2 do [SOUND(1,50,191); SOUND(1,50,143)];
    ];
CURSOR(WIDTH -18, BOTTOM); DINTOUT(DTOTAL,TOTAL);
end;	\BUMPSCORE



proc	DISPLAY(X,Y,CH);	\UPDATE TV SCREEN AND SCREEN ARRAY
int	X, Y, CH;
begin
if X>=0 & X <=RIGHT & Y>=0 & Y<HEIGHT then
    [CURSOR(X,Y);
    CHOUT(TV,CH);
    SCREEN(X,Y):= CH;
    ];
end;	\DISPLAY



proc	NEWGAME;	\INITIALIZATION FOR A NEW GAME
int	X, Y, I;
begin
MANX:=128; MANY:=128; MANSHOOT:= false;		\STRIDE

\SHOW INTRODUCTORY SCREEN:
CHOUT(TV,FF);	\CLEAR TV
CURSOR(CENTER-9,0); TEXT(TV,"DEC-21-86 VERSION");

X:= CENTER -14; Y:= HEIGHT /2 -9;
CURSOR(X,Y); for I:=1,27 do CHOUT(TV,MUSH);
CURSOR(X,Y +1); CHOUT(TV,MUSH); CURSOR(X+26,Y +1); CHOUT(TV,MUSH);
CURSOR(X,Y +2); CHOUT(TV,MUSH); TEXT(TV,"    C E N T I P E D E    ");
CHOUT(TV,MUSH);
CURSOR(X,Y +3); CHOUT(TV,MUSH); CURSOR(X+26,Y +3); CHOUT(TV,MUSH);
CURSOR(X,Y +4); for I:=1,27 do CHOUT(TV,MUSH);

CURSOR(CENTER-15, Y+8);  TEXT(TV,"NEW PLAYER EVERY 10000 POINTS");
CURSOR(CENTER-12, Y+11); TEXT(TV,"SELECT SPEED WITH ARROWS");
CURSOR(CENTER-05, Y+12); TEXT(TV,"<-- X -->");
CURSOR(CENTER-17, Y+14); TEXT(TV,"PUSH SPACE BAR TO START AND SHOOT");

\SHOW THE RESULTS OF PREVIOUS GAME:
CURSOR(0,BOTTOM -1); TEXT(TV,"WAVE");
CURSOR(0,BOTTOM); INTOUT(TV,WAVE +1);

CURSOR(WIDTH -24, BOTTOM-1); TEXT(TV,"SCORE ");
CURSOR(WIDTH -24, BOTTOM); DINTOUT(DTOTAL,TOTAL);

CURSOR(WIDTH-11, BOTTOM -1); TEXT(TV,"HIGH ");
CURSOR(WIDTH-11, BOTTOM); DINTOUT(DHISCORE,HISCORE);

OPENI(KB);		\STRIDE;
SPEED:= 5;
repeat
	SPEED:= PADDLE(0);		\GET A PLAYER'S SPEED SELECTION
	CURSOR(CENTER-1,Y+12); TEXT(TV," ");
	CURSOR(CENTER-1,Y+12); INTOUT(TV,SPEED /26);
	DELAY(10);
until BUTTON(0) ! BUTTON(1);		\START GAME

CHOUT(TV,FF);	\CLEAR TV
for Y:= 0,BOTLIMIT do			\CLEAR SCREEN ARRAY
    for X:=0,RIGHT do
	SCREEN(X,Y):= ^ ;

\SET UP MUSHROOMS:
for I:= 1,IMUSH do DISPLAY(RAN(WIDTH), RAN(HEIGHT -2), MUSH);

WAVE:= 0; MODWAVE:= 0;
TOTAL:= 0; DTOTAL:= 0;
MEN:= ROUNDS;

SHOWPLAYERS;		\SHOW THE WAITING PLAYERS
\SHOW THE SCORE:
CURSOR(WIDTH -24, BOTTOM); TEXT(TV,"SCORE "); DINTOUT(DTOTAL,TOTAL);
CURSOR(WIDTH-11, BOTTOM); TEXT(TV,"HIGH "); DINTOUT(DHISCORE,HISCORE);
end;	\NEWGAME



proc	STARTSPIDER;	\START THE SPIDER OFF OF THE SCREEN
begin
BIAS:= RAN(2);
if BIAS=0 then BIAS:= -1;
SPIDRX:= CENTER - (CENTER + CENTER/2)*BIAS;
SPIDRY:= SPIDLIMIT;
SPWAS:=^ ; SPWAS1:=^ ;
SPIXDIR:=BIAS;
SPIYDIR:=0;
end;	\STARTSPIDER



proc	SETUP;		\INITIALIZATION FOR THE START OF EACH ROUND
int	I;
int	SEGXTBL, DIRXTBL, SHAPTBL;
begin
\INITIALIZE CENTIPEDE ARRAYS:     TABLE(MODWAVE, SEGMENT)
SEGXTBL:=[
	[28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39],	\0
	[27, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0],	\1
	[10, 18, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39],	\2
	[35, 24, 12,  8,  7,  6,  5,  4,  3,  2,  1,  0],	\3
	[ 8, 17, 24, 29, 32, 33, 34, 35, 36, 37, 38, 39],	\4
	[34, 27, 20, 14,  9,  6,  5,  4,  3,  2,  1,  0],	\5
	[ 5, 12, 19, 24, 27, 32, 34, 35, 36, 37, 38, 39],	\6
	[34, 28, 23, 18, 15, 10,  7,  4,  3,  2,  1,  0],	\7
	[ 0,  5, 10, 15, 20, 24, 28, 32, 36, 37, 38, 39],	\8
	[37, 32, 27, 23, 19, 15, 11,  8,  5,  2,  1,  0],	\9
	[ 0,  4,  8, 11, 14, 17, 22, 27, 30, 34, 38, 39],	\10
	[39, 34, 30, 27, 24, 20, 18, 14, 10,  7,  3,  0]	\11
	];
DIRXTBL:=[
	[-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],	\0
	[-1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1],	\1
	[-1,  1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],	\2
	[-1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1],	\3
	[ 1, -1, -1,  1, -1, -1, -1, -1, -1, -1, -1, -1],	\4
	[ 1,  1, -1,  1,  1,  1,  1,  1,  1,  1,  1,  1],	\5
	[ 1, -1,  1, -1,  1, -1, -1, -1, -1, -1, -1, -1],	\6
	[ 1, -1, -1,  1,  1,  1, -1, -1,  1,  1,  1,  1],	\7
	[ 1,  1,  1, -1, -1, -1,  1, -1, -1, -1, -1, -1],	\8
	[ 1,  1,  1,  1, -1,  1,  1, -1, -1,  1,  1,  1],	\9
	[ 1,  1, -1, -1, -1,  1,  1,  1, -1,  1, -1, -1],	\10
	[-1, -1, -1, -1, -1, -1, -1,  1,  1,  1,  1,  1]	\11
	];
SHAPTBL:=[
	[^8, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q],	\0
	[^8, ^8, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q],	\1
	[^8, ^8, ^8, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q],	\2
	[^8, ^8, ^8, ^8, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q],	\3
	[^8, ^8, ^8, ^8, ^8, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q],	\4
	[^8, ^8, ^8, ^8, ^8, ^8, ^Q, ^Q, ^Q, ^Q, ^Q, ^Q],	\5
	[^8, ^8, ^8, ^8, ^8, ^8, ^8, ^Q, ^Q, ^Q, ^Q, ^Q],	\6
	[^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^Q, ^Q, ^Q, ^Q],	\7
	[^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^Q, ^Q, ^Q],	\8
	[^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^Q, ^Q],	\9
	[^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^Q],	\10
	[^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8, ^8]	\11
	];

for I:= 0,TAIL do
    [SEGX(I):= SEGXTBL(MODWAVE, I);
    SEGY(I):= 0;
    DIRX(I):= EXTEND(DIRXTBL(MODWAVE, I));	\STRIDE BUG
    DIRY(I):= 1;
    SHAPE(I):= SHAPTBL(MODWAVE, I);
    ];
\HATCH CENTIPEDE
for I:=0, TAIL do DISPLAY(SEGX(I), SEGY(I), SHAPE(I));
SEGCNT:=LENGTH;

CURSOR(0,BOTTOM); INTOUT(TV,WAVE +1);	\DISPLAY WAVE NUMBER

\SHOW REMAINING PLAYERS (REINFORCEMENTS):
CURSOR(3,BOTTOM); TEXT(TV,"            ");
CURSOR(3,BOTTOM); for I:= 2,MEN do CHOUT(TV,PLAYER);

PLAYX:= CENTER; PLAYY:= BOTLIMIT;	\START IN SOME SAFE LOCATION
ARMED:=true;
DISPLAY(PLAYX, PLAYY, PLAYER);

DROPPING:=false;	\DON'T DROP FLEA YET
FLEAWAS:=^ ;

STARTSPIDR;
BIT:= false;
FULLMOON:= 0;
end;	\SETUP



proc	CLEANUP;		\CLEAN UP THE BODIES
int	I;
begin
\REMOVE CENTIPEDE:
for I:=0,TAIL do
	if SHAPE(I)#DEAD then DISPLAY(SEGX(I), SEGY(I), ^ );
\REMOVE SHELL FROM FLIGHT:
if not ARMED then [DISPLAY(SHELLX,SHELLY,^ ); ARMED:= true];
\REMOVE FLEA:
if DROPPING then [DISPLAY(FLEAX,FLEAY,^ ); DROPPING:= false];
\REMOVE SPIDER:
DISPLAY(SPIDRX,SPIDRY,^ );
DISPLAY(SPIDRX +1,SPIDRY,^ );
\REMOVE PLAYER AND A POSSIBLE SPIDER:
DISPLAY(PLAYX-1, PLAYY, ^ );
DISPLAY(PLAYX, PLAYY, ^ );
DISPLAY(PLAYX+1, PLAYY, ^ );
end;	\CLEANUP



proc	BITTEN;		\SOMETHING BIT THE PLAYER (I.E. YOU'RE DEAD)
int	I, J, X, Y;
begin
for J:=1,5 do	\YOU'RE DEAD, PLAYER (AWFUL NOISE)
    [for I:=0,50 do SOUND(1,2,RAN(6));
    CURSOR(PLAYX, PLAYY); CHOUT(TV,PLAYER);
    for I:=0,100 do SOUND(1,4,RAN(12));
    CURSOR(PLAYX, PLAYY); CHOUT(TV,SCREEN(PLAYX,PLAYY));
    ];

\RESTORE SHOT-UP MUSHROOMS:
for X:=0,RIGHT do
    for Y:=0,BOTLIMIT do
	case SCREEN(X, Y) of MUSH1, MUSH2, MUSH3:
		begin
		BUMPSCORE(5);
		DISPLAY(X, Y, MUSH);
    		for I:=2,3\0\ do SOUND(1,2,RAN(I));	\STRIDE
		DELAY(10);
		end
	other;
DELAY(100);		\PAUSE FOR EFFECT
MEN:=MEN-1;		\ONE LESS PLAYER
DISPLAY(PLAYX,PLAYY,^ );	\REMOVE DEAD PLAYER
end;	\BITTEN



proc	MOVEFLEA;	\MOVE THE FLEA
int	X,Y,I;
begin
if WAVE =0 then return;		\(GIVE THE GUY A BREAK TO START WITH)
if DROPPING then
	begin
	if FLEAY <BOTLIMIT then
		begin
		if FLEAWAS =^  then	\LEAVE MUSHROOMS IN WAKE
		    if RAN(HEIGHT /6) =0 then DISPLAY(FLEAX, FLEAY, MUSH)
		    else DISPLAY(FLEAX,FLEAY,^ )
		\REPLACE WHAT THE FLEA HOPPED ON EXCEPT IF IT IS A MOVING OBJECT
		else	case FLEAWAS of
			  HEAD, SEGMENT, PLAYER, SHELL, SCORP, SPIDER:
				DISPLAY(FLEAX,FLEAY,^ )
			other DISPLAY(FLEAX,FLEAY,FLEAWAS);
		FLEAY:= FLEAY +1;
		FLEAWAS:= SCREEN(FLEAX,FLEAY);	\SAVE WHAT THE FLEA IS ON
		DISPLAY(FLEAX, FLEAY, FLEA);
		if FLEAWAS=PLAYER then BIT:= true;
		SOUND(1, 2, FLEAY*30 +200);
		end
	else	[DROPPING:= false;		\HIT BOTTOM
		DISPLAY(FLEAX,FLEAY,^ );	\ERADICATE IT
		];
	end
else	begin
	\COUNT THE MUSHROOMS ON THE BOTTOM 5 ROWS (APPROXIMATELY)
	I:=0;
	for X:=0,RIGHT do
	    for Y:=TOPLIMIT,BOTLIMIT do
		if SCREEN(X,Y)#^  then I:=I+1;
	\IF THE MUSHROOMS ARE LESS THAN THRESHOLD THEN DROP THE FLEA
	if I < 5*IMUSH/HEIGHT then
		begin
		DROPPING:=true;
		FLEAMAD:= false;
		FLEAX:= RAN(WIDTH); FLEAY:= 0;
		FLEAWAS:=SCREEN(FLEAX,FLEAY);
		end;
	end;
end;	\MOVEFLEA



proc	MOVESPIDER;	\BOUNCE THE SPIDER AROUND
int	I,X,Y;
begin
X:= SPIDRX; Y:= SPIDRY;

\ENTER AT TOP LINE
if X=0 ! X=RIGHT then [Y:=SPIDLIMIT; SPIXDIR:=BIAS];

if RAN(10)=0 then SPIYDIR:=RAN(5) -2;
if SPIYDIR <=0 then Y:= SPIDRY -1
    else if SPIYDIR >0 then Y:= SPIDRY+1;

if RAN(10)=0 then SPIXDIR:=RAN(3) -1 +BIAS;
if SPIXDIR <0 then X:= SPIDRX -1
	else if SPIXDIR >0 then X:= SPIDRX+1;

if Y >BOTLIMIT then [Y:= BOTLIMIT -1; SPIYDIR:= -SPIYDIR]
    else if Y <SPIDLIMIT -1 then [Y:= SPIDLIMIT; SPIYDIR:= -SPIYDIR];

\PUT BACK WHAT THE SPIDER TROMPED ON EXCEPT IF IT IS A MOVING OBJECT
case SPWAS of SHELL, HEAD, SEGMENT, FLEA, SCORP, PLAYER:
	DISPLAY(SPIDRX,SPIDRY,^ )
other DISPLAY(SPIDRX,SPIDRY,SPWAS);
case SPWAS1 of SHELL, HEAD, SEGMENT, FLEA, SCORP, PLAYER:
	DISPLAY(SPIDRX+1,SPIDRY,^ )
other DISPLAY(SPIDRX+1,SPIDRY,SPWAS1);	\PUT BACK WHAT THE SPIDER TROMPED ON

\SAVE WHAT THE SPIDER IS ABOUT TO TROMP ON
\(BEWARE OF READING INVALID ARRAY LOCATIONS MAY CAUSE 68000 ADDRESS ERROR)
if X >=0 & X <=RIGHT then SPWAS:= SCREEN(X,Y);
if X+1 >=0 & X+1 <=RIGHT then SPWAS1:= SCREEN(X+1,Y);
SPIDRX:= X; SPIDRY:= Y;

if SPWAS=PLAYER ! SPWAS1=PLAYER then
	begin
	BIT:= true;
	DISPLAY(PLAYX -1,PLAYY,^<);
	DISPLAY(PLAYX +1,PLAYY,^>);
	end
else	begin
	if SPIDRX+1>=0 & SPIDRX<=RIGHT then
		begin
		SOUND(1, 2, (SPIDRY-SPIDLIMIT)*10 +100);
		DISPLAY(SPIDRX, SPIDRY, SPIDER);
		DISPLAY(SPIDRX+1, SPIDRY, SPIDER);
		end;
	end;

\IF HE WENT WAY OFF THE SCREEN THEN RESTART HIM THERE:
if SPIDRX>RIGHT+WIDTH ! SPIDRX< -WIDTH then
	[BIAS:=-BIAS; SPIDRX:=SPIDRX+BIAS];
end;	\MOVESPIDER



proc	MOVEPLAY;	\MOVE THE PLAYER
int	XPAD, YPAD, X, Y, S;
begin
if BIT then return;		\DON'T MOVE BITTEN PLAYER
XPAD:= PADDLE(0) *WIDTH /256;	\(0 THRU WIDTH-1;
X:= PLAYX;
if XPAD >PLAYX & PLAYX <RIGHT then X:= PLAYX +1;
if XPAD <PLAYX & PLAYX >0 then X:= PLAYX -1;

\FOR SYSTEMS WITH A JOYSTICK:
YPAD:= BOTLIMIT - (255-PADDLE(1)) *6 /256;	\(0 THRU 5)  LB'S IS UPSIDE DOWN
Y:= PLAYY;
if YPAD >PLAYY & PLAYY <BOTLIMIT then Y:= PLAYY +1;
if YPAD <PLAYY & PLAYY >TOPLIMIT then Y := PLAYY -1;

\FOR SYSTEMS WITH ONLY A PADDLE:
\if XPAD <3 then Y:= 3 -XPAD
\else if XPAD >RIGHT-3 then Y:= -(RIGHT-3 -XPAD)
\else Y:= 0;
\Y:= BOTLIMIT -Y;

\(THE MOVEING SHELL CAN CLEAR THE PLAYER SO WE DISPLAY IT EACH TIME
\ WHETHER IT MOVED OR NOT)
S:= SCREEN(X,Y);
if S #MUSH & S #MUSH1 & S #MUSH2 & S #MUSH3 then
	[DISPLAY(PLAYX, PLAYY, ^ );	\DON'T MOVE OVER MUSHROOMS
	DISPLAY(X, Y, PLAYER);	\PUT PLAYER DOWN
	PLAYX:= X; PLAYY:= Y;
	];
end;	\MOVEPLAY



proc	SCORE;		\BUMP SCORE IF SHELL HIT SOMETHING
int	I, POINTS;



proc	FLASH(X,Y,N);	\FLASH SCORE
int	X,Y,N;
int	I;
begin
if X +2 >RIGHT then X:= X-2;	\DON'T GO OFF EDGE
CURSOR(X,Y); INTOUT(TV,N);
for I:=100,150 do SOUND(1,3,RAN(I));	\MAKE SPLAT SOUND
DELAY(10);			\STRIDE
DISPLAY(X,Y,^ );		\REMOVE ANYTHING THE SCORE MAY HAVE HIT
DISPLAY(X+1,Y,^ );
DISPLAY(X+2,Y,^ );
end;	\FLASH



proc	SCORSEG;	\HIT A SEGMENT OR HEAD
int	I;
begin
\FIND THE HIT SEGMENT (OR HEAD):
loop for I:=0,TAIL do
	if SHELLX=SEGX(I) & SHELLY=SEGY(I) & SHAPE(I)#DEAD then quit;
DISPLAY(SEGX(I), SEGY(I),^ );		\REMOVE IT
if SHAPE(I) =HEAD then DISPLAY(SEGX(I) +DIRX(I), SEGY(I), MUSH)
	\(MAKE IT A MUSHROOM SHIFTED OVER ONE POSITION)
else DISPLAY(SEGX(I), SEGY(I), MUSH);
SHAPE(I):=DEAD;
\GROW A NEW HEAD AT THE NEXT SEGMENT:
if I <TAIL & SHAPE(I+1) =SEGMENT then SHAPE(I+1):=HEAD;
SEGCNT:=SEGCNT-1;
end;	\SCORSEG



begin	\SCORE
POINTS:=0;	\DEFAULT POINTS
case SCREEN(SHELLX, SHELLY) of
    MUSH1:	[POINTS:= 1;
    		for I:=2,50 do SOUND(1,2,RAN(I));
		DISPLAY(SHELLX, SHELLY, ^ );
		];
    MUSH2:	[for I:=2,50 do SOUND(1,2,RAN(I));
		DISPLAY(SHELLX, SHELLY, MUSH1);
		];
    MUSH3:	[for I:=2,50 do SOUND(1,2,RAN(I));
		DISPLAY(SHELLX, SHELLY, MUSH2);
		];
    MUSH:	[for I:=2,50 do SOUND(1,2,RAN(I));
		DISPLAY(SHELLX, SHELLY, MUSH3);
		];
    SEGMENT:	[POINTS:= 10;
		for I:=50,100 do SOUND(1,4,RAN(I));
		SCORSEG;
		];
    HEAD:	[POINTS:= 100;
		for I:=50,100 do SOUND(1,3,RAN(I));
		SCORSEG;
		];
    SPIDER:	[case PLAYY -SPIDRY of
		    1:POINTS:= 900;
		    2:POINTS:= 600
		other POINTS:= 300;
    		FLASH(SPIDRX,SPIDRY,POINTS);
		DISPLAY(SHELLX-1, SHELLY, ^ );	\REMOVE DEAD SPIDER
		DISPLAY(SHELLX, SHELLY, ^ );
		DISPLAY(SHELLX+1, SHELLY, ^ );
		STARTSPIDR;
		];
		\(INTERESTING THINGS HAPPEN IF YOU SHOOT A SPIDER
		\ THAT IS HALF WAY EMERGED FROM THE LEFT SIDE.)
    SCORP:	[POINTS:= 1000;
		DISPLAY(SHELLX, SHELLY, ^ );
		];
    FLEA:	if FLEAMAD then
			[POINTS:= 200;
			DISPLAY(SHELLX, SHELLY, ^ );
			DROPPING:=false;
			]
		else	FLEAMAD:= true
   other	[DISPLAY(SHELLX, SHELLY, ^ )];
BUMPSCORE(POINTS);
end;	\SCORE



proc	MOVESHELL;		\MOVE THE SHELL IF FIRED
begin
if ARMED then
	begin
	if BUTTON(0) ! BUTTON(1) then		\FIRE!
		begin
		SHELLX:= PLAYX; SHELLY:= PLAYY-1;
		ARMED:= false;
		if SCREEN(SHELLX, SHELLY)#^  then [SCORE; ARMED:= true]
		else DISPLAY(SHELLX, SHELLY, SHELL);
		end;
	end
else	begin			\IT'S IN THE AIR
	DISPLAY(SHELLX, SHELLY, ^ );
	if SHELLY <1 then ARMED:= true	\MISSED
	else	begin
		SHELLY:= SHELLY -1;
		if SCREEN(SHELLX, SHELLY)#^  then [SCORE; ARMED:= true]
		else DISPLAY(SHELLX, SHELLY, SHELL);
		end;
	end;
end;	\MOVESHELL



proc	MOVECENT;		\MOVE CENTIPEDE
int	I, X, X1, Y, Y1;


	proc	TURN;	\TURN THE SEGMENT
	begin
	\DROP THE SEGMENT DOWN ONE POSITION AND PUT A SPACE WHERE IT WAS
	Y1:= Y +DIRY(I);
	if Y1 >BOTLIMIT then
		begin
		DIRY(I):= -1;
		end		\INJECT A HEAD
	else if Y1 <TOPLIMIT then DIRY(I):= +1;
	SEGY(I):= Y +DIRY(I);
	DIRX(I):= -DIRX(I);
	end;	\TURN


begin	\MOVECENT
for I:= 0,TAIL do
    [if SHAPE(I) #DEAD then	\DON'T MOVE DEAD SEGMENTS
	[X:= SEGX(I); Y:= SEGY(I);
	X1:= X +DIRX(I);
	if X1<0 then TURN
	else if X1>RIGHT then TURN
	else	case SCREEN(X1,Y) of
		  ^ , PLAYER, SHELL: SEGX(I):=X1
		other TURN;
	DISPLAY(X,Y,^ ); DISPLAY(SEGX(I), SEGY(I), SHAPE(I));
	if PLAYX=SEGX(I) & PLAYY=SEGY(I) then BIT:= true;
	];
    ];
end;	\MOVECENT



proc	INJECTHEAD;	\INJECT A NEW HEAD AT BOTTOM TO PREVENT BOREDOM
int I, TALLY, ZOMBIE;
begin
if FULLMOON >FIVESEC then 		\THE ZOMBIES EMERGE
    begin
    TALLY:= 0;
    ZOMBIE:= -1;			\START WITH NO DEAD BODIES
    for I:= 0,TAIL do
        if SEGY(I) >=TOPLIMIT ! SHAPE(I) =DEAD then TALLY:= TALLY +1;
    if TALLY =LENGTH then \ALL THE LIVE SEGMENTS ARE NEAR THE BOTTOM
	for I:= 0,TAIL do \FIND A DEAD SEGMENT TO REVIVE
		if SHAPE(I) =DEAD then ZOMBIE:= I;
    if ZOMBIE >= 0 then	\WE FOUND A LIVE ONE (SORT OF)
	[SHAPE(ZOMBIE):= HEAD;
	if RAN(2) =0 then DIRX(ZOMBIE):= -1
	    else DIRX(ZOMBIE):= 1;
	DIRY(ZOMBIE):= 1;
	if DIRX(ZOMBIE) =1 then SEGX(ZOMBIE):= 0
	    else SEGX(ZOMBIE):= RIGHT;
	SEGY(ZOMBIE):= TOPLIMIT-1;
	SEGCNT:= SEGCNT +1;	\THE ZOMBIE FLESH LIVES...
	];
    FULLMOON:= 0; \NOW FOR A PERIOD OF DARKNESS
    end
    else FULLMOON:= FULLMOON +1;
end;	\INJECTHEAD



begin	\MAIN
SHOCUR(false);		\turn off the cursor
TAIL:= LENGTH -1; RIGHT:= WIDTH -1; BOTTOM:= HEIGHT -1;
CENTER:= WIDTH /2; BOTLIMIT:= BOTTOM -1; TOPLIMIT:= BOTTOM-5;
SPIDLIMIT:= BOTTOM-9;
SCREEN:= RESERVE(WIDTH *4);
for I:= 0,RIGHT do SCREEN(I):=RESERVE(BOTTOM *4);
DIRX:= RESERVE(LENGTH *4);
DIRY:= RESERVE(LENGTH *4);
SEGX:= RESERVE(LENGTH *4);
SEGY:= RESERVE(LENGTH *4);
SHAPE:= RESERVE(LENGTH *4);
IMUSH:=WIDTH*HEIGHT/24;
TOTAL:= 0; DTOTAL:= 0;	\(BECAUSE "NEWGAME" SHOWS TOTAL OF GAME JUST FINISHED)
HISCORE:=0; DHISCORE:= 0;
WAVE:= 0;
loop	begin
	NEWGAME; 
	while MEN>0 do
		begin
		SETUP;		\ARRAYS, CENTIPEDE, PLAYER, ETC.
		loop	begin
			DELAY(SPEED /(if TOTAL>5000 then 35 else 25));
			MOVECENT;
			MOVEFLEA;
			if FLEAMAD then MOVEFLEA;
			MOVESPIDER;
			for LOOPER:= 0,6 do	\DO THESE FASTER
				begin
				MOVEPLAY;
				MOVESHELL;
				if BIT then [BITTEN; quit];
				if SEGCNT<=0 then [WAVE:=WAVE+1; quit];
				end;
			INJECTHEAD;
			end;
		MODWAVE:= REM(WAVE/12);
		CLEANUP;	\CLEAN UP THE CARNAGE
		end;
	if DTOTAL>DHISCORE ! (DTOTAL = DHISCORE & TOTAL > HISCORE) then
		[HISCORE:=TOTAL; DHISCORE:= DTOTAL;];
	for I:= 0,12 do SOUND(1,9,227 +19 *I);
	repeat until not BUTTON(0) & not BUTTON(1);
	end;
end;	\MAIN
