\CHARSET.XPL
\CREATE CHARACTER SET FOR TEKTERM

'CODE'
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45;


'DEF'
	HITE=8,
	TAB=9,
	FF=$C;



'INTEGER' X,COM,DROW,DCOL,ODEV;


'ADDRESS'
	OFFMASK,
	ONMASK,
	CHAR;





'PROCEDURE' HEXCHAR(C);
'INTEGER' C;
'IF' C<10 'THEN' CHOUT(ODEV,^0+C)
	'ELSE' CHOUT(ODEV,^A+C-10);


'PROCEDURE' BYTEOUT(B);
'INTEGER' B,R;
'BEGIN'
B:=B&$FF;
B:=B/16;
R:=REM(0);
HEXCHAR(B);
HEXCHAR(R);
'END';


'PROCEDURE' COMLINE;
'BEGIN'
CURSOR(0,22);
TEXT(0,"                                       ");
CURSOR(0,22);
'END';



'PROCEDURE' PRESET;
'INTEGER' X;
'BEGIN'
'FOR' X:=0,HITE-1 'DO' CHAR(X):=0;
DROW:=0;
DCOL:=0;
'END';



'PROCEDURE' DISPLAY;
'INTEGER' X;
'BEGIN'
CHOUT(0,FF);
CURSOR(12,5);
'FOR' X:=0,7 'DO' INTOUT(0,X);
'FOR' X:=0,HITE-1 'DO'
	'BEGIN'
	CURSOR(10,6+X);
	INTOUT(0,X);
	'END';
CURSOR(0,18);
TEXT(0,"K=LEFT,L=RIGHT,");CRLF(0);
TEXT(0,"K=DOWN,I=UP");CRLF(0);
TEXT(0,"O=ON,F=OFF,W=WRITE,Q=QUIT");CRLF(0);
'END';



'PROCEDURE' CONVERT(BYTE);
'ADDRESS' BYTE,WORK;
'BEGIN'
WORK:=0;
'IF' (BYTE&ONMASK(0))#0 'THEN' WORK:=WORK+2;
'IF' (BYTE&ONMASK(1))#0 'THEN' WORK:=WORK+4;
'IF' (BYTE&ONMASK(2))#0 'THEN' WORK:=WORK+8;
'IF' (BYTE&ONMASK(3))#0 'THEN' WORK:=WORK+16;
'IF' (BYTE&ONMASK(4))#0 'THEN' WORK:=WORK+32;
'IF' (BYTE&ONMASK(5))#0 'THEN' WORK:=WORK+64;
'IF' (BYTE&ONMASK(6))#0 'THEN' WORK:=WORK+128;
'RETURN' WORK;
'END';



'PROCEDURE' UPDATE;
'INTEGER' ROW,X;
'BEGIN'
ODEV:=0;
'FOR' ROW:=0,HITE-1 'DO'
'FOR' X:=0,7 'DO'
	'BEGIN'
	CURSOR(12+X,ROW+6);
	'IF' (CHAR(ROW) & ONMASK(X))=0
	'THEN' CHOUT(0,^.)
	'ELSE' CHOUT(0,126);
	'END';
'FOR' ROW:=0,HITE-1 'DO'
	'BEGIN'
	CURSOR(23,ROW+6);
	CHOUT(0,^$);
	BYTEOUT(CONVERT(CHAR(ROW)));
	'END';
CURSOR(12+DCOL,DROW+6);
'END';



'PROCEDURE' BUILD;
'BEGIN'
ONMASK(0):=$80;
ONMASK(1):=$40;
ONMASK(2):=$20;
ONMASK(3):=$10;
ONMASK(4):=$8;
ONMASK(5):=$4;
ONMASK(6):=$2;
ONMASK(7):=1;

OFFMASK(0):=$7F;
OFFMASK(1):=$BF;
OFFMASK(2):=$DF;
OFFMASK(3):=$EF;
OFFMASK(4):=$F7;
OFFMASK(5):=$FB;
OFFMASK(6):=$FD;
OFFMASK(7):=$FE;
'END';



'PROCEDURE' ON;
'BEGIN'
CHAR(DROW):=CHAR(DROW)!ONMASK(DCOL);
UPDATE;
'END';



'PROCEDURE' OFF;
'BEGIN'
CHAR(DROW):=CHAR(DROW)&OFFMASK(DCOL);
'END';



'PROCEDURE' CWRITE;
'INTEGER' LETTER;
'BEGIN'
COMLINE;
TEXT(0,"ENTER LETTER ");
OPENI(0);
LETTER:=CHIN(0);
CRLF(3);
CHOUT(3,^;);CHOUT(3,LETTER);
CRLF(3);
ODEV:=3;
'FOR' X:=0,HITE-1 'DO'
	'BEGIN'
	CHOUT(3,TAB);
	TEXT(3,".BYTE");
	CHOUT(3,TAB);
	CHOUT(3,^$);
	BYTEOUT(CONVERT(CHAR(X)));
	CRLF(3);
	'END';
CRLF(3);
PRESET;
UPDATE;
'END';



'PROCEDURE' COMMAND;
'BEGIN'
'LOOP'
	'BEGIN'
	COM:=CHIN(1);
	'CASE' COM 'OF'
	^J: 'IF' DCOL#0 'THEN' DCOL:=DCOL-1;
	^L: 'IF' DCOL<7 'THEN' DCOL:=DCOL+1;
	^I: 'IF' DROW#0 'THEN' DROW:=DROW-1;
	^K: 'IF' DROW<HITE-1 'THEN' DROW:=DROW+1;
	^O: ON;
	^F: OFF;
	^W: CWRITE;
	^Q: 'QUIT'
	'ELSE';
	UPDATE;
	'END';

'END';



'BEGIN'	\MAIN
ONMASK:=RESERVE(8);
OFFMASK:=RESERVE(8);

CHAR:=RESERVE(HITE);
BUILD;
OPENO(3);

PRESET;
DISPLAY;
UPDATE;
COMMAND;
CHOUT(3,$1A);
CLOSE(3);
'END';
