
code
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT	=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;

code real

RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;



integer
	RTCHAR,	\RETURN CHARACTER
	RTCOD1,	\RETURN CODE BYTES
	RTCOD2,
	RTDAT1,	\RETURN DATA BYTES
	RTDAT2,
	RTCHK1,	\RETURN CHECKSUM BYTES
	RTCHK2;


integer
	CHKACC,	\CHECKSUM ACCUMULATED
	CHKSNT,	\CHECKSUM SENT
	ERRCOD,	\ERROR CODES
	SERIAL;	\FLAGS SERIAL CHANNEL

define	\SOME CHARACTERS
	FF=$0C,
	CR=13,
	LF=10;

address
	KEY,	\APPLE KEY PORT
	KEYCLR;	\CLEAR PORT


address
	BUFFER;	\INPUT BUFFER

address
	ACIA;	\ACIA ADDRESS

define 
	STAT=0,	\INDEX TO ACIA STATUS REG
	DATA=1;	\INDEX TO ACIA DATA REG

integer
	X;


define	\ERROR CODES FROM REMOTE

	NOERR=0,
	BADCOM=1,
	CHKERR=2,
	BADCHR=3;



procedure WAIT;
integer C;
begin
TEXT(0,"HIT any KEY");
C:=CHIN(1);
end;



procedure TABINT(I,T);
integer I,T;
begin
FORMAT(T,0);
RLOUT(0,FLOAT(I));
end;



procedure BCDBIN(I);
\CONVERT BCD TO BINARY
integer I;
return ((I/16)*10)+REM(I/16);



procedure BINBCD(I);
\CONVERT BINARY TO BCD
integer I;
return ((I/10)*16)+REM(I/10);



procedure MAKBIN(HI,LO);
integer HI,LO;
begin
if HI<^A then HI:=HI-^0
else HI:=HI-^A+10;
if LO<^A then return HI*16+(LO-^0)
else return HI*16+(LO-^A+10);
end;



procedure MAKWRD(L1,L2,H1,H2);
integer L1,L2,H1,H2;
return 16*MAKBIN(H1,H2)+MAKBIN(L1,L2);



\**************************************

\MODULE DOES DIRECT I-O TO COMCARD
\CARD IS IN SLOT 2


procedure INITIALIZE;
\INITIALIZE ACIA
begin
ACIA(STAT):=3;
ACIA(STAT):=$11;
end;

procedure ACIN;
\GET1 CHAR FROM ACIA
int X;
begin
while (ACIA(STAT) & 1)#1 do;
X:=ACIA(DATA)&$7F;
return X;
end;


procedure ACOUT(X);
\OUTPUT CHAR TO ACIA
int X;
begin
while (ACIA(STAT)&2)=0 do;
ACIA(DATA):=X;
end;


procedure ATEXT(STR);
\SEND TEXT STRING TO ACIA
addr STR;
integer X;
begin
X:=0;
repeat
	begin
	ACOUT(STR(X));
	X:=X+1;
	end
until STR(X-1)>$7F;
end;


procedure ACRLF;
\SEND CRLF TO ACIA
begin
ACOUT(CR);ACOUT(LF);
end;


\**************************************



procedure SCOUT(C);
integer C;
begin
if SERIAL then ACOUT(C) else CHOUT(0,C);
CHKACC:=C+CHKACC;
end;


procedure GETC;
return if SERIAL then ACIN else CHIN(0);



procedure SERBYT(B);
integer B,R;

procedure HEXCHR(C);
integer C;
if C<10 then SCOUT(^0+C) else SCOUT(^A+C-10);

begin
B:=B&$FF;B:=B/16;
R:=REM(0);HEXCHR(B);
HEXCHR(R);
end;


procedure SERWRD(W);
integer W;
begin
SERBYT(W);
SERBYT(SWAP(W));
end;



procedure BYTOUT(B);
integer B,R;

procedure HEXCHR(C);
integer C;
if C<10 then CHOUT(0,^0+C) else CHOUT(0,^A+C-10);

begin
B:=B&$FF;B:=B/16;
R:=REM(0);HEXCHR(B);
HEXCHR(R);
end;


procedure WRDOUT(W);
integer W;
begin
BYTOUT(SWAP(W));
BYTOUT(W);
end;


procedure ISHEX(C);
integer C;
return (C>=^0 & C<=^9) ! (C>=^A & C<=^F);



procedure GETBYT;
integer C1,C2;
begin
repeat C1:=CHIN(0) until ISHEX(C1);
C2:=CHIN(0);
if ISHEX(C2) then else [C2:=C1;C1:=^0;];
return MAKBIN(C1,C2);
end;





procedure DISCHECK(A,S);
integer A,S;
begin
TEXT(0,"ACCUMULATED=");BYTOUT(A);
TEXT(0," FOUND=");BYTOUT(S);
CRLF(0);
end;



procedure DISRET;
\DISPLAY RETURN CODE STATUS
begin

if RTCHAR#^R then
	begin
	TEXT(0,"R missing FOUND=");
	BYTOUT(RTCHAR);CRLF(0);
	return false;
	end;

CHKACC:=(^R+RTCOD1+RTCOD2+RTDAT1+RTDAT2) & $FF;
CHKSNT:=MAKBIN(RTCHK1,RTCHK2);

if CHKACC#CHKSNT then
	begin
	TEXT(0,"CHECKSUM ERROR FROM remote");
	CRLF(0);
	DISCHECK(CHKACC,CHKSNT);
	return false;
	end;

RTCOD1:=MAKBIN(RTCOD1,RTCOD2);
RTDAT1:=MAKBIN(RTDAT1,RTDAT2);

case RTCOD1 of
	NOERR: return true;

	BADCOM:
		begin
		TEXT(0,"host SENT BAD COMMAND");
		CRLF(0);
		return false;
		end;

	CHKERR:
		begin
		TEXT(0,"remote RECEIVED BAD CHECK FROM HOST");
		CRLF(0);
		return false;
		end;
	BADCHR:
		begin
		TEXT(0,"remote RECEIVED BAD CHARACTER");
		CRLF(0);
		return false;
		end
else
	begin
	TEXT(0,"UNRECOGNIZED RETURN CODE=");
	BYTOUT(RTCOD1);
	CRLF(0);
	return false;
	end;
end;



procedure CHKRET;
\TEST FOR RETURN STRING ERRORS
begin
if RTCHAR#^R then return false;
CHKACC:=(^R+RTCOD1+RTCOD2+RTDAT1+RTDAT2) & $FF;
CHKSNT:=MAKBIN(RTCHK1,RTCHK2);
if CHKACC#CHKSNT then return false;
return MAKBIN(RTCOD1,RTCOD2)=NOERR;
end;




procedure GETRET;
\GET RETURN CODE
begin;
RTCHAR:=GETC;
RTCOD1:=GETC;RTCOD2:=GETC;
RTDAT1:=GETC;RTDAT2:=GETC;
RTCHK1:=GETC;RTCHK2:=GETC;
OPENI(0);
return CHKRET;
end;





procedure SENDCOM(C1,C2);
\SEND COMMAND
integer C1,C2,CHK;
begin
OPENI(0);
CHK:=C1+C2;
SCOUT(^;);
SCOUT(C1);SCOUT(C2);
SERBYT(CHK);

return GETRET;
end;



procedure FILLBUF(L,S);
integer L,S,X;
begin
for X:=0,L-1 do
	repeat
	BUFFER(X):=GETC;
	until BUFFER(X)>$1F;

if not DISRET then return false;

CHKACC:=S;
for X:=0,L-3 do CHKACC:=CHKACC+BUFFER(X);

CHKSNT:=MAKBIN(BUFFER(L-2),BUFFER(L-1));
if CHKSNT#(CHKACC&$FF) then
	begin
	TEXT(0,"BAD data CHECKSUM");
	CRLF(0);
	DISCHECK(CHKACC,CHKSNT);
	TEXT(0,"DISPLAY string? ");
	OPENI(0);
	if CHIN(0)=^Y then
		begin
		CRLF(0);
		for X:=0,L-1 do CHOUT(0,BUFFER(X));
		CRLF(0);CRLF(0);
		end;
	return false;
	end;
return true;
end;



procedure BUFBYT(P);
integer P;
return MAKBIN(BUFFER(P),BUFFER(P+1));




procedure BUFWRD(P);
integer P;
return BUFBYT(P)+SWAP((BUFBYT(P+2)));



procedure BUFBCD(P);
integer P;
[CHOUT(0,BUFFER(P));CHOUT(0,BUFFER(P+1));];



procedure BCDTST(B);
integer B;
begin
return (B>=^0) & (B<=^9);
end;




procedure CLOCKTST;
integer P,C,ERR;


procedure ERRTST;
begin
for P:=0,13 do
if not BCDTST(BUFFER(P)) then
	begin
	ERR:=ERR+1;
	INTOUT(0,C);
	TEXT(0," BCD ERROR= ");
	INTOUT(0,BUFFER(P));
	TEXT(0," AT ");
	INTOUT(0,P);
	CRLF(0);
	end;
end;


begin
CHOUT(0,FF);

ERR:=0;
C:=0;
loop
	begin
	C:=C+1;
	CURSOR(0,0);
	TEXT(0,"                    ");
	CURSOR(0,0);
	INTOUT(0,C);
	TEXT(0,"  ");
	INTOUT(0,ERR);

	CURSOR(0,23);

	if not SENDCOM(^R,^T)then
		begin
		DISRET;
		return;
		end;


	if FILLBUF(16,0) then ERRTST;

	end;
end;




begin	\MAIN
ACIA:=$C0AE;	\LOCATION OF PORT

KEY:=$C000;
KEYCLR:=$C010;


INITIALIZE;

BUFFER:=RESERVE(20*45+2);

CHOUT(0,FF);
TEXT(0,"OUTPUT TO Screen or Line (L/S)");
CRLF(0);

OPENI(0);
SERIAL:=CHIN(0)=^L;

CLOCKTST;
end;
