\COLOR.XPL	DEC-11-92
\Display the 256 colors.
\This version by-passes BIOS and goes ten times faster.

inc	C:\CXPL\CODESI;

int	II, JJ, CPUREG, DATASEG;
addr	COLTBL;
seg addr SCREEN;	\Array for video screen in mode $13



proc	PALETTE(N, R, G, B);	\Set color register N
int	N,		\Register to set
	R, G, B;	\Red, Green, and Blue [0..255]
begin
CPUREG(0):= $1010;		\AX function $10, subfunction $10
CPUREG(1):= N;			\BX select color register
CPUREG(2):= G<<8 ! (B&$FF);	\CX green<<8 blue
CPUREG(3):= R<<8;		\DX red<<8
SOFTINT($10);			\Call BIOS routine
end;	\PALETTE



proc	SETCOLREGS(START, N, TBL);
\Set N color registers starting with START
int	START, N;
addr	TBL;
begin
CPUREG(0):= $1012;		\AX function $10, subfunction $12
CPUREG(1):= START;		\BX first color register
CPUREG(2):= N;			\CX number of color registers
CPUREG(3):= TBL;		\DX table of 3-byte entries (R, G, B)
CPUREG(11):= DATASEG;		\ES:= DS
SOFTINT($10);			\Call BIOS routine
end;	\SETCOLREGS



proc	FIXPALETTE;	\Make palette registers correspond to DAC registers
int	N, CPUREG;
begin
CPUREG:= GETREG;
for N:= 0, 15 do
	begin
	CPUREG(0):= $1000;	\AX function $10, subfunction $00
	CPUREG(1):= N<<8!N;	\BX DAC and palette registers
	SOFTINT($10);		\Call BIOS routine
	end;
end;	\FIXPALETTE



proc	DRAWBOX(X, Y, C);	\Draw a color swatch (C) at X, Y
int	X, Y, C;
int	I, J;
def	H=200/16, W=320/16;
begin
for J:= Y, Y+H-1 do
    for I:= X, X+W-1 do
	SCREEN(J, I):= C;
end;	\DRAWBOX



proc	DRAWBOXES;		\Draw the color swatches
int	I, J;
begin
for J:= 0, 15 do		\16 x 16 array
    for I:= 0, 15 do
	DRAWBOX(I*320/16, J*(200/16), J*16+I);
end;	\DRAWBOXES



begin	\MAIN
CPUREG:= GETREG;
DATASEG:= CPUREG(12);

SCREEN:= RESERVE(200*2);	\Set up video screen array
for JJ:= 0, 199 do
	SCREEN(JJ):= $A000 + 320/16 *JJ;

SETVID($13);
CURSOR(10, 24);
TEXT(0, "MODE $13: 256 COLORS");

DRAWBOXES;
if CHIN(1) then;

\Display color gradients:
FIXPALETTE;
COLTBL:= RESERVE(3 *256);
II:= 0;
for JJ:= 0, 63 do
	[COLTBL(II):= JJ;
	COLTBL(II+1):= 0;
	COLTBL(II+2):= 0;
	II:= II +3];
for JJ:= 0, 63 do
	[COLTBL(II):= 0;
	COLTBL(II+1):= JJ;
	COLTBL(II+2):= 0;
	II:= II +3];
for JJ:= 0, 63 do
	[COLTBL(II):= 0;
	COLTBL(II+1):= 0;
	COLTBL(II+2):= JJ;
	II:= II +3];
for JJ:= 0, 63 do
	[COLTBL(II):= JJ;
	COLTBL(II+1):= JJ;
	COLTBL(II+2):= JJ;
	II:= II +3];
SETCOLREGS(0, 256, COLTBL);
if CHIN(1) then;

II:= 0;
for JJ:= 0, 63 do
	[COLTBL(II):= 0;
	COLTBL(II+1):= JJ;
	COLTBL(II+2):= JJ;
	II:= II +3];
for JJ:= 0, 63 do
	[COLTBL(II):= JJ;
	COLTBL(II+1):= 0;
	COLTBL(II+2):= JJ;
	II:= II +3];
for JJ:= 0, 63 do
	[COLTBL(II):= JJ;
	COLTBL(II+1):= JJ;
	COLTBL(II+2):= 0;
	II:= II +3];
for JJ:= 0, 63 do
	[COLTBL(II):= JJ;
	COLTBL(II+1):= JJ;
	COLTBL(II+2):= JJ;
	II:= II +3];
SETCOLREGS(0, 256, COLTBL);
if CHIN(1) then;

OPENI(0);
SETVID($03);
end;	\MAIN
