\CONVERT.XPL		7-2-83
\HUFFMAN CODE CONVERTER
\BY LOREN BLANEY
\   THIS PROGRAM CONVERTS THE HUFFMAN CODES GENERATED BY THE PROGRAM
\"HUFFMAN" INTO ANOTHER SET OF HUFFMAN CODES WHICH ARE MORE SUITABLE
\FOR DECODING.

code REM=2 RESERVE=3, CHIN=7, CHOUT=8, CRLF=9 INTIN=10, INTOUT=11,
TEXT=12, OPENI=13, OPENO=14, CLOSE=15, FREE=18;

def	TV=0, KB=0, FILE=3;	\I/O DEVICE NUMBERS
def	BS=$08, TAB=$09, LF=$0A, CR=$0D, EOF=$1A, SP=$20;
def	NIL=0;	\EMPTY NODE

int	I,
	CH,
	DEV,
	MAXI,
	MAXCHAR,
	LINE,
	LIST,
	COUNT,
	CODON,
	L,
	;

\----------------------------------------------------------------------

proc	BITOUT(N);
int	N;
int	I,MASK;
begin
MASK:=$4000;
for I:=COUNT,14 do MASK:=MASK/2;
for I:=1,COUNT do
	begin
	CHOUT(DEV,if (MASK&N)#0 then ^1 else ^0);
	MASK:=MASK/2;
	end;
end;	\BITOUT

\----------------------------------------------------------------------

begin	\MAIN
LIST:=RESERVE($80*2);
for I:=0,$7F do LIST(I):=RESERVE(3*2);

TEXT(TV,"-- HUFFMAN CODE CONVERTER, VER 1.0X --
");
TEXT(TV,"OUTPUT DEVICE? ");
DEV:=INTIN(KB);
OPENO(DEV);

COUNT:=13; BITOUT($1234); CRLF(DEV);	\***DEBUG

\READ IN THE FILE
OPENI(FILE);
loop for LINE:=0,$7F do
	begin
	LIST(LINE,0):=INTIN(FILE);
	LIST(LINE,1):=INTIN(FILE);
	LIST(LINE,2):=INTIN(FILE);
	INTOUT(TV,LIST(LINE,0)); CRLF(TV);\***

	repeat	CH:=CHIN(FILE);		\SKIP TO END OF LINE
		if CH=EOF then quit;
	until CH=CR;
	end;

TEXT(TV,"READ IN OK
");		\*** DEBUG
CODON:=0;
COUNT:=3;		\*** DEBUG ***

for L:=0,LINE do		\FOR ALL LINES...
	begin
	MAXCHAR:=0;		\FIND THE LARGEST
	for I:=0,LINE do
		begin
		if LIST(I,2)>MAXCHAR then
			begin
			MAXCHAR:=LIST(I,2);
			MAXI:=I;
			end;
		end;

	if LIST(MAXI,1)>COUNT then
		begin
		COUNT:=LIST(MAXI,1);
		CODON:=CODON+CODON;
		end;

	\OUTPUT LINE OF INFO
	for I:=0,2 do
		begin
		INTOUT(DEV,LIST(MAXI,I));
		CHOUT(DEV,TAB);
		end;

	\OUTPUT CODON
	BITOUT(CODON);
	CRLF(DEV);

	\CALCULATE NEXT CODON
	CODON:=CODON+1;

	\DELETE LINE FROM INPUT FILE
	LIST(MAXI,2):=0;
	end;

CLOSE(DEV);
end;	\MAIN
