	page	59,130
;COPYLINE.ASM	NOV-07-93
;External assembly language procedure for ROLL.XPL.

cseg	segment dword public 'code'
	assume cs:cseg

;----------------------------------------------------------------------
;Copy a horizontal scan line from Raster to screen
; CopyLine(Src, Dst, Raster, Depth);
; offsets: 10   8    6       4
;  Src = line from Raster
;  Dst = line on screen
;  Raster = segment array (4x38400)
;  Depth = number of bit planes [0..4]
;
	public	copyline
copyline:
	mov	bp,sp		;get pointer to arguments

;if Dst < 0 then Dst:= 0;	(Copy it anyway to keep timing the same)
	mov	ax,[bp]+8
	test	ax,ax
	jns	dl10
	sub	ax,ax
dl10:

;Dst:= Dst *80;   Src:= Src *80;   \Convert line to address offset
	mov	dx,80		;There are 80 bytes per scan line
	mul	dx
	mov	di,ax

	mov	ax,[bp]+10
	mov	dx,80
	mul	dx
	mov	si,ax

	cld			;set up for rep movsw instruction below
	push	es
	mov	ax,0a000h	;point es to graphic screen
	mov	es,ax

;for D:= 0, DEPTH-1 do
	mov	dx,3c4h		;address of sequencer registers
	sub	cl,cl		;D:= 0
	mov	ch,[bp]+4	;Depth

;Register usage:
; cl = depth counter
; ch = depth limit+1
; dx = output port address
; si = offset to image source (in Raster)
; di = offset to image destination (on screen)
; bp = arguments

;POUT($100<<D!2, $3C4, 1);	\Enable appropriate bit plane
dl20:	mov	ah,01h
	shl	ah,cl
	mov	al,02h
	out	dx,ax		;sequencer map mask register

;Blit(Raster(D), Src, Screen(0), Dst, 80);
	mov	bx,[bp]+6	;Raster
	mov	al,cl		;+2*D
	add	al,cl
	sub	ah,ah
	add	bx,ax

	push	ds		;save registers
	push	cx
	push	si
	push	di
	mov	ds,[bx]
	mov	cx,40		;40 words per scan line
	rep movsw		;es:di++ <-- ds:si++  cx--

	pop	di		;restore registers
	pop	si
	pop	cx
	pop	ds

	inc	cl		;next bit plane
	cmp	cl,ch		;loop for Depth planes
	jl	dl20

	pop	es		;restore registers
	retf	8		;drop 4 arguments

cseg	ends
	end
