\CURFIT.XPL

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
	GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
	FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
	CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
	FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
	BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
	CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
	READPIX=44,	SETVID=45	FIX=50,		POUT=64,
	PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68;
code realRLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
	RLABS=51,	FORMAT=52,
	SQRT=53,	LN=54,		EXP=55,		SIN=56,
	ATAN2=57,	MOD=58,		LOG=59,		COS=60,
	TAN=61,		ASIN=62,	ACOS=63;

real 	XVALUES,	\X VALUES
	YVALUES,	\Y VALUES
	MATRIX;		\DETERMINATE MATRIX

integer
	X,	\TEMPORARY
	DVZFLG,	\FLAGS DIVIDE BY ZERO
	PFLAG	\FLAG POLYNOMIAL MODE
	VPTR,	\POINTER TO X AND Y VALUES
	WIDTH,	\WIDTH OF XVALUES DATA
	TERMS;	\NUMBER OF TERMS IN THE EQUATION

define
	LLX=320,LLY=189,	\WINDOW CORNERS
	URX=629,URY=11,
	MAXTRM=40,	\MAXIMUM NUMBER OF TERMS
	MAXVAL=100;	\MAXIMUM NUMBER OF VALUES

\--------- WINDOW ROUTINES ----------------------

integer MAXX,MAXY,ORX,ORY;

real XSCALE,YSCALE,XOFF,YOFF;


procedure WINDOW(X1,Y1,X2,Y2);
\OPEN A WINDOW
\ X1Y1= LOWER LEFT CORNER
\ X2Y2= UPPER RIGHT CORNER
integer X1,Y1,X2,Y2;
begin
MOVE(X1,Y1);
LINE(X2,Y1,1);LINE(X2,Y2,1);
LINE(X1,Y2,1);LINE(X1,Y1,1);
MAXX:=ABS(X2-X1);MAXY:=ABS(Y2-Y1);
ORX:=X1;ORY:=Y1;
end;



procedure OPOINT(X,Y,C);
\PLACE POINT, REFERENCED TO ORIGIN
integer X,Y,C;
POINT(ORX+X,ORY-Y,C);



procedure OLINE(X,Y,C);
\DRAW LINE, REFERRENCE TO ORIGIN
integer X,Y,C;
LINE(ORX+X,ORY-Y,C);



procedure OMOVE(X,Y);
\MOVE, REFERENCED TO ORIGIN
integer X,Y;
MOVE(ORX+X,ORY-Y);



procedure RLINE(X,Y,C);
\DRAW SCALED AND OFFSET LINE
real X,Y;
integer C;
OLINE(FIX((X-XOFF)*XSCALE),FIX((Y-YOFF)*YSCALE),C);



procedure RPOINT(X,Y,C);
\PLACE SCALED AND OFFSET POINT
real X,Y;
integer C;
OPOINT(FIX((X-XOFF)*XSCALE),FIX((Y-YOFF)*YSCALE),C);



procedure RMOVE(X,Y);
\MOVE SCALED AND OFFSET
real X,Y;
OMOVE(FIX((X-XOFF)*XSCALE),FIX((Y-YOFF)*YSCALE));


procedure SYMBOL(X,Y);
\PLACE A SYMBOL IN WINDOW
\SYMBOL TYPE IN T
real X,Y;
integer T,X1,Y1,SHAPE;
begin
SHAPE:=[
[[2,2],[2,-2],[-2,-2],[-2,2],[2,2]], \SQUARE
[[0,2],[2,0],[0,-2],[-2,0],[0,2]], \DIAMOND
[[2,2],[-2,-2],[2,-2],[-2,2],[2,2]] \X
];

X1:=FIX((X-XOFF)*XSCALE);
Y1:=FIX((Y-YOFF)*YSCALE);
OMOVE(X1+SHAPE(T,0,0),Y1+SHAPE(T,0,1));
OLINE(X1+SHAPE(T,1,0),Y1+SHAPE(T,1,1),1);
OLINE(X1+SHAPE(T,2,0),Y1+SHAPE(T,2,1),1);
OLINE(X1+SHAPE(T,3,0),Y1+SHAPE(T,3,1),1);
OLINE(X1+SHAPE(T,4,0),Y1+SHAPE(T,4,1),1);
end;


procedure VGRID(X,R1,R2);
\DRAW VERTICAL GRID
\NUMBER OF LINES IN X
\START AND END OF SCALE IN R1 AND R2
integer X;
real R1,R2,DL;
integer O,I;
begin
XSCALE:=FLOAT(MAXX)/(R2-R1);
XOFF:=R1;

O:=MAXX/X;
for I:=1,X do
	begin
	OMOVE(I*O,0);
	OLINE(I*O,MAXY,1);
	end;


FORMAT(2,1);
DL:=(R2-R1)/FLOAT(X);
for I:=0,X do
	begin
	CURSOR((I*O+ORX)/8-5,(ORY/8)+1);
	RLOUT(0,R1);
	R1:=R1+DL;
	end;
end;




procedure HGRID(Y,R1,R2);
\DRAW VERTICAL GRID
\NUMBER OF LINES IN X
\START AND END OF SCALE IN R1 AND R2
integer Y;
real R1,R2,DL;
integer O,I;
begin
YSCALE:=FLOAT(MAXY)/(R2-R1);
YOFF:=R1;

O:=MAXY/Y;
for I:=1,Y do
	begin
	OMOVE(0,O*I);
	OLINE(MAXX,O*I,1);
	end;

FORMAT(2,1);
DL:=(R2-R1)/FLOAT(Y);
for I:=0,Y do
	begin
	CURSOR((ORX/8)-5,(ORY-(O*I))/8);
	RLOUT(0,R1);
	R1:=R1+DL;
	end;
end;


\--------------------------------


procedure PAUSE;
integer C;
begin
TEXT(0,"HIT ANY KEY ");
C:=CHIN(1);
end;




procedure DISVALUE(P);
\DISPLAY ONE ARRAY ENTRY
integer P;
begin
INTOUT(0,P);
for X:=0,WIDTH-1 do
	begin
	TEXT(0," X");
	INTOUT(0,X);
	RLOUT(0,XVALUES(P,X));;
	end;
TEXT(0," -  Y= ");
RLOUT(0,YVALUES(P));
CRLF(0);
end;


procedure DISARRAY;
\DISPLAY ALL VALUES IN ARRAY
integer X,C;
begin
FORMAT(3,3);
CRLF(0);
for X:=0,VPTR-1 do
	begin
	DISVALUE(X);
	if REM((X+1)/23)=0 then C:=CHIN(1);
	end;
end;



procedure ENTER(P);
\ENTER X AND Y VALUES
integer P,X;
begin
for X:=0,WIDTH-1 do
	begin
	TEXT(0,"ENTER X");
	INTOUT(0,X);
	TEXT(0,"  ");
	XVALUES(P,X):=RLIN(0);
	end;
TEXT(0,"ENTER Y VALUE ");
YVALUES(P):=RLIN(0);
end;


procedure EDIT;
\EDIT ARRAY ITEMS
integer C,P;
begin
loop
	begin
	DISARRAY;
	TEXT(0,"EDIT AN ENTRY? Y/N ");
	OPENI(0);
	C:=CHIN(0);
	if (C#^Y) & (C#^y) then quit;

	TEXT(0,"ENTER INDEX");
	P:=INTIN(0);
	CRLF(0);CRLF(0);
	DISVALUES(P);
	CRLF(0);CRLF(0);
	ENTER(P);
	end;
end;


procedure GETVALUES;
\FILL ARRAY WITH X AND Y VALUES
integer C;
begin
VPTR:=0;
loop
	begin
	ENTER(VPTR);
	VPTR:=VPTR+1;
	if VPTR>=MAXVAL then
		begin
		TEXT(0,"!! ARRAY IS FULL !!");
		quit;
		end;
	TEXT(0," MORE ? Y/n ");
	C:=CHIN(0);
	case C of ^N,^n: quit else;
	CRLF(0);
	end;
CRLF(0);
EDIT;
end;



procedure GRAPH;
\GRAPH NEW EQUATION
real XMAX,YMAX,XMIN,YMIN,XINC,DX,DY;
integer W,X,Y;



	procedure L2GRAPH;
	\DO MULTITERM LINEAR GRAPH
	real XV,YV,P;
	integer T,I;
	begin
	for I:=0,VPTR-1 do
		begin
		YV:=MATRIX(0,TERMS+1);
		for T:=0,TERMS-1 do
			YV:=YV+(MATRIX(T+1,TERMS+1)*XVALUES(I,T));

		for T:=0,TERMS-1 do SYMBOL(XVALUES(I,T),YV,1);
		end
	end;


	procedure L1GRAPH;
	\DO ONE TERM LINEAR GRAPH
	real XV,YV;
	integer T;
	begin
	XV:=XMIN;
	repeat
		begin
		YV:=MATRIX(0,TERMS+1);
		for T:=1,TERMS do
			YV:=YV+(MATRIX(T,TERMS+1)*XV);
		RPOINT(XV,YV,1);
		XV:=XV+XINC;
		end
	until XV>=XMAX;
	end;


	procedure PGRAPH;
	\DO POLYNOMIAL GRAPH
	real XV,YV,P;
	integer T;
	begin
	XV:=XMIN;
	repeat
		begin
		YV:=MATRIX(0,TERMS+1);
		P:=1.0;
		for T:=1,TERMS do
			begin
			P:=P*XV;
			YV:=YV+(MATRIX(T,TERMS+1)*P);
			end;
		RPOINT(XV,YV,1);
		XV:=XV+XINC;
		end
	until XV>=XMAX;
	end;


	procedure MGRAPH;
	\SELECT THE PROPER GRAPH
	begin
	if PFLAG then PGRAPH
	else if TERMS=1 then L1GRAPH
	else L2GRAPH;
	end;


begin	\OF GRAPH

XMAX:=1.E-300;YMAX:=1.E-300;
XMIN:=9.9E300;YMIN:=9.9E300;
W:=if PFLAG then 0 else TERMS-1;
for X:=0,VPTR-1 do
	begin
	if YVALUES(X)>YMAX then YMAX:=YVALUES(X);
	if YVALUES(X)<YMIN then YMIN:=YVALUES(X);
	for Y:=0,W do
		begin
		if XVALUES(X,Y)>XMAX then XMAX:=XVALUES(X,Y);
		if XVALUES(X,Y)<XMIN then XMIN:=XVALUES(X,Y);
		end;
	end;

DX:=(XMAX-XMIN)*.1;
DY:=(YMAX-YMIN)*.1;

SETVID(6);
WINDOW(LLX,LLY,URX,URY);
VGRID(5, XMIN-DX, XMAX+DX);
HGRID(5, YMIN-DY, YMAX+DY);
XINC:=(XMAX-XMIN)/FLOAT(URX-LLX);

for X:=0,VPTR-1 do
for Y:=0,W do SYMBOL(XVALUES(X,Y),YVALUES(X),0);

MGRAPH;

CURSOR(0,24);
PAUSE;
SETVID(3);
end;	\OF GRAPH



procedure EXPAND;
\EXPAND X TERMS INTO RESPECTIVE POWERS
integer X,T;
real P1,P2;
begin
for X:=0,VPTR-1 do
	begin
	P1:=XVALUES(X,0);
	P2:=P1;
	for T:=1,TERMS-1 do
		begin
		P1:=P1*P2;
		XVALUES(X,T):=P1;
		end;
	end;
end;


procedure real SELECT(X,Y);
\SELECT THE PROPER DATA ITEM
integer X,Y;
begin
case of
	Y=0      : return 1.0;
	Y=TERMS+1: return YVALUES(X)
else return XVALUES(X,Y-1);
end;



procedure BUILD;
\BUILD DETERMINATE MATRIX
integer X,Y,S;
begin
\ZERO MATRIX
for X:=0,TERMS+1 do
for Y:=0,TERMS+1 do
	MATRIX(X,Y):=0.0;

for S:=0,VPTR-1 do
for X:=0,TERMS+1 do
for Y:=0,TERMS+1 do
	MATRIX(X,Y):=MATRIX(X,Y) + (SELECT(S,X)*SELECT(S,Y));
end;



procedure DISMATRIX;
integer X,Y;
begin
CRLF(0);
CRLF(0);
for X:=0,TERMS+1 do
	begin
	for Y:=0,TERMS+1 do
		begin
		TEXT(0,"  M(");
		INTOUT(0,X);
		TEXT(0,",");
		INTOUT(0,Y);
		TEXT(0,")=");
		RLOUT(0,MATRIX(X,Y));
		TEXT(0,"  ");
		end;
	CRLF(0);
	end;
X:=CHIN(1);
end;



procedure GAUSS;
\DO GAUSS JORDAN ELEMINATION
integer I,K,J;
real S;

procedure DISX;
begin
TEXT(0,"I=");INTOUT(0,I);
TEXT(0," J=");INTOUT(0,J);
TEXT(0,"  K=");INTOUT(0,K);
TEXT(0,"MATRIX = ");
RLOUT(0,MATRIX(K,J));
RLOUT(0,MATRIX(K,K));
CRLF(0);
end;




begin
K:=0;
DVZFLG:=false;
loop
	begin
	S:=MATRIX(K,K);
	if S=0.0 then [DVZFLG:=true;S:=4.19E-307;];
	for J:=K,TERMS+1 do MATRIX(K,J):=MATRIX(K,J)/S;
	if K>=TERMS then quit;
	for I:=K+1,TERMS do
		begin
		S:=MATRIX(I,K);
		for J:=K,TERMS+1 do
			MATRIX(I,J):=MATRIX(I,J)-S*MATRIX(K,J);
		end;
	K:=K+1;
	end;

while K>0 do
	begin
	I:=K-1;
	repeat
		begin
		S:=MATRIX(I,K);
		for J:=K,TERMS+1 do
			MATRIX(I,J):=MATRIX(I,J)-S*MATRIX(K,J);
		I:=I-1;
		end
	until I<0;
	K:=K-1;
	end;
end;


procedure DISCONST;
\DISPLAY CONSTANTS FOR EACH TERM
integer C;
begin
TEXT(0,"

CONSTANTS TERMS FOR EQUATIONS

POLYNOMIAL = K0 + K1 * X + K2 * X^2 + K3 * X^3

LINEAR     = K0 + K1 * X1 + K2 * X2 + K3 * X3

");
if DVZFLG then
	begin
	CHOUT(0,8);
	TEXT(0,"! DIVIDE BY ZERO WAS ENCOUNTERED !");CRLF(0);
	TEXT(0,"     ACCURACY MAY BE LOST");CRLF(0);
	end;

FORMAT(6,15);
for C:=0,TERMS do
	begin
	TEXT(0,"CONSTANT TERM ");
	INTOUT(0,C);
	TEXT(0," ");
	RLOUT(0,MATRIX(C,TERMS+1));
	CRLF(0);
	end;
end;



procedure LINEAR;
\DO A LINEAR FIT
begin
PFLAG:=false;
loop
	begin
	TEXT(0,"Enter the number of X samples per Y value: ");
	TERMS:=INTIN(0);
	if TERMS<MAXTRM then quit;
	TEXT(0,"!! TOO MANY SAMPLES !!");
	CRLF(0);
	end;
WIDTH:=TERMS;
GETVALUES;
BUILD;
GAUSS;
GRAPH;
DISCONST;
VPTR:=0;
end;



procedure POLYNOM;
\DO A POLYNOMIAL FIT
integer C;
begin
PFLAG:=true;
WIDTH:=1;
if VPTR=0 then GETVALUES
else
	begin
	TEXT(0,"N = ENTER NEW DATA  O = USE OLD DATA ");
	OPENI(0);
	C:=CHIN(0);
	case C of ^n,^N: GETVALUES else EDIT;
	end;

loop
	begin
	TEXT(0,"Enter the DEGREE of the equation: ");
	TERMS:=INTIN(0);
	if TERMS<MAXTRM then quit;
	TEXT(0,"!! TO LARGE A DEGREE !!");
	CRLF(0);
	end;

EXPAND;
BUILD;
GAUSS;
GRAPH;
DISCONST;
end;



procedure MENU;
integer C;
begin
CHOUT(0,$0C);
TEXT(0,"

************ CURVE FITTING PROGRAM *************

1) LINEAR FIT
2) POLYNOMIAL FIT

Select : ");
C:=INTIN(0);
case C of
	1: LINEAR;
	2: POLYNOM
else;
PAUSE;
end;


begin
VPTR:=0;

MATRIX:=RLRES(MAXTRM);
for X:=0,MAXTRM-1 do MATRIX(X):=RLRES(MAXTRM);

YVALUES:=RLRES(MAXVAL);
XVALUES:=RLRES(MAXVAL);
for X:=0,MAXVAL-1 do XVALUES(X):=RLRES(MAXTRM);

loop MENU;
end;
