\CYCLE.XPL	SEP-18-99

inc	\CXPL\CODESI;

def	ColorSize=256;		\Number of color registers to cycle
int	Cpureg,			\Address of CPU register array (from Getreg)
	DataSeg,
	JJ;

char	COLTBL;
seg addr SCREEN;	\Array for video screen in mode $13

\-------------------------------------------------------------------------------

proc	WaitVB;		 \Wait for beginning of next vertical blank
int	SR;
begin
SR:= Peek($40, $63) + $306;	\Port address of status register
if (SR & $39A) # $39A then return;
while Pin(SR, 0) & $08 do;	\Wait for no vertical blank
repeat until Pin(SR, 0) & $08;	\Wait for vertical blank
end;	\WaitVB;

\-------------------------------------------------------------------------------

func	CallInt(Int, AX, BX, CX, DX, BP, DS, ES); \Call software interrupt
int	Int, AX, BX, CX, DX, BP, DS, ES; \(Unused arguments need not be passed)
begin
Cpureg(0):= AX;
Cpureg(1):= BX;
Cpureg(2):= CX;
Cpureg(3):= DX;
Cpureg(6):= BP;
Cpureg(9):= DS;
Cpureg(11):= ES;
Softint(Int);
return Cpureg(0);		\return AX register
end;	\CallInt

\-------------------------------------------------------------------------------

proc	Cycle;
int	I, TempR, TempG, TempB;
begin
TempR:= COLTBL(0);
TempG:= COLTBL(1);
TempB:= COLTBL(2);

for I:= 0, ColorSize-1-1 do
	begin
	COLTBL(I*3):= COLTBL((I+1)*3);
	COLTBL(I*3+1):= COLTBL((I+1)*3+1);
	COLTBL(I*3+2):= COLTBL((I+1)*3+2);
	end;

COLTBL((ColorSize-1)*3):= TempR;
COLTBL((ColorSize-1)*3+1):= TempG;
COLTBL((ColorSize-1)*3+2):= TempB;

CallInt($10, $1012, 0, ColorSize, COLTBL, 0, 0, DataSeg);	\Set block of color registers
end;	\Cycle

\-------------------------------------------------------------------------------

proc	FIXPALETTE;	\Make palette registers correspond to DAC registers
int	N, CPUREG;
begin
CPUREG:= GETREG;
for N:= 0, 15 do
	begin
	CPUREG(0):= $1000;		\AX function $10, subfunction $00
	CPUREG(1):= N<<8!N;		\BX DAC and palette registers
	SOFTINT($10);			\Call BIOS routine
	end;
end;	\FIXPALETTE

\-------------------------------------------------------------------------------

proc	DRAWBOX(X, Y, C); \Draw a color swatch
int	X, Y, C;	\Pixel coordinates, color
int	I, J;
def	H=200/16, W=320/16;		\Height and width of swatches (pixels)
begin
for J:= Y, Y+H-1 do
    for I:= X, X+W-1 do
	SCREEN(J, I):= C;
end;	\DRAWBOX

\-------------------------------------------------------------------------------

proc	DRAWBOXES;	\Draw a 16x16 array of color swatches
int	I, J, K;
begin
K:= 0;
for J:= 0, 15 do
    for I:= 0, 15 do
	begin
	DRAWBOX(I*320/16, J*(200/16), K);
	K:= K + 1;
	end;
end;	\DRAWBOXES

\-------------------------------------------------------------------------------

begin	\Main
COLTBL:= Reserve(3*ColorSize);
SCREEN:= RESERVE(200*2);		\Set up video screen array
for JJ:= 0, 199 do			\Set seg address of each scan line
	SCREEN(JJ):= $A000 + 320/16 *JJ;

Cpureg:= Getreg;
DataSeg:= Cpureg(12);

SETVID($13);				\320x200x256

DRAWBOXES;				\Show default palette

CallInt($10, $1017, 0, ColorSize, COLTBL, 0, 0, DataSeg);	\Get block of color registers
loop	begin
	WaitVB;
	WaitVB;
	WaitVB;
	WaitVB;
	WaitVB;
	WaitVB;
	Cycle;
	if ChkKey then quit;
	end;
SetVid(3);
end;	\Main
