\DECODER.XPL		7-2-83
\HUFFMAN DECODER
\BY LOREN BLANEY
\THIS PROGRAM TRANSLATES THE INPUT FILE FROM HUFFMAN TO ASCII.
\ IT USES THE CODES DETERMINED BY THE COMPANION PROGRAM,
\ "HUFFMAN".

code ABS=0, RAN=1, REM=2, RESERVE=3, SWAP=4, CHIN=7, CHOUT=8, CRLF=9
INTIN=10, INTOUT=11, TEXT=12, OPENI=13, OPENO=14, CLOSE=15, FREE=18;

def	TV=0, KB=0, PR=2, FILE=3;	\I/O DEVICE NUMBERS
def	EOF=$1A, BEL=$07;

char	TABLE;	\DECODER TABLE
int	BITSTR,	\BIT STREAM
	BITBUF,
	BITCNT,
	DEV,
	CH,
	;

\----------------------------------------------------------------------\

proc	BITIN;
begin
if BITCNT<=0 then
	begin
	BITBUF:=CHIN(FILE);
	BITBUF:=SWAP(BITBUF);
	BITCNT:=8;
	end;
BITSTR:=BITSTR+BITSTR;
if BITBUF<0 then BITSTR:=BITSTR+1;
BITBUF:=BITBUF+BITBUF;
BITCNT:=BITCNT-1;
end;	\BITIN

\----------------------------------------------------------------------\

proc	READTABLE;
int	I,DEBUGTBL;
begin
DEBUGTBL:=[3,32,197,84,79,65,78,82,201,72,83,76,85,89,
	141,46,71,67,68,39,35,77,87,194,70,80,86,203,33,
	172,90,162,202,81,186,51,54,38,49,55,88];

for I:=0,40 do TABLE(I):=DEBUGTBL(I);
\'FOR'I:=0,40'DO'CHOUT(TV,TABLE(I)&$7F);	\\*** DEBUG
end;	\READTABLE

\----------------------------------------------------------------------\

func	DECODE;
\CONVERT HUFFMAN TO ASCII
int	PTR,I,CODON;
begin
\SCAN TABLE FOR MATCH (NOTE THE FIRST ENTRY OF THE TABLE CONTAINS THE
\ NUMBER OF BITS IN THE FIRST CHARACTER)
BITSTR:=0;
for I:=1,TABLE(0) do BITIN;
PTR:=1;
CODON:=0;
loop	begin
\	INTOUT(TV,BITSTR); CHOUT(TV,^ ); INTOUT(TV,CODON); CRLF(TV);	\\***
	if CODON=BITSTR then return TABLE(PTR)&$7F;
	CODON:=CODON+1;
	if TABLE(PTR)>=$80 then
		begin
		CODON:=CODON+CODON;
		BITIN;
		end;
	PTR:=PTR+1;
	end;
end;	\DECODE

\----------------------------------------------------------------------\

begin	\MAIN
TABLE:=RESERVE(100);
TEXT(TV,"-- HUFFMAN DECODER, VER 1.0X --
");
TEXT(TV,"OUTPUT DEVICE? ");
DEV:=INTIN(KB);
OPENO(DEV);

READTABLE;

OPENI(FILE); BITCNT:=0;
loop	begin
	CH:=DECODE;
	if CH=EOF then quit;
	CHOUT(DEV,CH);
	end;

CLOSE(DEV);
end;	\MAIN
