\DEFLECT.XPL
\ APPLE DEFLECTION

\BY LOREN BLANEY AND RICHARD OTTOSEN
\COPYRIGHT 1979
\ (REF. KILOBAUD FEB. '78 PG. 112)
\ ORIGINALLY BY ANDREW RECUPERO

\ APPLE VERSION BY ROGER NACE

\ IN THIS VERSION THE KEYS:
\	0-9 CONTROLS THE SPEED (0 IS THE FASTEST)
\	C CLEARS THE SCREEN AND RETURNS TO APEX
\	F (FUTILE) ERASES THE DEFLECTORS

code		RAN=1,		REM=2,
RESERVE=3,	CHIN=7,		CHOUT=8,
CRLF=9,		NUMIN=10,	NUMOUT=11,
TEXT=12,	OPENI=13,	CURSOR=23,
SOUND=39,	PADDLE=38,	SWITCH=37,
ABORT=16;

int I, J, CON, UP, DOWN, RIGHT,
X, Y, DIR, RUNNER, LEFT, HIT,
SLASH, BKSLASH, TAR1, TAR2,
TARGET, TRUE, FALSE, SCORE1,
SCORE2, DELAY, FUTILE,
LSTKY1, LSTKY2, ECHOCOUNT, ECHOTOGGLE;

addr FIELD, XN, YN, DIRN, 
RUNN, CMDN, KEYIN;

proc UPDATE(X, Y, SYMBOL); \UPDATE FIELD AND SCREEN
int X, Y, SYMBOL;
begin
FIELD(X+40*Y):=SYMBOL;
CURSOR(X,Y);
CHOUT(CON, SYMBOL);
end; \UPDATE

proc NEWPARAM;
int INK;
begin

INK:=KEYIN(0) & $7F; \READ THE KEYBOARD
KEYIN($10):=0; \RESET THE KEY STROBE

if INK >= ^0 & INK <= ^9 then
	DELAY:=2+(INK-^0)*4;

if INK=^C then [ CURSOR(0,0); CHOUT(CON,12);
	ABORT; ];

FUTILE:=INK=^F;

end; \NEWPARAM

proc INPUT; \TIME DELAY & BUTTON CHECK
int D;
begin

CMDN(0):=0; CMDN(1):=0; \NOT BACKSLASH OR SLASH

\NOTE: THE LSTKY FUNCTION PREVENTS A PLAYER
\ FROM GENERATING DEFLECTORS BY HOLDING
\ DOWN HIS BUTTON.

D:=DELAY;

loop	begin

	D:=D-1; if D=0 then quit;

	if LSTKY1 & SWITCH(0) then
		[ if PADDLE(0)<100
		then CMDN(0):=BKSLASH
		else CMDN(0):=SLASH;
		LSTKY1:=FALSE; ];

	if LSTKY2 & SWITCH(1) then
		[ if PADDLE(1)<100
		then CMDN(1):=BKSLASH
		else CMDN(1):=SLASH;
		LSTKY2:=FALSE; ];

	LSTKY1:= not SWITCH(0);
	LSTKY2:= not SWITCH(1);

	end;

end; \INPUT

proc ECHO;
int D;
begin

ECHOTOGGLE:=ECHOTOGGLE+1;
D:=ECHOTOGGLE & 1;

if D=1 then CURSOR(25,23)
else CURSOR(13,23);

if PADDLE(D)<100 then CHOUT(CON,BKSLASH)
else CHOUT(CON,SLASH);

ECHOCOUNT:=5;

end; \ECHO

proc PSCORE; \PRINT THE INDIVIDUAL SCORE
begin
CURSOR(17,23); NUMOUT(CON,4-TAR1);
CURSOR(21,23); NUMOUT(CON,4-TAR2);
end; \PSCORE

proc ACTION(PLAYER);
int PLAYER, COMMAND;

proc EDGE; \BOUNCE OFF OF EDGE
begin
if X=0 & DIR=LEFT then
	[DIR:=RIGHT; SOUND(40,12,900)]
else if X=39 & DIR=RIGHT then
	[DIR:=LEFT; SOUND(40,12,900)]
else if Y=0 & DIR=UP then
	[DIR:=DOWN; SOUND(40,12,900)]
else if Y=22 & DIR=DOWN then
	[DIR:=UP; SOUND(40,12,900)];
end; \EDGE

begin \ACTION
X:=XN(PLAYER); Y:=YN(PLAYER);
DIR:=DIRN(PLAYER); RUNNER:=RUNN(PLAYER);
COMMAND:=CMDN(PLAYER);
\IF OLD RUNNER IS DISPLACED THEN REMOVE IT
if FIELD(X+40*Y)=RUNNER then UPDATE(X,Y,^ );

\CALCULATE NEW RUNNER POSITION
if DIR=RIGHT then X:=X+1
else if DIR=LEFT then X:=X-1
else if DIR=UP then Y:=Y-1
else if DIR=DOWN then Y:=Y+1;

\IF WE HIT A TARGET THEN REMOVE IT, SOUND GONG &
\TEST FOR WIN

HIT:=FIELD(X+40*Y)=TARGET;

if HIT then
	begin
	UPDATE(X,Y,^ );
	for I:=0, 5 do
		[SOUND(127,25,180);
		SOUND(0,25,180)];
	end;

if FIELD(X+40*Y)=^  then UPDATE(X,Y,RUNNER);

\SEE IF RUNNER NEEDS TO CHANGE DIRECTION - IF SO, DO IT
if COMMAND#0 \BUTTON IS PUSHED\ then UPDATE(X,Y,COMMAND);
if FIELD(X+40*Y)=SLASH then
	[   if DIR=RIGHT then DIR:=UP
	else if DIR=LEFT then DIR:=DOWN
	else if DIR=UP   then DIR:=RIGHT
	else if DIR=DOWN then DIR:=LEFT;
	SOUND(32,7,(DIR+5)*90); ];

if FIELD(X+40*Y)=BKSLASH then
	[   if DIR=RIGHT then DIR:=DOWN
	else if DIR=LEFT then DIR:=UP
	else if DIR=UP   then DIR:=LEFT
	else if DIR=DOWN then DIR:=RIGHT;
	SOUND(32,7,(DIR+1)*90); ];
EDGE;

XN(PLAYER):=X; YN(PLAYER):=Y;
DIRN(PLAYER):=DIR; RUNN(PLAYER):=RUNNER;
end; \ACTION

begin \MAINLINE
CON:=0; TRUE:=1=1; FALSE:=1=0;
UP:=0; DOWN:=1; RIGHT:=2; LEFT:=3;
SLASH:=^/; BKSLASH:=^\;
TARGET:=^*;
KEYIN:=$C000;
FIELD:=RESERVE(1024);
XN:=RESERVE(2); YN:=RESERVE(2);
DIRN:=RESERVE(2); RUNN:=RESERVE(2);
CMDN:=RESERVE(2);
RUNN(0\PLAYER 1\):=^@;
RUNN(1\PLAYER 2\):=^#;
SCORE1:=0; SCORE2:=0;
DELAY:=20;
loop begin
FUTILE:=FALSE;
TAR1:=4; TAR2:=TAR1;

CURSOR(0,23); TEXT(CON,"+-+- ");
if SCORE1<10 then TEXT(CON," ");
NUMOUT(CON,SCORE1);
TEXT(CON," -+-+   "); CHOUT(CON,RUNN(0));
CURSOR(23,23); CHOUT(CON,RUNN(1));
TEXT(CON,"   +-+- ");
if SCORE2<10 then TEXT(CON," ");
NUMOUT(CON,SCORE2);
TEXT(CON," -+-+");
ECHO; ECHO; PSCORE;

for Y:=0,22 do for X:=0,39 do UPDATE(X,Y,^ );
for I:=1,TAR1+TAR2-1 do UPDATE(RAN(40), RAN(21)+1,TARGET);
XN(0):=0; YN(0):=0; DIRN(0):=RIGHT;
XN(1):=39; YN(1):=0; DIRN(1):=LEFT;

loop begin

	INPUT;

	ACTION(0\PLAYER 1\);

	if HIT then [ TAR1:=TAR1-1;
		PSCORE ];

	ACTION(1\PLAYER 2\);

	if HIT then [ TAR2:=TAR2-1;
		PSCORE ];

	SOUND(20,1,90); \FOOTSTEPS

	ECHOCOUNT:=ECHOCOUNT-1;
	if ECHOCOUNT=0 then ECHO;

	if (KEYIN(0) & $80)#0 then NEWPARAM;

	if FUTILE then
		[ for Y:=0,22 do
		for X:=0,39 do
			[ J:=FIELD(X+40*Y);
			if J=SLASH ! J=BKSLASH then
				UPDATE(X,Y,^ )];
		FUTILE:=FALSE;
		];

	if TAR1=0 ! TAR2=0 & TAR1#TAR2 then quit;

	end;

SOUND(40,26,720); SOUND(40,35,540);
SOUND(40,42,450); SOUND(40,70,270);
SOUND(40,35,540); SOUND(40,42,450);

\OUTPUT THE SCORE
if TAR1#0 ! TAR2#0 then 
	if TAR1=0 then SCORE1:=SCORE1+1
	else SCORE2:=SCORE2+1;
end;

end; \MAINLINE
