\DOSIN.XPL
\
\	D O S I N
\
\ THIS UTILITY WILL READ DOS STRUCTURED
\ DISKS, AND CREATE APEX FORMATTED
\ FILES.  THE UTILITY WILL DO THE
\ FOLLOWING:
\	FOR TEXT, APPLSOFT AND INTEGER
\	BASIC FILES, A "STANDARD" APEX
\	FILE MAY BE WRITTEN, THAT IS,
\	AN APEX "TEXT" FILE MAY BE
\	PRODUCED.  FOR ALL FILES OF THIS
\	NATURE, THE USER IS GIVEN THE
\	OPTION OF APPENDING A <LINE-
\	FEED> CHARACTER AFTER EACH
\	<RETURN>.  THIS ALLOWS ONE TO
\	MOVE "ROD-WRITE" FILES TO APEX.
\
\	FOR BINARY DOS FILES THE USER
\	IS GIVEN THE OPPORTUNITY TO
\	PRODUCE AN APEX FILE AS
\	DESCRIBED ABOVE, OR A "SAVE" OR
\	"BINARY" (LOAD IMAGE) FILE.
\	THE SAVE FILE IS HANDY TO SIMPLY
\	TAKE A STAND-ALONE DOS BINARY
\	FILE AND CONVERT IT TO A
\	RUNABLE APEX FILE.  THE LOAD
\	IMAGE BINARY IS HANDY FOR
\	SEGMENTED BINARY IMAGES WHICH
\	UNDER APEX MAY BE LOADED IN
\	ONE COMMAND.  CAUTION! - THE
\	PAGE ZERO AND "SYSTEM" LOCATIONS
\	USED FOR APEX MIGHT MAKE THIS
\	OPERATION DIFFICULT.
\
\	FINALLY, FOR ANY TYPE OF FILE
\	ORGANIZATION, THE USER MAY
\	SELECT THE "UNFORMATTED" OPTION.
\	THIS SIMPLY MOVES BLOCKS OF DATA
\	FROM THE DOS DISK TO THE APEX
\	DISK WITHOUT ANY SPECIAL START
\	OR END CONDITION SEARCHES.
\
\	A FINAL CAUTION:  THE APEX AND
\	DOS STRUCTURED DISKS MUST BE ON
\	DIFFERENT DRIVES!
\
\
\	ROGER NACE - DECEMBER 1980.
\
\



'CODE'	\XPL0 V4D
RESERVE=3	SWAP=4		CHIN=7
CHOUT=8		CRLF=9		NUMIN=10
NUMOUT=11	TEXT=12		OPENI=13
OPENO=14	CLOSE=15	FREAD=31;

'INT'	SE	IN	T	DIR
	OUT	DOSIN;





'PROC'	BLOCK(TRA,SEC);	\CONVERT TRACK-SECTOR TO BLOCK
'INT'	TRA,	SEC;
'BEGIN'
'RETURN' (TRA*13)+SEC;
'END';




'PROC'	ONEBYTE;	\RETURN THE FIRST BYTE OF A TYPED LINE
'INT'	T;
'BEGIN'
T:=CHIN(0);
'IF' T#$D 'THEN'
	'WHILE' CHIN(0)#$D 'DO';
'RETURN' T;
'END';





'PROC'	HEXOUT(D);	\PRINT ARGUMENT AS A HEX PAIR
'INT'	D;


'PROC'	NIBOUT(D);	\PRINT ARGUMENT AS A HEX NIBBLE
'INT'	D;

'BEGIN'
D:=D+48;
'IF' D>57 'THEN' D:=D+7;
CHOUT(OUT,D);
'END';	\OF NIBOUT

'BEGIN'	\OF HEXOUT
NIBOUT(D/16);
NIBOUT(D&$0F)
'END';	\OF HEXOUT



'PROC'	COPY(IN);	\COPY THE DOS TO APEX FILE
'INT'	IN	FLSIDX	T1	APPON
	LODON	SAVON	FIRSTB	ST
	BLEN	KEEPON	UNFON	TXTON;

'ADDR'	FLS,	BUF	SSA;


'PROC' DOFIRST;		\SPECIAL ROUTINE FOR FIRST BLOCK
'BEGIN'
 FIRSTB:='FALSE';
BLEN:=BUF(2)+SWAP(BUF(3));
SSA:=$BF00;	\SETUP THE $BF00 PAGE
SSA(1):=BUF(0); SSA(2):=BUF(1);
SSA(4):=BUF(0); SSA(5):=BUF(1);
SSA($15):=BUF(0); SSA($16):=BUF(1);
SSA($17):=BUF(3); SSA($28):='TRUE';

'IF' BUF(2)#0 'THEN'
	SSA($17):=SSA($17)+1;

SSA($10):=BUF(0);
SSA($11):=BUF(1); SSA($12):=SSA($17);

\OUTPUT THE $BF00 PAGE IF WE PRODUCE A SAVE FILE
'IF' (OUT=3) & SAVON 'THEN'
	'FOR' T1:=0,$FF 'DO'
		CHOUT(OUT,SSA(T1));

\SET NEW START IF BINARY STUFF IS SKIPPED
'IF' (DIR(IN)&$8000)#0 'THEN' ST:=4;

\OUTPUT THE LOADER'S ADDRESS HEADER
'IF' LODON 'THEN'
	[CHOUT(OUT,^*);
	HEXOUT(SSA(2));
	HEXOUT(SSA(1))];

'END';	\OF DOFIRST




'PROC'	DOTXT;		\OUTPUT A TEXT FILE
'BEGIN'
'FOR' T1:=ST,255 'DO'
	[KEEPON:=BUF(T1) #0;
	'IF' KEEPON 'THEN'
		CHOUT(OUT,BUF(T1));
	'IF' APPON & (BUF(T1)=$0D) 'THEN'
		CHOUT(OUT,$0A)];

'IF' 'NOT' KEEPON 'THEN'
	CHOUT(OUT,26);	\EOF ON THIS FILE TYPE

'END';	\OF DOTXT



'PROC'	DOUNF;		\OUTPUT AN UNFORMATTED FILE (NO SEARCH FOR INTERNAL END)
'BEGIN'
'FOR' T1:=0,255 'DO'	\NOTE THAT THERE IS NO OFFSET ON START POSITION EITHER
	CHOUT(OUT,BUF(T1));
'END';




'PROC'	DOLOD;		\OUTPUT A BINARY (LOAD IMAGE) FILE
'BEGIN'
'FOR' T1:=ST,255 'DO'
	'IF' KEEPON 'THEN'
		[HEXOUT(BUF(T1));
		BLEN:=BLEN-1;
		KEEPON:=(BLEN#0)];

'IF' 'NOT' KEEPON 'THEN'
	CHOUT(OUT,26);	\EOF ON THIS FILE TYPE

'END';	\OF DOLOD


'PROC'	DOSAV;		\OUTPUT A SAVE IMAGE
'BEGIN'
'FOR' T1:=ST,255 'DO'
	'IF' KEEPON 'THEN'
		[CHOUT(OUT,BUF(T1));
		BLEN:=BLEN-1;
		KEEPON:=(BLEN#0)];

'END';	\OF DOSAV






'BEGIN'	\OF COPY

FLS:=RESERVE(256);	\A BUFFER FOR THE FILE LINK SECTOR (FLS)
BUF:=RESERVE(256);	\A BUFFER FOR DOS FILE INPUT DATA

LODON:='FALSE';	SAVON:='FALSE';
UNFON:='FALSE';	TXTON:='FALSE';
APPON:='FALSE';

FIRSTB:='TRUE';

'IF' (DIR(IN)&$8000) # 0 'THEN'
	'BEGIN'
	TEXT(0,"
TREAT AS TEXT, BINARY (LOAD IMAGE),
SAVE, OR UNFORMATTED FILE
(ENTER: T,B,S OR U) <T> ");
	T1:=ONEBYTE;
	'CASE' T1 'OF'
		^B:LODON:='TRUE';
		^L:LODON:='TRUE'; \ELIMINATE SOME OF NACE'S TYPING ERRORS
		^S:SAVON:='TRUE';
		^U:UNFON:='TRUE'
	'ELSE' TXTON:='TRUE';
	'END'
'ELSE'
	'BEGIN'
	TEXT(0,"
TREAT AS TEXT OR UNFORMATTED FILE
(ENTER: T OR U) <T> ");
	T1:=ONEBYTE;
	'CASE' T1 'OF'
		^U:UNFON:='TRUE'
	'ELSE' TXTON:='TRUE';
	'END';



'IF' TXTON 'THEN'
	[TEXT(0,"
APPEND LF AFTER CR  <Y> ");
	APPON:=(ONEBYTE#^N)];

FREAD(DOSIN,BLOCK(SWAP(DIR(IN))&$3F,DIR(IN)&$FF),FLS,1);
	\GET THE FIRST FLS
FLSIDX:=10;
KEEPON:='TRUE';
'LOOP'
	'BEGIN'
	FLSIDX:=FLSIDX+2;
	'IF' (FLSIDX=256) & (FLS(1)#0)'THEN'
		'BEGIN'
		FREAD(DOSIN,BLOCK(FLS(1),FLS(2)),FLS,1);
			\GET SUBSEQUENT FLS'S
		FLSIDX:=12;
		'END';

	'IF' FLS(FLSIDX)=0 'THEN' 'QUIT';

	FREAD(DOSIN,BLOCK(FLS(FLSIDX),FLS(FLSIDX+1)),BUF,1);
		\GET A BLOCK OF THE INPUT FILE
	ST:=0;

	'IF' FIRSTB 'THEN' DOFIRST;

	'CASE' 'OF'
		LODON:DOLOD;
		SAVON:DOSAV;
		TXTON:DOTXT;
		UNFON:DOUNF
	'ELSE';

	'IF' 'NOT' KEEPON 'THEN' 'QUIT';

	'END';

'END';	\OF COPY





'PROC'	PNAME(DIRB,IND,IN35);	\PRINT THE DOS FILENAME
'ADDR'	DIRB;
'INT'	IND,	IN35,	T;
'BEGIN'
TEXT(0,"   ");
'IF' IND<10 'THEN' TEXT(0," ");
NUMOUT(0,IND);
TEXT(0,"  ");
DIR(IND):=SWAP(DIRB(IN35+11))+DIRB(IN35+12);
	\BUILD T&S ARRAY
'CASE' DIRB(IN35+13) & $3F 'OF'
	0:TEXT(0,"T ");
	1:TEXT(0,"I ");
	2:TEXT(0,"A ");
	4:[TEXT(0,"B "); DIR(IND):=DIR(IND) ! $8000]
		\FLAG THE T&S ARRAY IF BINARY
'ELSE' TEXT(0,"? ");
'FOR' T:=0,29 'DO'
	CHOUT(0,
	DIRB(IN35+14+T));
CRLF(0);
'END';






'PROC'	DIRLIST;	\PRINT THE DOS DIRECTORY
'ADDR'	DIRB;
'INT'	INDEX,	T,	TSEC,	T7,
	IN35	NAMC;
'BEGIN'

DIRB:=RESERVE(256);

TEXT(0,"INDEX    NAME");
CRLF(0); CRLF(0);

TSEC:=0;
NAMC:=0;
'LOOP'
	'BEGIN'
	T7:=TSEC*7;
	SE:=12-TSEC;
	FREAD(DOSIN,BLOCK($11,SE),DIRB,1);
	'FOR' INDEX:=0,6 'DO'
		'BEGIN'
		IN35:=INDEX*35;
		'IF' DIRB(IN35+11)=0 'THEN'
			'QUIT';
		'IF' DIRB(IN35+11)#$FF 'THEN'
			[PNAME(DIRB,T7+INDEX,IN35);
			NAMC:=NAMC+1;
			'IF' NAMC=21 'THEN'
				[NAMC:=ONEBYTE;
				NAMC:=0;];];

		'END';
	TSEC:=TSEC+1;
	'IF' TSEC=12 'THEN' 'QUIT'
	'END';

'END';

'BEGIN'	\ MAINLINE

DIR:=RESERVE(168);

\THERE IS A DIR() ENTRY FOR EACH INDEX
\OF THE DOS DISK.  DIR(X)=$FFFF IF THE
\FILE DOES NOT EXIST.
\DIR(X)=TRACK*256+SECTOR IF THE FILE
\EXISTS.  DIR(X)=DIR(X)!$8000 IF THE
\FILE IS A DOS BINARY IMAGE.

'FOR' T:=0,83 'DO' DIR(T):=$FFFF;

CHOUT(0,12);	\<FF>

TEXT(0,"
	    D O S I N

READ APPLEDOS STRUCTURED FILES INTO AN
APEX FILE STRUCTURE.

PLEASE ENTER THE 'DISK UNIT' NUMBER
OF THE DOS STRUCTURED DEVICE <1> ");
DOSIN:=ONEBYTE;
'IF' DOSIN=$D 'THEN' DOSIN:=1;
DOSIN:=DOSIN & $07;

TEXT(0,"
PLEASE ENTER THE 'DEVICE' NUMBER
FOR THE OUTPUT <3> ");
OUT:=ONEBYTE;
'IF' OUT=$D 'THEN' OUT:=3;
OUT:=OUT & $07;
OPENO(OUT);

CHOUT(0,12);	\<FF>

DIRLIST;

TEXT(0,"
PLEASE SELECT THE PROGRAM TO COPY
BY TYPING ITS INDEX NUMBER ");
IN:=NUMIN(0);
'IF' DIR(IN)#$FFFF 'THEN'
	COPY(IN)
	'ELSE'	[CRLF(0); CHOUT(0,7);
		TEXT(0,"
THERE IS NO FILE BY THAT INDEX");];
CRLF(0);
CLOSE(OUT);


'END';

