\DOSREAD.XPL
\
\	D O S A P X
\
\ THIS UTILITY WILL READ DOS STRUCTURED
\ DISKS, AND CREATE APEX FORMATTED
\ FILES.  THE UTILITY WILL DO THE
\ FOLLOWING:
\	FOR TEXT, APPLSOFT AND INTEGER
\	BASIC FILES, A "STANDARD" APEX
\	FILE MAY BE WRITTEN, THAT IS,
\	AN APEX "TEXT" FILE MAY BE
\	PRODUCED.  FOR ALL FILES OF THIS
\	NATURE, THE USER IS GIVEN THE
\	OPTION OF APPENDING A <LINE-
\	FEED> CHARACTER AFTER EACH
\	<RETURN>.
\
\	FOR BINARY DOS FILES THE USER
\	IS GIVEN THE OPPORTUNITY TO
\	PRODUCE AN APEX FILE AS
\	DESCRIBED ABOVE, OR A "SAVE" OR
\	"BINARY" (LOAD IMAGE) FILE.
\	THE SAVE FILE IS HANDY TO SIMPLY
\	TAKE A STAND-ALONE DOS BINARY
\	FILE AND CONVERT IT TO A
\	RUNABLE APEX FILE.  THE LOAD
\	IMAGE BINARY IS HANDY FOR
\	SEGMENTED BINARY IMAGES WHICH
\	UNDER APEX MAY BE LOADED IN
\	ONE COMMAND.  CAUTION! - THE
\	PAGE ZERO AND "SYSTEM" LOCATIONS
\	USED FOR APEX MIGHT MAKE THIS
\	OPERATION DIFFICULT.
\
\	FINALLY, FOR ANY TYPE OF FILE
\	ORGANIZATION, THE USER MAY
\	SELECT THE "UNFORMATTED" OPTION.
\	THIS SIMPLY MOVES BLOCKS OF DATA
\	FROM THE DOS DISK TO THE APEX
\	DISK WITHOUT ANY SPECIAL START
\	OR END CONDITION SEARCHES.
\
\	ROGER NACE DECEMBER 1980
\
\	MODIFIED FOR 16 SECTOR DOS 3.3
\	AND SINGLE DRIVE USAGE  & RENAMED
\	FROM DOSIN TO DOSREAD
\
\       COMPUTER SIGHT JANUARY, 1982
\
\	A FEW BUGS FIXED:
\	 SAV FILE PAGE
\	 TXT <LF> AFTER <CR>
\
\	ROGER NACE  AUGUST 1982
\
\		* * N O T E * *
\
\	THIS MUST BE COMPILED WITH XPLV5,
\	AND USED WITH I2LBIG (FROM XPL V4).
\	THE SAVE FILE SHOULD HAVE THE 
\	DEFAULT OUTPUT EXTENTION SET AND
\	THE DEFAULT INPUT EXTENTION CLEAR!



'CODE'	\XPL0 V5 E
RESERVE=3	SWAP=4		CHIN=7
CHOUT=8		CRLF=9		NUMIN=10
NUMOUT=11	TEXT=12		OPENI=13
OPENO=14	CLOSE=15	FREAD=31WRITE=30        ABORT=16;

'INT'	SE	IN	T	DIR
	OUT	DOSIN;



\DECLARATIONS FOR "FAKE" BYTE I/O
address BUFFER;
address OTLBLK,OTHBLK,OTFLG,OTDEV;
define BUFSIZ=$4000;
define BEL=$7;
integer BLOCKS,GARB;
integer FIRBLK,LASTBLK, \FIRST AND LAST BLOCKS OF APEX FILE
        UNIT, \UNIT OF APEX DEVICE;
	NOWBLK, \NEXT BLOCK TO WRITE
	LEFT, \BLOCKS REMAINING
	INDEX; \BUFFER POINTER TO CURRENT CHARACTER

procedure CHNGDSK(NEWUN,OPSYS);
integer NEWUN;
character OPSYS;

begin
    TEXT(0,"


PUT ");TEXT(0,OPSYS);
TEXT(0," DISK ON UNIT ");
    NUMOUT(0,NEWUN);CRLF(0);
    TEXT(0,"
TYPE RETURN WHEN READY:");
    GARB:=CHIN(0);
end;

procedure ERROR(ERR);
integer ERR,MESS;
define NUMESS=3;


begin
MESS:=RESERVE(2*(NUMESS+1));
MESS(0):="NO OUTPUT FILE WAS OPENED";
MESS(1):="OUT OF DISK SPACE FILE HAS
BEEN TRUNCATED";
MESS(2):="THERE IS NO FILE WITH THAT INDEX";
MESS(3):="NO FILES ?==> NOT DOS DISK?";
CRLF(0);CRLF(0);
TEXT(0," *** error ***");CRLF(0);
TEXT(0,MESS(ERR));
CHNGDSK(UNIT,"APEX");
     ABORT;
end;\ERROR


procedure OPENA;
function integer SWABL(WHERE);
address WHERE;
return WHERE(0)+SWAP(WHERE(1));

begin \OPENA
  OTLBLK:=$BF70;
  OTHBLK:=$BF72;
  OTFLG:=$BF74;
  OTDEV:=$BF76;
  
     FIRBLK:=SWABL(OTLBLK);
     LASTBLK:=SWABL(OTHBLK);
     UNIT:=OTDEV(0);
     LEFT:=LASTBLK-FIRBLK+1;
     NOWBLK:=FIRBLK;
     INDEX:=0;
     if OTFLG(0)=0 then ERROR(0);

end;

procedure CLOSEO;
begin
     NOWBLK:=NOWBLK-1;
     OTHBLK(0):=(NOWBLK&$FF);
     OTHBLK(1):=SWAP(NOWBLK);
     OTFLG(0):=$FF;
end;

procedure OUTBUF;

begin
     BLOCKS:=(INDEX-1)/256+1;
     if BLOCKS>LEFT then [CLOSEO;ERROR(1);];
     if UNIT=DOSIN then CHNGDSK(UNIT,"APEX");
     WRITE(UNIT,NOWBLK,BUFFER,BLOCKS);
     NOWBLK:=NOWBLK+BLOCKS;
     LEFT:=LASTBLK-NOWBLK+1;
     if INDEX>=BUFSIZ & DOSIN=UNIT then
     CHNGDSK(DOSIN,"DOS");
     INDEX:=0;
end;

procedure CHOUTM(CHAR);
integer CHAR;
begin
    BUFFER(INDEX):=CHAR;
    INDEX:=INDEX+1;
    if INDEX >=BUFSIZ then OUTBUF;
end;


'PROC'	BLOCK(TRA,SEC);	\CONVERT TRACK-SECTOR TO BLOCK
'INT'	TRA,	SEC	,APSEC,HOLD;
'BEGIN'
if SEC=0 then APSEC:=0
else APSEC:=if SEC=15 then 15 else
       15-SEC;
'RETURN' (TRA*16)+APSEC;
'END';




'PROC'	ONEBYTE;	\RETURN THE FIRST BYTE OF A TYPED LINE
'INT'	T;
'BEGIN'
T:=CHIN(0);
'IF' T#$D 'THEN'
	'WHILE' CHIN(0)#$D 'DO';
'RETURN' T;
'END';





'PROC'	HEXOUT(D);	\PRINT ARGUMENT AS A HEX PAIR
'INT'	D;


'PROC'	NIBOUT(D);	\PRINT ARGUMENT AS A HEX NIBBLE
'INT'	D;

'BEGIN'
D:=D+48;
'IF' D>57 'THEN' D:=D+7;
CHOUTM(D);
'END';	\OF NIBOUT

'BEGIN'	\OF HEXOUT
NIBOUT(D/16);
NIBOUT(D&$0F)
'END';	\OF HEXOUT



'PROC'	COPY(IN);	\COPY THE DOS TO APEX FILE
'INT'	IN	FLSIDX	T1	APPON
	LODON	SAVON	FIRSTB	ST
	BLEN	KEEPON	UNFON	TXTON;

'ADDR'	FLS,	BUF	SSA;


'PROC' DOFIRST;		\SPECIAL ROUTINE FOR FIRST BLOCK
'BEGIN'
 FIRSTB:='FALSE';
BLEN:=BUF(2)+SWAP(BUF(3));
SSA:=$BF00;	\SETUP THE $BF00 PAGE
SSA(1):=BUF(0); SSA(2):=BUF(1);
SSA(4):=BUF(0); SSA(5):=BUF(1);
SSA($15):=BUF(0); SSA($16):=BUF(1);
SSA($17):=BUF(3); SSA($28):='TRUE';

'IF' BUF(2)#0 'THEN'
	SSA($17):=SSA($17)+1;

SSA($10):=BUF(0);
SSA($11):=BUF(1); SSA($12):=SSA($17);

\OUTPUT THE $BF00 PAGE IF WE PRODUCE A SAVE FILE
'IF' \(OUT=3) &\ SAVON 'THEN'
	'FOR' T1:=0,$FF 'DO'
		CHOUTM(SSA(T1));

\SET NEW START IF BINARY STUFF IS SKIPPED
'IF' (DIR(IN)&$8000)#0 'THEN' ST:=4;

\OUTPUT THE LOADER'S ADDRESS HEADER
'IF' LODON 'THEN'
	[CHOUTM(^*);
	HEXOUT(SSA(2));
	HEXOUT(SSA(1))];

'END';	\OF DOFIRST




'PROC'	DOTXT;		\OUTPUT A TEXT FILE
'BEGIN'
'FOR' T1:=ST,255 'DO'
	begin
	KEEPON:=BUF(T1) #0;
	'IF' KEEPON 'THEN'
		CHOUTM(BUF(T1)&$7F);
	'IF' APPON & ( (BUF(T1)&$7F) = $0D) 'THEN'
		CHOUTM($0A)
	end;

'IF' 'NOT' KEEPON 'THEN'
	CHOUTM(26);	\EOF ON THIS FILE TYPE

'END';	\OF DOTXT



'PROC'	DOUNF;		\OUTPUT AN UNFORMATTED FILE (NO SEARCH FOR INTERNAL END)
'BEGIN'
'FOR' T1:=0,255 'DO'	\NOTE THAT THERE IS NO OFFSET ON START POSITION EITHER
	CHOUTM(BUF(T1));
'END';




'PROC'	DOLOD;		\OUTPUT A BINARY (LOAD IMAGE) FILE
'BEGIN'
'FOR' T1:=ST,255 'DO'
	'IF' KEEPON 'THEN'
		[HEXOUT(BUF(T1));
		BLEN:=BLEN-1;
		KEEPON:=(BLEN#0)];

'IF' 'NOT' KEEPON 'THEN'
	CHOUTM(26);	\EOF ON THIS FILE TYPE

'END';	\OF DOLOD


'PROC'	DOSAV;		\OUTPUT A SAVE IMAGE
'BEGIN'
'FOR' T1:=ST,255 'DO'
	'IF' KEEPON 'THEN'
		[CHOUTM(BUF(T1));
		BLEN:=BLEN-1;
		KEEPON:=(BLEN#0)];

'END';	\OF DOSAV






'BEGIN'	\OF COPY

FLS:=RESERVE(256);	\A BUFFER FOR THE FILE LINK SECTOR (FLS)
BUF:=RESERVE(256);	\A BUFFER FOR DOS FILE INPUT DATA

LODON:='FALSE';	SAVON:='FALSE';
UNFON:='FALSE';	TXTON:='FALSE';
APPON:='FALSE';

FIRSTB:='TRUE';

'IF' (DIR(IN)&$8000) # 0 'THEN'
	'BEGIN'
	TEXT(0,"

TREAT AS TEXT, BINARY (LOAD IMAGE),
SAVE, OR UNFORMATTED FILE?
(ENTER: T,B,S OR U) <T> ");
	T1:=ONEBYTE;
	'CASE' T1 'OF'
		^B:LODON:='TRUE';
		^L:LODON:='TRUE'; \ELIMINATE SOME OF NACE'S TYPING ERRORS
		^S:SAVON:='TRUE';
		^U:UNFON:='TRUE'
	'ELSE' TXTON:='TRUE';
	'END'
'ELSE'
	'BEGIN'
	TEXT(0,"
TREAT AS TEXT OR UNFORMATTED FILE
(ENTER: T OR U) <T> ");
	T1:=ONEBYTE;
	'CASE' T1 'OF'
		^U:UNFON:='TRUE'
	'ELSE' TXTON:='TRUE';
	'END';



'IF' TXTON 'THEN'
	begin
	TEXT(0,"
APPEND LF AFTER CR  <Y> ");
	APPON:=(ONEBYTE#^N);
	end;

FREAD(DOSIN,BLOCK(SWAP(DIR(IN))&$3F,DIR(IN)&$FF),FLS,1);
	\GET THE FIRST FLS
FLSIDX:=10;
KEEPON:='TRUE';
'LOOP'
	'BEGIN'
	FLSIDX:=FLSIDX+2;
	'IF' (FLSIDX=256) & (FLS(1)#0)'THEN'
		'BEGIN'
		FREAD(DOSIN,BLOCK(FLS(1),FLS(2)),FLS,1);
			\GET SUBSEQUENT FLS'S
		FLSIDX:=12;
		'END';

	'IF' FLS(FLSIDX)=0 'THEN' 'QUIT';

	FREAD(DOSIN,BLOCK(FLS(FLSIDX),FLS(FLSIDX+1)),BUF,1);
		\GET A BLOCK OF THE INPUT FILE
	ST:=0;

	'IF' FIRSTB 'THEN' DOFIRST;

	'CASE' 'OF'
		LODON:DOLOD;
		SAVON:DOSAV;
		TXTON:DOTXT;
		UNFON:DOUNF
	'ELSE';

	'IF' 'NOT' KEEPON 'THEN' 'QUIT';

	'END';

'END';	\OF COPY





'PROC'	PNAME(DIRB,IND,IN35);	\PRINT THE DOS FILENAME
'ADDR'	DIRB;
'INT'	IND,	IN35,	T;
'BEGIN'
TEXT(0,"   ");
'IF' IND<10 'THEN' TEXT(0," ");
NUMOUT(0,IND);
TEXT(0,"  ");
DIR(IND):=SWAP(DIRB(IN35+11))+DIRB(IN35+12);
	\BUILD T&S ARRAY
'CASE' DIRB(IN35+13) & $3F 'OF'
	0:TEXT(0,"T ");
	1:TEXT(0,"I ");
	2:TEXT(0,"A ");
	4:[TEXT(0,"B "); DIR(IND):=DIR(IND) ! $8000]
		\FLAG THE T&S ARRAY IF BINARY
'ELSE' TEXT(0,"? ");
'FOR' T:=0,29 'DO'
	CHOUT(0,
	DIRB(IN35+14+T));
CRLF(0);
'END';






'PROC'	DIRLIST;	\PRINT THE DOS DIRECTORY
'ADDR'	DIRB;
'INT'	INDEX,	T,	TSEC,	T7,
	IN35	NAMC,X,GARB;
'BEGIN'

DIRB:=RESERVE(256);

TEXT(0,"


RECORD THE INDEX THAT PRECEDES 

THE D O S FILE YOU WISH TO TRANSFER.

");

TEXT(0,"INDEX    NAME");
CRLF(0); CRLF(0);

TSEC:=0;
NAMC:=0;
'LOOP'
	'BEGIN'
	T7:=TSEC*7;
	SE:=15-TSEC;
	FREAD(DOSIN,BLOCK($11,SE),DIRB,1);
	'FOR' INDEX:=0,6 'DO'
		'BEGIN'
		IN35:=INDEX*35;
		'IF' DIRB(IN35+11)=0 'THEN'
quit;		'IF' DIRB(IN35+11)#$FF 'THEN'
			[PNAME(DIRB,T7+INDEX,IN35);
			NAMC:=NAMC+1;
			'IF' NAMC=15 'THEN'
				[
	TEXT(0,"
TYPE: RETURN TO ADVANCE CATALOG
        E    TO EXIT TO FILE SELECTION");NAMC:=ONEBYTE;
if NAMC=^E then quit;				NAMC:=0;];];

		'END';

	TSEC:=TSEC+1;
	'IF' TSEC=15 'THEN' 'QUIT'
	'END';

'END';

'BEGIN'	\ MAINLINE

DIR:=RESERVE(168);
BUFFER:=RESERVE(BUFSIZ);

\THERE IS A DIR() ENTRY FOR EACH INDEX
\OF THE DOS DISK.  DIR(X)=$FFFF IF THE
\FILE DOES NOT EXIST.
\DIR(X)=TRACK*256+SECTOR IF THE FILE
\EXISTS.  DIR(X)=DIR(X)!$8000 IF THE
\FILE IS A DOS BINARY IMAGE.

'FOR' T:=0,83 'DO' DIR(T):=$FFFF;

CHOUT(0,12);	\<FF>

TEXT(0,"


          D O S   TO   A P E X

 TRANSFERS APPLE  D O S  FILES ONTO AN

             A P E X  DISK



PLEASE ENTER THE DOS UNIT NUMBER <0> ");


DOSIN:=ONEBYTE;
'IF' DOSIN=$D 'THEN' DOSIN:=0;
DOSIN:=DOSIN & $07;

OPENA;

TEXT(0,"
make sure that your DOS disk is

          write protected");

CHOUT(0,BEL);
CHNGDSK(DOSIN,"DOS");
CHOUT(0,12);	\<FF>

DIRLIST;

TEXT(0,"

    PLEASE SELECT THE  D O S  FILE 

    BY TYPING ITS INDEX NUMBER: ");
IN:=NUMIN(0);
'IF' DIR(IN)#$FFFF 'THEN'
	COPY(IN)
	'ELSE' ERROR(2);
CRLF(0);
CHOUTM($1A);\AN EOF "JUST TO BE SURE"
OUTBUF;
CLOSEO;\CLOSE OUTPUT FILE

'END';
