\DRAFT.XPL	3-2-84
\DRAFTING PROGRAM USING THE APPLE HI-RES SCREEN AND C. ITOH PRINTER.
\BY TED DUNNING AND LOREN BLANEY
\ (USE VER 5.1 I2LBIG.SAV)

code	ABS=0, RAN=1, REM=2, RESERVE=3, SWAP=4, EXTEND=5, RESTART=6, CHIN0=7,
	CHOUT=8, CRLF=9, INTIN=10, INTOUT=11, TEXT=12, OPENI=13, OPENO=14,
	CLOSE=15, ABORT=16, TRAP=17, FREE=18, GETERR=22, CURSOR=23, SCAN=24,
	SETRUN=25, OPENF=29, SETTXT=33, SETHI=34, SETMIX=35, SOUND=39, CLEAR=40,
	POINT0=41, LINE0=42, MOVE=43, FIX=50;
code real RLRES=46, RLIN=47, RLOUT=48, FLOAT=49, RLABS=51, FORMAT=52,
	SQRT=53, ATAN2=57;

'DEF'	ITOH='TRUE';	\C.ITOH PLOTTER?
def	TV=0, KBB=0, KB=1, PR=2, DISK=3;
def	BEL=$07, TAB=$09, LF=$0A, FF=$0C, CR=$0D, EOF=$1A, SP=$20;
def	KEYBOARD=$C000, STROBE=$C010;	\APPLE PORT ADDRESSES
def	DEVTAB=$BFC0;			\APEX DEVICE TABLE
def	WNDTOP=$22;			\TV WINDOW TOP
def	CURFLASH=300;			\CURSOR FLASH RATE
def	PITCH=640;			\PRINTER GRAPHICS DOTS/LINE

def	\KEYBOARD COMMANDS WHILE DRAWING
		\MOVE THE CURSOR
	LEFT	=$11,	\MOVE LEFT	CTRL-Q
	RIGHT	=$01,	\MOVE RIGHT	CTRL-A
	UP	=$17,	\MOVE UP	CTRL-W
	DOWN	=$13,	\MOVE DOWN	CTRL-S
	BY5	=$05,	\4 MORE STEPS	CTRL-E
	BY20	=$04,	\19 MORE STEPS	CTRL-D
		\POINTS, DOTS AND LINES
	ALINE	=$1A,	\DRAW A LINE	CTRL-Z
	APOINT	=$18,	\DRAW A POINT	CTRL-X
	AMOVE	=$03,	\MOVE TO A POINT (START A LINE)	CTRL-C
	ACIRCLE	=$0F,	\DRAW A CIRCLE			CTRL-O
	ANARC	=^O,	\DRAW AN ARC
		\DEFINITIONS
	ABEGIN	=^<,	\START A SUBFIGURE
	ANEND	=^>,	\END A SUBFIGURE
	SUBFIG	=^/,	\DRAW SUBFIGURE
	INSERT	=^I,	\START INSERTING CHARS
		\ENVIRONMENT
	AGRID	=^G,	\SET THE GRID SIZE
	AMAG	=^M,	\SET THE MAGNIFICATION
	TURN	=^T,	\ROTATE ALPHA
	ASIZE	=^A,	\SET ALPHA SIZE
	LTYPE	=^L	\SET LINE TYPE
	ADISP	=^D,	\DISPLAY CURRENT SETTINGS
		\MISCELLANEOUS
	ESC	=$1B,	\ESCAPE KEY	ESC
	AHINT	=^H,	\DISPLAY HELP MESSAGES
	AQUIT	=^Q,	\EXIT THIS PROGRAM
	AREAD	=^R,	\READ A FILE
	AWRITE	=^W,	\WRITE A FILE
	APLOT	=^P,	\PLOT THE DRAWING
	BACKSP	=$08,	\BACK SPACE (<--)
	ALIST	=^V,	\VOCABULARY LIST
	AKILL	=^K,	\DELETE ENTIRE DRAWING
	AREDRAW	=$12	\REDRAW THE SCREEN	CTRL-R
	ABOX	=$02,	\START/END A MAGIC BOX		CTRL-B
	ANERASE	=$16,	\ERASE THE CONTENTS OF THE BOX	CTRL-V
	ABOXFIL	=$06,	\"FILL" BOX FOR MOVE		CTRL-F
	ABOXMOV	=$0D,	\MOVE THE BOX			CTRL-M
	;  

def	\MXTICK	=617,	\\GRAPHICS DOT SIZE (METRIC)
	\MYTICK	=556,	\\GRAPHICS DOT SIZE (METRIC)
	EXTICK	=48,	\GRAPHICS DOT SIZE (ENGLISH)  (X MUST = Y FOR CIRCLES)
	EYTICK	=48\44\,	\GRAPHICS DOT SIZE (ENGLISH)
	PXTICK	=14\12\,	\PLOTTER GRAPHICS DOT SIZE
	PYTICK	=14,	\PLOTTER GRAPHICS DOT SIZE
	EFACTOR	=100.0,	\CONVERSION FROM INTEGER TO INCHES

	MOVMAX	=3000,	\SIZE OF DRAWING LIST
	DEFMAX	=3000,	\SIZE OF SUB-FIGURE LIST
	SYMMAX	=499,	\LAST ELEMENT OF SYMBOL TABLE
	;

real	FACTOR,		\GRID FACTOR (= "EFACTOR" FOR ENGLISH UNITS)
	;

int	XNOW,YNOW,	\CURRENT POSITION OF CURSOR
	XLAST,YLAST	\HOLDS THE PREVIOUS COORDINATES (FOR LINES)
	XLO,XHI,	\CURRENT WINDOW LIMITS
	YLO,YHI,
	YLOMIX,		\LOW WINDOW LIMIT FOR MIXED MODE GRAPHICS
 	XTICK,YTICK,	\DOT SIZE (= "EXTICK" FOR ENGLISH UNITS)
	SCALE,		\SCALE (MAGNIFICATION) FACTOR
	GRID,		\GRID SPACING--MINIMUM MOVEMENT OF CURSOR
	LINTYP,		\LINE TYPE (SOLID, ERASE, ETC.)
	ALPHANG,	\LETTERING ANGLE
	ALPHMAG,	\LETTERING SIZE (16=0.1" LETTERS)
	TVMODE,		\DISPLAY MODE: 0, 1, 2
	METRIC,		\BOOLEAN: MEASUREMENTS IN MM (VS. INCHES)
	LASTDIR,	\LAST DIRECTION MOVED BY CURSOR
	MUSSFLG,	\MUST REDRAW COMPLETELY
	NXTMOV,		\NEXT CELL IN "MOVLST"
		\SYMBOL TABLE POINTERS
	NXTDEF,		\NEXT CELL IN "DEFLST" ("MOVLST" FOR SUB-FIGS)
	NXTSYM,		\NEXT CELL IN "SYMTBL"
	NEWSYM,		\CELL AFTER NEW NAME (FROM PROC "GETNAM")
	FIGNEW,		\CELL AFTER FIGURE NAME
	FIGNXT,		\START OF FIGURE NAME
	SAVMOV,		\"NXTMOV" AT BEGINNING OF SUB-FIG
	SAVTYP,		\"LINTYP" IN EFFECT BEFORE A SUB-FIG
	NEST,		\NESTING OF SUB-FIGURE COMMANDS (THEY CAN'T BE NESTED)
	XOLD,YOLD,	\ORIGIN OF SUB-FIGURE

	XBOXMIN, YBOXMIN,  \OPPOSITE CORNERS OF MAGIC BOX
	XBOXMAX, YBOXMAX,
	BOXON,		\BOOLEAN: BOX HAS BEEN STARTED
	DRAGBOX,	\BOOLEAN: BOX HAS BEEN "FILLED"
	XPT,YPT,	\LAST POINT FOR PRINTER GRAPHICS
	PLOT,		\FLAG TO DIRECT OUTPUT TO PLOTTER (VS. HI-RES)

	CUBYTE,		\SAVES FIRST BYTE OF "CHKUSR" ROUTINE IN TV HANDLER
	CHKUSR,		\ADDRESS OF "CHKUSR" ROUTINE
	I,		\SCRATCH FOR MAIN
	;

addr	COLD,		\STRING THAT HOLDS "A" ON COLD START
	MOVLST,		\ARRAY: LIST OF MOVES (DRAWING AND SUB-FIGURES)
	SYMTBL,		\ARRAY: SYMBOL TABLE (SUB-FIGURE NAMES)

	BITTBL,		\FOR PRINTER GRAPHICS
	BITTB2,
	RASBUF,

	ADDR,		\= 0, ADDRESS FOR ACCESSING HARDWARE PORTS
	;

def	\TVMODE\ HI, MIX, TXT;
def	\LINTYP\ SOLID=$80, ERASE=0;
		\(ANYTHING WILL OVERRIDE "SOLID")

\========================= GLOBAL SUBROUTINES ==========================\

func	CHIN(DEV);	\ROUTINE TO INSERT OUR OWN KEYBOARD HANDLER
int	DEV;
int	CH;
begin
if DEV#KB then return CHIN0(DEV);
loop	begin
	CH:=ADDR(KEYBOARD);			\GET CHAR FROM KEYBOARD
	if CH>=$80 then
		begin
		DEV:=ADDR(STROBE);		\CLEAR STROBE
		if CH=\CTRL-P\$90 then
			[ADDR(CHKUSR):=CUBYTE;	\FIX CHKUSR ROUTINE
			ADDR(WNDTOP):=$0;	\FIX TV DISPLAY
			ABORT];			\(APEX SWAP ENTRY)
		return CH&$7F;			\RETURN 7-BIT ASCII CHAR
		end;
	end;
end;	\CHIN



proc	WAIT;		\WAIT FOR KEYSTROKE THEN PROCEED
int	C;
[CURSOR(13,23); TEXT(TV,"(HIT ANY KEY TO CONTINUE)");
C:=CHIN(KB)];



proc	SETRES;		\SET DISPLAY TO "TVMODE"
case TVMODE of
  HI:	SETHI;
  MIX:	[SETHI; SETMIX];
  TXT:	SETTXT
else;



proc	CLRBOTTOM;	\MOVE TO THE BOTTOM LINE AND CLEAR IT
int	I;
addr	ADDR;
begin
ADDR:=$7D0;
for I:=0,39 do ADDR(I):=$A0;
CURSOR(0,23);
end;



proc	ERROR(MSG);	\DISPLAY ERROR MESSAGE
char	MSG;
begin
CHOUT(TV,BEL);
SETHI; SETMIX; \STATUS;\
CLRBOTTOM;
TEXT(TV,"error  ");
TEXT(TV,MSG);
if CHIN(KB) then;
CLRBOTTOM;
SETRES;			\RESTORE DISPLAY TO WHAT IT WAS
end;	\ERROR

\======================================================================\

func	GET(N);		\GET A 16-BIT VALUE FROM THE MOVE LIST
int	N,IX;
begin
IX:=MOVLST+N;
return IX(0);
end;


func	GETC(N);	\GET A BYTE FROM MOVE LIST
int	N;
return MOVLST(N);


func	GETCC(N);	\GET MOVE TYPE FROM MOVE LIST
int	N;
return MOVLST(N) & $7F;


func	GETX(N);	\GET X COORDINATE FROM MOVE LIST
int	N;
return GET(N+1);


func	GETY(N);	\GET Y COORDINATE
int	N;
return GET(N+3);


proc	GETT(N);	\GET MOVE LINE TYPE FROM MOVE LIST
int	N;
return not MOVLST(N) & $80;


func	GETS(N);	\GET START INDEX OF SUB-FIGURE
int	N;
return GET(N+5);


func	GETE(N);	\GET END INDEX
int	N;
return GET(N+7);


func	GETA(N);	\GET ANGLE OF SUB-FIGURE
int	N;
return GETC(N+9);


func	GETSC(N);	\GET MAGNITUDE (SCALE) OF SUB-FIGURE
int	N;
return GETC(N+10);



proc	SET(N,X);	\STORE A 16-BIT VALUE IN THE MOVLST
int	N,X,IX;
begin
IX:=MOVLST+N;
IX(0):=X
end;


proc	SETC(N,C);	\STORE MOVE TYPE IN MOVE LIST
int	N,C;
MOVLST(N):=C;


proc	SETX(N,X);	\STORE X COORDINATE IN MOVE LIST
int	N,X;
SET(N+1,X);


proc	SETY(N,Y);	\STORE Y COORDINATE
int	N,Y;
SET(N+3,Y);


proc	SETT(N,T);	\STORE MOVE LINE TYPE IN MOVE LIST
int	N,T;
MOVLST(N+5):=T;


proc	SETS(N,S);	\STORE START INDEX OF SUB-FIGURE
int	N,S;
SET(N+5,S);


proc	SETE(N,E);	\STORE END INDEX
int	N,E;
SET(N+7,E);


proc	SETA(N,A);	\STORE ANGLE OF SUB-FIGURE
int	N,A;
SETC(N+9,A);


proc	SETSC(N,SC);	\STORE MAGNITUDE (SCALE)
int	N,SC;
SETC(N+10,SC);



func	SIZE(N);	\RETURNS THE NUMBER OF BYTES IN A "MOVLST" ENTRY
int	N;
case GETCC(N) of
  ^C,^/,^A:	return 12	\(WARNING: ARC SIZE MUST BE 12)
else return 6;



proc	ADDMOV(C,X,Y,T);	\ADD A MOVE (DOT, MOVE, LINE) TO THE MOVE LIST
int	C,X,Y,T;
begin
if (NXTMOV<MOVMAX & NXTMOV>=MOVMAX-SIZE(NXTMOV)) !
	NXTMOV>=DEFMAX+MOVMAX-SIZE(NXTMOV) then
	begin
	ERROR("OUT OF MEMORY SPACE");
	return;
	end;
T:=not T & $80;
SETC(NXTMOV,C!T);
SETX(NXTMOV,X);
SETY(NXTMOV,Y);
NXTMOV:=NXTMOV+SIZE(NXTMOV);
SETC(NXTMOV-1,C);
end;	\ADDMOV



proc	ADDTHREAD(C,X,Y,START,END,ANGLE,MAG,T);	\ADD A SUB-FIGURE TO MOVE LIST
int	C,X,Y,
	START,END,ANGLE,MAG,T;
begin
if (NXTMOV<MOVMAX & NXTMOV>=MOVMAX-SIZE(NXTMOV)) !
	NXTMOV>=DEFMAX+MOVMAX-SIZE(NXTMOV) then
	begin
	ERROR("OUT OF MEMORY SPACE");
	return;
	end;
T:=not T & $80;
SETC(NXTMOV,C!T);
SETX(NXTMOV,XNOW);
SETY(NXTMOV,YNOW);
SETS(NXTMOV,START);
SETE(NXTMOV,END);
SETA(NXTMOV,ANGLE);
SETSC(NXTMOV,MAG);
NXTMOV:=NXTMOV+SIZE(NXTMOV);
SETC(NXTMOV-1,C);
end;	\ADDTHREAD

\======================================================================\

'PROC'	ITOHOUT(N);	\OUTPUT SCALED INTEGER TO ITOH PLOTTER
'INT'	N;
INTOUT(PR,N*SCALE/4);



proc	PRPOINT(TYPE);		\ROUTINE TO PLOT A POINT ON THE PRINTER
\PLOTS XPT,YPT (X INCREASES TO THE RIGHT, AND Y INCREASES GOING DOWN)
int	TYPE;
int	Q,BYTE;
begin
'IF'ITOH'THEN''RETURN';
if XPT>PITCH ! XPT<0 then return;	\CLIP POINTS OUTSIDE WINDOW
if YPT>95 ! YPT<0 then return;
Q:=YPT/8;
BYTE:=XPT +PITCH*Q;
if TYPE=SOLID then
	RASBUF(BYTE):=RASBUF(BYTE) ! BITTBL(REM(0))
else	RASBUF(BYTE):=RASBUF(BYTE) & BITTB2(REM(0));
end;	\PRPOINT



proc	PRLINE(NEWX, NEWY, TYPE);
\ROUTINE TO DRAW A LINE ON THE PRINTER FROM XPT,YPT TO NEWX,NEWY
int	NEWX, NEWY, TYPE;
int	DX, DY, XBUMP, YBUMP, BIGX, BRM;
begin
XBUMP:=1;
DX:=NEWX-XPT;
if DX<0 then [DX:=-DX; XBUMP:=-1];
YBUMP:=1;
DY:=NEWY-YPT;
if DY<0 then [DY:=-DY; YBUMP:=-1];

BRM:=DY-DX;
BIGX:=BRM;

loop	begin
	PRPOINT(TYPE);
	if XPT=NEWX then [XBUMP:=0; if YPT=NEWY then quit];
	if BRM<=0 then
		begin		\MOVE IN X DIRECTION
		BRM:=BRM+DY;
		if BIGX>=0 then [BRM:=BRM-DX; YPT:=YPT+YBUMP];
		XPT:=XPT+XBUMP;
		end
	else	begin		\MOVE IN Y DIRECTION
		BRM:=BRM-DX;
		if BIGX<0 then [BRM:=BRM+DY; XPT:=XPT+XBUMP];
		YPT:=YPT+YBUMP;
		end;
	end;
end;	\PRLINE



proc	PRCIRCLE(XCENTER,YCENTER,RADIUS,TYPE,SEGS);
\ROUTINE TO DRAW A CIRCLE ON THE PRINTER
int	XCENTER,YCENTER,RADIUS,TYPE,SEGS;
int	X, Y, E, U, V;


	proc	OCTANT(X,Y);
	int	X,Y;

		proc	POINT(X,Y);
		int	X,Y;
		begin
		\(SEGMENTS ARE FOR Y GOING UP)
		XPT:=X+XCENTER; YPT:= -Y+YCENTER;
		PRPOINT(TYPE);
		end;

	begin	\OCTANT
	if SEGS&$01 then POINT(Y, X);	\SEGMENT 0
	if SEGS&$02 then POINT(X, Y);	\SEGMENT 1
	if SEGS&$04 then POINT(-X, Y);	\SEGMENT 2
	if SEGS&$08 then POINT(-Y, X);	\SEGMENT 3
	if SEGS&$10 then POINT(-Y, -X);	\SEGMENT 4
	if SEGS&$20 then POINT(-X, -Y);	\SEGMENT 5
	if SEGS&$40 then POINT(X, -Y);	\SEGMENT 6
	if SEGS&$80 then POINT(Y, -X);	\SEGMENT 7
	end;		\OCTANT


begin	\PRCIRCLE
'CASE''OF'			\CLIP
  XCENTER+RADIUS<0, XCENTER-RADIUS>=PITCH,
  YCENTER+RADIUS<0, YCENTER-RADIUS>95: 'RETURN'
'ELSE';
X:=0;
Y:=RADIUS;
U:=1;
V:=1-2*RADIUS;
E:=1-RADIUS;
while X<Y do
	begin
	OCTANT(X,Y);
	if E<0 then
		begin
		U:=U+2;
		V:=V+2;
		E:=E+U;
		end
	else
		begin
		U:=U+2;
		V:=V+4;
		E:=E+V;
		Y:=Y-1;
		end;
	X:=X+1;
	end;
if X=Y then OCTANT(X,Y);
end;	\PRCIRCLE



proc	DOT(X,Y,TYPE);	\DISPLAY A DOT ON HI-RES SCREEN
int	X,Y,TYPE;
int	IX,IY;
begin	\DOT
case of
X<XLO, X>XHI, Y<YLO, Y>YHI: return
else;

IX:=(X-XLO)*SCALE/XTICK;
IY:=(if PLOT then 95 else 191) - (Y-YLO)*SCALE/YTICK;

if PLOT then [XPT:=IX; YPT:=IY; PRPOINT(TYPE)]
	else POINT0(IX,IY,TYPE);
end;	\DOT



proc	LINE(X1,Y1,X2,Y2,TYPE);
\DRAW THE PORTION OF THE LINE SEGMENT THAT APPEARS IN THE WINDOW
\ USING COHEN-SUTHERLAND CLIPPING ALGORITHM.
\ REF: FUNDAMENTALS OF INTERACTIVE COMPUTER GRAPHICS, J.D.FOLEY
\ & A. VAN DAM, P149.
int	X1,Y1,X2,Y2,TYPE;
int	CODE1, CODE2;		\4-BIT BOOLEAN ARRAY
int	TR,IX,IY;


	func	OUTCODE(X,Y);
	int	X,Y;
	int	CODE;
	begin
	CODE:=if Y>YHI then 1
	else if Y<YLO then 2
	else 0;
	if X>XHI then CODE:=CODE!4
	else if X<XLO then CODE:=CODE!8;
	return CODE;
	end;	\OUTCODE


	proc	XLAT(X,Y);	\TRANSLATE TO HI-RES COORDINATES
	int	X,Y;
	begin
	IX:=(X-XLO)*SCALE/XTICK;
	IY:=(if PLOT then 95 else 191) - (Y-YLO)*SCALE/YTICK;
	end;	\XLAT


begin	\LINE
'IF'PLOT & ITOH'THEN'
	'BEGIN'
	CHOUT(PR,^M); ITOHOUT(X1); CHOUT(PR,^,); ITOHOUT(Y1); CRLF(PR);
	CHOUT(PR,^D); ITOHOUT(X2); CHOUT(PR,^,); ITOHOUT(Y2); CRLF(PR);
	'RETURN';
	'END';
loop	begin
	CODE1:=OUTCODE(X1,Y1); CODE2:=OUTCODE(X2,Y2);
	if CODE1 & CODE2 then quit;		\TRIVIALLY REJECT
	if (CODE1!CODE2) = 0 then 		\TRIVIALLY ACCEPT
		begin
		XLAT(X1,Y1);
		if PLOT then [XPT:=IX; YPT:=IY] else MOVE(IX,IY);
		XLAT(X2,Y2);
		if PLOT then PRLINE(IX,IY,TYPE) else LINE0(IX,IY,TYPE);
		quit;
		end;
	\SUBDIVIDE THE LINE SINCE AT MOST ONE ENDPOINT IS INSIDE THE WINDOW
	\ FIRST, IF POINT X1,Y1 IS INSIDE THE WINDOW, EXCHANGE ENDPOINTS
	\ (AND THEIR OUTCODES) TO GUARANTEE THAT POINT X1,Y1 IS OUTSIDE
	\ THE WINDOW.
	if CODE1=0 then		\EXCHANGE
		begin
		TR:=X1; X1:=X2; X2:=TR;
		TR:=Y1; Y1:=Y2; Y2:=TR;
		CODE1:=CODE2;
		end;
	\NOW PERFORM A SUBDIVISION, MOVE POINT X1,Y1 TO THE INTERSECTION
	\ POINT (X,Y); USE THE FORMULAS:	Y = Y1 + SLOPE*(X - X1)
	\					X = X1 + (1/SLOPE)*(Y - Y1)
	case of
	    CODE1&1:		\DIVIDE LINE AT TOP OF WINDOW
		[X1:=X1 + FIX(FLOAT(X2 - X1) *FLOAT(YHI - Y1) /FLOAT(Y2 - Y1));
		Y1:=YHI];
	    CODE1&2:		\DIVIDE LINE AT BOTTOM OF WINDOW
		[X1:=X1 + FIX(FLOAT(X2 - X1) *FLOAT(YLO - Y1) /FLOAT(Y2 - Y1));
		Y1:=YLO];
	    CODE1&4:		\DIVIDE LINE AT RIGHT EDGE OF WINDOW
		[Y1:=Y1 + FIX(FLOAT(Y2 - Y1) *FLOAT(XHI - X1) /FLOAT(X2 - X1));
		X1:=XHI];
	    CODE1&8:		\DIVIDE LINE AT LEFT EDGE OF WINDOW
		[Y1:=Y1 + FIX(FLOAT(Y2 - Y1) *FLOAT(XLO - X1) /FLOAT(X2 - X1));
		X1:=XLO]
	else	[];
	end;
end;	\LINE



proc	HICIRCLE(XCENTER,YCENTER,RADIUS,TYPE,SEGS);
\ROUTINE TO DRAW A CIRCLE ON THE HI-RES SCREEN
\Y INCREASES GOING DOWN
int	XCENTER,YCENTER,RADIUS,TYPE,SEGS;
int	X, Y, E, U, V;


	proc	OCTANT(X,Y);
	int	X,Y;

		proc	POINT(X,Y);
		int	X,Y;
		begin
		\(SEGMENTS ARE FOR Y GOING UP)
		X:=X+XCENTER; Y:= -Y+YCENTER;
		if X<0 ! X>279 then return;
		if Y<0 ! Y>191 then return;
		POINT0(X, Y, TYPE);
		end;

	begin	\OCTANT
	if SEGS&$01 then POINT(Y, X);	\SEGMENT 0
	if SEGS&$02 then POINT(X, Y);	\SEGMENT 1
	if SEGS&$04 then POINT(-X, Y);	\SEGMENT 2
	if SEGS&$08 then POINT(-Y, X);	\SEGMENT 3
	if SEGS&$10 then POINT(-Y, -X);	\SEGMENT 4
	if SEGS&$20 then POINT(-X, -Y);	\SEGMENT 5
	if SEGS&$40 then POINT(X, -Y);	\SEGMENT 6
	if SEGS&$80 then POINT(Y, -X);	\SEGMENT 7
	end;		\OCTANT


begin	\HICIRCLE
'CASE''OF'			\CLIP
  XCENTER+RADIUS<0, XCENTER-RADIUS>279,
  YCENTER+RADIUS<0, YCENTER-RADIUS>191: 'RETURN'
'ELSE';
X:=0;
Y:=RADIUS;
U:=1;
V:=1-2*RADIUS;
E:=1-RADIUS;
while X<Y do
	begin
	OCTANT(X,Y);
	if E<0 then
		begin
		U:=U+2;
		V:=V+2;
		E:=E+U;
		end
	else
		begin
		U:=U+2;
		V:=V+4;
		E:=E+V;
		Y:=Y-1;
		end;
	X:=X+1;
	end;
if X=Y then OCTANT(X,Y);
end;	\HICIRCLE



proc	CIRCLE(XCENTER,YCENTER,X,Y,TYPE,SEGS);
int	XCENTER,YCENTER,X,Y,TYPE,SEGS;
int	RADIUS;
'REAL'	DX, DY;

	func	XLAT(X);	\TRANSLATE TO HI-RES COORDINATES
	int	X;
	return (X-XLO)*SCALE/XTICK;


	proc	YLAT(Y);	\TRANSLATE TO HI-RES COORDINATES
	int	Y;
	return (if PLOT then 95 else 191) - (Y-YLO)*SCALE/YTICK;


begin	\CIRCLE
DX:=FLOAT(X-XCENTER); DY:=FLOAT(Y-YCENTER);
RADIUS:=FIX(SQRT(DX*DX + DY*DY));
'IF'PLOT & ITOH'THEN'
	'BEGIN'
	'IF'SEGS=0'THEN''RETURN';
	CHOUT(PR,^W); ITOHOUT(XCENTER); CHOUT(PR,^,);
	ITOHOUT(YCENTER); CHOUT(PR,^,); 
	ITOHOUT(RADIUS); CHOUT(PR,^,); 
	'IF'SEGS=$FF'THEN'		\CIRCLE
		[TEXT(PR,"0,360,0");
		CRLF(PR);
		'RETURN'];
	X:=0;
	'WHILE'(SEGS&1)=1'DO'	\MOVE TO BLANK
		'BEGIN'
		SEGS:=SEGS/2 + 128*(SEGS&1);
		X:=X+45;
		'END';
	'WHILE'(SEGS&1)=0'DO'	\MOVE TO SEG
		'BEGIN'
		SEGS:=SEGS/2 + 128*(SEGS&1);
		X:=X+45;
		'END';
	INTOUT(PR,X); CHOUT(PR,^,);	\START OF SEG
	'WHILE'(SEGS&1)=1 'DO'	\MOVE TO BLANK
		'BEGIN'
		SEGS:=SEGS/2 + 128*(SEGS&1);
		X:=X+45;
		'END';
	INTOUT(PR,REM(X/360)); CHOUT(PR,^,); 
	INTOUT(PR,0);
	CRLF(PR);
	'RETURN';
	'END';

RADIUS:=RADIUS * SCALE/XTICK;
X:=XLAT(X); Y:=YLAT(Y);
XCENTER:=XLAT(XCENTER); YCENTER:=YLAT(YCENTER);
if PLOT then PRCIRCLE(XCENTER, YCENTER, RADIUS, TYPE, SEGS)
else HICIRCLE(XCENTER, YCENTER, RADIUS, TYPE, SEGS);
end;	\CIRCLE



func	ARCSEGS(THETA,ARCANGLE);	\SET UP THE SEGMENTS IN THE ARC
real	THETA, ARCANGLE;
int	I, SEGS;
begin
SEGS:=0;
if ARCANGLE>=0.0 then
	begin
	for I:=1,FIX(ARCANGLE/45.0) do
		SEGS:=SEGS*2 +1;		\LEFT SHIFT IN 1'S
	for I:=1, FIX(THETA/45.0)&7 do
		SEGS:=SEGS*2 + (SEGS&128)/128;	\LEFT ROTATE 8 BITS
	end
else
	begin
	for I:=1,FIX(-ARCANGLE/45.0) do
		SEGS:=(SEGS + 256)/2;		\RIGHT SHIFT IN 1'S
	for I:=1, FIX(-THETA/45.0)&7 do
		SEGS:=((SEGS&1)*256 + SEGS) /2;	\RIGHT ROTATE 8 BITS
	end;
return SEGS;
end;	\ARCSEGS

\----------------------------------------------------------------------\

proc	MARK;		\DISPLAY (OR REMOVE) THE CURSOR CROSS HAIRS
int	XMIN,YMIN;	\CORNER OPPOSITE XNOW,YNOW
begin
if DRAGBOX then
	[XMIN:=XBOXMIN+XNOW-XBOXMAX;  YMIN:=YBOXMIN+YNOW-YBOXMAX]
else	[XMIN:=XBOXMIN; YMIN:=YBOXMIN];

if BOXON then
	begin		\SHOW MAGIC BOX
	LINE(XNOW, YNOW, XMIN, YNOW, $40);
	LINE(XNOW, YNOW, XNOW, YMIN, $40);
	LINE(XMIN, YNOW, XMIN, YMIN, $40);
	LINE(XNOW, YMIN, XMIN, YMIN, $40);
	end;
			\SHOW CROSS HAIRS
LINE(XNOW-25, YNOW, XNOW+25, YNOW, $40);
LINE(XNOW, YNOW-25, XNOW, YNOW+25, $40);
LINE(XLAST-12, YLAST, XLAST+12, YLAST, $40);
LINE(XLAST, YLAST-12, XLAST, YLAST+12, $40);
end;	\MARK

\======================================================================\

fproc	DOCMD;

proc	DRAW(START,END,ANGLE,MAGFAC,XBASE,YBASE,XL,YL,LT);	\DRAW AN IMAGE
int	START,		\STARTING POINT OF DRAWING
	END,		\END POINT OF DRAWING
	ANGLE,		\ROTATION
	MAGFAC,		\MAGNIFICATION FACTOR
	XBASE,YBASE,	\BASE OF SUB-FIGURE
	XL,YL,		\LAST POINT (FOR LINE)
	LT,		\LINE TYPE (ANYTHING OVERRIDES SOLID)

	I,		\"MOVLST" INDEX
	IT,		\LOCAL TEMPS
	XT,YT,		\POINTS FROM MOVLST
	XMIN,YMIN,XMAX,YMAX,	\SUB-FIGURE BOUNDARIES
	MAG,
	SEGS;
begin
I:=START;
while I<END do
	begin
	if ADDR(KEYBOARD)>=$80 then
		if not PLOT then DOCMD;	\DON'T MAKE THE GUY WAIT
	if MUSSFLG then return;

	XT:=GETX(I); YT:=GETY(I);
	case ANGLE of
	    0:	;
	    1:	[IT:=XT; XT:=-YT; YT:=IT];
	    2:	[XT:=-XT; YT:=-YT];
	    3:	[IT:=XT; XT:=YT; YT:=-IT]
	else;
	if MAGFAC=16 then
		[XT:=XBASE + XT;
		YT:=YBASE + YT]
	else	[XT:=XBASE + MAGFAC *XT /16;
		YT:=YBASE + MAGFAC *YT /16];

	case GETCC(I) of
	  ^M:	[XL:=XT; YL:=YT];
	  ^L:	begin				\DRAW LINE
		LINE(XL,YL,XT,YT,if LT=SOLID then GETT(I) else LT);
		XL:=XT; YL:=YT;
		end;
	  ^P:	[DOT(XT,YT,if LT=SOLID then GETT(I) else LT);	\DRAW POINT
		XL:=XT; YL:=YT];
	  ^O:	begin				\DRAW CIRCLE
		CIRCLE(XL,YL,XT,YT,if LT=SOLID then GETT(I) else LT,$FF);
		XL:=XT; YL:=YT;
		end;
	  ^A:	begin				\DRAW ARC
		SEGS:=GETA(I);	  	
		for IT:=1,ANGLE*2 do
			SEGS:=SEGS*2 + (SEGS&128)/128;	\LEFT ROTATE 8 BITS
		CIRCLE(XL, YL, XT, YT, if LT=SOLID then GETT(I) else LT, SEGS&$FF);
		XL:=XT; YL:=YT;
		end;
	  ^/:	begin		\MOST SUB-FIGS ARE OUTSIDE THE WINDOW
		IT:=GETS(I)+MOVLST;		\GET ADDR OF SUB-FIG

		MAG:= MAGFAC *GETSC(I) /16;
		XMIN:=IT(0) *MAG /16;
		YMIN:=IT(1) *MAG /16;
		XMAX:=IT(2) *MAG /16;
		YMAX:=IT(3) *MAG /16;

		if (XMAX-XMIN) *SCALE/XTICK >=1 !	\IF IT IS LARGE ENOUGH
			(YMAX-YMIN) *SCALE/YTICK >=1 then
			begin
			case 3&(GETA(I)+ANGLE) of
			    0:	;
			    1:	[IT:=XMIN; XMIN:=-YMAX; YMAX:=XMAX; XMAX:=-YMIN; YMIN:=IT];
			    2:	[IT:=XMIN; XMIN:=-XMAX; XMAX:=-IT; IT:=YMIN; YMIN:=-YMAX; YMAX:=-IT];
			    3:	[IT:=XMIN; XMIN:=YMIN; YMIN:=-XMAX; XMAX:=YMAX; YMAX:=-IT]
			else;

			case of
			XT+XMIN>XHI, XT+XMAX<XLO, YT+YMIN>YHI, YT+YMAX<YLO:[]
			else	DRAW(GETS(I)+8, GETE(I), 3&(GETA(I)+ANGLE),
				MAGFAC*GETSC(I)/16,XT,YT,XL,YL,
				if LT=SOLID then GETT(I) else LT);
			end
				\SHOW SMALL SUB-FIG AS A DOT
		else DOT(XT,YT,if LT=SOLID then GETT(I) else LT);
		end;
	  ^C:	[]	\(CHARACTERS ARE HANDLED AS SUB-FIGURES)
	else [ERROR("BAD COMMAND IN MOVE LIST")];	\(SHOULDN'T EVER HAPPEN)
	I:=I+SIZE(I);
	end;
end;	\DRAW



proc	DRAWLAST;	\DRAW THE LAST ITEM IN THE MOVE LIST
\DRAW THE MOVE THAT WAS JUST ENTERED
int	OLD;
if NXTMOV>5 then
	begin
	OLD:=NXTMOV-SIZE(NXTMOV-1);
	DRAW(OLD,NXTMOV-1,0,16,0,0,XLAST,YLAST,SOLID);
	end;



proc	SETLIMIT;	\SET HIGH & LOW WINDOW LIMITS
begin
XLO:=XNOW - 139*XTICK/SCALE;
XHI:=XNOW + 138*XTICK/SCALE;
YLO:=YNOW - 95*YTICK/SCALE;
YHI:=YNOW + 94*YTICK/SCALE;
YLOMIX:=YNOW - 63*YTICK/SCALE;
end;	\SETLIMIT

\----------------------------------------------------------------------\

proc	SETSTAT;	\DISPLAY INVERSE VIDEO STATUS BANNER
int	I;
char	STR,ADDR;
begin
STR:="   X      Y      DX     DY   DIST  ANGLE";
ADDR:=$650;
for I:=0,39 do ADDR(I):=STR(I)&$3F;
end;	\SETSTAT



proc	STATUS;		\DISPLAY STATUS INFORMATION
real	DX,DY;
begin
SETSTAT;
if ADDR(KEYBOARD)>=$80 then return;	\DON'T MAKE THE GUY WAIT
if METRIC then FORMAT(4,1) else FORMAT(3,2);
CURSOR(0,21);

RLOUT(TV,FLOAT(XNOW)/FACTOR);
CHOUT(TV,^ );
RLOUT(TV,FLOAT(YNOW)/FACTOR);
CHOUT(TV,^ );
if ADDR(KEYBOARD)>=$80 then return;	\DON'T MAKE THE GUY WAIT

DX:=FLOAT(XNOW-XLAST);
DY:=FLOAT(YNOW-YLAST);
RLOUT(TV,DX/FACTOR);
CHOUT(TV,^ );
RLOUT(TV,DY/FACTOR);
if ADDR(KEYBOARD)>=$80 then return;	\DON'T MAKE THE GUY WAIT

RLOUT(TV,SQRT(DX*DX + DY*DY)/FACTOR);
if ADDR(KEYBOARD)>=$80 then return;	\DON'T MAKE THE GUY WAIT

CHOUT(TV,^ );
FORMAT(4,1);
RLOUT(TV,if DY=0.0 & DX=0.0 then 0.0 else ATAN2(DY,DX) *57.2957795);
end;	\STATUS



proc	STATALL;		\DISPLAY STATUS INFORMATION
begin
if METRIC then FORMAT(4,1) else FORMAT(3,2);
ADDR(WNDTOP):=0;	\MAKE WINDOW ENTIRE SCREEN
CHOUT(TV,FF);
SETTXT;
TEXT(TV,"	      -- STATUS --

");
TEXT(TV,"	space		"); INTOUT(TV,MOVMAX-NXTMOV); CHOUT(TV,^,);
INTOUT(TV,DEFMAX+MOVMAX-NXTDEF); CRLF(TV);
CRLF(TV);
CRLF(TV);
TEXT(TV,"	grid		"); RLOUT(TV,FLOAT(GRID)/FACTOR); CRLF(TV);
CRLF(TV);
TEXT(TV,"	magnification	"); RLOUT(TV,FLOAT(SCALE)/10.0); CRLF(TV);
CRLF(TV);
CRLF(TV);
TEXT(TV,"	line type	");
case LINTYP of
  SOLID:	TEXT(TV," SOLID");
  ERASE:	TEXT(TV," ERASE")
else	INTOUT(TV,LINTYP);		\*** DEBUG
CRLF(TV);
CRLF(TV);
CRLF(TV);
TEXT(TV,"	alpha size	"); RLOUT(TV,FLOAT(ALPHMAG)/16.0); CRLF(TV);
CRLF(TV);
TEXT(TV,"	alpha angle	"); RLOUT(TV,FLOAT(ALPHANG)*90.0); CRLF(TV);
CRLF(TV);
CRLF(TV);
TEXT(TV,"	units		");
TEXT(TV,if METRIC then "MILLIMETERS" else "INCHES"); CRLF(TV);

STATUS;
WAIT;
end;	\STATALL

\========================== COMMANDS ==================================\

func	RND(X,GRID);	\ROUND "X" TO THE NEAREST GRID POINT
int	X,GRID;
int	R;
begin
if X<0 then return -RND(-X,GRID);
R:=REM(X/GRID);
return if R+R>=GRID then X-R+GRID else X-R;
end;	\RND



proc	SETMUSS;	\SET FLAG TO REDRAW THE IMAGE
MUSSFLG:=true;



proc	GOLEFT(MUCH);	\COMMAND TO MOVE CURSOR LEFT BY "MUCH" GRID POINTS
int	MUCH;
begin
MARK;			\CLEAR CURSOR AT CURRENT POSITION
XNOW:=RND(XNOW-MUCH*GRID,GRID);
LASTDIR:=LEFT;
if XNOW<XLO then SETMUSS;	\IF WE MOVED OFF THE SCREEN THEN REDRAW IMAGE
MARK;			\DISPLAY CURSOR AT NEW POSITION
end;



proc	GORIGHT(MUCH);	\COMMAND TO MOVE CURSOR RIGHT
int	MUCH;
begin
MARK;
XNOW:=RND(XNOW+MUCH*GRID,GRID);
LASTDIR:=RIGHT;
if XNOW>XHI then SETMUSS;
MARK;
end;



proc	GOUP(MUCH);	\COMMAND TO MOVE CURSOR UP
int	MUCH;
begin
MARK;
YNOW:=RND(YNOW+MUCH*GRID,GRID);
if YNOW>YHI then SETMUSS;
LASTDIR:=UP;
MARK;
end;



proc	GODOWN(MUCH);	\COMMAND TO MOVE CURSOR DOWN
int	MUCH;
begin
MARK;
YNOW:=RND(YNOW-MUCH*GRID,GRID);
LASTDIR:=DOWN;
if YNOW<YLOMIX then 
	if TVMODE=MIX then SETMUSS
	else if YNOW<YLO then SETMUSS;
MARK;
end;



proc	GOBY(N);
\COMMAND TO MOVE CURSOR IN LAST DIRECTION BY "N" GRID POINTS
int	N,I;
begin
case LASTDIR of
    LEFT:	GOLEFT(N);
    RIGHT:	GORIGHT(N);
    UP: 	GOUP(N);
    DOWN:	GODOWN(N)
else [];
end;	\GOBY



proc	DOMOVE;		\COMMAND TO MOVE TO A POINT
begin
MARK;
XLAST:=XNOW; YLAST:=YNOW;
ADDMOV(^M, XNOW, YNOW, 0);
MARK;
end;



proc	DODOT;		\COMMAND TO DRAW A DOT
begin
MARK;
XLAST:=XNOW; YLAST:=YNOW;
ADDMOV(^P, XNOW, YNOW, LINTYP);
DRAWLAST;
MARK;
end;



proc	DOLINE;		\COMMAND TO DRAW A LINE
begin
MARK;
ADDMOV(^L, XNOW, YNOW, LINTYP);
DRAWLAST;
XLAST:=XNOW; YLAST:=YNOW;
MARK;
end;



proc	DOCIRCLE;		\COMMAND TO DRAW A CIRCLE
begin
MARK;
ADDMOV(^O, XNOW, YNOW, LINTYP);
DRAWLAST;
XLAST:=XNOW; YLAST:=YNOW;
MARK;
end;



proc	OOPS;		\COMMAND TO DELETE LAST MOVE
begin
if NXTMOV>7 then	\(DON'T DELETE THE FIRST MOVE 0,0)
	begin
	MARK;
	NXTMOV:=NXTMOV-SIZE(NXTMOV-1);		\BACK UP A MOVE
	XLAST:=GETX(NXTMOV-SIZE(NXTMOV-1));	\GET START OF THIS LINE
	YLAST:=GETY(NXTMOV-SIZE(NXTMOV-1));
	case GETCC(NXTMOV) of
	  ^M:	[];
	  ^L:	LINE(XLAST, YLAST, GETX(NXTMOV), GETY(NXTMOV), ERASE);
	  ^P:	DOT(GETX(NXTMOV), GETY(NXTMOV), ERASE);
	  ^O:	CIRCLE(XLAST, YLAST, GETX(NXTMOV), GETY(NXTMOV), ERASE, $FF);
	  ^A:	CIRCLE(XLAST, YLAST, GETX(NXTMOV), GETY(NXTMOV), ERASE, GETA(NXTMOV));
	  ^/:	DRAW(NXTMOV,NXTMOV+SIZE(NXTMOV),0,16,0,0,XLAST,YLAST,ERASE);
	  ^C:	[]
	else ERROR("BAD COMMAND IN MOVE LIST");		\(SHOULD NEVER HAPPEN)
	MARK;
	end;
if NXTMOV<=SAVMOV then
	begin
	NEST:=0;
	SAVMOV:=-1;
	NXTSYM:=FIGNXT;
	ERROR("DELETED ENTIRE SUB-FIGURE");
	end;
end;	\OOPS

\----------------------- SUB-FIGURE ROUTINES --------------------------\

func	GETNAM;
\GET NAME OF A SUB-FIGURE FROM OPERATOR AND STORE IT INTO SYMBOL TABLE.
\OUTPUTS: "NEWSYM" - POINTS TO BASE OF NEXT ENTRY AFTER THIS NEW SYMBOL
\ RETURNS TERMINATOR CHARACTER
int	C,I;
begin
TEXT(TV,"figure name : ");
repeat C:=CHIN(KBB) until C>SP ! C=CR;
if C=CR then [NEWSYM:=NXTSYM; return C];
I:=1;				\SKIP 1ST LOC
repeat	SYMTBL(NXTSYM+I):=C;	\COPY NAME INTO SYMBOL TABLE
	I:=I+1;
	C:=CHIN(KBB);
until C<=SP ! NXTSYM+I>SYMMAX;

if NXTSYM+I>SYMMAX then ERROR("SYMBOL TABLE FULL")
else	begin
	NEWSYM:=NXTSYM+I;	\POINT TO NEXT ENTRY IN SYMBOL TABLE
	SYMTBL(NXTSYM):=I-1;	\STORE CHAR COUNT
	end;
return C;			\RETURN TERMINATOR CHAR (FOR "GETFIG")
end;	\GETNAM



func	FNDNAM;
\FIND NAME OF A SUB-FIGURE IN SYMBOL TABLE AND RETURN INDEX OF ITS
\ "START" AND "END" ENTRY
int	SYM,I,FLAG;
begin
SYM:=0;
while SYM<NXTSYM do
	begin
	if SYMTBL(SYM)=SYMTBL(NXTSYM) then	\IF THE NO. OF CHARS MATCH...
		begin
		FLAG:=true;
		for I:=1,SYMTBL(SYM) do
			FLAG:=FLAG & (SYMTBL(SYM+I)=SYMTBL(NXTSYM+I));
		if FLAG then return SYM+SYMTBL(SYM)+1;
		end;
	SYM:=SYM+SYMTBL(SYM)+5;			\NEXT SYMBOL NAME
	end;
return -1;		\NAME NOT FOUND
end;	\FNDNAM



proc	FIGBEGIN;	\COMMAND TO BEGIN (CREATE) A SUB-FIGURE
int	C;
begin
if NEST#0 then [ERROR("MUST HAVE ^">^" BEFORE THIS ^"<^""); return];
C:=GETNAM;		\GET NAME OF SUB-FIG AND STORE INTO SYMBOL TABLE
if NEWSYM=NXTSYM then'RETURN';	\IF NO NAME GIVEN THEN FORGET IT
'IF'FNDNAM#-1'THEN'[ERROR("NAME IS ALREADY USED");'RETURN'];
NEST:=1;
SAVMOV:=NXTMOV;		\SAVE START OF SUB-FIG IN "MOVLST"
FIGNEW:=NEWSYM;		\SAVE LOC OF CURRENT NAME'S START AND END
FIGNXT:=NXTSYM;		\SAVE LOC OF NEW SUB-FIG
NXTSYM:=FIGNEW+4;	\BUMP TO NEXT ENTRY IN SYMBOL TABLE
XOLD:=XNOW; YOLD:=YNOW;	\SAVE COORDINATES FOR START OF SUB-FIG
SAVTYP:=LINTYP;		\SAVE "LINTYP"
LINTYP:=SOLID;		\SUB-FIG DEFS CAN ONLY HAVE SOLID LINES
end; \FIGBEGIN



proc	FIGEND;		\COMMAND TO END A SUB-FIGURE
int	IT,I,OFFSET,K,L,XMIN,XMAX,YMIN,YMAX,
	KXMIN, KYMIN, KXMAX, KYMAX,
	XL, YL, RADIUS;
'REAL'	DX, DY;
begin
if NEST#1 then [ERROR("NO ^"<^" FOR THIS ^">^""); return];
NEST:=0;
LINTYP:=SAVTYP;
if NXTMOV=SAVMOV then
	begin
	SAVMOV:=-1;
	ERROR("NULL SUB-FIGURE");
	NXTSYM:=FIGNXT;		\DELETE NAME FROM SYMBOL TABLE
	return;
	end;
NXTSYM:=FIGNEW+4;		\BUMP TO NEXT ENTRY IN  SYMBOL TABLE
OFFSET:=NXTDEF-SAVMOV;
IT:=FIGNEW+SYMTBL;
IT(0):=SAVMOV+OFFSET;		\START
IT(1):=NXTMOV+OFFSET+7;		\END (+8-1) 8 BYTES FOR MIN & MAX

I:=SAVMOV;			\GET THE MIN AND MAX DIMENSIONS OF SUB-FIG
XMIN:=GETX(I); XMAX:=XMIN;
YMIN:=GETY(I); YMAX:=YMIN;
	\MOVE SUB-FIG DEF TO HIGH END OF MOVLST
repeat	L:=I+OFFSET+8;
	SETC(L,GETC(I));		\MOVE SUB-FIG INTO "DEFLST"
	SETX(L,GETX(I)-XOLD);		\SAVE COORDINATES RELATIVE TO
	SETY(L,GETY(I)-YOLD);		\ THE STARTING POINT
	'CASE' GETCC(I)'OF'^/, ^C, ^A:
		begin			\MOVE THE REST OF IT
		SETS(L,GETS(I));
		SETE(L,GETE(I));
		SETA(L,GETA(I));
		SETSC(L,GETSC(I));
		'END'
	'ELSE';
	'CASE' GETCC(I)'OF'
	^/:	'BEGIN'			\EXTEND BY EXTENT OF SUB-FIG
		K:=GETS(I)+MOVLST;
		KXMIN:=K(0);
		KYMIN:=K(1);
		KXMAX:=K(2);
		KYMAX:=K(3);

		case GETA(I) of			\ROTATE THE SUB-FIG
		    0:	;
		    1:	[IT:=KXMIN; KXMIN:=-KYMAX; KYMAX:=KXMAX; KXMAX:=-KYMIN; KYMIN:=IT];
		    2:	[IT:=KXMIN; KXMIN:=-KXMAX; KXMAX:=-IT; IT:=KYMIN; KYMIN:=-KYMAX; KYMAX:=-IT];
		    3:	[IT:=KXMIN; KXMIN:=KYMIN; KYMIN:=-KXMAX; KXMAX:=KYMAX; KYMAX:=-IT]
		else;

		if GETX(I)+KXMIN<XMIN then XMIN:=GETX(I)+KXMIN;
		if GETY(I)+KYMIN<YMIN then YMIN:=GETY(I)+KYMIN;
		if GETX(I)+KXMAX>XMAX then XMAX:=GETX(I)+KXMAX;
		if GETY(I)+KYMAX>YMAX then YMAX:=GETY(I)+KYMAX;
		end;
	^O, ^A:	'BEGIN'			\EXTEND BY RADIUS
		DX:=FLOAT(GETX(I)-XL);
		DY:=FLOAT(GETY(I)-YL);
		RADIUS:=FIX(SQRT(DX*DX + DY*DY));
		if XL-RADIUS < XMIN then XMIN:=XL-RADIUS;
		if YL-RADIUS < YMIN then YMIN:=YL-RADIUS;
		if XL+RADIUS > XMAX then XMAX:=XL+RADIUS;
		if YL+RADIUS > YMAX then YMAX:=YL+RADIUS;
		'END'
	'ELSE'	'BEGIN'			\EXTEND BY END POINTS
		if GETX(I)<XMIN then XMIN:=GETX(I);
		if GETY(I)<YMIN then YMIN:=GETY(I);
		if GETX(I)>XMAX then XMAX:=GETX(I);
		if GETY(I)>YMAX then YMAX:=GETY(I);
		'END';

	XL:=GETX(I); YL:=GETY(I);
	I:=I+SIZE(I);
	SETC(I+OFFSET+7, GETC(I-1));
until I>=NXTMOV;

K:=NXTDEF+MOVLST;
K(0):=XMIN-XOLD; K(1):=YMIN-YOLD;		\SET SUB-FIG'S MIN & MAX
K(2):=XMAX-XOLD; K(3):=YMAX-YOLD;		\ RELATIVE TO STARTING POINT
NXTDEF:=NXTMOV+OFFSET+8;			\BUMP "DEFLST" POINTER
NXTMOV:=SAVMOV;					\RESTORE "MOVLST" POINTER
SAVMOV:=-1;
SETMUSS;
end;	\FIGEND



proc	GETFIG;		\COMMAND TO GET A SUB-FIGURE NAME AND DRAW IT
int	I,START,END,ANGLE,C,MAG;
begin
C:=GETNAM;
if NEWSYM=NXTSYM then return;	\NO NAME GIVEN, SO FORGET IT
I:=FNDNAM;
if I#-1 then		\IF NAME IS FOUND
	begin
	I:=I+SYMTBL;
	START:=I(0);
	END:=I(1);
	while (C<^0 ! C>^3) & C#CR do C:=CHIN(KBB);	\GET ANGLE
	if C>=^0 & C<=^3 then ANGLE:=C-^0 else ANGLE:=0;

	if C=CR then MAG:=16			\GET MAGNIFICATION FACTOR
	else	begin
		while C#SP & C#CR & C#^, do C:=CHIN(KBB); \SKIP TO SEPARATOR
		if C#CR then MAG:=FIX(RLABS(RLIN(KBB)*16.0))
		else MAG:=16;
		end;

	ADDTHREAD(^/,XNOW,YNOW,START,END,ANGLE,MAG,LINTYP);
	SETRES; MARK; DRAWLAST;
	XLAST:=XNOW; YLAST:=YNOW;
	MARK;
	end
else ERROR("SUB-FIGURE DOES NOT EXIST");
end;	\GETFIG



proc	VLIST;	\COMMAND TO DISPLAY SUB-FIGURE NAMES (VOCAB. LIST)
int	I,J,COUNT;
begin
ADDR(WNDTOP):=0;	\MAKE WINDOW ENTIRE SCREEN
CHOUT(TV,FF);
SETTXT;
TEXT(TV,"	   -- SUB-FIGURES --

");
I:=0;
COUNT:=1;
while I<NXTSYM do
	begin
	if SYMTBL(I+1)#^* then		\DON'T INCLUDE CHARACTER NAMES
		begin
		for J:=1,SYMTBL(I) do CHOUT(TV,SYMTBL(I+J));
		CHOUT(TV,TAB);
		if REM(COUNT/45)=0 then
			begin
			CRLF(TV); WAIT; CHOUT(TV,FF);
			end;
		COUNT:=COUNT+1;
		end;
	I:=I+SYMTBL(I)+5;		\NEXT ENTRY
	end;
CRLF(TV); WAIT; SETRES;
end;	\VLIST

\--------------------- CHARACTER HANDLING ROUTINES --------------------\

func	FNDCHR(C);
int	C;
begin
SYMTBL(NXTSYM):=2;
SYMTBL(NXTSYM+1):=^*;
SYMTBL(NXTSYM+2):=C;
NEWSYM:=NXTSYM+3;
return FNDNAM;
end;



proc	ADDCH(C);	\ADD A TEXT CHARACTER TO MOVE LIST
int	C,I,XR,YR;
begin
MARK;
I:=FNDCHR(C);		\LOOK FOR THE CHARACTER
if I#-1 then		\IF FOUND THEN...
	[I:=I+SYMTBL;
	ADDTHREAD(^/,XNOW,YNOW,I(0),I(1),ALPHANG,ALPHMAG,LINTYP);
	DRAWLAST]
else ADDTHREAD(^C,XNOW,YNOW,C,0,ALPHANG,ALPHMAG,LINTYP);
XR:=[1,0,-1,0]; YR:=[0,1,0,-1];
XNOW:=XNOW+XR(ALPHANG)*ALPHMAG*10/16;
YNOW:=YNOW+YR(ALPHANG)*ALPHMAG*10/16;
MARK;
end;	\ADDCH



proc	DOINSERT;	\COMMAND TO INSERT TEXT CHARACTERS
int	I,C,XR,YR;


	func	GOODCHAR;
	addr	S,I;
	begin
	S:="?:#@'=[].<(+!&*);-/,%_>  ";
	if C=SP ! C=^" ! (C>=^A & C<=^Z) ! (C>=^0 & C<=^9) then 
		return true
	else	begin
		I:=0;
		loop	begin
			if C=S(I) then return true;
			if S(I)=SP then return false;
			I:=I+1;
			end;
		end;
	end;	\GOODCHAR


begin	\DOINSERT
C:=CHIN(KB);
while C>=SP do
	begin
	if GOODCHAR then ADDCH(C)
	else if C=BACKSP then
		begin
		XR:=[1,0,-1,0]; YR:=[0,1,0,-1];
		MARK;
		XNOW:=XNOW-XR(ALPHANG)*ALPHMAG*10/16;
		YNOW:=YNOW-YR(ALPHANG)*ALPHMAG*10/16;
		MARK;
		OOPS;
		end
	else CHOUT(TV,BEL);
	C:=CHIN(KB);
	end;
if XNOW<XLO ! YNOW>YHI ! XNOW>XHI ! YNOW<YLO then SETMUSS;
end;	\DOINSERT

\------------------------ DISK I/O ROUTINES ---------------------------\

proc	SAVE;	\COMMAND TO WRITE DRAWING TO DISK FILE
int	I;
begin
TRAP(false);
OPENO(DISK);
TRAP(true);
if GETERR then [ERROR("OUTPUT FILE IS NOT SET UP"); return];
INTOUT(DISK,NXTMOV); CHOUT(DISK,^,);
INTOUT(DISK,NXTDEF); CHOUT(DISK,^,);
INTOUT(DISK,NXTSYM); CHOUT(DISK,^,);
INTOUT(DISK,MOVMAX); CHOUT(DISK,^,);
INTOUT(DISK,0); CRLF(DISK);		\VERSION NUMBER (NOT USED)

for I:=0,NXTSYM-1 do CHOUT(DISK,SYMTBL(I));
for I:=MOVMAX,NXTDEF-1 do CHOUT(DISK,MOVLST(I));
for I:=0,NXTMOV-1 do CHOUT(DISK,MOVLST(I));
CLOSE(DISK);
end;	\SAVE



proc	LOAD;		\COMMAND TO READ IN A DRAWING FILE
int	C,I,J,INFO,
	NXTM,		\TENTATIVE NXTMOV
	NXTD,		\     "    NXTDEF
	NXTS,		\     "    NXTSYM
	MAXM,		\"MOVMAX" FROM FILE
	UNIT,		\INPUT UNIT NUMBER
	;
addr	NAME;
begin
NAME:=RESERVE(11);
INFO:=RESERVE(4);  
\OPENI(KBB);
TEXT(TV,"unit:filename  : ");
repeat C:=CHIN(KBB) until C>SP ! C=CR;
if C=CR then return;		\IGNORE COMMAND IF NO NAME GIVEN
if C<^0 ! C>^9 then [ERROR("NEED UNIT NUMBER"); return];
UNIT:=C-^0;
C:=CHIN(KBB);			\EAT COLON
C:=CHIN(KBB);

I:=0;
loop	begin
	NAME(I):=C;		\GET FILE NAME
	C:=CHIN(KBB);
	I:=I+1;
	if C<=SP ! I>=8 then quit;
	end;
for J:=I,7 do NAME(J):=SP;	\PAD NAME WITH SPACES
NAME(8):=^F;			\ADD EXTENSION
NAME(9):=^O;
NAME(10):=^T;

TRAP(false);
SCAN(UNIT,INFO,NAME);
OPENF(UNIT,INFO);
TRAP(true);
if GETERR then
	begin
	ERROR("FILE NOT FOUND");
	return;
	end;

NXTM:=INTIN(DISK);		\READ HEADER INFO
NXTD:=INTIN(DISK);
NXTS:=INTIN(DISK);
MAXM:=INTIN(DISK);
if INTIN(DISK) then;		\READ VERSION NUMBER (IGNORE IT)
if NXTM>MOVMAX ! NXTD>MOVMAX+MOVMAX ! NXTS>SYMMAX then
	[ERROR("FILE IS TOO BIG"); return];
NXTMOV:=NXTM; NXTDEF:=NXTD; NXTSYM:=NXTS;
I:=CHIN(DISK);		\EAT THE DAMN LINE FEED

for I:=0,NXTSYM-1 do SYMTBL(I):=CHIN(DISK);
for I:=MOVMAX,NXTDEF-1 do MOVLST(I):=CHIN(DISK);
for I:=0,NXTMOV-1 do MOVLST(I):=CHIN(DISK);

XLAST:=GETX(NXTMOV-SIZE(NXTMOV-1));	\GET THE LAST POINT
YLAST:=GETY(NXTMOV-SIZE(NXTMOV-1));
end;	\LOAD

\----------------------------------------------------------------------\

proc	DOPLOT;
\PLOT HARDCOPY OF DRAWING ON C.ITOH PRINTER.
\PLOTTER DIMENSIONS: 640,768    PICA PITCH, 96 LINES  (= 768/8)
\ WINDOW IS 12 LINES HIGH (WHICH OCCUPIES 12*640 = 7680 BYTES IN
\ HI-RES BUFFER), 96 / 12 = 8 WINDOWS FOR ENTIRE DRAWING.
\X IS ACROSS THE PAGE AND Y IS DOWN THE PAGE. THE DRAWING IS ROTATED
\ 90 DEGREES BEFORE IT IS PRINTED.
int	I,J,
	WINDOW,
	LPTSAV;		\ADDR OF PRINTER HANDLER LPT SIMULATOR



proc	PRBUF;		\DUMP "RASBUF" TO THE PRINTER
int	I,C,CHLINE;
begin
for CHLINE:=0,11 do
	begin
	C:=CHLINE*PITCH;
	CHOUT(PR,ESC); TEXT(PR,"S0640");	\(PITCH)
	for I:=0,PITCH-1 do CHOUT(PR,RASBUF(I+C));
	CRLF(PR);
	end;
end;	\PRBUF



proc	PROPEN;		\INITIALIZE PRINTER FOR PLOTTING
int	I;
begin
RASBUF:=$2000;		\USE HI-RES BUFFER (8K AVAIL)
BITTBL:="01234567";
BITTB2:="01234567";
J:=1;
for I:=0,7 do
	[BITTBL(I):=J;
	BITTB2(I):=not J;
	J:=J+J];
OPENO(PR);
I:=$BFC4;
I:=I(0);		\USE NO LPT SIMULATION
LPTSAV:=I(5);		\SAVE LPT ADDRESS
I(5):=I(8);

CHOUT(PR,ESC); TEXT(PR,"N");		\SET PICA PITCH (640 DOTS/CHAR LINE)
CHOUT(PR,ESC); TEXT(PR,"T16");		\SET LINE FEED PITCH TO 16/144
CHOUT(PR,ESC); TEXT(PR,">");		\SET UNIDIRECTIONAL MODE
CRLF(PR);		\MAKE SURE PRINTER IS ON DETENT

PLOT:=true;		\SET FLAG TO DIRECT OUTPUT TO PRINTER
XTICK:=PXTICK;
YTICK:=PYTICK;
end;	\PROPEN



begin	\DOPLOT
TEXT(TV,"plot drawing ? ");
if CHIN(KBB)#^Y then return;
ADDR(WNDTOP):=0;	\MAKE WINDOW ENTIRE SCREEN
CHOUT(TV,FF);
CURSOR(14,9); TEXT(TV,"PLOTTING");
CURSOR(12,15); TEXT(TV,"PLEASE WAIT...");
SETTXT;
PROPEN;
XLO:= -(PITCH/2-1)*XTICK/SCALE;
XHI:=(PITCH/2-2)*XTICK/SCALE;
WINDOW:=3;

'IF'ITOH'THEN'
	[TEXT(PR,"I960,1020
");
	DRAW(0,NXTMOV-1,1,16,0,0,XLAST,YLAST,SOLID)]
'ELSE' while WINDOW>=-4 do
	begin
	CLEAR;
	YLO:=WINDOW*96 *YTICK/SCALE;
	YHI:=((WINDOW+1)*96 -1) *YTICK/SCALE;
	DRAW(0,NXTMOV-1,1,16,0,0,XLAST,YLAST,SOLID);
	PRBUF;
	WINDOW:=WINDOW-1;
	end;

I:=$BFC4;		\RESTORE PRINTER HANDLER
I:=I(0);
I(5):=LPTSAV;
\CLOSE(PR);
'IF'ITOH'THEN'TEXT(PR,"H
");
PLOT:=false;		\CLEAR PRINTER OUTPUT FLAG
XTICK:=EXTICK;
YTICK:=EYTICK;
CLEAR;			\(DON'T FLASH GARBAGE)
SETMUSS;		\REDRAW HI-RES SCREEN
end;	\DOPLOT

\----------------------------------------------------------------------\

proc	HELP;		\COMMAND TO DISPLAY HELP MESSAGES
int	C;
begin
ADDR(WNDTOP):=0;	\MAKE WINDOW ENTIRE SCREEN
CHOUT(TV,FF);
SETTXT;
\TEXT(TV,"	 -- DRAWING COMMANDS --
\
\CTRL-q	- MOVE CURSOR 1 STEP LEFT
\CTRL-a	- MOVE CURSOR 1 STEP RIGHT
\CTRL-w	- MOVE CURSOR 1 STEP UP
\CTRL-s	- MOVE CURSOR 1 STEP DOWN
\CTRL-e	- MOVE CURSOR 4 MORE STEPS
\CTRL-d	- MOVE CURSOR 19 MORE STEPS
\
\CTRL-z	- DRAW LINE
\CTRL-x	- DRAW DOT (AND START A LINE)
\CTRL-c	- START A LINE
\CTRL-o	- DRAW CIRCLE
\
\CTRL-r	- REDRAW SCREEN
\CTRL-b	- TURN BOX ON/OFF
\CTRL-v	- ERASE (VAPORIZE) BOX CONTENTS
\CTRL-f	- FILL BOX FOR MOVE
\CTRL-m	- MOVE BOX CONTENTS
\
\i	- START WRITING CHARACTERS
\	  (STOP WITH ANY CONTROL CHAR)
\<--	- DELETE LAST KEYSTROKE
\");
WAIT;
CHOUT(TV,FF);
\TEXT(TV,"
\mAGNIFY	- SET THE MAGNIFICATION
\gRID	- SET THE GRID SIZE
\lINE	- SET LINE TYPE (eRASE, sOLID)
\aLPHA	- SET THE CHARACTER SIZE
\tURN	- SET THE CHARACTER ANGLE
\dISPLAY	- DISPLAY CURRENT SETTINGS
\esc	- TURN STATUS DISPLAY OFF/ON
\
\<	- BEGIN AND LABEL A SUB-FIGURE
\>	- END A SUB-FIGURE
\/	- DRAW SUB-FIGURE (ANGLE, SIZE)
\vOCAB.	- LIST CURRENT SUB-FIGURES
\o	- DRAW AN ARC
\
\wRITE	- WRITE THE DRAWING TO DISK
\rEAD	- READ A DRAWING FROM DISK
\pLOT	- PLOT DRAWING ON PRINTER
\
\kILL	- ERASE ENTIRE DRAWING
\hELP	- DISPLAY THIS LIST
\qUIT	- EXIT THE PROGRAM
\");
WAIT;
SETRES;
end;	\HELP



proc	DOESC;		\TURN TEXT FIELD ON/OFF
begin
if TVMODE=HI then
	begin
	TVMODE:=MIX;
	CLRBOTTOM;			\MAKE SURE BOTTOM LINE IS CLEAR
	if YNOW<YLOMIX then SETMUSS;
	end
else	TVMODE:=HI;
SETRES;			\DISPLAY IN NEW MODE
end;	\DOESC



proc	BOXERASE;	\REMOVE FIGURES INSIDE MAGIC BOX
int	I,J,	\INDICES INTO "MOVLST"
	K,	\SCRATCH FOR "SAVEIT"
	INBOX,	\CURRENT POINT IS INSIDE THE BOX, DELETE LINE IF NEXT
	XL,YL;	\LAST POINT (FOR LINE)


	proc	SAVEIT;		\SAVE ITEM BY SQUASHING IT DOWN
	begin
	for K:=0,SIZE(I)-1 do		\MOVE ENTRIES DOWN
		MOVLST(J+K):=MOVLST(I+K);
	J:=J+K;
	end;


begin
MARK;				\REMOVE BOX
if XNOW<XBOXMIN then		\SWAP
	[XBOXMAX:=XBOXMIN; XBOXMIN:=XNOW]
else	XBOXMAX:=XNOW;
if YNOW<YBOXMIN then		\SWAP
	[YBOXMAX:=YBOXMIN; YBOXMIN:=YNOW]
else	YBOXMAX:=YNOW;

I:=0; J:=0;
INBOX:=false;
while I<NXTMOV do
	begin
	if INBOX then		\IF THE PREVIOUS POINT WAS IN THE BOX...
		begin
		if GETCC(I)=^L then	\ AND IF THIS IS A LINE, DELETE IT
			begin
			SETC(I,^M);	\CHANGE IT INTO A MOVE
			SETC(I+SIZE(I)-1,^M);
			LINE(XL, YL, GETX(I), GETY(I), ERASE);
			INBOX:=false;
			end
		else if GETCC(I)=^O then  \ AND IF THIS IS A CIRCLE, DELETE IT
			begin
			SETC(I,^M);	\CHANGE IT INTO A MOVE
			SETC(I+SIZE(I)-1,^M);
			CIRCLE(XL, YL, GETX(I), GETY(I), ERASE, $FF);
			INBOX:=false;
			end
		else if GETCC(I)=^A then  \ AND IF THIS IS AN ARC, DELETE IT
			begin
			CIRCLE(XL, YL, GETX(I), GETY(I), ERASE, GETA(I));
			SETC(I,^M);	\CHANGE IT INTO TWO MOVES
			SETC(I+5,^M);
			SETC(I+6,^M);
			SETC(I+11,^M);
			INBOX:=false;
			end;
		end;
	if GETX(I)>=XBOXMIN & GETX(I)<=XBOXMAX &
	    GETY(I)>=YBOXMIN & GETY(I)<=YBOXMAX then
		begin			\IT'S IN THE BOX
		INBOX:=true;		\SAVE IN CASE A LINE IS NEXT
		XL:=GETX(I); YL:=GETY(I);

		case GETCC(I) of
		  ^M:	[];
		  ^L:	SAVEIT;	\SAVE LINES WHOS ORIGIN IS OUTSIDE THE BOX
		  ^P:	DOT(GETX(I), GETY(I), ERASE);
		  ^O:	SAVEIT;
		  ^A:	SAVEIT;
		  ^/:	DRAW(I, I+SIZE(I), 0, 16, 0, 0, GETX(I), GETY(I), ERASE);
		  ^C:	[]
		else;
		end
	else	begin
		SAVEIT;		\NOT IN THE BOX SO SAVE IT
		INBOX:=false;
		end;
	I:=I+SIZE(I);		\NEXT ITEM
	end;
NXTMOV:=J;
XLAST:=GETX(NXTMOV-SIZE(NXTMOV-1));	\GET THE LAST POINT
YLAST:=GETY(NXTMOV-SIZE(NXTMOV-1));

BOXON:=false;
DRAGBOX:=false;		\(MAKE SURE IT'S OFF)
MARK;		\DISPLAY CROSS HAIRS
end;	\BOXERASE



proc	BOXMOVE;	\MOVE FIGURES INSIDE BOX
int	I,	\INDEX INTO "MOVLST"
	INBOX,	\BOOLEAN: COORDINATES ARE IN THE BOX (REDRAW LINE IF NEXT)
	DX, DY,	\AMOUNT TO MOVE
	X, Y,	\COORDINATES
	XL, YL,	\LAST POINT (FOR LINE) BEFORE MOVE
	XLM, YLM; \LAST POINT AFTER (POSSIBLE) MOVE

	proc	MOVEIT;
	[SETX(I, GETX(I)+DX);
	SETY(I, GETY(I)+DY)];

begin
MARK;			\REMOVE CURSOR DISPLAY (BOX)
if DRAGBOX then 
	begin
	DRAGBOX:=false;
	DX:=XNOW-XBOXMAX;	\CALCULATE AMOUNT TO MOVE
	DY:=YNOW-YBOXMAX;

	if XBOXMAX<XBOXMIN then		\SWAP
		[I:=XBOXMAX; XBOXMAX:=XBOXMIN; XBOXMIN:=I];
	if YBOXMAX<YBOXMIN then		\SWAP
		[I:=YBOXMAX; YBOXMAX:=YBOXMIN; YBOXMIN:=I];

	INBOX:=false;
	I:=0;
	while I<NXTMOV do
		begin
		X:=GETX(I); Y:=GETY(I);
		if X>=XBOXMIN & X<=XBOXMAX &
		    Y>=YBOXMIN & Y<=YBOXMAX then
			begin			\IT'S IN THE BOX
			INBOX:=true;
			case GETCC(I) of
			  ^M:	MOVEIT;
			  ^L:	begin
			  	LINE(XL, YL, X, Y, ERASE);
				MOVEIT;
			  	LINE(XLM, YLM, GETX(I), GETY(I), SOLID);
				end;
			  ^P:	begin
			  	DOT(X, Y, ERASE);
				MOVEIT;
			  	DOT(GETX(I), GETY(I), SOLID);
				end;
			  ^O:	begin
				CIRCLE(XL, YL, X, Y, ERASE, $FF);
				MOVEIT;
				CIRCLE(XLM, YLM, GETX(I), GETY(I), SOLID, $FF);
				end;
			  ^A:	begin
				CIRCLE(XL, YL, X, Y, ERASE, GETA(I));
				MOVEIT;
				CIRCLE(XLM, YLM, GETX(I), GETY(I), SOLID, GETA(I));
				end;
			  ^/:	begin
				DRAW(I, I+SIZE(I), 0, 16, 0, 0, X, Y, ERASE);
				MOVEIT;
				DRAW(I, I+SIZE(I), 0, 16, 0, 0, GETX(I), GETY(I), SOLID);
				end;
			  ^C:	MOVEIT
			else;
			end
		else
			begin			\IT'S NOT IN THE BOX, BUT
			if INBOX then		\IF THE PREVIOUS POINT WAS IN THE BOX
			    begin
			    if GETCC(I)=^L then	\ AND IF THIS IS A LINE, REDRAW IT
				begin
				LINE(XL, YL, X, Y, ERASE);
				LINE(XLM, YLM, X, Y, SOLID);
				end;
			    if GETCC(I)=^O then	\ AND IF THIS IS A CIRCLE, REDRAW IT
				begin
				CIRCLE(XL, YL, X, Y, ERASE, $FF);
				CIRCLE(XLM, YLM, X, Y, SOLID, $FF);
				end;
			    if GETCC(I)=^A then	\ AND IF THIS IS AN ARC, REDRAW IT
				begin
				CIRCLE(XL, YL, X, Y, ERASE, GETA(I));
				CIRCLE(XLM, YLM, X, Y, SOLID, GETA(I));
				end;
			    end;
			INBOX:=false;
			end;
		XL:=X; YL:=Y;
		XLM:=GETX(I); YLM:=GETY(I);
		I:=I+SIZE(I);		\NEXT ITEM
		end;
	XLAST:=GETX(NXTMOV-SIZE(NXTMOV-1));	\GET THE LAST POINT
	YLAST:=GETY(NXTMOV-SIZE(NXTMOV-1));	\ (IT MIGHT HAVE MOVED)
	end;
BOXON:=false;
MARK;		\DISPLAY CROSS HAIRS
end;	\BOXMOVE



func real	GETPARM(STR,VAL);	\GET A PARAMETER FROM BOTTOM LINE
char	STR;
real	VAL;
int	CH;
real	NEWVAL;
begin
CLRBOTTOM;
TEXT(TV,STR);
CHOUT(TV,SP);
RLOUT(TV,VAL);
TEXT(TV,"  :  ");
while ADDR(KEYBOARD)<$80 do;	\WAIT FOR KEYSTROKE
CH:=ADDR(KEYBOARD)&$7F;		\GET THE CHAR
if CH<$20 then [CH:=ADDR(STROBE); return VAL];
NEWVAL:=RLIN(KBB);
return NEWVAL;
end;	\GETPARM



proc	GETLINE;		\GET THE LINE TYPE
int	CH;
begin
CLRBOTTOM;
TEXT(TV,"line type : ");
case LINTYP of
  SOLID:	TEXT(TV,"SOLID");
  ERASE:	TEXT(TV,"ERASE")
else	INTOUT(TV,LINTYP);		\*** DEBUG
TEXT(TV,"  :  ");
while ADDR(KEYBOARD)<$80 do;	\WAIT FOR KEYSTROKE
CH:=ADDR(KEYBOARD)&$7F;		\GET THE CHAR
if CH<$20 then [CH:=ADDR(STROBE); return];
CH:=CHIN(KBB);
case CH of
    ^S: LINTYP:=SOLID;
    ^E:	LINTYP:=ERASE
else ERROR("INVALID LINE TYPE");
end;	\GETLINE



proc	DOARC;
int	SEGS,CH;
real	DX,  DY, THETA, ARCANG;
begin
CLRBOTTOM;
TEXT(TV,"arc angle  :  ");
while ADDR(KEYBOARD)<$80 do;	\WAIT FOR KEYSTROKE
CH:=ADDR(KEYBOARD)&$7F;		\GET THE CHAR
if CH<$20 then [CH:=ADDR(STROBE); return];
ARCANG:=RLIN(KBB);

DX:=FLOAT(XNOW-XLAST);
DY:=FLOAT(YNOW-YLAST);
THETA:=if DY=0.0 & DX=0.0 then 0.0 else ATAN2(DY,DX) *57.2957795;
SEGS:=ARCSEGS(THETA,ARCANG);
MARK;
ADDTHREAD(^A, XNOW, YNOW, 0, 0, SEGS, 0, LINTYP);
DRAWLAST;
XLAST:=XNOW; YLAST:=YNOW;
MARK;
end;	\DOARC



proc	KILLIT;		\ERASE EVERYTHING (EXCEPT SUB-FIGS) AND START OVER
begin
NEST:=0;
SAVMOV:=-1;

ALPHMAG:=16; ALPHANG:=0;
XNOW:=0; YNOW:=0;

NXTMOV:=0;
GRID:=50;
SCALE:=10;
METRIC:=false;

XTICK:=EXTICK;
YTICK:=EYTICK;
FACTOR:=EFACTOR;
SETLIMIT;
DOMOVE;
LINTYP:=SOLID;	\SOLID LINES
SETMUSS;
BOXON:=false;
DRAGBOX:=false;
end;	\KILLIT;



proc	DOCMD;		\EXECUTE COMMAND FROM KEYBOARD
int	CH,I;
begin
CH:=CHIN(KB);
case CH of
    LEFT:	GOLEFT(1);
    RIGHT:	GORIGHT(1);
    UP:		GOUP(1);
    DOWN:	GODOWN(1);
    BY5:	GOBY(4);
    BY20:	GOBY(19);
    AMOVE:	DOMOVE;
    APOINT:	DODOT;
    ALINE:	DOLINE;
    ACIRCLE:	DOCIRCLE;
    AREDRAW:	SETMUS;
    BACKSP:	OOPS;
    INSERT:	DOINSERT;
    ABOX:	begin
		DOMOVE;
		MARK;		\REMOVE CURRENT CURSORS
		XBOXMIN:=XNOW; YBOXMIN:=YNOW;	\ASSUME LOWER RIGHT CORNER
		BOXON:=not BOXON;		\FLIP CONDITION
		if not BOXON then DRAGBOX:=false;
		MARK;		\SHOW NEW CURSOR
		end;
    ANERASE:	begin
		if BOXON then BOXERASE else ERROR("NO BOX TO ERASE");
		end;
    ABOXFIL:	begin		\DEFINE END OF BOX TO BE MOVED
		if BOXON then
			begin
			MARK;
			XBOXMAX:=XNOW;
			YBOXMAX:=YNOW;
			DRAGBOX:=true;
			MARK;
			end
		else	ERROR("NO BOX TO FILL");
		end;
    ABOXMOV:	BOXMOVE;
    ESC:	DOESC
else	begin
	SETHI; SETMIX;
	OPENI(KBB);
	FORMAT(3,2);
	CLRBOTTOM;
	ADDR(WNDTOP):=23;	\SCROLL ONLY THE BOTTOM LINE
	case CH of
	AMAG:	begin
		I:=SCALE;
		repeat SCALE:=FIX(GETPARM("magnification",FLOAT(SCALE)/10.0) *10.0);
		until SCALE>0;
		if I#SCALE then SETMUSS;
		end;
	AGRID:	begin
		repeat GRID:=FIX(GETPARM("grid",FLOAT(GRID)/FACTOR) *FACTOR);
		until GRID>0;
		MARK;
		XNOW:=RND(XNOW,GRID);
		YNOW:=RND(YNOW,GRID);
		MARK;
		end;
	LTYPE:	GETLINE;
	ASIZE:	ALPHMAG:=FIX(GETPARM("alpha size",FLOAT(ALPHMAG)/16.0) *16.0);
	TURN:	begin
		ALPHANG:=FIX(GETPARM("alpha angle",FLOAT(ALPHANG*90)) /90.0) &3;
		end;
	ANARC:	DOARC;
	ADISP:	STATALL;
	ABEGIN:	FIGBEGIN;
	ANEND:	FIGEND;
	SUBFIG:	GETFIG;
	ALIST:	VLIST;
	AWRITE:	SAVE;
	AREAD:	[LOAD; SETMUSS];
	APLOT:	DOPLOT;
	AKILL:	begin
		TEXT(TV,"erase entire drawing ? ");
		if CHIN(KBB)=^Y then KILLIT;
		end;
	AHINT:	HELP;
	AQUIT:	begin
		TEXT(TV,"quit ? ");
		if CHIN(KBB)=^Y then
			[ADDR(CHKUSR):=CUBYTE;	\FIX "CHKUSR" ROUTINE
			ADDR(WNDTOP):=$0;	\FIX TV DISPLAY
			SETTXT; exit]
		end
	else [ERROR("ILLEGAL COMMAND")];

	CLRBOTTOM;
	ADDR(WNDTOP):=0;	\MAKE WINDOW ENTIRE SCREEN
	SETRES;			\RESTORE TV DISPLAY MODE
	end;

case TVMODE of	\UPDATE STATUS IF IT IS DISPLAYED
  HI:	;
  MIX:	STATUS;
  TXT:	STATALL
else;
end;	\DOCMD

\======================================================================\

begin	\MAIN
MOVLST:=RESERVE(MOVMAX+1+DEFMAX+1);
SYMTBL:=RESERVE(SYMMAX+1);
COLD:="A ";
ADDR:=0;

\DEBUG
TEXT(TV,"AVAILABLE HEAP SPACE: "); INTOUT(TV,FREE); CRLF(TV);
WAIT;
\END DEBUG

CHOUT(TV,FF);
CURSOR(7,23);
TEXT(TV,"-- DRAFT, VERSION 0.0X2 --");

CHKUSR:=DEVTAB;		\DISABLE CTRL-C, S, P ("CHKUSR" ROUTINE)
CHKUSR:=CHKUSR(KB);
CHKUSR:=CHKUSR+1;
CHKUSR:=CHKUSR(9);
CUBYTE:=ADDR(CHKUSR);		\SAVE FOR LATER
ADDR(CHKUSR):=\RTS\$60;

NEST:=0;
SAVMOV:=-1;
PLOT:=false;

if COLD(0)=^A then
	begin
	KILLIT;
	NXTDEF:=MOVMAX;		\ERASE SUB-FIGS
	NXTSYM:=0;
	COLD(0):=^B;
	end;
CLEAR;
TVMODE:=MIX;
SETRES;
SETMUSS;
STATUS;

loop	begin
	while MUSSFLG do	\(MULTITASKING WOULD BE NICE HERE)
		begin
		SETLIMIT;
		CLEAR;
		MARK;			\SHOW CURSOR
		MUSSFLG:=false;
		DRAW(0,NXTMOV-1,0,16,0,0,XLAST,YLAST,SOLID);
		end;
	loop	begin
		for I:=1,CURFLASH do if ADDR(KEYBOARD)>=$80 then quit;
		MARK;		\FLASH CURSOR OFF
		for I:=1,CURFLASH do
			if ADDR(KEYBOARD)>=$80 then [MARK; quit];
		MARK;		\FLASH CURSOR ON
		end;
	DOCMD;
	end;
end;	\MAIN
