\DTEST.XPL
\LOW LEVEL DISK MANIPULATOR

\COPYRIGHT 1981,82 LARRY FISH

'CODE' ABS=0,RAN=1,REM=2,
RESERVE=3,SWAP=4,CHIN=7,CHOUT=8,
CRLF=9,NUMIN=10,NUMOUT=11,TEXT=12,
OPENIN=13,OPENOUT=14,CLOSE=15,
SPACE=18,
CURSOR=23;



'ADDRESS'
	CONBASE;	\BASE ADDRESS OF CONTROLLER

'INTEGER'
	CHAR,
	DUM,		\DUMMY TO TURN ON SWITCHES
	DRIVE,		\HOLD CURRENT DRIVE
	TRACK,		\CURRENT TRACK POSITION
	SLOT;		\SLOT NUMBER OF CONTROLLER CARD




'DEF'
	INLINE=21,	\LINE FOR COMMANDS
	FF=$C,		\FORM FEED
	MOFF=8,		\INDEX TO TURN OFF MOTOR
	MON=9,		\INDEX TO TURN ON MOTOR
	DEVONE=10,	\INDEX TO SELECT DEVICE ONE
	DEVTWO=11,	\INDEX TO SELECT DEVICE TWO
	Q6OFF=$C,	\INDEX TO TURN OFF Q6
	Q6ON=$D,	\INDEX TO TURN ON Q6
	Q7OFF=$E,	\INDEX TO TURN OFF Q7
	Q7ON=$F,	\INDEX TO TURN ON Q7
	IOBASE=$C080;	\I-O BASE ADDRESS



'PROCEDURE' BLINE;
'INTEGER' X;
TEXT(0,"                                       ");


'PROCEDURE' GETSLOT;
'BEGIN'
'REPEAT'
	'BEGIN'
	CHOUT(0,FF);
	TEXT(0,"ENTER SLOT NUMBER OF DISK CARD ");
	OPENIN(0);
	SLOT:=NUMIN(0);
	CRLF(0);
	'END'
'UNTIL' SLOT>0 & SLOT<7;
CONBASE:=(SLOT*16)+IOBASE;
'END';





'PROCEDURE' MENU;
'BEGIN'
CHOUT(0,FF);
TEXT(0,"***** DRIVE MANIPULATOR *****");CRLF(0);
CRLF(0);
TEXT(0,"COMMANDS:");CRLF(0);
CRLF(0);
TEXT(0,"  D	SELECT ANOTHER DRIVE");CRLF(0);
TEXT(0,"  T	STEP TO ANOTHER TRACK");CRLF(0);
TEXT(0,"  I	STEP IN ONE TRACK");CRLF(0);
TEXT(0,"  O	STEP OUT ONE TRACK");CRLF(0);
TEXT(0,"  H	HOME THE DRIVE");CRLF(0);
TEXT(0,"  M	TURN ON DRIVE MOTOR");CRLF(0);
TEXT(0,"  S	TURN OFF DRIVE MOTOR");CRLF(0);
TEXT(0,"  F	IN-OUT TEN");CRLF(0);
TEXT(0,"  B	OUT-IN TEN");CRLF(0);
TEXT(0,"  V	VERIFY TRACK UNDER HEAD");CRLF(0);
TEXT(0,"  Q	QUIT");CRLF(0);
'END';



'PROCEDURE' SELECT;
'BEGIN'
'REPEAT'
	'BEGIN'
	CURSOR(0,INLINE);
	TEXT(0,"WHICH DRIVE, (ENTER 1 OR 2)?");
	OPENIN(0);
	DRIVE:=NUMIN(0);
	'END'
'UNTIL' DRIVE=1 ! DRIVE=2;
DUM:=CONBASE(DEVONE+(DRIVE-1));
MENU;
'END';



'PROCEDURE' ONDRIVE;
'INTEGER' PHASE;
'BEGIN'
PHASE:=REM((TRACK(DRIVE-1)*2)/4);
DUM:=CONBASE((PHASE*2)+1);
DUM:=CONBASE(MON);
'END';



'PROCEDURE' OFFDRIVE;
'BEGIN'
DUM:=CONBASE(MOFF);
'END';



'PROCEDURE' BCYCLE;
'INTEGER' X,I;
'BEGIN'
DUM:=CONBASE(0);
'FOR' X:=0,3 'DO'
	'BEGIN'
	DUM:=CONBASE(7-(X*2));
	'FOR' I:=0,30 'DO';
	DUM:=CONBASE(6-(X*2));
	'END';
'END';



'PROCEDURE' HOME;
'INTEGER' T;
'BEGIN'
'FOR' T:=0,80 'DO' BCYCLE;
TRACK(DRIVE-1):=0;
'END';



'PROCEDURE' SEEK(TARGET);
'INTEGER' TARGET,DELTA,PHASE;

'DEF' DELAY=40;

'PROCEDURE' BACK;
'INTEGER' X,I;
'BEGIN'
'FOR' X:=1,ABS(DELTA)*2 'DO'
	'BEGIN'
	DUM:=CONBASE(PHASE*2);
	PHASE:='IF' PHASE=0 'THEN' 3 'ELSE' PHASE-1;
	DUM:=CONBASE((PHASE*2)+1);
	'FOR' I:=0,DELAY 'DO';
	'END';
'END';


'PROCEDURE' FORWARD;
'INTEGER' X,I;
'BEGIN'
'FOR' X:=1,DELTA*2 'DO'
	'BEGIN'
	DUM:=CONBASE(PHASE*2);
	PHASE:='IF' PHASE=3 'THEN' 0 'ELSE' PHASE+1;
	DUM:=CONBASE((PHASE*2)+1);
	'FOR' I:=0,DELAY 'DO';
	'END';
'END';


'BEGIN'
DELTA:=TARGET-TRACK(DRIVE-1);
PHASE:=REM((TRACK(DRIVE-1)*2)/4);
DUM:=CONBASE((PHASE*2)+1);
DUM:=CONBASE(MON);
'IF' DELTA<0 'THEN' BACK 'ELSE' FORWARD;
TRACK(DRIVE-1):=TARGET;
'END';



'PROCEDURE' FIND;
'INTEGER' TARGET;
'BEGIN'
'REPEAT'
	'BEGIN'
	CURSOR(0,INLINE);
	TEXT(0,"STEP TO WHAT TRACK (0-34)? ");
	OPENIN(0);
	TARGET:=NUMIN(0);
	'END'
'UNTIL' TARGET>-1 & TARGET<35;
SEEK(TARGET);
MENU;
'END';



'PROCEDURE' SETUP;
'BEGIN'
GETSLOT;
DUM:=CONBASE(Q6OFF);
DUM:=CONBASE(Q7OFF);
CHOUT(0,FF);
TEXT(0,"HOMING DRIVES....");
CRLF(0);
DUM:=CONBASE(DEVTWO);
DRIVE:=2;
DUM:=CONBASE(MON);
HOME;
DUM:=CONBASE(DEVONE);
DRIVE:=1;
DUM:=CONBASE(MON);
HOME;
OFFDRIVE;
'END';



'PROCEDURE' STATUS;
'BEGIN'
CURSOR(5,17);
TEXT(0,"	WORKING DRIVE=");
NUMOUT(0,DRIVE);CRLF(0);
CRLF(0);
TEXT(0,"DRIVE 1=");NUMOUT(0,TRACK(0));
TEXT(0,"   ");
TEXT(0,"DRIVE 2=");NUMOUT(0,TRACK(1));
TEXT(0,"   ");
'END';



'PROCEDURE' IN;
'INTEGER' TARGET;
'BEGIN'
TARGET:=TRACK(DRIVE-1)+1;
'IF' TARGET<35 'THEN' SEEK(TARGET);
'END';



'PROCEDURE' OUT;
'INTEGER' TARGET;
'BEGIN'
TARGET:=TRACK(DRIVE-1)-1;
'IF' TARGET>-1 'THEN' SEEK(TARGET);
'END';



'PROCEDURE' INTEN;
'INTEGER' TARGET,OLD;
'BEGIN'
OLD:=TRACK(DRIVE-1);
TARGET:=OLD+10;
'IF' TARGET>34 'THEN' SEEK(34)
'ELSE' SEEK(TARGET);
STATUS;
SEEK(OLD);
'END';



'PROCEDURE' OUTTEN;
'INTEGER' TARGET,OLD;
'BEGIN'
OLD:=TRACK(DRIVE-1);
TARGET:=OLD-10;
'IF' TARGET<0 'THEN' SEEK(0)
'ELSE' SEEK(TARGET);
STATUS;
SEEK(OLD);
'END';



'PROCEDURE' VERIFY;
'EXTERNAL' READD=$B944;
'BEGIN'
ONDRIVE;
'END';



'PROCEDURE' TEST;
'INTEGER' DONE;
'BEGIN'
DONE:='FALSE';
CURSOR(5,22);
TEXT(0,"SELECT: ");
CHAR:=CHIN(1);
CURSOR(5,15);
TEXT(0,"COMMAND: ");
CHOUT(0,CHAR);
CURSOR(0,INLINE);
'CASE' CHAR 'OF'
	^D: SELECT;
	^T: FIND;
	^I: IN;
	^O: OUT;
	^H: [ONDRIVE;HOME];
	^M: ONDRIVE;
	^S: OFFDRIVE;
	^F: INTEN;
	^B: OUTTEN;
	^Q: DONE:='TRUE';
	^V: VERIFY

'ELSE';
STATUS;
CURSOR(0,INLINE);BLINE;
CURSOR(0,INLINE+1);BLINE;
CURSOR(0,INLINE+2);BLINE;
'RETURN' DONE;
'END';



'BEGIN'	\MAIN
TRACK:=RESERVE(4);
SETUP;
MENU;
STATUS;
'REPEAT' 'UNTIL' TEST;
'END';
