\DUMP.XPL	NOV-85
\PROGRAM TO DUMP THE DISK

code	REM=2,		RESERVE=3,	CHIN=7,		CHOUT=8,
	CRLF=9,		INTIN=10,	INTOUT=11,	TEXT=12,
	OPENI=13,	OPENO=14,	CLOSE=15,	TRAP=17,
	ERRFLG=22,	READ=31;

int	ODEV,		\OUTPUT DEVICE NUMBER
	UNIT,		\UNIT NUMBER
	BLKNUM,		\BLOCK NUMBER
	FBLK,		\FIRST BLOCK
	LBLK;		\LAST BLOCK
addr	BLOCK;		\HOLD WORKING BLOCK OF DISK DATA

\----------------------------------------------------------------------\

proc	BYTEOUT(N);	\OUTPUT "N" AS 2 HEX DIGITS
int	N,R;
addr	HEXTBL;
begin	\BYTEOUT
HEXTBL:="0123456789ABCDEF ";
N:= (N&$FF)/16;
R:=REM(0);
CHOUT(ODEV, HEXTBL(N));
CHOUT(ODEV, HEXTBL(R));
end;	\BYTEOUT

\----------------------------------------------------------------------\

proc	READBLK;	\READ A BLOCK FROM "UNIT"
begin
if ERRFLG then;		\FLUSH ERRORS
TRAP(false);
READ(UNIT,BLKNUM,BLOCK,1);
TRAP(true);
if ERRFLG then
	begin
	TEXT(0,"READ ERROR ON BLOCK NUMBER ");
	INTOUT(0,BLKNUM);
	CRLF(0);
	end;
end;	\READBLK

\----------------------------------------------------------------------\

proc	SHOWCH(CH);	\SHOW CHARACTER
int	CH;
begin
CH:= CH&$7F;
CHOUT(ODEV,if CH<$20 ! CH>=$7F then ^. else CH);
end;	\SHOWCH



proc	SHOWBLK;	\SHOW THE BLOCK
int	X,Y;
begin
CRLF(ODEV);
TEXT(ODEV,"BLOCK NUMBER "); INTOUT(ODEV,BLKNUM); CRLF(ODEV);
CRLF(ODEV);

for X:=0,31 do
	begin
	BYTEOUT(8*X);
	TEXT(ODEV,":  ");
	for Y:=0,7 do
		begin
		BYTEOUT(BLOCK(8*X+Y));
		CHOUT(ODEV,^ );
		end;
	TEXT(ODEV,"  ");
	for Y:=0,7 do SHOWCH(BLOCK(8*X+Y));
	CRLF(ODEV);
	end;
end;	\SHOWBLK

\----------------------------------------------------------------------\

begin	\MAIN
BLOCK:= RESERVE(256);
TEXT(0,"-- DISK DUMP, V1.8 --
OUTPUT DEVICE? ");
ODEV:= INTIN(0);

TEXT(0,"UNIT? ");
UNIT:= INTIN(0);

OPENO(ODEV);
loop	begin
	TEXT(0,"FIRST BLOCK? ");
	FBLK:= INTIN(0);
	TEXT(0,"LAST BLOCK?  ");
	LBLK:= INTIN(0);
	for BLKNUM:=FBLK,LBLK do
		begin
		READBLK;
		SHOWBLK;
		CRLF(ODEV);
		end;
	TEXT(0,"MORE? ");
	if (CHIN(0)!$20)#^y then quit;
	end;
CLOSE(ODEV);
end;	\MAIN
