\DUP.XPL	DEC-05-86
\DISK DUPLICATOR FOR APEX V1.8
\ BY P.J.R. BOYLE

\REVISION HISTORY:
\NOV-21-85, ADDED SINGLE DISK DUP, AND REPEATED DUPLICATION, L.B.
\DEC-05-86, FIXED THE INCREDIBLE SHRINKING BUFFER BUG, L.B.

code	ABS=0,         RAN=1,        REM=2,
	RESERVE=3,     SWAP=4,       EXTEND=5,
	RESTART=6,     CHIN=7,       CHOUT=8,
	CRLF=9,        INTIN=10,     INTOUT=11,
	TEXT=12,       OPENI=13,     OPENO=14,
	CLOSE=15,      ABORT=16,     TRAP=17,
	SPACE=18,      RERUN=19,     GETSP=20,
	SETSP=21,      ERRFLG=22,    CURSOR=23,
	SETRUN=25,     FGET=26,      FASAVE=27,
	FRUN=28,       FSAVE=29,     FWRITE=30,
	FREAD=31;

int	I, FROMUNIT, TOUNIT, SIZE0, MAXBLK;
addr	BUFFER;



func	VERIFY;		\RETURN 'TRUE' IF "Y" (OR "y") IS TYPED IN
begin
TEXT(0," - VERIFY? ");
OPENI(0);
return (CHIN(0)!$20)= ^y;
end;	\VERIFY



proc	NEWDISK(FLAG);	\PROMPT USER TO INSERT DISK
int	FLAG;
begin
if TOUNIT=FROMUNIT then
	begin
	TEXT(0,if FLAG then "INSERT COPY DISK"
	else "RESTORE ORIGINAL DISK");
	repeat until VERIFY;
	end;
end;	\NEWDISK



proc	SHOWTITLE(UNIT);	\OUTPUT THE TITLE OF THE SPECIFIED UNIT
int	UNIT;
int	I, CH;
addr	BUFFER, TITLE;
begin
BUFFER:= RESERVE(256);
TITLE:= BUFFER+88;
FREAD(UNIT,12,BUFFER,1);
for I:= 0,79 do
	begin
	CH:= TITLE(I);
	if CH>=$20 & CH<$80 then CHOUT(0,CH)
	else I:= 80;
	end;
CHOUT(0,$7F&CH);
end;	\SHOWTITLE



proc	DUPDSK;
int	BLK, SIZE;
begin
BLK:= 0;
SIZE:= SIZE0;
loop	begin
	if MAXBLK-BLK < SIZE
		then SIZE:= MAXBLK -BLK;
	if SIZE = 0 then quit;

	FREAD(FROMUNIT, BLK, BUFFER, SIZE);

	NEWDISK(true);		\INSERT COPY DISK (IF NECESSARY)
	FWRITE(TOUNIT, BLK, BUFFER, SIZE);
	BLK:= BLK +SIZE;
	if BLK=MAXBLK then quit;
	NEWDISK(false);		\INSERT ORIGINAL DISK (IF NECESSARY)
	end;
end;	\DUPDSK



begin	\MAIN
SIZE0:= $00FF & SWAP(SPACE);	\GET SIZE IN BLOCKS (BEWARE OF >32767)
SIZE0:= SIZE0 -1;		\LEAVE A LITTLE SPACE TO WORK WITH (FOR SAFETY)
BUFFER:= RESERVE(SIZE0 *256);

TEXT(0,"-- DISK DUPLICATOR, V1.8x1 --
BUFFER: "); INTOUT(0,SIZE0); CRLF(0);

TEXT(0,"FROM, TO UNITS? ");
FROMUNIT:= INTIN(0);
TOUNIT:= INTIN(0);

TEXT(0,"HOW MANY BLOCKS? ");
MAXBLK:= INTIN(0);

loop	begin
	if TOUNIT#FROMUNIT then
		begin
		repeat	TEXT(0,"ABOUT TO OVERWRITE UNIT ");
			INTOUT(0,TOUNIT); CRLF(0);
			SHOWTITLE(TOUNIT); CRLF(0);
		until VERIFY;
		end
	else	begin
		TEXT(0,"INSERT ORIGINAL DISK");
		repeat until VERIFY;
		end;

	DUPDSK;
	TEXT(0,"ALL DONE. DUP ANOTHER DISK? ");
	OPENI(0);
	if (CHIN(0)!$20)#^y then quit;
	CRLF(0);
	end;
end;	\MAIN
