\replace exit command. Esc is hit accidently too often.
\show what the commands are.


\EDFONT.XPL	DEC-26-95
\Font editor by Loren Blaney

\REVISION HISTORY
\MAR-18-94, Original
\DEC-26-95, Modified for 11-point font using VGA text mode

inc	C:\CXPL\CODESI;		\Include code definitions for intrinsic routines

def	Points = 11;	\Font size in points. A 10-point font is 10 dots high.
def	FontSize = Points*256;
char	FontTable;

int	CpuReg,		\address of CPU registers
	PspSeg,		\address of PSP segment (for file I/O)
	DataSeg,	\address of data segment (heap & stack)
	II;		\scratch for Main

def	Nul=$00, Bel=$07, BS=$08, Tab=$09, LF=$0A, FF=$0C,	\Control chars
	CR=$0D, EOF=$1A, Esc=$1B, Sp=$20, Ctrl=$40;

def	UpArrow=$48, DnArrow=$50, LfArrow=$4B, RtArrow=$4D,	\Scan codes
	PageUp=$49, PageDn=$51, Home=$47, End=$4F, Insert=$52, Delete=$53,
	Func1=$3B;

def	Black, Blue, Green, Cyan, Red, Magenta, Brown, White,	\Attribute colors
	Gray, LBlue, LGreen, LCyan, LRed, LMagenta, Yellow, BWhite; \ EGA palette

\Global variables for DOS I/O routines:
int	InHandle,	\input file handle (= -1 if no input file)
	OutHandle;	\output file handle (= -1 if no output file)
addr	InFileName,	\input file name (all file names are zero terminated)
	OutFileName,	\output file name
	TmpFileName,	\temporary output file name (.$$$)
	BakFileName;	\backup output file name (.BAK)
def	NameSize=80;	\maximum number of chars in a file name (incl path)

\========================== DOS I/O ROUTINES ==========================

func	DosOpen(InExt, OutExt);	\Open MS-DOS files. Returns: 0 if no errors;
\ 1 if error opening input file; 2 if error opening output file.
addr	InExt, OutExt;	\input and output extensions
int	Inx;		\index into CmdLine
addr	CmdLine;	\command line tail


	proc	CopyName(From, To, Ext);
	\Copy file name and replace any existing extension with "Ext".
	\If "Ext" = "???" then use extension from "From".
	addr	From, To,	\strings are 0 terminated
		Ext;		\extension
	int	I, J, Ch;
	begin
	I:= 0;
	loop	begin				\copy file name
		Ch:= From(I);
		if Ch=^. ! Ch=0 then quit;
		To(I):= Ch;
		if I < NameSize-1 then I:= I +1;
		end;
	To(I):= ^.;				\copy extension
	if I < NameSize-1 then I:= I +1;
	for J:= 0, 2 do
		begin
		Ch:= Ext(J) & $7F;
		To(I):= if Ch=^? then From(I) else Ch;
		if I < NameSize-1 then I:= I +1;
		end;
	To(I):= 0;				\terminate string
	end;	\CopyName



	proc	GetName(Name);
	\Read file name from command line and return it in "Name".
	\The command line is terminated by a CR.
	addr	Name;
	int	I, Ch;


		proc	GetCh;	\Get character, stripping out switches
		begin
		loop	begin
			Ch:= CmdLine(Inx);
			Inx:= Inx +1;
			if Ch # ^/ then quit;
			Ch:= CmdLine(Inx);	\ignore any one-char switches
			Inx:= Inx +1;
			if Ch = CR then quit;	\handle wise guys
			end;
		end;	\GetCh


	begin	\GetName
	repeat GetCh until Ch # SP;		\skip any leading spaces
	I:= 0;
	loop	begin
		case Ch of SP, CR, ^,: Ch:= 0 other; \terminate Name with 0
		Name(I):= Ch;
		if Ch = 0 then quit;
		if I < NameSize-1 then I:= I +1;
		GetCh;
		end;
	end;	\GetName


begin	\DosOpen
CmdLine:= Reserve($7F);			\get command tail from PSP
Blit(PspSeg, $81, DataSeg, CmdLine, $7F);
CmdLine($7E):= CR;			\make sure it's terminated with a CR

InHandle:= -1;   OutHandle:= -1;	\set to illegal values

Inx:= 0;
if InExt(0) # SP then
	begin				\get the input file name
	GetName(InFileName);
	CopyName(InFileName, InFileName, InExt);

	Trap(false);
	InHandle:= Fopen(InFileName, 0);
	Trap(true);
	if Geterr # 0 then		\file or path does not exist,
		[InHandle:= -1;   return 1]; \ SHARE conflict, etc.
	Fset(InHandle, ^I);
	end;

if OutExt(0) # SP then
	begin				\get the output file name
	if Inx > 0 then Inx:= Inx -1;	\backup in case of CR
	GetName(OutFileName);
	if OutFileName(0) =0 then	\if no outfile then use the infile
		CopyName(InFileName, OutFileName, OutExt)
	else	CopyName(OutFileName, OutFileName, OutExt);

	CopyName(OutFileName, TmpFileName, "$$$");
	CopyName(OutFileName, BakFileName, "BAK");

	Trap(false);
	OutHandle:= Fopen(TmpFileName, 1);
	Trap(true);
	if Geterr # 0 then		\path does not exist, file already exists
		[OutHandle:= -1;   return 2]; \ root directory full, etc.
	Fset(OutHandle, ^O);
	end;

return 0;				\no errors
end;	\DosOpen

\----------------------------------------------------------------------

func	DosClose;	\Close MS-DOS files. Returns: 0 if no errors;
\ 1 if error closing input file; 2 if error closing output file.
begin
if InHandle # -1 then
	begin
	Trap(false);
	Fclose(InHandle);
	Trap(true);
	if Geterr # 0 then return 1;
	end;

if OutHandle # -1 then
	begin
	Trap(false);
	Fclose(OutHandle);

	CpuReg(\AX\0):= $4100;		\DEL OutFileName.BAK
	CpuReg(\DS\9):= DataSeg;
	CpuReg(\DX\3):= BakFileName;
	Softint($21);			\(.BAK file might not exist)

	CpuReg(\AX\0):= $5600;		\REN OutFileName.EXT OutFileName.BAK
	CpuReg(\DS\9):= DataSeg;
	CpuReg(\DX\3):= OutFileName;
	CpuReg(\ES\11):= DataSeg;
	CpuReg(\DI\4):= BakFileName;
	Softint($21);

	CpuReg(\AX\0):= $5600;		\REN OutFileName.$$$ OutFileName.EXT
	CpuReg(\DS\9):= DataSeg;
	CpuReg(\DX\3):= TmpFileName;
	CpuReg(\ES\11):= DataSeg;
	CpuReg(\DI\4):= OutFileName;
	Softint($21);

	Trap(true);
	if Geterr # 0 then return 2;	\disk write error when flushing buffers
	end;

return 0;				\no errors
end;	\DosClose

\======================================================================

func	CallInt(Int, AX, BX, CX, DX, BP, DS, ES); \Call software interrupt
int	Int, AX, BX, CX, DX, BP, DS, ES; \(Unused arguments need not be passed)
begin
Cpureg:= Getreg;
Cpureg(0):= AX;
Cpureg(1):= BX;
Cpureg(2):= CX;
Cpureg(3):= DX;
Cpureg(6):= BP;
Cpureg(9):= DS;
Cpureg(11):= ES;
Softint(Int);
return Cpureg(0);		\return AX register
end;	\CallInt



func	Rol(N, C);		\Rotate byte N left C bits
int	N, C;
return N<<C ! N>>(8-C);



func	Ror(N, C);		\Rotate byte N right C bits
int	N, C;
return N>>C ! N<<(8-C);



func	SwapBits(N);		\Swap the order of the bits in N
int	N;
int	B, M;
begin
B:= 1;   M:= 0;
while N\#0\ do
	begin
	if N < 0 then M:= M +B;	\Or bit into M if MSB of N is set
	B:= B +B;		\Shift left
	N:= N +N;
	end;
return	M;
end;	\SwapBits



func	ShiftKey;		\Returns 'true' if a shift key is down
return (CallInt($16, $0200) & $03) # 0;	\Function $02



func	GetKey;		\Get character from keyboard (wait if necessary)
int	SC, Ch;			\This is a low-level routine with no echo,
begin				\ no Ctrl-C, and no cursor.
SC:= CallInt($16, $0000);	\Function $00
Ch:= SC & $FF;
if Ch = 0 then Ch:= -(SC>>8);	\Return non-ascii chars as negative scan code
return Ch;
end;	\GetKey



func	GetCurShape;	\Get cursor shape
begin
CallInt($10, $0300);		\Function $03
return Cpureg(2);
end;	\GetCurShape



proc	SetCurShape(Shape);	\Set cursor shape
\WARNING: $0607 does not work for monochrome mode 7. Use $0B0C instead.
\ $000D gives a solid block for all modes.
int	Shape;
CallInt($10, $0100, 0, Shape);	\Function $01



proc	ShowCursor(On);	\Turn flashing cursor off and on
int	On;	\Flag: True = cursor on; False = cursor off
int	CS;	\Own-type variable to save original cursor shape
begin
CS:= [$000D];	\Default is solid block
if On then SetCurShape(CS(0))
else	[CS(0):= GetCurShape;
	SetCurShape($2000)];
end;	\ShowCursor



proc	Ctxt(X, Y, Str);	\Display a string on device 6 at X, Y
int	X, Y;
char	Str;
begin
Cursor(X, Y);
Text(6, Str);
end;	\Ctxt



proc	RCtxt(X, Y, Str);	\Display a string of raw text at X, Y
int	X, Y;
char	Str;
begin
Cursor(X, Y);
RawText(6, Str);
end;	\RCtxt



proc	Hex2out(Dev, N);	\Output two hex digits (a byte)
int	Dev, N;
char	HexDigit;
begin
HexDigit:= "0123456789ABCDEF ";
Chout(Dev, HexDigit(N>>4 & $0f));
Chout(Dev, HexDigit(N & $0f));
end;	\Hex2out

\==============================================================================

proc	ShowChars(Atb);	\Show all of the characters using specified attribute
int	Atb;
int	Ch;
begin
Attrib($00);
Text(6, "        ");
Attrib(Atb);
for Ch:= 0, 255 do
	begin
	case Ch of
	  CR,LF:  Chout(6, ^.)
	other Chout(6, Ch);
	if (Ch&$3f) = $3f then
		[Crlf(6);
		Attrib($00);
		Text(6, "        ");
		Attrib(Atb)];
	end;
Crlf(6);
end;	\ShowChars

\------------------------------------------------------------------------------

proc	Edit;		\Edit character fonts
int	Ch,		\selected character
	I, J,		\scratch
	Xc, Yc,		\coordinates in character selection table
	X, Y,		\coordinates in big edit box
	Byte,
	Done,		\flag: quit font edit loop
	Key;		\key command for editing
char	Copy;		\copy of character font (in case of abort--Esc)
def	X0=30, Y0=10;		\Coords for big character
def	X1= 8, Y1= 5;		\Coords for little characters
begin
Copy:= Reserve(Points);

Xc:= 0;  Yc:= 0;
loop	begin
	Cursor(0, 0);
	ShowChars(Blue<<4+BWhite);	\show sample chars on two backgrounds
	ShowChars(Black<<4+White);

	\Show command menu:
	Attrib(Black<<4+White);
	Ctxt(5, Y0+4, "Move:   ");  Chout(6, $1b);	\arrows in 4 directions
	Chout(6, Sp); Chout(6, $1a);
	Chout(6, Sp); Chout(6, $18);
	Chout(6, Sp); Chout(6, $19);
	Ctxt(5, Y0+5, "Change: Space");
	Ctxt(5, Y0+6, "Shift:  Sh- ");  Chout(6, $1b);
	Chout(6, Sp); Chout(6, $1a);
	Chout(6, Sp); Chout(6, $18);
	Chout(6, Sp); Chout(6, $19);
	Ctxt(5, Y0+7, "Mirror: Tab");
	Ctxt(5, Y0+8, "Save:   Enter");
	Ctxt(5, Y0+9, "Exit:   Esc");

	\Show test patterns:
	Ctxt(54, 12, "PACK MY BOX WITH FIVE");
	Ctxt(54, 13, "DOZEN LIQUOR JUGS.  ");
	Ctxt(54, 14, "pack my box with five");
	Ctxt(54, 15, "dozen liquor jugs.  ");
	RCtxt(54,16, "ĿĪ͸ ");
	RCtxt(54, 17,"^P/\^\^[=-߱ ");
	RCtxt(54, 18,"Ĵ=_͵ ");
	RCtxt(54, 19,"  ; ");
	RCtxt(54, 20,"ķ | ͻ ");
	RCtxt(54, 21,"+-= _   ݺ ");
	RCtxt(54, 22,"Ķ ^Y ͹ ");
	RCtxt(54, 23,"Ľ  ͼ ");

	\Show prompt:
	Attrib(Blue<<4+BWhite);
	Ctxt(5, Y0+1, " Select Character ");

	loop	begin
		Ch:= Xc + Yc*64;
		Attrib(LRed<<4+BWhite);		\Show cursor
		Cursor(X1+Xc, Y1+Yc);  Chout(6, Ch);

		Key:= GetKey;

		Attrib(Black<<4+White);
		Cursor(X1+Xc, Y1+Yc);  Chout(6, Ch);

		case Key of
		  -LfArrow:	Xc:= (Xc - (if ShiftKey then 8 else 1)) & $3F;
		  -RtArrow:	Xc:= (Xc + (if ShiftKey then 8 else 1)) & $3F;
		  -UpArrow:	[Yc:= Yc -1;  if Yc<0 then Yc:= 4-1];
		  -DnArrow:	[Yc:= Yc +1;  if Yc>=4 then Yc:= 0];
		  CR,Sp:	quit;
		  Esc:		return
		other	if Key>=0 & Key<=255 then
			    [Ch:= Key;  Xc:= Ch&$3F;  Yc:= Ch>>6;  quit]
			else Sound(1, 2, 1190);
		end;

	Attrib($00);		\Clear "Select Character" message
	Ctxt(5, Y0+1, "                  ");

	\Do actual editing
	\Save a copy of the font for the selected char in case of abort (=Esc)
	for J:= 0, Points-1 do Copy(J):= FontTable(Ch*Points+J);

	X:= 0;  Y:= 0;
	Done:= false;
	loop	begin			\font edit loop
		\Show small character and its hex value
		Attrib(Black<<4+White);  Cursor(X0+16+3, Y0);
		Chout(6, ^$);  Hex2out(6, Ch);
		Attrib(Blue<<4+BWhite);
		Cursor(X0+16+4, Y0+1);  Chout(6, Ch);

		\Display big image (8xPoints)
		for J:= 0, Points-1 do
			begin
			Byte:= FontTable(Ch*Points+J);
			Cursor(X0, Y0+J);
			for I:= 0, 7 do
				begin
				if Byte & $80>>I then
					[Chout(6, ^);  Chout(6, ^)]
				else	[Chout(6, ^.);  Chout(6, ^ )];
				end;
			end;

		\Show cursor
		Attrib(Blue<<4+LRed);
		Cursor(X0+X+X, Y0+Y);  Chout(6, ^);

		Key:= GetKey;

		Attrib(Blue<<4+BWhite);
		Cursor(X0+X+X, Y0+Y);
		if FontTable(Ch*Points+Y) & $80>>X then
			Chout(6, ^)
		else	Chout(6, ^.);

		case Key of
		  -LfArrow:
			if ShiftKey then
			  for J:= 0, Points-1 do
			    FontTable(Ch*Points+J):= Rol(FontTable(Ch*Points+J), 1)
			else X:= (X -1) & 7;
		  -RtArrow:
			if ShiftKey then
			  for J:= 0, Points-1 do
			    FontTable(Ch*Points+J):= Ror(FontTable(Ch*Points+J), 1)
			else X:= (X +1) & 7;
		  -UpArrow:
			if ShiftKey then
			  [I:= FontTable(Ch*Points);
			  for J:= 0, Points-2 do
			    FontTable(Ch*Points+J):= FontTable(Ch*Points+J+1);
			  FontTable(Ch*Points+Points-1):= I]
			else [Y:= Y -1;  if Y<0 then Y:= Points-1];
		  -DnArrow:
			if ShiftKey then
				[I:= FontTable(Ch*Points+Points-1);
				for J:= -(Points-1), -1 do
				  FontTable(Ch*Points-J):= FontTable(Ch*Points-J-1);
				FontTable(Ch*Points):= I]
			else	[Y:= Y +1;  if Y>=Points then Y:= 0];
		  SP:	begin
			FontTable(Ch*Points+Y):= FontTable(Ch*Points+Y) | ($80>>X);
			end;
		  Tab:	for J:= 0, Points-1 do
			  FontTable(Ch*Points+J):= Swap(SwapBits(FontTable(Ch*Points+J)));
		  CR:	Done:= true;
		  Esc:	[for J:= 0, Points-1 do 		\discard
				FontTable(Ch*Points+J):= Copy(J);
			Done:= true]
		other;

		\Change font that is displayed on the screen:
		CallInt($10, $1110,	\set up font
			Points<<8,	\bytes per char (height in pixels = points), block =0
			1,		\only one char in table
			Ch,		\char's ascii code (NUL)
			FontTable+Ch*Points, 0, DataSeg);

		SetCurShape($2000);	\compensate for BIOS bug

		if Done then quit;
		end;			\font edit loop
	end;
end;	\Edit

\==============================================================================

begin	\Main
CpuReg:= Getreg;
PspSeg:= CpuReg(11);
DataSeg:= CpuReg(12);

FontTable:= Reserve(FontSize);

InFileName:= Reserve(NameSize);
OutFileName:= Reserve(NameSize);
TmpFileName:= Reserve(NameSize);
BakFileName:= Reserve(NameSize);

case DosOpen("FNT", "FNT") of
\case DosOpen("F10", "FNT") of
  1:	[Text(0, "Cannot open input file");  exit];
  2:	[Text(0, "Cannot open output file");  exit]
other;

\Load font from file
Openi(3);
for II:= 0, FontSize-1 do
	begin
	FontTable(II):= Chin(3);
\	FontTable(II):= if Rem(II/11) = 10 then 0 else Chin(3); \\load F10 font
	end;

if (CallInt($10, $1202, $30) &$00ff) # $12 then	\400 scan lines
	[Text(0, "VGA required.");   exit];

Setvid($03);		\VGA text mode

CallInt($10, $1110,	\set up font
	Points<<8,	\bytes per char (height in pixels = points), block =0
	256,		\number of chars in table
	0,		\first char's ascii code (NUL)
	FontTable, 0, DataSeg);

ShowCursor(false);

Edit;

Chout(0, FF);		\clear screen
ShowCursor(true);

\Write the font table to the output file
Openo(3);
for II:= 0, FontSize-1 do
	begin
	Chout(3, FontTable(II));
	end;
Close(3);

case DosClose of
  1:	Text(0, "Cannot close input file");
  2:	Text(0, "Cannot close output file")
other;
end;	\Main
