 \Fireflys.XPL	11/15/93		Richard Ottosen
\This program simulates the synchronized flashing of fireflies.


include C:\cxpl\CODESI.XPL;

def	BS=$08, Tab=$09, FF=$0C, CR=$0D, EOF=$1A, Esc=$1B, SP=$20; \ASCII chars
def	Up=$48, Dn=$50, Lt=$4B, Rt=$4D, Home=$47;		\Scan codes

def	False= 0, True= -1;

def	Height= 22, Width= 26;		\Firefly array size
def	FullCycle= 100;			\Number of phases in a full osc. cycle

int	CPUREG, DATASEG;

int	Dev, Dummy;
int	Exit, Period, CurX, CurY, X, Y, ListEnd;

real	RMS;

int \array\ Speed, Fly, Phase, Rate, Level, ListX, ListY;


proc Delay;
int DI;
begin
for DI:= 0, Period do [];
end;


proc	Print(String);
int	String;
begin
Text(Dev,String);
end;	\Print


proc	PrintR(String);
int	String;
begin
Text(Dev,String);	CRLF(Dev);
end;	\PrintR


proc	DoTab;
begin
PRINT("	");
end;


proc	Underline;
begin
PrintR("-----------------------------------------------------------------------------");
end;


proc	DoubleLine;
begin
PrintR("=============================================================================");
end;


proc	DottedLine;
begin
Text(0,":::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::");
end;


proc	Box(X, Y, W, H);	\Draw a rectangle using graphic chars
int	X, Y, W, H;		\ with upper-left corner at X, Y
int	I;			\The minimum width (W) & height (H) is 2
begin
Cursor(X, Y);	ChOut(0, ^);		\Draw top line with brackets
for I:= 1, W-2 do ChOut(0, ^);
ChOut(0, ^);
for I:= 1, H-2 do			\Draw sides
	[Cursor(X, Y+I);   ChOut(0, ^);
	Cursor(X+W-1, Y+I);   ChOut(0, ^)];
Cursor(X, Y+H-1);   Chout(0, ^);	\Draw bottom line with brackets
for I:= 1, W-2 do ChOut(0, ^);
ChOut(0, ^);
end;	\Box


proc	NumOut(N);
real	N;
begin
RlOut(Dev,N);
end;	\NumOut


proc	Place(X,Y, Whole, Decimal, Prompt, Default, Units);
int X,Y,Whole,Decimal,Prompt;  real Default;  int Units;
begin
Format(Whole,Decimal); Cursor(X,Y);
Print(Prompt); RlOut(Dev,Default); Print(Units);
Format(5,3);
end;	\Place


proc	Output(X,Y, Whole, Decimal, Prompt, Default, Units);
int X,Y,Whole,Decimal,Prompt;  real Default;  int Units;
begin
Format(Whole,Decimal);
Print(Prompt); RlOut(Dev,Default); PrintR(UNITS);
Format(5,3);
end;	\Output


proc	AnyKey;
begin
if Dev =0 ! Dev =1 then
	[Cursor(0,23);
\	DoubleLine;
	DottedLine;
	Cursor(0,24); Text(0,"Hit any key to continue.");
\	CRLF(0);
	OpenI(1); Dummy:= ChIn(1);
	];
end;


proc	Yes(Question);
int	Question;
int	Dummy, Char;
begin
Cursor(0,23);
\DoubleLine;
DottedLine;
Cursor(0,24);	\Clear a line
Text(0,"								");
Cursor(0,24);
Text(0,Question); ChOut(0,BS);
OpenI(0);
Dummy:= CR;
repeat
	Char:= Dummy;
	Dummy:= ChIn(1);
	if Dummy #CR then [ChOut(0, Dummy); ChOut(0,BS);];
until Dummy =CR;
if (Char =^Y) ! (Char =^y) then
	return True else return False;
end;


proc	ShowTitle;
begin
ChOut(0, FF);
PrintR("             ==============================================");
PrintR("             =                                            =");
PrintR("             =          Firefly flash simulator           =");
PrintR("             =            By Richard Ottosen              =");
PrintR("             =                                            =");
PrintR("             =                                            =");
PrintR("             =     See Scientific American Magazine       =");
PrintR("             =       ?????????? 1993 pages ???? and ???   =");
PrintR("             =                                            =");
PrintR("             =                                            =");
PrintR("             =     Use the cursors to select Firefly.     =");
PrintR("             =     - - - - - - - - - - - - - - - - -      =");
PrintR("             =     F = Turn a Fly on or off here.         =");
PrintR("             =     P = Set the oscillator phase.          =");
PrintR("             =     R = Set the oscillator rate.           =");
PrintR("             =                                            =");
PrintR("             =                                            =");
PrintR("             =     S = Start and Stop simulation.         =");
PrintR("             =                                            =");
PrintR("             =     Use ? key to get this screen again.    =");
PrintR("             =                                            =");
PrintR("             =     Use the ESC key to exit the program.   =");
PrintR("             =                                            =");
PrintR("             ==============================================");
OpenI(0); Dummy:= Chin(0);
ChOut(0,FF);
end;	\ShowTitle


proc CalcExp;	\Precalculate an exponential table
int P;
begin
for P:= 0, FullCycle do
Level(P):= FullCycle -Fix(Exp(-(Float(P) /Float(FullCycle))) *Float(FullCycle));
\                               --------  ----------------   -----------------
\                              ----------------------------
\                            -------------------------------
end; \CalcExp


proc ShowFlies;
int SX, SY;
begin
ChOut(0,FF);
for SX:= 0, Width -1 do
	for SY:= 0, Height -1 do
		[Cursor(SX *3, SY);
		if Fly(SX, SY) = ^* then ChOut(0, ^*)
			else ChOut(0, ^.);
		];		
CurX:= Width /2; CurY:= Height /2;
end;	\ShowFlies


proc Flash (X,Y);
int FX, FY;
int FI;
real XX, YY, Distance, Fire;
begin
Phase(FX, FY):= Phase(FX, FY) +1;  

Fire:= 0.0;
for FI:= 0, ListEnd do
    if Fly(ListX(FI), ListY(FI)) =^* then \if firefly is flashing... 
	[XX:= Float(Abs(ListX(FI) -FX));  YY:= Float(Abs(ListY(FI) -FY));
	Distance:= SqRt(XX *XX + YY *YY);
	if Distance >0.0 then Fire:= Fire + 1.0 /Distance;
	];
if Level(Phase(FX, FY)) + Fix(Fire) *10 > Rate(FX, FY)
	 then Phase(FX, FY):= 0;

if Phase(FX, FY) < 7 then Fly(FX, FY):= ^* else Fly(FX, FY):= SP ;
Cursor(FX *3, FY); ChOut(0, Fly(FX, FY));
Cursor(0,Height +2); Dotab; Dotab;
Cursor(0,Height +2); Intout(0,Phase(FX,FY));
end; \Flash

proc Makelist;		\Make a list of all the fireflies that are active
int MX, MY, L;
begin
L:= 0;
for MX:= 0, Width -1 do
	for MY:= 0, Height -1 do
		[if Fly(MX, MY) = ^* then	\ListX and ListY hold the
			[ListX(L):= MX;		\ coordinates of active
			ListY(L):= MY;		\ fireflies
			L:= L +1;			
			];
		];		
ListEnd:= L -1;
end; \Makelist


proc	Simulate;
int	L;
begin
MakeList;
	loop begin
	for L:= 0, ListEnd do
		Flash(ListX(L), ListY(L));
	Delay;
	
	if ChkKey then
		[for L:= 0, ListEnd do 	\Light all the fireflies
			Fly(ListX(L), ListY(L)):= ^*;
		 quit;
		];
	end; \loop
end;	\Simulate


proc Status;	\Show information for the firefly under cursor
begin
Cursor(0, Height +2);
DoTab; DoTab;
Cursor(10, Height +2); Print("Firefly is at: "); IntOut(0,CurX);
  Print(", "); IntOut(0,CurY); Print("	    ");
Cursor(36, Height +2); Print("Phase is: "); IntOut(0, Phase(CurX, CurY));
  Print("%"); DoTab;
Cursor(52, Height +2); Print("Rate is: "); IntOut(0, Rate(CurX, CurY));
  Print(" per minute"); DoTab;
Cursor(CurX *3, CurY); Chout(0, Fly(CurX, CurY));
end;	\Status


proc SetFlies;		\Let user cursor around to set up firefly conditions
int SX,SY;
begin
	case ChIn(1) of
	  Up:		begin
			CurY:= CurY -1;
			if CurY< 0 then CurY:= 0;
			end;
	  Dn:		begin
			CurY:= CurY +1;
			if CurY> Height -1 then CurY:= Height -1;
			end;
	  Lt:		begin
			CurX:= CurX -1;
			if CurX< 0 then CurX:= 0;
			end;
	  Rt:		begin
			CurX:= CurX +1;
			if CurX> Width -1 then CurX:= Width -1;
			end;
	  Home:		begin
			CurX:= Width /2; CurY:= Height /2;
			end;
	  ^F, ^f:	begin
			if Fly(CurX, CurY) = ^* then Fly(CurX, CurY):= ^.
				else Fly(CurX, CurY):= ^*;
			Cursor(CurX *3, CurY);
			end;
	  ^P, ^p:	begin
			Cursor(36, Height +1);
			Phase(CurX, CurY):= IntIn(0);
			Cursor(36, Height +1); DoTab; DoTab;
			end;
	  ^R, ^r:	begin
			Cursor(52, Height +1);
			Rate(CurX, CurY):= IntIn(0);
			Cursor(52, Height +1); DoTab; DoTab;
			end;
	  ^?, ^/:	begin
			ShowTitle;
			ShowFlies;
			end;
	
	  ^S, ^s:	begin
	  		Cursor(0,Height +2); Print("				");
			Simulate;
			ShowFlies;
			end;

	  ESC:		Exit:= True
	other;		\ignore

	Status;
end;	\SetFlies


proc	Testflies;		\Add some more flies
begin
CurX:= Width /2 -3; CurY:= Height /2 -1;
Fly(CurX, CurY):= ^*; Rate(CurX, CurY):= 59;
Cursor(CurX *3, CurY); ChOut(0, ^*); Cursor(CurX *3, CurY);
CurX:= Width /2 -4; CurY:= Height /2 +3;
Fly(CurX, CurY):= ^*; Rate(CurX, CurY):= 61;
Cursor(CurX *3, CurY); ChOut(0, ^*); Cursor(CurX *3, CurY);
end;	\Testflies


proc	Initialize;
int	IX, IY;
begin
CalcExp;			\Make an exponential lookup table
ChOut(0,FF);
for IX:= 0, Width -1 do		\Initialize the firefly arrays
	for IY:= 0, Height -1 do
		[Fly(IX, IY):= ^.;
\***		Phase(IX, IY):= 0;
		Phase(IX, IY):= Ran(FullCycle);
		Rate(IX, IY):= 60;
		Cursor(IX *3, IY); ChOut(0, ^.);
		];		
CurX:= Width /2; CurY:= Height /2;	\Start with a single firefly
Fly(CurX, CurY):= ^*;			\ in the center of the screen
Cursor(CurX *3, CurY); ChOut(0, ^*); Cursor(CurX *3, CurY); \ and show it
Testflies;
end;


begin	\MAIN ============================================================
DEV:= 0;
RMS:= SQRT(2.0);
Level:= Reserve(FullCycle *2);

\Set aside space for the firefly arrays
Fly:= Reserve(Width *2);
for X:= 0, Width -1 do Fly(X):= Reserve(Height *2);
Phase:= Reserve(Width *2);
for X:= 0, Width -1 do Phase(X):= Reserve(Height *2);
Rate:= Reserve(Width *2);
for X:= 0, Width -1 do Rate(X):= Reserve(Height *2);
ListX:= Reserve(Width *2 *Height *2); ListY:= Reserve(Width *2 *Height *2);

Format(3,2);

ShowTitle;		\Show credits screen and info

Initialize;		\Initialize things
Speed:= Equip;		\Get a rough measure of CPU speed for timing uses
Period:= Fix(Float(Speed(3)) *1.8);	\Multiplier arrived at by measurment

Status;			\Show status for an individual firefly
Exit:= False;		\Don't quit yet
loop begin
SetFlies;		\Let the user set the fireflies starting states
if Exit then quit	\Exit from the program
end;	\loop

end;	\MAIN
