\FITLINE.XPL	MAR-15-99

inc	\CXPL\CODESI;

real	Slope,		\Slope of straight line from FitLine procedure
	Intercept;	\Intercept of straight line from FitLine procedure



proc	FitLine(N, X, Y);
\Fit a straight line to the X,Y coordinate pairs and return its slope and intercept
\This uses Gauss's method of least squares
int	N;	\Number of coordinates in arrays
real	X, Y;	\Arrays of coordinate pairs
int	I;
real	Sum, XMean, YMean, Temp;
begin
Sum:= 0.0;
for I:= 0, N-1 do
	Sum:= Sum + X(I);
XMean:= Sum / Float(N);

Sum:= 0.0;
for I:= 0, N-1 do
	Sum:= Sum + Y(I);
YMean:= Sum / Float(N);

Sum:= 0.0;
for I:= 0, N-1 do
	Sum:= Sum + (X(I) - XMean)*(Y(I) - YMean);
Temp:= Sum;

Sum:= 0.0;
for I:= 0, N-1 do
	Sum:= Sum + (X(I) - XMean)*(X(I) - XMean);

Slope:= Temp / Sum;

Intercept:= YMean - Slope*XMean;
end;	\FitLine



begin	\Main
FitLine(3, [2.0, 4.0, 6.0], [2.5, 4.5, 6.5]);
Rlout(0, Slope);
Rlout(0, Intercept);
Crlf(0);

FitLine(3, [2.0, 4.0, 6.0], [2.5, 3.5, 6.5]);
Rlout(0, Slope);
Rlout(0, Intercept);
Crlf(0);

Trap(false);
FitLine(1, [2.0], [2.5]);
Rlout(0, Slope);
Rlout(0, Intercept);
Crlf(0);

FitLine(3, [2.0, 4.0, 6.0], [-2.5, -4.5, -6.5]);
Rlout(0, Slope);
Rlout(0, Intercept);
Crlf(0);

FitLine(2, [2.0, 4.0], [0.0, 4.0]);
Rlout(0, Slope);
Rlout(0, Intercept);
Crlf(0);
end;	\Main
