\FIX.XPL
\PROGRAM TO HELP FIX A BAD DIRECTORY

code
ABS=0,         RAN=1,        REM=2,
RESERVE=3,     SWAP=4,       EXTEND=5,
REBEGIN=6,     CHIN=7,       CHOUT=8,
CRLF=9,        INTIN=10,     INTOUT=11,
TEXT=12,       OPENIN=13,     OPENOUT=14,
CLOSE=15,      ABORT=16,     TRAP=17,
SPACE=18,      RERUN=19,     GETSP=20,
SETSP=21,      ERRFLG=22,    CURSOR=23,
SETRUN=25,     FGET=26,      FASAVE=27,
FRUN=28,       FSAVE=29,     FWRITE=30,
FREAD=31,      FRESTOR=32;



address
	BLOCK;	\HOLD WORKING BLOCK;

integer
	ODEV,		\CURRENT OUTPUT DEVICE
	POINTER,	\BLOCK POINTER
	NUM,	\GLOBAL NUMBER
	CHAR,	\GLOBAL CHARACTER
	BINFLG,	\FLAG BINARY BLOCKS
	FNUM,	\HOLDS FILE NUMBER
	OLDZ,	\FLAGS CTZ IN LAST BLOCK
	ZFLG,	\FLAG SCAN TERMINATED WITH CTZ
	FLAG,	\STATE OF CURRENT BLOCK
	START,	\START OF CURRENT SEGMENT
	OLDFLG,	\STATE OF LAST BLOCK
	DSIZE,	\DISK SIZE
	UNIT,	\WORKING UNIT
	FSIZE,	\SMALLEST FILE TO PRINT
	BLKNUM;	\WORKING BLOCK NUMBER


def
	NULL,	\STARTING CONDITION
	ASCII,	\FLAG ASCII
	BINARY;	\FLAG BINARY


def
	FF=$0C,	\FORM FEED
	CR=$0D,	\END OF LINE
	CTZ=26;	\END OF FILE



procedure GETC;
CHAR:=CHIN(0);



procedure NUMERIC;
integer DUMMY;
return CHAR>=^0 & CHAR<=^9;



procedure NUMBER;
integer I,ADD;



procedure HEX;
integer DUMMY;
return NUMERIC ! (CHAR>=^A & CHAR<=^Z);



begin
I:=0;
while HEX do
	begin
	if CHAR<^A then ADD:=CHAR-^0
	else ADD:=CHAR-^A+10;
	I:=I*16+ADD;
	GETC;
	end;
return I;
end;



procedure HEXCHAR(C);
integer C;
if C<10 then CHOUT(ODEV,^0+C)
	else CHOUT(ODEV,^A+C-10);


procedure BYTEOUT(B);
integer B,R;
begin
B:=B&$FF;
B:=B/16;
R:=REM(0);
HEXCHAR(B);
HEXCHAR(R);
end;


procedure WORDOUT(W);
integer W;
begin
BYTEOUT(SWAP(W));
BYTEOUT(W);
end;



procedure SLINE(S);
address S;
TEXT(0,S);


procedure CLINE(S);
address S;
[SLINE(S);CRLF(0);];




procedure WAIT;
integer DUM;
begin
CLINE("HIT RETURN TO CONTINUE");
OPENIN(0);
DUM:=CHIN(0);
end;



procedure GETBLKN;
integer X;
begin
OPENIN(0);
X:=INTIN(0);
while X<0 ! X>=DSIZE do
	begin
	CLINE("OUT OF RANGE");
	OPENIN(0);
	X:=INTIN(0);
	end;
return X;
end;



procedure NEWBLK;
begin
SLINE("ENTER BLOCK NUMBER ");
BLKNUM:=GETBLKN;
end;



procedure GETPARM;
integer DUM;
begin
CHOUT(0,FF);
SLINE("UNIT= ");INTOUT(0,UNIT);CRLF(0);
SLINE("SIZE= ");INTOUT(0,DSIZE);CRLF(0);
SLINE("CHANGE? ");
if CHIN(0)=^Y then
	begin
	SLINE("ENTER UNIT ");
	UNIT:=INTIN(0);
	SLINE("ENTER SIZE ");
	DSIZE:=INTIN(0);
	GETPARM;
	end;
CHOUT(0,FF);
end;



procedure READBLK;
begin
TRAP(false);
FREAD(UNIT,BLKNUM,BLOCK,1);
TRAP(true);
if ERRFLG then
	begin
	SLINE("UNABLE TO READ BLOCK NUMBER ");
	INTOUT(0,BLKNUM);
	CRLF(0);
	end;
end;


procedure SCAN;
integer X;
begin
X:=0;
OLDZ:=ZFLG;
ZFLG:=false;
loop
	begin
	if BLOCK(X)&$80 then
		begin
		FLAG:=BINARY;
		quit;
		end;
	if BLOCK(X)=CTZ then
		begin
		FLAG:=ASCII;
		ZFLG:=true;
		quit;
		end;
	if X=255 then
		begin
		FLAG:=ASCII;
		quit;
		end;
	X:=X+1;
	end;
end;



procedure FILENUM;
begin
SLINE("FILE # ");
INTOUT(0,FNUM);
SLINE(" ");
FNUM:=FNUM+1;
end;



procedure ENDBLK;
integer DUMMY;
return if ZFLG then BLKNUM else BLKNUM-1;



procedure TERMASC;
begin
if FSIZE>(ENDBLK-START) then [START:=ENDBLK+1;return];
SLINE("ASCII  ");
FILENUM;
INTOUT(0,ENDBLK-START+1);SLINE(" ");
;INTOUT(0,START);
SLINE("-");INTOUT(0,ENDBLK);
if not ZFLG then SLINE(" NO EOF");
CRLF(0);
START:=ENDBLK+1;
end;

procedure TERMBIN;
begin
if not BINFLG then
	[START:=BLKNUM;return];
if FSIZE>(BLKNUM-START) then
	[START:=BLKNUM;return];
SLINE("BINARY ");
FILENUM;
INTOUT(0,BLKNUM-START);
SLINE(" ");
INTOUT(0,START);
SLINE("-");INTOUT(0,BLKNUM-1);
CRLF(0);
START:=BLKNUM;
end;


procedure FILEND;
begin
case of
OLDFLG=BINARY&FLAG=ASCII:
	begin
	TERMBIN;
	if ZFLG then TERMASC;
	end;
ZFLG: TERMASC;
(not OLDZ)&OLDFLG=ASCII&FLAG=BINARY: TERMASC
else;
end;


procedure MAP;

begin
FNUM:=1;
GETPARM;
SLINE("PRINT BINARYS? ");
BINFLG:=if CHIN(0)=^Y then true else false;
SLINE("MINIMUM FILE SIZE? ");
FSIZE:=INTIN(0);
START:=0;
OLDFLG:=NULL;
for BLKNUM:=0,DSIZE-1 do
	begin
	READBLK;
	SCAN;
	FILEND;
	OLDFLG:=FLAG;
	end;
if FLAG=ASCII then TERMASC else TERMBIN;
end;


procedure PASC(C);
integer C;
begin
case of
	C<$20:CHOUT(ODEV,^.);
	C>$7D & C<$A0:CHOUT(ODEV,^.)
	else CHOUT(ODEV,C);
end;



procedure DISBLK;
integer X,Y;
def WIDTH=8;
begin
CRLF(ODEV);CRLF(ODEV);
TEXT(ODEV,"^^^^^^^^^^^^^^^^^^^^");CRLF(ODEV);
TEXT(ODEV,"BLOCK NUMBER=");INTOUT(ODEV,BLKNUM);
CRLF(ODEV);
TEXT(ODEV,"^^^^^^^^^^^^^^^^^^^^");
CRLF(ODEV);CRLF(ODEV);
for X:=0,31 do
	begin
	for Y:=0,7 do
		begin
		BYTEOUT(BLOCK(8*X+Y));
		CHOUT(ODEV,^ );
		end;
	TEXT(ODEV," <> ");
	for Y:=0,7 do PASC(BLOCK(8*X+Y));
	CRLF(ODEV);
	end;
end;



procedure PRINT;
integer LBLK,FBLK;
begin
GETPARM;
SLINE("OUTPUT DEVICE");
ODEV:=INTIN(0);
OPENOUT(ODEV);
loop
	begin
	SLINE("FIRST BLOCK ");
	FBLK:=GETBLKN;
	SLINE("LAST BLOCK ");
	LBLK:=GETBLKN;
	for BLKNUM:=FBLK,LBLK do
		begin
		READBLK;
		DISBLK;
		end;
	SLINE("MORE? ");
	if CHIN(0)=^N then quit;
	end;
CHOUT(ODEV,CTZ);
CLOSE(ODEV);
ODEV:=0;
end;


procedure GETPOINTER;
begin
POINTER:=NUMBER;
while POINTER>256-1 ! POINTER<0 do
	begin
	SLINE("OUT OF BLOCK RANGE");
	POINTER:=NUMBER;
	end;
end;

procedure PRINT8;	\PRINT EIGHT BYTES OF BLOCK
integer X;
begin
WORDOUT(POINTER);CHOUT(0,^ );
for X:=0,7 do
	begin
	BYTEOUT(BLOCK(POINTER+X));CHOUT(0,^ );
	end;
CRLF(0);
end;


procedure MODIFY;
begin
PRINT8;
loop
	begin
	WORDOUT(POINTER);SLINE(" ");
	BYTEOUT(BLOCK(POINTER));SLINE(" ");
	OPENIN(0);
	GETC;
	case CHAR of
		^-:	if POINTER#0 then POINTER:=POINTER-1;
		CR:	if POINTER#256-1 then POINTER:=POINTER+1;
		^Q:	[SLINE("EXAMINE ");quit]
	else
		begin
		BLOCK(POINTER):=NUMBER;
		if POINTER#256-1 then POINTER:=POINTER+1;
		end;
	end;
end;

procedure EXAMINE;	\EXAMINE AND MODIFY MEMORY
begin
POINTER:=0;
SLINE("ADDRESS OR Q=QUIT,M=MODIFY,RETURN=NEXT ");CRLF(0);
SLINE("EXAMINE ");
loop
	begin
	OPENIN(0);
	GETC;
	case CHAR of
		CR:
		begin
		if (POINTER+8)<256 then POINTER:=POINTER+8;
		PRINT8;
		end;
		^M:	MODIFY;
		^Q:	quit
	else
	[GETPOINTER;PRINT8];
	end;
end;



procedure SWRITE;
begin
NEWBLK;
SLINE("WARNING!! WILL OVER WRITE SECTOR=");
INTOUT(0,BLKNUM);
CRLF(0);
if CHIN(0)#^Y then return;
FWRITE(UNIT,BLKNUM,BLOCK,1);
end;



procedure EDIT;
begin
GETPARM;
loop
	begin
	CLINE("***MENU***");
	CLINE("0) QUIT");
	CLINE("1) READ SECTOR");
	CLINE("2) EXAMINE OR MODIFY");
	CLINE("3) RE-WRITE SECTOR");
	CRLF(0);
	NUM:=INTIN(0);
	cases NUM of
		0:quit;
		1:[NEWBLK;READBLK];
		2:EXAMIN;
		3:SWRITE
	else;
	end;
end;



procedure BADBLK(UNIT);
integer UNIT,X,BSFLG;
begin
BSFLG:=false;
SLINE("BAD BLOCK: ");
CRLF(0);
CRLF(0);
for X:=0,DSIZE-1 do
	begin
	TRAP(false);
	FREAD(UNIT,X,BLOCK,1);
	TRAP(true);
	if ERRFLG then
		begin
		BSFLG:=true;
		CHOUT(0,^ );
		INTOUT(0,X);
		end;
	end;
if not BSFLG then
	begin
	SLINE("NO BAD BLOCKS");
	CRLF(0);
	end;
CRLF(0);
return BSFLG;
end;



procedure REPAIR;
integer UNIT,TRYS,SEC,RC,REWRITE;


proc RETRY;
begin
RC:=TRYS;
SLINE("BAD= ");INTOUT(0,SEC);
loop
	begin
	FREAD(UNIT,SEC,BLOCK,1);
	if not ERRFLG then
		begin
		FWRITE(UNIT,SEC,BLOCK,1);
		if ERRFLG then CLINE(" UNABLE TO WRITE")
		else CLINE(" FIXED");
		quit;
		end;
	RC:=RC-1;
	if RC<0 then
		begin
		CLINE(" unable TO FIX");
		quit;
		end;
	end;
end;


begin
SLINE("ENTER UNIT NUMBER? ");
UNIT:=INTIN(0);
SLINE("NUMBER OF RETRYS? ");
TRYS:=INTIN(0);
SLINE("REWRITE ALL SECTORS? Y/N ");
OPENIN(0);
REWRITE:=^Y=CHIN(0);
TRAP(false);

for SEC:=0,DSIZE-1 do
	begin
	FREAD(UNIT,SEC,BLOCK,1);
	if ERRFLG then RETRY
	else if REWRITE then FWRITE(UNIT,SEC,BLOCK,1);
	if ERRFLG then RETRY;
	end;

TRAP(true);
end;




procedure DRIVET;
address BUFFER;
integer TIMES,COUNT,SEC,TRACK,TUNIT;


procedure REDWRT;
begin
SLINE(" R ");
TRAP(false);
FREAD(TUNIT,TRACK,BUFFER,SEC);
TRAP(true);
if ERRFLG then SLINE("bad") else SLINE("OK");
FWRITE(TUNIT,TRACK,BUFFER,SEC);
SLINE(" W");
end;



begin

SLINE("UNIT NUMBER? ");
TUNIT:=INTIN(0);
SLINE("SECTOR PER TRACK? ");
SEC:=INTIN(0);
SLINE("TRACK NUMBER ");
TRACK:=INTIN(0)*SEC;
SLINE("NUMBER OF CYCLES? ");
TIMES:=INTIN(0);
CRLF(0);

BUFFER:=RESERVE(SEC*256);

CLINE("!!! THIS MAY erase");
SLINE("DRIVE=");INTOUT(0,TUNIT);
SLINE("  TRACK=");INTOUT(0,TRACK/SEC);
CRLF(0);

SLINE("ARE YOU SURE?? ");
OPENIN(0);
if CHIN(0)#^Y then return;


CHOUT(0,FF);
for COUNT:=1,TIMES do
	begin
	INTOUT(0,COUNT);
	REDWRT;
	CRLF(0);
	end;

end;



procedure SPEED;
address DRIVES;
integer X,SEC;


procedure TSTREAD(TUNIT);
integer TUNIT,BSFLG,X;
address BUFFER;
begin
BUFFER:=RESERVE(SEC*256);
BSFLG:=false;
SLINE("BAD BLOCK: ");
CRLF(0);
CRLF(0);
X:=0;
repeat
	begin
	TRAP(false);
	FREAD(TUNIT,X,BUFFER,SEC);
	TRAP(true);
	if ERRFLG then
		begin
		BSFLG:=true;
		CHOUT(0,^ );
		INTOUT(0,X);
		end;
	X:=X+SEC;
	end
until X>=DSIZE;
CRLF(0);
return BSFLG;
end;


procedure TEST;
begin
CHOUT(0,FF);
X:=0;
repeat
	begin
	SLINE("TESTING UNIT: ");
	INTOUT(0,DRIVES(X));
	CRLF(0);
	if TSTREAD(DRIVES(X)) then
		begin
		SLINE("BADBLOCKS ON UNIT");
		INTOUT(0,DRIVES(X));
		CRLF(0);
		CRLF(0);
		end
	else
		begin
		SLINE("NO BADBLKS ON UNIT: ");
		INTOUT(0,DRIVES(X));
		CRLF(0);
		end;
	X:=X+1;
	end
until DRIVES(X)=9;
end;


begin
DRIVES:=RESERVE(10);
SLINE("SECTOR PER TRACK? ");
SEC:=INTIN(0);
SLINE("UNIT SIZE? ");
DSIZE:=INTIN(0);
SLINE("ENTER UNIT NUMBERS, END WITH NINE");
CRLF(0);
X:=0;
loop
	begin
	SLINE("UNIT: ");
	DRIVES(X):=INTIN(0);
	if DRIVES(X)=9 then quit;
	X:=X+1;
	if X=10 then
		begin
		DRIVES(X-1):=9;
		quit;
		end;
	end;
repeat
	begin
	SLINE("PUT DISKS IN DRIVES-HIT RETURN");
	OPENIN(0);
	X:=CHIN(0);
	TEST;
	SLINE("MORE? ");
	end
until CHIN(0)=^N;
end;



procedure BCOPY;
integer X,FUNIT,TUNIT,SIZE;
address BUFFER;
begin
BUFFER:=RESERVE(256);
SLINE("FROM UNIT? ");
FUNIT:=INTIN(0);
SLINE("TO UNIT? ");
TUNIT:=INTIN(0);
SLINE("SIZE? ");
SIZE:=INTIN(0);
TRAP(false);
for X:=0,SIZE-1 do
	begin
	SLINE("BLOCK ");INTOUT(0,X);
	CRLF(0);
	FREAD(FUNIT,X,BUFFER,1);
	if ERRFLG then
		begin
		SLINE("UNABLE TO READ BLOCK ");
		INTOUT(0,X);CRLF(0);
		end
	else
		begin
		FWRITE(TUNIT,X,BUFFER,1);
		if ERRFLG then
			begin
			SLINE("UNABLE TO WRITE BLOCK ");
			INTOUT(0,X);
			CRLF(0);
			end;
		end;
	end;
TRAP(true);
end;



procedure BLKCOPY;
integer X,FUNIT,TUNIT,BEGSOR,ENDSOR,
BEGDES;
address BUFFER;
begin
BUFFER:=RESERVE(256);
SLINE("FROM UNIT? ");
FUNIT:=INTIN(0);
SLINE("TO UNIT? ");
TUNIT:=INTIN(0);
SLINE("START BLOCK OF SOURCE? ");
BEGSOR:=INTIN(0);
SLINE("END BLOCK OF DESTINATION? ");
ENDSOR:=INTIN(0);
SLINE("START BLOCK OF DESTINATION? ");
BEGDES:=INTIN(0);
WAIT;
for X:=BEGSOR,ENDSOR do
	begin
	FREAD(FUNIT,X,BUFFER,1);
	FWRITE(TUNIT,BEGDES,BUFFER,1);
	BEGDES:=BEGDES+1;
	end;
end;



procedure FIND;
integer FBLK,LBLK,TARGET,TARLEN,X;


procedure COMPARE(BPTR);
integer BPTR,TPTR;
begin
TPTR:=1;
loop
	begin
	if TPTR=TARLEN then return true;
	BPTR:=BPTR+1;
	if BLOCK(BPTR)#TARGET(TPTR) then return false;
	TPTR:=TPTR+1;
	end;
end;


procedure SEARCH;
integer X;
begin
for X:=0,255 do
if BLOCK(X)=TARGET(0) then
if COMPARE(X) then
	begin
	SLINE("MATCH AT BLOCK ");
	INTOUT(0,BLKNUM);
	SLINE(" BYTE NUMBER ");
	INTOUT(0,X);
	CRLF(0);
	end;
end;


begin
TARGET:=RESERVE(10);
GETPARM;
SLINE("FIRST BLOCK ");
FBLK:=GETBLKN;
SLINE("LAST BLOCK ");
LBLK:=GETBLKN;
CLINE("SEARCH STRING (IN HEX)");
SLINE("TERMINATE WITH RETURN");

OPENIN(0);
X:=0;
loop
	begin
	GETC;
	if CHAR=CR then quit;
	TARGET(X):=NUMBER;
	X:=X+1;
	if X=5 then quit;
	end;
TARLEN:=X;

for BLKNUM:=FBLK,LBLK do
begin
	READBL;
	SEARCH;
	end;
end;



procedure SIGNDEC;
integer NUM;
begin
SLINE("ENTER HEX NUMBER");
OPENIN(0);
GETC;
NUM:=NUMBER;
SLINE("SIGNED DECIMAL VALUE: ");
INTOUT(0,NUM);
CRLF(0);
end;



procedure COMSECT;
integer SECTA,SECTB,UNITA,UNITB
	STARTA,ENDA,STARTB,ENDB,X,P;
address BUFFA,BUFFB;

procedure DOCOM;
begin
FREAD(UNITA,SECTA,BUFFA,1);
FREAD(UNITB,SECTB,BUFFB,1);
for X:=0,255 do
	begin
	if BUFFA(X)#BUFFB(X) then
		begin
		BYTEOUT(X);
		SLINE("  U");
		INTOUT(0,UNITA);
		SLINE("B");
		INTOUT(0,SECTA);
		SLINE(" ");
		BYTEOUT(BUFFA(X));

		SLINE("  U");
		INTOUT(0,UNITB);
		SLINE("B");
		INTOUT(0,SECTB);
		SLINE(" ");
		BYTEOUT(BUFFB(X));
		CRLF(0);
		end;
	end;
end;


begin
repeat
	begin
	BUFFA:=RESERVE(256);
	BUFFB:=RESERVE(256);
	SLINE("FIRST UNIT ");
	UNITA:=INTIN(0);
	SLINE("STARTING SECTOR ");
	STARTA:=INTIN(0);
	SLINE("ENDING SECTOR ");
	ENDA:=INTIN(0);
	
	SLINE("SECOND UNIT ");
	UNITB:=INTIN(0);
	SLINE("STARTING SECTOR ");
	STARTB:=INTIN(0);
	SLINE("ENDING SECTOR ");
	ENDB:=INTIN(0);
	
	if (ENDA-STARTA) # (ENDB-STARTB) then
		begin
		SLINE("NOT EQUAL NUMBER OF SECTORS!!");
		CRLF(0);
		end
	else
		begin
		SECTA:=STARTA;
		SECTB:=STARTB;
		for P:=STARTA,ENDA do
			begin
			DOCOM;
			SECTA:=SECTA+1;
			SECTB:=SECTB+1;
			end;
		end;
	SLINE("MORE? ");
	OPENIN(0);
	end;
until CHIN(0)=^N;
end;



begin	\MAIN
CHOUT(0,FF);
BLOCK:=RESERVE(256);
UNIT:=0;
DSIZE:=560;
ODEV:=0;
loop
	begin
	CLINE("0) QUIT");
	CLINE("1) MAP");
	CLINE("2) PRINT SECTORS");
	CLINE("3) EDIT SECTOR");
	CLINE("4) DISPLAY BAD BLOCKS");
	CLINE("5) SPEED BLOCK");
	CLINE("6) BRUTE FORCE COPY");
	CLINE("7) BLOCK COPY");
	CLINE("8) SCAN FOR CHARACTER");
	CLINE("9) CONVERT HEX TO SIGNED DECIMAL");
	CLINE("10) COMPARE TWO DISK SECTORS");
	CLINE("11) REPAIR A UNREADABLE SECTORS");
	CLINE("12) DISK DRIVE TEST");
	NUM:=INTIN(0);

	cases NUM of
		0:quit;
		1:MAP;
		2:PRINT;
		3:EDIT;
		4:[GETPARM;BADBLK(UNIT);];
		5:SPEED;
		6:BCOPY;
		7:BLKCOPY;
		8:FIND;
		9:SIGNDEC;
		10:COMSECT;
		11:REPAIR;
		12:DRIVET
	else;
	WAIT;
	CHOUT(0,FF);
	end;
end;
