
include \CXPL\CODESI.XPL;

\MS-DOS I-O STUFF

integer
	SYSINF,		\REGISTER SET FOR DOS CALLS
	INHAND,		\INPUT HANDLE
	OUTHAND;	\OUTPUT HANDLE

define WHITE=1,NPOINTS=512;
define DISK=3,EOF=$1A;
define WIDTH=640;

real SINTAB,X,Y,MAGNITUDE,PHASE;

integer I,CH;


proc LIST;
integer I;
begin
for I:=0,NPOINTS-1 do
	begin
	RLOUT(0,X(I));CHOUT(0,^,);
	RLOUT(0,Y(I));CRLF(0)
	end;
end;


proc PLOT(PNTS,N,S);
real PNTS;
int N,S,I;
real MAX;
begin
MAX:=0.0;
for I:=0,N-1 do if MAX<RLABS(PNTS(I)) then MAX:=RLABS(PNTS(I));

if MAX=0.0 then MAX:=1.0E-300;

SETVID(6);CLEAR;
MOVE(0,96);
for I:=0,N-1 do LINE(I*(WIDTH/N),96-FIX(PNTS(I)*90.0/MAX+0.5),WHITE);
CURSOR(0,24);
TEXT(0,S);TEXT(0,"  (MAG IS ");RLOUT(0,MAX);TEXT(0,")");
CH:=CHIN(1);
SETVID(3);
end;


proc SETSIN;
integer I;
for I:=0,NPOINTS do
  SINTAB(I):=SIN(6.283185308*FLOAT(I)/FLOAT(NPOINTS));


proc real SINT(I);
integerI;
begin
if I<0 then return SINT(I+NPOINTS)
else if I>NPOINTS then return SINT(I-NPOINTS)
else return SINTAB(I);
end;

proc real COST(I);
integer I;
return SINT(I-NPOINTS/4);


proc  FFT(REAL,IMAG);
real  REAL,IMAG,TR,TI,WR,WI;
integer MR,M,L,NN,CHAR,STEP,A;
integer  I,J;
begin
MR:=0;
NN:=NPOINTS-1;
for M:=1,NN do
	begin
	L:=NPOINTS;
	repeat L:=L/2 until MR+L<=NN;
	MR:=REM(MR/L)+L;
	if MR>M then
		begin
		TR:=REAL(M);
		REAL(M):=REAL(MR);
		REAL(MR):=TR;
		TI:=IMAG(M);
		IMAG(M):=IMAG(MR);
		IMAG(MR):=TI;
		end;
	end;

CRLF(0);
TEXT(0,"FIRST HALF OF FFT");
CRLF(0);
  
L:=1;
while L<NPOINTS do
	begin
	INTOUT(0,L);TEXT(0," ");
	STEP:=2*L;
	for M:=0,L-1 do
		begin
		A:=(NPOINTS/STEP)*(-M);
		WR:=-COST(A);
		WI:=SINT(A);
		I:=M;
		repeat
			begin
			J:=I+L;
			TR:=(WR*REAL(J)-WI*IMAG(J));
			TI:=(WR*IMAG(J)+WI*REAL(J));
			REAL(J):=REAL(I)-TR;
			IMAG(J):=IMAG(I)-TI;
			REAL(I):=REAL(I)+TR;
			IMAG(I):=IMAG(I)+TI;
			I:=I+STEP
			end
		until I>=NPOINTS-1;
		end;
	L:=STEP;
	end;

for I:=0,NPOINTS/2 do
	begin
	MAGNITUDE(I):=SQRT(REAL(I)*REAL(I)+IMAG(I)*IMAG(I))/FLOAT(NPOINTS);
	TR:=if REAL(I)=0.0 then 1.0E-300 else REAL(I);
	PHASE(I):=ATAN2(IMAG(I),TR);
	end;
end;

procedure IBMOPEN;
integer PSEG,CSEG;
addres TAIL,TLEN;


	procedure PARSE;
	\PARSE COMMAND TAIL AND SET I/O HANDLES
	address EXT1,EXT2;
	integer P,EFLG,I;
	begin
	EXT1:=".XPL";EXT2:=".CAS";

	P:=0;
	EFLG:=false;
	\PARSE COMMAND TAIL FOR EXTENTION

	loop
		begin
		if TAIL(P)=^. then
			begin
			EFLG:=true;
			quit;
			end;
		P:=P+1;
		if P>=TLEN(0) then
			begin
			EFLG:=false;
			quit;
			end;
		end;

	\SET EXTENTION AND INPUT HANDLE
	if not EFLG then
		for I:=0,3 do TAIL(P+I):=EXT1(I);
	INHAND:=FOPEN(TAIL,0);
	end;


begin	\OF IBMOPEN

\GET COMMAND TAIL FROM PSP
TLEN:=RESERVE(80);
TAIL:=TLEN+1;
SYSINF:=GETREG;
PSEG:=SYSINF(11);
CSEG:=SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);
if TLEN(0)>79 then TLEN(0):=79;

\PARSE COMMAND LINE AND SET HANDLES
PARSE;

\OPEN FILES
FSET(INHAND,^I);
end;




begin
IBMOPEN;
OPENI(DISK);
SINTAB:=RLRES(NPOINTS+1);
MAGNITUDE:=RLRES((NPOINTS/2)+1);
PHASE:=RLRES((NPOINTS/2)+1);

X:=RLRES(NPOINTS);
Y:=RLRES(NPOINTS);


SETSIN;
OPENI(3);
for I:=0,NPOINTS-1 do X(I):=RLIN(3);
for I:=0,NPOINTS-1 do Y(I):=0.0;


PLOT(X,NPOINTS,"INPUT WAVE FORM");
FFT(X,Y);CHOUT(0,7);

PLOT(MAGNITUDE,NPOINTS/2+1,"SPECTRUM");
PLOT(PHASE,NPOINTS/2+1,"PHASE");

PLOT(X,NPOINTS,"REAL PART");
PLOT(Y,NPOINTS,"IMAGINARY PART");

FFT(X,Y);
PLOT(X,NPOINTS,"RECONSTRUCTED WAVE FORM");
FCLOSE(INHAND);
end;
