\FTEST.XPL	APR-11-91
\PROGRAM TO TEST AS MANY FLOATING POINT OPERATIONS AS POSSIBLE

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
	GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
	FIX=50;
code real
	RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
	RLABS=51,	FORMAT=52,
	SQRT=53,	LN=54,		EXP=55,		SIN=56,
	ATAN2=57,	MOD=58,		LOG=59,		COS=60,
	TAN=61,		ASIN=62,	ACOS=63;

real RT,SUM;

integer P;

define RASIZE=13;	\NUMBER OF ELEMENTS IN RA ARRAY


procedure real PTEST(X,Y,Z);
\TEST PARAMETER PASSING
real X,Y,Z;
begin
TEXT(0,"SHOULD BE 6.0 = ");
RLOUT(0,X+Y+Z);
CRLF(0);
return X+Y+Z;
end;

procedure DESCRETE;
real ARRAY;
real X,Y,Z;int A,B,C;
begin
CHOUT(0,$0C);
TEXT(0,"HIT ANY KEY: ");
A:=CHIN(1);

TEXT(0,"Testing ADD,SUB,MUL,DIV");CRLF(0);
TEXT(0,"2.0 + 2.0 =");RLOUT(0,2.0+2.0);CRLF(0);
TEXT(0,"2.0 - 2.0 =");RLOUT(0,2.0-2.0);CRLF(0);
TEXT(0,"2.0 * 2.0 =");RLOUT(0,2.0*2.0);CRLF(0);
TEXT(0,"2.0 / 2.0 =");RLOUT(0,2.0/2.0);CRLF(0);
CRLF(0);CRLF(0);
A:=CHIN(1);


TEXT(0,"Testing FLOATING COMPARES");CRLF(0);
if 3.>2. then TEXT(0," > OK ") else TEXT(0," > BAD ");CRLF(0);
if 2.<3. then TEXT(0," < OK ") else TEXT(0," < BAD ");CRLF(0);
if 2.>=1. then TEXT(0," >= OK ") else TEXT(0," >= BAD ");CRLF(0);
if 2.<=3. then TEXT(0," <= OK ") else TEXT(0," <= BAD ");CRLF(0);
if 2.#3. then TEXT(0," # OK ") else TEXT(0," # BAD ");CRLF(0);
if 2.=2. then TEXT(0," = OK ") else TEXT(0," = BAD ");CRLF(0);
CRLF(0);CRLF(0);
A:=CHIN(1);



TEXT(0,"Testing RESERVE and ARRAYS");CRLF(0);
ARRAY:=RLRES(2);
for A:=0,1 do ARRAY(A):=RLRES(2);
ARRAY(0,0):=1.0;ARRAY(0,1):=2.0;
ARRAY(1,0):=3.0;ARRAY(1,1):=4.0;

if ARRAY(0,0)#1.0 then TEXT(0,"BAD ARRAY ELEMENT 0,0") 
	else TEXT(0,"GOOD ARRAY ELEMENT 0,0");CRLF(0);
if ARRAY(0,1)#2.0 then TEXT(0,"BAD ARRAY ELEMENT 0,1")
	else TEXT(0,"GOOD ARRAY ELEMENT 0,1");CRLF(0);
if ARRAY(1,0)#3.0 then TEXT(0,"BAD ARRAY ELEMENT 1,0")
	else TEXT(0,"GOOD ARRAY ELEMENT 1,0");CRLF(0);
if ARRAY(1,1)#4.0 then TEXT(0,"BAD ARRAY ELEMENT 1,1")
	else TEXT(0,"GOOD ARRAY ELEMENT 1,1");
CRLF(0);
for A:=0,1 do for B:=0,1 do
	[RLOUT(0,ARRAY(A,B));CRLF(0);];

CRLF(0);CRLF(0);
A:=CHIN(1);


TEXT(0,"Testing PARAMETER PASSING");CRLF(0);
X:=PTEST(1.0,2.0,3.0);
CRLF(0);
TEXT(0,"SHOULD BE 6 = ");RLOUT(0,X);
CRLF(0);CRLF(0);
A:=CHIN(1);


TEXT(0,"Testing RLIN and RLOUT");CRLF(0);
RLOUT(8,123.456);
X:=RLIN(8);
if X=123.456 then TEXT(0,"FUNCTIONS OK ") else TEXT(0,"FAILURE ");
CRLF(0);
TEXT(0,"SHOULD BE 123.456 IS ");RLOUT(0,X);
CRLF(0);CRLF(0);
A:=CHIN(1);


TEXT(0,"Testing FIX and FLOAT");CRLF(0);
X:=FLOAT(-1234);
A:=FIX(X);
if A=-1234 then TEXT(0,"FUNCTIONS OK ") else TEXT(0,"FAILURE ");
INTOUT(0,A);TEXT(0,"   -1234");
CRLF(0);CRLF(0);
A:=CHIN(1);


TEXT(0,"Testing RLABS");CRLF(0);
X:=RLABS(-1234.456);
if X=1234.456 then TEXT(0,"FUNCTIONS OK ") else TEXT(0,"FAILURE ");
RLOUT(0,X);TEXT(0,"  1234.456");
CRLF(0);CRLF(0);
A:=CHIN(1);


TEXT(0,"Testing FORMAT");CRLF(0);
FORMAT(5,0);
TEXT(0,"YOU SHOULD SEE: 123 - ");RLOUT(0,123.456);CRLF(0);
FORMAT(5,5);
TEXT(0,"YOU SHOULD SEE: 123.456 - ");RLOUT(0,123.456);CRLF(0);
FORMAT(0,5);
TEXT(0,"YOU SHOULD SEE: 1.23456 E 002 - ");RLOUT(0,123.456);CRLF(0);
FORMAT(-1,5);
TEXT(0,"YOU SHOULD SEE: 123.456 E 000 - ");RLOUT(0,123.456);CRLF(0);
FORMAT(5,5);
CRLF(0);CRLF(0);
A:=CHIN(1);


TEXT(0,"Testing SQRT,LN,EXP");CRLF(0);
X:=SQRT(1.234);Y:=LN(1.234);Z:=EXP(1.234);
TEXT(0,"SQRT SHOULD BE 1.1108 is ");RLOUT(0,X);CRLF(0);
TEXT(0,"LN SHOULD BE 0.2102 is ");RLOUT(0,Y);CRLF(0);
TEXT(0,"EXP SHOULD BE 3.434 is ");RLOUT(0,Z);CRLF(0);
CRLF(0);CRLF(0);
A:=CHIN(1);



TEXT(0,"Testing SIN,COS,TAN");CRLF(0);
X:=SIN(1.234);Y:=COS(1.234);Z:=TAN(1.234);
TEXT(0,"SINE SHOULD BE 0.9438 is ");RLOUT(0,X);CRLF(0);
TEXT(0,"COS SHOULD BE 0.3304 is ");RLOUT(0,Y);CRLF(0);
TEXT(0,"TAN SHOULD BE 2.856 is ");RLOUT(0,Z);CRLF(0);
CRLF(0);CRLF(0);
A:=CHIN(1);



TEXT(0,"Testing ASIN,ACOS,ATAN2");CRLF(0);
X:=ASIN(.1234);Y:=ACOS(.1234);Z:=ATAN2(.1234,1.0);
TEXT(0,"ASINE SHOULD BE .1237 is ");RLOUT(0,X);CRLF(0);
TEXT(0,"ACOS SHOULD BE 1.447 is ");RLOUT(0,Y);CRLF(0);
TEXT(0,"ATAN2 SHOULD BE .1227 is ");RLOUT(0,Z);CRLF(0);
CRLF(0);CRLF(0);
A:=CHIN(1);



TEXT(0,"Testing FLMOD, LOG");CRLF(0);
X:=MOD(1.1234,1.0);Y:=LOG(.1234);
TEXT(0,"MOD SHOULD BE .1234 is ");RLOUT(0,X);CRLF(0);
TEXT(0,"LOG SHOULD BE -0.9086 is ");RLOUT(0,Y);CRLF(0);
CRLF(0);CRLF(0);
A:=CHIN(1);
end;


procedure RLOAD;	\LOAD RT ARRAY WITH POSITIVE VALUES
real RA;
begin
RA:=[	+1.23456789E-1,	\0
	-2.23456789E-2,	\1
	+3.23456789E-3,	\2
	-4.23456789E-4,	\3
	+5.23456789E1,	\4
	-6.23456789E2,	\5
	+7.23456789E3,	\6
	-8.23456789E4,	\7
	+9.23456789,	\8
	-0.123456789,	\9
	+0.223456789,	\10
	-0.33456789,	\11
	+0.43456789];	\12

for P:=0,RASIZE-1 do
	begin
	OPENI(8); OPENO(8);
	RLOUT(8,RA(P)); CRLF(8);
	RT(P):= RLABS(RLIN(8));
	end;
end;	\RLOAD



procedure DISERR(E1);	\DISPLAY TRAPPED ERROR NUMBER IF IT IS WRONG
int	E1,E2;
begin
E2:=GETERR;
if E1#E2 then
	begin
	TEXT(0,"!! TRAP ERROR !!");
	TEXT(0,"EXPECTED: "); INTOUT(0,E1);
	TEXT(0," GOT: "); INTOUT(0,E2);
	CRLF(0);
	end;
end;	\DISERR


procedure COMPREHENSIVE;
begin
\DEFAULT FORMAT MUST BE: FORMAT(5,5);
RT:=RLRES(RASIZE);
RLOAD;			\LOAD REAL VALUES INTO ARRAY

\for P:=0,RASIZE-1 do [RLOUT(0,RT(P)); CRLF(0)];

\DO A TRANSCENDENTAL ON EACH VALUE
RT(0):=SQRT(RT(0));
RT(1):=LN(RT(1));
RT(2):=EXP(RT(2));
RT(3):=SIN(RT(3));
RT(4):=ATAN2(RT(4),1.0);
RT(5):=MOD(RT(5),10.0);
RT(6):=LOG(RT(6));
RT(7):=COS(RT(7));
RT(8):=TAN(RT(8));
RT(9):=ASIN(RT(9));
RT(10):=ACOS(RT(10));

\DO A MATH OPERATION ON EACH VALUE
for P:=0,RASIZE-2 do RT(P):=RT(P)/RT(P+1);
for P:=0,RASIZE-2 do RT(P):=RT(P)*RT(P+1);
for P:=0,RASIZE-2 do RT(P):=RT(P)+RT(P+1);
for P:=0,RASIZE-2 do RT(P):=RT(P)-RT(P+1);

\TEST COMPARISONS
SUM:=0.0;
SUM:=SUM +(if 2.1233>-1.2345 then 1.234 else -9.876);
SUM:=SUM +(if 2.1233>3.123457 then 5.678 else -5.432);
SUM:=SUM +(if 2.1233>=-1.2345 then 9.0123 else -1.098);
SUM:=SUM +(if 2.1233>=3.123457 then 4.567 else -7.654);
SUM:=SUM +(if 2.1233<-1.2345 then 8.9012 else -3.231);
SUM:=SUM +(if 2.1233<.123457 then 3.456 else -0.123);
SUM:=SUM +(if 2.1233<=-1.2345 then 7.891 else -4.567);
SUM:=SUM +(if 2.1233<=3.123457 then 2.345 else -8.901);
SUM:=SUM +(if 2.1233#-1.2345 then 6.789 else -2.345);
SUM:=SUM +(if 2.0#2.0 then 0.1234 else -6.789);
SUM:=SUM +(if 2.1233<=-1.2345 then 9.876 else -1.987);
SUM:=SUM +(if 2.1233<=3.123457 then 5.432 else -6.4312);
SUM:=SUM +(if 2.1233=-1.2345 then 2.109 else -9.999);
SUM:=SUM +(if 2.0=2.0 then 8.765 else -2.367);

SUM:=SUM *FLOAT(-5432);
SUM:=SUM +FLOAT(FIX(123.4324));

\PRODUCE SINGLE SUM
for P:=0,RASIZE-1 do SUM:=SUM+RT(P);
CRLF(0);
FORMAT(5,15);

TEXT(0,"RESULT IS: "); RLOUT(0,SUM); CRLF(0);
TEXT(0,"SHOULD BE: 24777.4495173998"); CRLF(0);
CRLF(0);

\TRAP TEST
TRAP(0);
SUM:=1.0/0.0; DISERR(6);		\FOR APPLE:
SUM:=9.9E200*9.9E200; DISERR(7);	\SUM:=9.9E20*9.9E20; DISERR(7);
SUM:=9.9E-200*9.9E-200; DISERR(8);	\SUM:=9.9E-30*9.9E-30; DISERR(8);
P:=FIX(9.9E20); DISERR(9);
SUM:=SQRT(-1.0); DISERR(10);
SUM:=LOG(-1.0); DISERR(11);
SUM:=LN(-1.0); DISERR(11);
SUM:=EXP(800.0); DISERR(12);
SUM:=EXP(9.9E9); DISERR(12);
SUM:=ATAN2(0.0,0.0); DISERR(14);
TRAP($FFFF);
end;


begin
TEXT(0,"

**** FLOATING POINT OPERATIONS TESTER ****

D) DESCRETE TEST
C) COMPREHENSIVE TEST

SELECT ONE: ");
case CHIN(0) of
	^D,^d: DESCRETE;
	^C,^c: COMPREHENSIVE
else;
TEXT(0,"**** TEST DONE ******");
CRLF(0);
end;
