\FUTILE.XPL
\	F U T I L E
\
\
\    THIS PROGRAM WILL READ THE
\    SURFACE OF AN APEX DISK AND
\    ATTEMPT TO REPORT THE TYPE OF
\    FILES STORED ON IT. IT IS USED
\    WHEN A DIRECTORY IS CLOBBERED,
\    AND ALL THE USER WANTS TO MAKE A
\    (SOMETIMES) FUTILE ATTEMT TO
\    EXTRACT THE DATA FROM THE DISK.
\    WHEN THE TYPES OF THE FILES (AND
\    THE LENGTH OF THEM) ARE KNOWN,
\    THE "MAKE" COMMAND OF APEX MAY
\    BE USED TO "FIX" THE DIRECTORY.
\
\	ROGER NACE  NOVEMBER 1981
\

code	\STANDARD XPLV4D INTRINSICS
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEN=5		RESTRT=6	CHIN=7
CHOUT=8		CRLF=9		NUMIN=10	NUMOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	SPACE=18	CURSOR=23
FWRITE=30	FREAD=31;


define
	CR=13
	LF=10
	FF=12
	AS=42	\<*>
	SE=59	\<;>

	CON=0
;

integer
	DISK	\UNIT FOR INPUT
	OUT	\UNIT FOR OUTPUT
	BUFFSIZ	\BUFFERSIZE
	START	\STARTING BLOCK
	END	\ENDING BLOCK
	CURR	\CURRENT BLOCK TO TEST
	LOC	\LOCATION OF BLOCK IN BUFF
	EOFPOINT\EOF POINTER
	TYPE	\COMPOSITE TYPE OF FILE
	GOODTYPE\BUFFER FOR TYPE
	STARTB	\BUFFER FOR STARTING BLOCK

	TXT	\TXT SWITCH
	BIN	\BIN SWITCH
	I2L	\I2L SWITCH
	SAV	\SAV SWITCH

	BDATA	\BINARY COUNTER
	ADATA	\ALPHA COUNTER
	CRS	\<CR> COUNTER
	NDATA	\NUMERICAL COUNTER (HEX RANGE)
	SEMS	\<;> COUNTER

	BLOCK	\BLOCK WITHIN BUFF
	BLOCKS	\BLOCK COUNT OF SAV FILE
;

address
	BUFF	\BUFFER FOR DATA
;


procedure	INIT;

begin	\INIT

CHOUT(CON,FF);

TEXT(CON,"
	F U T I L E

Disk unit to scan ");
DISK:=NUMIN(CON);

TEXT(CON,"

Device for output report ");
OUT:=NUMIN(CON);

OPENO(OUT);
if OUT#CON then
	begin
	TEXT(OUT,"	FUTILE report of files on unit ");
	NUMOUT(OUT,DISK);
	CRLF(OUT);
	end;

TEXT(CON,"

Starting block ");
START:=NUMIN(CON);

TEXT(CON,"Ending block ");
END:=NUMIN(CON);

if OUT#CON then
	begin
	TEXT(OUT,"	From block ");
	NUMOUT(OUT,START); TEXT(OUT," to block ");
	NUMOUT(OUT,END); CRLF(OUT);
	end;

TEXT(CON,"

The buffer space is ");
NUMOUT(CON,BUFFSIZ);
TEXT(CON," blocks.");
CRLF(CON);

CRLF(OUT);

end;	\INIT


procedure	SCAN;

integer
	C	\CHARACTER BUFFER
	PREVC	\PREVIOUS CHARACTER
;

begin	\SCAN

PREVC:=0;

BDATA:=0;
ADATA:=0;
CRS:=0;
NDATA:=0;
SEMS:=0;

EOFPOINT:=0;

repeat
	begin

	C:=BUFF(LOC+EOFPOINT);
	
	case of
	(C<=^F) & (C>=^A)
		:  NDATA:=NDATA+1;
	(C<=^Z) & (C>=^G)
		:  ADATA:=ADATA+1;
	(C<=^z) & (C>=^a)
		:  ADATA:=ADATA+1;

	C=CR	:  CRS:=CRS+1;

	(C<=^9) & (C>=^0)
		:  NDATA:=NDATA+1;

	(C<9) & (C#7)	\ 7 IS FOR <BELL> IN TXT FILES
		:  BDATA:=BDATA+1;
	(C<=31) & (C>=15)
		:  BDATA:=BDATA+1;
	C>=128	:  BDATA:=BDATA+1

	else;

	if PREVC=LF & (C=^; ! C=^^) then
		SEMS:=SEMS+1;

	PREVC:=C;

	EOFPOINT:=EOFPOINT+1;
	
	end
until
	(EOFPOINT=256) !
		(BUFF(LOC+EOFPOINT)=26);

end;	\SCAN

procedure	FINDOUT;

begin	\FINDOUT

TXT:=false;
BIN:=false;
I2L:=false;
SAV:=false;

SCAN;

\+DEBUG
\TEXT(CON,"BDATA = "); NUMOUT(CON,BDATA); CRLF(CON);
\TEXT(CON,"ADATA = "); NUMOUT(CON,ADATA); CRLF(CON);
\TEXT(CON,"CRS = "); NUMOUT(CON,CRS); CRLF(CON);
\TEXT(CON,"NDATA = "); NUMOUT(CON,NDATA); CRLF(CON);
\TEXT(CON,"SEMS = "); NUMOUT(CON,SEMS); CRLF(CON);
\-DEBUG

BIN:=(BDATA=0) & (CRS=0) & (SEMS=0) &
	(ADATA=0) & (NDATA#0);

I2L:=(BDATA=0) & (CRS#0) & (SEMS#0) &
	(ADATA=0) & (NDATA#0);

SAV:=(BDATA#0) & (not BIN) & (not I2L);

TXT:=(not BIN) & (not I2L) & (BDATA=0);

TYPE:=(SAV&8) ! (I2L&4) ! (BIN&2) ! (TXT&1);

\+DEBUG
\TEXT(CON,"BIN = ");NUMOUT(CON,BIN);CRLF(CON);
\TEXT(CON,"I2L = ");NUMOUT(CON,I2L);CRLF(CON);
\TEXT(CON,"TXT = ");NUMOUT(CON,TXT);CRLF(CON);
\TEXT(CON,"SAV = ");NUMOUT(CON,SAV);
\-DEBUG

if SAV then
	begin
	BLOCKS:=BUFF(LOC+$17)+1;
	end;

end;	\FINDOUT


procedure	GETBLOCK(DESIRED);

integer
	DESIRED	\BLOCK DESIRED
;

own
	FBLOCK	\FIRST BLOCK IN BUFF
	LBLOCK	\LAST BLOCK IN BUFF
;

procedure	READDISK;

begin	\READDISK
if END-DESIRED+1<BUFFSIZ then
	BUFFSIZ:=END-DESIRED+1;
FREAD(DISK,DESIRED,BUFF,BUFFSIZ);
FBLOCK:=DESIRED;
LBLOCK:=FBLOCK+BUFFSIZ-1;
end;	\READDISK

begin	\GETBLOCK

\+DEBUG
\TEXT(CON,"GETBLOCK at ");
\NUMOUT(CON,DESIRED);
\CRLF(CON);
\-DEBUG

if OUT#CON then
	begin
	CURSOR(0,17);
	TEXT(CON,"Testing block ");
	NUMOUT(CON,DESIRED);
	end;

if (DESIRED<FBLOCK) ! (DESIRED>END) then
	begin
	TEXT(CON,"SYNC ERROR!");
	ABORT;
	end;

if FBLOCK=0 then
	begin	\FIRST ENTRY
	READDISK;
	return 0;
	end
else
	begin	\ALL OTHER ENTRIES
	if DESIRED<=LBLOCK then
		return (DESIRED-FBLOCK)*256
	else
		begin
		READDISK;
		return 0;
		end;
	end;
end;	\GETBLOCK


procedure	VALIDA;

begin	\VALIDA

if TXT then
	return true;

if SAV then
	return (BUFF(LOC+$17)<154) &
	  (BUFF(LOC)=$4C &
	    BUFF(LOC+3)=$4C &
	     BUFF(LOC+6)=$4C &
	      BUFF(LOC+9)=$4C);

if BIN then
	return BUFF(LOC)=AS;

if I2L then
	return ((BUFF(LOC)=CR) & 
		 (BUFF(LOC+1)=LF) &
		  (BUFF(LOC+2)=SE));

end;	\VALIDA
				
begin	\MAIN

BUFFSIZ:=(SPACE-1000)/256;
BUFF:=RESERVE(BUFFSIZ*256);

INIT;

CURR:=START;

repeat
	begin
	LOC:=GETBLOCK(CURR);
	FINDOUT;
	if TYPE then
		if VALIDA then
			begin
			GOODTYPE:=TYPE;
			TEXT(OUT,"New file at ");
			STARTB:=CURR;
			NUMOUT(OUT,STARTB);
			TEXT(OUT," of type ");
			case of
			TXT:TEXT(OUT,"TXT");
			BIN:TEXT(OUT,"BIN");
			I2L:TEXT(OUT,"I2L");
			SAV:	begin
				TEXT(OUT,"SAV length is ");
				NUMOUT(OUT,BLOCKS);
				CRLF(OUT);
				CURR:=CURR+BLOCKS;
				end
			else;
			if not SAV then
				loop
					begin
					if EOFPOINT>=256 then
						begin
						CURR:=CURR+1;
						if CURR>END then
							quit;
						LOC:=GETBLOCK(CURR);
						FINDOUT;
						end;
					if (TYPE#GOODTYPE) & (TYPE#0) then
						begin
						TEXT(OUT," Abort for new type");
						CRLF(OUT);
\						CURR:=CURR+1;
						quit;
						end;
					if EOFPOINT<256 then
						begin
						TEXT(OUT," end at ");
						NUMOUT(OUT,CURR);
						TEXT(OUT," length is ");
						NUMOUT(OUT,CURR-STARTB+1);
						CRLF(OUT);
						CURR:=CURR+1;
						quit;
						end;
					end;
			end
	else
		CURR:=CURR+1;
	end
until
	CURR>END;

CLOSE(OUT);

end;	\MAIN
