\GETFILE.XPL	MAR-21-94
\Routine to select a file from a list of files displayed in a window.

inc	C:\CXPL\CODESI;

def	AX, BX, CX, DX, DI, SI, BP, CF, CS, DS, SS, ES;	\GETREG registers
def	BS=$08, TAB=$09, FF=$0C, CR=$0D, EOF=$1A, ESC=$1B, SP=$20; \ASCII chars
def	UP=-72, DN=-80, LT=-75, RT=-77,
	PGUP=-73, PGDN=-81, END=-79, HOME=-71;		\Scan codes

char	FILENAME,	\Variable for demo code in Main
	;

\Standard Lib Variables:
int	Cpureg,
	DataSeg,
	;
\Global variables for GetFile:
int	IFNDISP,	\Index to top of displayed file names
	IFNSEL;		\Index to selected (highlighted) file name
def	MaxFiles=100;	\Maximum number of file names in list

\======================== STANDARD LIB ROUTINES ======================

func	ToUpper(Ch);		\Convert character to uppercase
int	Ch;
return if Ch>=^a & Ch<=^z then Ch&$df else Ch;



func	GetKey;			\Get character from keyboard (wait if necessary)
int	Ch;			\This is a low-level routine with no echo,
begin				\ no Ctrl-C, and no cursor.
Cpureg(AX):= 0;			\Function $00
SoftInt($16);			\Call BIOS routine
Ch:= Cpureg(AX) & $ff;
if Ch = 0 then			\Return non-ASCII chars as negative scan code
	Ch:= -(Cpureg(AX)>>8);
return Ch;
end;	\GetKey



func	GetCurShape;		\Get cursor shape
begin
Cpureg(AX):= $0300;
SoftInt($10);
return Cpureg(CX);
end;	\GetCurShape



proc	SetCurShape(Shape);	\Set cursor shape
\WARNING: $0607 does not work for monochrome mode 7. Use $0b0c instead.
\ $000d gives a solid block for all modes.
int	Shape;
begin
Cpureg(AX):= $0100;
Cpureg(CX):= Shape;
SoftInt($10);
end;	\SetCurShape



proc	ShowCursor(On);		\Turn flashing cursor off and on
int	On;	\Flag: True = cursor on; False = cursor off
int	CS;	\Own-type variable to save original cursor shape
begin
CS:= [$000d];	\Default is solid block
if On then SetCurShape(CS(0))
else	[CS(0):= GetCurShape;
	SetCurShape($2000)];
end;	\ShowCursor



proc	Box(X, Y, W, H, T);	\Draw a rectangle using type T box chars
int	X, Y, W, H, T;		\ with upper-left corner at X, Y
int	TBL, I;			\The minimum width (W) & height (H) is 2
char	S;			\Note this uses device 6 with attributes
begin
\	 012345   Box Character Type (T):
TBL:=  ["Ŀ ",	\0
	"͸Ծ ",	\1
	"ķӽ ",	\2
	"ͻȼ "];	\3
S:= TBL(T&3);				\(Mask for safety)

Cursor(X, Y);	Chout(6, S(0));		\Draw top line with brackets
for I:= 1, W-2 do Chout(6, S(1));
Chout(6, S(2));
for I:= 1, H-2 do			\Draw sides
	[Cursor(X, Y+I);   Chout(6, S(3));
	Cursor(X+W-1, Y+I);   Chout(6, S(3))];
Cursor(X, Y+H-1);   Chout(6, S(4));	\Draw bottom line with brackets
for I:= 1, W-2 do Chout(6, S(1));
Chout(6, S(5));
end;	\Box



func	StrNCmp(A, B, N);	\Compare string A to string B up to N bytes long
\This returns:
\	>0 if A > B
\	=0 if A = B
\	<0 if A < B
\This provides a general string compare, for example:
\ if StrNCmp(A, B, N) >= 0 then...	(if A >= B then...)
char	A, B;	\Strings to be compared (must be right justified)
int	N;	\Number of bytes to compare
int	I;
begin
for I:= 0, N-1 do
	if A(I) # B(I) then
		return A(I) - B(I);
return 0;			\They're equal
end;	\StrNCmp

\======================================================================

proc	Sort(A, N);		\Sort array using the shell sort method
int	A,			\Address of array
	N;			\Number of elements in array (size)
int	J, GAP, I, JG, T;
begin
GAP:= N /2;
while GAP > 0 do
	begin
	for I:= GAP, N-1 do
		begin
		J:= I -GAP;
		loop	begin
			if J < 0 then quit;
			JG:= J +GAP;
			if StrNCmp(A(J), A(JG), 8) <= 0 then quit;
			T:= A(J);   A(J):= A(JG);   A(JG):= T;
			J:= J -GAP;
			end;
		end;
		GAP:= GAP /2;
	end;
end;	\SORT

\----------------------------------------------------------------------

func	GETFILE(Template, WinX, WinY, WinWide, WinHigh);
char	Template;
int	WinX, WinY,	\Coordinates of upper-left corner of window
	WinWide, WinHigh; \Size of window
int	J, Key,
	Names,		\Array of pointers to strings
	QMaxx;		\Index to last file + 1



proc	READDIR;		\Read a directory with specified template
int	I, P, Ch;
char	DTA, N;
begin	
DTA:= Reserve(43);		\Set up data for directory work
Cpureg(0):= $1A00;
Cpureg(3):= DTA;
Cpureg(9):= DataSeg;
Softint($21);

Cpureg(0):= $4E00;		\Look up first file
Cpureg(2):= $FFF7;
Cpureg(9):= DataSeg;
Cpureg(3):= Template;
Softint($21);
QMaxx:= 0;
if (Cpureg(0) & $FF) # 0 then return;

loop	begin
	P:= 0;
	N:= Names(QMaxx);
	loop	begin
		Ch:= DTA(30+P);
		if Ch = ^. then quit;
		N(P):= Ch;
		P:= P +1;
		end;
	for I:= P, 7 do N(I):= SP;
	N(7):= N(7) ! $80;
	QMaxx:= QMaxx +1;

	Cpureg(0):= $4F00;		\Look up next file
	Softint($21);
	if (Cpureg(0) & $FF) # 0 then quit;
	end;
end;	\ReadDir



proc	ShowFiles;		\Fill window with list of files
int	Q, I;
begin
Q:= IFNDISP;
for I:= 1, WinHigh-2 do
	begin
	Cursor(WinX+1, WinY+I);
	ATTRIB(if Q = IFNSEL then $70 else $07);	\Highlight selected file
	CHOUT(6, SP);
	TEXT(6, if Q < QMaxx then Names(Q) else "        "); \Display file name
	CHOUT(6, SP);
	Q:= Q +1;
	end;
end;	\ShowFiles



proc	ScrollBar;		\Draw scroll bar with slider
int	J;
begin
Attrib($70);
Cursor(WinX+WinWide-1, WinY+1);   Chout(6, $18);	 \Up arrow
for J:= WinY+2, WinY+WinHigh-3 do
	[Cursor(WinX+WinWide-1, J);   CHOUT(6, ^)];
Cursor(WinX+WinWide-1, WinY+WinHigh-2);   CHOUT(6, $19); \Down arrow

\Show slider
Attrib($07);
J:= if QMaxx > 1 then (IFNSEL * (WinHigh-5) + (QMaxx-1)/2 ) / (QMaxx-1)
		 else 0;
Cursor(WinX+WinWide-1, J+WinY+2);
CHOUT(6, ^);
end;	\ScrollBar



func	Search(Ch, I);	\Search Names for file that starts with CH.
\Returns index of next name or current name if none.
int	Ch, I;
char	Str;
begin
loop	begin
	I:= I + 1;
	if I >= QMaxx then I:= 0;	\loop back to start of list
	if I = IFNSEL then return I;	\back where we started

	Str:= Names(I);
	if Ch = Str(0) then return I;
	end;
end;	\SEARCH



begin	\GetFile
Names:= Reserve(MaxFiles*2);
for J:= 0, MaxFiles-1 do
	Names(J):= Reserve(8);

Box(WinX, WinY, WinWide, WinHigh, 3);	\Draw window
Template(5):= 0;			\Fix template: terminate with 0
ReadDir;				\Read list of file names
Sort(Names, QMaxx);			\Put them into alphabetical order
loop	begin
	ShowFiles;
	ScrollBar;

	Key:= GetKey;
	case Key of
	  Up:	begin
		IFNSEL:= IFNSEL -1;
		if IFNSEL < 0 then IFNSEL:= 0;
		if IFNSEL < IFNDISP then IFNDISP:= IFNSEL;
		end;
	  Dn:	begin
		IFNSEL:= IFNSEL +1;
		if IFNSEL >= QMaxx then IFNSEL:= QMaxx-1;
		if IFNSEL >= IFNDISP+WinHigh-2 then
			IFNDISP:= IFNSEL-(WinHigh-2)+1;
		end;
	  Home:	begin
		IFNSEL:= 0;
		IFNDISP:= 0;
		end;
	  End:	begin
		IFNSEL:= QMaxx-1;
		IFNDISP:= QMaxx-1 - (WinHigh-2)+1;
		if IFNDISP < 0 then IFNDISP:= 0;
		end;
	  PgUp:	begin
		IFNDISP:= IFNDISP - (WinHigh-2);
		if IFNDISP < 0 then IFNDISP:= 0;
		IFNSEL:= IFNDISP;
		end;
	  PgDn:	begin
		IFNDISP:= IFNDISP + (WinHigh-2);
		if IFNDISP > QMaxx-1 - (WinHigh-2)+1 then
			[IFNDISP:= QMaxx-1-(WinHigh-2)+1;
			if IFNDISP < 0 then IFNDISP:= 0];
		IFNSEL:= IFNDISP + WinHigh-2-1;
		if IFNSEL >= QMaxx then IFNSEL:= QMaxx-1;
		end;
	  CR:	return Names(IFNSEL);	\Return selected file name
	  Esc:	return -1
	other	begin
		IFNSEL:= SEARCH(ToUpper(KEY), IFNSEL);
		if IFNDISP>IFNSEL ! IFNDISP+(WinHigh-2)<=IFNSEL then
			IFNDISP:= IFNSEL;
		if IFNDISP > QMaxx-1 - (WinHigh-2)+1 then
			[IFNDISP:= QMaxx-1-(WinHigh-2)+1;
			if IFNDISP < 0 then IFNDISP:= 0];
		end;
	end;
end;	\GetFile

\======================================================================
\Example showing how to use GetFile

begin	\Main
Cpureg:= GETREG;
DataSeg:= Cpureg(12);

CHOUT(0, FF);
ShowCursor(false);

IFNDISP:= 0;
IFNSEL:= 0;
loop	begin
	FILENAME:= GETFILE(\"*.MOL "\"*.??? ", 35, 12, 12, 7);
	if FILENAME = -1 then quit;
	Cursor(0, 0);   TEXT(0, FILENAME);
	\FOPEN(FILENAME, 0);
	end;

ShowCursor(true);
end;	\Main
