\GETFLD.XPL	MAR-02-95

inc	\CXPL\STDDEF;

\Define window position and size:
def	WINDOWX0= 50, WINDOWY0= 11, WINDOWX1= 76, WINDOWY1= 22;
\X0,Y0 must be upper-left corner.
\The window includes the end points, e.g: this window is 12 lines high,
\ and 27 characters wide.

\Prompts and error messages are not used if this line is outside the window.
def	PROMPTLINE= WINDOWY1 -WINDOWY0;	\Line for prompt and error messages

\def	COLOR = BWHITE!BLUE<<4;
def	COLOR = WHITE!BLACK<<4;

def	TV = 6;
int	KEY;		\Last keystroke from KEYIN


char	NN, XX, YY, TT;					\### EXAMPLE ###
def	NNSIZE=2, XXSIZE=6, YYSIZE=6, TTSIZE=10;	\### EXAMPLE ###

\----------------------------------------------------------------------

proc	CHIRP;			\A not-too-obnoxious beep
begin
\SOUND(false, 1, 1000);
\SOUND(true, 1, 3000);
end;	\CHIRP



proc	WCURSOR(X, Y);		\Move cursor to window coordinates X,Y
int	X, Y;
begin
CURSOR(X+WINDOWX0, Y+WINDOWY0);
end;	\WCURSOR



proc	CLRWIND;		\Clear window & move cursor to upper-left corner
int	N, Y;
begin
N:= WINDOWX1 -WINDOWX0 +1;
for Y:= 0, WINDOWY1-WINDOWY0 do
	begin
	WCURSOR(0, Y);
	SPOUT(TV, N);
	end;
WCURSOR(0, 0);
end;	\CLRWIND



proc	WTXT(X, Y, STR);	\Display a string at window coordinates X,Y
\The string may have tabs and carriage returns in it
int	X, Y;
char	STR;
int	I, CHAR;


	proc	DOCR;		\Do a carriage return
	begin
	X:= 0;				\Move to start of next line
	Y:= Y +1;
	if Y > WINDOWY1 then Y:= 0;	\If beyond bottom then wrap to top
	WCURSOR(0, Y);
	end;	\DOCR


	proc	DOCH(CH);	\Do a character output
	int	CH;
	begin
	CHOUT(TV, CH);
	X:= X +1;			\Move cursor ahead one character
	if X > WINDOWX1 then DOCR;	\Auto carriage return at end of line
	end;	\DOCH


begin	\WTXT
WCURSOR(X, Y);
for I:= 0, MAXFORSIZE do
	begin
	CHAR:= STR(I) & $7F;
	case CHAR of
	  CR:	DOCR;
	  LF:	[];	\Ignore the line feed
	  TAB:	repeat DOCH(SP) until (X&7) =0
	other	DOCH(CHAR);
	if STR(I) >= $80 then I:= MAXFORSIZE;	\Terminate 'FOR' loop
	end;
end;	\WTXT

\----------------------------------------------------------------------

proc	INVERT(X, Y, LEN);	\Invert video on LEN many characters at X,Y
int	X, Y, LEN;
begin
\HILIGHT(X, Y, X+LEN-1, Y, $70);
HILIGHT(X, Y, X+LEN-1, Y, (COLOR>>4!COLOR<<4)&$7F);
end;	\INVERT


proc	NORMAL(X, Y, LEN);	\Re-invert video on LEN many characters at X,Y
int	X, Y, LEN;
begin
\HILIGHT(X, Y, X+LEN-1, Y, $07);
HILIGHT(X, Y, X+LEN-1, Y, COLOR);
end;	\NORMAL



proc	HILITE(ON);		\Turn full brightness on or off
int	ON;			\This does nothing unless TV = 6
begin
\ATTRIB(if ON then $0F else $07);
ATTRIB(if ON then COLOR!$08 else COLOR);
end;	\HILITE

\----------------------------------------------------------------------

proc	SHOWFLD(FIELD, N, X, Y);	\Show a field (string)
char	FIELD;	\Address of field
int	N,	\Number of characters in FILED
	X, Y;	\Screen position
int	I;
begin
WCURSOR(X, Y);
for I:= 0, N-1 do CHOUT(TV, FIELD(I));
end;	\SHOWFLD



proc	CLRLINE(N);		\Erase line N within the window
int	N;
int	I;
begin
if N<WINDOWY0 ! N >WINDOWY1 then return;
WCURSOR(0, N);
SPOUT(TV, WINDOWX1-WINDOWX0+1);
WCURSOR(0, N);
end;	\CLRLINE



proc	PROMPT(MSG);	\Display a message on the prompt (bottom) line
char	MSG;
int	I, C;
begin
if PROMPTLINE<WINDOWY0 ! PROMPTLINE >WINDOWY1 then return;
CLRLINE(PROMPTLINE);
WTXT(0, PROMPTLINE, MSG);
end;	\PROMPT



proc	ERRMSG(STR);	\Display an error message (and buzz)
char	STR;
int	I;
begin
CHIRP;
if PROMPTLINE<WINDOWY0 ! PROMPTLINE >WINDOWY1 then return;
PROMPT(STR);
INVERT(WINDOWX0, WINDOWY0+PROMPTLINE, WINDOWX1-WINDOWX0+1);
WAIT(55);
NORMAL(WINDOWX0, WINDOWY0+PROMPTLINE, WINDOWX1-WINDOWX0+1);
end;	\ERRMSG

\----------------------------------------------------------------------

func	KEYIN;			\Input a keystroke and don't echo it
begin
SHOWCURSOR(true);		\Turn on flashing cursor
KEY:= GETKEY;
SHOWCURSOR(false);		\Turn off flashing cursor
if KEY = TAB then KEY:= -DNARROW;
if KEY = -$0F \Shift-Tab\ then KEY:= -UPARROW;
return KEY;
end;	\KEYIN



proc	GETFLD(FIELD, N, X, Y, NUMFLG, HINT);
\Input a field (string) of chars. Numbers are entered calculator style;
\ text is entered from left to right.
char	FIELD;	\Address of field
int	N,	\Number of characters in field
	X, Y,	\Field position on screen
	NUMFLG;	\Flag: 'TRUE' if numeric entry is required
char	HINT;	\Prompt message
int	CH,
	M,	\Maximum index of FIELD
	I, J,
	NUMERIC,
	FIRSTTIME;
begin
M:= N -1;
\Fill field with underlines. Unused spaces in the field are converted to
\ underlines, which are converged from both ends.
I:= 0;   while FIELD(I)=SP & I<=M do [FIELD(I):= ^_;   I:= I +1];
I:= M;   while FIELD(I)=SP & I>=0 do [FIELD(I):= ^_;   I:= I -1];

PROMPT(HINT);
FIRSTTIME:= true;
J:= if NUMFLG then M else 0;	\Our position in the field
loop	begin
	WCURSOR(X, Y);		\Display what we have
	if FIRSTTIME then HILITE(true);
	TEXTN(TV, FIELD, N);
	HILITE(false);
	WCURSOR(X+J, Y);		\Place cursor
	CH:= KEYIN;
	NUMERIC:= CH>=^0 & CH<=^9;
	case CH of ^-, ^+, ^:, ^., ^E, ^e, SP, ^,, ^_, ^/: NUMERIC:= true
	other;

	case CH of
	   -LFARROW:
		if J > 0 then [J:= J -1;   FIRSTTIME:= false];
	   -RTARROW:
		if J < M then [J:= J +1;   FIRSTTIME:= false];
	   FF:	[for I:= 0, M do FIELD(I):= ^_;	\Clear the entire field
		J:= if NUMFLG then M else 0];	\Our position in the field
	   -DELETE:
		begin
		if NUMFLG then
			[for I:= -J, -1 do	\Shift field right
				FIELD(-I):= FIELD(-I-1);
			FIELD(0):= ^_]
		else	[for I:= J, M-1 do	\Shift field left
				FIELD(I):= FIELD(I+1);
			FIELD(M):= ^_];
		FIRSTTIME:= false;
		end;
	   BS:	begin
		if J > 0 then
			[J:= J -1;
			for I:= J, M-1 do	\Shift field left
				FIELD(I):= FIELD(I+1);
			FIELD(M):= ^_];
		FIRSTTIME:= false;
		end;
	   CR, -DNARROW, -UPARROW, ESC:	quit
	other	begin
		if NUMFLG & CH=^/ then quit;	\For dates
		if NUMFLG & ~NUMERIC then
			[ERRMSG(" PLEASE ENTER A NUMBER");
			PROMPT(HINT)]
		else if CH >= $20 then		\Ignore control chars
			begin
			if FIRSTTIME then STRNFILL(FIELD, N, ^_)
			else	begin
				if NUMFLG then
					begin
					if FIELD(0)=^_ then
					    for I:= 1, J do \Shift left
						FIELD(I-1):= FIELD(I);
					end
				else	begin
					for I:= -M+1, -J do \Shift right
						FIELD(-I+1):= FIELD(-I);
					end;
				end;
			FIELD(J):= CH;
			if ~NUMFLG & J<M then J:= J +1;	\Move cursor right
			FIRSTTIME:= false;
			end;
		end;
	end;

J:= 0;			\Put spaces back in place of underlines
while J<=M & FIELD(J)=^_ do [FIELD(J):= SP;	J:= J +1];
J:= M;
while J>=0 & FIELD(J)=^_ do [FIELD(J):= SP;	J:= J -1];

WCURSOR(X, Y);		\Re-display field without underlines and highlight
TEXTN(TV, FIELD, N);
CLRLINE(PROMPTLINE);	\Erase the prompt message
end;	\GETFLD

\----------------------------------------------------------------------

proc	SHOWYN(FIELD, X, Y); \Show yes/no switch at position X,Y
char	FIELD;
int	X, Y;
begin
WTXT(X, Y, if FIELD(0) = ^Y then "YES" else "NO ");
end;	\SHOWYN



proc	GETYESNO(FIELD, X, Y, HINT);
\Get a YES/NO switch from the operator and display it at X,Y
char	FIELD;
int	X, Y;
char	HINT;
int	CH;
begin
PROMPT(HINT);
loop	begin
	HILITE(true);
	SHOWYN(FIELD, X, Y);
	HILITE(false);
	WCURSOR(X, Y);
	CH:= KEYIN;
	case CH of CR, -DNARROW, -UPARROW, ESC: quit other;
	if CH = SP then
		CH:= if FIELD(0) = ^Y then ^N else ^Y;
	CH:= CH & $DF;			\Convert to uppercase
	if CH=^Y ! CH=^N then FIELD(0):= CH
	else [ERRMSG(" PRESS Space, Enter OR Esc");   PROMPT(HINT)];
	end;
SHOWYN(FIELD, X, Y);			\Redisplay without highlight
CLRLINE(PROMPTLINE);			\Erase the prompt message
end;	\GETYESNO



func	POPYESNO(LINE, DEFAULT, QUESTION, HINT);
\Boolean function--pops up a YES/NO question, returns 'true' if yes
int	LINE, DEFAULT;
char	QUESTION, HINT;
char	FIELD;
begin
FIELD:= RESERVE(1);
FIELD(0):= DEFAULT;
CLRLINE(LINE);
WTXT(0, LINE, QUESTION);
loop	begin
	GETYESNO(FIELD, 24, LINE, HINT);
	case KEY of CR, ESC: quit	\Don't accept up or down arrows
	other ERRMSG(" PRESS Space, Enter OR Esc");
	end;
CLRLINE(LINE);				\Erase the question
return FIELD(0) = ^Y;
end;	\POPYESNO

\----------------------------------------------------------------------

proc	COPYBUF(A, Size);	\Copy BUF into array
char	A;	\Array
int	Size;	\Number of bytes to copy
int	I;
begin
OPENI(8);
for I:= 0, Size-1 do
	A(I):= CHIN(8);
end;	\COPYBUF



func	STR2INT(Str, Size);
char	Str;
int	Size;
int	N;
begin
Str(Size-1):= Str(Size-1) ! $80;
N:= AtoI(Str);
Str(Size-1):= Str(Size-1) & $7f;
return N;
end;	\STR2INT



func	VALCHK(FIELD, N, MIN, MAX, MSG);	\Validity check
\Displays error message and returns 'FALSE' if number exceeds limits
char	FIELD;	\Address of field
int	N,	\Size of field
	MIN, MAX; \Limits
char	MSG;	\Error message
int	I;
begin
if KEY = ESC then return true;		\Accept anything if ESC key
I:= STR2INT(FIELD, N);
if I>=MIN & I<=MAX then return true;
ERRMSG(MSG);
for I:= 0, N-1 do FIELD(I):= ^_;
return false;
end;	\VALCHK



proc	JUSTIFY(FIELD, SIZE);	\Right justify numeric params field
\For example: "123__" is converted to "00123"
char	FIELD;	\Address of field
int	SIZE;	\Number of bytes in field
int	I;
def	FILL=^0; \Fill character (typically 0 or space)
begin
\Replace any possible leading blanks with zeros
for I:= 0, SIZE-1 do
	if FIELD(I) = SP then FIELD(I):= FILL
	else I:= SIZE-1;		\(Exit 'for' loop)

\While last place FIELD(SIZE-1) is non-numeric do...
while FIELD(SIZE-1)<^0 ! FIELD(SIZE-1)>^9 do
    for I:= -(SIZE-1), 0 do		\Shift digits one place right
	if -I >= 1 then FIELD(-I):= FIELD(-I-1)	\Shift right
	else FIELD(0):= FILL;		\Shift a zero into left-most place
end;	\JUSTIFY



proc	GETINT(FIELD, S, X, Y, HINT);	\Get an integer from the operator
char	FIELD;
int	S, X, Y, HINT;
int	NUM;
begin
GETFLD(FIELD, S, X, Y, true, HINT);
NUM:= STR2INT(FIELD, S);		\Convert string to binary
OPENO(8);   SPOUT(8, S);
OPENO(8);   INTOUT(8, NUM);		\Convert binary to a string
COPYBUF(FIELD, S);
JUSTIFY(FIELD, S);
SHOWFLD(FIELD, S, X, Y);
end;	\GETINT

\----------------------------------------------------------------------

func real STR2RL(Str, Size);
char	Str;
int	Size;
real	X;
begin
Str(Size-1):= Str(Size-1) ! $80;
X:= AtoF(Str);
Str(Size-1):= Str(Size-1) & $7f;
return X;
end;	\STR2RL



proc	GETRL(FIELD, S, X, Y, M, N, HINT);	\Get a real number from the operator
char	FIELD;	\Address of field
int	S,	\Size
	X, Y,	\Coordinates
	M, N,	\Format
	HINT;	\Hint string
real	NUM;
int	I;
begin
GETFLD(FIELD, S, X, Y, true, HINT);
NUM:= STR2RL(FIELD, S);
FORMAT(M, N);
OPENO(8);
RLOUT(8, NUM);
COPYBUF(FIELD, S);
SHOWFLD(FIELD, S, X, Y);
end;	\GETRL

\############################### EXAMPLE ##############################

proc	MARK;		\EXAMPLE
int	ENT;
begin
CLRWIND;
WTXT(2, 0, "-- SET TABLE ENTRIES --

 ENTRY:

     X:

 DO IT:

  TEXT:

(0 enters current position)");

SHOWFLD(NN, NNSIZE, 16, 2);			\ENTRY
SHOWFLD(XX, XXSIZE, 16, 4);
SHOWYN(YY, 16, 6);
SHOWFLD(TT, TTSIZE, 16, 8);

ENT:= 0;
loop	begin
	case ENT of
	  0:	[repeat GETINT(NN, NNSIZE, 16, 2, "Enter selection (1 thru 40)");
		until VALCHK(NN, NNSIZE, 1, 40, " PLEASE SELECT 1 THRU 40")];
	  1:	GETRL(XX, XXSIZE, 16, 4, 2, 3, "Enter XX.XXX");
	  2:	GETYESNO(YY, 16, 6, "Enter Y(es) or N(o)");
	  3:	GETFLD(TT, TTSIZE, 16, 8, false, "Enter any text");
	  4:	\if POPYESNO(11, ^N, "Any changes?", " ") then ENT:= -1
		if POPYESNO(11, ^N, " ", "Any changes?") then ENT:= -1
	other	quit;

	if KEY = ESC then return;
	ENT:= ENT + (if KEY = -UPARROW then -1 else +1);
	if ENT < 0 then ENT:= 4;
	end;
\Act based on input data. Note that Esc by-passes this action.
\DATA(1):= STR2RL(XX, XXSIZE);
end;	\MARK



proc	MISCMENU;	\EXAMPLE: Show miscellaneous menu
char	STR;
begin
STR:= RESERVE(1);
loop begin
CLRWIND;

WTXT(2, 0, "-- MISCELLANEOUS MENU --

  0. Exit program
  1. Set table entries

Selection: _");

loop	begin
	STR(0):= ^_;
	GETINT(STR, 1, 11, 5, " ");
	if KEY = ESC then return;
	case STR2INT(STR, 1) of
	  0:	return;
	  1:	[MARK;   quit]
	other ERRMSG(" PLEASE TYPE ^"0^" THRU ^"1^"");
	end;
end;	\loop
end;	\MISCMENU



proc	INIT;		\Initialize fields with spaces
int	I;
begin
for I:= 0, NNSIZE-1 do NN(I):= SP;
for I:= 0, XXSIZE-1 do XX(I):= SP;
for I:= 0, YYSIZE-1 do YY(I):= SP;
for I:= 0, TTSIZE-1 do TT(I):= SP;
end;	\INIT



begin	\MAIN
Cpureg:= Getreg;
NN:= RESERVE(NNSIZE);
XX:= RESERVE(XXSIZE);
YY:= RESERVE(YYSIZE);
TT:= RESERVE(TTSIZE);

INIT;

ATTRIB(COLOR);
DRAWBOX(WINDOWX0-1, WINDOWY0-1, WINDOWX1-WINDOWX0+1+2, WINDOWY1-WINDOWY0+1+2, 0);

DRAWBOX(WINDOWX0-1, WINDOWY0-1, 
	WINDOWX1-WINDOWX0+1+2, WINDOWY1-WINDOWY0+1+2,
 0);

HILIGHT(WINDOWX0-1, WINDOWY0-1, WINDOWX1+1, WINDOWY1+1, COLOR);

SHOWCURSOR(false);
MISCMENU;
SHOWCURSOR(true);
CRLF(0);
TEXTN(0, NN, NNSIZE); CRLF(0);
TEXTN(0, XX, XXSIZE); CRLF(0);
TEXTN(0, YY, YYSIZE); CRLF(0);
TEXTN(0, TT, TTSIZE); CRLF(0);
end;	\MAIN
