\GETFLD2.XPL	SEP-17-95



func	GetInt(N0, Size, X, Y); \Input an integer; scroll calculator-style
int	N0,	\Initial value
	Size,	\Number of digits in field
	X, Y;	\Display position on screen
int	N,	\Number
	M,	\Maximum number +1
	Ch,	\Digit (character) from keyboard
	First;	\Flag: First digit clears display
begin
M:= 1;						\Create maximum number +1
for N:= 1, Size-1 do M:= M *10;

N:= N0;						\Get initial value
First:= true;
loop	begin
	Cursor(X, Y);				\Display our number
	JustOut(N, Size);

	Ch:= GetKey;
	case CH of
	  BS, -Delete: [N:= 0;   First:= true];
	  Esc:	return N0;			\Return original value
	  CR:	return N			\Return new value
	other
	    if Ch>=^0 & Ch<=^9 then		\Ignore other characters
		begin
		if First then N:= 0		\First digit replaces number
		else	if N < M then N:= N * 10;
		N:= N/10*10 + Ch-^0;
		First:= false;
		end
	end;	\loop
end;	\GetInt



func	STR2INT(STR, SIZE);	\Convert positive string to positive integer
\This ignores decimal points, commas, leading blanks, etc.
char	STR;
int	SIZE;
int	I, NUM, DIGIT;
begin
NUM:= 0;
for I:= 0, SIZE-1 do
	begin
        DIGIT:= STR(I);
	if DIGIT>=^0 & DIGIT<=^9 then
		NUM:= NUM *10 + (DIGIT -^0);
	end;
return NUM;
end;	\STR2INT



func real STR2RL(STR, SIZE);
\Read in the ASCII representation of a real number from the specified device
\ and return its value
char	STR;	\String
int	SIZE;	\Number of characters in STR
int	CH,	\Character
	INX,	\Index
	EX,	\Power-of-ten exponent, total effective value
	N,	\Exponent as specified by input
	NEG,	\Flag: Negative real number
	ENEG,	\Flag: Negative exponent
	DIGIT;	\Flag: Last character is a digit (0 thru 9)
real	X,	\Value of real number
	TEN;	\10.0, Avoids use of real constants which are not easily
		\ ported from one floating-point representation to another


	proc	GETCH;		\Get character from input device
	begin
	if INX < SIZE then
		[CH:= STR(INX);   INX:= INX +1]
	else CH:= ^0;

	DIGIT:= CH>=^0 & CH<=^9;	\Is it a digit?
	end;	\GETCH


begin	\STR2RL
INX:= 0;
TEN:= FLOAT(10);
NEG:= false;
loop	begin
	GETCH;		\Ignore any leading garbage
	if CH =^- then NEG:= ~NEG;
	if DIGIT then
		begin
		X:= FLOAT(CH -^0);
		loop	begin
			if INX >= SIZE then quit;
			GETCH;
			if ~DIGIT then quit;
			X:= X *TEN + FLOAT(CH -^0);
			end;
		quit;
		end;
	if CH=^. then [X:= FLOAT(0);   quit];
	end;
EX:= 0;
if CH = ^. then
	loop	begin
		if INX >= SIZE then quit;
		GETCH;
		if ~DIGIT then quit;
		X:= X *TEN + FLOAT(CH -^0);
		EX:= EX -1;	\if X gets bigger, the exponent
				\gets smaller
		end;
if CH=^E ! CH=^e then
	begin
	N:=0;
	GETCH;
	if CH = ^- then [ENEG:= true;   GETCH] else ENEG:= false;
	if CH = ^+ then GETCH;
	while DIGIT do [N:= N *10 +(CH -^0);   GETCH];
	EX:= EX + (if ENEG then -N else N);
	end;
while EX < 0 do [X:= X /TEN;   EX:= EX +1];
while EX > 0 do [X:= X *TEN;   EX:= EX -1];
return if NEG then -X else X;
end;	\STR2RL



func real HMS2RL(STR, SIZE);
\Input HH MM SS.S and return the equivalent hours (a real number).
char	STR;	\String containing HH MM SS.S
int	SIZE;	\Length of STR
int	INX,	\Index into STR array
	NEG; 	\Flag: Minus sign seen
real	NUM;	\Hours * 360000.0


	func	GETCH;		\Get next character from STR
	int	CH;
	begin
	if INX >= SIZE then return ^0;
	CH:= STR(INX);
	INX:= INX +1;
	return CH;
	end;	\GETCH



	func real GETNUM;	\Get number, look for minus signs
	int	CH, N;
	begin
	\Ignore leading garbage (i.e: non-numerics)
	loop	begin
		CH:= GETCH;
		if CH>=^0 & CH<=^9 ! CH=^- then quit;
		if CH=^. ! CH=^: then return 0;
		end;
	if CH=^- then [NEG:= true;   CH:= GETCH];

	N:= CH - ^0;
	loop	begin
		if INX >= SIZE then quit;
		CH:= GETCH;
		if CH<^0 ! CH>^9 then quit;
		N:= N*10 + CH-^0;
		end;

	return FLOAT(N);
	end;	\GETNUM


begin	\HMS2RL
INX:= 0;
NEG:= false;
NUM:= GETNUM *36000.0 + GETNUM *600.0 + GETNUM *10.0 + GETNUM;
if NEG then NUM:= -NUM;
return NUM /36000.0;
end;	\HMS2RL

\----------------------------------------------------------------------

proc	HMSOUT(DEV, HOURS, TENTHS);	\Output HOURS in the 
					\format: HH MM SS.S
int	DEV;		\Output device number
real	HOURS;		\Value to output
int	TENTHS;		\Flag: Display tenths of a second
int	H, II;


	proc	NUMOUT(N);
	\Output a positive 2-digit integer with leading zeros
	int	N;
	begin
	CHOUT(DEV, N/10 +^0);
	CHOUT(DEV, REM(0) +^0);
	end;	\NUMOUT


	func int INT(X);	\Return the integer part of a real
	real	X;
	begin
	X:= X - MOD(X, 1.0);
	return FIX(X);
	end;	\INT


begin	\HMSOUT
if HOURS < 0.0 then [CHOUT(DEV, ^-);   HOURS:= -HOURS]
else CHOUT(DEV, SP);

HOURS:= HOURS + (if TENTHS then 0.5 /36000.0 else 0.5 /3600.0);	\Round

II:= INT(HOURS);
NUMOUT(II);	CHOUT(DEV, ^ );

HOURS:= (HOURS - FLOAT(II)) *60.0;	\Minutes
II:= INT(HOURS);
NUMOUT(II);	CHOUT(DEV, ^ );

HOURS:= (HOURS - FLOAT(II)) *60.0;	\Seconds
II:= INT(HOURS);
NUMOUT(II);

if TENTHS then				\Show tenths of seconds
	begin
	CHOUT(DEV, ^.);
	HOURS:= (HOURS - FLOAT(II)) *10.0;
	II:= INT(HOURS);
	INTOUT(DEV, II);
	end;

\Integer version (modify compiler to handle large constants)
\H:= FIX(HOURS *36000.0);
\if H < 0 then
\	[CHOUT(DEV, ^-);   H:= -H]
\else CHOUT(DEV, SP);
\
\if H > 3599999 then H:= 3599999;		\\Limit to 99:59:59.9
\II:= H /36000;	H:= REM(0);
\NUMOUT(II);	CHOUT(DEV, ^ );
\
\II:= H /600;	H:= REM(0);
\NUMOUT(II);	CHOUT(DEV, ^ );
\
\II:= H /10;	H:= REM(0);
\NUMOUT(II);
\
\if TENTHS then				\\Show tenths of seconds
\	[CHOUT(DEV, ^.);   CHOUT(DEV, H +^0)];
end;	\HMSOUT



proc	GETHMS(FIELD, S, X, Y, TENTHS, HINT); \Get a HMS number from the operator
char	FIELD;
int	S, X, Y, TENTHS, HINT;
real	NUM;
int	I;
begin
GETFLD(FIELD, S, X, Y, true, HINT);
NUM:= HMS2RL(FIELD, S);		\Convert the string to binary
OPENO(BUF);   HMSOUT(BUF, NUM, TENTHS);	\Convert the binary to a string
COPYBUF(FIELD, S);
SHOWFLD(FIELD, S, X, Y);		\Show the string, skip sign
end;	\GETHMS

\----------------------------------------------------------------------

proc	DISINT(S, P);		\Display string then display and enter integer
char	S;
int	P;
begin
SLINE(S);   SLINE("  ");
INTOUT(0, IOWN(P));   SLINE("  ");
if LOOKKEY # CR then IOWN(P):= INTIN(0) else CRLF(0);
end;	\DISINT



proc	DISREAL(S, P);		\Display string then display and enter real
char	S;
int	P;
begin
SLINE(S);   SLINE("  ");
RLOUT(0, ROWN(P));   SLINE("  ");
if LOOKKEY # CR then ROWN(P):= RLIN(0) else CRLF(0);
end;	\DISREAL



proc	DISBOOL(S, P);		\Display string then display and enter boolean
char	S;
int	P, C;
begin
SLINE(S);
SLINE("  ");
CHOUT(0, if IOWN(P) then ^Y else ^N);
SLINE("  ");
if LOOKKEY # CR then
	begin
	C:= CHIN(1);
	IOWN(P):= C=^Y ! C=^y;
	end
else CRLF(0);
end;	\DISBOOL
