\GOLDMEAN.XPL	JAN-24-93
\Zooms in on the golden mean

include C:\CXPL\CODESI;

def	WIDTH=640-1, HEIGHT=480-1;

int	MODE;


def	AX, BX, CX, DX, DI, SI, BP, CF, CS, DS, SS, ES;	\GETREG registers



func	GETVID;		\Returns the current video mode
int	REG;	\Pointer to array of processor registers
begin
REG:= GETREG;
REG(AX):= $0F00;	\Function $0F
SOFTINT($10);		\Call BIOS routine
return REG(AX) & $FF;
end;	\GETVID



proc	WAITVB;		\Wait for the beginning of the next vertical blank
begin
while PIN($3DA, 0) & $08 do;		\Wait for no vertical blank
repeat until PIN($3DA, 0) & $08;	\Wait for vertical blank
end;	\WAITVB;



proc	CMOVE(X, Y);
int	X, Y;
begin
if X<0 then X:=0
else if X>WIDTH then X:=WIDTH;
if Y<0 then Y:=0
else if Y>HEIGHT then Y:=HEIGHT+1;
MOVE(X, Y);
end;	\CMOVE



proc	CLINE(X, Y, C);
int	X, Y, C;
begin
if X<0 then X:=0
else if X>WIDTH then X:=WIDTH;
if Y<0 then Y:=0
else if Y>HEIGHT then Y:=HEIGHT+1;
LINE(X, Y, C);
end;	\CLINE



proc	SQUARE(X, Y, S, C);
int	X, Y, S, C;
int	J;
begin
CMOVE(X-S+1, Y);
CLINE(X, Y, C);
CLINE(X, Y-S+1, C);
end;	\SQUARE



proc	DRAW;
real	GM, S0, S, X, Y;
int	C, C0;
def	S00 = 0.1;
begin
GM:= 1.0 + (SQRT(5.0)-1.0) / 2.0;
C0:= 0;
loop	begin
	S0:= S00;
	loop	begin
		C:= C0;
		S:= S0;
		X:= 1.0;
		Y:= 1.0;
		\WAITVB;
		loop	begin
			SQUARE(FIX(X), FIX(Y), FIX(S), C+1);

			S:= S *GM;
			Y:= Y +S;
			C:= (C +1) & 3;
			SQUARE(FIX(X), FIX(Y), FIX(S), C+1);
	
			S:= S *GM;
			X:= X +S;
			C:= (C +1) & 3;
			if FIX(S) > WIDTH then quit;
			end;
		S0:= S0 * 1.001;
		if S0 > S00 *(1.0+GM) then quit;
		if CHKKEY then quit;
		end;
	C0:= (C0 +2) & 3;
	if CHKKEY then quit;
	end;
end;	\DRAW



begin
MODE:= GETVID;
SETVID($12);	\640x480x16

DRAW;

SETVID(MODE);
end;
