
\IBM PC XPL CODE SET FOR XPL V5.6I

include \CXPL\CODESI.XPL;

define MAXWIND=5;

integer ACTWIND;

integer MAXX,MAXY,ORX,ORY;

real XSCALE,YSCALE,XOFF,YOFF;

integer X,VIDMOD;

procedure WINDOW(X1,Y1,X2,Y2);
\OPEN A WINDOW
\ X1Y1= LOWER LEFT CORNER
\ X2Y2= UPPER RIGHT CORNER
integer X1,Y1,X2,Y2;
begin
MOVE(X1,Y1);
LINE(X2,Y1,1);LINE(X2,Y2,1);
LINE(X1,Y2,1);LINE(X1,Y1,1);
MAXX(ACTWIND):=ABS(X2-X1);MAXY(ACTWIND):=ABS(Y2-Y1);
ORX(ACTWIND):=X1;ORY(ACTWIND):=Y1;
end;



procedure OPOINT(X,Y,C);
\PLACE POINT, REFERENCED TO ORIGIN
integer X,Y,C;
POINT(ORX(ACTWIND)+X,ORY(ACTWIND)-Y,C);



procedure OLINE(X,Y,C);
\DRAW LINE, REFERRENCE TO ORIGIN
integer X,Y,C;
LINE(ORX(ACTWIND)+X,ORY(ACTWIND)-Y,C);



procedure OMOVE(X,Y);
\MOVE, REFERENCED TO ORIGIN
integer X,Y;
MOVE(ORX(ACTWIND)+X,ORY(ACTWIND)-Y);



procedure RLINE(X,Y,C);
\DRAW SCALED AND OFFSET LINE
real X,Y;
integer C;
OLINE(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)),C);



procedure RPOINT(X,Y,C);
\PLACE SCALED AND OFFSET POINT
real X,Y;
integer C;
OPOINT(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)),C);



procedure RMOVE(X,Y);
\MOVE SCALED AND OFFSET
real X,Y;
OMOVE(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)));


procedure SYMBOL(T,X,Y);
\PLACE A SYMBOL IN WINDOW
\SYMBOL TYPE IN T
real X,Y;
integer T,X1,Y1,SHAPE;
begin
SHAPE:=[
[[2,2],[2,-2],[-2,-2],[-2,2],[2,2]], \SQUARE
[[0,2],[2,0],[0,-2],[-2,0],[0,2]], \DIAMOND
[[2,2],[-2,-2],[2,-2],[-2,2],[2,2]] \X
];
if T>=3 then T:=0;

X1:=FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND));
Y1:=FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND));
OMOVE(X1+SHAPE(T,0,0),Y1+SHAPE(T,0,1));
OLINE(X1+SHAPE(T,1,0),Y1+SHAPE(T,1,1),1);
OLINE(X1+SHAPE(T,2,0),Y1+SHAPE(T,2,1),1);
OLINE(X1+SHAPE(T,3,0),Y1+SHAPE(T,3,1),1);
OLINE(X1+SHAPE(T,4,0),Y1+SHAPE(T,4,1),1);
end;


procedure VGRID(X,R1,R2);
\DRAW VERTICAL GRID
\NUMBER OF LINES IN X
\START AND END OF SCALE IN R1 AND R2
integer X;
real R1,R2,DL;
integer O,I;
begin
XSCALE(ACTWIND):=FLOAT(MAXX(ACTWIND))/(R2-R1);
XOFF(ACTWIND):=R1;

O:=MAXX(ACTWIND)/X;
for I:=1,X do
	begin
	OMOVE(I*O,0);
	OLINE(I*O,MAXY(ACTWIND),1);
	end;


FORMAT(2,1);
DL:=(R2-R1)/FLOAT(X);
for I:=0,X do
	begin
	CURSOR((I*O+ORX(ACTWIND))/8-5,(ORY(ACTWIND)/8)+1);
	RLOUT(0,R1);
	R1:=R1+DL;
	end;
end;




procedure HGRID(Y,R1,R2);
\DRAW VERTICAL GRID
\NUMBER OF LINES IN X
\START AND END OF SCALE IN R1 AND R2
integer Y;
real R1,R2,DL;
integer O,I;
begin
YSCALE(ACTWIND):=FLOAT(MAXY(ACTWIND))/(R2-R1);
YOFF(ACTWIND):=R1;

O:=MAXY(ACTWIND)/Y;
for I:=1,Y do
	begin
	OMOVE(0,O*I);
	OLINE(MAXX(ACTWIND),O*I,1);
	end;

FORMAT(2,1);
DL:=(R2-R1)/FLOAT(Y);
for I:=0,Y do
	begin
	CURSOR((ORX(ACTWIND)/8)-5,(ORY(ACTWIND)-(O*I))/8);
	RLOUT(0,R1);
	R1:=R1+DL;
	end;
end;



procedure SETWND;
begin
ACTWIND:=0;
SETVID(VIDMOD);
WINDOW(80,85,639,0);
VGRID(5,0.,128.);
HGRID(5,-40.,0.);

ACTWIND:=1;
WINDOW(80,190,639,105);
VGRID(6,-3.,3.);
HGRID(6,-12.,12.0);
end;


procedure TEST;
real X,Y;
int S;
begin
CURSOR(0,0);
ACTWIND:=0;
loop
	begin
	X:=RLIN(0);
	if X<0.0 then quit;
	Y:=RLIN(0);
	S:=INTIN(0);
	SYMBOL(X,Y,S);
	end;
ACTWIND:=1;
loop
	begin
	X:=RLIN(0);
	if X<0.0 then quit;
	Y:=RLIN(0);
	S:=INTIN(0);
	SYMBOL(X,Y,S);
	end;
SETVID(3);
end;



begin
MAXX:=RESERVE(MAXWIND*2);
MAXY:=RESERVE(MAXWIND*2);
ORX:=RESERVE(MAXWIND*2);
ORY:=RESERVE(MAXWIND*2);

XSCALE:=RLRES(MAXWIND);
YSCALE:=RLRES(MAXWIND);
XOFF:=RLRES(MAXWIND);
YOFF:=RLRES(MAXWIND);
TEXT(0,"EGA COMPATABLE? Y/N");
VIDMOD:=CHIN(1);
VIDMOD:=if VIDMOD=^Y ! VIDMOD=^y then $0E else 6;

SETWND;
TEST;
end;
