\GRAPH.XPL
\Routines to draw graphs

inc	C:\CXPL\CODESI;

int	MAXX, MAXY,	\Height and width of window
	ORX, ORY;	\Origin; Pixel coordinate of upper-left corner of window
real	XSCALE, YSCALE,
	XOFF, YOFF;



proc	WINDOW(X1, Y1, X2, Y2);	\Open a window
int	X1, Y1, 	\Lower-left corner
	X2, Y2;		\Upper-right corner
begin
MOVE(X1, Y1);
LINE(X2, Y1, 1);
LINE(X2, Y2, 1);
LINE(X1, Y2, 1);
LINE(X1, Y1, 1);

MAXX:= ABS(X2-X1);   MAXY:= ABS(Y2-Y1);
ORX:= X1;   ORY:= Y1;
end;	\WINDOW



proc	OPOINT(X, Y, C);	\Draw a point; referenced to origin (window)
int	X, Y, C;
POINT(ORX+X, ORY-Y, C);



proc	OLINE(X, Y, C);		\Draw line, referrenced to origin
int	X, Y, C;
LINE(ORX+X, ORY-Y, C);



proc	OMOVE(X, Y);		\Move, referenced to origin
int	X, Y;
MOVE(ORX+X, ORY-Y);



proc	RLINE(X, Y, C);		\Draw scaled and offset line
real	X, Y;
int	C;
OLINE(FIX((X-XOFF)*XSCALE), FIX((Y-YOFF)*YSCALE), C);



proc	RPOINT(X, Y, C);	\Draw scaled and offset point
real	X, Y;
int	C;
OPOINT(FIX((X-XOFF)*XSCALE), FIX((Y-YOFF)*YSCALE), C);



proc	RMOVE(X, Y);		\Move scaled and offset
real	X, Y;
OMOVE(FIX((X-XOFF)*XSCALE), FIX((Y-YOFF)*YSCALE));



proc	SYMBOL(X, Y, T);	\Draw symbol referenced to origin
real	X, Y;
int	T;			\Type of symbol (0..2)
int	X1, Y1, SHAPE, I;
begin
SHAPE:=[[[ 2,  2], [ 2, -2], [-2, -2], [-2,  2], [ 2,  2]], 	\SQUARE
	[[ 0,  2], [ 2,  0], [ 0, -2], [-2,  0], [ 0,  2]], 	\DIAMOND
	[[ 2,  2], [-2, -2], [ 2, -2], [-2,  2], [ 2,  2]]];	\X

X1:= FIX((X-XOFF) *XSCALE);
Y1:= FIX((Y-YOFF) *YSCALE);
OMOVE(X1+SHAPE(T, 0, 0),  Y1+SHAPE(T, 0, 1));
for I:= 1, 4 do
	OLINE(X1+SHAPE(T, I, 0),  Y1+SHAPE(T, I, 1), 1);
end;	\SYMBOL



proc	VGRID(X, R1, R2);	\Draw vertical grid
int	X;		\Number of lines
real	R1, R2;		\Start and end of scale
real	DL;
int	O, I;
begin
XSCALE:= FLOAT(MAXX) /(R2-R1);
XOFF:= R1;

O:= MAXX /X;
for I:= 1, X do
	begin
	OMOVE(I*O, 0);
	OLINE(I*O, MAXY, 1);
	end;

FORMAT(2, 1);
DL:= (R2-R1) /FLOAT(X);
for I:= 0, X do
	begin
	CURSOR((I*O+ORX)/8-5, (ORY/8)+1);
	RLOUT(0, R1);
	R1:= R1+DL;
	end;
end;	\VGRID



proc	HGRID(Y, R1, R2);	\Draw horizontal grid
int	Y;		\Number of lines
real	R1, R2;		\Start and end of scale
real	DL;
int	O, I;
begin
YSCALE:= FLOAT(MAXY) /(R2-R1);
YOFF:= R1;

O:= MAXY /Y;
for I:= 1, Y do
	begin
	OMOVE(0, O*I);
	OLINE(MAXX, O*I, 1);
	end;

FORMAT(2, 1);
DL:= (R2-R1) /FLOAT(Y);
for I:= 0, Y do
	begin
	CURSOR((ORX/8)-5, (ORY-(O*I))/8);
	RLOUT(0, R1);
	R1:= R1+DL;
	end;
end;	\HGRID



proc	SETWND;
begin
SETVID(6);
WINDOW(320, 189, 639, 0);
VGRID(5, 0.0, 3.0);
HGRID(5, 0.0, 12.0);
end;	\SETWIND



proc	TEST;
real	X, Y;
int	S;
begin
loop	begin
	X:= RLIN(0);
	Y:= RLIN(0);
	S:= INTIN(0);
	SYMBOL(X, Y, S);
	end;
end;



begin	\MAIN
SETWND;
TEST;
end;	\MAIN
