\HAMURABI.XPL			4/15/81
\ BY LOREN BLANEY
\ HAMMURABI GAME TRANSLATED FROM THE BASIC VERSION IN
\ "WHAT TO DO AFTER YOU HIT RETURN," BY DIVID AHL.

code	ABS=0, RND=1, REM=2, RESERVE=3, SWAP=4, EXTEND=5,
	SHORT=6, CHIN=7, CHOUT=8, CRLF=9, INTIN=10, INTOUT=11,
	TEXT=12, OPENI=13, OPENO=14, CLOSE=15, ABORT=16;

def	TV=0, KB=0;

int	ACRES,
	YEAR,
	X,  		\TEMPORARY SCRATCH
	PRICE,		\BUSHELS PER ACRE
	FEED,		\BUSHELS FED TO PEOPLE
	SUPPORT,	\NO. OF PEOPLE WHICH CAN LIVE ON "FEED"
	PLANT,		\ACRES PLANTED
	DEATHS,		\BY STARVATION
	TOLL,		\ACCUMULATIVE DEATHS
	RATS,		\BUSHELS EATEN BY RATS
	HARVEST,
	IMMIGRANTS,	\INCLUDES BIRTHS
	LAND,		\ACRES PER PERSON
	POPULATION,
	STORED,		\BUSHELS IN STORAGE
	YIELD;		\BUSHELS PER ACRE


proc	PRINT(I);	\PRINT A LINE OF TEXT
addr	I;
[TEXT(TV, I); CRLF(TV)];


proc	IMPEACH;
begin
PRINT("DUE TO THIS EXTREME MISMANAGEMENT YOU HAVE NOT ONLY");
PRINT("BEEN IMPEACHED AND THROWN OUT OF OFFICE BUT YOU HAVE");
PRINT("ALSO BEEN DECLAIRED A NATIONAL FINK!");
ABORT;
end;


proc	ERR710;
begin
PRINT("HAMMURABI:  THINK AGAIN.  YOU HAVE ONLY");
INTOUT(TV, STORED); PRINT(" BUSHELS OF GRAIN.  NOW THEN,");
end;


proc	ERR720;
begin
TEXT(TV, "HAMMURABI:  THINK AGAIN.  YOU OWN ONLY ");
INTOUT(TV, ACRES); PRINT(" ACRES.  NOW THEN,");
end;


proc	RESIGN;
begin
PRINT("HAMMURABI:  I CANNOT DO WHAT YOU WISH.");
PRINT("GET YOURSELF ANOTHER STEWARD!!");
ABORT;
end;


proc	EVALUATION;
begin
LAND:= ACRES /POPULATION;
TEXT(TV, "IN YOUR 10-YEAR TERM OF OFFICE A TOTAL OF ");
INTOUT(TV, TOLL); PRINT(" PEOPLE STARVED!!");
PRINT("YOU STARTED WITH 10 ACRES PER PERSON AND ENDED WITH");
INTOUT(TV, LAND); PRINT(" ACRES PER PERSON.");

if TOLL > 330 ! LAND < 7 then IMPEACH

else if TOLL > 100 ! LAND < 9 then [PRINT(
"YOUR HEAVY-HANDED PERFORMANCE SMACKS OF NERO AND IVAN IV.");
PRINT(
"THE PEOPLE (REMAINING) FIND YOU AN UNPLEASNT RULER, AND,");
PRINT("FRANKLY, HATE YOUR GUTS!");
ABORT]

else if TOLL > 30 ! LAND < 10 then [PRINT(
"YOUR PERFORMANCE COULD HAVE BEEN SOME WHAT BETTER, BUT");
TEXT(TV, "REALLY WASN`T TOO BAD AT ALL.  ");
INTOUT(TV, POPULATION *RND(80) /100); PRINT(" PEOPLE");
PRINT(
"WOULD DEARLY LIKE TO SEE YOU ASSASSINATED, BUT WE ALL HAVE");
PRINT("OUR TRIVIAL PROBLEMS.");
ABORT]

else [PRINT(
"A FANTASTIC PERFORMANCE!!!  CHARLEMANGE, DISRAELI, AND");
PRINT("JEFFERSON COMBINED COULD NOT HAVE DONE BETTER!");
ABORT];
end;


proc	GAME;
begin
CRLF(TV);
PRINT("HAMMURABI:  I BEG TO REPORT TO YOU,");
YEAR:=YEAR+1;
TEXT(TV, "IN YEAR "); INTOUT(TV, YEAR); TEXT(TV, ", ");
INTOUT(TV, DEATHS); TEXT(TV, " PEOPLE STARVED, ");
INTOUT(TV, IMMIGRANTS); PRINT(" CAME TO THE CITY,");

POPULATION:= POPULATION +IMMIGRANTS;
if RND(100) < 7 then
	[POPULATION:= POPULATION/2;
	PRINT(
	 "A HORRIBLE PLAGUE STRUCK!  HALF THE PEOPLE DIED.")];
TEXT(TV, "POPULATION IS NOW "); INTOUT(TV, POPULATION);
CRLF(TV);

TEXT(TV, "THE CITY NOW OWNS "); INTOUT(TV, ACRES);
PRINT(" ACRES.");
TEXT(TV, "YOU HARVESTED "); INTOUT(TV, YIELD);
PRINT(" BUSHELS PER ACRE.");
TEXT(TV, "RATS ATE "); INTOUT(TV, RATS); PRINT(" BUSHELS.");
TEXT(TV, "YOU NOW HAVE "); INTOUT(TV, STORED);
PRINT(" BUSHELS IN STORE.");
CRLF(TV);

if YEAR = 11 then EVALUATION;	\(EVALUATION ABORTS)
\ ***********************************************

PRICE:= RND(10) +17;
TEXT(TV, "LAND IS TRADING AT "); INTOUT(TV, PRICE);
PRINT(" BUSHELS PER ACRE.");
loop	begin
	TEXT(TV, "HOW MANY ACRES DO YOU WISH TO BUY?  ");
	X:= INTIN(KB);
	if X < 0 then RESIGN;
	if PRICE *X <= STORED then quit;
	ERR710;
	end;
ACRES:= ACRES +X; STORED:= STORED -PRICE *X;
if X = 0 then
	begin
		loop begin
		TEXT(TV, "HOW MANY ACRES DO YOU WISH TO SELL?  ");
		X:= INTIN(KB); 
		if X < 0 then RESIGN;
		if X <= ACRES then quit;
		ERR720;
		end;
	ACRES:= ACRES -X; STORED:= STORED +PRICE *X;
	end;

loop	begin
	TEXT(TV,
	"HOW MANY BUSHELS DO YOU WISH TO FEED YOUR PEOPLE?  ");
	FEED:= INTIN(KB);
	if FEED < 0 then RESIGN;
	\ TRYING TO USE MORE GRAIN THAN IS IN THE SILOS?
	if FEED <= STORED then quit;
	ERR710;
	end;
STORED:= STORED -FEED;

loop	begin
  loop  begin
    loop   begin
	TEXT(TV,
	"HOW MANY ACRES DO YOU WISH TO PLANT WITH SEED?  ");
	PLANT:= INTIN(KB);
	if PLANT < 0 then RESIGN;
	\ TRYING TO PLANT MORE ACRES THAN YOU OWN?
	if PLANT <= ACRES then quit;
	ERR720;
    end;
    \ ENOUGH GRAIN FOR SEED?
    if PLANT /2 <= STORED then quit;
    ERR710;
  end;
  \ ENOUGH PEOPLE TO TEND THE CROPS?
  if PLANT < 10 *POPULATION then quit;
  TEXT(TV, "BUT YOU HAVE ONLY "); INTOUT(TV, POPULATION);
  PRINT(" PEOPLE TO TEND THE FIELDS!  NOW THEN,");
end;
STORED:= STORED -PLANT /2;

\ A BOUNTIFUL HARVEST
YIELD:= RND(5) +1;
HARVEST:= PLANT *YIELD;
\ 40% CHANCE OF RATS EATING 25% TO 50% OF STORED GRAIN
if RND(100) <=40 then RATS:= STORED /(RND(3) +2)
	else RATS:=0;
STORED:= STORED -RATS +HARVEST;

IMMIGRANTS:=
	(RND(5) +1) *(ACRES +STORED/20) /POPULATION /5 +1;

\ HOW MANY PEOPLE SURVIVED ON WHAT WAS FED?
SUPPORT:= FEED /20;
if POPULATION <= SUPPORT then [DEATHS:= 0; return];
\ STARVE ENOUGH FOR IMPEACHMENT?
DEATHS:= POPULATION -SUPPORT;
if DEATHS > 9 *POPULATION /20 then
	[CRLF(TV);
	TEXT(TV, "YOU STARVED "); INTOUT(TV, DEATHS);
	PRINT(" PEOPLE IN ONE YEAR!!!");
	IMPEACH];
POPULATION:= SUPPORT; TOLL:= TOLL +DEATHS;
end;


begin		\MAIN PROC
CHOUT(TV, \FORM FEED\12);
PRINT("TRY YOUR HAND AT GOVERNING ANCIENT SUMERIA");
PRINT("FOR A TEN-YEAR TERM OF OFFICE.");

TOLL:= 0;
YEAR:= 0; POPULATION:= 95;
STORED:=2800; HARVEST:=3000; RATS:= HARVEST -STORED;
YIELD:=3; ACRES:=HARVEST /YIELD; IMMIGRANTS:=5;
DEATHS:=0;
loop GAME;
end;
