\HANOI256.XPL	MAY-27-90
\Towers of Hanoi solver in 256 bytes or less using XPL version 6.
\The paddle controls the speed.
\
\               <-- Top(1)
\            =I=                        I                         I
\           ==I==                       I                         I
\          ===I===                      I                         I
\         ====I====                     I <-- Top(2)              I <-- Top(3)
\    Center:  1                         2                         3

code	Reserve=3, ChIn=7, ChOut=8,
	CrLf=9, IntIn=10, IntOut=11,
	Text=12, Cursor=23, Paddle=38, Sound=39, Note=72;

def	FF=$0C, Sp=$20;
def	DiskCh= ^=, NeedleCh= ^I;	\Symbols used to draw disks & needles
def	TVW=80, TVH=24;			\Screen dimensions in characters

int	Disks,		\Number of disks
	Radius;		\Radius of disk (in characters)
addr	Top,		\Array: Line number above tower of disks
	Center;		\Array: Column number of each of the three needles



proc	Show(Cx, Cy, Ch);	\Draw (or erase) a disk
int	Cx, Cy, Ch;
int	I;	\(This is here so "ShowHalf" is an optimized procedure)
\Also inputs Radius


	proc	ShowHalf;	\Show (or clear) half of a disk
	for I:= 1, Radius do ChOut(0, Ch);


begin
Cursor(Center(Cx)-Radius, Top(Cy));
ShowHalf;
ChOut(0, Needlech);
ShowHalf;
end;	\Show



proc	MoveTower(From, To, Using);
int	From, To, Using;
begin
Radius:= Radius -1;
if Radius >0 then
	begin
	MoveTower(From, Using, To);	\Move subtower from "From" to "Using"
					\"Subtower" is tower above bottom disk
	Top(From):= Top(From) +1;	\Move bottom disk from "From" to "To"
	Show(From, From, Sp);		\Erase disk on "From" needle

	Show(To, To, DiskCh);		\Show disk on "To" needle
	Top(To):= Top(To) -1;

	Sound(1, 4, Radius*50);		\Make clink sound
	Sound(0, 500, Paddle(0));	\Delay according to paddle position

	MoveTower(Using, To, From);	\Move subtower from "Using" to "To"
	end;
Radius:= Radius +1;
end;	\MoveTower



begin	\Main
Top:= Reserve(4);	\The first element, Top(0), is not used
Center:= Reserve(4);
ChOut(0, FF);
loop	begin
	Cursor(0, 0);   Note(0, 'HOW MANY DISKS? ');
	Disks:= IntIn(0);

	Center(1):= 13;		\TVW /6 = 13
	Center(2):= 3 *13;	\TVW /6 = 13
	Center(3):= 5 *13;	\TVW /6 = 13

	ChOut(0, FF);			\Set up the initial display
	for Radius:= 1, Disks do
		begin
		Top(3):= TVH -1 -Disks +Radius;
		Show(1, 3, DiskCh);
		Show(2, 3, Sp);
		Show(3, 3, Sp);
		end;
	\Radius  =  Disks +1;
	\Top(3)  =  TVH -1 -Disks +Disks  =  TVH -1
	Top(1):= TVH -1 -Disks;		\Needle 1 initially has all the disks
	Top(2):= TVH -1;		\Needles 2 and 3 are empty

	MoveTower(1, 3, 2);		\Move tower from needle 1 to 3 using 2
	end;
end;	\Main
