\HARP.XPL	DEC-09-91
\BY LOREN BLANEY (XDIR BY LARRY FISH)
\
\REVISION HISTORY:
\APR-15-81, ORIGINAL
\OCT-31-88, FIXED DIVIDE BY ZERO BUG
\DEC-09-91, MODIFIED TO RUN ON PC WITH XDIR

int	TEMPO, DURATION, PERIOD, VOLUME, CYCLES;
int	INHANDLE;

\DIRECTORY PROGRAM
include \CXPL\CODESI.XPL;

define		\SOME ASCII CHARACTERS
	BS=8,		\BACKSPACE
	DEL=8,		\DELETE CHARACTER
	SP=$20,		\SPACE
	ESC=$1B,	\ESCAPE
	CR=13,		\CARRIAGE RETURN
	LF=10,		\LINE FEED
	FF=12;		\FORM FEED


char	FNAME;		\FILE NAME
define	FNMSIZ=52;	\FILE NAME SIZE


\** WINDOW AND MENU VARIABLES **

integer
	MONITOR,		\HOLDS TYPE OF VIDEO MONITOR
	ATTRIB1,ATTRIB2,	\VIDEO ATTRIBUTES FOR WINDOWS
	ATTRIB3,ATTRIB4,
	ATTRIB5,HIATT1;

define
	BWHITE,		\BLACK AND WHITE MONITOR TYPE
	COLOR;		\COLOR MONITOR TYPE

integer
	DATASEG,\CURRENT DATA SEGMENT
	CPUREG;	\SYSTEM INFO

\KEY BOARD SCAN CODE DEFINITIONS

define
	FUNC1=59,	\FUNCTION 1
	FUNC2=60,	\FUCNTION 2
	PAGEDN=81,	\PAGE DOWN KEY
	PAGEUP=73,	\PAGE UP KEY
	HOME=71,	\HOME KEY
	END=79,		\END KEY
	UPARROW=72,	\UP ARROW KEY
	DNARROW=80;	\DOWN ARROW KEY


\***** LOW LEVEL DEVICE DEPENDENT IO *****


procedure GETSTR(STR,LEN);
\DO CONTROLLED STRING INPUT
address STR;
integer LEN,PTR,C;
begin
OPENI(0);
PTR:=0;
loop
	begin
	C:=CHIN(1);
	case C of
	DEL: if PTR#0 then [CHOUT(0,BS);CHOUT(0,SP);CHOUT(0,BS);PTR:=PTR-1;];
	ESC: [PTR:=0; quit;];
	CR,0: quit
	else if PTR<LEN & C>$1F then [STR(PTR):=C;CHOUT(0,C);PTR:=PTR+1;];
	end;
if PTR>0 then STR(PTR-1):=STR(PTR-1) ! $80 else STR(0):=C ! $80;
end;


procedure ALPHA(C);
\RETURN TRUE IF ASCII NUMERIC
integer C;
[C:=C & $7F;return (C>=^A & C<=^Z) ! (C>=^a & C<=^z);];



procedure BLANK;
\BLANK THE SCREEN
CHOUT(0,FF);


procedure STRLEN(S);
\FIND STRING LENGTH
char S;
int I;
for I:=0,32767 do
if S(I)>$7F then return I+1;



procedure ZERTRM(S1,S2);
\MAKE S1 ZERO TERMINATED STRING RESULT IN S2
char S1,S2;int P,C;
begin
for P:=0,32000 do
	begin
	C:=S1(P);
	S2(P):=C&$7F;
	if C>$7F then [S2(P+1):=0;return;];
	end;
end;


procedure ZTEXT(D,S);
\OUTPUT A ZERO TERMINATED STRING
int D;char S;int P;
for P:=0,32000 do [if S(P)=0 then return P;CHOUT(D,S(P));];


procedure Z2MCOPY(S1,S2);
\COPY ZERO TERMINATED STRING TO MSB TERMINATED
char S1,S2;
int P;
begin
for P:=0,32000 do
	begin
	S2(P):=S1(P);
	if S1(P)=0 then
		begin
		if P=0 then S2(0):=$A0
		else S2(P-1):=S2(P-1) ! $80;
		return;
		end;
	end;
end;



procedure DIRECTORY;
\This procedure handles all directory and file functions
\It returns the selected file in FNAME
integer SPTR,FPTR,COM,P,NAMES;
char FATT,DOSBUF,TEMPLATE;
integer X1,Y1,X2,Y2;
define MAXFILE=400;


	procedure GETFNAME;
	\MANUAL FILENAME ENTRY
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+2,Y1+18,X2-2,Y1+18,$02,true);
	TEXT(6,"FILE NAME: ");
	GETSTR(FNAME,FNMSIZ);
	ATTRIB(ATTRIB1);
	SETWIND(X1+2,Y1+18,X2-2,Y1+18,$02,true);
	end;


	procedure DISPATH;
	\DISPLAY CURRENT PATH
	char PATH;integer DRIVE;
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+2,Y1+14,X2-2,Y1+14,$FF02,true);
	PATH:=RESERVE(64);
	CPUREG(0):=$4700;
	CPUREG(3):=0;
	CPUREG(9):=DATASEG;
	CPUREG(5):=PATH;
	SOFTINT($21);
	CPUREG(0):=$1900;
	SOFTINT($21);
	CHOUT(6,(CPUREG(0) & $FF) + ^A);
	TEXT(6,":\");ZTEXT(6,PATH);
	end;


	procedure DISTEMP;
	\DISPLAY CURRENT TEMPLATE
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+14,Y1+16,X1+14+13,Y1+16,$FF02,true);
	ZTEXT(6,TEMPLATE);
	end;


	procedure DISENTRY(P);
	\DISPLAY A DIRECTORY ENTRY
	int P,L;
	begin
	TEXT(6,"  ");
	if P<0 ! P>=FPTR then [TEXT(6,"               ");return;];
	if FATT(P)=$10 then [CHOUT(0,^<);L:=ZTEXT(6,NAMES(P));CHOUT(0,^>);]
		else L:=ZTEXT(6,NAMES(P));
	for P:=1,18-L do CHOUT(6,$20);
	end;


	procedure READDIR(T,E,A);
	\READ A DIRECTORY WITH SPECIFIED TEMPLATE AND ATTRIBUTES
	char T;int E,A,P;
	char S;
	begin	
	\LOOK UP FIRST FILE
	CPUREG(0):=$4E00; CPUREG(2):=$FFFF;
	CPUREG(9):=DATASEG;
	CPUREG(3):=T; SOFTINT($21);
	if (CPUREG(0) & $FF) # 0 then return;

	loop
		begin
		P:=0;
		if DOSBUF(21)=E ! DOSBUF(21)&A then
			begin
			S:=NAMES(FPTR);
			loop [S(P):=DOSBUF(30+P);if DOSBUF(30+P)=0 then quit;P:=P+1;];
			FATT(FPTR):=DOSBUF(21);
			FPTR:=FPTR+1;
			if FPTR>=MAXFILE then quit;
			end;

		\LOOK UP NEXT FILE
		CPUREG(0):=$4F00; SOFTINT($21);
		if (CPUREG(0) & $FF) # 0 then quit;
		end;
	end;


	procedure GETDIR;
	\GET THE CURRENT DOS DIRECTORY
	char TT;
	begin
	TT:=RESERVE(16);
	ZERTRM("*.*",TT);

	ATTRIB(ATTRIB2);
	SETWIND(X1+2,Y1+14,X2-2,Y1+14,$FF02,true);
	TEXT(6," READING DIRECTORY ");

	SPTR:=0;FPTR:=0;
	READDIR(TT,-1,$10);
	READDIR(TEMPLATE,0,$21);
	end;


	procedure CHDRIVE(C);
	\CHANGE DRIVES
	int C;
	char BUFFER;
	begin

	ATTRIB(ATTRIB2);
	SETWIND(X1+2,Y1+14,X2-2,Y1+14,$FF02,true);
	TEXT(6," TESTING DRIVE ");
	BUFFER:=RESERVE(512);
	C:=if C>=^a then C-^a else C-^A;
	TRAP($FFFB);
	READ(C,0,BUFFER,1);
	TRAP($FFFF);
	if GETERR#3 then
		begin
		CPUREG(3):=C & $FF;
		CPUREG(0):=$0E00;
		SOFTINT($21);
		end;
	GETDIR;
	end;


	procedure CHANGEDIR(P);
	\CHANGE DIRECTORIES
	int P;
	begin
	if FATT(P)# $10 then return;
	CPUREG(3):=NAMES(P);
	CPUREG(0):=$3B00;
	CPUREG(9):=DATASEG;
	SOFTINT($21);
	GETDIR;
	end;


	procedure GETEMPLATE;
	\ENTER TEMPLATE STRING
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+2,Y1+18,X2-2,Y1+18,$02,true);
	TEXT(6,"TEMPLATE: ");
	GETSTR(TEMPLATE,12);
	ZERTRM(TEMPLATE,TEMPLATE);
	ATTRIB(ATTRIB1);
	SETWIND(X1+2,Y1+18,X2-2,Y1+18,$02,true);
	GETDIR;
	end;


	procedure DISDIRECT;
	\DISPLAY DIRECTORY
	integer P1,P2,XX1,YY1,XX2,YY2,COM;
	define LINES=10,DIRWID=16;
	begin
	DISPATH;
	DISTEMP;

	ATTRIB(ATTRIB4);
	XX1:=X1+2;YY1:=Y1+3;
	XX2:=XX1+DIRWID;YY2:=YY1+LINES-1;
	SETWIND(XX1,YY1,XX2,YY2,$FF02,true);
	OPENI(0);
	SPTR:=0;
	loop
		begin
		for P1:=0,LINES-1 do
			begin
			P2:=SPTR-(LINES/2) + P1;
			CURSOR(XX1,YY1+P1);
			DISENTRY(P2);
			end;
		HILIGHT(XX1,YY1+LINES/2,XX2,YY1+LINES/2,HIATT1);
		
		CURSOR(0,24);
		COM:=CHIN(1);
		case of
		ALPHA(COM): quit;
		COM=CR: quit;
		COM=0:		begin
				COM:=CHIN(1);
				case COM of
				PAGEDN: SPTR:=if (SPTR+LINES) >=FPTR then FPTR-1 else SPTR+LINES;
				PAGEUP: SPTR:=if (SPTR-LINES) <0 then 0  else SPTR-LINES;
				HOME: SPTR:=0;
				END: SPTR:=FPTR-1;
				UPARROW: if SPTR>0 then SPTR:=SPTR-1;
				DNARROW: if SPTR<FPTR-1 then SPTR:=SPTR+1;
				FUNC1,FUNC2: quit
				other;
				end
		other;
		end;
	return COM;
	end;



procedure DISMENU;
begin
ATTRIB(ATTRIB1);
SETWIND(X1,Y1,X2,Y2+6,$FF02,true);
RAWTEXT(6,"ͻ
                 SELECT A FILE OR A DIRECTORY                   
͹
                      HOME/END  - START/END OF LIST            
                      PAGE UP   - UP ONE PAGE                  
                      PAGE DOWN - DOWN ONE PAGE                
                              - MOVE HIGHLIGHT               
                      RETURN    - SELECT FILE OR DIRECTORY     
                      A,B,C...  - CHANGE DISK DRIVE            
                      F1        - MANUAL FILE ENTRY            
                      F2        - CHANGE TEMPLATE              
                      <..>      - Move Up a Directory          
                      <name>    = Directory                    
͹
                                                                
͹
 TEMPLATE:                                                     
͹ 
                                                                
ͼ ");
HILIGHT(X1+22,Y1+3,X2-2,Y2-2,ATTRIB5);
end;



begin	\DIRECTORY
DOSBUF:=RESERVE(43);

\SETUP A DTA FOR DIRECTORY WORK
CPUREG(0):=$1A00;
CPUREG(3):=DOSBUF;
CPUREG(9):=DATASEG;
SOFTINT($21);

FATT:=RESERVE(MAXFILE);
NAMES:=RESERVE(MAXFILE*2);
for P:=0,MAXFILE-1 do NAMES(P):=RESERVE(13);
TEMPLATE:=RESERVE(16);
ZERTRM("*.MUS",TEMPLATE);
X1:=7;Y1:=2;
X2:=X1+66;Y2:=Y1+13;

BLANK;
GETDIR;
DISMENU;
loop 
	begin
	COM:=DISDIRECT;
	case of
	COM=CR: if FATT(SPTR)=$10 then CHANGEDIR(SPTR)
		else [Z2MCOPY(NAMES(SPTR),FNAME); return;];
	ALPHA(COM): CHDRIVE(COM);
	COM=FUNC2: GETEMPLATE;
	COM=FUNC1: [GETFNAME; return;]
	else;
	end;
end;	\DIRECTORY



procedure SETVIDEO;
\Do video specific setup
begin
CPUREG(0):= $0F00;
SOFTINT($10);
case CPUREG(0) & $FF of
	$02,$07: MONITOR:=BWHITE
else MONITOR:=COLOR;  
if MONITOR=COLOR then
	begin
	ATTRIB1:=$17;
	ATTRIB2:=$47;
	ATTRIB3:=$0E;
	ATTRIB4:=$02;
	ATTRIB5:=$1E;
	HIATT1:=$70;
	end
else	begin
	ATTRIB1:=$07;
	ATTRIB2:=$70;
	ATTRIB3:=$0F;
	ATTRIB4:=$0F;
	ATTRIB5:=$07;
	HIATT1:=$70;
	end;
end;	\SETVIDEO



begin	\MAIN 
CPUREG:=GETREG;
DATASEG:=CPUREG(12);
FNAME:=RESERVE(FNMSIZ);

SETVIDEO;
loop	begin
	DIRECTORY;

	\CHOUT(0,$0C);
	\TEXT(0,"WORKING NAME: ");
	\TEXT(0,FNAME);
	\CRLF(0);


	\MUSIC FILE CONSISTS OF:
	\TEMPO, PERIOD, DURATION (IN 1/64 NOTES)
	\ IF PERIOD=0 THEN VOLUME=0, I.E. REST NOTE.

	INHANDLE:= FOPEN(FNAME, 0);
	FSET(INHANDLE, ^I);
	OPENI(3);

	TEMPO:= INTIN(3);
	loop	begin
		PERIOD:= INTIN(3);	\GENERATE THE ACTUAL MELODY
		if PERIOD < 0 then quit;
		DURATION:= INTIN(3);
		VOLUME:= 1;
		if PERIOD = 0 then [VOLUME:= 0;   PERIOD:= 100];
		SOUND(VOLUME, DURATION, PERIOD*TEMPO);
		if CHKKEY then quit;
		end;

	FCLOSE(INHANDLE);
	end;
end;	\MAIN
