\HELP.XPL	JUL-02-88
\This program displays a series of screens which summarize Apex, V1.8 commands.
\
\REVISION HISTORY:
\MAR-03-86, Original.
\AUG-86, Convert to lower case.
\APR-10-87, Changed string termination.
\JUL-02-88, Changed messages slightly.

code CHIN=7, CHOUT=8, CRLF=9, TEXT=12, OPENI=13;


proc	PAGE(STR);	\Display a page of text
addr	STR;
int	I;
begin
CHOUT(0,$0C);				\Clear screen
TEXT(0,STR);				\Display page of text
OPENI(0);   I:=CHIN(0);			\Wait for return
end;	\PAGE


begin	\MAIN
PAGE("      -- APEX, V1.8 COMMANDS --

(The common commands are listed first.)

CTRL-C		Restarts Apex.

CTRL-P		Saves the current memory
		image in SCRATCH.SYS and
		reloads & restarts Apex.

DA(TE) (FILE)	Changes the system date
DA		or dates specified file.

DI(RECT) UNIT	Shows the directory of a
DI 0		unit.
/N /E /S /D /L	Sort by: Name, Extension,
		Size, Date or Location.

LI(ST) FILE	Displays the contents
LI FROG.TXT	of the specified file.

DE(LETE) FILE	Removes files from the
DE FROG.*	directory.
	(Press return to continue.) ");


PAGE(
"CTRL-S		Stops the display.

DF(AULT) (FILE)	Shows (or sets) the de-
DF 0:FROG.TXT	fault unit & file name.

DO OPTION	Enables the specified
DO PACK		option: PA(CK), CH(ECK),
		BA(CKUP) and AB(ORT).

NO OPTION	Disables the specified
NO PA		option.

NE(W)		Lets Apex know that you
		changed diskettes.
		(CTRL-C also does this.)

SA(VE) FILE	Writes the memory image
SA =$800,$FFF	into specified .SAV file.

RE(NAME) FL<FL	Changes the name of a
RE NEW<OLD	file in the directory.

TI(TLE) STRING	Changes the title of a
TI WORK DISK	unit. ");


PAGE(
"MA(KE) FILE	Creates a new file.
MA FROG=20,407	E.g: 20 blocks at 407.

BD(IRECTORY)	Shows the backup
BD FR?G.*	directory of a unit.
	/W	Writes the backup
		dir. over the main dir.
	/B	Writes the main dir.
		over the backup dir.

ST(ART)		Starts the program saved
		by a CTRL-P.

SW(AP)		Reloads the memory image
		saved by a CTRL-P and
		enters the debugger.

GE(T) FILE	Loads specified file and
GET FROG(.SAV)	enters the debugger.

OP(EN) FILE(S)	Opens specified files
OP FROG>FISH	for input and/or output.
	/R	Replaces input file with
		output file. ");


PAGE(
"CL(OSE)		Closes any output file.

SY(STEM) (UNIT)	Shows (or reboots from
		specified) system unit.

SI(ZE) UNIT	Shows, or changes, the
SI 1=2560	size of specified unit.

ZE(RO) UNIT	Deletes all files in
ZE 1		the directory of a
		specified unit.

LO(CK) UNIT	Prevents a unit from
LO 1		being written to.

UN(LOCK) UNIT	Unlocks a unit.

SU(BDIR) (FILE)	Enters a sub-directory
SU 1:WORK(.SBD)	or returns to root dir.
SU		if no file is specified.

FROG/E =200	Runs FROG.SAV instead
		of FROG.CMD.  Minimum
		out file is 200 blocks.");


PAGE("      -- COMMON UTILITY PROGRAMS --

ED FILE		Starts the text editor.
		(Must first MAKE new
		files.)

PR FILE		Prints specified file.

COPY		Copies individual files.

DUP		Duplicates an entire
		diskette.

SQ UNIT		Squashes files together.

SET FILE	Sets up .SAV file
		parameters.

INSTALL FILE	Installs I/O handlers
		such as for the printer.

CONFIG		Displays the currently
		installed handlers. ");


PAGE("     -- COMMON FILE EXTENSIONS --


.BAK	Backup file (may be any kind)

.CMD	Command file (executable)

.DOC	Documentation file

.OBJ	Object file (loadable)

.SAV	Saved memory image (executable)

.SBD	Sub-directory

.SYS	System file (for Apex only)

.TXT	Text file

.XPL	XPL source code for compiler

.68K	68000 source code for assembler ");

end;	\MAIN
