\HUFCODER.XPL		7-1-83
\HUFFMAN ENCODER
\BY LOREN BLANEY
\THIS PROGRAM TRANSLATES THE INPUT FILE FROM ASCII TO HUFFMAN.
\ IT USES THE CODES DETERMINED BY THE COMPANION PROGRAM,
\ "HUFFMAN".

code ABS=0, RAN=1, REM=2, RESERVE=3, SWAP=4, CHIN=7, CHOUT=8, CRLF=9
INTIN=10, INTOUT=11, TEXT=12, OPENI=13, OPENO=14, CLOSE=15, FREE=18;

def	TV=0, KB=0, PR=2, FILE=3;	\I/O DEVICE NUMBERS
def	LF=$0A, EOF=$1A, BEL=$07;

int	BYTE,	\8-BIT BUFFER FOR "BITOUT" PROCEDURE
	BITPTR;	\BIT POINTER (SHIFTING BIT)
int	HUFTBL;	\TABLE OF HUFMAN CODES

\----------------------------------------------------------------------\

proc	BITOUT(BIT);	\SEND A BIT TO THE OUTPUT FILE
\PACK 8 BITS PER BYTE THEN OUTPUT THE BYTE (MSB FIRST)
int	BIT;
begin
\CHOUT(0,BIT+^0); 'RETURN';		\\*** DEBUG ***
if BIT=1 then BYTE:=BYTE ! BITPTR;
BITPTR:=BITPTR/2;		\SHIFT BIT POINTER RIGHT
if BITPTR=0 then		\NEXT BYTE
	[CHOUT(FILE,BYTE);
	BITPTR:=$80;
	BYTE:=0];
end;	\BITOUT

\----------------------------------------------------------------------\

proc	ENCODE;
\CONVERT ASCII TO HUFFMAN CODE (ASCII CODED BINARY)
int	I,CH,TABLE;
char	CODE;
begin
TABLE:=[
\32\	"000",
\33\	"11111100",
\34\	"111111101",
\35\	"111001",
\36\	"0",
\37\	"0",
\38\	"111111111010",
\39\	"111000",
\40\	"0",
\41\	"0",
\42\	"0",
\43\	"0",
\44\	"11111101",
\45\	"0",
\46\	"110100",
\47\	"0",
\48\	"0",
\49\	"111111111011",
\50\	"0",
\51\	"111111111000",
\52\	"0",
\53\	"0",
\54\	"111111111001",
\55\	"111111111100",
\56\	"0",
\57\	"0",
\58\	"11111111011",
\59\	"0",
\60\	"0",
\61\	"0",
\62\	"0",
\63\	"0",
\64\	"0",
\65\	"0110",
\66\	"111100",
\67\	"110110",
\68\	"110111",
\69\	"001",
\70\	"1111010",
\71\	"110101",
\72\	"10100",
\73\	"1001",
\74\	"1111111100",
\75\	"1111101",
\76\	"10110",
\77\	"111010",
\78\	"0111",
\79\	"0101",
\80\	"1111011",
\81\	"11111111010",
\82\	"1000",
\83\	"10101",
\84\	"0100",
\85\	"10111",
\86\	"1111100",
\87\	"111011",
\88\	"111111111101",
\89\	"11000",
\90\	"111111100"];

loop	begin
	CH:=CHIN(FILE) & $7F;
	if CH=EOF then quit;
	while CH=LF do CH:=CHIN(FILE);	\GET RID OF THE DAMN LINE FEED
	if CH=13 then CODE:="11001" else CODE:=TABLE(CH-32);
	loop for I:=0,32767 do
		if CODE(I)<$80 then BITOUT(CODE(I)-^0)
		else [BITOUT((CODE(I)&$7F)-^0); quit];
	end;
end;	\ENCODE

\----------------------------------------------------------------------\

\'PROC'	SETUP;		\\SET UP "HUFTBL"
\'INT'	I;
\'BEGIN'
\'FOR'I:=0,$7F'DO'HUFTBL(I):=NIL;
\'LOOP'	'BEGIN'
\	CH:=CHIN(FILE) & $7F;
\	'IF'CH=EOF'THEN''QUIT';
\
\		\\READ IN THE CODE
\	'WHILE'CH#TAB'DO'CH:=CHIN(FILE);	\\SKIP TO TAB
\	I:=INTIN(FILE)
\
\	PNTR:=ALLOCATE();
\	HUFTBL(I):=PNTR;
\
\	I:=0;
\	'LOOP'	'BEGIN'
\		'CASE'CHIN(FILE)'DO'
\		  ^0:	[PNTR(I):=^0; I:=I+1];
\		  ^1:	[PNTR(I):=^1; I:=I+1];
\		  CR:	'QUIT'
\		'ELSE'	;
\	'END';
\'END';	\\SETUP

\----------------------------------------------------------------------\

begin	\MAIN
HUFTBL:=RESERVE($80*2);
TEXT(TV,"-- HUFFMAN ENCODER, VER 1.0X1 --
");

\SETUP;

OPENI(FILE);

OPENO(FILE);
BITPTR:=$80; BYTE:=0;	\INITIALIZE BITOUT PARAMETERS
ENCODE;

if BITPTR#$80 then	\CLOSE "BITOUT" PROC BY WRITING FINAL BYTE
	CHOUT(FILE,BYTE);
CLOSE(FILE);
end;	\MAIN
