\----------------------------------------------------------

procedure IBMOPEN;
\This routine opens an input and an output file (big buffers)
\using the command tail and the default extensions provided below:
\It only handles the basic case of a single file name given.
\it has an example switch use.

integer PSEG,CSEG,SYSINF;
addres TAIL,TLEN;

	function MAKUP(C);
	\CONVERT C TO UPPERCASE
	int C;
	return if C>=^a & C<=^z then C-32 else C;


	function GETSWT;
	\FIND, REMOVE AND RETURN NEXT AVAILABLE SWITCH
	integer P,T;
	begin
	for P:=0,TLEN(0) do if TAIL(P)=^/ then
		begin
		TAIL(P):=$20;	\so we know we took it
		if P<TLEN(0) then
			begin
			T:=TAIL(P+1);	\the switch character
			TAIL(P+1):=$20;	\so we know we took it
			return MAKUP(T);\in upper case, return it
			end;
		end;
	return 0;	\if none, return zero.
	end;



	procedure PARSE(EXT1,EXT2);
	address EXT1,EXT2;
	\PARSE COMMAND TAIL AND SET I/O HANDLES: OUTHAND AND INHAND.
	\this rather simple routine assumes only one file name was given, 
	\optionally with an input extension. The name part is also used to 
	\unconditionally open the output file.

	integer P,EFLG,I;
	begin
	P:=0;
	EFLG:=false;
	\PARSE COMMAND TAIL FOR EXTENTION

	loop
		begin
		if TAIL(P)=^. then
			begin
			EFLG:=true;
			quit;
			end;
		P:=P+1;
		if P>=TLEN(0) then
			begin
			EFLG:=false;
			quit;
			end;
		end;

	\SET EXTENTION AND INPUT HANDLE
	if not EFLG then
		for I:=0,3 do TAIL(P+I):=EXT1(I);
	TRAP(0);
	INHAND:=FOPEN(TAIL,0);
	if GETERR#0 then 
		begin 
		TEXT(0,"usage: >ASM65 infile [/C][/F][/P]
Switches select list device: C=console, F=file, P=printer, or none.");
		CRLF(0);
		exit ;
		end ;
	TRAP($FFFF);
	\SET EXTENTION AND OUTPUT HANDLE
	for I:=0,3 do TAIL(P+I):=EXT2(I);
	OUTHAND:=FOPEN(TAIL,1);
	end;



begin	\OF IBMOPEN

\GET COMMAND TAIL FROM PSP
TLEN:=RESERVE(80);
TAIL:=TLEN+1;
SYSINF:=GETREG;			\FETCH CPU REGISTERS
PSEG:=SYSINF(11);		\get the segment register contents
CSEG:=SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);	\copy over the command tail
if TLEN(0)>79 then TLEN(0):=79; \correct the limit

case GETSWT of 
	^F:	[BINDEV:=7;LDEV:=3];
	^P:	[LDEV:=2];
	^C:	[LDEV:=0];
	 0:	[]	\NONE, DO NOTHING
else [TEXT(0,"UNRECOGNIZED SWITCH");CRLF(0)];

\PARSE COMMAND LINE AND SET HANDLES
if BINDEV=3 then PARSE(".P65",".BIN")
	    else PARSE(".P65",".LST");


\OPEN FILES
FSET(INHAND,^I);
FSET(OUTHAND,^O);
end;



