\INTIO.XPL	MAY-14-00
\A pair of routines to replace INTIN and INTOUT intrinsics.

code	ABS=0,		RAN=1,		Rem=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	Chin=7,
	Chout=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	RESET=16,	TRAP=17,	FREE=18,	RERUN=19,
	POUT=20,	SETHP=21,	GETERR=22,	PIN=23,
	SOUND=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
	CLRWDT=28,	OPTION=29,	SLEEP=30;

int	Number;



func	IntinX(Dev);		\Input a decimal integer from specified device
int	Dev;			\ (Does not handle EOF like intrinsic does)
int	NF, Neg, Ch, N;
begin
NF:= false;
repeat	begin
	Ch:= Chin(Dev);
	Neg:= false;
	if Ch = ^- then
		begin
		Neg:= true;
		Ch:= Chin(Dev);
		end;
	N:= 0;
	loop	begin
		if Ch<^0 ! Ch>^9 then quit;
		NF:= true;		\indicate a digit was read in
		N:= N*10 + Ch-^0;
		Ch:= Chin(Dev);
		end;
	end;
until NF;
return if Neg then -N else N;
end;	\IntinX



proc	IntoutX(Dev, N);	\Output decimal integer N to specified device
int	Dev, N;
int	P, LZ, D;
begin
if N < 0 then
	begin
	N:= -N;
	Chout(Dev, ^-);
	end;
P:= 10000;
LZ:= false;
repeat	D:= N /P;
	N:= Rem(0);
	if LZ ! D \#0\ then
		begin
		Chout(Dev, D+^0);
		LZ:= true;
		end;
	P:= P /10;
until	P = 1;
Chout(Dev, N+^0);
end;	\IntoutX



begin	\Main
loop	begin
	Number:= IntinX(0);
	IntoutX(0, Number);
	Crlf(0);
	if Number = 0 then quit;
	end;

loop	begin
	Number:= Intin(0);
	Intout(0, Number);
	Crlf(0);
	if Number = 0 then quit;
	end;
end;	\Main
