\INTTEST.XPL	APR-12-91
\FUNDAMENTAL INTRINSIC TESTER

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	\TRAP=17,\	FREE=18,	RERUN=19,
	GETHP=20,	\SETHP=21,\	\GETERR=22,\	CURSOR=23,
	\FSET=24,\	\SETRUN=25,\	HEXIN=26,	HEXOUT=27,
\	CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
\	FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
\	BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
\	CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
\	READPIX=44,	SETVID=45	FIX=50,		POUT=64,
\	PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
\	ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72,
\	MALLOC=73,	RELEASE=74,	TRAPC=75,	TESTC=76,
	;

def	BEL=7, FF=$0C;
int	CH;
addr	ARRAY;



proc	ERROR(STR);	\DISPLAY ERROR MESSAGE
addr	STR;
begin
CHOUT(0, BEL);
TEXT(0, "ERROR: ");
TEXT(0, STR);
CRLF(0);
end;	\ERROR



proc	DOABS;
int	N;
begin
if ABS(-1)#1 then ERROR("ABS(-1)");
if ABS(12345)#12345 then ERROR("ABS(12345)");
if ABS(0)#0 then ERROR("ABS(0)");
if ABS(-5432)#5432 then ERROR("ABS(-5432)");
if ABS($8000)#$8000 then ERROR("ABS($8000)");
end;	\DOABS



proc	DORAN;
int	I, M, N;
begin
if RAN(1)#0 then ERROR("RAN(1)");
for N:= 1, 100 do
	if RAN(10)>=10 then ERROR("RAN(10) >= 10");

I:= RAN(0);
N:= RAN(1000);
I:= RAN(0);
M:= RAN(1000);
if N#M then ERROR("RAN(0) NOT REPEATABLE");

I:= RAN(-100);		\RANDOMIZE
end;	\DORAN



proc	DOREM;
int	M, N;
begin
if REM(17/5)#2 then ERROR("REM(17/5) # 2");
N:= 18/5;
M:= 4 * -3 *N;
if REM(0)#3 then ERROR("REM(18/5) # 3");

\NEGATIVE NUMBERS ARE NOT HANDLED CORRECTLY
end;	\DOREM



proc	DOSWAP;
int	N;
begin
if SWAP($1234) # $3412 then ERROR("SWAP($1234) # $3412");
if SWAP(0) # 0 then ERROR("SWAP(0) # 0");
if SWAP($FFFF) # $FFFF then ERROR("SWAP($FFFF) # $FFFF");
end;	\DOSWAP



proc	DOEXTEND;
int	N;
begin
if EXTEND($0034) # $0034 then ERROR("EXTEND($0034) # $0034");
if EXTEND($0084) # $FF84 then ERROR("EXTEND($0084) # $FF84");
if EXTEND($0FFF) # $FFFF then ERROR("EXTEND($0FFF) # $FFFF");
end;	\DOEXTEND



begin	\MAIN
if RERUN\=true\ then
	begin
	if ARRAY(0)#$34 then ERROR("RERUN: ARRAY(0) # $34");
	if ARRAY(1)#$12 then ERROR("RERUN: ARRAY(1) # $12");

	TEXT(0, "That's all folks...");		\APOSTROPHE IN STRING
	CLOSE(0);
	ABORT;
	end;

OPENO(0);
CHOUT(0, ^X);
TEXT(0, "PL INTRINSIC TESTER
");

ARRAY:= RESERVE($1000);
ARRAY(0):= $34;   ARRAY(1):= $12;
if ARRAY(0)#$34 then ERROR("ARRAY(0) # $34");
if ARRAY(1)#$12 then ERROR("ARRAY(1) # $12");

TEXT(0, "Character echo. Press ^"\^" to continue.");
						\BACKSLASH AND QUOTES IN STRING
CRLF(0);
OPENI(1);
loop	begin
	CH:=CHIN(1);
	CHOUT(1, CH);
	if CH=^\ then quit;
	end;
CRLF(0);

TEXT(0, "Number echo. Enter ^^0^^ to continue.");
						\META IN STRING
OPENI(0);
loop	begin
	CRLF(0);
	CH:= INTIN(0);
	INTOUT(0, CH);
	if CH=0 then quit;
	end;
CRLF(0);

CHOUT(0, FF);
TEXT(0, "Hex number echo. Enter ^"$1234^" to continue.");
OPENI(0);
loop	begin
	CURSOR(10, 2);
	CH:= HEXIN(0);
	CURSOR(10, 4);
	HEXOUT(0, CH);
	if CH=$1234 then quit;
	end;

CURSOR(0, 6);   TEXT(0,"FREE:	$");   HEXOUT(0, FREE);		\(PC TAB PROBLEM)
CURSOR(0, 8);   TEXT(0,"ARRAY:	$");   HEXOUT(0, ARRAY);
CURSOR(0,10);   TEXT(0,"HP:	$");   HEXOUT(0, GETHP);
CURSOR(0,12);

DOABS;
DORAN;
DOREM;
DOSWAP;
DOEXTEND;

RESTART;
ERROR("RESTART");
end;	\MAIN
