\JUL4.XPL	NOV-07-90

\REVISION HISTORY:
\JUL-04-85, ORIGINAL
\JUL-09-90, MODIFIED FOR PC
\NOV-07-90, SET 80x25 TEXT DISPLAY MODE WHEN EXITING, IMPROVED DELAY.

code	RAN=1, RESERVE=3, OPENI=13, OPENO=14, KEYHIT=33, SOUND=39,
	CLEAR=40, POINT=41, SETVID=45, FIX=50;
code real FLOAT=49, SIN=56, COS=60;

\NOTE: Y IS UPSIDE DOWN HERE, I.E. INCREASES DOWNWARD.

int	XX,XY,	\POSITION IN X AND Y (SCALLED BY $100)
	VX,VY,	\VELOCITY IN X AND Y (SCALLED BY $100)
	N,	\NUMBER OF PARTICLES
	POWER,	\POWER OF EXPLOSION
	VAR;	\VARIENCE IN VELOCITY OF THE PARTICLES
def	G=10;	\GRAVITATION CONSTANT



proc	BOOM;	\EXPLODE ROCKET
int	I,X,Y,GOING,T;
addr	AX,AY;
begin
AX:=addr X;
AY:=addr Y;
T:=0;
GOING:=true;
while GOING do
	begin
	GOING:=false;		\ASSUME IT'S BURNED OUT
	for I:=0,N-1 do
		begin
		X:=XX(I); Y:=XY(I);
		POINT(AX(1), AY(1), $00);	\CLEAR POINT (USE HIGH BYTE)
		if AY(1) < 192-12 & AX(1)>=0 then  \IF IT'S IN THE AIR
			begin
			X:=VX(I) + X;
			Y:=VY(I) + Y;
			VY(I):=VY(I) + G;
			XX(I):=X; XY(I):=Y;
			POINT(AX(1), AY(1), RAN(16));	\SET POINT
			GOING:=true;		\NOT BURNED OUT
			end;
		end;
	X:=XX(T); Y:=XY(T);
	POINT(AX(1), AY(1), $00);	\CLEAR POINT (USE HIGH BYTE)
	AY(1):=192;
	XY(T):=Y;
	if T<N-1 then T:=T+1;
	SOUND(0, 1, 1);	\DELAY
	end;
SOUND(0, 18, 1);	\DELAY 1 SECOND
end;	\BOOM



func	RANDOM(N);	\PLUS OR MINUS RANDOM NUMBER
int	N;
return if RAN(2)=1 then RAN(N) else -RAN(N);



func real RLRAN(N);	\RETURN A REAL RANDOM NUMBER 0.0 <= X < N
real	N;
return FLOAT( RAN(FIX(N*1000.0)) )/1000.0;



proc	ZOOM;	\SEND UP THE ROCKET AND INITIALIZE THE VELOCITIES
int	I,
	RXX,RXY,RVX,RVY;	\ROCKET PARAMETERS
def	PI2=6.283185307;
real	PX, PY,			\RANDOM X,Y COORDINATES
	PD, PD2,		\RANDOM DIRECTION
	PR, PR2;		\RANDOM RADII
addr	AX,AY;
begin
RXX:=220*$100; RXY:=180*$100;	\INITIAL ROCKET PARAMETERS
RVY:= -$100*100/N - G*N/2 + RANDOM(100);
RVX:= RVY/4 + RANDOM(30);
AX:=addr RXX;
AY:=addr RXY;
for I:=0,N-1 do
	begin
	POINT(AX(1), AY(1), $0F);		\SHOW ROCKET (HIGH BYTE)

	PR2:=FLOAT(POWER + RANDOM(VAR));	\GENERATE SPHERICALLY RANDOM
	PD:=RLRAN(PI2);				\ INITIAL VELOCITIES
	PD2:=RLRAN(PI2);			\(THIS IS CLOSE BUT IS BIASED)
	PR:=COS(PD2) * PR2;
	PX:=COS(PD) * PR;
	PY:=SIN(PD) * PR;
	VX(I):=FIX(PX);
	VY(I):=FIX(PY);

	POINT(AX(1), AY(1), $00);		\CLEAR ROCKET (HIGH BYTE)
	RXX:=RVX + RXX;
	RXY:=RVY + RXY;
	RVY:=RVY + G;
	SOUND(0, 1, 1);	\DELAY
	end;

POINT(AX(1), AY(1), $0F);		\SHOW ROCKET (HIGH BYTE)
for I:=0,N-1 do			\PARTICLES GET ROCKET'S POSITION AND VELOCITY
	begin
	XX(I):=RXX;
	XY(I):=RXY;
	VX(I):=VX(I) + RVX;
	VY(I):=VY(I) + RVY;
	end;
end;	\ZOOM



begin	\MAIN
XX:=RESERVE(1024);	\512 PARTICLES MAXIMUM
XY:=RESERVE(1024);
VX:=RESERVE(1024);
VY:=RESERVE(1024);

OPENI(1);
SETVID($13);
loop	begin
	N:=100 + RANDOM(50);		\NUMBER OF PARTICLES
	POWER:=200 + RANDOM(100);	\POWER OF EXPLOSION
	VAR:=20 + RANDOM(20);	\VARIENCE IN VELOCITY OF THE PARTICLES
	ZOOM;
	BOOM;
	if KEYHIT then quit;
	end;
SETVID(3);
end;	\MAIN
