\JUSTIFY.XPL
\TEXT FORMATTING AND JUSTIFY PROGRAM


'CODE'RESERVE=3,CHIN=7,CHOUT=8,
REM=2,CRLF=9,NUMIN=10,
NUMOUT=11,TEXT=12,OPENIN=13,
OPENOUT=14,CLOSE=15,ABORT=16;


'ADDR'
	EXTRAS,	\ARRAY OF POINTS TO ADD FILLS
	INLINE,	\INPUT ARRAY
	PIPE;	\HOLD CHARACTER IN THE PIPELINE


'INT'
	PARFLG,	\FLAGS NEW PARAGRAPH
	LMAR,	\HOLDS LEFT MARGIN
	RMAR,	\HOLDS RIGHT MARGIN
	WIDTH,	\WIDTH, FROM MARGIN TO MARGIN
	INPTR,	\POINTER TO INPUT LINE
	SPCNT,	\NUMBER OF CONSEQUTIVE SPACES
	EOFLG,	\FLAGS END OF FILE
	FILFLG,	\FLAGS FILL MODE
	CHAR,	\GLOBAL CHARACTER
	OLDCHR,	\ONE CHARACTER BACK
	IDEV,	\INPUT DEVICE
	ODEV,	\OUTPUT DEVICE
	PIPTR;	\PIPELINE POINTER


'DEF'
	SPACE=$20,	\BLANK
	EOF=$1A,	\END OF FILE
	FEED=$0A,	\LINE FEED
	TAB=$09,		\TAB
	RET=$0D,		\CARRIAGE RETURN
	COMCHR=$5C;	\BACKSLASH  FLAGS COMMAND



'PROCEDURE' PULL;	\PULL CHARACTER OUT OF PIPE
'INTEGER' C;
'BEGIN'
'IF' PIPTR=0 'THEN' C:=CHIN(IDEV)
	'ELSE' [PIPTR:=PIPTR-1;C:=PIPE(PIPTR);];
'RETURN' C;
'END';



'PROCEDURE' PUSH(C);	\PUSH CHARACTER BACK INTO PIPE
'INTEGER' C;
'BEGIN'
PIPE(PIPTR):=C;
PIPTR:=PIPTR+1;
'END';



'PROCEDURE' NEXTCHAR;	\ONE CHAR LOOK AHEAD
'INTEGER' C;
'BEGIN'
C:=PULL;
PUSH(C);
'RETURN' C;
'END';



'PROCEDURE' ERROR(STRING);	\PRINT MESSAGE AND ABORT
'ADDR' STRING;
'BEGIN'
TEXT(0,STRING);
ABORT;
'END';



'PROCEDURE' MARGIN(SIZE);
'INTEGER' SIZE,X;
'FOR' X:=1,SIZE 'DO' CHOUT(ODEV,SPACE);



'PROCEDURE' PAGE;
'BEGIN'
'END';



'PROCEDURE' LEFTMAR;
'BEGIN'
'END';


'PROCEDURE' RIGHTMAR;
'BEGIN'
'END';



'PROCEDURE' DECODE(C);
'INTEGER' C;
'BEGIN'
C:=C & $5F;	\MAKE SURE UPPERCASE
'CASE' C 'OF'
	^N:	FILFLG:='FALSE';	\TURN OFF FILL MODE
	^F:	FILFLG:='TRUE';	\TURN ON FILL MODE
	^P:	PAGE;	\FORCE A PAGE
	^L:	LEFTMAR;	\RESET LEFT MARGIN
	^R:	RIGHTMAR	\RESET RIGHT MARGIN
'ELSE'
	'BEGIN'
	CHOUT(0,^<);CHOUT(0,C);
	TEXT(0,"> ");
	ERROR("ILLEGAL COMMAND");
	'END';
'END';



'PROCEDURE' COMMAND;	\PULL COMMAND OUT OF TEXT
'INTEGER' C;
'LOOP'
	'BEGIN'
	C:=PULL;
	'IF' C=FEED 'THEN' 'QUIT'
	'ELSE' 'IF' C#^, & C#RET 'THEN' DECODE(C);
	'END';



'PROCEDURE' GETC;	\LOW LEVEL INPUT CHARACTER
'INTEGER' C;
'BEGIN'
OLDCHR:=CHAR;
C:=PULL;
'IF' OLDCHR=FEED 'THEN'
	'IF' C=RET ! C=TAB ! C=SPACE 'THEN'
		PARFLG:='TRUE' 'ELSE'
	'WHILE' C=COMCHR 'DO'
		'BEGIN'
		COMMAND;
		C:=PULL;
		'END';
EOFLG:=EOF=C;
CHAR:=C;
'END';


'PROCEDURE' NOFILL;	\NO FILL LOOP
'LOOP'
	'BEGIN'
	GETC;
	'IF' EOFLG ! FILFLG 'THEN'
		'BEGIN'
		PUSH(CHAR);
		PARFLG:='FALSE';
		'QUIT';
		'END';
	CHOUT(ODEV,CHAR);
	'END';



'PROCEDURE' BLANK;	\TEST BLANKS
'INTEGER' DUMMY;
'RETURN' CHAR=RET ! CHAR=FEED ! CHAR=TAB ! CHAR=SPACE;


'PROCEDURE' DUMP;	\DUMP INPUT LINE WITHOUT FILL
'INTEGER' X;
'BEGIN'
'FOR' X:=0,INPTR-1 'DO' CHOUT(ODEV,INLINE(X));
CRLF(ODEV);
'END';



'PROCEDURE' READLINE;	\READ LINE TO BE FILLED
'INTEGER' C;


'PROCEDURE' SPACEOUT;	\DEAL WITH SPACES
'BEGIN'
'IF' BLANK 'THEN'
	'BEGIN'
	C:=SPACE;
	SPCNT:=SPCNT+1;
	'END'
'ELSE'
	'BEGIN'
	C:=CHAR;
	SPCNT:=0;
	'END';
'END';


'BEGIN'
INPTR:=0;
'LOOP'
	'BEGIN'
	'LOOP'
		'BEGIN'
		GETC;
		'IF' PARFLG ! EOFLG ! ('NOT'FILFLG) 'THEN'
			'BEGIN'
			PUSH(CHAR);
			'RETURN';
			'END';
		SPACEOUT;
		'IF' SPCNT<2 'THEN' 'QUIT';
		'END';
	'IF' INPTR#0 ! C#SPACE 'THEN'
		'BEGIN'
		INLINE(INPTR):=C;
		INPTR:=INPTR+1;
		'END';
	'IF' INPTR=WIDTH 'THEN' 'QUIT';
	'END';
'IF' NEXTCHAR#SPACE 'THEN'
	'LOOP'
	'BEGIN'
	INPTR:=INPTR-1;
	'IF' INPTR<=0 'THEN' ERROR("WORD LONGER THAN MARGINS");
	'IF' INLINE(INPTR)=SPACE 'THEN' 'QUIT'
		'ELSE' PUSH(INLINE(INPTR));
	'END';
'END';



'PROCEDURE' FILL;	\CALCULTE NUMBER OF FILLS AND WHERE THEY GO
'INT'
	PLACES,	\NUMBER OF PLACES TO PUT FILLS
	FILLS,	\TOTAL FILLS PER LINE
	X,Y;
'BEGIN'
PLACES:=0;
'FOR' X:=0,63 'DO' EXTRAS(X):=0;
FILLS:=WIDTH-INPTR;
'IF' FILLS=0 'THEN' 'RETURN';
'FOR' X:=0,INPTR-1 'DO'
	'IF' INLINE(X)=SPACE 'THEN' PLACES:=PLACES+1;
'IF' PLACES=0 'THEN' 'RETURN';
X:=0;Y:=PLACES-1;
'LOOP' 'BEGIN'
	EXTRAS(X):=EXTRAS(X)+1;
	X:=X+1;FILLS:=FILLS-1;
	'IF'FILLS=0'THEN''QUIT';
	'IF' X=PLACES'THEN'X:=0;
	EXTRAS(Y):=EXTRAS(Y)+1;
	Y:=Y-1;FILLS:=FILLS-1;
	'IF'FILLS=0'THEN''QUIT';
	'IF'Y=-1'THEN'Y:=PLACES-1;
	'END';
'END';



'PROCEDURE' PRINT;
'INT' C,EPTR,X,Y;

'PROC' ADD;
'INT' ADDS,X;
'BEGIN'
ADDS:=EXTRAS(EPTR);
EPTR:=EPTR+1;
'FOR' X:=1,ADDS'DO'CHOUT(ODEV,SPACE);
'END';

'BEGIN'	\START OF PRINT
MARGIN(LMAR);
EPTR:=0;
Y:=0;
'WHILE' INLINE(Y)=SPACE 'DO' [CHOUT(ODEV,INLINE(Y));Y:=Y+1];
'FOR' X:=Y,INPTR-1 'DO'
	'BEGIN'
	C:=INLINE(X);
	'IF'C=SPACE'THEN'ADD;
	CHOUT(ODEV,C);
	'END';
CRLF(ODEV);
'END';



'PROCEDURE' FILOOP;	\PROCESS FILLED TEXT
'LOOP'
	'BEGIN'
	READLINE;
	'IF' EOFLG ! ('NOT' FILFLG) 'THEN'
		'BEGIN'
		DUMP;
		'QUIT';
		'END'
	'ELSE' 'IF' PARFLG 'THEN'
		'BEGIN'
		DUMP;
		CRLF(ODEV);
		PARFLG:='FALSE';
		'QUIT';
		'END';
	FILL;
	PRINT;
	'END';



'PROCEDURE' DISTRIBUTE;	\SELECT FILE AND NON-FILL MODES;
'REPEAT'
	'BEGIN'
	'IF' FILFLG 'THEN' FILOOP
		'ELSE' NOFILL;
	'END'
'UNTIL' EOFLG;



'BEGIN'	\MAIN
SPCNT:=0;
EOFLG:='FALSE';
FILFLG:='FALSE';
PARFLG:='FALSE';
CHAR:=FEED;
PIPE:=RESERVE(100);
INLINE:=RESERVE(150);
EXTRAS:=RESERVE(64);
PIPTR:=0;
TEXT(0,"<INPUT,OUTPUT>");
IDEV:=NUMIN(0);ODEV:=NUMIN(0);
TEXT(0,"LEFT MARGIN, RIGHT MARGIN");
LMAR:=NUMIN(0);RMAR:=NUMIN(0);
WIDTH:=RMAR-LMAR;
OPENIN(IDEV);OPENOUT(ODEV);
DISTRIBUTE;
CHOUT(ODEV,EOF);
CLOSE(ODEV);
'END';
