\KALEID.XPL	NOV-07-90
\This program draws rather nice kaleidoscopic patterns.

\REVISION HISTORY:
\Original lost in antiquity, Boyle and Wall were involved.
\MAY-23-87, V3.00, Modified by Craig Wasinger.
\NOV-07-90, Modified for PC.

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
	GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
	FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
	CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
	FCLOSE=32,	KEYHIT=33,	SOFTINT=34,	GETREG=35,
	BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
	CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
	READPIX=44,	SETVID=45	FIX=50,		POUT=64,
	PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
	ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72;

def	WIDTH= 320,	\640 for high res
	HEIGHT= 200,	\400 for interlace
	INTSIZE= 2	\Size of numbers for compiler version
	PENSMAX= 10;	\Number of pens

\Arrays:
int	X, Y,		\Coordinates of point
	T,		\Temporary
	STEP,		\Rotation step size (actually reciprocal)
	COLOR;		\Color of point

int	PENS,		\Number of active points (see PENSMAX)
	CH,		\Character from keyboard
	N;		\Temporary scratch
int	CPUREG;		\Pointer to system info



func	GETKEY;		\Get character from low-level keyboard routine
begin			\No echo, no ctrl-C, and no cursor
CPUREG(0):= 0;
SOFTINT($16);
return CPUREG(0) & $FF;
end;	\GETKEY



proc	PLOT(X, Y, COLOR);	\Eight-Fold Symmetry Display Plotter
int	X, Y, COLOR;
int	W, H;
begin
W:= WIDTH >>1;
H:= HEIGHT >>1;
POINT(X+W, Y+H, COLOR);
POINT(X+W, -Y+H, COLOR);
POINT(-X+W, -Y+H, COLOR);
POINT(-X+W, Y+H, COLOR);
POINT(Y+W, X+H, COLOR);
POINT(Y+W, -X+H, COLOR);
POINT(-Y+W, -X+H, COLOR);
POINT(-Y+W, X+H, COLOR);
end;	\PLOT



begin	\MAIN
CPUREG:= GETREG;

X:= RESERVE(PENSMAX *INTSIZE);
Y:= RESERVE(PENSMAX *INTSIZE);
T:= RESERVE(PENSMAX *INTSIZE);
STEP:= RESERVE(PENSMAX *INTSIZE);
COLOR:= RESERVE(PENSMAX *INTSIZE);

loop begin
OPENI(0);   OPENO(0);
CHOUT(0, $0C);
TEXT(0,"-- KALEID, V3.02 --

This program draws rather nice kaleidoscopic patterns.

Press:
     SPACE	to clear the screen
     ESC	to start over
     CTRL-C	to Quit
     CTRL-S	to Stop

Number of pens (1-");
INTOUT(0,PENSMAX);
TEXT(0,")? ");
loop	begin
	PENS:= INTIN(0);
	if PENS>=1 & PENS<=PENSMAX then quit;
	CHOUT(0,$07);		\BEEP
	end;

for N:= 0, PENS-1 do
	begin
	X(N):= 0;
	Y(N):= 0;
	STEP(N):= RAN(16383);
	COLOR(N):= N
	end;

CLEAR;
SETVID(13);

loop	begin
	for N:=0, PENS-1 do
		begin
		if RAN(STEP(N)) <10 then COLOR(N):= COLOR(N) +1;
		if COLOR(N) >= 16 then COLOR(N):= 0;
	
		T(N):= X(N) + Y(N) /STEP(N);    \Rotate X,Y about the center
		Y(N):= Y(N) - X(N) /STEP(N);
		X(N):= T(N);

		X(N):= X(N) + RAN(3) -1;	\ +/-1 OR 0
		Y(N):= Y(N) + RAN(3) -1;

		X(N):= REM(X(N)/WIDTH>>1);	\Keep point on screen (wraps)
		Y(N):= REM(Y(N)/WIDTH>>1);
		end;

	for N:=0, PENS-1 do
		PLOT(X(N), Y(N), COLOR(N));	\Eight-fold symmetry

	if KEYHIT then
		begin
		case GETKEY of
		  $20:	CLEAR;
		  $1B: \ESC\ quit;
		  $03: \CTRL-C\ [SETVID(2);   exit];
		  $13: \CTRL-S\ [repeat until KEYHIT;   CH:= GETKEY]
		other	CHOUT(0, 7);
		end;
	end;
SETVID(2);
end;	\LOOP
end;	\MAIN
