\KALEID3.XPL	JUN-18-88
\This program draws rather nice kaleidoscopic patterns.

\REVISION HISTORY:
\Original lost in antiquity, Boyle and Wall were involved.
\MAY-23-87, V3.00, Modified by Craig Wasinger.
\JUN-18-88, V3.01, Modified for new console handler (changed HEIGHT to 240,
\ and moved BITMAP calls so OPENO doesn't change them), fixed COLOR array
\ (it can't = 0), and increased speed by using register variables, L.B.

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	CURSOR=23,	HEXIN=26,	HEXOUT=27,
	CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
	BITMAP=108,	BITMAP2=109,	VIEW=110,	PALETTE=111,
	GETKEY=125,	KEYHIT=126,	SHOCUR=127;

def	WIDTH= 320,	\640 for high res
	HEIGHT= 240,	\400 for interlace
	DEPTH= 5,	\Number of bit-planes
	RED= 8,		\XXXXREDS00000000  }
	GREEN= 4,	\XXXX0000GREN0000   }-Palette Positions
	BLUE= 0,	\XXXX00000000BLUE  }
	INTSIZE= 4	\Size of numbers for compiler version
	MAXPOINTS= 10;	\Number of change points

\Arrays:
int	X, Y,		\Coordinates of point
	T,		\Temporary
	STEP,		\Rotation step size (actually reciprocal)
	COLOR;		\Color of point
int	NODES,		\Number of active points (see MAXPOINTS)
	CH,		\Character from keyboard
	COLORS;		\Array of palette values
reg int	N;		\Temporary scratch
addr	RASTER;		\Memory array that is displayed as the screen



proc	PLOT(X, Y, COLOR);	\Eight-Fold Symmetry Display Plotter
reg int	X, Y, COLOR;
begin	POINT(X, Y, COLOR);
	POINT(X, -Y, COLOR);
	POINT(-X, -Y, COLOR);
	POINT(-X, Y, COLOR);
	POINT(Y, X, COLOR);
	POINT(Y, -X, COLOR);
	POINT(-Y, -X, COLOR);
	POINT(-Y, X, COLOR);
end;	\8 POINT PLOTTER.



begin	\MAIN
X:= RESERVE(MAXPOINTS * INTSIZE);
Y:= RESERVE(MAXPOINTS * INTSIZE);
T:= RESERVE(MAXPOINTE * INTSIZE);
STEP:= RESERVE(MAXPOINTS * INTSIZE);
COLOR:= RESERVE(MAXPOINTS * INTSIZE);
RASTER:= RESERVE(WIDTH/8 *HEIGHT *DEPTH);

loop begin
OPENI(0);
OPENO(0);		\(This resets the BITMAPs)
CHOUT(0, $0C);
TEXT(0,"-- KALEID, V3.01 --

This program draws rather nice kaleidoscopic patterns.

Press:
     SPACE	to clear the screen
     ESC	to start over
     CTRL-C	to Quit
     CTRL-S	to Stop

Number of active change nodes (1-");
INTOUT(0,MAXPOINTS);
TEXT(0,")? ");
loop	begin
	NODES:= INTIN(0);
	if NODES>=1 & NODES<=MAXPOINTS then quit;
	CHOUT(0,$07);		\BEEP
	end;
NODES:= NODES -1;

for N:= 0, NODES do
	begin
	X(N):= 0;
	Y(N):= 0;
	STEP(N):= RAN(16383);
	COLOR(N):= N
	end;

BITMAP(RASTER, WIDTH, HEIGHT, DEPTH);
BITMAP2(0, 0, WIDTH>>1, HEIGHT>>1, false, true);
CLEAR;

COLORS:= [$0000, $0F00, $00F0, $000F, $0FF0, $0F0F, $00FF, $0FFF,
	  $0333, $0700, $0070, $0007, $0770, $0707, $0077, $0777,
	  $0000, $0A00, $00A0, $000A, $0F70, $0F07, $00F7, $0000,
	  $0000, $0033, $0303, $0330, $07F0, $070F, $007F, $0AAA];
for N:= 0, 31 do
	PALETTE(N, COLORS(N));

VIEW(RASTER, $5000);			\Select 5 bit planes, low res

loop	begin
	for N:=0, NODES do
		begin
		if RAN(STEP(N)) <10 then COLOR(N):= COLOR(N) +1;
		if COLOR(N) >= 16 then COLOR(N):= 0;
	
		T(N):= X(N) + Y(N) /STEP(N);    \Rotate X,Y about the center
		Y(N):= Y(N) - X(N) /STEP(N);
		X(N):= T(N);

		X(N):= X(N) + RAN(3) -1;	\ +/-1 OR 0
		Y(N):= Y(N) + RAN(3) -1;

		X(N):= REM(X(N)/WIDTH>>1);	\Keep point on screen (wraps)
		Y(N):= REM(Y(N)/WIDTH>>1);
		end;

	for N:=0, NODES do
		PLOT(X(N), Y(N), COLOR(N));	\Eight-fold symmetry

	if KEYHIT then
		begin
		CH:= GETKEY;
		if CH = $20 then CLEAR;
		if CH = $1B \ESC\ then quit;
		if CH = $03 \CTRL-C\ then exit;
		if CH = $13 \CTRL-S\ then [repeat until KEYHIT; CH:= GETKEY];
		end;
	end;
end;	\LOOP
end;	\MAIN
