\KNTSTOUR.XPL	DEC-02-92
\Translation of Jim Phillip's translation of the knight's tour problem.
\See Algorithms + Data Structures = Programs by Nicklaus Wirth.

\The knight's tour problem is as follows. Start somewhere on somesize
\ chess board and use the Knight to visit every square on the board, but
\ only once.

\This program illustrates recursive backtracking.

\It is fun to watch the H array while the program runs.

\   Ŀ   From a given position on a chess board the
\        2       1         Knight has 8 legal moves, numbered 0 - 7.
\   Ĵ
\    3               0  
\   Ĵ   Move 0 has an X value of
\           Knt            2 and a Y value of 1.
\   Ĵ   Move 5 has an X value of -1 and
\    4               7     a Y value of -2.
\   Ĵ   These moves are represented in the constant
\        5       6         arrays, LGLX and LGLY
\   

inc	C:\CXPL\CODESI;

int	N, NSQ;	\Length of side and length squared
int	I, J, Q;
int	H;	\Boolean array "two-dimentional" N by N
int	LGLX, LGLY;	\Array of legal moves



func	TRY(I, X, Y);
int	I, X, Y;
int	K, U, V;
begin
for K:= 0, 7 do
	begin
	U:= X + LGLX(K);	\U and V get next square
	V:= Y + LGLY(K);
	if H(U, V) = 0 then		\if square has not been visited
		begin
		H(U, V):= I;		\mark square with sequence number
		if I = NSQ then return true;
		if TRY(I+1, U, V) then return true	\lead to soln?
		else H(U, V):= 0;	\No? restore virginity
		end;
	end;
return false;
end;	\TRY



begin	\MAIN
H:= RESERVE(24*2);
for I:= 0, 24-1 do
	H(I):= RESERVE(24*2);

for I:= 0, 24-1 do		\SET UP BORDER FOR SPEED
    for J:= 0, 24-1 do
	H(I, J):= 1;

for I:= 0, 24-1 do		\MOVE H TO H(2,2)
	H(I):= H(I) + 2*2;
H:= H + 2*2;

LGLX:= [2, 1, -1, -2, -2, -1, 1, 2];
LGLY:= [1, 2, 2, 1, -1, -2, -2, -1];

TEXT(0, "Enter length of chess board: ");
N:= INTIN(0);
if N > 20 then
	begin
	TEXT(0, "Sorry chess board is larger than 20 x 20.
");
	exit;
	end;

NSQ:= N *N;

for I:= 0, N-1 do
    for J:= 0, N-1 do
	H(I, J):= 0;		\Initalize two-dimentional array

H(0, 0):= 1;		\Seed location 0,0 to be origin
Q:= TRY(2, 0, 0);	\Start recursion looking for square 2 from X,Y = 0,0

if Q then		\Draw chess board with knight move sequence
	begin
	for I:= 0, N-1 do
		begin
		for J:= 0, N-1 do
			begin
			if H(I, J) < 10 then CHOUT(0, ^ );
			INTOUT(0, H(I, J));
			TEXT(0, "   ");
			end;
		CRLF(0);
		end;
	end
else	TEXT(0, "No Solution
");
end;	\MAIN
