\LEDPS.XPL	8/13/93		Richard Ottosen
\LED POWER SUPPLY DESIGN AID

include C:\cxpl\CODESI.XPL;

def	BS= $08,	\Back Space
	CR= $0D,	\Carriage Return
	FF= $0C,	\Form Feed
	SP= $20;	\Space

def	FALSE= 0, TRUE= -1;

int	DEV, DUMMY, TOP;


\STRINGS DESCRIBING COMPONENTS
int	REGULATOR, FET, SCHOTT, OPAMP, LED, COIL1, COIL2;

int	BATTERY,	\SELECTED BATTERY
	SIZE;		\SIZE OF CIRCUIT
int \array\	CIRCUIT;

real \array\
	VALUES;
\POINTERS INTO "VALUES" ARRAY:
int	RON, RMIN, RMAX, IMAX, VDIODE, VRES, IMISC;


int	VARIETY;		\NUMBER OF BATTERIES IN TABLE
int \array\
	TYPE,			\Description of battery
	STYLE;			\Case size
real \array\
	FRESH,			\Fresh battery open circuit voltage
	DEAD,			\End of life open circuit voltage
	CAPACITY,		\Capacity in amp/hours
	WEIGHT;			\Total battery weight in grams

int \array\
	TYPEA, STYLEA, 			\Alkaline battery values
	TYPEL, STYLEL;			\Lithium battery values
real \array\
	FRESHA, DEADA, CAPACA, WEIGHTA,	\Alkaline battery values
	FRESHL, DEADL, CAPACL, WEIGHTL;	\Lithium battery values
	

real	\"CONSTANTS"
	RMS;			\SQUARE ROOT OF 2

real	\variables
	L,			\INDUCTOR VALUE
	PD,			\TOTAL POWER DISSIPATION
	LIFE;			\BATTERY LIFE IN HOURS



def
  \REGULATOR SPEC'S:
  FREQ= 45.0E3, FREQMIN= 40.0E3, FREQMAX= 50.0E3,	\OSC. FREQUENCY
  VREF= 1.31,				\REGULATOR REFERENCE VOLTAGE
  VBREAK= 16.5,				\REGULATOR BREAKDOWN VOLTAGE
  VFWRD= 1.0,				\INTERNAL DIODE FORWARD VOLTAGE
  RLXMIN=3.0, RLX=6.0, RLXMAX=12.0,	\INTERNAL SWITCH ON RESISTANCE
  IRLX= .450,				\MAXIMUM INTERNAL SWITCH CURRENT
  IREG= 50E-6,				\REGULATOR CURRENT IN AMPS/VOLT

  \LED SPEC'S:
  VLEDMIN= 1.5, VLED= 2.0, VLEDMAX= 2.7,	\VOLTAGE DROP OF LED
  ILED= 0.020,				\LED OPERATING CURRENT

  \COIL SPEC'S:
  SCOIL= 0.5,				\SMALL LOW CURRENT INDUCTOR RESISTANCE
  LCOIL= 0.1,				\LARGE HIGH CURRENT INDUCTOR RESISTANCE

  \EXTERNAL DIODE SPEC'S:
  VSCHOTT= 0.75,			\EXTERNAL SCHOTTKY DIODE FORWARD VOLTAGE

  \FET SPEC'S:
  RFETMIN= 0.2, RFET= 0.3, RFETMAX= 0.4,  \EXTERNAL FET ON RESISTANCE
  IFET= 5.2,				\MAXIMUM EXTERNAL FET CURRENT

  \OP-AMP SPEC'S
  GAIN=	1.0E6 /100E3 +1.0,		\AMPLIFIER GAIN
  OPREF= VREF /GAIN,			\EQUIVLALENT REF VOLATAGE USING OP AMP
  IOPAMP= 150E-6;			\OP-AMP CURRENT IN AMPS PER VOLT OF SUPPLY


proc SPECPARTS;	\COMPONENT SPECIFICATIONS:
begin
VARIETY:=4;		\NUMBER OF BATTERIES IN TABLE

\STRINGS DESCRIBING COMPONENTS
REGULATOR:= "MAX641A.";
LED:= "HP HLMA-CL00.";
COIL1:= "TOKO 8RBS High Current series.";
COIL2:= "Toroid ???.";
SCHOTT:= "1N5817.";
FET:= "IRFD120.";
OPAMP:= "TLC271C.";

\BATTERY SPEC'S (Alkaline):
TYPEA:=   ["9 Volt alka.",     "6 Volt alka.", "4.5 Volt alka.",    "3 Volt alka."];
STYLEA:=  ["Trans.",	     "4 x AAA",	      "3 x AA",		 "2 x C"];
FRESHA:=  [9.0,		      6.0,	       4.5,		  3.00]; \VOLTS
DEADA:=   [4.8,		      3.2,	       2.4,		  1.6]; \VOLTS
CAPACA:=  [.550,	      1.000,	       2.215,		  7.000]; \A/H
WEIGHTA:= [57.1,	     44.0,	      63.3,		128.0]; \GRAMS

\BATTERY SPEC'S (Lithium):
TYPEL:=   ["9 Volt lith.",     "6 Volt lith.", "4.5 Volt alka.", "3 Volt lith."];
STYLEL:=  ["Trans.",	     "DL223A",	      "3 x AAA",	 "DL123A"];
FRESHL:=  [9.75,	      6.5,	       4.5,		  3.25]; \VOLTS
DEADL:=   [6.0,		      4.0,	       2.4,		  2.0]; \VOLTS
CAPACL:=  [1.15,	      1.300,	       1.000,		  1.300]; \A/H
WEIGHTL:= [38.3,	     37.0,	      33.0,		 16.0]; \GRAMS


\DESCRIPTION OF CIRCUIT:
CIRCUIT:=
	[
\0\	"RESISTOR",
\1\	"REGULATOR, COIL",
\2\	"REGULATOR, COIL, SCHOTTKY",
\3\	"REGULATOR, COIL, FET, SCHOTTKY",
\4\	"REGULATOR, COIL, OP-AMP, RESISTORS",
\5\	"REGULATOR, COIL, SCHOTTKY, OP-AMP, RESISTORS",
\6\	"REGULATOR, COIL, FET, SCHOTTKY, OP-AMP, R'S"
	];

	RON:=0; RMIN:=1; RMAX:=2; IMAX:=3; VDIODE:=4; VRES:=5;      IMISC:=6;
VALUES:=[
\0\	 [0.0,  0.0,     0.0,     0.0,     0.0,       0.0,          0.0   ],
\1\	 [RLX,	RLXMIN,  RLXMAX,  IRLX,    VFWRD,     VREF,         0.0   ],
\2\	 [RLX,	RLXMIN,  RLXMAX,  IRLX,    VSCHOTT,   VREF,         0.0   ],
\3\	 [RFET,	RFETMIN, RFETMAX, IFET,    VSCHOTT,   VREF,         0.0   ],
\4\	 [RLX,	RLXMIN,  RLXMAX,  IRLX,    VFWRD,     OPREF,	    IOPAMP],
\5\	 [RLX,	RLXMIN,  RLXMAX,  IRLX,    VSCHOTT,   OPREF,	    IOPAMP],
\6\	 [RFET,	RFETMIN, RFETMAX, IFET,	   VSCHOTT,   OPREF,	    IOPAMP]
	];
end;	\SPECPARTS


proc	PRINT(STRING);
int	STRING;
begin
TEXT(DEV,STRING);
end;	\PRINT


proc	PRINTR(STRING);
int	STRING;
begin
TEXT(DEV,STRING);	CRLF(DEV);
end;	\PRINTR


proc	TAB;
begin
PRINT("	");
end;


proc	CLEARSCREEN;
begin
if DEV =0 then CHOUT(DEV,FF);
end;


proc	PAGE;
begin
if (DEV =2) & TOP =false then CHOUT(DEV,FF);
TOP:= false;
end;


proc	UNDERLINE;
begin
PRINTR("-----------------------------------------------------------------------------");
end;


proc	DOUBLELINE;
begin
PRINTR("=============================================================================");
end;


proc	DOTTEDLINE;
begin
TEXT(0,":::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::");
end;


proc	NUMOUT(N);
real	N;
begin
RLOUT(DEV,N);
end;	\NUMOUT


proc	PLACE(X,Y, WHOLE, DECIMAL, PROMPT, DEFAULT, UNITS);
int X,Y,WHOLE,DECIMAL,PROMPT;  real DEFAULT;  int UNITS;
begin
FORMAT(WHOLE,DECIMAL); CURSOR(X,Y);
PRINT(PROMPT); RLOUT(DEV,DEFAULT); PRINT(UNITS);
FORMAT(5,3);
end;	\PLACE


proc	OUTPUT(X,Y, WHOLE, DECIMAL, PROMPT, DEFAULT, UNITS);
int X,Y,WHOLE,DECIMAL,PROMPT;  real DEFAULT;  int UNITS;
begin
FORMAT(WHOLE,DECIMAL);
PRINT(PROMPT); RLOUT(DEV,DEFAULT); PRINTR(UNITS);
FORMAT(5,3);
end;	\OUTPUT


proc	ANYKEY;
begin
if DEV =0 ! DEV =1 then
	[CURSOR(0,23);
\	DOUBLELINE;
	DOTTEDLINE;
	CURSOR(0,24); TEXT(0,"Hit any key to continue.");
\	CRLF(0);
	OPENI(1); DUMMY:= CHIN(1);
	];
end;


proc	YES(QUESTION);
int	QUESTION;
int	DUMMY, CHAR;
begin
CURSOR(0,23);
\DOUBLELINE;
DOTTEDLINE;
CURSOR(0,24);	\Clear a line
TEXT(0,"								");
CURSOR(0,24);
TEXT(0,QUESTION); CHOUT(0,BS);
OPENI(0);
DUMMY:= CR;
repeat
	CHAR:= DUMMY;
	DUMMY:= CHIN(1);
	if DUMMY #CR then [CHOUT(0, DUMMY); CHOUT(0,BS);];
until DUMMY =CR;
if (CHAR =^Y) ! (CHAR =^y) then
	return TRUE else return FALSE;
end;


proc	SETTINGS(SIZE);
int	SIZE;
int \array\ ORDER;
begin
FORMAT(1,2);
PRINT("  Switch on res.: "); NUMOUT(VALUES(SIZE, RON)); PRINT(" Ohms, ");
  NUMOUT(VALUES(SIZE, RMIN)); PRINT(" Ohms min. and ");
  NUMOUT(VALUES(SIZE, RMAX)); PRINTR(" Ohms max.");
PRINT("  Maximum switch current: "); NUMOUT(VALUES(SIZE, IMAX));
  PRINTR(" Amps.");
PRINT("  Rectifier forward voltage drop: "); NUMOUT(VALUES(SIZE, VDIODE));
  PRINTR(" Volts.");
PRINT("  Current sense voltage = "); NUMOUT(VALUES(SIZE, VRES));
  PRINTR(" Volts.");
PRINT("  Op-amp current: "); NUMOUT(VALUES(SIZE, IMISC) *1000.0);
  PRINTR(" mAmps.");
CRLF(DEV);
end;	\SETTINGS


proc	SPECLITHIUM;
begin
TYPE:= TYPEL; STYLE:= STYLEL;
FRESH:= FRESHL; DEAD:= DEADL; CAPACITY:= CAPACL; WEIGHT:= WEIGHTL
end;

proc	SPECALKALINE;
begin
TYPE:= TYPEA; STYLE:= STYLEA;
FRESH:= FRESHA; DEAD:= DEADA; CAPACITY:= CAPACA; WEIGHT:= WEIGHTA;
end;


proc	SHOWBATT;
begin
PRINTR("	1st Battery	2nd Battery	3rd Battery	4th Battery");
UNDERLINE;
PRINT("Type:");
for BATTERY:= 0, VARIETY -1 do [TAB; PRINT(TYPE(BATTERY));];
CRLF(DEV);
PRINT("Style:");
for BATTERY:= 0, VARIETY -1 do [TAB; PRINT(STYLE(BATTERY)); TAB;];
CRLF(DEV);

PRINT("Fresh:"); FORMAT(1,2);
for BATTERY:= 0, VARIETY -1 do
	[TAB; NUMOUT(FRESH(BATTERY)); TAB;];
PRINTR("	Volts");

PRINT("Dead:"); FORMAT(1,2);
for BATTERY:= 0, VARIETY -1 do
	[TAB; NUMOUT(DEAD(BATTERY)); TAB;];
PRINTR("	Volts");

PRINT("Capac.:"); FORMAT(1,3); 
for BATTERY:= 0, VARIETY -1 do
	[TAB; NUMOUT(CAPACITY(BATTERY)); TAB;];
PRINTR("	Amp/hr");

PRINT("Weight:"); FORMAT(3,1);
for BATTERY:= 0, VARIETY -1 do
	[TAB; NUMOUT(WEIGHT(BATTERY)); TAB;];
PRINTR("	Grams");
end;	\SHOWBATT


proc	SHOWSPECS;
int	I,J;
begin
CLEARSCREEN;	PAGE;
PRINT("Regulator is number "); PRINTR(REGULATOR);
PRINT("  Switching at "); NUMOUT(FREQ); PRINT(" Hz typ., ");
  NUMOUT(FREQMIN); PRINT(" Hz min. and ");
  NUMOUT(FREQMAX); PRINTR(" Hz max.");
PRINT("  Reference voltage of "); NUMOUT(VREF); PRINTR(" Volts.");
PRINT("  Diode forward drop of "); NUMOUT(VFWRD); PRINTR(" Volts.");
PRINT("  Switch on res. of "); NUMOUT(RLX); PRINT(" Ohms typ., ");
  NUMOUT(RLXMIN); PRINT(" Ohms min. and ");
  NUMOUT(RLXMAX); PRINTR(" Ohms max.");
PRINT("  Maximum switch current of "); NUMOUT(IRLX); PRINTR(" Amps.");
PRINT("  Operating current of "); NUMOUT(IREG); PRINTR(" Amps /Volt.");
PRINT("  Maximum output voltage of "); NUMOUT(VBREAK); PRINTR(" Volts.");

CRLF(DEV);
PRINT("LED is number "); PRINTR(LED);
PRINT("  Forward drop of "); NUMOUT(VLEDMIN); PRINT("  Volts min., ");
  NUMOUT(VLED); PRINT("  Volts typ. and ");
  NUMOUT(VLEDMAX); PRINTR(" Volts max.");
PRINT("  Operating current of "); NUMOUT(ILED); PRINTR(" Amps.");

CRLF(DEV);
PRINT("Small coil is number "); PRINTR(COIL1);
PRINT("  With a series resistance of "); NUMOUT(SCOIL); PRINTR(" Ohms.");
PRINT("Large coil is number "); PRINTR(COIL2);
PRINT("  With a series resistance of "); NUMOUT(LCOIL); PRINTR(" Ohms.");

ANYKEY;
CLEARSCREEN;
PRINT("Diode is number "); PRINTR(SCHOTT);
PRINT("  Forward voltage is "); NUMOUT(VSCHOTT); PRINTR(" Volts.");

CRLF(DEV);
PRINT("External FET number is "); PRINTR(FET);
PRINT("  On resistance of "); NUMOUT(RFET); PRINT(" Ohms typ., ");
  NUMOUT(RFETMIN); PRINT(" Ohms min. and ");
  NUMOUT(RFETMAX); PRINTR(" Ohms max.");
PRINT("  Maximum current of "); NUMOUT(IFET); PRINTR(" Amps.");

CRLF(DEV);
PRINT("Op-amp is number "); PRINTR(OPAMP);
PRINT("  Operating current is "); NUMOUT(IOPAMP); PRINTR(" Amps /Volt.");
PRINT("  Gain is set at "); NUMOUT(GAIN); PRINTR(" Volts /Volt.");

ANYKEY;
\BATTERY SPEC'S:
CLEARSCREEN; if DEV =2 then CRLF(DEV);
PRINTR("Alkaline batteries");
DOUBLELINE;
SPECALKALINE;
SHOWBATT;
CRLF(DEV);
PRINTR("Lithium batteries");
DOUBLELINE;
SPECLITHIUM;
SHOWBATT;
end;	\SHOWSPECS


proc	CALCREFF;
int	I,
	N;			\NUMBER OF DIODES

real	VLEDS,			\TOTAL VOLTAGE ON DIODES
	VRES,			\VOLTAGE ACROSS SERIES LIMITING RESISTOR
	SERIESR;		\SERIES CURRENT LIMITING RESISTOR

def	MAXLEDS =5;

begin
PRINT("      ^\");
for BATTERY:= 0, VARIETY -1 do [TAB; PRINT(TYPE(BATTERY));]; CRLF(DEV);
PRINTR("Diodes ^\Fresh	Dead	Fresh	Dead	Fresh	Dead	Fresh	Dead");
UNDERLINE;
for N:= 1, MAXLEDS -1 do
    [INTOUT(DEV,N); TAB;
    for BATTERY:= 0, VARIETY -1 do
	[VLEDS:= FLOAT(N) *VLED;
	FORMAT(2,0);
	if VLEDS <FRESH(BATTERY) then
	    [NUMOUT(VLEDS /FRESH(BATTERY) *100.0); TAB;]
	    else PRINT("---     ");
	if VLEDS <DEAD(BATTERY) then
	    [NUMOUT(VLEDS /DEAD(BATTERY) *100.0); TAB;]
	    else PRINT("---     ");
	];
    CRLF(DEV);
    ];
end;	\CALCREFF


proc	CALCRVAL;
int	I,
	N;			\NUMBER OF DIODES

real	VIN,			\BATTERY INPUT VOLTAGE
	SERIESR;		\SERIES CURRENT LIMITING RESISTOR

def	MAXLEDS =5;

begin
PRINT("      ^\");
for BATTERY:= 0, VARIETY -1 do [TAB; PRINT(TYPE(BATTERY));]; CRLF(DEV);
PRINTR("Diodes ^\Series R	Series R	Series R	Series R");
UNDERLINE;
for N:= 1, MAXLEDS -1 do
	[INTOUT(DEV,N); TAB;
	for BATTERY:= 0, VARIETY -1 do
		[VIN:= FRESH(BATTERY);
		SERIESR:= (VIN -(FLOAT(N) *VLED)) /ILED;	
		FORMAT(4,0);
		if (FLOAT(N) *VLED) <FRESH(BATTERY) then
			NUMOUT(SERIESR)
			else PRINT(" ---");
		TAB; TAB;
		];
	CRLF(DEV);
	];
end;	\CALCRVAL


proc	CALCLEFF;
int	I,
	N;			\NUMBER OF LED'S

real	VIN,			\BATTERY INPUT VOLTAGE
	VOUT,			\REGULATOR OUTPUT VOLTAGE
	VFWD,			\DIODE FORWARD VOLTAGE
	VSW,			\SWITCH ON VOLTAGE
	VSENSE,			\VOLTAGE ACROSS CURRENT SENSE RESISTOR
	TONMIN, TONMAX,		\ON TIMES
	IPEAK,			\PEAK SWITCH AND RECTIFIER CURRENT
	LMIN, LMAX,		\INDUCTOR
	HOURS,			\BATTERY LIFE
	EFF,			\EFFICIENCY IN PERCENT
	PLED,			\POWER USED BY LEDS
	P1,P2,P3,P4,P5,P6,P7;	\OTHER POWER USED

begin
TONMAX:= 1.0 /(FREQ *0.9) *0.6;  \LOWEST FREQUENCY AND LONGEST DUTY CYCLE
TONMIN:= 1.0 /(FREQ /0.9) *0.4;  \HIGHEST FREQUENCY AND SHORTEST DUTY CYCLE
VFWD:= VALUES(SIZE, VDIODE);
VSENSE:= VALUES(SIZE, VRES);
PRINT("      ^\");
for BATTERY:= 0, VARIETY -1 do [TAB; PRINT(TYPE(BATTERY));]; CRLF(DEV);
PRINTR("Diodes ^\%	Hours	%	Hours	%	Hours	%	Hours");
UNDERLINE;
for N:= 1, FIX((VBREAK- VSENSE) /VLEDMAX) do
    [INTOUT(DEV,N); TAB;
    for BATTERY:= 0, VARIETY -1 do
    	[VIN:= DEAD(BATTERY);
	VFWD:= VALUES(SIZE, VDIODE);
\***	VSW:= VALUES(SIZE, RMAX) *VALUES(SIZE, IMAX);
	VSW:= 0.75;
	VOUT:= FLOAT(N) *VLED +VALUES(SIZE, VRES);

	IPEAK:= (VOUT +VFWD -VIN) / (0.25 *(VIN -VSW)) *ILED;
	LMAX:= (VIN -VSW) /IPEAK *TONMIN;

	VIN:= FRESH(BATTERY);
\***	VSW:= VALUES(SIZE, RMIN) *VALUES(SIZE, IMAX);
	VSW:= 0.25;
	LMIN:= (VIN -VSW) /VALUES(SIZE, IMAX) *TONMAX;


	PLED:= FLOAT(N) *VLED *ILED;
	P1:= VALUES(SIZE, VRES) *ILED;
	P2:= VALUES(SIZE, IMISC) *VOUT;
	P3:= VOUT *IREG;
	P4:= VFWD *(ILED +VALUES(SIZE, IMISC) +IREG);
	P5:= VSW *(ILED +VALUES(SIZE, IMISC) +IREG);
	P6:= 0.0;
	P7:= 0.0;
	EFF:= PLED /(PLED +P1 +P2 +P3 +P4 +P5 +P6 +P7);
	FORMAT(2,0);
	if (LMAX >LMIN) & (IPEAK <VALUES(SIZE, IMAX)) &
			       (FLOAT(N) *VLEDMIN +VSENSE +VFWD >FRESH(BATTERY))
		 then NUMOUT(EFF *100.0)
		else PRINT("--");
	TAB;
	HOURS:= CAPACITY(BATTERY) /(ILED *VOUT /EFF /(FRESH(BATTERY) +
								DEAD(BATTERY)));
	if (LMAX >LMIN)	& (IPEAK <VALUES(SIZE, IMAX)) &
			       (FLOAT(N) *VLEDMIN +VSENSE +VFWD >FRESH(BATTERY))
		 then NUMOUT(HOURS)
		else PRINT("--");
	TAB;
	];
    CRLF(DEV);
    ];
end;	\CALCLEFF


proc	CALCLVAL;
int	I,
	N;			\NUMBER OF LED'S

real	VIN,			\BATTERY INPUT VOLTAGE
	VOUT,			\REGULATOR OUTPUT VOLTAGE
	VFWD,			\DIODE FORWARD VOLTAGE
	VSW,			\SWITCH ON VOLTAGE
	VSENSE,			\VOLTAGE ACROSS CURRENT SENSE RESISTOR
	TONMIN, TONMAX,		\ON TIMES
	IPEAK,			\PEAK SWITCH AND RECTIFIER CURRENT
	LMIN, LMAX;		\INDUCTOR


begin
TONMAX:= 1.0 /(FREQ *0.9) *0.6;  \LOWEST FREQUENCY AND LONGEST DUTY CYCLE
TONMIN:= 1.0 /(FREQ /0.9) *0.4;  \HIGHEST FREQUENCY AND SHORTEST DUTY CYCLE
VFWD:= VALUES(SIZE, VDIODE);
VSENSE:= VALUES(SIZE, VRES);
PRINT("Circuit #"); INTOUT(DEV,SIZE +1); PRINT(":  ");
PRINTR(CIRCUIT(SIZE));
DOUBLELINE;	CRLF(DEV);
PRINT("      ^\");
for BATTERY:= 0, VARIETY -1 do [TAB; PRINT(TYPE(BATTERY));]; CRLF(DEV);
PRINTR("Diodes ^\Coil	I Peak	Coil	I Peak	Coil	I Peak	Coil	I Peak");
UNDERLINE;
for N:= 1, FIX((VBREAK- VSENSE) /VLEDMAX) do
    [INTOUT(DEV,N); TAB;
    for BATTERY:= 0, VARIETY -1 do
	[VIN:= DEAD(BATTERY);
	VFWD:= VALUES(SIZE, VDIODE);
\***	VSW:= VALUES(SIZE, RMAX) *VALUES(SIZE, IMAX);
	VSW:= 0.75;
	VOUT:= FLOAT(N) *VLED +VALUES(SIZE, VRES);

	IPEAK:= (VOUT +VFWD -VIN) / (0.25 *(VIN -VSW)) *ILED;
	LMAX:= (VIN -VSW) /IPEAK *TONMIN;

	VIN:= FRESH(BATTERY);
\***	VSW:= VALUES(SIZE, RMIN) *VALUES(SIZE, IMAX);
	VSW:= 0.25;
	LMIN:= (VIN -VSW) /VALUES(SIZE, IMAX) *TONMAX;

	FORMAT(4,0);
	if LMAX >LMIN then NUMOUT((LMIN +LMAX) /2.0 *1E6)
		else PRINT("Min>Max");
	TAB;
	FORMAT(1,3);
	if IPEAK <VALUES(SIZE, IMAX) then NUMOUT(IPEAK)
		else PRINT("OVER");
	TAB;
	];
    CRLF(DEV);
    ];
end;	\CALCLVAL


proc	SHOWEFF;
begin
CLEARSCREEN;	PAGE;
PRINTR("Circuit #1:  Resistor only");
DOUBLELINE;		CRLF(DEV);
CALCREFF;	CRLF(DEV);	 CRLF(DEV);	 CRLF(DEV);
CALCRVAL;   
ANYKEY;
PAGE;
for SIZE:= 1, 6 do
	[CLEARSCREEN;
	if SIZE =4 then PAGE else if DEV =2 then [CRLF(DEV); CRLF(DEV);];
	if SIZE =0 then  else
		[PRINT("Circuit #"); INTOUT(DEV,SIZE +1); PRINT(":  ");
		PRINTR(CIRCUIT(SIZE));
		DOUBLELINE;
		SETTINGS(SIZE);
		CALCLEFF;
		];
	ANYKEY;
	];
end;	\SHOWEFF


begin	\MAIN ============================================================
DEV:= 0;
RMS:= SQRT(2.0);

SPECPARTS;	\INITIALIZE THE PARTS SPECIFICATIONS

FORMAT(3,2);
CLEARSCREEN;	 CRLF(DEV); CRLF(DEV);
PRINTR("             ==============================================");
PRINTR("             =                                            =");
PRINTR("             =        LED power supply design aid         =");
PRINTR("             =                                            =");
PRINTR("             ==============================================");
CRLF(DEV);	CRLF(DEV);
\DRAW;
CRLF(DEV); CRLF(DEV);

TOP:= true;
loop begin

if YES("Printer ON? N") then DEV:= 2 else DEV:= 0;

if YES("Show component spec's? N") then SHOWSPECS;

if YES("Show efficiencies? N") then
    [if YES("Lithium batteries? N") then SPECLITHIUM else SPECALKALINE;
    SHOWEFF;
    ];

if YES("Show coil values? N") then
    for SIZE:= 1, 6 do 
	[CLEARSCREEN;
	if SIZE =4 then PAGE else if DEV =2 then [CRLF(DEV); CRLF(DEV);];
	CALCLVAL;
	ANYKEY;
	];
end;	\loop
end;	\MAIN
