\LINEFEED.XPL	DEC-09-91
\This program fixes files that use a linefeed to terminate a line by
\ inserting a carriage return. These weird files come from AmigaDOS and
\ even WordPerfect under MS-DOS.

include	\CXPL\CODESI;

\Variables for DOS file I/O:
int	CPUREG,		\pointer to system info
	PSPSEG,		\address of PSP segment (for file I/O)
	DATASEG,	\address of data segment (heap & stack)
	INHANDLE,	\input file handle (= -1 if no input file)
	OUTHANDLE;	\output file handle (= -1 if no output file)
addr	INFILENAME,	\input file name (all file names are zero terminated)
	OUTFILENAME,	\output file name
	TMPFILENAME,	\temporary output file name (.$$$)
	BAKFILENAME;	\backup output file name (.BAK)
def	NAMESIZE=80;	\maximum number of chars in a file name (incl path)

\========================== DOS I/O ROUTINES ==========================

proc	DOSOPEN(INEXT, OUTEXT);	\Open MS-DOS files
addr	INEXT, OUTEXT;	\input and output extensions
int	INX;		\index into CMDLINE
addr	CMDLINE;	\command line tail
def	SP=$20, CR=$0D;


	proc	COPYNAME(FROM, TO, EXT);
	\Copy file name and replace any existing extension with EXT.
	\If EXT = "@@@" then use extension from FROM.
	addr	FROM, TO,	\Strings are 0 terminated
		EXT;		\Extension
	int	I, J, CH;
	begin
	I:= 0;
	loop	begin
		CH:= FROM(I);
		if CH=^. ! CH=0 then quit;
		TO(I):= CH;
		if I < NAMESIZE-1 then I:= I +1;
		end;
	TO(I):= ^.;
	if I < NAMESIZE-1 then I:= I +1;
	for J:= 0, 2 do
		begin
		CH:= EXT(J) & $7F;
		TO(I):= if CH=^@ then FROM(I) else CH;
		if I < NAMESIZE-1 then I:= I +1;
		end;
	TO(I):= 0;
	end;	\COPYNAME



	proc	GETNAME(NAME);
	\Read file name from command line and return it in NAME
	\The command line is terminated by a CR.
	addr	NAME;
	int	I, CH;


		proc	GETCH;	\Get character and strip out switches
		begin
		CH:= CMDLINE(INX);
		INX:= INX +1;
		if CH=^/ then
			begin			\ignore any one-char switches
			CH:= CMDLINE(INX);
			INX:= INX +1;
			if CH # CR then		\handle wise guys
				begin
				CH:= CMDLINE(INX);
				INX:= INX +1;
				end;
			end;
		end;	\GETCH


	begin
	repeat GETCH until CH # SP;
	I:= 0;
	loop	begin
		if CH=SP ! CH=CR then CH:= 0;	\terminate NAME with 0
		NAME(I):= CH;
		if CH = 0 then quit;
		if I < NAMESIZE-1 then I:= I +1;
		GETCH;
		end;
	end;	\GETNAME


begin	\DOSOPEN
CMDLINE:= RESERVE($7F);			\get command tail from PSP
BLIT(PSPSEG, $81, DATASEG, CMDLINE, $7F);

INHANDLE:= -1;   OUTHANDLE:= -1;	\set to illegal values

INX:= 0;
if INEXT(0) # SP then
	begin				\get the input file name
	GETNAME(INFILENAME);
	COPYNAME(INFILENAME, INFILENAME, INEXT);

	INHANDLE:= FOPEN(INFILENAME, 0);
	FSET(INHANDLE, ^I);
	end;

if OUTEXT(0) # SP then
	begin				\get the output file name
	INX:= INX -1;			\backup in case of CR
	GETNAME(OUTFILENAME);
	if OUTFILENAME(0) =0 then	\if no outfile then use the infile
		COPYNAME(INFILENAME, OUTFILENAME, OUTEXT)
	else	COPYNAME(OUTFILENAME, OUTFILENAME, OUTEXT);

	COPYNAME(OUTFILENAME, TMPFILENAME, "$$$");
	COPYNAME(OUTFILENAME, BAKFILENAME, "BAK");

	OUTHANDLE:= FOPEN(TMPFILENAME, 1);
	FSET(OUTHANDLE, ^O);
	end;
end;	\DOSOPEN

\----------------------------------------------------------------------

proc	DOSCLOSE;	\Close MS-DOS files
begin
if INHANDLE # -1 then FCLOSE(INHANDLE);

if OUTHANDLE # -1 then
	begin
	FCLOSE(OUTHANDLE);

	CPUREG(\AX\0):= $4100;		\DEL OUTFILENAME.BAK
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= BAKFILENAME;
	SOFTINT($21);			\(.BAK file might not exist)

	CPUREG(\AX\0):= $5600;		\REN OUTFILENAME.EXT OUTFILENAME.BAK
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= OUTFILENAME;
	CPUREG(\ES\11):= DATASEG;
	CPUREG(\DI\4):= BAKFILENAME;
	SOFTINT($21);

	CPUREG(\AX\0):= $5600;		\REN OUTFILENAME.$$$ OUTFILENAME.EXT
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= TMPFILENAME;
	CPUREG(\ES\11):= DATASEG;
	CPUREG(\DI\4):= OUTFILENAME;
	SOFTINT($21);
	end;
end;	\DOSCLOSE

\======================================================================

proc	LINEFEED;
int	CH;
def	LF=$0A, CR=$0D, EOF=$1A;
begin
OPENI(3);   OPENO(3);
loop	begin
	CH:= CHIN(3);
	if CH = LF then CHOUT(3, CR);
	CHOUT(3, CH);
	if CH = EOF then quit;
	end;
CLOSE(3);
end;	\LINEFEED



begin	\MAIN
CPUREG:= GETREG;
PSPSEG:= CPUREG(11);
DATASEG:= CPUREG(12);

INFILENAME:= RESERVE(NAMESIZE);
OUTFILENAME:= RESERVE(NAMESIZE);
TMPFILENAME:= RESERVE(NAMESIZE);
BAKFILENAME:= RESERVE(NAMESIZE);

DOSOPEN("@@@", "@@@");
LINEFEED;
DOSCLOSE;
end;	\MAIN
