\LODIX.XPL	NOV-27-92
\This loads an .I2L file used for making a Certex PROM for the 3500, 3100
\ and 6200.
\The .I2L file format is normal ASCII interpreted as follows:
\	; = Load address follows (4 chars).
\	* = Address follows (4 chars). This address is relocated by adding
\	    the execution base address (EXBASE) to it.
\	^ = Address follows (4 chars). This address is to have the current
\	    PC value stored into it. This enables forward references.
\	After each of the above, there can follow 2 characters of hex for each
\	loaded byte for any number of bytes.
\	$ = End of .I2L file.
\	Modules are not handled by this loader.

inc	C:\CXPL\CODESI;

def	BEL=$07;

int	PC,		\execution address program counter
	EXBASE,		\execution base address
	LDBASE,		\load base address
	INX,		\index into PROM
	ADDR,		\address read from .I2L file
	CARRY,		\flag: a non-hex character was read by INHEX
	PROMSIZE,	\number of bytes in PROM
	ACC,		\scratch (accumulator)
	CHAR;		\character read from input .I2L file
addr	PROM;		\array: PROM image

\Variables for DOS file I/O:
int	CPUREG,		\pointer to system info
	PSPSEG,		\address of PSP segment (for file I/O)
	DATASEG,	\address of data segment (heap & stack)
	INHANDLE,	\input file handle (= -1 if no input file)
	OUTHANDLE;	\output file handle (= -1 if no output file)
addr	INFILENAME,	\input file name (all file names are zero terminated)
	OUTFILENAME,	\output file name
	TMPFILENAME,	\temporary output file name (.$$$)
	BAKFILENAME;	\backup output file name (.BAK)
def	NAMESIZE=80;	\maximum number of chars in a file name (incl path)

\========================== DOS I/O ROUTINES ==========================

proc	DOSOPEN(INEXT, OUTEXT);	\Open MS-DOS files
addr	INEXT, OUTEXT;	\input and output extensions
int	INX;		\index into CMDLINE
addr	CMDLINE;	\command line tail
def	SP=$20, CR=$0D;


	proc	COPYNAME(FROM, TO, EXT);
	\Copy file name and replace any existing extension with EXT.
	\If EXT = "@@@" then use extension from FROM.
	addr	FROM, TO,	\Strings are 0 terminated
		EXT;		\Extension
	int	I, J, CH;
	begin
	I:= 0;
	loop	begin
		CH:= FROM(I);
		if CH=^. ! CH=0 then quit;
		TO(I):= CH;
		if I < NAMESIZE-1 then I:= I +1;
		end;
	TO(I):= ^.;
	if I < NAMESIZE-1 then I:= I +1;
	for J:= 0, 2 do
		begin
		CH:= EXT(J) & $7F;
		TO(I):= if CH=^@ then FROM(I) else CH;
		if I < NAMESIZE-1 then I:= I +1;
		end;
	TO(I):= 0;
	end;	\COPYNAME



	proc	GETNAME(NAME);
	\Read file name from command line and return it in NAME
	\The command line is terminated by a CR.
	addr	NAME;
	int	I, CH;


		proc	GETCH;	\Get character and strip out switches
		begin
		CH:= CMDLINE(INX);
		INX:= INX +1;
		if CH=^/ then
			begin			\ignore any one-char switches
			CH:= CMDLINE(INX);
			INX:= INX +1;
			if CH # CR then		\handle wise guys
				begin
				CH:= CMDLINE(INX);
				INX:= INX +1;
				end;
			end;
		end;	\GETCH


	begin
	repeat GETCH until CH # SP;
	I:= 0;
	loop	begin
		if CH=SP ! CH=CR then CH:= 0;	\terminate NAME with 0
		NAME(I):= CH;
		if CH = 0 then quit;
		if I < NAMESIZE-1 then I:= I +1;
		GETCH;
		end;
	end;	\GETNAME


begin	\DOSOPEN
CMDLINE:= RESERVE($7F);			\get command tail from PSP
BLIT(PSPSEG, $81, DATASEG, CMDLINE, $7F);

INHANDLE:= -1;   OUTHANDLE:= -1;	\set to illegal values

INX:= 0;
if INEXT(0) # SP then
	begin				\get the input file name
	GETNAME(INFILENAME);
	COPYNAME(INFILENAME, INFILENAME, INEXT);

	INHANDLE:= FOPEN(INFILENAME, 0);
	FSET(INHANDLE, ^I);
	end;

if OUTEXT(0) # SP then
	begin				\get the output file name
	if INX > 0 then INX:= INX -1;	\backup in case of CR
	GETNAME(OUTFILENAME);
	if OUTFILENAME(0) =0 then	\if no outfile then use the infile
		COPYNAME(INFILENAME, OUTFILENAME, OUTEXT)
	else	COPYNAME(OUTFILENAME, OUTFILENAME, OUTEXT);

	COPYNAME(OUTFILENAME, TMPFILENAME, "$$$");
	COPYNAME(OUTFILENAME, BAKFILENAME, "BAK");

	OUTHANDLE:= FOPEN(TMPFILENAME, 1);
	FSET(OUTHANDLE, ^O);
	end;
end;	\DOSOPEN

\----------------------------------------------------------------------

proc	DOSCLOSE;	\Close MS-DOS files
begin
if INHANDLE # -1 then FCLOSE(INHANDLE);

if OUTHANDLE # -1 then
	begin
	FCLOSE(OUTHANDLE);

	CPUREG(\AX\0):= $4100;		\DEL OUTFILENAME.BAK
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= BAKFILENAME;
	SOFTINT($21);			\(.BAK file might not exist)

	CPUREG(\AX\0):= $5600;		\REN OUTFILENAME.EXT OUTFILENAME.BAK
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= OUTFILENAME;
	CPUREG(\ES\11):= DATASEG;
	CPUREG(\DI\4):= BAKFILENAME;
	SOFTINT($21);

	CPUREG(\AX\0):= $5600;		\REN OUTFILENAME.$$$ OUTFILENAME.EXT
	CPUREG(\DS\9):= DATASEG;
	CPUREG(\DX\3):= TMPFILENAME;
	CPUREG(\ES\11):= DATASEG;
	CPUREG(\DI\4):= OUTFILENAME;
	SOFTINT($21);
	end;
end;	\DOSCLOSE

\======================================================================

proc	FAIL;		\Error handler
begin
CHOUT(0, BEL);
TEXT(0, "ILLEGAL .I2L FILE
");
ABORT;
end;	\FAIL



func	INHEX;
\Read an ASCII hex digit from the input .I2L file, convert it to binary, and
\ return it. Set CARRY true if not a hex digit.
begin
CHAR:= CHIN(3);
CARRY:= false;
case of
  CHAR>=^0 & CHAR<=^9: return CHAR - ^0;
  CHAR>=^A & CHAR<=^F: return CHAR - ^A + 10
other CARRY:= true;
return CHAR;
end;	\INHEX



func	BYTEIN;
\Read an ASCII hex byte (two hex digits) from the input .I2L file, convert it
\ to binary, and return it. Carry is set if a non-hex digit is read.
int	I, J;
begin
I:= INHEX;
if CARRY then return;
J:= INHEX;
if CARRY then FAIL;
return I<<4 ! J;
end;	\BYTEIN



func	GETADDR;
\Read an ASCII hex word, convert it to binary, and return it.
int	J;
begin
J:= BYTEIN;
if CARRY then FAIL;
J:= SWAP(J) ! BYTEIN;
if CARRY then FAIL;
return J;
end;	\GETADDR



proc	STORE(J);	\Store J into PROM at INX
int	J;
begin
if INX >= PROMSIZE then FAIL;
PROM(INX):= J;
INX:= INX +1;
end;	\STORE



proc	STOREBYTES(J); \Store bytes into PROM at INX
int	J;
begin
loop	begin
	J:= BYTEIN;
	if CARRY then quit;
	STORE(J);
	end;
end;	\STOREBYTES

\----------------------------------------------------------------------

begin	\MAIN
CPUREG:= GETREG;	\set up for file I/O
PSPSEG:= CPUREG(11);
DATASEG:= CPUREG(12);

INFILENAME:= RESERVE(NAMESIZE);
OUTFILENAME:= RESERVE(NAMESIZE);
TMPFILENAME:= RESERVE(NAMESIZE);
BAKFILENAME:= RESERVE(NAMESIZE);

PROMSIZE:= $DC00 - $8000;
PROM:= RESERVE(PROMSIZE);
for INX:= 0, PROMSIZE-1 do PROM(INX):= $FF;

TEXT(0, "I2L LOADER FOR CERTEX PROMs, V1.0
");

EXBASE:= $8000;
LDBASE:= 0;
INX:= 0;

PROM(INX):= 0;		\store an "exit" opcode (=0) into the first location

EXBASE:= EXBASE +1;
LDBASE:= LDBASE +1;
INX:= INX +1;

DOSOPEN("I2L", "DAT");
OPENI(3);   OPENO(3);

CHAR:= CHIN(3);		\get a command character
loop	begin
	case CHAR of
	  ^;:	begin
		INX:= GETADDR + LDBASE;
		STOREBYTES;
		end;
	  ^^:	begin
		ADDR:= GETADDR + LDBASE;
		PC:= EXBASE + INX - LDBASE;
		PROM(ADDR):= PC;
		PROM(ADDR+1):= SWAP(PC);
		STOREBYTES;
		end;
	  ^*:	begin
		ACC:= GETADDR + EXBASE;
		STORE(ACC);
		STORE(SWAP(ACC));
		STOREBYTES;
		end;
	  ^$:	quit
	other	begin
		CHAR:= CHIN(3);		\get a command character
		end;
	end;

for INX:= 0, PROMSIZE-1 do		\write output .DAT file
	CHOUT(3, PROM(INX));

CLOSE(3);
DOSCLOSE;
end;	\MAIN
