\LZW.XPL	SEP-05-99
\This uses LZW algorithm to compress a file.

inc	\cxpl\codesi;

int     CPUREG,		\Register array from GETREG
	HANDIN,HANDOUT, \File handles
	II;		\Scratch
char    CMDTAIL;	\Copy of command tail



proc	LZW;
int	WTbl(2000),
	KTbl(2000),
	TblInx,
	Code,		\= index into Tbls
	K,		\Byte (character) from input file
	W;		\Str


	func	FindWKCode;
	int	I;
	\Returns the code (index) of Str in Tbl
	\returns -1 if not found;
	begin
	for I:= 256, TblInx-1 do
		if W=WTbl(I) & K=KTbl(I) then return I;
	return -1;
	end;	\FindWKCode


begin	\LZW
\initialize table to contain single-byte strings
TblInx:= 256;

\read first input character and store it into prefix string W
W:= Chin(3);

Trap(false);
loop	begin
	K:= Chin(3);			\read next input byte

	\if input is exhausted then [output code(w); exit]
	if Geterr then			\deal with automatic Ctrl-Z
		begin
		Chout(3, W);
		Chout(3, W>>8);
		quit;
		end;

	\else if wK exists in the string table then append K to prefix string
	Code:= FindWKCode;
	if Code >= 0 then W:= Code	\W:= WK   (= Code)
	else	begin			\string is not in table
		Chout(3, W);
		Chout(3, W>>8);

		WTbl(TblInx):= W;	\store code WK into table
		KTbl(TblInx):= K;
		TblInx:= TblInx + 1;
		if TblInx >= 1024 then TblInx:= 256;	\limit to 9 bit codes
		\ERROR this can overwrite the last value used in the table

		W:= K;			\start string with new byte
		end;
	end;	\loop
Trap(true);
Crlf(0);
Text(0, "Max TblInx = "); Intout(0, TblInx);
Crlf(0);
end;	\LZW



begin	\Main
Text(0, "
This compresses a file using LZW.

WARNING: This is a simple-minded program. Two, complete and different
file names must be given on the command line and they must be separated
by a comma. For example:

	LOWCASE FILE1.TXT, FILE2.TXT

Thinking...");

CPUREG:= GETREG;                \Get DOS PSP and data segment
CMDTAIL:= RESERVE($80);         \Get copy of command tail
BLIT(CPUREG(11), $81, CPUREG(12), CMDTAIL, $7F);

HANDIN:= FOPEN(CMDTAIL, 0);     \Open first file name for input
FSET(HANDIN, ^I);
OPENI(3);

loop for II:= 1, $7F do          \Scan to second file name
	if CMDTAIL(II) = ^, then quit;

HANDOUT:= FOPEN(CMDTAIL+II+1, 1); \Open second file name for output
FSET(HANDOUT, ^O);
OPENO(3);

LZW;

CLOSE(3);
FCLOSE(HANDIN);
FCLOSE(HANDOUT);
end;	\Main
