\MAKEFONT.XPL	JAN-02-2001
\Convert font in table from 5x7 to 7x5
\I.E: Output a standard raster font with MSB on the left and 8 bytes per character.

inc	\CXPL\CODESI;

int	FontTbl,	\font table
	Ch,		\character
	IM, OM,		\input & output masks
	IB, OB,		\input & output bytes
	I, J;

def	OD = 3;		\output device



proc	FOpenO(Str);
char	Str;
int	H;
begin
H:= FOpen(Str, 1);
FSet(H, ^O);		\(closed automatically when program exits)
OpenO(3);
end;	\FOpenO



proc	Hex1out(Dev, N);	\Output a hex digit
int	Dev, N;
char	Hexdigit;
begin
Hexdigit:= "0123456789ABCDEF ";
Chout(Dev, Hexdigit(N & $0F));
end;	\Hex1out



proc	Hex2out(Dev, N);	\Output two hex digits (a byte)
int	Dev, N;
begin
Hex1out(Dev, N>>4);
Hex1out(Dev, N);
end;	\Hex2out



begin	\Main
\The first entry of each character corresponds to the left column. The least
\ significant bit is the top. Bit 6 represents the base line. Lowercase
\ letters with decenders (i.e: g, j, p, q, y) use bit 7.
FontTbl:=
       [$06, $09, $09, $06, $00,		\$00  NULL  DEGREE
	$30, $48, $48, $30, $48,		\$01  ALPHA
	$80, $7F, $25, $25, $1A,		\$02  BETA
	$01, $E1, $FE, $08, $04,		\$03  GAMMA
	$60, $58, $46, $58, $60,		\$04  DELTA
	$41, $63, $55, $49, $63,		\$05  SIGMA
	$78, $20, $10, $08, $04,		\$06  ACK  CHECK
	$30, $2E, $61, $2E, $30,		\$07  BELL
	$10, $38, $54, $10, $10,		\$08  BS  <--
	$10, $10, $54, $38, $10,		\$09  TAB  -->
	$08, $10, $3E, $10, $08,		\$0A  LF  DOWN ARROW
	$08, $04, $3E, $04, $08,		\$0B  UP ARROW
	$1F, $05, $FD, $28, $28,		\$0C  FF
	$0E, $11, $F9, $68, $90,		\$0D  CR
	$3E, $49, $49, $3E, $00,		\$0E  THETA
	$1C, $22, $7F, $22, $1C,		\$0F  PHI
	$78, $A4, $94, $78, $00,		\$10  0  SUBSCRIPTS
	$00, $88, $FC, $80, $00,		\$11  1
	$88, $C4, $A4, $98, $00,		\$12  2
	$44, $94, $9C, $64, $00,		\$13  3
	$60, $50, $48, $FC, $40,		\$14  4
	$5C, $94, $94, $64, $00,		\$15  5
	$78, $94, $94, $60, $00,		\$16  6
	$04, $E4, $14, $0C, $00,		\$17  7
	$68, $94, $94, $68, $00,		\$18  8
	$18, $A4, $A4, $78, $00,		\$19  9
	$0E, $51, $F1, $51, $0E,		\$1A  FEMALE  (EOF)
	$70, $88, $8D, $8B, $77,		\$1B  MALE  (ESC)
	$41, $22, $1C, $20, $40,		\$1C  LAMBDA
	$80, $78, $40, $78, $40,		\$1D  MU
	$4E, $71, $01, $71, $4E,		\$1E  OMEGA
	$08, $78, $08, $78, $08,		\$1F  PI
	$00, $00, $00, $00, $00,		\SPACE
	$00, $00, $5F, $00, $00,		\!
	$00, $07, $00, $07, $00,		\"
	$14, $7F, $14, $7F, $14,		\#
	$24, $2A, $7F, $2A, $12,		\$
	$23, $13, $08, $64, $62,		\%
	$36, $49, $56, $20, $50,		\&
	$00, $00, $07, $00, $00,		\'
	$00, $1C, $22, $41, $00,		\(
	$00, $41, $22, $1C, $00,		\)
	$22, $14, $7F, $14, $22,		\*
	$08, $08, $3E, $08, $08,		\+
	$00, $40, $30, $00, $00,		\,
	$08, $08, $08, $08, $08,		\-
	$00, $00, $40, $00, $00,		\.
	$20, $10, $08, $04, $02,		\/
	$3E, $51, $49, $45, $3E,		\0
	$00, $42, $7F, $40, $00,		\1  MSB           LSB
	$62, $51, $49, $49, $46,		\2   . * * . . . * .
	$21, $41, $49, $4D, $33,		\3   . * . * . . . *
	$18, $14, $12, $7F, $10,		\4   . * . . * . . *
	$27, $45, $45, $45, $39,		\5   . * . . * . . *
	$3C, $4A, $49, $49, $31,		\6   . * . . . * * .
	$01, $71, $09, $05, $03,		\7
	$36, $49, $49, $49, $36,		\8
	$46, $49, $49, $29, $1E,		\9
	$00, $00, $14, $00, $00,		\:
	$00, $40, $34, $00, $00,		\;
	$08, $14, $22, $41, $00,		\<
	$14, $14, $14, $14, $14,		\=
	$00, $41, $22, $14, $08,		\>
	$02, $01, $59, $05, $02,		\?
	$3E, $41, $5D, $59, $4E,		\@
	$7C, $12, $11, $12, $7C,		\A
	$7F, $49, $49, $49, $36,		\B
	$3E, $41, $41, $41, $22,		\C
	$7F, $41, $41, $41, $3E,		\D
	$7F, $49, $49, $49, $41,		\E
	$7F, $09, $09, $09, $01,		\F
	$3E, $41, $41, $51, $71,		\G
	$7F, $08, $08, $08, $7F,		\H
	$00, $41, $7F, $41, $00,		\I
	$20, $40, $40, $40, $3F,		\J
	$7F, $08, $14, $22, $41,		\K
	$7F, $40, $40, $40, $40,		\L
	$7F, $02, $0C, $02, $7F,		\M
	$7F, $04, $08, $10, $7F,		\N
	$3E, $41, $41, $41, $3E,		\O
	$7F, $09, $09, $09, $06,		\P
	$3E, $41, $51, $21, $5E,		\Q
	$7F, $09, $19, $29, $46,		\R
	$26, $49, $49, $49, $32,		\S
	$01, $01, $7F, $01, $01,		\T
	$3F, $40, $40, $40, $3F,		\U
	$1F, $20, $40, $20, $1F,		\V
	$7F, $20, $18, $20, $7F,		\W
	$63, $14, $08, $14, $63,		\X
	$03, $04, $78, $04, $03,		\Y
	$61, $51, $49, $45, $43,		\Z
	$7F, $7F, $41, $41, $41,		\[
	$02, $04, $08, $10, $20,		\\
	$41, $41, $41, $7F, $7F,		\]
	$10, $08, $04, $08, $10,		\^
	$40, $40, $40, $40, $40,		\_
	$00, $01, $02, $04, $00,		\`
	$20, $54, $54, $54, $78,		\a
	$7F, $44, $44, $44, $38,		\b
	$38, $44, $44, $44, $44,		\c
	$38, $44, $44, $44, $7F,		\d
	$38, $54, $54, $54, $58,		\e
	$08, $7E, $09, $09, $02,		\f
	$18, $A4, $A4, $A4, $78,		\g
	$7F, $04, $04, $04, $78,		\h
	$00, $44, $7D, $40, $00,		\i
	$40, $80, $80, $7D, $00,		\j
	$7F, $10, $28, $44, $00,		\k
	$00, $41, $7F, $40, $00,		\l
	$7C, $04, $78, $04, $78,		\m
	$7C, $04, $04, $04, $78,		\n
	$38, $44, $44, $44, $38,		\o
	$FC, $24, $24, $24, $18,		\p
	$18, $24, $24, $24, $FC,		\q
	$7C, $08, $04, $04, $08,		\r
	$48, $54, $54, $54, $24,		\s
	$04, $04, $3F, $44, $44,		\t
	$3C, $40, $40, $40, $7C,		\u
	$1C, $20, $40, $20, $1C,		\v
	$3C, $40, $38, $40, $3C,		\w
	$44, $28, $10, $28, $44,		\x
	$8C, $50, $20, $10, $0C,		\y
	$44, $64, $54, $4C, $44,		\z
	$08, $3E, $41, $41, $00,		\{
	$00, $00, $77, $00, $00,		\|
	$00, $41, $41, $3E, $08,		\}
	$08, $04, $08, $10, $08,		\~
	$FF, $FF, $FF, $FF, $FF];		\RUBOUT

FOpenO("font.txt");
\Rotate font
for Ch:= 0, 127 do
	begin
	IM:= $01;
	for J:= 0, 7 do
		begin
		OM:= $10;
		OB:= 0;
		for I:= 0, 4 do
			begin
			IB:= FontTbl(Ch*5+I);
			if IB & IM then
				OB:= OB ! OM;
			OM:= OM >> 1;
			end;
		Hex2Out(OD, OB);
		Text(OD, " ");
		IM:= IM << 1;
		end;
	Crlf(OD);
	end;
Close(OD);
end;	\Main
