\MASTERBK.XPL	NOV-06-90
\MASTER MIND CODE BREAKER
\ BY KEVIN MORGAN AND LOREN BLANEY
\BASED ON A PROGRAM WRITTEN IN BASIC BY LLOYD MILLIGAN, BYTE OCT 1977
\ P. 168.

\REVISION HISTORY:
\APR-01-85, ORIGINAL (FOR ALL YOU FOOLS, APRIL AND OTHERWISE)
\FEB-28-86, MODIFIED FOR 32-BIT XPL, L.B.
\NOV-06-90, MODIFIED FOR PC.

code	RAN=1, RESERVE=3, CHIN=7, CHOUT=8, CRLF=9, INTIN=10,
	INTOUT=11, TEXT=12, OPENI=13;

def	INTSIZE=2;	\NUMBER OF BYTES IN AN INTEGER
def	TAB=$09, FF=$0C, BEL=$07;

int	BOARD,		\ARRAY: 10 ROWS (TURNS) BY 4 COLUMNS
	COLOR,		\ARRAY OF COLORS
	PEGS,		\(10,2) ARRAY: NO. OF WHITE & BLACK PEGS FOR EACH ROW
	MOVE,		\ARRAY: MOVE (4 COLORS) FOR ONE ROW
	B,C,		\SCRATCH MOVE ARRAYS
	DONE,		\FLAG: THE GAME IS OVER
	ROW,		\THE CURRENT ROW (TURN)
	I,J,		\SCRATCH (MADE GLOBAL FOR SPEED)
	R,		\TEMPORARY ROW COUNTER FOR SEARCHING
	COMBOS,		\THE NUMBER OF COMBINATIONS (COLORS) (-1)
	BLACKS,		\THE NUMBER OF BLACK PEGS FOR THE CURRENT ROW
	WHITES,		\THE NUMBER OF WHITE PEGS
	I0,I1,I2,I3;	\'FOR' LOOP VARIABLES FOR "SEARCH"



proc	MAKEMOVE;	\MAKE MOVE AND GET BLACK AND WHITE PEGS
int	W,B;
begin
TEXT(0,"My move for row "); INTOUT(0,ROW+1); TEXT(0," is:	");
for I:=0,3 do [TEXT(0,BOARD(ROW,I)); CHOUT(0,TAB)];
CRLF(0);

OPENI(0);
loop	begin
	TEXT(0,"How many black pegs? ");
	B:=INTIN(0);
	if B>=0 & B<=4 then quit;
	CHOUT(0,BEL); TEXT(0,"Only 0 through 4 are possible."); CRLF(0);
	end;
PEGS(ROW,0):=B;
if B=4 then [DONE:=true; return];
if B=3 then
	W:=0		\IF 3 BLACKS THEN 0 WHITES
else	begin
	loop	begin
		TEXT(0,"How many white pegs? ");
		W:=INTIN(0);
		if W>=0 & W<=4-B then quit;
		CHOUT(0,BEL);
		TEXT(0,"Only 0 through "); INTOUT(0,4-B);
		TEXT(0," are possible."); CRLF(0);
		end;
	end;
PEGS(ROW,1):=W;
end;	\MAKEMOVE



proc	SEARCH;		\BRUTE-FORCE SEARCH FOR A MOVE
begin
for I0:=0,COMBOS do
    for I1:=0,COMBOS do
	for I2:=0,COMBOS do
	    for I3:=0,COMBOS do
		begin
		MOVE(0):=COLOR(I0);	\GNEREATE A HYPOTHETICAL CODE
		MOVE(1):=COLOR(I1);
		MOVE(2):=COLOR(I2);
		MOVE(3):=COLOR(I3);

		loop	begin
			for R:=0,ROW-1 do	\CHECK CODE FOR CONSISTENCY WITH
				begin		\ WHITE AND BLACK PEGS FROM
				for J:=0,3 do	\ PREVIOUS ROWS
					begin
					C(J):=BOARD(R,J);
					B(J):=MOVE(J);
					end;
	
				\COUNT THE BLACK PEGS FIRST
				BLACKS:=0;
				for J:=0,3 do
					if C(J)=B(J) then
						begin
						BLACKS:=BLACKS+1;
						B(J):="X";	\CROSS THEM OFF
						C(J):="X";	\(ONLY USE ONCE)
						end;
				\NOW COUNT THE WHITE PEGS
				WHITES:=0;
				for J:=0,3 do
				    for I:=0,3 do
					if C(J)=B(I) then
						begin
						WHITES:=WHITES+1;
						B(I):="X";	\CROSS IT OFF
						I:=3;		\SKIP TO NEXT J
						end;

				\CHECK FOR AGREEMENT OF BLACK AND WHITE COUNT
				if BLACKS#PEGS(R,0) ! WHITES#PEGS(R,1) then
					quit;	\REJECT--GET NEXT COMBO
				end;	\"R" LOOP

			\MAKE SURE THIS MOVE DOES NOT DUPLICATE THE FIRST ROW
			I:=0;
			for J:=0,3 do
				if BOARD(0,J)=MOVE(J) then I:=I+1;
			if I=4 then quit;	\REJECT--GET NEXT COMBO

			\ASSIGN HYPOTHETICAL MOVE TO ROW
			for J:=0,3 do BOARD(ROW,J):=MOVE(J);
			MAKEMOVE;
			if DONE then
				begin
				TEXT(0,"Thanks for the game."); CRLF(0);
				return;
				end;
			ROW:=ROW+1;	\NEXT ROW
			if ROW>=10 then
				begin
				TEXT(0,"I give up, YOU WIN!"); CRLF(0);
				return;	\(SHOULDN'T EVER HAPPEN)
				end;
			CRLF(0);
			quit;		\CONTINUE WITH NEXT COMBO
			end;	\'LOOP'
		end;	\NESTED 'FOR' LOOPS
TEXT(0,"I'm confused, could you possibly have made a mistake?"); CRLF(0);
end;	\SEARCH



loop begin	\MAIN
BOARD:=RESERVE(10*INTSIZE);		\(10,4)	MOVE FOR ROW, COLUMN
for J:=0,9 do BOARD(J):=RESERVE(4*INTSIZE);
PEGS:=RESERVE(10*INTSIZE);		\10,2	WHITE (1) AND BLACK (0) PEGS
for J:=0,9 do PEGS(J):=RESERVE(2*INTSIZE);

COLOR:=["RED","BLUE","GREEN","YELLOW","BLACK","WHITE","EMPTY"];
MOVE:=RESERVE(4*INTSIZE);
B:=RESERVE(4*INTSIZE);
C:=RESERVE(4*INTSIZE);

CHOUT(0,FF);
TEXT(0,"			-- MASTER MIND CODEBREAKER --

The colors are: RED, BLUE, GREEN, YELLOW, BLACK, WHITE, and optionally EMPTY.
You make up a code using 4 of the colors, and I'll break it. A black peg is
given for each position with the correct color. A white peg is given for each
correct color which is not in the correct position. For example:

	your code:	RED	GREEN	YELLOW	YELLOW
	my guess:	WHITE	RED	YELLOW	BLUE

You give a black peg for the matched YELLOWs and a white peg for the REDs.

");

OPENI(0);
TEXT(0,"Are EMPTY positions allowed (n/y)? ");
COMBOS:=if (CHIN(0)!$20) = ^y then 6 else 5;
CRLF(0);

ROW:=0;
\MAKE INITIAL GUESS BY ASSIGNING COLORS AT RANDOM FOR THE FIRST ROW
for J:=0,3 do BOARD(0,J):=COLOR(RAN(COMBOS+1));

DONE:=false;
MAKEMOVE;
if DONE then
	[TEXT(0,"Gee!  That was just a wild guess."); CRLF(0)]
else	[ROW:=1; CRLF(0); SEARCH];

CRLF(0);
TEXT(0,"Another game (n/y)? ");
OPENI(0);
if (CHIN(0)!$20) # ^y then quit;
CRLF(0);
end;	\MAIN
