\MAZE.XPL	APR-17-90
\Writen by various members of the 6502 Group.
\This version uses the PC's box characters to draw the maze.

code RAN= 1, RESERVE= 3, CHOUT= 8, CRLF= 9, OPENO= 14, CLOSE=15;

def	INTSIZE= 2;
def	OD= 0;		\Output device
def	FULL= false, EMPTY= true,	\Some useful booleans
	CLOSED= true, OPEN= false;

int	ROWS,		\Number of rows
	COLS,		\Number of columns
	II, JJ;		\Scratch for MAIN

int	\Arrays:
	VWALL,		\Vertical walls (either open or closed)
	HWALL,		\Horizontal walls (either open or closed)
	CELL;		\Cells of the maze (either empty or full)



proc	PRINT;		\Print the maze
int	I, J, M;
addr	TBL;		\Table of box characters
begin
OPENO(OD);

for J:= 0, ROWS do			\For all rows...
	begin
	CRLF(OD);
	for I:= 0, COLS-1 do		\One line of horizontal walls
		begin
		M:= 0;
		if I >0 then if HWALL(I-1, J) =CLOSED then M:= M !2;
		if J >0 then if VWALL(I, J-1) =CLOSED then M:= M !1;
		if J <ROWS then if VWALL(I, J) =CLOSED then M:= M !4;
		if HWALL(I, J) = CLOSED then
			begin			\ +---
			TBL:= [$C8CD, $CACD, $CCC9, $CECB];
			CHOUT(OD, TBL(M));
			CHOUT(OD, $CD); CHOUT(OD, $CD); CHOUT(OD, $CD);
			end
		else	begin			\ +   
			TBL:= [$BA20, $BCCD, $BABA, $B9BB];
			CHOUT(OD, TBL(M));
			CHOUT(OD, ^ ); CHOUT(OD, ^ ); CHOUT(OD, ^ );
			end;
		end;
	M:= 0;
	if HWALL(COLS-1, J) =CLOSED then M:= M !2;
	if J >0 then if VWALL(COLS, J-1) =CLOSED then M:= M !1;
	if J <ROWS then if VWALL(COLS, J) =CLOSED then M:= M !4;
	TBL:= [$BA20, $BCCD, $BABA, $B9BB];
	CHOUT(OD, TBL(M));
	CRLF(OD);

	if J # ROWS then
	    for I:= 0, COLS do		\One line of vertical walls
		begin
		if VWALL(I, J) = CLOSED then
			CHOUT(OD, $BA)
		else	CHOUT(OD, ^ );
		CHOUT(OD, ^ ); CHOUT(OD, ^ ); CHOUT(OD, ^ );
		end;
	end;
CLOSE(OD);
end;	\PRINT

\======================================================================

proc	FILL;		\Fill the maze with paths
int	NOFILLED, I, J, SI, SJ;
int	MAXC;	\Number of cells in the maze



proc	TRACE;		\Trace one path
int	STUCK, UPOK, DNOK, LFOK, RTOK, DIR;



proc	MOVCHK;		\Check potiential move
\Can't go out of bounds and can't move into a filled cell.
begin

UPOK:= false;   DNOK:= false;   LFOK:= false;   RTOK:= false;

if J-1 >= 0   then UPOK:= CELL(I, J-1);	\Can we go up?
if J+1 < ROWS then DNOK:= CELL(I, J+1);	\Can we go down?
if I-1 >= 0   then LFOK:= CELL(I-1, J);	\Can we go left?
if I+1 < COLS then RTOK:= CELL(I+1, J);	\Can we go right?

STUCK:= not (UPOK ! DNOK ! LFOK ! RTOK); \Are we stuck?
end;	\MOVCHK



begin	\TRACE
MOVCHK;					\Find the valid directions
while not STUCK do
	begin
	DIR:= RAN(4);			\Choose a random direction
	loop	begin			\Try to go that way
		case DIR of
		  0: if RTOK then
			begin
			I:= I +1;
			VWALL(I, J):= OPEN;
			quit;
			end;
		  1: if LFOK then
			begin
			I:= I -1;
			VWALL(I+1, J):= OPEN;
			quit;
			end;
		  2: if UPOK then
			begin
			J:= J -1;
			HWALL(I, J+1):= OPEN;
			quit;
			end;
		  3: if DNOK then
			begin
			J:= J +1;
			HWALL(I, J):= OPEN;
			quit;
			end
		other;

		DIR:= DIR +1;		\No good so try next direction
		if DIR > 3 then DIR:= 0;
		end;

	CELL(I, J):= FULL;		\Found one, so mark it
	NOFILLED:= NOFILLED +1;		\One more full
	MOVCHK;				\Set up for next move
	end;
end;	\TRACE



proc	NEWCELL;	\Step to next cell (raster scan)
begin
if SJ+1 < ROWS then SJ:= SJ +1		\Go down if possible
else	begin
	SJ:= 0;				\Else go to top
	if SI+1 < COLS then SI:= SI +1	\And right one if possible
	else SI:= 0;			\Reset if we cannot
	end;
I:= SI;
J:= SJ;
end;	\NEWCELL



begin	\FILL
I:= RAN(COLS);				\Start at a random cell
J:= RAN(ROWS);
CELL(I, J):= FULL;			\Mark it full
NOFILLED:= 1;				\We have one full
SI:= I;					\Save starting position
SJ:= J;					\ for NEWCELL

MAXC:= ROWS *COLS;			\Form array sizes

while NOFILLED < MAXC do		\Fill all cells
	begin
	while CELL(I, J) = EMPTY do	\Find a full cell
		 NEWCELL;
	TRACE;				\ and trace from there
	NEWCELL;			\Then go to next cell
	end;
end;	\FILL

\======================================================================

begin	\MAIN
\The matrices are seen as I by J, I being the X direction.
\CELL is (I, J), with I:= 0, COLS-1 and J:= 0, ROWS-1
\VWALL is (I, J), with I:= 0, COLS and J:= 0, ROWS-1
\HWALL is (I, J), with I:= 0, COLS-1 and J:= 0, ROWS

ROWS:= 11;
COLS:= 18;

CELL:= RESERVE(COLS *INTSIZE);
for II:= 0, COLS-1 do
	CELL(II):= RESERVE(ROWS *INTSIZE);

VWALL:= RESERVE((COLS+1) *INTSIZE);
for II:= 0, COLS do
	VWALL(II):= RESERVE(ROWS *INTSIZE);

HWALL:= RESERVE(COLS *INTSIZE);
for II:= 0, COLS-1 do
	HWALL(II):= RESERVE((ROWS+1) *INTSIZE);

for JJ:= 0, ROWS-1 do 
    for II:= 0, COLS-1 do
	CELL(II, JJ):= EMPTY;		\Set all cells to empty

for JJ:= 0, ROWS-1 do 
    for II:= 0, COLS do
	VWALL(II, JJ):= CLOSED;		\Set all vertical walls to closed

for JJ:= 0, ROWS do 
    for II:= 0, COLS-1 do
	HWALL(II, JJ):= CLOSED;		\Set all horizontal walls to closed

FILL;					\Trace all paths
					\Open up the ends:
JJ:= RAN(ROWS);				\Pick a random row on the left
VWALL(0, JJ):= OPEN;
JJ:= RAN(ROWS);				\Pick another on the right
VWALL(COLS, JJ):= OPEN;

PRINT;					\Display maze
end;	\MAIN
