\MENU.XPL	MAR-19-93
\MENU FOR EXECUTING OTHER PROGRAMS

inc	C:\CXPL\CODESI;

char	FNAME;		\FILE NAME

int	COLOR, 		\FLAG: COLOR MONITOR AVAILABLE	
	BAR, 		\MENU STRUCTURE FOR HIGHLIGHTING
	SELECTION, 	\SELECTED ITEM
	;

def	CR=$0D, TAB=$09, FF=$0C;
def	UP=-72, DN=-80;



func	KEYIN;			\Input a keystroke and handle special keys
int	KEY;
begin
KEY:= CHIN(1);
if KEY = 0 then
	KEY:= -CHIN(1);		\Get scan code for non-ASCII keys
return KEY;			\ and return it as a negative number
end;	\KEYIN

\----------------------------------------------------------------------

func	MENU(M, C);		\SHOW A MENU AND HIGHLIGHT BARS
\RETURN THE VALUE OF THE BAR SELECTED
integer M,	\structure
	C,	\STARTING BAR
	P;


	proc	ADVANCE;	\ADVANCE MENU BAR
	begin
	HILIGHT(M(P,1), M(P,2), M(P,1)+M(P,3), M(P,2),
		if COLOR then $17 else $07);
	P:= P +1;
	if M(P, 0) = 0 then P:= 0;
	HILIGHT(M(P,1), M(P,2), M(P,1)+M(P,3), M(P,2),
		if COLOR then $70 else $7F);
	end;	\ADVANCE


	proc	BACKUP;		\BACKUP MENU BAR
	begin
	HILIGHT(M(P,1), M(P,2), M(P,1)+M(P,3), M(P,2),
		if COLOR then $17 else $07);
	if P = 0 then
		repeat P:= P+1 until M(P,0) = 0;
	P:= P -1;
	HILIGHT(M(P,1), M(P,2), M(P,1)+M(P,3), M(P,2),
		if COLOR then $70 else $7F);
	end;	\BACKUP


begin	\MENU
P:= 0;
while M(P,0) # 0 do
	[CURSOR(M(P,1), M(P,2));   TEXT(6, M(P,0));   P:= P +1];

\DECODE KEYS AND HIGHLIGHT MENU ITEMS
CURSOR(0, 24);
P:= C;
HILIGHT(M(P,1), M(P,2), M(P,1)+M(P,3), M(P,2), if COLOR then $70 else $7F);
loop	begin
	case KEYIN of
	  CR:	return P;
	  UP: 	BACKUP;
	  DN:	ADVANCE
	other;
	end;
end;	\MENU



proc	PAINT;
begin
CHOUT(0, FF);
ATTRIB(if COLOR then $17 else $07);
SETWIND(0, 0, 80, 25, $100, false);
RAWTEXT(6, "
ͻ
                              HARMONIC MOTIONS                             
                  Copyright 1993 The 6502 Program Exchange                 
            Select option with up and down arrows then hit Enter           
Ķ
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
ͼ
 ");
end;	\PAINT



proc	MAKEMENU;		\Create menu structure
begin
\EACH CONSIST OF:
\ 1. MENU ITEM STRING
\ 2. X, Y LOCATION OF STRING
\ 3. LENGTH OF HIGHLIGHT BAR
BAR:= [ ["   GO TO SPRING ", 30, 8, 20], 	\0
	["   GO TO PENDULUM", 30, 9, 20], 	\1
	["   GO TO REALPEND", 30, 10, 20], 	\2
	["   GO TO COUPLE  ", 30, 11, 20], 	\3
	["   GO TO OSC3D  ", 30, 12, 20], 	\4
	["   GO TO CHAOS  ", 30, 13, 20], 	\5
	["       QUIT       ", 28, 14, 20], 	\6
	[0] ];
end;	\MAKEMENU



begin	\MAIN
COLOR:= true;	
MAKEMENU;

SELECTION:= 0;
loop	begin
	PAINT;
	SELECTION:= MENU(BAR, SELECTION);
	case SELECTION of
	  0: FNAME:= "SPRING.COM";
	  1: FNAME:= "PENDULUM.COM";
	  2: FNAME:= "REALPEND.COM";
	  3: FNAME:= "COUPLE.COM";
	  4: FNAME:= "OSC3D.COM";
	  5: FNAME:= "CHAOS.COM";
	  6: quit
	other;
	CHOUT(0, FF);
	CHAIN(FNAME);
	end;

CHOUT(0, FF);
end;	\MAIN
