\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,       MOD=58,         LOG=59,         COS=60,
TAN=61,         ASIN=62,        ACOS=63;

int CPUREG,TEMP;
int MOUSEX,MOUSEY,SSX,SSY,LFTFST,RGTFST,BBX,BBY,LMX,LMY,SENX,SENY,SENM;
int MBLEFT,MBRIGHT,MBMIDDLE;

proc MC(ON);
int ON;
begin
if ON then TEMP:=1 else TEMP:=2;
CPUREG(0):=TEMP;          \TURN ON/OFF MOUSE CURSOR;
SOFTINT($33);
end;

proc SETMSENSITIVITY;           \Set Mouse Sensitivity
begin
CPUREG(0):=$1B;
SOFTINT($33);
SENX:=CPUREG(1);
SENY:=CPUREG(2);
SENM:=CPUREG(3);
CPUREG(0):=$1A;
CPUREG(1):=CPUREG(1)/2;
CPUREG(2):=CPUREG(2)/2;
CPUREG(3):=CPUREG(3)/2;
SOFTINT($33);
end;

proc RESMSENSITIVITY;           \Restor Mouse Sensitivity
begin
CPUREG(0):=$1A;
CPUREG(1):=SENX;
CPUREG(2):=SENY;
CPUREG(3):=SENM;
SOFTINT($33);
end;

proc SMPOS;
begin
CPUREG(0):=4;
CPUREG(2):=MOUSEX;
CPUREG(3):=MOUSEY;
SOFTINT($33);
end;

proc MOUSEBOUNDRY(BX,BY,EX,EY);
int BX,BY,EX,EY;
begin
CPUREG(0):=$7;     CPUREG(2):=BX;      CPUREG(3):=EX;   SOFTINT($33);
CPUREG(0):=$8;     CPUREG(2):=BY;      CPUREG(3):=EY;   SOFTINT($33);
end;

proc SETVGA;
begin
SSX:=640;
SSY:=480;
SETVID(18);
MC(true);
MOUSEBOUNDRY(0,0,SSX-1,SSY-1);
\Set Max/Min positions for Horizontal and Vertical
end;

proc GETMINFO;
begin
CPUREG(0):=$3;
SOFTINT($33);
MOUSEX:=CPUREG(2);
MOUSEY:=CPUREG(3);
TEMP:=CPUREG(1);
case TEMP of
0:      [MBLEFT:=false;MBRIGHT:=false];
1:      [MBLEFT:=true;MBRIGHT:=false];
2:      [MBLEFT:=false;MBRIGHT:=true];
3:      [MBLEFT:=true;MBRIGHT:=true]
        else;
\CURSOR(0,0);
\INTOUT(0,CPUREG(1));
end;

proc WAITMOUSE;
loop
        begin
        GETMINFO;
        if MBLEFT=false & MBRIGHT=false then quit;
        end;

proc EXITP;
begin
SETVID(3);
exit;
end;

proc INVPNT(INVX,INVY);
int INVX,INVY;
begin
\RETCLR:=READPIX(XPOS,YPOS);
POINT(INVX,INVY,15-READPIX(INVX,INVY));
end;

proc INVBOX(BX,BY,EX,EY);
int BX,BY,EX,EY;
begin
MC(false);
if BX>EX then [TEMP:=EX;EX:=BX;BX:=TEMP];
if BY>EY then [TEMP:=EY;EY:=BY;BY:=TEMP];
for TEMP:=BX,EX do [INVPNT(TEMP,BY);INVPNT(TEMP,EY)];
for TEMP:=BY,EY do [INVPNT(BX,TEMP);INVPNT(EX,TEMP)];
MC(true);
end;

proc SELECT;
begin
loop
        begin
        GETMINFO;
        if MBRIGHT=false then [RGTFST:=true;INVBOX(BBX,BBY,LMX,LMY);quit];
        if RGTFST then
                begin
                RGTFST:=false;
                BBX:=MOUSEX;
                BBY:=MOUSEY;
                LMX:=MOUSEX;
                LMY:=MOUSEY;
                INVPNT(BBX,BBY);
                end
        else
                begin
                if LMX#MOUSEX ! LMY#MOUSEY then
                        begin
                        INVBOX(BBX,BBY,LMX,LMY);
                        INVBOX(BBX,BBY,MOUSEX,MOUSEY);
                        LMX:=MOUSEX;
                        LMY:=MOUSEY;
                        end;
                end;
        end;
end;

proc DRAW;
begin
loop
        begin
        GETMINFO;
        if MBLEFT=false then [LFTFST:=true;quit];
        if LFTFST then
                begin
                LFTFST:=false;
                MC(false);
                POINT(MOUSEX,MOUSEY,15);
                MC(true);
                LMX:=MOUSEX;
                LMY:=MOUSEY;
                end
                else
                        if LMX#MOUSEX ! LMY#MOUSEY then
                                begin
                                MC(false);
                                LINE(MOUSEX,MOUSEY,15);
                                MC(true);
                                LMX:=MOUSEX;
                                LMY:=MOUSEY;
                                end;
        end;
end;

begin
CPUREG:=GETREG;
SETVGA;
LFTFST:=true;
RGTFST:=true;
loop
        begin
        GETMINFO;
        if MBRIGHT then SELECT;
        if MBLEFT then DRAW;
        if CHKKEY then EXITP;
        end;
end;
