


\File opening dialog box

include \CXPL\CODESI.XPL;

\ GLOBAL DECLARATIONS

define		\SOME ASCII CHARACTERS
	BS=8,		\BACKSPACE
	DEL=8,		\DELETE CHARACTER
	SP=$20,		\SPACE
	ESC=$1B,	\ESCAPE
	CR=13,		\CARRIAGE RETURN
	LF=10,		\LINE FEED
	FF=12;		\FORM FEED


\VARIABLES FOR MOUSE SUPPORT

integer
	DOWNCALLS,		\CALLS SINCE BUTTON WENT DOWN
	GOTMOUSE,		\FLAGS MOUSE IS PRESENT
	MOUSECX,MOUSECY,	\CHARACTER COORDINATE OF LAST BUTTON PRESS
	MOUSEHX,MOUSEHY,	\GRAPHICS COORDIANTE OF LAST BUTTON PRESS
	CHARHEIGHT,		\HEIGHT OF RASTER GRAPHICS CHARACTER
	MOUSEHOT;		\ARRAYS OF HOT SPOTS


\VARIABLES FOR OPENING FILES

address
	DEFTEMP,	\DEFAULT TEMPLATE
	TEMPLATE,	\FILE TEMPLATE
	FNAME;		\CURRENT FILE NAME

define
	TEMPMAX=32,	\MAX CHARACTERS FOR TEMPLATE
	FNAMMAX=80;	\FILE NAME LENGTH

integer
	DATASEG,	\POINTER TO DATA SEGMENT
	CPUREG;		\CPU REGISTER ARRAY

\TEXT WINDOW AND MENU VARIABLES


integer
	OLDVMODE,		\VIDEO MODE UPON ENTER
	MONITOR,		\HOLDS TYPE OF VIDEO MONITOR
	ATTRIB1,ATTRIB2,	\VIDEO ATTRIBUTES FOR WINDOWS
	ATTRIB3,ATTRIB4,
	ATTRIB5,ATTRIB7,HIATT1;


\KEY BOARD SCAN CODE DEFINITIONS


define
	NULCOM=-1,	\NUL OR NO COMMAND FOR MOUSE
	EXTCOM1=-2,	\EXTENDED COMMAND FOR MOUSE
	EXTCOM2=-3,
	FUNC1=59,	\FUNCTION 1
	FUNC2=60,	\FUCNTION 2
	FUNC3=61,	\FUNCTION 3
	PAGEDN=81,	\PAGE DOWN KEY
	PAGEUP=73,	\PAGE UP KEY
	HOME=71,	\HOME KEY
	END=79,		\END KEY
	UPARROW=72,	\UP ARROW KEY
	DNARROW=80;	\DOWN ARROW KEY

\VARIABLES FOR FORMATED SCREEN DISPLAYS

integer
	INFLAG;		\FLAGS TYPE OF INPUT

define
	BWHITE,		\BLACK AND WHITE MONITOR TYPE
	COLOR;		\COLOR MONITOR TYPE
	
integer
	X;		\GLOBAL TEMP

\------------------- LOW LEVEL SUPPORT ROUTINES ------------------------

procedure MAKEUP(C);
\CONVERT CHARACTER TO UPPER CASE
integer C;
return if C>=^a & C<=^z then C-$20 else C;


procedure BLANK;
CHOUT(0,FF);


\------------------- STRING HANDLING ROUTINES --------------------------


procedure ALPHA(C);
\RETURN TRUE IF ASCII ALPHA
integer C;
begin
if C>0 then C:=C & $7F;
return (C>=^A & C<=^Z) ! (C>=^a & C<=^z);
end;


procedure GETSTR(STR,LEN);
\DO CONTROLLED STRING INPUT
address STR;
integer LEN,PTR,C;
begin
OPENI(0);
PTR:=0;
loop
	begin
	C:=CHIN(1);
	case C of
	DEL: if PTR#0 then [CHOUT(0,BS);CHOUT(0,SP);CHOUT(0,BS);PTR:=PTR-1;];
	ESC: [PTR:=0; quit;];
	CR,0: quit
	else if PTR<LEN & C>$1F then [STR(PTR):=C;CHOUT(0,C);PTR:=PTR+1;];
	end;
if PTR>0 then STR(PTR-1):=STR(PTR-1) ! $80 else STR(0):=C ! $80;
end;


procedure STRLEN(S);
\FIND STRING LENGTH
char S;
int I;
for I:=0,32767 do
if S(I)>$7F then return I+1;



procedure SCOPY(S1,S2);
\COPY STRINGS S2 INTO S1
char S1,S2;
int I;
for I:=0,32767 do
[S1(I):=S2(I);if S1(I)>$7F then return];


procedure CENTER(DEV,S,L);
\CENTER A STRING ON A LINE OF LENGTH L
int DEV;char S;int L,P;
[for P:=1,(L-STRLEN(S))/2 do CHOUT(DEV,SP);TEXT(DEV,S);];



procedure ZTEXT(D,S);
\OUTPUT A ZERO TERMINATED STRING
int D;char S;int P;
for P:=0,32000 do [if S(P)=0 then return P;CHOUT(D,S(P));];



procedure ZERTRM(S1,S2);
\MAKE S1 ZERO TERMINATED STRING RESULT IN S2
char S1,S2;int P,C;
begin
for P:=0,FNAMMAX-1 do
	begin
	C:=S1(P);
	S2(P):=C&$7F;
	if C>$7F then [S2(P+1):=0;return;];
	end;
end;


procedure Z2MCOPY(S1,S2);
\COPY ZERO TERMINATED STRING TO MSB TERMINATED
char S1,S2;
int P;
begin
for P:=0,32000 do
	begin
	S2(P):=S1(P);
	if S1(P)=0 then
		begin
		if P=0 then S2(0):=$A0
		else S2(P-1):=S2(P-1) ! $80;
		return;
		end;
	end;
end;


\------------------- WINDOW SUPPORT ROUTINES ---------------------------


procedure FSTRING(S,L);
\INPUT NEW STRING IF USER DOESN'T ENTER CR
char S;int L;
char STMP;
begin
STMP:=RESERVE(L);
GETSTR(STMP,L);
if (STMP(0) & $7F)>$1F then SCOPY(S,STMP);
INFLAG:=STMP(0) & $7F;
end;




\-------------------- SET UP VIDEO DISPLAY -----------------------------


procedure GETVMODE;
\RETURNS CURRENT VIDEO MODE
begin
CPUREG(0):= $0F00;
SOFTINT($10);
return CPUREG(0) & $FF;
end;



procedure SETVIDEO;
\Do video specific setup
begin
CPUREG(0):= $0F00;
SOFTINT($10);
OLDVMODE:=CPUREG(0) & $FF;
case OLDVMODE of
	$02,$07: MONITOR:=BWHITE
else MONITOR:=COLOR;  
if MONITOR=COLOR then
	begin
	ATTRIB1:=$17;ATTRIB2:=$47;ATTRIB3:=$0E;
	ATTRIB4:=$02;ATTRIB5:=$1E;HIATT1:=$70;
	ATTRIB7:=$1C;
	end
else
	begin
	ATTRIB1:=$07;ATTRIB2:=$70;ATTRIB3:=$0F;
	ATTRIB4:=$0F;ATTRIB5:=$07;HIATT1:=$70;
	ATTRIB7:=$07;
	end;
end;


\------------------- MOUSE SUPPORT ROUTINES ----------------------------

procedure MOUSEINI;
int M;
\Test for mouse and initialize

	procedure MVECTOR;
	\TEST FOR VALID MOUSE VECTOR
	begin
	CPUREG(0):=$3533;
	SOFTINT($21);
	return CPUREG(1)#0 ! CPUREG(11)#0;
	end;

begin
if not MVECTOR then [GOTMOUSE:=false; return;];
CPUREG(0):=0;
SOFTINT($33);
GOTMOUSE:=CPUREG(0);

case GETVMODE of
	  6: CHARHEIGHT:=8;
	$10: CHARHEIGHT:=14;
	$12: CHARHEIGHT:=16
other CHARHEIGHT:=8;
end;



procedure SHOWMCURSOR(ON);
\Turn mouse cursor on or off
int ON;
begin
if not GOTMOUSE then return;
CPUREG(0):=if ON then 1 else 2;
SOFTINT($33);
end;



procedure MCURSOR(X,Y);
\Move mouse cursor to specified position
int X,Y;
begin
if not GOTMOUSE then return;
CPUREG(0):=4;
CPUREG(2):=X;
CPUREG(3):=Y;
SOFTINT($33);
end;



procedure TIMEOUT;
\Delay to simulate repeat action
int DELAY,TIME1;
begin
case DOWNCALLS of
	0,1: DELAY:=1;
	2: DELAY:=9
other DELAY:=1;
TIME1:=(PEEK(0,$46C) + DELAY) & $FF;
loop
	begin
	if PEEK(0,$46C)=TIME1 then return true;
	CPUREG(0):=5;
	CPUREG(1):=0;
	SOFTINT($33);
	if CPUREG(0)=0 then return false;
	end;
end;




procedure MOUSEBUTTON;
\RETURN TRUE IF MOUSE BUTTON HIT
int BTEMP;
begin
if not GOTMOUSE then return false;
\Check for mouse button
CPUREG(0):=3;
CPUREG(1):=0;
SOFTINT($33);
MOUSEHX:=CPUREG(2);
MOUSEHY:=CPUREG(3);
BTEMP:=CPUREG(1)=1;
DOWNCALLS:=if BTEMP the DOWNCALLS+1 else 0;
return BTEMP;
end;


procedure NEWMOUSE;
\WAIT FOR BUTTON UP OR NEW MOUSE POSITION
int OLDX,OLDY;
begin
OLDX:=MOUSEHX;OLDY:=MOUSEHY;
while MOUSEBUTTON do
if OLDX#MOUSEHX ! OLDY#MOUSEHY then return true;
return false;
end;

procedure PAUSE;
integer X;
begin
OPENI(0);TEXT(0,"HIT any KEY ");
repeat until not MOUSEBUTTON;
repeat until MOUSEBUTTON ! CHKKEY;
end;



procedure MOUSECOM(HOT);
\Check button press and decode mouse command
\from 'HOT' button array
int HOT; int P,T;
begin
if not GOTMOUSE then return NULCOM;
if MOUSEBUTTON then
	begin
	MOUSECX:=MOUSEHX/8;
	MOUSECY:=MOUSEHY/CHARHEIGHT;
	P:=0;
	while HOT(P,0)#-1 do
		begin
		if MOUSECY>=HOT(P,1) & MOUSECY<=HOT(P,3) then
		if MOUSECX>=HOT(P,0) &  MOUSECX<=HOT(P,2) then
			return if TIMEOUT then HOT(P,4) else NULCOM;

		P:=P+1;
		end;
	end;
return NULCOM;
end;



procedure MGETKEY(HOT);
int HOT,COM;
\Get keyboard or mouse input
\array of hotspots in HOT
begin
SHOWMCURSOR(true);
loop
	begin
	\Check for keystroke
	if CHKKEY then [COM:=CHIN(1);if COM=0 then COM:=-CHIN(1);quit;];
	COM:=MOUSECOM(HOT);
	if COM # NULCOM then quit;
	end;
SHOWMCURSOR(false);
return COM;
end;




procedure MOUSE_YES;
\RETURNS TRUE IF MOUSE OR KEY SELECTS YES
int A,X,Y,MOUSEHOT;
begin
TEXT(6,"CONFIRM ");
X:=PEEK($40,$50); Y:=PEEK($40,$51);
ATTRIB(ATTRIB2);
RAWTEXT(6," YES  NO  ");
MOUSEHOT:=[[0,0,0,0,^Y], [0,0,80,24,^N], [-1,-1,-1]];
MOUSEHOT(0,0):=X; MOUSEHOT(0,1):=Y; MOUSEHOT(0,2):=X+4; MOUSEHOT(0,3):=Y;
return MAKEUP(MGETKEY(MOUSEHOT))=^Y;
end;




\------------------- ROUTINES OPEN AND MANIPULATE DISK FILES -----------



procedure DIRECTORY(S);
\This procedure handles all directory and file functions
\String 'S' displayed as a prompt string
\It returns the selected file in FNAME
char S;
integer SPTR,FPTR,COM,P,NAMES;
char FATT,DOSBUF;
define MAXFILE=100;
define
	X1=5,Y1=1,		\Upper left corner of menu
	X2=X1+68,Y2=Y1+22,	\Lower right corner of menu
	LINES=11,		\Lines in directory window
	DIRWID=16,		\Width of directory window
	XX1=X1+2,YY1=Y1+5,	\Upper left corner of directory window
	XX2=XX1+DIRWID,		\Lower right corner of directory window
	YY2=YY1+LINES-1,
	BX1=XX1,BY1=YY1+LINES/2,\Coordinates of directory highlight bar
	BX2=XX2,BY2=BY1;


	procedure TPARSE(START,S1,S2);
	\PARSE A TEMPLATE INTO SEPARATE TARGETS
	int START;char S1,S2;int P,C;
	begin
	for P:=0,TEMPMAX-1 do
		begin
		C:=S1(P+START);S2(P):=C&$7F;
		if C>$7F then [S2(P+1):=0;return -1;];
		if S2(P)=^, then [S2(P):=0;return START+P+1;];
		end;
	return -1;
	end;


	procedure GETFNAME;
	\MANUAL FILENAME ENTRY
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+2,YY1+16,X2-2,YY1+16,$02,true);
	TEXT(6,"FILE NAME: ");
	FSTRING(FNAME,FNAMMAX);
	ATTRIB(ATTRIB1);
	SETWIND(X1+2,YY1+16,X2-2,YY1+16,$02,true);
	end;


	procedure DISPATH;
	\DISPLAY CURRENT PATH
	char PATH;
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+2,Y2-5,X2-2,Y2-5,$FF02,true);
	PATH:=RESERVE(64);
	CPUREG(0):=$4700;
	CPUREG(3):=0;
	CPUREG(9):=DATASEG;
	CPUREG(5):=PATH;
	SOFTINT($21);
	CPUREG(0):=$1900;
	SOFTINT($21);
	CHOUT(6,(CPUREG(0) & $FF) + ^A);
	TEXT(6,":\");ZTEXT(6,PATH);
	end;


	procedure DISTEMP;
	\DISPLAY CURRENT TEMPLATE
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+14,Y2-3,X1+14+TEMPMAX,Y2-3,$FF02,true);
	ZTEXT(6,TEMPLATE);
	end;


	procedure DISENTRY(P);
	\DISPLAY A DIRECTORY ENTRY
	int P,L;
	begin
	TEXT(6,"  ");
	if P<0 ! P>=FPTR then [TEXT(6,"               ");return;];
	if FATT(P)=$10 then [CHOUT(0,^<);L:=ZTEXT(6,NAMES(P));CHOUT(0,^>);]
		else L:=ZTEXT(6,NAMES(P));
	for P:=1,18-L do CHOUT(6,$20);
	end;


	procedure READDIR(T,E,A);
	\READ A DIRECTORY WITH SPECIFIED TEMPLATE AND ATTRIBUTES
	\E must equal the file attribute or A must match one bit
	char T;int E,A,P;
	char S;
	begin	
	\LOOK UP FIRST FILE
	CPUREG(0):=$4E00;
	CPUREG(2):=$FFF7;
	CPUREG(9):=DATASEG;
	CPUREG(3):=T; SOFTINT($21);
	if (CPUREG(0) & $FF) # 0 then return;

	loop
		begin
		P:=0;
		if DOSBUF(21)=E ! DOSBUF(21)&A then
		if DOSBUF(30)#^. ! DOSBUF(31)#0 then
			begin
			if FPTR>=MAXFILE then quit;
			S:=NAMES(FPTR);
				loop [S(P):=DOSBUF(30+P);if DOSBUF(30+P)=0 then quit;P:=P+1;];
			FATT(FPTR):=DOSBUF(21);
			FPTR:=FPTR+1;
			end;

		\LOOK UP NEXT FILE
		CPUREG(0):=$4F00; SOFTINT($21);
		if (CPUREG(0) & $FF) # 0 then quit;
		end;
	end;


	procedure GETDIR;
	\GET THE CURRENT DOS DIRECTORY
	char TT;int P;
	begin
	TT:=RESERVE(TEMPMAX);
	ZERTRM("*.*",TT);

	ATTRIB(ATTRIB2);
	SETWIND(X1+2,YY1+12,X2-2,YY1+12,$FF02,true);
	TEXT(6," READING DIRECTORY ");


	SPTR:=0;FPTR:=0;
	\Read directories
	READDIR(TT,-1,$10);
	\Now read files
	P:=0;
	repeat
		begin
		P:=TPARSE(P,TEMPLATE,TT);
		READDIR(TT,0,$21);
		end
	until P < 0;
	end;


	procedure CHDRIVE(C);
	\CHANGE DRIVES
	int C;
	char BUFFER;
	begin
	ATTRIB(ATTRIB2);
	SETWIND(X1+2,YY1+12,X2-2,YY1+12,$FF02,true);
	TEXT(6," TESTING DRIVE ");
	BUFFER:=RESERVE(512);
	C:=if C>=^a then C-^a else C-^A;
	TRAP($FFFB);
	READ(C,0,BUFFER,1);
	TRAP($FFFF);
	if GETERR#3 then
		begin
		CPUREG(3):=C & $FF;
		CPUREG(0):=$0E00;
		SOFTINT($21);
		end;
	GETDIR;
	end;


	procedure CHANGEDIR(P);
	\CHANGE DIRECTORIES
	int P;
	begin
	if FATT(P)# $10 then return;
	CPUREG(3):=NAMES(P);
	CPUREG(0):=$3B00;
	CPUREG(9):=DATASEG;
	SOFTINT($21);
	GETDIR;
	end;


	procedure DISFATT(P);
	\DISPLAY FILE ATTRIBUTES
	int P;
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+2,Y1+21,X2-2,Y1+21,$02,true);
	TEXT(6,"FILE ATTRIBUTE: ");
	HEXOUT(6,FATT(P));
	P:=MGETKEY(MOUSEHOT);
	ATTRIB(ATTRIB1);
	SETWIND(X1+2,Y1+21,X2-2,Y1+21,$02,true);
	end;


	procedure GETEMPLATE;
	\ENTER TEMPLATE STRING
	begin
	ATTRIB(ATTRIB4);
	SETWIND(X1+2,YY1+16,X2-2,YY1+16,$02,true);
	TEXT(6,"TEMPLATE: ");
	FSTRING(TEMPLATE,TEMPMAX);
	if INFLAG>$1F then ZERTRM(TEMPLATE,TEMPLATE) else ZERTRM(DEFTEMP,TEMPLATE);
	ATTRIB(ATTRIB1);
	SETWIND(X1+2,YY1+16,X2-2,YY1+16,$02,true);
	GETDIR;
	end;




	procedure DISDIRECT;
	\DISPLAY DIRECTORY
	integer P1,P2,P3,COM; real PC;
	begin
	DISPATH;
	DISTEMP;

	ATTRIB(ATTRIB4);
	SETWIND(XX1,YY1,XX2,YY2,$FF02,true);
	OPENI(0);
	SPTR:=0;
	loop
		begin
		for P1:=0,LINES-1 do
			begin
			P2:=SPTR-(LINES/2) + P1;
			CURSOR(XX1,YY1+P1);
			DISENTRY(P2);
			end;
		HILIGHT(XX1,YY1+LINES/2,XX2,YY1+LINES/2,HIATT1);

		HILIGHT(X1+21,YY1,X1+21,Y2-7,ATTRIB3);
		P3:=if FPTR<=1 then 1 else FIX( FLOAT(LINES-3) * ( FLOAT(SPTR)/FLOAT(FPTR-1) )) +1;
		HILIGHT(X1+21,YY1+P3,X1+21,YY1+P3,HIATT1);

		CURSOR(0,24);
		OPENI(0);
		COM:=MGETKEY(MOUSEHOT);
		case COM of
		-PAGEDN: SPTR:=if (SPTR+LINES) >=FPTR then FPTR-1 else SPTR+LINES;
		-PAGEUP: SPTR:=if (SPTR-LINES) <0 then 0  else SPTR-LINES;
		EXTCOM1: begin
			SPTR:=SPTR+(MOUSECY-BY1);
			if SPTR >=FPTR then SPTR:=FPTR-1;
			if SPTR<0 then SPTR:=0;
			MCURSOR(MOUSECX*8,(YY1+LINES/2)*8);
			end;
		EXTCOM2: begin
			PC:=FLOAT(MOUSECY-(YY1+1)) /FLOAT(LINES-3);
			SPTR:=FIX(FLOAT(FPTR-1)*PC);			
			end;
		-HOME: SPTR:=0;
		-END: SPTR:=FPTR-1;
		-UPARROW: if SPTR>0 then SPTR:=SPTR-1;
		-DNARROW: if SPTR<FPTR-1 then SPTR:=SPTR+1;
		-FUNC1,-FUNC2,-FUNC3: quit
		other case of
		ALPHA(COM): quit;
		COM=CR,COM=ESC: quit
		other;
		end;
	return COM;
	end;



	procedure DECODE;
	\Loop and Decode Directory commands
	begin
	loop 
		begin
		COM:=DISDIRECT;
		case of
		COM=ESC: return false;
		COM=CR: if FATT(SPTR)=$10 then CHANGEDIR(SPTR)
			else [Z2MCOPY(NAMES(SPTR),FNAME); return true;];
		COM=-FUNC2: GETEMPLATE;
		COM=-FUNC1: [GETFNAME; if INFLAG>$1F then return true;];
		COM=-FUNC3: DISFATT(SPTR);
		ALPHA(COM): CHDRIVE(COM)
		else;
		end;
	end;




procedure DISMENU;
\Display Directory Menu
begin
ATTRIB(ATTRIB1);
SETWIND(X1,Y1,X2,Y2,$FF02,true);
RAWTEXT(6,"ͻ
                                                                   
͹
                   SELECT A FILE OR A DIRECTORY                    
͹
                      HOME/END       - START/END OF LIST        
                      PAGE UP        - UP ONE PAGE              
                      PAGE DOWN      - DOWN ONE PAGE            
                                   - MOVE HIGHLIGHT           
                      RETURN         - SELECT FILE OR DIRECTORY 
                      A,B,C,D,E,F..  - CHANGE DISK DRIVE        
                      F1             - MANUAL FILE ENTRY        
                      F2             - CHANGE TEMPLATE          
                      ESCAPE         = Exit                     
                      <..>           = Move Up a Directory      
                      <name>         = Directory                
͹
                                                                   
͹
 TEMPLATE:                                                        
͹ 
                                                                   
ͼ ");
ATTRIB(ATTRIB7);CURSOR(X1+1,Y1+1);CENTER(6,S,X2-X1-2);

\Build structure for hot spots in menu
MOUSEHOT:=[[X1+21,YY1,X1+21,YY1,-UPARROW],
	[X1+21,Y2-7,X1+21,Y2-7,-DNARROW],
	[X1+26,YY1,X1+29,YY1,-HOME],
	[X1+31,YY1,X1+33,YY1,-END],
	[X1+26,YY1+1,X1+32,YY1+1,-PAGEUP],
	[X1+26,YY1+2,X1+34,YY1+2,-PAGEDN],
	[X1+26,YY1+3,X1+26,YY1+3,-UPARROW],
	[X1+31,YY1+3,X1+31,YY1+3,-DNARROW],
	[X1+26,YY1+4,X1+31,YY1+4,CR],
	[X1+26,YY1+5,X1+26,YY1+5,^A],
	[X1+28,YY1+5,X1+28,YY1+5,^B],
	[X1+30,YY1+5,X1+30,YY1+5,^C],
	[X1+32,YY1+5,X1+32,YY1+5,^D],
	[X1+34,YY1+5,X1+34,YY1+5,^E],
	[X1+36,YY1+5,X1+36,YY1+5,^F],
	[X1+26,YY1+6,X1+27,YY1+6,-FUNC1],
	[X1+26,YY1+7,X1+27,YY1+7,-FUNC2],
	[X1+26,YY1+8,X1+31,YY1+8,ESC],
	[X1+2,Y2-3,X1+10,Y2-3,-FUNC2],
	[BX1,BY1,BX2,BY2,CR],
	[XX1,YY1,XX2,YY2,EXTCOM1],
	[X1+21,Y1+5,X1+21,Y2-7,EXTCOM2],
	[-1,-1,-1]];

HILIGHT(X1+24,YY1,X1+40,Y2-9,ATTRIB5);
HILIGHT(X1+2,Y2-3,X1+10,Y2-3,ATTRIB5);
end;



begin	\start of DIRECTORY
DOSBUF:=RESERVE(43);

\SETUP A DTA FOR DIRECTORY WORK
CPUREG(0):=$1A00;
CPUREG(3):=DOSBUF;
CPUREG(9):=DATASEG;
SOFTINT($21);

FATT:=RESERVE(MAXFILE);
NAMES:=RESERVE(MAXFILE*2);
for P:=0,MAXFILE-1 do NAMES(P):=RESERVE(13);

ZERTRM(DEFTEMP,TEMPLATE);

BLANK;
GETDIR;
DISMENU;
COM:=DECODE;
return COM;
end;	\of DIRECTORY




\-------- CODE TO EXECUTE A PROGRAM ------------------------------------------


procedure VALIDEXE(S);
\Parse filename for EXE or COM
char S,P;
begin
P:=-1;
repeat [P:=P+1;if S(P)>$7F then return false;] until S(P)=^.;
if S(P+1)=^C & S(P+2)=^O & S(P+3)=(^M ! $80) then return true;
if S(P+1)=^E & S(P+2)=^X & S(P+3)=(^E ! $80) then return true;
return false;
end;



procedure EXECUTE;
\execute a file
begin
CHAIN(FNAME);
if CPUREG(7) then 
	begin
	CRLF(0);
	TEXT(0,"UNABLE TO EXECUTE PROGRAM");
	CRLF(0);
	end;
end;


procedure DOXDIR;
\Handle directory and execute files
char PROMPT;
begin
PROMPT:="SELECT FILE TO EXECUTE";
while DIRECTORY(PROMPT) do
	begin
	BLANK;
	if VALIDEXE(FNAME) then EXECUTE
	else [TEXT(0,"NOT EXECUTABLE");CRLF(0);];
	BLANK;
	PAUSE;
	MOUSEINI;
	end;
end;



begin	\MAIN PROCEDURE
CPUREG:=GETREG;
DATASEG:=CPUREG(12);

TEMPLATE:=RESERVE(TEMPMAX);
FNAME:=RESERVE(FNAMMAX);

DEFTEMP:="*.XPL,*.EXE,*.COM";

SETVIDEO;
MOUSEINI;
DOXDIR;
end;
