
\ ---------- Electronic-Network-Analysis Program --------------
\  Tranlated by Loren Blaney, enhancements by Larry Fish.
\  From a program written by Edward Niemeyer.
\  Ref: Niemeyer, Edward, "Network-Analysis program runs on
\  small computer system," EDN, Feb 4, 1981, Pg. 126.
\     This program is based on Schnider's algorithm, which uses an
\  indefinite admittance matrix to solve network problems. It
\  handles both passive and active network elements and even
\  accomodates transmission-line analysis.
\       Nodes are consecutively numbered starting at one. The
\  highest node number is the common node. The network elements may
\  be entered in any order. Input and output values are always with
\  respect to common.

include C:\CXPL\CODESI.XPL;

def	TV=0, PR=2, KB=0, DISK=3;
def	PI=3.14159265;

def	
	CR=$0D,
	ESC=$1B,
	FF=$0C;



\KEY BOARD SCAN CODE DEFINITIONS

define
	FUNC1=59,	\FUNCTION 1
	FUNC2=60,	\FUCNTION 2
	FUNC3=61,	\FUNCTION 3
	FUNC4=62,	\FUCNTION 4
	PAGEDN=81,	\PAGE DOWN KEY
	PAGEUP=73,	\PAGE UP KEY
	HOME=71,	\HOME KEY
	END=79,	\END KEY
	INSERT=82,	\INSERT KEY
	DELETE=83,	\DELETE KEY
	RTARROW=77	\RIGHT ARROW KEY
	LFARROW=75,	\LEFT ARROW KEY
	UPARROW=72,	\UP ARROW KEY
	DNARROW=80;	\DOWN ARROW KEY


real	RESMAT,CAPMAT,INDMAT,	\TOPOLOGY MATRICES
	SM,AM,BM;
real	LL,ZL;
real	OO,ZZ,R5,V,OMEGA;
int	IL,ML,NL,OL,
	TLL;		\TRANSMISSION-LINE LIST
def	\TLL(X)\ NONE, TLINE, OPEN, SHORT;
int	I,J,K,L;
int	HINODE,		\COMMON NODE (= HIGHEST NUMBER)
	X,O,Z,SELECTION;


\ARRAYS FOR UNPROCESSED NETWORK

define
	MAXELM=20,	\MAXIMUM NUMBER OF ELEMENTS IN NETWORK
	MAXNOD=4,	\MAXIMUM NODES PER ELEMENT
	MAXVAL=2;	\MAXIMUM VALUES PER ELEMENT

integer
	TYPE,		\INDICATES TYPE OF ELEMENTS
	TOLFLAGS,	\TOLERANCE FLAGS FOR INDIVIDUAL COMPONENTS
	DOTOLER,	\TURNS ON COMPONENT TOLERANCE TESTING
	NODES;		\HOLDS NODE VALUES FOR AN ELEMENT

real
	TOLERANCE,	\TOLERANCE RANGE
	VALUES;		\HOLDS VALUE FOR AN ELEMENT


define
	LOWTOL,		\FLAG FOR LOW TOLERANCE TEST
	CENTOL,		\FLAG FOR CENTER OF TOLERANCE
	HITOL;		\FLAG FOR HIGH TOLERANCE


\ELEMENT TYPES

define
	RESTYP=0,CAPTYP=1,INDTYP=2,
	LINTYP=3,SSTUBTYP=4,OSTUBTYP=5,
	OPAMPTYP=6,NPNTYP=7,FETTYP=8;


\DEFAULTS FOR DISPLAY OR GRAPHING


int
	LOGAMP,		\FLAGS LOGS AMPLITUDE
	INODE,		\INPUT NODE
	ONODE;		\OUTPUT NODE

real
	VHIGH,		\SCALE FACTORS FOR  GRAPH
	VLOW,
	LINLOW,		\LINER RANGE
	LINHIGH,
	LOGLOW,		\LOG RANGE
	LOGHIGH,
	STARTFQ,	\START FREQUENCY
	STOPFQ;		\STOP FREQUENCY


integer
	TEMP,
	EPARAM;	\PARAMETER LIST LIST FOR ELEMENT TYPES


\VARIABLES FOR GRAPHICS WINDOW

define
	BLUE=1,  GREEN=2,   AQUA=3,     RED=4,     VIOLET=5,
	BROWN=6, WHITE=7,   GRAY=8,     LTBLUE=9,  LTGREEN=10,
	CYAN=11, ORANGE=12, LTVIOLET=13,YELLOW=14, LTWHITE=15;

integer ACOLOR,PCOLOR,MCOLOR;	\COLORS FOR AMPLITUDE AND PHASE

define MAXWIND=5;		\MAXIMUM NUMBER OF WINDOWS

integer ACTWIND;		\POINTER TO ACTIVE WINDOW

integer MAXX,MAXY,ORX,ORY;	\GRAPHICS WINDOW OFFSET AND MAX

real XSCALE,YSCALE,XOFF,YOFF;	\GRAPHICS WINDOW SCALES AND ORIGINS

define 
	\CORNERS FOR AMPLITUDE WINDOW
	AWINX1=50,AWINY1=75,	\LOWER LEFT
	AWINX2=620,AWINY2=0,	\UPPER RIGHT
	\CORNERS FOR PHASE WINDOW
	PWINX2=AWINX2,		\UPPER RIGHT
	PWINY2=AWINY1+10,
	PWINX1=AWINX1,		\LOWER LEFT
	PWINY1=PWINY2+24;

define 
	XPOINTS=AWINX2-AWINX1,			\NUMBER OF POINTS FOR SPECTRUM
	YPOINTS=AWINY1-AWINY2;

integer VIDMOD;			\VIDEO MODE


\VARIABLE FOR MS-DOS INTERFACE

address FNAME;

int	IHANDLE,OHANDLE,CPUREG;



\----------- HUMAN INTERFACE ROUTINES ----------------------------------


procedure GETSTR(S);
address S;
integer P;
begin
for P:=0,32000 do
	begin
	S(P):=CHIN(0);
	if S(P)=$0D then
		[if P#0 then S(P-1):=S(P-1) ! $80 else P(0):=$20;return;];
	if  P>=79 then [S(P):=S(P) ! $80;return;];
	end;
end;


procedure NOTCR;
\LOOK AHEAD TO SEE IF NEXT KEY IS CR
integer C;
begin
OPENI(KB);
repeat until CHKKEY;
CPUREG(0):=$0100;
SOFTINT($16);
C:=CPUREG(0) & $7F;
if C=CR then [CRLF(TV);return false;] else return true;
end;


procedure DISREAL(S,R);
\DISPLAY AND GET A REAL - by pointer
int S;real R;
begin
TEXT(TV,S);RLOUT(TV,R(0));
TEXT(TV,"  ");
if NOTCR then R(0):=RLIN(KB);
end;



procedure GETCHAR(S,I);
\DISPLAY AND GET AN CHARACTER - value
int S,I;
begin
TEXT(TV,S);CHOUT(TV,I);
TEXT(TV,"  ");
if NOTCR then return CHIN(KB);
return I;
end;



procedure DISBOOL(S,B);
\DISPLAY AND GET A BOOLEAN - by pointer
int S,B;
begin
TEXT(TV,S);
TEXT(TV,if B(0) then "Yes" else "No");
TEXT(TV,"  ");
if NOTCR then 
case CHIN(KB) of
^Y,^y: B(0):=true;
^N,^n: B(0):=false
else;
end;



procedure DISINT(S,I);
\DISPLAY AND GET AN INTEGER - by pointer
int S,I;
begin
TEXT(TV,S);INTOUT(TV,I(0));
TEXT(TV,"  ");
if NOTCR then I(0):=INTIN(KB);
end;



funct INPUT; char STR;
begin
TEXT(TV,STR); TEXT(TV,": ");
return INTIN(KB);
end;	\INPUT



procedure real GETVALUE(S,R);
\GET AND DISPLAY VALUE - by value
int S;real R;
begin
TEXT(TV,S);RLOUT(TV,R);
TEXT(TV,"  ");
if NOTCR then return RLIN(KB);
return R;
end;



procedure GETINT(S,I);
\DISPLAY AND GET AN INTEGER - by value
int S,I;
begin
TEXT(TV,S);INTOUT(TV,I);
TEXT(TV,"  ");
if NOTCR then return INTIN(KB);
return I;
end;


procedure PAUSE;
integer C;
[TEXT(0,"HIT ANY KEY ");C:=CHIN(1);];



procedure MAGNITUDE(R);
\DISPLAY NUMBER BY MAGINITUDE
real R,M;
begin
if R<0.0 then [R:=-R;CHOUT(TV,^-);];
M:=if R=0.0 then 0.0 else LOG(R);
FORMAT(3,0);
case of
	M>=12.: [RLOUT(TV,R/1E12);TEXT(TV,"Tera ");];
	M>=9.: [RLOUT(TV,R/1E9);TEXT(TV,"Giga ");];
	M>=6.: [RLOUT(TV,R/1E6);TEXT(TV,"Mega ");];
	M>=3.: [RLOUT(TV,R/1E3);TEXT(TV,"Kilo ");];
	M>=0.:  [RLOUT(TV,R);TEXT(TV,"     ");];
	M>=-3.: [RLOUT(TV,R/1E-3);TEXT(TV,"Milla");];
	M>=-6.: [RLOUT(TV,R/1E-6);TEXT(TV,"Micro");];
	M>=-9.: [RLOUT(TV,R/1E-9);TEXT(TV,"Nano ");];
	M>=-12.: [RLOUT(TV,R/1E-12);TEXT(TV,"Pico ");]
else;
end;

\------------------- ROUTINES TO HANDLE WINDOWING ----------------------



procedure WINDOW(X1,Y1,X2,Y2);
\OPEN A WINDOW
\ X1Y1= LOWER LEFT CORNER
\ X2Y2= UPPER RIGHT CORNER
integer X1,Y1,X2,Y2;
begin
MOVE(X1,Y1);
LINE(X2,Y1,1);LINE(X2,Y2,1);
LINE(X1,Y2,1);LINE(X1,Y1,1);
MAXX(ACTWIND):=ABS(X2-X1);MAXY(ACTWIND):=ABS(Y2-Y1);
ORX(ACTWIND):=X1;ORY(ACTWIND):=Y1;
end;



procedure OPOINT(X,Y,C);
\PLACE POINT, REFERENCED TO ORIGIN
integer X,Y,C;
POINT(ORX(ACTWIND)+X,ORY(ACTWIND)-Y,C);



procedure OLINE(X,Y,C);
\DRAW LINE, REFERRENCE TO ORIGIN
integer X,Y,C;
LINE(ORX(ACTWIND)+X,ORY(ACTWIND)-Y,C);



procedure OMOVE(X,Y);
\MOVE, REFERENCED TO ORIGIN
integer X,Y;
MOVE(ORX(ACTWIND)+X,ORY(ACTWIND)-Y);



procedure RLINE(X,Y,C);
\DRAW SCALED AND OFFSET LINE
real X,Y;
integer C;
OLINE(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)),C);



procedure RPOINT(X,Y,C);
\PLACE SCALED AND OFFSET POINT
real X,Y;
integer C;
OPOINT(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)),C);



procedure RMOVE(X,Y);
\MOVE SCALED AND OFFSET
real X,Y;
OMOVE(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)));


procedure SYMBOL(T,X,Y);
\PLACE A SYMBOL IN WINDOW
\SYMBOL TYPE IN T
real X,Y;
integer T,X1,Y1,SHAPE;
begin
SHAPE:=[
[[2,2],[2,-2],[-2,-2],[-2,2],[2,2]], \SQUARE
[[0,2],[2,0],[0,-2],[-2,0],[0,2]], \DIAMOND
[[2,2],[-2,-2],[2,-2],[-2,2],[2,2]] \X
];
if T>=3 then T:=0;

X1:=FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND));
Y1:=FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND));
OMOVE(X1+SHAPE(T,0,0),Y1+SHAPE(T,0,1));
OLINE(X1+SHAPE(T,1,0),Y1+SHAPE(T,1,1),1);
OLINE(X1+SHAPE(T,2,0),Y1+SHAPE(T,2,1),1);
OLINE(X1+SHAPE(T,3,0),Y1+SHAPE(T,3,1),1);
OLINE(X1+SHAPE(T,4,0),Y1+SHAPE(T,4,1),1);
end;


procedure VGRID(X,R1,R2,T);
\DRAW VERTICAL GRID
\NUMBER OF LINES IN X
\START AND END OF SCALE IN R1 AND R2
int X; real R1,R2; int T;
real DL;
integer O,I;
begin
XSCALE(ACTWIND):=FLOAT(MAXX(ACTWIND))/(R2-R1);
XOFF(ACTWIND):=R1;

O:=MAXX(ACTWIND)/X;
for I:=1,X do
	begin
	OMOVE(I*O,0);
	OLINE(I*O,MAXY(ACTWIND),1);
	end;


FORMAT(2,1);
DL:=(R2-R1)/FLOAT(X);
if not T then return;
for I:=0,X do
	begin
	CURSOR((I*O+ORX(ACTWIND))/8-5,(ORY(ACTWIND)/8)+1);
	MAGNITUDE(R1);
	R1:=R1+DL;
	end;
end;




procedure HGRID(Y,R1,R2,T1,T2);
\DRAW VERTICAL GRID
\NUMBER OF LINES IN X
\START AND END OF SCALE IN R1 AND R2
integer Y;real R1,R2;int T1,T2;
real DL;integer O,I;
begin
YSCALE(ACTWIND):=FLOAT(MAXY(ACTWIND))/(R2-R1);
YOFF(ACTWIND):=R1;

O:=MAXY(ACTWIND)/Y;
for I:=1,Y do
	begin
	OMOVE(0,O*I);
	OLINE(MAXX(ACTWIND),O*I,1);
	end;

FORMAT(T1,T2);
DL:=(R2-R1)/FLOAT(Y);
for I:=0,Y do
	begin
	CURSOR((ORX(ACTWIND)/8)-5,(ORY(ACTWIND)-(O*I))/8);
	RLOUT(0,R1);
	R1:=R1+DL;
	end;
end;


\----------------------------------------------------------------------
	

funct real POWER; real X,Y;	\RETURNS X**Y
return EXP(Y*LN(X));


funct real SGN; real X;	\BASIC SIGN FUNCTION
return if X<0.0 then -1.0 else 1.0;


\------------------- PROCESS MATRIX-------------------------------------


proc	TLOAD;
\INPUTS: TLL, LL, ZL, HINODE, OMEGA.
\OUTPUTS: SM, X.
int	P,Q,R,I,J;
real	R1,R2,R3;

	proc	PROC270;
	[SM(Q,Q):=SM(Q,Q)+R1;
	SM(R,R):=SM(R,R)+R1;
	SM(Q,R):=SM(Q,R)-R1;
	SM(R,Q):=SM(R,Q)-R1];

begin
if TLL(1)=NONE then return;
for I:=1,HINODE do for J:=1,HINODE do SM(I,J):=0.0;
for X:=1,20 do
	case TLL(X) of
	NONE:	return;
	TLINE:	[R1:= -1.0 / (ZL(X) * TAN(0.25*OMEGA/LL(X)));
		Q:=ML(X); R:=IL(X); PROC270;
		Q:=NL(X); R:=OL(X); PROC270;
		R1:= 1.0 / (ZL(X) * SIN(0.25*OMEGA/LL(X)));
		P:=IL(X); R:=NL(X);
		SM(R,P):=SM(R,P)-R1;
		SM(P,R):=SM(P,R)-R1;
		R:=OL(X);
		SM(R,P):=SM(R,P)+R1;
		SM(P,R):=SM(P,R)+R1;
		P:=ML(X);
		SM(R,P):=SM(R,P)-R1;
		SM(P,R):=SM(P,R)-R1;
		R:=NL(X);
		SM(R,P):=SM(R,P)+R1;
		SM(P,R):=SM(P,R)+R1];
	OPEN:	[R2:= 1.0 / (ZL(X) * TAN(0.25*OMEGA/LL(X)));
		R3:= 1.0 / (ZL(X) * SIN(0.25*OMEGA/LL(X)));
		R1:=R3*R3/R2 -R2;
		Q:=ML(X); R:=NL(X); PROC270];
	SHORT:	[R1:= -1.0 / (ZL(X) * TAN(0.25*OMEGA/LL(X)));
		Q:=ML(X); R:=NL(X); PROC270]
	else	ABORT;	\*** DEBUG ***
end;	\TLOAD


proc	COMP;
\THE DETERMINANT IS UPPER TRIANGULATED, AND THE PRODUCT OF THE
\ DIAGONAL ELEMENTS RETURNS IN CARTESIAN COORDINATES.
\INPUTS: AM, BM, HINODE.
\OUTPUTS: ZZ, OO.
real	A, S, T;
int	C, I, J, K \REFERENCE ROW POINTER\, L;
begin
if HINODE <= 1 then	\ALREADY SOLVED
	[OO:=AM(1,1); ZZ:=BM(1,1); return];
OO:=1.0; ZZ:=0.0; K:=1;

repeat
L:=K;				\FIND AND MOVE LARGEST VECTOR
S:=RLABS(AM(K,K)) + RLABS(BM(K,K));	\ TO "TOP" ROW.
for I:=K,HINODE do
	[T:=RLABS(AM(I,K)) + RLABS(BM(I,K));
	if S<T then [L:=I; S:=T]];
if L#K then for J:=1,HINODE do
	[S:= -AM(K,J); AM(K,J):=AM(L,J); AM(L,J):=S;
	A:= -BM(K,J); BM(K,J):=BM(L,J); BM(L,J):=A];
L:=K+1;
for I:=L,HINODE do
	[A:= AM(K,K)*AM(K,K) + BM(K,K)*BM(K,K);
	S:= (AM(I,K)*AM(K,K) + BM(I,K)*BM(K,K)) /A;
	BM(I,K):= (AM(K,K)*BM(I,K) - AM(I,K)*BM(K,K)) /A;
	AM(I,K):=S];
C:=K-1;		\CALCULATE ROW COEFFICIENTS FOR REDUCTION
if C#0 then for J:=L,HINODE do for I:=1,C do
	[AM(K,J):= AM(K,J) - AM(K,I)*AM(I,J) + BM(K,I)*BM(I,J);
	BM(K,J):= BM(K,J) - BM(K,I)*AM(I,J) - AM(K,I)*BM(I,J)];
C:=K;			\REDUCE ALL ROWS BELOW REFERENCE
K:=K+1;
for I:=K,HINODE do for J:=1,C do
	[AM(I,K):= AM(I,K) - AM(I,J)*AM(J,K) + BM(I,J)*BM(J,K);
	BM(I,K):= BM(I,K) - BM(I,J)*AM(J,K) - AM(I,J)*BM(J,K)];
until K=HINODE;

L:=1;			\CALCULATE PRODUCT OF DIAGONAL TERMS
C:= HINODE/2;
if HINODE # 2*C then [L:=0; OO:=AM(HINODE,HINODE); ZZ:=BM(HINODE,HINODE)];
for I:=1,C do
	[J:= HINODE-I+L;
	S:= AM(I,I)*AM(J,J) - BM(I,I)*BM(J,J);
	A:= AM(I,I)*BM(J,J) + AM(J,J)*BM(I,I);
	T:= OO*S - ZZ*A;
	ZZ:= ZZ*S + OO*A;
	OO:=T];
end;	\COMP


proc	DET;
\CREATES THE COMPLEX DETERMINATE BY DELETING TWO ROWS AND
\ COLUMNS FROM THE INDETERMINANT MATRIX.
\INPUTS: Z (COLUMN TO DELETE), O (ROW TO DELETE),
\	RESMAT, CAPMAT, INDMAT, SM, OMEGA.
\OUTPUTS: R5 (AMPLITUDE), ZZ (PHASE).
int	SN,	\TEMPORARY SAVE FOR HINODE
	I,J	\ROW AND COLUMN OFFSETS
	K,L;	\ROW AND COLUMN COUNTERS
real	Y;
begin
SN:=HINODE;				\STORE MATRIX SIZE
HINODE:=HINODE-1;				\CALCULATE SIZE OF DETERMINATE
I:=0;
for K:=1,HINODE do
	begin
	if K=O then I:=1;
	J:=0;
	for L:=1,HINODE do
		[if L=Z then J:=1;	\LOAD DETERMINANT
		AM(K,L):= RESMAT(K+I,L+J);	\REAL PART
		BM(K,L):= OMEGA*CAPMAT(K+I,L+J) - 	\IMAGINARY PART
			INDMAT(K+I,L+J)/OMEGA + SM(K+I,L+J)];
	end;
COMP;			\EVALUATE THE COMPLEX DETERMINATE
HINODE:=SN;			\RESTORE MATRIX DIMENSIONS
R5:=SQRT(OO*OO + ZZ*ZZ); \RECTANGULAR TO POLAR CONVERSION
Y:=ZZ;
if OO=0.0 then [ZZ:=90.0*SGN(Y); return];
ZZ:=180./PI * ATAN2(ZZ/OO,1.0);
if ZZ>90. then ZZ:=ZZ -360.0;	\(ATAN FIX)
if OO>0.0 then return;
ZZ:= ZZ + SGN(Y)*180.0;
if Y=0.0 then ZZ:=180.0;
end;	\DET




proc	RESL;	\BUILD RESISTIVE TOPOLOGY MATRIX
begin
RESMAT(I,I):=RESMAT(I,I)+V;
RESMAT(J,J):=RESMAT(J,J)+V;
RESMAT(I,J):=RESMAT(I,J)-V;
RESMAT(J,I):=RESMAT(J,I)-V;
if I>HINODE then HINODE:=I;
if J>HINODE then HINODE:=J;
end;	\RESL


proc	CAPL;	\BUILD CAPACITIVE TOPOLOGY MATRIX
begin
CAPMAT(I,I):=CAPMAT(I,I)+V;
CAPMAT(J,J):=CAPMAT(J,J)+V;
CAPMAT(I,J):=CAPMAT(I,J)-V;
CAPMAT(J,I):=CAPMAT(J,I)-V;
if I>HINODE then HINODE:=I;
if J>HINODE then HINODE:=J;
end;	\CAPL


proc	INDL;	\BUILD INDUCTIVE TOPOLOGY MATRIX
begin
INDMAT(I,I):=INDMAT(I,I)+V;
INDMAT(J,J):=INDMAT(J,J)+V;
INDMAT(I,J):=INDMAT(I,J)-V;
INDMAT(J,I):=INDMAT(J,I)-V;
if I>HINODE then HINODE:=I;
if J>HINODE then HINODE:=J;
end;	\INDL


proc	TRANS;	\BUILD "TRANSISTOR" TOPOLOGY MATRIX
begin
RESMAT(I,K):=RESMAT(I,K)+V;
RESMAT(J,L):=RESMAT(J,L)+V;
RESMAT(J,K):=RESMAT(J,K)-V;
RESMAT(I,L):=RESMAT(I,L)-V;
if K>HINODE then HINODE:=K;
if L>HINODE then HINODE:=L;
if I>HINODE then HINODE:=I;
if J>HINODE then HINODE:=J;
end;	\TRANS


proc	RES(ENT);	\GET RESISTOR PARAMETERS
integer ENT;
begin
I:=NODES(ENT,0);
J:=NODES(ENT,1);
V:=1.0/VALUES(ENT,0);
RESL;
end;	\RES


proc	CAP(ENT);	\GET CAPACITOR PARAMETERS
integer ENT;
begin
I:=NODES(ENT,0);
J:=NODES(ENT,1);
V:=VALUES(ENT,0);
CAPL;
end;	\CAP


proc	IND(ENT);	\GET INDUCTOR PARAMETERS
integer ENT;
begin
I:=NODES(ENT,0);
J:=NODES(ENT,1);
V:=1.0/VALUES(ENT,0);

INDL;
end;	\IND


proc	PROC44(ENT);
integer ENT;
begin
ZL(X):=VALUES(ENT,0);
LL(X):=VALUES(ENT,1);
if IL(X)>HINODE then HINODE:=IL(X);
if ML(X)>HINODE then HINODE:=ML(X);
if NL(X)>HINODE then HINODE:=NL(X);
if OL(X)>HINODE then HINODE:=OL(X);
X:=X+1; TLL(X):=NONE;
end;


proc	DOTLINE(ENT);	\GET TRANSMISSION-LINE PARAMETERS
integer ENT;
begin
TLL(X):=TLINE;
ML(X):= NODES(ENT,0);
IL(X):= NODES(ENT,1);
OL(X):= NODES(ENT,2);
NL(X):= NODES(ENT,3);

PROC44(ENT);
end;	\DOTLINE


proc	SSTUB(ENT);	\GET SHORTED STUB PARAMETERS
integer ENT;
begin
TLL(X):=SHORT;
ML(X):=NODES(ENT,0);
NL(X):=NODES(ENT,1);
PROC44(ENT);
end;	\SSTUB


proc	OSTUB(ENT);	\GET OPEN STUB PARAMETERS
integer ENT;
begin
TLL(X):=OPEN;
ML(X):=NODES(ENT,0);
NL(X):=NODES(ENT,1);
PROC44(ENT);
end;	\OSTUB


proc	OPAMP(ENT);	\GET OP-AMP PARAMETERS
integer ENT;
begin
K:=NODES(ENT,0);
L:=NODES(ENT,1);
I:=NODES(ENT,2);
J:=NODES(ENT,3);

R5:=VALUES(ENT,0);
V:=1.0/VALUES(ENT,1);

RESL;			\LOAD RESMAT WITH RESISTANCE
V:=V*R5;
TRANS;			\LOAD RESMAT WITH TRANSCONDUCTANCE
end;	\OPAMP


proc	NPN(ENT);	\GET NPN TRANSISTOR PARAMETERS
integer ENT;
begin
K:=NODES(ENT,0);
J:=NODES(ENT,1);
I:=NODES(ENT,2);
R5:=VALUES(ENT,0);
V:=1.0/VALUES(ENT,1);

L:=I; I:=K; RESL;	\LOAD RESMAT WITH INPUT CONDUCTANCE
I:=L; L:=J; V:=V*R5; TRANS;  \LOAD RESMAT WITH TRANSCONDUCTANCE
end;	\NPN


proc	FET(ENT);	\GET FET PARAMETERS
integer ENT;
begin
K:=NODES(ENT,0);
J:=NODES(ENT,1);
I:=NODES(ENT,2);
V:=VALUES(ENT,0);
L:=J;
TRANS;			\LOAD RESMAT WITH TRANSCONDUCTANCE
end;	\FET



\------------ CONTROL AND ANALIZE NETWORK ------------------------------


procedure ZEROMAT;
\ZERO ALL ARRAYS
begin
for I:=1,10 do for J:=1,10 do
	begin
	RESMAT(I,J):=0.0;
	CAPMAT(I,J):=0.0;
	INDMAT(I,J):=0.0;
	SM(I,J):=0.0;
	end;
X:=1;
TLL(X):=NONE;
HINODE:=0;
end;


procedure INSELEM(I,TOL);
\INSERT AN ELEMENT INTO THE DETERMINATE ARRAYS
define TOLERANCE=.1;
integer I,TOL;
real TEMP,OFF;
begin
TEMP:=VALUES(I,0);


if TOLFLAGS(I)#^O then
	begin
	OFF:=TOLERANCE * TEMP;
	if TOLFLAGS(I)=^- then OFF:=-OFF;
	case TOL of
	LOWTOL:	VALUES(I,0):=TEMP-OFF;
	HITOL:  VALUES(I,0):=TEMP+OFF
	else;
	end;

case TYPE(I) of
	RESTYP: RES(I);
	CAPTYP: CAP(I);
	INDTYP: IND(I);
	LINTYP: DOTLINE(I);
	SSTUBTYP: SSTUB(I);
	OSTUBTYP: OSTUB(I);
	OPAMPTYP: OPAMP(I);
	NPNTYP: NPN(I);
	FETTYP: FET(I)
else;
VALUES(I,0):=TEMP;
end;



procedure NEWPARAM;
begin
DISINT("INPUT NODE  ",add INODE);
DISINT("OUTPUT NODE ",add ONODE);
loop
	begin
	DISREAL("START FREQ (HZ): ", add STARTFQ);
	if STARTFQ>0. then quit;
	TEXT(0,"start MUST BE GREATER THAN zero");
	CRLF(0);
	end;

DISREAL("STOP FREQ (HZ): ", add STOPFQ);
DISBOOL("LOG AMPLITUDE: ",add LOGAMP);
if LOGAMP then
	begin
	DISREAL("     LOG LOW: ", add LOGLOW);
	DISREAL("     LOG HIGH: ", add LOGHIGH);
	end
else
	begin
	DISREAL("     LINEAR LOW: ", add LINLOW);
	DISREAL("     LINEAR HIGH: ", add LINHIGH);
	end;

DISBOOL("TOLERANCE TEST: ",add DOTOLER);
if DOTOLER then [DISREAL("     TOLERANCE RANGE + OR - ",addr TOLERANCE);];
end;



procedure DISPARAM;
begin
CHOUT(0,FF);
FORMAT(-1,2);
TEXT(TV,"

DISPLAY PARAMETERS

");
TEXT(TV,"INPUT NODE= ");INTOUT(TV,INODE);CRLF(TV);
TEXT(TV,"OUTPUT NODE= ");INTOUT(TV,ONODE);CRLF(TV);
TEXT(TV,"START FREQ= ");RLOUT(TV,STARTFQ);CRLF(TV);
TEXT(TV,"STOP FREQ= ");RLOUT(TV,STOPFQ);CRLF(TV);
TEXT(TV,"LOG AMPLITUDE= ");TEXT(TV,if LOGAMP then "Yes" else "No");CRLF(TV);
TEXT(TV,"LOW/HIGH AMPLITDUE ");
if LOGAMP then [RLOUT(TV,LOGLOW);RLOUT(TV,LOGHIGH)]
	  else [RLOUT(TV,LINLOW);RLOUT(TV,LINHIGH)];
CRLF(TV);
TEXT(TV,"TOLERANCE TEST= ");TEXT(TV,if DOTOLER then "Yes" else "No");CRLF(TV);
if DOTOLER then [TEXT(TV,"     TOLERANCE RANGE + OR - ");RLOUT(TV,TOLERANCE);CRLF(TV);];
end;



procedure GETPARAM;
begin
loop
	begin
	DISPARAM;
	TEXT(TV,"
CHANGE PARAMETERS?  ");
	OPENI(TV);
	case CHIN(TV) of ^Y,^y: NEWPARAM else quit;
	end;
if LOGAMP then	[VHIGH:=LOGHIGH;VLOW:=LOGLOW;]
	  else  [VHIGH:=LINHIGH;VLOW:=LINLOW;];
end;


procedure MEASURE;
\MEASURE SPECTRUM POINTS
integer CC;
real OFREQ,OAMP,FREQ,AMP,AINC,FINC;
real L;

	procedure UPDATE;
	\UPDATE CURSOR LINE
	begin
	RMOVE(STARTFQ,OAMP);RLINE(STOPFQ,OAMP,CC);
	RMOVE(OFREQ,VLOW);RLINE(OFREQ,VHIGH,CC);
	RMOVE(STARTFQ,AMP);RLINE(STOPFQ,AMP,CC);
	RMOVE(FREQ,VLOW);RLINE(FREQ,VHIGH,CC);
	OFREQ:=FREQ;OAMP:=AMP;
	end;

begin
AINC:=(VHIGH-VLOW)/FLOAT(YPOINTS);
FINC:=(STOPFQ-STARTFQ)/FLOAT(XPOINTS);

FREQ:=STARTFQ;AMP:=0.0;
OFREQ:=FREQ;OAMP:=AMP;
ACTWIND:=0;
CC:=MCOLOR ! $80;
FORMAT(5,2);

RMOVE(STARTFQ,AMP);RLINE(STOPFQ,AMP,CC);
RMOVE(FREQ,VLOW);RLINE(FREQ,VHIGH,CC);
loop
	begin
	FORMAT(5,2);
	CURSOR(0,23);
	TEXT(6,"  FREQ: ");RLOUT(0,FREQ);
	TEXT(6,"  AMP: ");RLOUT(0,AMP);
	case CHIN(1) of
		$1B: quit;
		0:	begin
			case CHIN(1) of
			LFARROW: if FREQ>STARTFQ then [FREQ:=FREQ-FINC;UPDATE];
			RTARROW: if FREQ<STOPFQ then [FREQ:=FREQ+FINC;UPDATE;];
			DNARROW: if AMP>VLOW then [AMP:=AMP-AINC;UPDATE];
			UPARROW: if AMP<VHIGH then [AMP:=AMP+AINC;UPDATE;]
			other;
			end		
	other;
	end;
RMOVE(STARTFQ,AMP);RLINE(STOPFQ,AMP,CC);
RMOVE(FREQ,VLOW);RLINE(FREQ,VHIGH,CC);
end;




proc	ANALIZE(TOL,CLEAR);	\ANALYZE THE CIRCUIT
int	TOL,CLEAR;
real	DELTA,  FREQ, AMPL, PHASE;
real	OLDFREQ,OLDAMPL,OLDPHASE;
real	MAXFREQ,MAXAMPL,MINFREQ,MINAMPL;
int	P, PASS, FIRST;


	procedure OPENWINDOW;
	\Open and setup windows
	begin
	SETVID(VIDMOD);
	ACTWIND:=0;
	WINDOW(AWINX1,AWINY1,AWINX2,AWINY2);
	HGRID(5,VLOW,VHIGH,1,1);

	VGRID(5,STARTFQ,STOPFQ,false);

	ACTWIND:=1;
	WINDOW(PWINX1,PWINY1,PWINX2,PWINY2);
	HGRID(2,-180.,180.,1,0);
	VGRID(5,STARTFQ,STOPFQ,true);
	end;


	proc	DISPLAY;	\DISPLAY ANALYSIS
	begin
	if FIRST then
		begin
		ACTWIND:=1;RPOINT(FREQ,PHASE,PCOLOR);
		ACTWIND:=0;RPOINT(FREQ,AMPL,ACOLOR);
		MAXFREQ:=FREQ;MAXAMPL:=AMPL;
		MINFREQ:=FREQ;MINAMPL:=AMPL;
		end
	else
		begin
		ACTWIND:=1;
		RMOVE(OLDFREQ,OLDPHASE);
		RLINE(FREQ,PHASE,PCOLOR);
		ACTWIND:=0;
		RMOVE(OLDFREQ,OLDAMPL);
		RLINE(FREQ,AMPL,ACOLOR);
		end;
	FIRST:=false;
	OLDFREQ:=FREQ;
	OLDAMPL:=AMPL;
	OLDPHASE:=PHASE;

	CURSOR(0,16);
	FORMAT(8,0);
	TEXT(TV,"FREQ = ");MAGNITUDE(FREQ);
	FORMAT(2,2);
	TEXT(TV,"   AMP = ");RLOUT(0,AMPL);
	FORMAT(4,1);
	TEXT(TV,"  PHASE = ");RLOUT(0,PHASE);

	if MAXAMPL<AMPL then [MAXAMPL:=AMPL;MAXFREQ:=FREQ;];
	if MINAMPL>AMPL then [MINAMPL:=AMPL;MINFREQ:=FREQ;];

	CURSOR(0,17);
	TEXT(TV,"FREQ = ");MAGNITUDE(MINFREQ);
	FORMAT(2,2);
	TEXT(TV,"   AMP = ");RLOUT(0,MINAMPL);
	TEXT(TV," ---- MINIMUM");
	CURSOR(0,18);
	TEXT(TV,"FREQ = ");MAGNITUDE(MAXFREQ);
	FORMAT(2,2);
	TEXT(TV,"   AMP = ");RLOUT(0,MAXAMPL);
	TEXT(TV," ---- MAXIMUM");
	end;


	procedure PROCESS;
	\PROCESS A SINGLE FREQUENCY POINT
				\SET UP NUMERATOR BLOCK-OUT MASK TO
	begin			\ FORM REAL PART OF COMPLEX DETERMINANT
	OMEGA:=2.0*PI * FREQ;	\SET UP MASK
	O:=INODE; Z:=ONODE;	\ROW = INPUT; COLUMN = OUTPUT
	TLOAD;			\LOAD "SA" WITH TRANSMISSION-LINE DATA
	DET;			\COMPUTE NUMERATOR
	AMPL:=R5; PHASE:=ZZ;	\ADJ FOR ODD OR EVEN COFACTOR SIGN
	if REM((INODE+ONODE)/2)=1 then PHASE:=PHASE -180.0;
	O:=INODE; Z:=INODE;	\SET UP MASK
	DET;			\COMPUTE DENOMINATOR
	PHASE:=PHASE-ZZ;	\DIVIDE AND ADJUST PHASE

	if R5#0.0 & AMPL#0.0 then AMPL:=AMPL/R5;

	if LOGAMP then AMPL:=20.0 * LOG(AMPL);	
	if AMPL>VHIGH then AMPL:=VHIGH;
	if AMPL<VLOW then AMPL:=VLOW;

	if PHASE > 180. then PHASE:=PHASE-360.;
	if PHASE < -180. then PHASE:=PHASE+360.;

	DISPLAY;
	FREQ:=FREQ+DELTA;
	end;


begin
ZEROMAT;
for P:=0,MAXELM-1 do INSELEM(P,TOL);
HINODE:=HINODE-1;

\CALC FREQUENCY DELTAS
DELTA:= (STOPFQ-STARTFQ) / FLOAT(XPOINTS-1);
FREQ:=STARTFQ;

FORMAT(-1,0);

if CLEAR then OPENWINDOWS;

FIRST:=true;
FORMAT(-1,4);
TRAP(0);

for PASS:=1,XPOINTS do
	begin
	PROCESS;
	if CHKKEY then if CHIN(1)=ESC then return;
	end;

HINODE:=HINODE+1;

TRAP($FFFF);
if GETERR#0 then
	begin
	CRLF(0);
	TEXT(0,"!! math error - precision lost !!");
	CRLF(0);
	end;
end;	\ANAL



procedure DOANALYSIS;
\CONTROL AND ANALIZE NETWORK
int T,LC,MC,HC;
begin
GETPARAM;

T:=ACOLOR;
if VIDMOD=$0E then [LC:=GREEN;MC:=YELLOW;HC:=RED;]
else [LC:=ACOLOR;MC:=ACOLOR;HC:=ACOLOR;];

if DOTOLER then
	begin
	ACOLOR:=LC;
	ANALIZE(LOWTOL,true);
	ACOLOR:=MC;
	ANALIZE(CENTOL,false);
	ACOLOR:=HC;
	ANALIZE(HITOL,false);
	ACOLOR:=T;
	end
else ANALIZE(CENTOL,true);
MEASURE;
CURSOR(0,24);
PAUSE;
SETVID(3);
end;


\------------------- EDIT NETWORK ----------------------------------


procedure SHOWITEM(ITEM);
\DISPLAY INDIVIDUAL ELEMENT
integer ITEM,X;
integer TSTRING;
begin
INTOUT(TV,ITEM);
TEXT(TV,") ");
if TYPE(ITEM)<0 then [CRLF(TV);return;];

TSTRING:=["RES","CAP","IND","LIN",
	"SST","OST","OPA  ","NPN","FET"];
CHOUT(TV,TOLFLAGS(ITEM));
TEXT(TV," ");
TEXT(TV,TSTRING(TYPE(ITEM)));
TEXT(TV,"-");
INTOUT(TV,NODES(ITEM,0));

for X:=1,EPARAM(TYPE(ITEM),0)-1 do
	begin
	TEXT(TV,",");
	INTOUT(TV,NODES(ITEM,X));
	end;

FORMAT(-1,1);
for X:=0,EPARAM(TYPE(ITEM),1)-1 do
	RLOUT(TV,VALUES(ITEM,X));
end;




procedure GETTOLER(I);
\GET COMPONET TOLERANCE PARAMETER
int I,C;
begin
TOLFLAGS(I):=GETCHAR("TOLLERANCE FLAGS (+,-,O): ",TOLFLAGS(I));
end;



proc	ENTRES(I);	\GET RESISTOR PARAMETERS
integer I;
begin
TYPE(I):=RESTYP;
TEXT(TV,"RESISTOR--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("NODE A ",NODES(I,0)); \INPUT 2 NODES AND RESISTANCE
NODES(I,1):= GETINT("NODE B ",NODES(I,1));
VALUES(I,0):=GETVALUE("RES (OHMS): ",VALUES(I,0));
end;	\RES



proc	ENTCAP(I);	\GET CAPACITOR PARAMETERS
integer I;
begin
TYPE(I):=CAPTYP;
TEXT(TV,"CAPACITOR--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("NODE A ",NODES(I,0));
NODES(I,1):= GETINT("NODE B ",NODES(I,1));
VALUES(I,0):=GETVALUE("CAP (FARADS): ",VALUES(I,0));
end;	\CAP



proc	ENTIND(I);	\GET INDUCTOR PARAMETERS
integer I;
begin
TYPE(I):=INDTYP;
TEXT(TV,"INDUCTOR--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("NODE A ",NODES(I,0));
NODES(I,1):= GETINT("NODE B ",NODES(I,1));
VALUES(I,0):=GETVALUE("INDUCTANCE (HENRYS): ",VALUES(I,0));
end;	\IND


proc	ENTPROC44(I);
integer I;
begin
VALUES(I,0):=GETVALUE("Zo: ",VALUES(I,0));
VALUES(I,1):=GETVALUE("QUARTER WAVE FREQ (HZ): ",VALUES(I,1));
end;


proc	ENTTLINE(I);	\GET TRANSMISSION-LINE PARAMETERS
integer I;
begin
TYPE(I):=LINTYP;
TEXT(TV,"TRANSMISSION LINE--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("SHIELD-IN ",NODES(I,0));
NODES(I,1):= GETINT("CENTER-IN ",NODES(I,1));
NODES(I,2):= GETINT("CENTER-OUT ",NODES(I,2));
NODES(I,3):= GETINT("SHIELD-OUT ",NODES(I,3));
ENTPROC44(I);
end;	\ENTTLINE


proc	ENTSSTUB(I);	\GET SHORTED STUB PARAMETERS
integer I;
begin
TYPE(I):=SSTUBTYP;

TEXT(TV,"SHORTED STUB--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("NODE A ",NODES(I,0));
NODES(I,1):= GETINT("NODE B ",NODES(I,1));
ENTPROC44(I);
end;	\SSTUB


proc	ENTOSTUB(I);	\GET OPEN STUB PARAMETERS
integer I;
begin
TYPE(I):=OSTUBTYP;
TEXT(TV,"OPEN STUB--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("NODE A ",NODES(I,0));
NODES(I,1):= GETINT("NODE B ",NODES(I,1));
ENTPROC44(I);
end;	\OSTUB


proc	ENTOPAMP(I);	\GET OP-AMP PARAMETERS
integer I;
begin
TYPE(I):=OPAMPTYP;
TEXT(TV,"OP-AMP--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("+ IN ",NODES(I,0));	\INPUT 4 NODES, GAIN, AND R(OUT)
NODES(I,1):= GETINT("- IN ",NODES(I,1));
NODES(I,2):= GETINT("- OUT ",NODES(I,2));
NODES(I,3):= GETINT("+ OUT ",NODES(I,3));
VALUES(I,0):=GETVALUE("GAIN (V/V): ",VALUES(I,0));
VALUES(I,1):=GETVALUE("OUTPUT RES (OHMS): ",VALUES(I,1));
end;	\OPAMP


proc	ENTNPN(I);	\GET NPN TRANSISTOR PARAMETERS
integer I;
begin
TYPE(I):=NPNTYP;
TEXT(TV,"NPN--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("BASE ",NODES(I,0));	\INPUT 3 NODES, BETA, AND
NODES(I,1):= GETINT("EMITTER ",NODES(I,1));	\ B-E RESISTANCE
NODES(I,2):= GETINT("COLLECTOR ",NODES(I,2));
VALUES(I,0):=GETVALUE("BETA: ", VALUES(I,0));
VALUES(I,1):=GETVALUE("Rbe (OHMS): ", VALUES(I,1));
end;	\NPN


proc	ENTFET(I);	\GET FET PARAMETERS
integer I;
begin
TYPE(I):=FETTYP;
TEXT(TV,"FET--");
CRLF(0);
GETTOLER(I);
NODES(I,0):= GETINT("GATE ",NODES(I,0));	\INPUT 3 NODES AND
NODES(I,1):= GETINT("SOURCE ",NODES(I,1));	\ TRANSCONDUCTANCE
NODES(I,2):= GETINT("DRAIN ",NODES(I,2));
VALUES(I,0):=GETVALUE("GAIN (A/V): ", VALUES(I,0));
end;	\FET

\-------------------------------------------------------------------


procedure ZERNET;
\ZERO THE RAW NETWORK DATA
integer X,Y;
begin
for X:=0,MAXELM-1 do
	begin
	TYPE(X):=-1;
	TOLFLAGS(X):=^O;
	for Y:=0,MAXNOD-1 do NODES(X,Y):=0;
	for Y:=0,MAXVAL-1 do VALUES(X,Y):=0.0;
	end;
end;



procedure DELITEM(I);
\DELETE AN ITEM;
integer I,C,X;
begin
TEXT(TV,"ABOUT TO DELETE THIS ITEM, CONFIRM: ");
if CHIN(TV)#^Y then return;
TYPE(I):=-1;
TOLFLAGS(I):=^O;
for X:=0,MAXNOD-1 do NODES(I,X):=0;
for X:=0,MAXVAL-1 do VALUES(I,X):=0.0;
end;





procedure SHOWNET;
\SHOW WHOLE NET WORK
integer I,X,Y,HALF;
begin
HALF:=MAXELM/2;
for I:=0,MAXELM-1 do
	begin
	if I<HALF then [X:=0; Y:=I;] else [X:=40; Y:=I-HALF;];
	CURSOR(X,Y);
	SHOWITEM(I);
	CRLF(TV);
	end;
end;




procedure EDITMENU;
\DISPLAY EDIT MENU
begin
SHOWNET;
TEXT(TV,"------------- REMEMBER: HIGHEST NODE WILL BE COMMON OR GROUND ------------- 
R  - RESISTOR        C  - CAPACITOR     L  - INDUCTOR   T  - TRANSMISSION LINE
S  - SHORTED STUB    O  - OPEN STUB     A  - OP-AMP     N  - NPN TRANSISTOR
F  - FET             Z  - ZERO NET      D  - DELETE     Q  - QUIT TO MAIN MENU
SELECT ONE: ");
end;



procedure EDIT;
\EDIT RAW NETWORK
integer COM,ITEM;


	procedure BARITEM(I,ON);
	\Put Hilight Bar on an item
	integer I,ON,X,Y,HALF;
	begin
	HALF:=MAXELM/2;
	if I<HALF then [X:=0; Y:=I;] else [X:=40; Y:=I-HALF;];
	HILIGHT(X,Y,X+38,Y,if ON then $70 else $07);
	end;

	procedure INCITEM;
	\Increment Item number
	if ITEM<MAXELM-1 then ITEM:=ITEM+1;


	procedure GETCOM;
	begin
	repeat
		begin
		COM:=CHIN(1);if COM=0 then COM:=-CHIN(1);
		BARITEM(ITEM,false);
		case COM of
		-UPARROW: if ITEM>0 then ITEM:=ITEM-1;
		-DNARROW: INCITEM
		other;
		BARITEM(ITEM,true);
		end
	until COM>=0;
	end;

begin
ITEM:=0;
loop
	begin
	CHOUT(0,FF);
	EDITMENU;
	BARITEM(ITEM,true);
	OPENI(0);
	GETCOM;
	case COM of
	^Z,^z: ZERNET;
	^D,^d: DELITEM;

	^R,^r: [ENTRES(ITEM);INCITEM;];
	^C,^c: [ENTCAP(ITEM);INCITEM;];
	^L,^l: [ENTIND(ITEM);INCITEM;];
	^T,^t: [ENTTLINE(ITEM);INCITEM;];
	^S,^s: [ENTSSTUB(ITEM);INCITEM;];
	^O,^o: [ENTOSTUB(ITEM);INCITEM;];
	^A,^a: [ENTOPAMP(ITEM);INCITEM;];
	^N,^n: [ENTNPN(ITEM);INCITEM;];
	^F,^f: [ENTFET(ITEM);INCITEM;];
	^Q,^q:  quit
	else;
	end;
end;



procedure READFILE;
\READ Network file
integer X,Y;
begin
TEXT(0,"Enter file name ");
OPENI(0);
GETSTR(FNAME);
TRAP(false);
IHANDLE:=FOPEN(FNAME,0);
TRAP(true);
if GETERR # 0 then
	begin
	TEXT(0,"CANNOT OPEN FILE");CRLF(0);
	X:=CHIN(1);
	return;
	end;
CRLF(0);
FSET(IHANDLE,^I);
OPENI(DISK);
for X:=0,MAXELM-1 do
	begin
	TYPE(X):=INTIN(DISK);
	for Y:=0,MAXNOD-1 do NODES(X,Y):=INTIN(DISK);
	for Y:=0,MAXVAL-1 do VALUES(X,Y):=RLIN(DISK);
	end;
FCLOSE(IHANDLE);
end;



procedure WRITEFILE;
\Write Network file
integer X,Y;
begin
TEXT(0,"Enter file name ");
OPENI(0);
GETSTR(FNAME);
OHANDLE:=FOPEN(FNAME,1);
CRLF(0);
FSET(OHANDLE,^O);
OPENO(DISK);
FORMAT(-1,5);
for X:=0,MAXELM-1 do
	begin
	INTOUT(DISK,TYPE(X));
	TEXT(DISK,"   ");
	for Y:=0,MAXNOD-1 do [INTOUT(DISK,NODES(X,Y));TEXT(DISK,",");];
	for Y:=0,MAXVAL-1 do [RLOUT(DISK,VALUES(X,Y));TEXT(DISK,",")];
	CRLF(DISK);
	end;
CHOUT(DISK,$1A);
CLOSE(DISK);
FCLOSE(OHANDLE);
end;


procedure MAINMENU;
begin
CHOUT(TV,FF);
TEXT(TV,"

-------- Electronic Network Analysis Program --------

- SELECT AN OPERATION

E=EDIT THE NETWORK
A=ANALIZE THE CURRENT NETWORK
W=WRITE NETWORK TO DISK
R=READ NETWORK FROM DISK
Q=QUIT

SELECT ONE: ");
end;


procedure MENU;
integer COM;
begin

loop
	begin
	MAINMENU;
	COM:=CHIN(TV);
	case COM of
	^E,^e: EDIT;
	^A,^a: DOANALYSIS;
	^R,^r: READFILE;
	^W,^w: WRITEFILE;
	^Q,^q: quit
	else;
	end;
end;


procedure SETVIDEO;
\SETUP VIDEO
int C;
begin
TEXT(0,"EGA COMPATABLE? Y/N");
C:=CHIN(1);
case C of
^y,^Y:
	begin
	VIDMOD:=$0E;
	PCOLOR:=RED;
	ACOLOR:=GREEN;
	MCOLOR:=YELLOW;
	end
else
	begin
	VIDMOD:= 6;
	PCOLOR:=1;
	ACOLOR:=1;
	MCOLOR:=1;
	end;
end;



procedure DEFAULT;
\SET DEFAULTS
begin
INODE:=1;ONODE:=2;
LOGAMP:=false;
LINLOW:=0.0;LINHIGH:=1.0;
LOGLOW:=-120.0;LOGHIGH:=10.0;
STARTFQ:=1.0;STOPFQ:=1E6;
DOTOLER:=false;
TOLERANCE:=.1;
end;




begin	\MAIN
CPUREG:=GETREG;
FNAME:=RESERVE(80);

\BUILD WINDOW ARRAYS
MAXX:=RESERVE(MAXWIND*2);
MAXY:=RESERVE(MAXWIND*2);
ORX:=RESERVE(MAXWIND*2);
ORY:=RESERVE(MAXWIND*2);

XSCALE:=RLRES(MAXWIND);
YSCALE:=RLRES(MAXWIND);
XOFF:=RLRES(MAXWIND);
YOFF:=RLRES(MAXWIND);

\BUILD PROCESSING ARRAYS
RESMAT:=RLRES(11); for I:=1,10 do RESMAT(I):=RLRES(11);
CAPMAT:=RLRES(11); for I:=1,10 do CAPMAT(I):=RLRES(11);
INDMAT:=RLRES(11); for I:=1,10 do INDMAT(I):=RLRES(11);
SM:=RLRES(11); for I:=1,10 do SM(I):=RLRES(11);
AM:=RLRES(11); for I:=1,10 do AM(I):=RLRES(11);
BM:=RLRES(11); for I:=1,10 do BM(I):=RLRES(11);
LL:=RLRES(21); ZL:=RLRES(21);
TLL:=RESERVE(21*2);
IL:=RESERVE(21*2); ML:=RESERVE(21*2);
NL:=RESERVE(21*2); OL:=RESERVE(21*2);

\BUILD UNPROCESSED NETWORK ARRAYS
TYPE:=RESERVE(MAXELM*2);
TOLFLAGS:=RESERVE(MAXELM*2);
NODES:=RESERVE(MAXELM*2);
for TEMP:=0,MAXELM-1 do NODES(TEMP):=RESERVE(MAXNOD*2);

VALUES:=RLRES(MAXELM);
for TEMP:=0,MAXELM-1 do VALUES(TEMP):=RLRES(MAXVAL);

\SET ELEMENT PARAMETER LIST
EPARAM:=[
	[2,1],	\RESTYP
	[2,1],	\CAPTYP
	[2,1],	\INDTYP
	[4,2],	\LINTYP
	[2,2],	\SSTUBTYP
	[2,2],	\OSTUBTYP
	[4,2],	\OPAMPTYP
	[3,2],	\NPNTYP
	[3,1]];	\FETTYP


DEFAULT;
SETVIDEO;

ZEROMAT;
ZERNET;
MENU;
end;	\MAIN
