\NOISE.XPL	AUG-04-93
\Display screen full of snow

inc	C:\CXPL\CODESI;

int	II, JJ, CPUREG, DATASEG;
addr	GRAY;



proc	SETCOLREGS(FIRST, N, TBL);	\Set color registers from table
int	FIRST,	\First color register
	N;	\Number of color registers
addr	TBL;	\Table of 3-byte (RGB) values
begin
CPUREG(0):= $1012;		\AX function $10, subfunction $12
CPUREG(1):= FIRST;		\BX first color register
CPUREG(2):= N;			\CX number of color registers
CPUREG(3):= TBL;		\DX table of 3-byte entries (R, G, B)
CPUREG(11):= DATASEG;		\ES:= DS
SOFTINT($10);			\Call BIOS routine
end;	\SETCOLREGS



proc	FIXPALETTE;	\Make palette registers correspond to DAC registers
int	N;
begin
for N:= 0, 15 do
	begin
	CPUREG(0):= $1000;	\AX function $10, subfunction $00
	CPUREG(1):= N<<8!N;	\BX DAC and palette registers
	SOFTINT($10);		\Call BIOS routine
	end;
end;	\FIXPALETTE



proc	WAITVB;		\Wait for the beginning of the next vertical blank
begin
while PIN($3DA, 0) & $08 do;		\Wait for no vertical blank
repeat until PIN($3DA, 0) & $08;	\Wait for vertical blank
end;	\WAITVB;



begin	\MAIN
CPUREG:= GETREG;
DATASEG:= CPUREG(12);

\This program requires VGA (or MCGA)
\(EGA is not sufficient because the color registers need to be changed.)
JJ:= EQUIP;
if (JJ(2) & $18) = 0 then
	[TEXT(0, "This program requires VGA.");   exit];

SETVID($0D);		\320x200x16

FIXPALETTE;

GRAY:= RESERVE(16*3);
JJ:= 0;
for II:= 0, 16*3-1 do
	begin
	GRAY(II+0):= JJ;
	GRAY(II+1):= JJ;
	GRAY(II+2):= JJ;
	JJ:= JJ + 4;
	II:= II +3 -1;
	end;

SETCOLREGS(0, 16, GRAY);

CURSOR(10, 12);
TEXT(0, "PLEASE STAND BY...");

\Plot random points
for JJ:= -(800-1), 0 do
    for II:= 0, 320-1 do
	POINT(II, -JJ, RAN(16));

OPENI(0);
loop	begin
	\Move start address register pointers
	WAITVB;
	POUT($0D, $3D4, 0);		\LOW
	POUT(RAN(256), $3D5, 0);
	POUT($0C, $3D4, 0);		\HIGH
	POUT(RAN((800-200)*40/256), $3D5, 0);
	if CHKKEY then quit;
	end;

OPENI(0);
SETVID($03);
end;	\MAIN
