\NUMSTR.XPL	8-23-85

\A LITTLE PACKAGE OF EXTERNALS FOR CONVERTING NUMBERS TO STRINGS
\AND VISA-VERSA.

\function integer ATOI(STR,N);	CONVERT STRING TO INTEGER
\function real ATOF(STR,N);	CONVERT STRING TO REAL
\procedure ITOA(N,STR,X);	CONVERT INTEGER TO STRING
\procedure FTOA(N,M,STR,X);	CONVERT REAL TO STRING
\procedure FLOUT(N,M,X);	PRINT A REAL, RIGHT JUSTIFY, SCREEN
\procedure FLOUTF(D,N,M,X);	PRINT REAL. LEFT JUSTIFY, DEVICE

code 	\THESE ARE WHAT REMAIN IN I2LVAC:
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
EXTEND=5,	REBEGIN=6,	CHIN=7,		CHOUT=8,
CRLF=9,		INTIN=10,	INTOUT=11,	TEXT=12,
OPENI=13,	OPENO=14,	CLOSE=15,	ABORT=16,
TRAP=17,	FREE=18,	RERUN=19,	GETHP=20,
SETHP=21,	GETERR=22,	CURSOR=23,	SCAN=24,
SETRUN=25,	CHAIN=28,	WRITE=30,	READ=31,
SETTXT=33,	SETHI=34,	SETMIX=35,	SOUND=39,
CLEAR=40,	POINT=41,	IFIX=50,	IRQON=42,
IRQOFF=43,	GETSAM=44,	LINE=36		MOVE=45,
OPENF=29;
code real	RLRES=46,	FLOAT=49,	RLABS=51;



function real MOD(X,Y);
real X,Y,Z,REM;
begin
Z:=X/Y;
REM:=X- FLOAT(IFIX(Z-0.5))*Y;
return REM;
end;	\MOD



link function integer ATOI(STR,N);	\CONVERT ASCII STRING TO INTEGER
addr STR; int N;
int I,X,C;
begin
X:=0;
for I:=0,N-1 do
	begin
	C:=STR(I)&$7F;
	if C=^. then return -1;
	C:=C-^0;
	if (C>=0)&(C<=9) then X:=X*10+C;
	end;
return X;
end;	\ATOI



link function real ATOF(STR,N);		\CONVERT ASCII STRING TO FLOATING POINT
addr STR; int N;
int I,C;
real X,Y;
begin
X:=0.0;Y:=0.0;
for I:=0,N-1 do
	begin
	C:=STR(I)&$7F;
	if ((C>=^0)&(C<=^9))!(C=^.) then
		begin
		if C=^. then 
		[if Y=0.0 then Y:=1.0]
		else begin
			X:=X*10.0+FLOAT(C-^0);
			Y:=Y*10.0;
			end;
		end;
	end;
if Y>0.0 then X:=X/Y;
return X;
end;	\ATOF



link procedure ITOA(N,STR,X);		\CONVERT INTEGER TO ASCII STRING
integer N; address STR; integer X;

\This routine produces a string containing the ASCII
\representation of an integer number. The string is
\assumed to be at least N bytes long. The last
\byte does NOT have the high bit set. The number is right
\rather than left justified. If the quantity will not
\fit then the first byte of the string is set to "*"
\and the remainder of the string is undefined.
\ N must be at least one.

integer I,NEGATIVE;
begin
NEGATIVE:=X<0;
if NEGATIVE then X:=-X;
for I:=0,N-1 do
	begin
	X:=X/10;
	STR(N-I-1):=REM(0)+^0;
	end;
if X>=1 then [STR(0):=^*; return];
I:=0;
while (I<N)&(STR(I)=^0) do [STR(I):=^ ;I:=I+1];
if I=N then STR(I-1):=^0;
if NEGATIVE then
[if I>=1 then STR(I-1):=^- else STR(0):=^*];
end;	\ITOA



link procedure FTOA(N,M,STR,X);		\CONVERT FLOATING POINT TO ASCII STRING
integer N,M; address STR; real X;

\This routine produces a string containing the ASCII
\representation of a floating point number. The string is
\assumed to be at least N+M+1 bytes long. It produces N
\bytes before the decimal and M bytes after it. The last
\byte does NOT have the high bit set. The number is right
\rather than left justified. If the quantity will not
\fit then the first byte of the string is set to "*"
\and the remainder of the string is undefined. The decimal
\itself is always present. It is in the last byte if
\M=0 (which is legal). N must be at least one.
\exponential and other notations are not supported.

integer I,NEGATIVE,DIGIT,LEN;
real HOLD,EXPO,COMP,ROUND;


	procedure FILL;
	integer I;
	begin
	for I:=0,LEN-1 do STR(I):=^*;
	end;


begin
LEN:=if M=0 then N else N+M+1;
NEGATIVE:=X<0.0;
if NEGATIVE then X:=-X;
ROUND:=0.5;
for I:=0,M-1 do ROUND:=ROUND*0.1;
X:=X+ROUND;
HOLD:=X;
EXPO:=0.0;COMP:=1.0;
for I:=0,N-1 do
	begin
	DIGIT:= IFIX(MOD(X,10.0)-0.5);
	EXPO:= EXPO + COMP *FLOAT(DIGIT);
	COMP:= COMP*10.0;
	STR(N-I-1):= DIGIT+^0;
	X:= X/10.0;
	end;
if X>=1.0 then [FILL; return];

I:=0;
while (I<N)&(STR(I)=^0) do [STR(I):=^ ; I:=I+1];
if I=N then [STR(I-1):=^0;I:=I-1];
if NEGATIVE then
	[if I<=0 then [FILL; return] else STR(I-1):=^-];

X:=HOLD-EXPO;
STR(N):=^.;
for I:=1,M do
	begin
	X:=X*10.0;
	DIGIT:=IFIX(X-0.5);
	STR(N+I):=DIGIT+^0;
	X:=X-FLOAT(DIGIT);
	end;
end;	\FTOA



link procedure FLOUT(N,M,X);
integer N,M; real X;
char STR; integer I,LEN;
begin
STR:=RESERVE(N+M+1);
FTOA(N,M,STR,X);
I:=0;
while STR(I)=^  do I:=I+1;
LEN:=if M=0 then N else N+M+1;
for I:=I,LEN-1 do CHOUT(0,STR(I));
end;	\FLOUT



link procedure FLOUTF(D,N,M,X);
integer D,N,M; real X;
char STR; integer I,LEN;
begin
STR:=RESERVE(N+M+1);
FTOA(N,M,STR,X);
LEN:=if M=0 then N else N+M+1;
for I:=0,LEN-1 do CHOUT(D,STR(I));
end;	\FLOUTF
