\OCT.XPL	DEC-19-92
\Hi-res, flicker-free animated octahedron 
\by Richard Willmore and Loren Blaney
\This demonstrates page flipping in VGA mode $12 (640x480x16).

include	C:\CXPL\CODESI;

ext	VLINE, VMOVE, VCLEAR, VDRAW, VSHOW;	\External assembly routines

def	POINTS= 14;	\Number of points or vertices
def	C1=130, C2=80;	\Determine speed of rotation (larger nos are slower)
int	X, Y, Z,	\Array: coordinates of a point
	PAGE,		\Selects page for drawing to and to display
	JJ;		\Scratch



proc	SETPALREG(N, C);	\Set palette register
int	N,	\Register to set
	C;	\Color value (0..$3F)
int	CPUREG;
begin
CPUREG:= GETREG;
CPUREG(0):= $1000;
CPUREG(1):= C<<8 ! N;
SOFTINT($10);		\Call BIOS
end;	\SETPALEREG



proc	WAITVB;		\Wait for the beginning of the next vertical blank
begin
while PIN($3DA, 0) & $08 do;	\Wait for no vertical blank
repeat until PIN($3DA, 0) & $08;	\Wait for vertical blank
end;	\WAITVB;



proc	DRAW(COLOR);	\Draw the octahedron with specified color
int	COLOR;
int	I;
def	SIZ=20;		\Scale factor
begin
VMOVE(X(0)/SIZ+320, 239-Y(0)/SIZ);
for I:= 1, POINTS-1 do
	VLINE(X(I)/SIZ+320, 239-Y(I)/SIZ, COLOR);
end;	\DRAW



proc	ROTATE;		\Rotate the octahedron
int	I;
begin
for I:= 0, POINTS-1 do
	begin
	X(I):= X(I) + Y(I) /C1;
	Y(I):= Y(I) - X(I) /C1;
	Y(I):= Y(I) + Z(I) /C2;
	Z(I):= Z(I) - Y(I) /C2;
	end;
end;	\ROTATE



begin	\MAIN
\Coordinates defining the starting position of the octahedron:
X:= [    0, 3000, 3000,    0,-3000,-3000,    0,-3000, 3000,    0, 3000,
     -3000,    0,    0];
Y:= [ 4242,    0,    0, 4242,    0,    0,-4242,    0,    0,-4242,    0,
         0, 4242,    0];
Z:= [    0, 3000,-3000,    0, 3000,-3000,    0, 3000, 3000,    0,-3000,
     -3000,    0,    0];

SETVID($12);	\Select 640x480x16 graphics
for JJ:= 1, $F do SETPALREG(JJ, $09);	\Set most palettes to light blue

PAGE:= 0;
loop	begin
	VCLEAR(PAGE);		\Erase page
	VDRAW(PAGE);		\Select page for drawing to
	DRAW($F);		\Draw the octahedron
	ROTATE;			\Rotate the octahedron for next frame
	if CHKKEY then quit;	\Quick if keystroke
	WAITVB;			\Wait for vertical blank
	WAITVB;
	VSHOW(PAGE);		\Show what was drawn
	PAGE:= (PAGE +1) & $01;	\Flip pages
	end;

OPENI(0);	\Eat keystroke
SETVID($03);	\Return to text mode
end;	\MAIN
