\OPRINT.XPL
\PRINTER HANDLER
\FOR OKIDATA 192

'CODE'

ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;



define	\SOME CHARACTERS

	BEL=7,		\BELL CHARACTER
	ESC=$1B,	\ESCAPE
	DEL=$7F,	\DELETE
	SP=$20,		\SPACE
	BS=8,		\BACKSPACE
	FF=$0C,		\FORM FEED
	EOF=$1A,	\END OF FILE
	CTC=3,		\CONTROL-C
	CR=$0D,		\CARRIAGE RETURN
	LF=$0A;		\LINE FEED




int
	COLLUM,	\CURRENT COLLUMN
	TEMP,	\TEMPORARY STORAGE
	CHAR,	\GLOBAL CHARACTER
	LINECOUNT,	\HOLDS CURRENT LINE POSITION
	PGCTR,	\HOLDS PAGE NUMBER
	PLENGTH,	\LENGTH OF PAGE
	COPCTR;	\COUNTS NUMBER OF COPIES


def	\DEVICE CHANNELS
	TV=0,		\VIDEO CHANNEL
	IDEV=3,		\INPUT CHANNEL
	PRI=2;	\PRINTER CHANNEL


def	\PAGE CONSTANTS

	FLENGTH=66,	\LENGTH OF FORM
	WIDTH=65;	\PAGE WIDTH

addr
	DATE;	\HOLDS DATE STRING




integer IOWN;	\INTEGER PARAMETER ARRAY
define		\INTEGER PARAMETERS POINTERS

	COPIES,	\NUMBER OF COPIES TO PRINT
	EXTRA,	\FLAGS EXTRA FORM FEED AT END OF PRINT
	STARPG,	\STARTING PAGE NUMBER
	PGFLG,	\FLAGS NUMBER PAGES
	GAP,	\GAP BETWEEN FORMS
	LMAR,	\LEFT MARGIN
	RMAR,	\RIGHT MARGIN
	CPI,	\CHARACTERS PER INCH
	MODE;	\PRINTER MODE




procedure BLANK;
CHOUT(0,FF);


procedure SLINE(S);
address S;
TEXT(TV,S);


procedure CLINE(S);
\ PRINT STRING WITH CRLF
address S;
[SLINE(S);CRLF(TV);];



procedure YESNO;
[OPENI(0);return CHIN(0)=^Y;];



procedure GETKEY;
\READ KEYBOARD PORT DIRECTLY
address PORT;
begin
PORT:=$C000;
OPENI(0);CHOUT(0,31);
repeat until PORT(0)>$7F;
CHOUT(0,8);CHOUT(0,$20);CHOUT(0,8);
return PORT(0)&$7F;
end;




procedure DISINT(S,P);
\DISPLAY STRING THEN DISPLAY
\AND ENTER INTEGER
address S;int P;
begin
SLINE(S);SLINE("  ");
INTOUT(0,IOWN(P));SLINE("  ");
if GETKEY#CR then IOWN(P):=INTIN(0) else CRLF(0);
end;



procedure DISCHAR(S,P);
\DISPLAY STRING THEN DISPLAY
\AND ENTER CHARACTER
address S;int P;
begin
SLINE(S);SLINE("  ");
CHOUT(0,IOWN(P));SLINE("  ");
if GETKEY#CR then IOWN(P):=CHIN(0) else CRLF(0);
end;



procedure DISBOOL(S,P);
\DISPLAY STRING THEN DISPLAY
\AND ENTER BOOLEAN
address S;int P;
begin
SLINE(S);
SLINE("  ");
CHOUT(0,if IOWN(P) then ^Y else ^N);
SLINE("  ");
if GETKEY#CR then IOWN(P):=CHIN(0)=^Y else CRLF(0);
end;



procedure DISPARM;
\DISPLAY PRINT PARAMETERS
begin
BLANK;

SLINE("NUMBER OF copies  ");
INTOUT(TV,IOWN(COPIES));CRLF(TV);

SLINE("extra WITH FORM FEED  ");
CHOUT(0,if IOWN(EXTRA) then ^Y else ^N);
CRLF(TV);

SLINE("PRINT page NUMBERS  ");
CHOUT(0,if IOWN(PGFLG) then ^Y else ^N);
CRLF(TV);

if IOWN(PGFLG) then
	begin
	SLINE("starting PAGE NUMBER  ");
	INTOUT(TV,IOWN(STARPG));CRLF(TV);
	end;

SLINE("gap BETWEEN FORMS  ");
INTOUT(TV,IOWN(GAP));CRLF(TV);

SLINE("left MARGIN  ");
INTOUT(TV,IOWN(LMAR));CRLF(TV);

SLINE("right MARGIN  ");
INTOUT(TV,IOWN(RMAR));CRLF(TV);

SLINE("char PER INCH ");
INTOUT(TV,IOWN(CPI));CRLF(TV);

SLINE("PRINTER mode ");
case IOWN(MODE) of
	^C: TEXT(TV,"CQ");
	^D: TEXT(TV,"DP")
else;
CRLF(TV);


end;






procedure SETUP;
begin
BLANK;

DISINT("NUMBER OF copies",COPIES);
DISBOOL("extra FORM FEED",EXTRA);
DISBOOL("PRINT page NUMBERS",PGFLG);

if IOWN(PGFLG) then
	DISINT("starting PAGE NUMBER",STARPG);
DISINT("gap BETWEEN FORMS",GAP);
loop
	begin
	DISINT("left MARGIN",LMAR);
	if IOWN(LMAR)>0 then quit;
	TEXT(TV,"MUST BE GREATER THAN ZERO");CRLF(TV);
	end;

DISINT("right MARGIN",RMAR);

DISINT("char PER INCH",CPI);

DISCHAR("PRINT mode",MODE);


end;



procedure SETLOOP;
\CALL SETUP TILL SATISFIED
begin
BLANK;
DISPARM;

loop
	begin
	CRLF(TV);
	CHOUT(0,BEL);
	SLINE("SATISFIED WITH SETUP (Y/N) ");
	OPENI(0);
	if CHIN(0)#^N then quit;
	BLANK;
	SETUP;
	end;
PLENGTH:=FLENGTH-IOWN(GAP);
end;





procedure DEFAULT;
\SET PARAMETERS
begin
IOWN:=	[
	1,	\NUMBER OF COPIES TO PRINT
	true,	\FLAGS EXTRA FORM FEED AT END OF PRINT
	1,	\STARTING PAGE NUMBER
	true,	\FLAGS NUMBER PAGES
	4,	\GAP BETWEEN FORMS
	5,	\LEFT MARGIN
	79,	\RIGHT MARGIN
	10,	\CHARACTERS PER INCH
	^C];	\PRINT MODE

end;






procedure SETPRINTER;
integer I;
begin
OPENO(PRI);

\CLEAR PRINTER BUFFER
CHOUT(PRI,$18);

\NO AUTO FORM FEED
CHOUT(PRI,ESC);CHOUT(PRI,^O);

\SET NEW MARGIN
CHOUT(PRI,ESC);CHOUT(PRI,^X);
CHOUT(PRI,IOWN(LMAR));CHOUT(PRI,90);

\RESET TAB STOP FOR NEW MARGINS
CHOUT(PRI,ESC);CHOUT(PRI,^D);
for I:=1,16 do CHOUT(PRI,(I*8)+(IOWN(LMAR)-1));
CHOUT(PRI,0);

\SET CHARACTERS PER INCH
case IOWN(CPI) of
	10: CHOUT(PRI,$12);
	12: [CHOUT(PRI,ESC);CHOUT(PRI,$3A);];
	17: CHOUT(PRI,$0F)
else;

\SET PRINTER MODE
case IOWN(MODE) of
	^C: [CHOUT(PRI,ESC);TEXT(PRI,"I3");];
	^D: [CHOUT(PRI,ESC);TEXT(PRI,"I1");]
else;

end;



procedure CLEARP;
begin
\RESET PARAMETERS
CHOUT(PRI,$18);
end;





procedure SKIP;
begin
CHOUT(PRI,CR);
\*CRLF(TV);
CHOUT(PRI,LF);
LINECOUNT:=LINECOUNT-1;
end;



proc PAGE;
int X;
begin
PGCTR:=PGCTR+1;
for X:=1,WIDTH-10 do CHOUT(PRI,SP);
TEXT(PRI,"PAGE ");INTOUT(PRI,PGCTR);
SKIP;
SKIP;
end;



procedure TOPFORM;
begin
CHOUT(PRI,FF);
LINECOUNT:=FLENGTH;
end;




proc DOFORM;
begin
TOPFORM;
if IOWN(PGFLG) then PAGE;
end;



proc GETC;
begin
CHAR:=CHIN(IDEV);
if CHAR=FF & LINECOUNT>=PLENGTH then GETC;
end;



proc GETDATE;
int X;
begin
X:=0;
loop
	begin
	CHAR:=CHIN(TV);
	if CHAR=13 ! X=20 then quit;
	DATE(X):=CHAR;
	X:=X+1;
	end;
DATE(X-1):=DATE(X-1) ! 128;
end;





procedure RESLINE;
\RESET LINE PARAMETERS
begin
if LINECOUNT<=IOWN(GAP) then DOFORM;
COLLUM:=IOWN(LMAR);
end;



procedure ENDLINE;
begin
\*CRLF(TV);
CHOUT(PRI,CHAR);
LINECOUNT:=LINECOUNT-1;
RESLINE;
end;



proc PRINT;
begin
COLLUM:=IOWN(LMAR);
PGCTR:=IOWN(STARPG);
OPENI(IDEV);
SKIP;
TEXT(PRI,"                               ");TEXT(PRI,DATE);
SKIP;
repeat
	begin
	GETC;
	case CHAR of
	LF: ENDLINE;
	FF: DOFORM
	else 
		begin
		CHOUT(PRI,CHAR);
		\*CHOUT(TV,CHAR);
		COLLUM:=COLLUM+1;
		if COLLUM>IOWN(RMAR) then [SKIP;RESLINE];
		end;
	end
until CHAR=EOF;
TOPFORM;
end;



begin	\MAIN

DATE:=RESERVE(20);


LINECOUNT:=FLENGTH;

BLANK;
TEXT(TV,"DATE ");
GETDATE;

DEFAULT;
SETLOOP;


TEXT(TV,"ALIGN FORMS, THEN TYPE RETURN ");
OPENI(TV);
TEMP:=CHIN(TV);

SETPRINTER;

for COPCTR:=1,IOWN(COPIES) do PRINT;
if IOWN(EXTRA)=true then TOPFORM;
CLEARP;
end;
