\PARSE3.XPL	OCT-18-90
\Table-driven, natural language parser with backtracking.
\Ref: "Algorithms + Data Structures = Programs" by Niklaus Wirth, p295.
\Ref: "Artificial Intelligence Programming" by Eugene Charniak, p306.

def	OD=0, DEBUG=false;

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
	GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
	FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
	CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
	FCLOSE=32,	KEYHIT=33,	SOFTINT=34,	GETREG=35,
	BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
	CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
	READPIX=44,	SETVID=45	FIX=50,		POUT=64,
	PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
	ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72;

def	INTSIZE=2;
def	EMPTY=0, NIL=0;

int	ATOM, SENINX,
	STACK, STKPTR,
	STACK2, STKPTR2,
	;
int	N00, N01, N02, N03, N04, N05, N06, N07, N08, N09,
	N10, N11, N12, N13, N14, N15, N16, N17, N18, N19,
	N20, N21, N22, N23, N24, N25, N26, N27, N28, N29;
addr	SENTENCE;



proc	GETATOM;
begin
ATOM:= SENTENCE(SENINX) & $7F;
SENINX:= SENINX +1;

if DEBUG then [TEXT(OD, "ATOM = ");   CHOUT(OD, ATOM);   CRLF(OD)];
end;	\GETATOM

\----------------------------------------------------------------------

proc	PARSE(NODE);
int	NODE;
int	DONE, SINX;
def \NODE\
	TERMFLAG,	\Boolean: VALUE is a termial value (not a pointer)
	VALUE,		\Value of the node, either a terminal value or pointer
	ALTERNATE,	\Pointer to alternative node
	SUCCESSOR;	\Pointer to succeeding node



proc	PUSH;
begin
if DEBUG then
	[TEXT(OD, "PUSH, NODE = ");  INTOUT(OD, (NODE-N01)/$11+1);  CRLF(OD)];
STACK2(STKPTR2):= NODE;
STKPTR2:= STKPTR2 +1;
end;	\PUSH



proc	PULL;
begin
STKPTR2:= STKPTR2 -1;
NODE:= STACK2(STKPTR2);
if DEBUG then
	[TEXT(OD, "PULL, NODE = ");  INTOUT(OD, (NODE-N01)/$11+1);  CRLF(OD)];
end;	\PULL



proc	SAVE;
begin
STACK(STKPTR):= NODE;
STKPTR:= STKPTR +1;
STACK(STKPTR):= SENINX;
STKPTR:= STKPTR +1;
end;	\SAVE



proc	DUMPSTACK;	\PRINT STATE
int	SP, N, I, V;
begin
SP:= 0;
loop	begin
	if SP >= STKPTR then quit;

	N:= STACK(SP);
	if N(TERMFLAG) then
		V:= N(VALUE)
	else	V:= ^@;
	if V = EMPTY then V:= ^ ;

	N:= (STACK(SP)-N01)/$11 +1;
	I:= STACK(SP+1);

	TEXT(OD, "NODE = ");   INTOUT(OD, N);
	TEXT(OD, "   VALUE = ");   CHOUT(OD, V);
	TEXT(OD, "   SENINX = ");   INTOUT(OD, I);
	if I>0 then [CHOUT(OD, ^ );   CHOUT(OD, SENTENCE(I-1))];
	CRLF(OD);

	SP:= SP +2;
	end;
CRLF(OD);
end;	\DUMPSTACK



proc	DOBACKUP;
begin
loop	begin
	if STKPTR <= 0 then [DONE:= true;   quit];	\ALL BACKED UP 

	STKPTR:= STKPTR -1;
	SENINX:= STACK(STKPTR);
	STKPTR:= STKPTR -1;
	NODE:= STACK(STKPTR);

	if SENINX = -1 then PUSH
	else	begin
		if not NODE(TERMFLAG) then PULL;
		NODE:= NODE(ALTERNATE);
		if NODE # NIL then quit;
		end
	end;
ATOM:= SENTENCE(SENINX-1) & $7F;

if DEBUG then
	[TEXT(OD, "BACKED UP
	"); DUMPSTACK;
	];
end;	\DOBACKUP



begin	\PARSE
DONE:= false;
GETATOM;
loop	begin
	if DEBUG then
		[TEXT(OD, "NODE = ");  INTOUT(OD, (NODE-N01)/$11+1);  CRLF(OD)];

	while not NODE(TERMFLAG) do
		begin
		SAVE;
		PUSH;
		NODE:= NODE(VALUE);		\GET NODE AT POINTER
		if DEBUG then
			[TEXT(OD, "NODE = ");   INTOUT(OD, (NODE-N01)/$11+1);
			CRLF(OD)];
		end;
	if NODE(VALUE) = ATOM ! NODE(VALUE) = EMPTY then
		begin
		SAVE;
		if NODE(VALUE) = ATOM then GETATOM;
		loop	begin
			NODE:= NODE(SUCCESSOR);
			if NODE # NIL then
				begin
				\if ATOM = ^# then DOBACKUP;	\\FAILED
				quit;
				end;
			if STKPTR2 <= 0 \STACK IS EMPTY\ then
				begin			\GRAMMER IS DONE
				if ATOM = ^# then	\(OPTIONAL)
					TEXT(OD, "PARSED:"); CRLF(OD);
					DUMPSTACK;	\PRINT SAVED PATH
				DOBACKUP;		\LOOK FOR OTHER PARSES
				quit;
				end;
			PULL;
			SINX:= SENINX;		\SAVE FOR BACKUP
			SENINX:= -1;		\KLUDGE FLAG
			SAVE;
			SENINX:= SINX;
			end;
		end
	else	begin
		NODE:= NODE(ALTERNATE);
		if NODE = NIL then DOBACKUP;
		end;
	if DONE then quit;
	end
end;	\PARSE

\----------------------------------------------------------------------

begin
STACK:= RESERVE(2*100*INTSIZE);
STKPTR:= 0;
STACK2:= RESERVE(100*INTSIZE);
STKPTR2:= 0;

OPENO(OD);

\(Reads one character beyond end)
\SENTENCE:= "DNVDN.#";	\\THE BOY SAW A BOX
\SENTENCE:= "TDNPDN.#";	\\IS THE BLOCK IN THE BOX?
\SENTENCE:= "TDNPDNA.#";	\\IS THE BLOCK IN THE BOX RED?
SENTENCE:= "DNPDNPDNTA.#";

TEXT(OD, SENTENCE);   CRLF(OD);   CRLF(OD);

\   TERMFLAG	VALUE	ALT	SUC
N01:= [false,	0\N06\,	0\N3\,	0\N02\];
N02:= [false,	0\N13\,	NIL,	0\N25\];
N03:= [true,	^T,	NIL,	0\N04\];
N04:= [false,	0\N06\,	NIL,	0\N05\];
N05:= [false,	0\N21\,	NIL,	0\N25\];
N06:= [true,	^M,	0\N07\,	NIL];
N07:= [true,	^I,	0\N08\,	NIL];
N08:= [true,	^D,	NIL,	0\N09\];
N09:= [true,	^N,	0\N10\,	0\N11\];
N10:= [true,	^A,	NIL,	0\N09\];
N11:= [false,	0\N23\,	0\N12\,	0\N11\];
N12:= [true,	EMPTY,	NIL,	NIL];
N13:= [true,	^X,	0\N17\,	0\N14\];
N14:= [true,	^~,	0\N18\,	0\N15\];
N15:= [true,	^V,	NIL,	0\N16\];
N16:= [false,	0\N06\,	NIL,	NIL];
N17:= [true,	EMPTY,	0\N19\,	0\N15\];
N18:= [true,	EMPTY,	NIL,	0\N15\];
N19:= [true,	^T,	NIL,	0\N20\];
N20:= [false,	0\N21\,	NIL,	NIL];
N21:= [true,	^A,	0\N22\,	NIL];
N22:= [false,	0\N23\,	NIL,	NIL];
N23:= [true,	^P,	NIL,	0\N24\];
N24:= [false,	0\N06\,	NIL,	NIL];
N25:= [true,	^.,	NIL,	NIL];

N01(1):= N06;	N01(2):= N03;	N01(3):= N02;
N02(1):= N13;			N02(3):= N25;
				N03(3):= N04;
N04(1):= N06;			N04(3):= N05;
N05(1):= N21;			N05(3):= N25;
		N06(2):= N07;
		N07(2):= N08;
				N08(3):= N09;
		N09(2):= N10;	N09(3):= N11;
				N10(3):= N09;
N11(1):= N23;	N11(2):= N12;	N11(3):= N11;

		N13(2):= N17;	N13(3):= N14;
		N14(2):= N18;	N14(3):= N15;
				N15(3):= N16;
N16(1):= N06;
		N17(2):= N19;	N17(3):= N15;
				N18(3):= N15;
				N19(3):= N20;
N20(1):= N21;
		N21(2):= N22;
N22(1):= N23;
				N23(3):= N24;
N24(1):= N06;


SENINX:= 0;
PARSE(N01);

if DEBUG then TEXT(OD, "ALL DONE
");

CLOSE(OD);
end;	\MAIN
