\PASS2.XPL	DEC-10-87
\THIS TRANSLATES XPLC.OBJ TO 802 CODE.
\BY P.J.R. BOYLE.

\REVISION HISTORY:
\JUL-13-85 ORIGINAL.
\DEC-10-87, FIXED MULTIPLE-LINE TEXT STRINGS, (.TEXT IS NO LONGER USED), L.B.

\NOTES:
\THIS ASSUMES THAT SUPPORT CODE EXISTS WHICH DOES NOT AFFECT THE X REGISTER.

code	ABS=0		REM=2		RESERVE=3	SWAP=4
	CHIN=7		CHOUT=8		CRLF=9		INTIN=10
	INTOUT=11	TEXT=12		OPENI=13	OPENO=14
	CLOSE=15;

def	EOF=$1A, TAB=$09, EOL=$0D, LF=$0A, CR=$0D;
int	CHAR, LABNUM, OPC, ODV;
int	LASTX,
	TOS;		\KEEPS TRACK OF WHERE TOS IS
def	STACKED,	\TOS IS ON THE STACK
	INTHEAC,	\TOS IS IN THE AC
	IMAGE;		\TOS HAS NOT BEEN GENERATED YET
addr	IMSTR;



proc	ERROR(N);
int	N;
begin
CRLF(0);
TEXT(0, "ERROR NUMBER ");   INTOUT(0, N);   CRLF(0);
TEXT(0, "OPCODE: ");   INTOUT(0, OPC);   CRLF(0);
TEXT(0, "LABEL: ");   INTOUT(0, LABNUM);   CRLF(0);
TEXT(0, "CHAR: ");   CHOUT(0, N);   CRLF(0);
exit;
end;	\ERROR



func	HEXBIN;
int	N;
begin
CHAR:= CHIN(3);
case of
  CHAR>=^0 & CHAR<=^9: N:= (CHAR-^0) *16;
  CHAR>=^A & CHAR<=^F: N:= (CHAR-$37) *16
other ERROR(2);

CHAR:= CHIN(3);
case of
  CHAR>=^0 & CHAR<=^9: N:= N + CHAR-^0;
  CHAR>=^A & CHAR<=^F: N:= N + CHAR-$37
other ERROR(2);

return N;
end;	\HEXBIN



proc	TTXT(STR);
addr	STR;
int	I, CH;
begin
loop for I:= 0, 32000 do
	begin
	CH:= STR(I);
	if CH >= $80 then quit;
	if CH = ^| then CRLF(ODV) else CHOUT(ODV, CH);
	end;
CH:= CH & $7F;
if CH = ^| then CRLF(ODV) else CHOUT(ODV, CH);
end;	\TTXT



proc	STKTOS;
\THIS IS INVOKED AT THE START OF A GEN IF THE OP
\ NEEDS TO BE SURE TOS HAS BEEN STACKED.
int	I;
begin
case TOS of
IMAGE:	begin
	TTXT("	PEA	");
	for I:= 0, 7 do CHOUT(ODV, IMSTR(I));
	CRLF(ODV);
	end;
INTHEAC: TTXT("	PHA|")
other;
TOS:= STACKED;
end;	\STKTOS



proc	PULTOS;
\THIS IS INVOKED AT THE START OF AN OP WHICH
\ NEEDS TO HAVE TOS IN THE AC.
int	I;
begin
case TOS of
IMAGE:	begin
	TTXT("	LDA#	");
	for I:= 0, 7 do CHOUT(ODV, IMSTR(I));
	CRLF(ODV);
	end;
STACKED:TTXT("	PLA|")
other;
TOS:= INTHEAC;
end;	\PULTOS



proc	DOEXIT;
begin
TTXT("	SEC|	XCE|	.MODE	EMULATE|	LDX#	$FF|");
TTXT("	TXS|	JMP	VEXIT|	.MODE	NATIVE|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
end;	\DOEXIT



proc	GENEXIT;
begin
DOEXIT;
end;	\GENEXIT



proc	GENLOD;
int	LEVEL, OFFSET;
begin
STKTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
OFFSET:= INTIN(3);
if LASTX#LEVEL then
	begin
	TTXT("	LDX	BASE");
	INTOUT(ODV, LEVEL);
	CRLF(ODV);
	LASTX:= LEVEL;
	end;
TTXT("	LDAX	");   INTOUT(ODV, OFFSET+1);
CRLF(ODV);
TOS:= INTHEAC;
end;	\GENLOD



proc	GENADR;
int	LEVEL, OFFSET;
begin
STKTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
OFFSET:= INTIN(3);
TTXT("	LDA	BASE");
INTOUT(ODV, LEVEL);
CRLF(ODV);
TTXT("	CLC|	ADC#	");   INTOUT(ODV, OFFSET+1);
CRLF(ODV);
TOS:= INTHEAC;
end;	\GENADR



proc	GENINP;
int	LEVEL, OFFSET;
begin
STKTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
OFFSET:= INTIN(3);
if LASTX#LEVEL then
	begin
	TTXT("	LDX	BASE");
	INTOUT(ODV, LEVEL);
	CRLF(ODV);
	LASTX:= LEVEL;
	end;
TTXT("	LDAX	");   INTOUT(ODV, OFFSET+1);   CRLF(ODV);
TTXT("	INCA|	STAX	");   INTOUT(ODV, OFFSET+1);   CRLF(ODV);
TOS:= INTHEAC;
end;	\GENINP



proc	GENSTO;
int	LEVEL, OFFSET;
begin
PULTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
OFFSET:= INTIN(3);
if LASTX#LEVEL then
	begin
	TTXT("	LDX	BASE");
	INTOUT(ODV, LEVEL);
	CRLF(ODV);
	LASTX:= LEVEL;
	end;
TTXT("	STAX	");   INTOUT(ODV, OFFSET+1);   CRLF(ODV);
TOS:= STACKED;
end;	\GENSTO



proc	GENLDX;
int	LEVEL, OFFSET;
begin
PULTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
OFFSET:= INTIN(3);
TTXT("	CLC|");
if LASTX#LEVEL then
	begin
	TTXT("	LDX	BASE");   INTOUT(ODV, LEVEL);
	LASTX:= LEVEL;
	CRLF(ODV);
	end;
TTXT("	ADCX	");   INTOUT(ODV, OFFSET+1);
TTXT("|	TAY|	LDAY	0|	AND#	$FF|");
TOS:= INTHEAC;
end;	\GENLDX



proc	GENSTX;
int	LEVEL, OFFSET;
begin
STKTOS;					\WE NEED THE AC
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
OFFSET:= INTIN(3);
TTXT("	CLC|");
if LASTX#LEVEL then
	begin
	TTXT("	LDX	BASE");   INTOUT(ODV, LEVEL);
	LASTX:= LEVEL;
	CRLF(ODV);
	end;
TTXT("	LDAX	");   INTOUT(ODV, OFFSET+1);
TTXT("|	CLC|	ADCS	3|	TAY|	PLA|	SEP	MFLG|");
TTXT("	STAY	0|	REP	MFLG|	PLA|");
TOS:= STACKED;
end;	\GENSTX



proc	GENDRP;
begin
if TOS=STACKED then TTXT("	PLA|");		\BE SURE IT'S IN THE AC
TOS:= STACKED;					\ AND THEN PRETEND IT ISN'T.
repeat CHAR:= CHIN(3) until CHAR=EOL;
end;	\GENDRP



proc	GENADD;
begin
PULTOS;
TTXT("	CLC|	ADCS	1|	STAS	1|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENADD



proc	GENDBA;
begin
PULTOS;
TTXT("	ASLA|	CLC|	ADCS	1|	STAS	1|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENDBA



proc	GENDBI;
begin
PULTOS;
TTXT("	ASLA|	CLC|	ADCS	1|	STAS	1|");
TTXT("	LDY	ZERO|	LDAS@Y	1|	STAS	1|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENDBI



proc	GENSTI;
begin
PULTOS;
TTXT("	LDY	ZERO|	STAS@Y	1|	PLA|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENSTI



proc	GENLDI;
begin
STKTOS;
TTXT("	LDY	ZERO|	LDAS@Y	1|	STAS	1|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENLDI



proc	GENAND;
begin
PULTOS;
TTXT("	ANDS	1|	STAS	1|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENAND



proc	GENOR;
begin
PULTOS;
TTXT("	ORAS	1|	STAS	1|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENOR



proc	GENSUB;
begin
STKTOS;
TTXT("	LDAS	3|	SEC|	SBCS	1|	STAS	3|	PLA|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENSUB



proc	GENMARK;
begin
STKTOS;					\BECAUSE WE NEED THE AC
TTXT("	PHA|	PHA|	PHA|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
end;	\GENMARK



proc	GENRTS;
begin
STKTOS;					\(I SUPPOSE??)
TTXT("	RTS|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
end;	\GENRTS



proc	GENCMP(I);
int	I;
int	CMPT;
begin			\THESE ARE THE "TRUE" BRANCHES:
CMPT:= [
"	BEQ	.+3	;EQ|",
"	BNE	.+3	;NE|",
"	BVC	.+4	;GE|	EOR	MBIT|	BMI	.+5|	BEQ	.+3|",
"	BVC	.+4	;GT|	EOR	MBIT|	BMI	.+3|",
"	BVC	.+4	;LE|	EOR	MBIT|	BPL	.+3|",
"	BVC	.+4	;LT|	EOR	MBIT|	BEQ	.+4|	BPL	.+3|"];
PULTOS;
TTXT("	LDY	TRUE|	SEC|	SBCS	1|");
TTXT(CMPT(I));
TTXT("	INY|	PLA|	TYA|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= INTHEAC;
end;	\GENCMP



proc	GENNEG;
begin
PULTOS;
TTXT("	EOR	TRUE|	INCA|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= INTHEAC;
end;	\GENNEG



proc	GENNOT;
begin
PULTOS;
TTXT("	EOR	TRUE|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= INTHEAC;
end;	\GENNOT



proc	GENMUL;
begin
PULTOS;
TTXT("	JSR	MULDO|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= INTHEAC;
LASTX:= $FFFF;
end;	\GENMUL



proc	GENDIV;
begin
PULTOS;
TTXT("	JSR	DIVDO|");
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= INTHEAC;
LASTX:= $FFFF;
end;	\GENDIV



proc	GENJMP;
begin
STKTOS;					\CLEAN UP??
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
CHAR:= CHIN(3);
if CHAR#^L then ERROR(4);
TTXT("	JMP	L");
INTOUT(ODV, INTIN(3));
CRLF(ODV);
TOS:= STACKED;
end;	\GENJMP



proc	GENJPC;
begin
PULTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
CHAR:= CHIN(3);
if CHAR#^L then ERROR(4);
TTXT("	BNE	.+5|	JMP	L");   INTOUT(ODV, INTIN(3));
CRLF(ODV);
TOS:= STACKED;
end;	\GENJPC



proc	GENCJP;
begin
PULTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
CHAR:= CHIN(3);
if CHAR#^L then ERROR(4);
TTXT("	CMPS	1	;CJP|	BEQ	.+5|	JMP	L");
INTOUT(ODV, INTIN(3));
CRLF(ODV);
TOS:= STACKED;
end;	\GENCJP



proc	GENFOR;
begin
PULTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
CHAR:= CHIN(3);
if CHAR#^L then ERROR(4);
TTXT("	SEC|	SBCS	1|	BVC	.+4|	EOR	MBIT|");
TTXT("	BMI	.+8|	BEQ	.+6|	PLA|	JMP	L");	
INTOUT(ODV, INTIN(3));
CRLF(ODV);
TOS:= STACKED;
end;	\GENFOR



proc	GENARG;
begin
STKTOS;					\WE NEED THE AC
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
TTXT("	TSA|	CLC|	ADC#	");
INTOUT(ODV, INTIN(3)+6);
TTXT("|	TAS|");
end;	\GENARG



proc	GENHPI;
int	LEVEL;
begin
STKTOS;					\WE NEED THE AC
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);

TTXT("	PEI	TOP|	PEI	BASE");
INTOUT(ODV, LEVEL);
TTXT("|	TSA|	SEC|	SBC#	");

INTOUT(ODV, INTIN(3));
TTXT("|	TAS|	STA	TOP|	STA	BASE");
INTOUT(ODV, LEVEL);
CRLF(ODV);
end;	\GENHPI



proc	GENRET;
int	LEVEL;
begin
STKTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
if LEVEL=0 then DOEXIT
else	begin
	TTXT("	LDA	BASE");
	INTOUT(ODV, LEVEL);
	TTXT("|	CLC|	ADC#	");
	INTOUT(ODV, INTIN(3));
	TTXT("|	TAS|	PLA|	STA	BASE");
	INTOUT(ODV, LEVEL);
	TTXT("|	PLA|	STA	TOP|	RTS|");
	end;
end;	\GENRET



proc	GENIMM;
int	I;
begin
STKTOS;					\CLEAN UP
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
I:= 0;
CHAR:= CHIN(3);
if CHAR=^L then [IMSTR(0):= CHAR;   I:= 1;   CHAR:= CHIN(3)];
repeat begin				\SAVE THE IMM ARG
	IMSTR(I):= CHAR;
	if I<7 then I:= I+1;
	CHAR:= CHIN(3);
	end
until CHAR<^0 ! CHAR>^9;
for I:= I, 7 do IMSTR(I):= ^ ;

while CHAR#EOL do CHAR:= CHIN(3);

TOS:= IMAGE;
end;	\GENIMM



proc	GENCML;
begin
PULTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
TTXT("	JSR	INTR");
INTOUT(ODV, INTIN(3));
CRLF(ODV);
TOS:= STACKED;
end;	\GENCML



proc	GENCAL;
begin
STKTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
CHAR:= CHIN(3);
if CHAR#^L then ERROR(4);
TTXT("	JSR	L");
INTOUT(ODV, INTIN(3));
CRLF(ODV);
TOS:= STACKED;
LASTX:= $FFFF;				\CAL MAY HAVE BOMBED IT?
end;	\GENCAL



proc	GENTXT;
int	CHAR2, META, CNT;
begin
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
TTXT("	.ASCII	");
CHAR:= CHIN(3);
if CHAR#^" then ERROR(6);
CHOUT(ODV, CHAR);				\OUTPUT A QUOTE MARK (")
META:= false;
CNT:= 0;
repeat CHAR:= CHIN(3) until CHAR#LF;	\READ THE FIRST CHARACTER IN THE STRING
loop	begin			\(CAN'T HAVE NULL STRINGS IN XPL, OK IN ASM)
	if CHAR=^^ then
		begin
		META:= true;
		CHAR:= CHIN(3);
		end;
	CHAR2:= CHAR;
	repeat CHAR:= CHIN(3) until CHAR#LF;
	if CHAR=^" then quit;
	if CHAR2=CR then
		begin
		TTXT("^"|	.BYTE	$D, $A|	.ASCII	^"");
		CNT:= 0;
		end
	else	begin
		if META then
			begin			\(.ASCII CAN'T HANDLE METAS)
			TTXT("^"|	.BYTE	");
			INTOUT(ODV, CHAR2);
			TTXT("|	.ASCII	^"");
			META:= false;
			CNT:= 0;
			end
		else	begin
			CHOUT(ODV, CHAR2);
			CNT:= CNT +1;
			if CNT >= 60 then	\(ASM CAN'T HANDLE LONG LINES)
				begin
				TTXT("^"|	.ASCII	^"");
				CNT:= 0;
				end;
			end;
		end;
	end;	\LOOP
TTXT("^"|	.BYTE	");
if CHAR2=CR then
	TTXT("$0D, $8A")
else	begin
	INTOUT(ODV, CHAR2 + $80);
	end;
CRLF(ODV);

while CHAR#EOL do CHAR:= CHIN(3);
end;	\GENTXT



proc	GENINT;
begin
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
TTXT("	.WORD	");
loop	begin
	CHAR:= CHIN(3);
	if CHAR=EOL then quit;
	if CHAR#LF then CHOUT(ODV, CHAR);
	end;
CRLF(ODV);
end;	\GENINT



proc	GENFLT;
int	I;
addr	CH;
begin
CH:= RESERVE(10);
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
CHAR:= CHIN(3);
if CHAR=^$ then
	begin
	for I:= 0, 9 do CH(I):= CHIN(3);
	TTXT("	.WORD	$");
	CHOUT(ODV, CH(2));   CHOUT(ODV, CH(3));
	CHOUT(ODV, CH(0));   CHOUT(ODV, CH(1));	
	TTXT("|	.WORD	$");
	CHOUT(ODV, CH(6));   CHOUT(ODV, CH(7));
	CHOUT(ODV, CH(4));   CHOUT(ODV, CH(5));	
	TTXT("|	.BYTE	$");
	CHOUT(ODV, CH(8));   CHOUT(ODV, CH(9));
	CRLF(ODV);
	repeat CHAR:= CHIN(3) until CHAR=EOL;
	end
else if CHAR=^F then
	begin
	TTXT("	.WORD	");
	loop	begin
		CHAR:= CHIN(3);
		if CHAR=EOL then quit;
		if CHAR#LF then CHOUT(ODV, CHAR);
		end;
	TTXT("|	.WORD	$0000|	.BYTE	$00|");
	end;
end;	\GENFLT



proc	GENNUL;
begin
CRLF(ODV);
repeat CHAR:= CHIN(3) until CHAR=EOL;
end;	\GENNUL



proc	GENFLD;
int	LEVEL, OFFSET;
begin
STKTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
OFFSET:= INTIN(3);
TTXT("	LDA	BASE");   INTOUT(ODV, LEVEL);
if OFFSET#1 then [TTXT("|	CLC|	ADC#	");   INTOUT(ODV, OFFSET+1)]
else TTXT("|	INCA");
TTXT("|	JSR	FLOD|");
TOS:= STACKED;
end;	\GENFLD



proc	GENFST;
int	K;
int	LEVEL, OFFSET;
begin
STKTOS;
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);
LEVEL:= INTIN(3);
OFFSET:= INTIN(3);
TTXT("	LDA	BASE");   INTOUT(ODV, LEVEL);
if OFFSET#1 then [TTXT("|	CLC|	ADC#	");   INTOUT(ODV, OFFSET+1)]
else TTXT("|	INCA");
TTXT("|	JSR	FSTO|");
TOS:= STACKED;
end;	\GENFST



proc	GENFIM;
int	I;
addr	LOC;
begin
LOC:= RESERVE(10);
STKTOS;					\CLEAN UP
CHAR:= CHIN(3);
if CHAR#TAB then ERROR(3);

CHAR:= CHIN(3);
if CHAR=^$ then
	begin
	for I:= 0, 4 do
		begin
		LOC(I*2+1):= CHIN(3);
		LOC(I*2):= CHIN(3);
		end;
	TTXT("	PEA	$");
	for I:= 0, 3 do CHOUT(ODV, LOC(9-I));
	TTXT("|	PEA	$");
	for I:= 4, 7 do CHOUT(ODV, LOC(9-I));
	TTXT("|	PEA	$");
	for I:= 8, 9 do CHOUT(ODV, LOC(9-I));
	CHOUT(ODV, ^0);   CHOUT(ODV, ^0);
	CRLF(ODV);
	TTXT("	TSA|	INCA|	TAS|");		\POP EXCESS BACK OFF
	repeat CHAR:= CHIN(3) until CHAR=EOL;
	end
else if CHAR=^F then
	begin
	TTXT("|	LDA#	0|	PHA|	SEP	$20|	PHA|");
	TTXT("	REP	$20|	PEA	");
	loop	begin
		CHAR:= CHIN(3);
		if CHAR=EOL then quit;
		if CHAR#LF then CHOUT(ODV, CHAR);
		end;
	CRLF(ODV);
	end
else ERROR(10);
end;	\GENFIM



proc	GENFDO(K);
int	K;
begin
STKTOS;
TTXT("	JSR	FLT");   INTOUT(ODV, K);   CRLF(ODV);
repeat CHAR:= CHIN(3) until CHAR=EOL;
TOS:= STACKED;
LASTX:= $FFFF;
end;	\GENFDO



begin	\MAIN
IMSTR:= RESERVE(8);
TEXT(0, "
-- PASS2, V1.1 --

OUTPUT DEVICE NUMBER (0-7)? ");
ODV:= INTIN(0);
OPENO(ODV);

OPENI(3);
LASTX:= $FFFF;
TOS:= STACKED;				\THE 'DEFAULT' CASE
TTXT("PROG:");

loop	begin
	repeat CHAR:= CHIN(3) until CHAR#$A;
	if CHAR=EOF then exit;
	LABNUM:= if CHAR=^L then INTIN(3) else 0;
	CHAR:= CHIN(3);
	if CHAR#^X then ERROR(1);
	OPC:= HEXBIN;
	if LABNUM\#0\ then
		begin
		STKTOS;				\CLEAN UP
		CHOUT(ODV, ^L);
		INTOUT(ODV, LABNUM);
		CHOUT(ODV, ^:);
		LASTX:= $FFFF;			\COULD COME FROM ANYWHERE
		end;
	case OPC of
	  $00:	GENEXIT;
	  $01:	GENLOD;
	  $02:	GENLDX;
	  $03:	GENSTO;
	  $04:	GENSTX;
	  $05:	GENCAL;
	  $06:	GENRET;
	  $07:	GENJMP;
	  $08:	GENJPC;
	  $09:	GENHPI;
	  $0A:	GENARG;
	  $0B:	GENIMM;
	  $0C:	GENCML;
	  $0D:	GENADD;
	  $0E:	GENSUB;
	  $0F:	GENMUL;
	  $10:	GENDIV;
	  $11:	GENNEG;
	  $18:	GENFOR;
	  $19:	GENINP;
	  $1A:	GENOR;
	  $1B:	GENAND;
	  $1C:	GENNOT;
	  $1E:	GENDBA;
	  $1F:	GENSTI;
	  $20:	GENDBI;
	  $21:	GENADR;
	  $22:	GENLDI;
	  $24:	GENIMM;
	  $25:	GENCJP;
	  $26:	GENCAL;
	  $27:	GENRTS;
	  $28:	GENDRP;
	  $2A:	GENFLD;
	  $2B:	GENFST;
	  $2C:	GENFIM;
	  $3C:	GENMARK;
	  $FB:	GENTXT;
	  $FC:	GENFLT;
	  $FD:	GENINT;
	  $FE:	begin
		TTXT("	.LINK	I2LMOD|");
		CLOSE(ODV);
		TEXT(0, "END OF CODE");
		CRLF(0);
		exit;
		end;
	  $FF:	GENNUL
	other	begin
		case of
		  OPC>=$12 & OPC<=$17:	GENCMP(OPC-$12);
		  OPC>=$2D & OPC<=$3B:	GENFDO(OPC)
		other	[ERROR(0);   exit];
		end;
	end;
end;	\MAIN
