\PHOTO2.XPL	FEB-27-91
\Print a 640x480 graphic image (modes $11 and $12) on the Epson 850 printer.
\This module is designed to be linked with a parent module.

code	CHOUT=8,	CRLF=9,		INTOUT=11,
	TEXT=12,	OPENO=14,	TESTPT=44;

def	TV= 0, PR= 2;
def	FF= $0C, ESC= $1B, SP= $20;



public proc PHOTO(NEGATIVE, HALFSIZE, COLUMN);
\Print an image of the current graphic screen.
int	NEGATIVE,	\Flag: Print a negative image (this is normally true)
	HALFSIZE,	\Flag: Print a half-size image (disabled for Epson)
	COLUMN;		\Character column (@ 10/inch) where left edge of
			\ half-size image starts
int	WIDTH,		\Width of graphic image (in pixels)
	HEIGHT,		\Height of graphic image (in pixels)
	L,		\Printer line pair
	X, Y,		\Coordinates of the graphic image
	Y0, Y1,		\Range of Y coordinates for current pair of print lines
	B;		\Graphic byte to send to the printer



proc	DOESC(STR);	\Send an ESC command to the printer
addr	STR;
begin
CHOUT(PR, ESC);
TEXT(PR, STR);
end;	\DOESC



proc	NUMOUT(N);	\Output a 4-digit integer to the printer
int	N;
begin
if N<1000 then CHOUT(PR, ^0);		\Output leading zeros, if any
if N<100 then CHOUT(PR, ^0);
if N<10 then CHOUT(PR, ^0);
INTOUT(PR, N);
end;	\NUMOUT



proc	DOFULL;		\Print a full-size image
begin
DOESC("A"); CHOUT(PR, 8);	\Set linefeed pitch to 8/72 inch

Y0:= 0;
for L:= 0, (HEIGHT+7)/8-1 do
	begin
	Y1:= Y0 +7;

	DOESC("*4");  CHOUT(PR,WIDTH);  CHOUT(PR,WIDTH>>8);	\72 dots per inch
	for X:= 0, WIDTH-1 do
		begin
		B:= 0;
		for Y:= Y0, Y1 do
			begin
			B:= B <<1;	\Top printer pin is MSB
			if TESTPT(X, Y) then B:= B ! $01;
			end;
		CHOUT(PR, if NEGATIVE then B else ~B);
		end;
	CRLF(PR);

	Y0:= Y0 +8;
	end;
end;	\DOFULL



begin	\PHOTO
OPENO(PR);

\Get graphic image dimensions:
WIDTH:= 640;	\Assume VGA
HEIGHT:= 480;

DOFULL;
CHOUT(PR, FF);

\Restore printer to normal settings:
DOESC("@");
OPENO(PR);
end;	\PHOTO
