\PHOTOHP.XPL	03 JUL 2000
\Print a 640x480 graphic image (for mode $11) on the HP InkJet printer.
\This module is designed to be linked with a parent module.

code	CHOUT=8,	CRLF=9,		INTOUT=11,	TEXT=12,
	OPENO=14;

def	TV= 0, PR= 2;
def	FF= $0C, ESC= $1B, SP= $20;

def	WIDTH = 640,		\Width of graphic image (in pixels)
	HEIGHT = 480;		\Height of graphic image (in pixels)


public proc PHOTO(NEGATIVE, HALFSIZE, COLUMN);
\Print an image of the current graphic screen.
int	NEGATIVE,	\Flag: Print a negative image (this is normally true)
	HALFSIZE,	\Flag: Print a half-size image (disabled)
	COLUMN;		\Character column (@ 10/inch) where left edge of
			\ half-size image starts (not used)



proc	ESCTXT(STR);	\Send an ESC command to the printer
char	STR;
begin
CHOUT(PR, ESC);
TEXT(PR, STR);
end;	\ESCTXT



proc	DOFULL;		\Print a full-size graphic image
seg char SCREEN(1);	\VGA screen address
int	X, Y,		\Screen coordinates in pixels
	YY,		\Pre computed Y coordinate (for efficiency)
	B;		\Graphic byte to send to the printer
begin
SCREEN(0):= $A000;	\Point to VGA screen memory for mode $11
\ESCTXT("&l1O");		\\Landscape orientation
\ESCTXT("*r0F");		\\Set presentation mode for graphics in landscape
\ESCTXT("*t75R");	\\Set resolution
CRLF(PR);
ESCTXT("*t150R");	\Set resolution
ESCTXT("&a18C");	\Start raster graphics at specified column
ESCTXT("*r1A");		\Start raster graphics at current location
YY:= 0;
for Y:= 0, HEIGHT-1 do
	begin
	ESCTXT("*b");		\Start graphic scan line
	INTOUT(PR, WIDTH/8);
	CHOUT(PR, ^W);
	for X:= 0, WIDTH/8-1 do
		begin
		B:= SCREEN(0, YY+X);
		CHOUT(PR, if NEGATIVE then B else ~B);
		end;
	YY:= YY + WIDTH/8;
	end;
ESCTXT("*rB");		\End raster graphics
\ESCTXT("&l0O");		\\Portrait orientation
end;	\DOFULL



begin	\PHOTO
OPENO(PR);
DOFULL;
\ESCTXT("E");		\\Restore printer to normal settings
end;	\PHOTO
