\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,       MOD=58,         LOG=59,         COS=60,
TAN=61,         ASIN=62,        ACOS=63;

real XMAX,YMAX,X,Y,RTMP;
def DEG2RAD=0.01745329252;
int PNTFST,CH,DRWCOL;
int MOUSEX,MOUSEY,CPUREG,SSX,SSY,TEMP,LFTFST,RGTFST,BBX,BBY,LMX,LMY;
int MBLEFT,MBRIGHT,MBMIDDLE;

proc MC(ON);
int ON;
begin
if ON then TEMP:=1 else TEMP:=2;
CPUREG(0):=TEMP;          \TURN ON/OFF MOUSE CURSOR;
SOFTINT($33);
end;

proc SETVGA;
begin
SSX:=640;
SSY:=480;
SETVID(18);
MC(true);
CPUREG(0):=$7;     CPUREG(2):=0;      CPUREG(3):=SSX-1;   SOFTINT($33);
CPUREG(0):=$8;     CPUREG(2):=0;      CPUREG(3):=SSY-1;   SOFTINT($33);
\Set Max/Min positions for Horizontal and Vertical
end;

proc GETMINFO;
begin
CPUREG(0):=$3;
SOFTINT($33);
MOUSEX:=CPUREG(2);
MOUSEY:=CPUREG(3);
TEMP:=CPUREG(1);
case TEMP of
0:      [MBLEFT:=false;MBRIGHT:=false];
1:      [MBLEFT:=true;MBRIGHT:=false];
2:      [MBLEFT:=false;MBRIGHT:=true];
3:      [MBLEFT:=true;MBRIGHT:=true]
        else;
\CURSOR(0,0);
\INTOUT(0,CPUREG(1));
end;

proc EXITP;
begin
SETVID(3);
exit;
end;

proc AXIS;
begin
POINT(0,(SSY-1)/2,15);LINE(SSX-1,(SSY-1)/2,15);
POINT((SSX-1)/2,0,15);LINE((SSX-1)/2,SSY-1,15);
end;

proc SQUW;
real DIV,DIV2;
begin
\CURSOR(0,0);
\SQUARE WAVE SYNTHESYS
Y:=
SIN(X*DEG2RAD)+
SIN(3.0*X*DEG2RAD)/3.0+
SIN(5.0*X*DEG2RAD)/5.0+
SIN(7.0*X*DEG2RAD)/7.0+
SIN(9.0*X*DEG2RAD)/9.0+
SIN(11.0*X*DEG2RAD)/11.0+
SIN(13.0*X*DEG2RAD)/13.0+
SIN(15.0*X*DEG2RAD)/15.0+
SIN(17.0*X*DEG2RAD)/17.0+
SIN(19.0*X*DEG2RAD)/19.0+
SIN(21.0*X*DEG2RAD)/21.0+
SIN(23.0*X*DEG2RAD)/23.0+
SIN(25.0*X*DEG2RAD)/25.0+
SIN(27.0*X*DEG2RAD)/27.0+
SIN(29.0*X*DEG2RAD)/29.0;
end;

proc TRIW;
begin
Y:=
SIN(X*DEG2RAD)-
SIN(3.0*X*DEG2RAD)*.11+
SIN(5.0*X*DEG2RAD)*.04-
SIN(7.0*X*DEG2RAD)*.02+
SIN(9.0*X*DEG2RAD)*.012;
end;

proc SAWW;
begin
Y:=SIN(X*DEG2RAD)-
SIN(2.0*X*DEG2RAD)/2.0+
SIN(3.0*X*DEG2RAD)/3.0-
SIN(4.0*X*DEG2RAD)/4.0+
SIN(5.0*X*DEG2RAD)/5.0-
SIN(6.0*X*DEG2RAD)/6.0+
SIN(7.0*X*DEG2RAD)/7.0-
SIN(8.0*X*DEG2RAD)/8.0+
SIN(9.0*X*DEG2RAD)/9.0-
SIN(10.0*X*DEG2RAD)/10.0+
SIN(11.0*X*DEG2RAD)/11.0-
SIN(12.0*X*DEG2RAD)/12.0+
SIN(13.0*X*DEG2RAD)/13.0-
SIN(14.0*X*DEG2RAD)/14.0
;
end;

proc RCTW;
begin
Y:=SIN(X*DEG2RAD)+
COS(2.0*X*DEG2RAD)*.2+
SIN(3.0*X*DEG2RAD)*.083+
COS(4.0*X*DEG2RAD)*.048+
SIN(5.0*X*DEG2RAD)*.033+
COS(6.0*X*DEG2RAD)*.021+
SIN(7.0*X*DEG2RAD)*.013+
COS(8.0*X*DEG2RAD)*.012+
SIN(9.0*X*DEG2RAD)*.009;
end;

proc PPNT(PX,PY);
int PX,PY;
begin
PY:=0-PY;
if (SSX-1)/2+PX>0 & (SSX-1)/2+PX<SSX & (SSY-1)/2+PY>0 & (SSY-1)/2+PY<SSY then
if PNTFST then [POINT((SSX-1)/2+PX,(SSY-1)/2+PY,DRWCOL);PNTFST:=false] else
LINE((SSX-1)/2+PX,(SSY-1)/2+PY,DRWCOL);
end;

proc PLOT;
real STEP;
begin
X:=0.0-XMAX;
STEP:=(XMAX*2.0)/FLOAT(SSX);
loop
        begin
case CH of
^q ! ^Q:        SQUW;
^t ! ^T:        TRIW;
^w ! ^W:        SAWW;
^R ! ^r:        RCTW
else;
        if Y<=YMAX & Y>=0.0-YMAX & X<=XMAX & X>=0.0-XMAX then
        PPNT(FIX( (FLOAT((SSX-1)/2)/XMAX)*X ),FIX((FLOAT((SSY-1)/2)/YMAX)*Y) );
        X:=X+STEP;
        if X>=XMAX then quit;
        if CHKKEY then quit;
        end;
end;

proc GETSIZE;
begin
\XMAX:=10.0;
\YMAX:=50.0;
TEXT(0,"X Maximum (Minimum): ");XMAX:=FLOAT(INTIN(0));
TEXT(0,"Y Maximum (Minimum): ");YMAX:=FLOAT(INTIN(0));
end;

begin
GETSIZE;
SETVGA;
AXIS;
DRWCOL:=10;
CH:=^W;
loop
        begin
        PNTFST:=true;
        PLOT;
        loop if CHKKEY then
                begin
                CH:=CHIN(1);
                quit;
                end;
        if CH=$1B then quit;
        DRWCOL:=DRWCOL+1;
        end;
end;
