\PLOT232.XPL	MAR-09-98
\Routine to sample and plot RS-232 inputs
\Loren Blaney
\The red line plots CTS (pin 5), and the green line plots DSR (pin 6).

inc	\CXPL\CODESI;

int	SERDATA,	\SERIAL PORT DATA REGISTER
	SERSTAT,	\SERIAL PORT STATUS REGISTER
	ModemStat;	\Serial port Modem Status Register I/O port address



proc	SEROPEN(COMM, BAUD);	\Initialize communications port
int	COMM,		\Comm port (1, 2, 3, 4)
	BAUD;		\Baud rate (unsigned)
int	N, BASE;
begin
if COMM<1 ! COMM>4 then 
	[TEXT(0, " ILLEGAL COMM PORT NUMBER ");   OPENI(1);   repeat until CHKKEY];
COMM:= (COMM -1) *2;
BASE:= PEEK($40, COMM) + SWAP(PEEK($40, COMM+1));
if BASE = 0 then 
	[TEXT(0, " COMM PORT IS NOT INSTALLED ");   OPENI(1);   repeat until CHKKEY];

SERDATA:= BASE;
SERSTAT:= BASE+5;
ModemStat:= Base+6;

POUT($80, BASE+3, 0);		\Set up baud rate generator
N:= 1152 / (BAUD>>1/50);	\First divide unsigned baud rate by 100
POUT(SWAP(N), BASE+1, 0);
POUT(N, BASE, 0);

\   BITS:	765		43		2		10
\		NOT USED	PARITY		STOP BITS	WORD LENGTH
\		XXX		X0 = none	0 = 1 bit	10 = 7 bits
\				01 = odd	1 = 2 bits	11 = 8 bits
\				11 = even
POUT($03, BASE+3, 0);		\No parity, 1 stop, 8 bits

POUT($00, BASE+1, 0);		\No interrupts
POUT($03, BASE+4, 0);		\Turn on RTS and DTR

N:= PIN(BASE, 0);		\"Kick some life into it"
N:= PIN(BASE, 0);
end;	\SEROPEN



proc	Samp;		\Sample and plot
int	S, I, J;
int	X, Y, Y0;
def	Size=32000;
char	A(Size);
begin
Seropen(1, 19200);	\Set up ModemStat for Comm 1

\Wait for sample to change (trigger) before starting
S:= Pin(ModemStat,0);
S:= Pin(ModemStat,0);
S:= Pin(ModemStat,0);
loop	begin
	if Pin(ModemStat,0) # S then quit;
	end;

for I:= 0, Size-1 do
	begin
	\read rs232 pin
	A(I):= Pin(ModemStat,0);
	\store it
	\show it
	\Hexout(6, S); Crlf(6)
	for J:= 1, 10 do;	\DELAY
	end;

Setvid($12);	\640x480x16 graphics

\Plot CTS (pin 5) as a red line
Y0:= 0;
X:= 0;
Move(X, Y0);
for I:= 0, Size-1 do
	begin
	Y:= (A(I)&$10)>>2 + Y0;
	Line(X, Y, $2);
	X:= X + 1;
	if X >= 640 then
		begin
		X:= 0;
		Y0:= Y0 + 9;
		Move(X, Y0);
		end;
	end;

\Plot DSR (pin 6) as a green line
Y0:= 1;		\shift down by one pixel so it doesn't overlap
X:= 0;
Move(X, Y0);
for I:= 0, Size-1 do
	begin
	Y:= (A(I)&$20)>>3 + Y0;
	Line(X, Y, $4);
	X:= X + 1;
	if X >= 640 then
		begin
		X:= 0;
		Y0:= Y0 + 9;
		Move(X, Y0);
		end;
	end;

Openi(1);	\Wait for keystroke
I:= Chin(1);
Setvid($03);	\Restore text screen
end;	\Samp



begin	\Main
Samp;
end;	\Main
