\PR.XPL		DEC-28-96
\This program converts a text file to a temporary file in printable format.
\ The switch /M is used to indent the left margin one tab stop.
\
\REVISION HISTORY:
\MAY-09-91, Original.
\DEC-02-91, Modified for OkiData printer and fix linefeed problem.
\SEP-09-96, Fix for printers that skip over perforations (59 lines).
\DEC-28-96, Fix dangling tab problem on a laser printer.

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	FSET=24,	FOPEN=29,	FCLOSE=32,	SOFTINT=34,
	GETREG=35,	BLIT=36;

def	TAB=$09, LF=$0A, FF=$0C, CR= $0D, EOF=$1A, ESC=$1B, SP=$20;
def	LINEMAX=59,	\number of lines to print on a page
	LINEPAGE=66;	\number of lines possible on an 11-inch page

int	MARGIN;		\flag: move left margin over one tab stop

\I/O variables:
int	CPUREG,		\pointer to system info
	PSPSEG,		\address of PSP segment (for file I/O)
	DATASEG,	\address of data segment (heap & stack)
	INHAND,		\input file handle
	OUTHAND;	\output file handle
addr	INFILE,		\input file name
	OUTFILE;	\output file name
def	NAMESIZE=40;	\maximum number of characters in a file name

\============================ I/O COMMANDS ==============================

proc	DOSOPEN;	\Routine to open MS-DOS files
int	INX;		\index into TAIL
addr	TAIL, TLEN;



proc	COPYNAME(FROM, TO, EXT);
\Copy file name from FROM to TO and replace any existing extension with EXT
addr	FROM, TO,	\Strings are terminated by 0 and must be <= NAMESIZE long
	EXT;		\Extension started with "." and terminated with an
			\ unused char with MSB set
int	I, J, CH;
begin
I:= 0;
loop	begin
	CH:= FROM(I);
	if CH=^. ! CH=0 then quit;
	TO(I):= CH;
	if I < NAMESIZE-1 then I:= I +1;
	end;
for J:= 0, 3 do
	begin
	TO(I):= EXT(J);
	if I < NAMESIZE-1 then I:= I +1;
	end;
TO(I):= 0;
end;	\COPYNAME



proc	GETNAME(NAME);	\Inputs: INX, TAIL, NAMESIZE
addr	NAME;
int	I, CH;
begin
while TAIL(INX) =SP do INX:= INX +1;
I:= 0;
repeat	CH:= TAIL(INX);
	INX:= INX +1;
	if CH=SP ! CH=CR then CH:= 0;	\terminate NAME with 0
	NAME(I):= CH;
	if I < NAMESIZE-1 then I:= I +1;
until CH =0;
end;	\GETNAME



proc	GETSWITCH;	\Search command line for "/M"
int	I, CH, SW;
begin
MARGIN:= false;
SW:= false;
I:= 0;
loop	begin
	CH:= TAIL(I);
	I:= I +1;
	if CH = ^/ then
		begin
		CH:= TAIL(I);
		TAIL(I):= SP;		\blot out the /x
		TAIL(I-1):= SP;
		I:= I +1;
		if CH=^M ! CH=^m then MARGIN:= true;
		end;
	if CH=CR ! CH=0 then quit;
	end;
end;	\GETSWITCH



begin	\DOSOPEN
TLEN:= RESERVE(80);			\get command tail from PSP
TAIL:= TLEN +1;
BLIT(PSPSEG, $80, DATASEG, TLEN, 79);
if TLEN(0)>79 then TLEN(0):= 79;

GETSWITCH;

INX:= 0;
GETNAME(INFILE);			\fatal error if no file specified
if INFILE(0) =0 then
	[TEXT(0, "No file specified
");   exit];

COPYNAME(INFILE, OUTFILE, ".PRN ");

INHAND:= FOPEN(INFILE, 0);		\get input and output handles
OUTHAND:= FOPEN(OUTFILE, 1);

FSET(INHAND, ^I);
FSET(OUTHAND, ^O);
end;	\DOSOPEN



proc	DOSCLOSE;	\Close MS-DOS files
begin
CHOUT(3, EOF);
CLOSE(3);
FCLOSE(OUTHAND);

FCLOSE(INHAND);
end;	\DOSCLOSE

\----------------------------------------------------------------------

proc	MAKEFILE;	\CONVERT FILE TO PRINTABLE FORM
int	LINE,
	CH,
	L;
begin
LINE:= 1;
if MARGIN then CHOUT(3, TAB);
loop	begin
	CH:= CHIN(3);
	case CH of
	  LF:	begin
		LINE:= LINE +1;
		if LINE > LINEMAX then
			begin
			CHOUT(3, FF);
			LINE:= 1;
			end
		else	CHOUT(3, CH);
		if MARGIN then CHOUT(3, TAB);
		end;
	  FF:	begin
		CHOUT(3, FF);
		LINE:= 1;
		end;
	  EOF:	quit
	other	CHOUT(3, CH);
	end;
CHOUT(3, CR);	\BACK UP OVER TAB BECAUSE FF DOESN'T DO A CR ON LASER
end;	\MAKEFILE

\----------------------------------------------------------------------

begin	\MAIN
CPUREG:= GETREG;
PSPSEG:= CPUREG(11);
DATASEG:= CPUREG(12);

INFILE:= RESERVE(NAMESIZE);		\reserve all the arrays here
OUTFILE:= RESERVE(NAMESIZE);

DOSOPEN;

MAKEFILE;

DOSCLOSE;
end;	\MAIN
