\PSDESIGN.XPL	1/23/87  Converted for PC 8/29/92
\Richard Ottosen
\LINEAR POWER DESIGN SUPPLY AID

include C:\UTILS\CODESI.XPL;

def	BS= $08,	\Back Space
	CR= $0D,	\Carriage Return
	FF= $0C,	\Form Feed
	SP= $20;	\Space

int	DEV, DUMMY;

int \array\	SCHEMATIC, BOTTOM;

real	RMS,		\PEAK /RMS
	FREQ,		\LINE FREQUENCY
	TIME,		\RIPPLE TIME
	TREG,		\TRANSFORMER REGULATION
	LINEV,		\LINE VOLTAGE VARIATION (RATIO TO 1)
	RIPPLE,		\VOLTAGE RIPPLE ON CAPACITOR
	VOUT,		\REGULATOR OUTPUT VOLTAGE
	VREF,		\REFERENCE VOLTAGE: 0.0 FOR FIXED VOLTAGE REGULATOR
	VBREAK,		\REGULATOR BREAKDOWN VOLTAGE
	DROPOUT,	\REGULATOR DROPOUT VOLTAGE
	WAVE,		\1 =HALF WAVE AND 2 =FULL WAVE RECTIFICATION, 4 =BRIDGE
	VFWRD,		\DIODE FORWARD VOLTAGE
	VDIODE,		\TOTAL DIODE DROP
	ILOAD,		\LOAD CURRENT
	VPEAK,		\PEAK TRANSFORMER VOLTAGE
	R2,		\OUTPUT VOLTAGE SETTING RESISTANCE
	C,		\FILTER CAP VALUE
	W,		\REGULATOR DISSIPATION
	VLIM,		\?????
	VCAP,		\CAPACITOR VOLTAGE
	VTRANS,		\TRANSFORMER VOLTAGE
	VMAX,		\????
	PD;		\POWER DISSIPATION LIMIT

proc	PRINT(STRING);
int	STRING;
begin
TEXT(DEV,STRING);
end;	\PRINT


proc	PRINTR(STRING);
int	STRING;
begin
TEXT(DEV,STRING);	CRLF(DEV);
end;	\PRINTR

proc	NUMOUT(N);
real	N;
begin
RLOUT(DEV,N);
end;	\NUMOUT


proc DRAW;
int	I, C;
begin
if (WAVE =1.0) & (VREF =0.0) then
SCHEMATIC:= "                                     ________________
    ______      ______\___________ IN        OUT  ___________  DC
         _)  (_     /                REF                    OUT
         _)  (_         D1       ________________     
         _)  (_                                       
AC       _)  (_                          V             
IN       _)  (_                                        
         _)  (_                                        
    ______)  (______         +                          
                           ____                         
            T1        V     _____  C1         
                                             
                              V              
 ";

if (WAVE =2.0) & (VREF =0.0) then
SCHEMATIC:= "                                     ________________
    ______      ______\___________ IN        OUT  ___________  DC
         _)  (_     /                REF                    OUT
         _)  (_         D1       ________________     
         _)  (______                                  
AC       _)  (_                         V             
IN       _)  (_     V                                  
         _)  (_         D2                              
    ______)  (______\_____                            
                      /   ____+                        
            T1              _____  C1         
                                             
                              V              
 ";

if (WAVE =4.0) & (VREF =0.0) then
SCHEMATIC:= "                                         ________________ 
    ______      ______________     _____ IN        OUT  ___________  DC
         _)  (_           / \              REF                    OUT
         _)  (_          /   \       ________________     
         _)  (_         /  D1 \                           
AC       _)  (_   .----<  THRU >             V             
IN       _)  (_   V     \  D4 /                             
         _)  (_          \   /                             
    ______)  (____________\_/    +                          
                                ____                         
            T1                  _____ C1          
                                                 
                                  V              
 ";
if (WAVE =1.0) & (VREF #0.0) then
begin
SCHEMATIC:= "                                     ________________
    ______      ______\___________ IN        OUT  ___________  DC
         _)  (_     /                REF                   OUT
         _)  (_         D1       ________________    
         _)  (_                                      
AC       _)  (_                          ---/\/\/----
IN       _)  (_                               R1      
         _)  (_                           >    240 OHM        
    ______)  (______         +           <              
                           ____            > R2        
            T1        V     _____  C1       < ";
BOTTOM:= "
                                            
                              V             V
 ";
end;

if (WAVE =2.0) & (VREF #0.0) then
begin
SCHEMATIC:= "                                     ________________
    ______      ______\___________ IN        OUT  ___________  DC
         _)  (_     /                REF                   OUT
         _)  (_         D1       ________________    
         _)  (______                                 
AC       _)  (_                         ---/\/\/----
IN       _)  (_     V                         R1      
         _)  (_         D2                >    240 OHM
    ______)  (______\_____             <              
                      /   ____+           > R2         
            T1              _____  C1       < ";
BOTTOM:= "
                                            
                              V             V
 ";
end;

if (WAVE =4.0) & (VREF #0.0) then
begin
SCHEMATIC:= "                                         ________________ 
    ______      ______________     _____ IN        OUT  ___________  DC
         _)  (_           / \              REF                   OUT
         _)  (_          /   \       ________________    
         _)  (_         /  D1 \                          
AC       _)  (_   .----<  THRU >             ---/\/\/----
IN       _)  (_   V     \  D4 /                   R1       
         _)  (_          \   /                >    240 OHM
    ______)  (____________\_/    +           <              
                                ____            > R2         
            T1                  _____ C1        < ";
BOTTOM:= "
                                                
                                  V             V
 ";
end;

if VREF #0.0 then
	[RAWTEXT(DEV,SCHEMATIC);	\Output top of schematic
	NUMOUT(R2);			\Insert a value.
	RAWTEXT(DEV,BOTTOM);		\Finish with the bottom part
	]
	else RAWTEXT(DEV,SCHEMATIC);
\if VREF #0.0 then [CURSOR(45,10); NUMOUT(R2); PRINT(" OHMS"); CURSOR(0,12);];
end;	\DRAW


proc	PLACE(X,Y, WHOLE, DECIMAL, PROMPT, DEFAULT, UNITS);
int X,Y,WHOLE,DECIMAL,PROMPT;  real DEFAULT;  int UNITS;
begin
FORMAT(WHOLE,DECIMAL); CURSOR(X,Y);
TEXT(DEV,PROMPT); RLOUT(DEV,DEFAULT); TEXT(DEV,UNITS);
FORMAT(5,3);
end;	\PLACE


funct real	INPUT(X,Y, WHOLE, DECIMAL, PROMPT, DEFAULT, UNITS);
int X,Y,WHOLE,DECIMAL,PROMPT;  real DEFAULT;  int UNITS;
int	I, C;
real	VALUE;
begin
PLACE(X,Y, WHOLE,DECIMAL, PROMPT, DEFAULT, UNITS); TEXT(DEV, " -->> ");
OPENI(DEV); OPENI(8); OPENO(8); \Reset keyboard buffers
\Allow an empty carriage return to use the present value as the default
I:= 0;
repeat
	[C:= CHIN(DEV);	\Get the character
	CHOUT(8,C);	\ and save it in case it was a number
	I:= I +1;	\Count the character
	];
until C =CR;
if I =1 then VALUE :=DEFAULT	\First character was a carriage return
	else [VALUE:= RLIN(8);];  \Get the number that was entered
PLACE(X,Y, WHOLE,DECIMAL, PROMPT, VALUE, UNITS); TEXT(DEV, "		");
FORMAT(5,3);
return VALUE;
end;	\INPUT


proc	OUTPUT(X,Y, WHOLE, DECIMAL, PROMPT, DEFAULT, UNITS);
int X,Y,WHOLE,DECIMAL,PROMPT;  real DEFAULT;  int UNITS;
begin
FORMAT(WHOLE,DECIMAL);
TEXT(DEV,PROMPT); RLOUT(DEV,DEFAULT); TEXT(DEV,UNITS); CRLF(DEV);
FORMAT(5,3);
end;	\OUTPUT


proc	REPORT;
begin
CHOUT(DEV,FF);
DRAW;
OUTPUT(0,13, 3,0, "Line frequency = ", FREQ, "Hz");
OUTPUT(0,14, 2,0, "Line variation = +/-", LINEV, "%");
OUTPUT(0,15, 2,0, "Transformer regulation = +/-", TREG, "%");
OUTPUT(0,16, 3,1, "Regulator output voltage: ", VOUT, " Volts");
OUTPUT(0,17, 2,2, "Reference voltage, 0 for fixed =", VREF, " Volts");
OUTPUT(0,18, 2,1, "Regulator dropout voltage: ", DROPOUT, " Volts");
OUTPUT(0,19, 2,0, "Regulator breakdown voltage: ", VBREAK, " Volts");
OUTPUT(0,20, 3,1, "Maximum dissipation allowed: ", PD, " Watts");
OUTPUT(0,21, 1,0, "Number of rectifiers: ", WAVE, " Diodes");
OUTPUT(0,22, 1,2, "Rectifier forward voltage drop: ", VFWRD, " Volts");
OUTPUT(0,23, 2,2, "Load current: ", ILOAD, " Amps");
CRLF(DEV);
end;	\SETTINGS


proc	SETTINGS;
begin
CHOUT(DEV,FF);
DRAW;
PLACE(0,13, 3,0, "Line frequency = ", FREQ, "Hz");
PLACE(0,14, 2,0, "Line variation = +/-", LINEV, "%");
PLACE(0,15, 2,0, "Transformer regulation = +/-", TREG, "%");
PLACE(0,16, 3,1, "Regulator output voltage: ", VOUT, " Volts");
PLACE(0,17, 2,2, "Reference voltage, 0 for fixed =", VREF, " Volts");
PLACE(0,18, 2,1, "Regulator dropout voltage: ", DROPOUT, " Volts");
PLACE(0,19, 2,0, "Regulator breakdown voltage: ", VBREAK, " Volts");
PLACE(0,20, 3,1, "Maximum dissipation allowed: ", PD, " Watts");
PLACE(0,21, 1,0, "Number of rectifiers: ", WAVE, " Diodes");
PLACE(0,22, 1,2, "Rectifier forward voltage drop: ", VFWRD, " Volts");
PLACE(0,23, 2,2, "Load current: ", ILOAD, " Amps");
CRLF(DEV);
end;	\SETTINGS

proc	ENTER;
begin
\CRLF(DEV);
\PRINTR("Enter the following:"); CRLF(DEV);
SETTINGS;
FREQ:= INPUT(0,13, 3,0, "Line frequency = ", FREQ, "Hz");
LINEV:= INPUT(0,14, 2,0, "Line variation = +/-", LINEV, "%");
TREG:= INPUT(0,15, 2,0, "Transformer regulation = +/-", TREG, "%");
VOUT:= INPUT(0,16, 3,1, "Regulator output voltage: ", VOUT, " Volts");
VREF:= INPUT(0,17, 2,2, "Reference voltage, 0 for fixed =", VREF, " Volts");
DROPOUT:= INPUT(0,18, 2,1, "Regulator dropout voltage: ", DROPOUT, " Volts");
VBREAK:= INPUT(0,19, 2,0, "Regulator breakdown voltage: ", VBREAK, " Volts");
PD:= INPUT(0,20, 3,1, "Maximum dissipation allowed: ", PD, " Watts");
repeat
	WAVE:= INPUT(0,21, 1,0, "Number of rectifiers: ", WAVE, " Diodes");
until (WAVE =1.0) ! (WAVE =2.0) ! (WAVE =4.0);
VFWRD:= INPUT(0,22, 1,2, "Rectifier forward voltage drop: ", VFWRD, " Volts");
ILOAD:= INPUT(0,23, 2,2, "Load current: ", ILOAD, " Amps");
CRLF(DEV);
end;	\ENTER


proc	SHOWIT;
begin
PRINTR("---------------------------------------------------------------------");
FORMAT(5,2);
VTRANS:= VPEAK /RMS;
PRINT("Transformer secondary is ");
if WAVE =2.0 then [NUMOUT(VTRANS *2.0); PRINTR(" Volts C.T.");]
	else  [NUMOUT(VTRANS); PRINTR(" Volts");];
PRINT("Ripple voltage is "); NUMOUT(RIPPLE); CRLF(DEV);
PRINT("Capacitance is "); NUMOUT(C *1E6); PRINTR(" uF");
PRINT("Power dissipation is "); NUMOUT(W); PRINTR(" Watts");
end;	\SHOWIT


proc	LIMITS;	\CALCULATE THE TRANSFORMER LIMITS AND ASSOCIATED CAP VALUES
begin
if WAVE =4.0 then VDIODE:= VFWRD *2.0 else VDIODE:= VFWRD;
if WAVE =1.0 then TIME:= 1.0 /FREQ else TIME:= 1.0 /FREQ /2.0;
if VREF #0.0 then R2:= VOUT /(VREF /240.0) -240.0;
RIPPLE:= VOUT /10.0;	\MINIMAL RIPPLE SO THINGS DON'T GO OUT OF REALITY
VPEAK:= (VOUT +DROPOUT +VDIODE +RIPPLE) *(LINEV /100.0 +1.0);
C:= ILOAD *TIME /RIPPLE;
W:= ILOAD *((VPEAK - VDIODE -RIPPLE /2.0) -VOUT);
CRLF(DEV);	CRLF(DEV);
PRINTR("		Minimum values");
SHOWIT;

VPEAK:= (VBREAK +VDIODE) /(LINEV /100.0 +1.0) /(TREG /100.0 +1.0); \???? VBREAK +VDIODE
VLIM:= (VOUT +VDIODE +PD /ILOAD *2.0) /(LINEV /100.0 +1.0);
if VPEAK >VLIM then VPEAK:= VLIM;		\????
if VREF #0.0 then R2:= VOUT /(VREF /240.0) -240.0;
RIPPLE:= VPEAK *(LINEV /100.0 +1.0) -VOUT -DROPOUT -VDIODE;
C:= ILOAD *TIME /RIPPLE;
W:= ILOAD *((VPEAK -VDIODE -RIPPLE /2.0) -VOUT);
CRLF(DEV);	CRLF(DEV);
PRINTR("		Maximum values");
SHOWIT;
end;	\LIMITS


begin	\MAIN
DEV:= 0;
RMS:= SQRT(2.0);
LINEV:= 15.0;	FREQ:= 60.0;	TREG:= 20.0;	RIPPLE:= 4.0;
VOUT:= 5.0;	VREF:= 0.0;	DROPOUT:= 3.0;	VBREAK:= 35.0;
PD:= 4.0;	WAVE:= 2.0;	VFWRD:= 1.0;	ILOAD:= 1.0;
FORMAT(3,2);

CHOUT(DEV,FF); CRLF(DEV); CRLF(DEV);
PRINTR("             ==============================================");
PRINTR("             =                                            =");
PRINTR("             =       Linear power supply design aid       =");
PRINTR("             =                                            =");
PRINTR("             ==============================================");
CRLF(DEV);	CRLF(DEV);
DRAW;
CRLF(DEV); CRLF(DEV);

loop begin
PRINT("Show present settings? N"); CHOUT(DEV,BS);
OPENI(0);
DUMMY:= CHIN(DEV); if (DUMMY =^Y) ! (DUMMY =^y) then SETTINGS;
PRINT("Do you want to change the present settings? N"); CHOUT(DEV,BS);
OPENI(0);
DUMMY:= CHIN(DEV); if (DUMMY =^Y) ! (DUMMY =^y) then ENTER;
LIMITS;
CRLF(DEV);
PRINT("Print it? N"); CHOUT(DEV,BS);
OPENI(0);
DUMMY:= CHIN(DEV); if (DUMMY =^Y) ! (DUMMY =^y) then
	[DEV:= 2;
	REPORT;
	LIMITS;
	DEV:= 0;
	];
end

end;	\MAIN
