
include \CXPL\CODESI.XPL;

char BBUFFER;

integer
	DSEG,
	P,
	CPUREG,
	PCOLOR,
	PALREG,
	PRED,PGREEN,PBLUE;



real R,G,B,RED,GREEN,BLUE;

real HUE,SAT,LITE,HINC;

define COLORMOD=4.0;


procedure PAUSE;
int C;
begin
TEXT(0,"HIT ANY KEY ");
C:=CHIN(1);
CRLF(0);
end;



procedure SETPALETE(P,C);
int P,C;
begin
CPUREG(0):=$1000;
CPUREG(1):=SWAP(C) + P;
SOFTINT($10);
end;



procedure SETALL;
int P;
begin
CRLF(0);

TEXT(0,"Set Pallet Registers");CRLF(0);

CRLF(0);CRLF(0);
TEXT(0,"Enter Palette Values: ");CRLF(0);
for P:=0,15 do
	begin
	INTOUT(0,P);
	TEXT(0," - ");
	BBUFFER(P):=HEXIN(0);
	end;
TEXT(0,"Overscan Value: ");BBUFFER(16):=HEXIN(0);

CPUREG(0):=$1002;
CPUREG(11):=DSEG;
CPUREG(3):=BBUFFER;
SOFTINT($10);
CRLF(0);
end;




procedure GETALL;
int P;
begin
CPUREG(0):=$1009;
CPUREG(11):=DSEG;
CPUREG(3):=BBUFFER;
SOFTINT($10);
end;


procedure FILLBOX(X,Y,C);
int X,Y,C,P;
define XSIZE=50,YSIZE=30;
begin
for P:=1,YSIZE do
	begin
	MOVE(X,Y+P);
	LINE(X+XSIZE,Y+P,C);
	end;
end;



procedure DISRGB(C);
int C,R,G,B;
begin
B:=((C & $08) >> 3)  ! ((C & $01) << 1);
G:=((C & $10) >> 4)  ! (C & $02);
R:=((C & $20) >> 5)  ! ((C & $04) >> 1);
TEXT(0," ");
INTOUT(0,R);
TEXT(0," ");
INTOUT(0,G);
TEXT(0," ");
INTOUT(0,B);
end;


procedure DISCOLORS;
int P;
begin
CLEAR;
for P:=0,7 do FILLBOX(0,P*40,P);
for P:=0,7 do FILLBOX(300,P*40,P+8);
end;



procedure DISVALUES;
int P,C;
begin
GETALL;
for P:=0,7 do 
	begin
	CURSOR(10,P*3);
	INTOUT(0,P);
	TEXT(0," - ");
	HEXOUT(0,BBUFFER(P));
	DISRGB(BBUFFER(P));
	end;
for P:=0,7 do
	begin
	CURSOR(50,P*3);
	INTOUT(0,P+8);
	TEXT(0," - ");
	HEXOUT(0,BBUFFER(P+8));
	DISRGB(BBUFFER(P+8));
	end;
end;


procedure UPDATE;
int P;
begin
PCOLOR:=((PBLUE & $02) >> 1)  ! ((PBLUE & $01)<<3);
PCOLOR:=(((PGREEN & $02))  ! ((PGREEN & $01)<<4)) ! PCOLOR;
PCOLOR:=(((PRED & $02) << 1)  ! ((PRED & $01)<<5)) ! PCOLOR;
SETPALETE(PALREG,PCOLOR);
DISVALUES;
end;




procedure MANUAL;
begin
CLEAR;
TEXT(0,"PALETE NUMBER: ");INTOUT(0,PALREG);
TEXT(0,"  ENTER HEX COLOR: ");
PCOLOR:=HEXIN(0);
SETPALETE(PALREG,PCOLOR);
DISCOLORS;
DISVALUES;
end;




procedure HSL2RGB;
\CONVERT HUE, SATURATION AND LIGHTNESS
\TO RED, GREEN AND BLUE VALUES
real INV_HUE;


	procedure MAGNITUDE(H);
	\CONVERT HUE TO RGB MAGNITUDE
	real H;
	begin
	H:=H*6.0;
	case of
	H<1.0 :[B:=1.0;G:=H;R:=0.0;];
	H<2.0 :[B:=1.0-(H-1.0);G:=1.0;R:=0.0;];
	H<3.0 :[B:=0.0;G:=1.0;R:=H-2.0;];
	H<4.0 :[B:=0.0;G:=1.0-(H-3.0);R:=1.0;];
	H<5.0 :[B:=H-4.0;G:=0.0;R:=1.0;]
	other [B:=1.0;G:=0.0;R:=1.0-(H-5.0);];
	end;

begin
INV_HUE:=if HUE<=.5 then HUE+.5 else HUE-.5;

MAGNITUDE(HUE);
BLUE:=B;RED:=R;GREEN:=G;
MAGNITUDE(INV_HUE);
BLUE:= (COLORMOD-1.0) * LITE * (BLUE +  ((1.0 - SAT) * B));
RED:=  (COLORMOD-1.0) * LITE * (RED +   ((1.0 - SAT) * R));
GREEN:=(COLORMOD-1.0) * LITE * (GREEN + ((1.0 - SAT) * G));

PBLUE:=FIX(BLUE);
PRED:=FIX(RED);
PGREEN:=FIX(GREEN);
end;



procedure real ADVANCE(V,D);
\ADVANCE A HUE, SAT OR LITE VALUE
real V,D;
begin
V:=V + (HINC*D);
if V>1.0 then V:=1.0;
if V<0.0 then V:=0.0;
return V;
end;




begin
CPUREG:=GETREG;
DSEG:=CPUREG(12);

BBUFFER:=RESERVE(40);
TEXT(0,"SET VIDEO MODE Y/N? ");
P:=CHIN(0);
if P=^Y ! P=^y then
	begin
	TEXT(0,"ENTER VIDEO MODE IN HEX: ");
	SETVID(HEXIN(0));
	end;

DISCOLORS;
PALREG:=0;
PBLUE:=0;PGREEN:=0;PRED:=0;
HUE:=0.0;SAT:=0.0;LITE:=0.0;
HINC:=(1.0/6.0)/COLORMOD;
DISVALUES;
loop 
	begin
	CURSOR(0,23);
	TEXT(0,"PALETE: ");
	INTOUT(0,PALREG);

	TEXT(0,"   RED: ");
	HEXOUT(0,PRED);

	TEXT(0,"   PGREEN: ");
	HEXOUT(0,PGREEN);

	TEXT(0,"   BLUE: ");
	HEXOUT(0,PBLUE);

	TEXT(0,"   COLOR: ");
	HEXOUT(0,PCOLOR);

	CURSOR(0,24);
	TEXT(0,"HUE: ");RLOUT(0,HUE);
	TEXT(0,"  SATURATION: ");RLOUT(0,SAT);
	TEXT(0,"  LIGHTNESS: ");RLOUT(0,LITE);

	case CHIN(1) of
	^M,^m: MANUAL;
	^B: [PBLUE:=(PBLUE+1) & 3;UPDATE;];
	^b: [PBLUE:=(PBLUE-1) & 3;UPDATE;];
	^G: [PGREEN:=(PGREEN+1) & 3;UPDATE;];
	^g: [PGREEN:=(PGREEN-1) & 3;UPDATE;];
	^R: [PRED:=(PRED+1) & 3;UPDATE;];
	^r: [PRED:=(PRED-1) & 3;UPDATE;];
	^P: PALREG:=(PALREG+1) & $F;
	^p: PALREG:=(PALREG-1) & $F;
	^H: [HUE:=ADVANCE(HUE,1.0);HSL2RGB;UPDATE;];
	^h: [HUE:=ADVANCE(HUE,-1.0);HSL2RGB;UPDATE;];
	^S: [SAT:=ADVANCE(SAT,1.0);HSL2RGB;UPDATE;];
	^s: [SAT:=ADVANCE(SAT,-1.0);HSL2RGB;UPDATE;];
	^L: [LITE:=ADVANCE(LITE,1.0);HSL2RGB;UPDATE;];
	^l: [LITE:=ADVANCE(LITE,-1.0);HSL2RGB;UPDATE;];
	$1B: quit
	other;
	end;

SETVID(3);
end;
