\ QUEST.XPL	NOV-06-90
\ BY ROGER CHAFFEE, PENINSULA SCHOOL, MENLO PARK, CA
\ COPYRIGHT 1979.  PERMISSION TO USE, NOT TO SELL.
\ REF:  BYTE, JULY 1979, P 176.
\ CONVERTED TO XPL AND MODIFIED SLIGHTLY BY LOREN BLANEY
\
\ REVISION HISTORY:
\ JUL-22-79, ORIGINAL
\ SEP-10-86, MODIFIED FOR 68000 XPL, L.B.
\ NOV-06-90, MODIFIED FOR PC.

code	ABS=0, RND=1, REM=2, RESERVE=3, SWAP=4, EXTEND=5,
	SHORT=6, CHIN=7, CHOUT=8, CRLF=9, INTIN=10, INTOUT=11,
	TEXT=12, OPENI=13, OPENO=14, CLOSE=15, ABORT=16,
	CURSOR=23;

def	INTSIZE =2;	\NUMBER OF BYTES IN AN INTEGER (2 OR 4)

def	TV=0, KB=0;
def	DEBUG = false;	\FLAG--IN DEBUG (OF DATABASE) MODE

int	NODE,		\PLAYER'S CURRENT LOCATION NUMBER
	NODES,		\TOTAL NUMBER OF NODES
	TRSNODE,	\NODE TREASURE IS CURRENTLY HIDDEN AT
	NODE0,		\SAVES OLD NODE FOR DEAD END (MOVE PROC)
	DIR0,		\SAVES OLD DIRECTION FOR DEAD END (MOVE PROC)
	CARRIED,	\FLAG--SET IF TREASURE IS CARRIED
	HIDE1, HIDE2,	\FIRST & SECOND TREASURE HIDING PLACES
	MOVTRS,		\SAVES THE MOVE NO. WHERE HE SAID NO,
		\ HE DIDN'T WANT TO TAKE THE TREASURE WITH HIM.
	GRABBED,	\FLAG--PIRATE GRABBED HIS TREASURE BACK
	PCNTR,		\COUNTER FOR PIRATE PROCEDURE
	MOVCNT,		\MOVE COUNTER
	DIR,		\DIRECTION INDEX FROM THE INPUT PROC
	POINTS,		\TOTAL POINTS SCORED
	CHAR,		\CHARACTER FROM KEYBOARD
	J;		\SCRATCH VARIABLE

addr	TRAIL;		\TRAIL POINTS, USED IN SCORING.
			\TRAIL(I)=1 IF HE HAS BEEN TO NODE I
int	MAP;		\MAP OF INTERCONNECTIONS
	\MAP(I +J*8) IS NEXT NODE FROM NODE J, WHEN YOU GO
	\N,E,U,D,W,S FOR I=0,1,2,3,4,5.
	\MAP(6 +J*8) POINTS TO TEXT 


proc	SETUP;	\SET UP THE MAP DESCRIBED BY DATABASE

proc	DATA(NODE,N,E,U,D,W,S,MSG);
int	NODE,N,E,U,D,W,S;
addr	MSG;
int	X;
begin
X:=NODE *8;
MAP(0 +X):=N; MAP(1 +X):=E;
MAP(2 +X):=U; MAP(3 +X):=D;
MAP(4 +X):=W; MAP(5 +X):=S;
MAP(6 +X):=MSG;;
end;


begin	\SETUP
\FORCED AND/OR RANDOM MOVES:
\MAP(0,NODE)=0 MEANS A FORCED MOVE AS SOON AS YOU REACH THE
\NODE.  IN THAT CASE, MAP(1,NODE)% OF THE TIME YOU GO TO NODE
\MAP(2,NODE).  IF YOU DON'T GO THERE, MAP(3,NODE)% OF THE TIME
\YOU GO TO NODE MAP(4,NODE) & THE REST OF THE TIME YOU GO TO
\NODE MAP(5,NODE).

\TO GO TO NODE 0 MEANS BOUNCE BACK TO THE NODE YOU CAME FROM.
\SOME "NODES" ARE REALLY ONLY MESSAGES AND THE BOUNCE KEEPS YOU
\AT THE PROPER NODE.

\NODES >100:
\NODE +100 MEANS NODE IF YOU DON'T HAVE THE TREASURE, AND
\NODE +1 IF YOU DO.
\NODE +200 MEANS NODE IF YOU DON'T HAVE THE TREASURE THE
\SECOND TIME, AND NODE +1 IF YOU DO.

\SPECIAL NODE, DIRECTIONS ARE MODIFIED BY THE CODE
DATA(1,0,0,0,0,0,0,
"You're at a dead end.");

DATA(2,0,100,0,0,0,0,
"You can't go in that direction.");

DATA(3,33,2,1,10,106,4,
"A tunnel goes north & south.  There is an opening
to the west.");

DATA(4,3,30,2,11,2,1,
"You're on the brink of a pit.");

DATA(5,8,8,15,10,8,16,
"You are standing north of the entrance to the cave.");

DATA(6,16,3,2,10,2,2,
"You're in the home of the Gnome King.  Fortunately,
he's gone at the moment.");

DATA(7,0,100,0,0,0,0,
"The Gnome King is home!  You'd better get out!");

DATA(8,18,18,15,10,18,9,
"You are lost in the woods.");

DATA(9,0,33,5,0,0,0," ");

DATA(10,0,100,0,0,0,0,
"You're not going to get far digging through solid rock.");

DATA(11,1,13,4,2,1,2,
"You're at the bottom of a pit.  A little stream flows
over the rocks here.");

DATA(12,36,2,1,2,1,2,
"You're at a dead end.");

DATA(13,2,37,2,1,11,14,
"You're at a wide spot.  There is a sooty patch where
somebody has rested a torch against the wall.  There are
jagged rocks above you.");

DATA(14,13,1,19,2,31,31,
"You are in a canyon.  High on the wall above you is
scratched the message:
	^"BILBO WAS HERE^".");

DATA(15,0,100,0,0,0,0,
"You're not a bird.  You can't fly!");

DATA(16,5,33,2,10,1,106,
"You're in a low chamber.  A tight tunnel goes east,
and you can walk to the south or west.  There is light
coming from the north.");

DATA(17,0,100,0,0,0,0,
"It's a tight squeeze.  You can't get past with the treasure.");

DATA(18,0,100,8,0,0,0,
"I don't think you can find the cave.");

DATA(19,224,2,2,14,42,1,
"You're at the top of a long climb.  Below you a message says:
	^"BILBO WAS HERE^".");

DATA(20,226,1,2,2,25,2,
"You're at the north side of a chasm, too wide to jump.
Ringing echoes from below are the only indication of depth.");

DATA(21,1,226,2,2,38,25,
"You're in Xanado.  Below you Alph, the sacred river,
runs through caverns measureless to man, down to a
sunless sea.");

DATA(22,0,33,13,50,29,30," ");

DATA(23,2,1,2,31,2,2,
"You're on the ledge above the Guillotine room.");

DATA(24,0,100,19,0,0,0,
"I hear the giant there!!!  You'd better go back!");

DATA(25,21,20,2,2,1,19,
"You're in the giant's cavern.  Better not be here when
the giant comes back!");

DATA(26,0,65,0,50,25,35,
"You're in the Quest research and development area.
I'm sorry, but visitors are not allowed.  You'll have
to leave.");

DATA(27,40,2,2,2,21,20,
"You're in the crystal palace.  The walls resonate with
awesome music.");

DATA(28,0,60,221,50,14,19," ");

DATA(29,2,1,2,13,42,1,
"You're at the top of a giant stalagtite.  You could
slide down but you couldn't climb back up.");

DATA(30,34,34,2,1,4,2,
"You're in a little grotto.  There is a book here
called ^"Jane's Fighting Ships^" dated 1763.");

DATA(31,14,14,23,2,1,2,
"You're in the Guillotine room.  A sharp rock
balances precariously on the ledge above you.");

DATA(32,0,100,16,0,0,0,
"You're in a chute, scrambling down the rocks!
No way to stop!  HANG ON!");

DATA(33,2,1,2,1,116,3,
"The tight tunnel turns a corner.");

DATA(34,1,35,2,1,30,30,
"You're in a little twisty maze.");

DATA(35,2,1,2,37,34,36,
"You're in a little twisting maze.");

DATA(36,35,2,1,37,34,12,
"You're in a twisting little maze.");

DATA(37,2,1,35,2,13,2,
"You're in a twisty little maze.");

DATA(38,2,21,2,116,1,2,
"You're in a prehistoric dwelling.  On the wall are drawings
of bison done in red clay.  The floor is strewn with bones,
the remains of ancient rituals.  A small tunnel goes through
the floor.");

DATA(39,41,40,2,32,40,40,
"You're in a black hole.  The force of gravity is
overwhelming!");

DATA(40,40,27,2,2,41,40,
"You're in the labyrinth.");

DATA(41,40,40,40,2,39,40,
"You're in the labyrinth.  It's very dark in here.");

DATA(42,28,28,28,28,28,28,
"You're in the ashram.  Incense is heavy in the air,
and all directions seem the same.");
end;


proc	INPUT;	\GET DIRECTION INDEX, ETC.
\THE FIRST CHAR OF THE INPUT STRING IS COMPARED WITH THE
\ LETTERS OF DSTRING, AND IF THERE IS A MATCH, THE INDEX IN
\ DSTRING IS RETURNED IN DIR.
addr	DSTRING;

begin
DSTRING:="neudwsp ";
OPENI(KB);
CHAR:=CHIN(KB) ! $20;
\SEARCH FOR THE CHAR IN THE DIRECTION STRING
DIR:=0;
loop	begin
	if CHAR=DSTRING(DIR) then quit;
	DIR:=DIR +1;
	if DIR >6 then quit;
	end;
end;


proc	INSTRUCTIONS;
TEXT(TV,"
Type N, S, E, W, U, or D to move north, south, east, west, up
or down.  Type P for your points.

");


proc	DESCRIBE;	\DESCRIBE THE CURRENT NODE
begin
TEXT(TV, MAP(6 +NODE *8) ); CRLF(TV);
if TRSNODE=NODE & (not CARRIED) then
	TEXT(TV,"The treasure is here!
");
if TRSNODE=HIDE2 & HIDE1=NODE & HIDE1#HIDE2 then
	TEXT(TV,"A note on the wall says:
	^"PIRATES NEVER LEAVE THEIR TREASURE
	    TWICE IN THE SAME PLACE.^"
");
end;


proc	SCORE;	\COMPUTE TOTAL POINTS (100 MAXIMUM)
int	J;
begin
POINTS:=0;
if CARRIED then POINTS:=POINTS +40;
if GRABBED then POINTS:=POINTS +10;
for J:=3,NODES-1 do POINTS:=POINTS +TRAIL(J);  \FOR EXPLORING
end;


proc	WHICHWAY;	\GET WHICH WAY HE WANTS TO GO
\RETURNS DIR WHICH IS AN INDEX:  0,1,2,3,4,5 FOR N,E,U,D,W,S
begin
loop	begin
	loop begin
		TEXT(TV,"					Which way?  ");
		INPUT;
		if DIR<=6 then quit;
		TEXT(TV,"Which direction do you want to go?");
		CRLF(TV);
		INSTRUCTIONS;
		DESCRIBE;
		end;
	if DIR<=5  then quit;
	SCORE;
	TEXT(TV,"You have "); INTOUT(TV,POINTS);
	TEXT(TV," out of 100 possible points.");
	CRLF(TV);
	end;
CRLF(TV);
end;


proc	MOVE;	\MOVE WHERE HE WANTS TO GO
int	NODE9,	\SAVES OLD NODE FOR BOUNCE
	NODE8,	\SAVES NODE WE BOUNCED FROM
	\ FOR SUPPRESSING DESCRIPTION WHEN BOUNCING OFF WALLS
	DEST;	\DESTINATION NODE

begin
NODE9:=NODE;	\REMEMBER WHERE WE ARE FOR BOUNCE.
NODE8:=0;
WHICHWAY;
\REMEMBER WHERE WE ARE UNLESS AT SPECIAL DEAD END
if NODE#1 then [NODE0:=NODE; DIR0:=DIR];
DEST:=MAP(DIR +NODE *8);

loop	begin	\(LOOP IS REQUIRED FOR FORCED MOVES
	if DEST= 0 then DEST:=NODE9;	\BOUNCE
	if DEBUG then
		[TEXT(TV,"		*** DEBUG *** "); INTOUT(TV,NODE);
		TEXT(TV," TO "); INTOUT(TV,DEST); CRLF(TV)];

	if DEST<100 then NODE:=DEST	\NORMAL ROUTE
	else if DEST<200 then  \ADD ONE IF CARRYING THE TREASURE
		[NODE:=DEST -100; if CARRIED then NODE:=NODE +1]
	else if DEST<300 then  \ADD 1 IF CARRYING TREAS 2ND TIME
		[NODE:=DEST -200;
		if CARRIED & GRABBED then NODE:=NODE +1];

	\IF SPECIAL DEAD END THEN ADJUST MAP SO YOU ONLY
	\ GET OUT IN THE OPPOSITE DIRECTION.
	if NODE=1 then
		[for J:=0,5 do MAP(J +1 *8):=2;
		MAP(5 -DIR0 +1 *8):=NODE0];

	\SUPPRESS DESCRIPTION OF CURRENT NODE IF HE'S
	\ SIMPLY BOUNCING OFF THE WALLS
	if NODE8#2 then DESCRIBE;
	TRAIL(NODE):=1;	\TALLY A POINT FOR COMING HERE
	NODE8:=NODE;

	\EXIT LOOP IF NOT A FORCED MOVE WITH RANDOM DESTINATIONS
	if MAP(0 +NODE *8)# 0 then quit;
	DEST:=MAP(5 +NODE *8);
	if MAP(3 +NODE *8) > RND(100) then
		DEST:=MAP(4 +NODE *8);
	if MAP(1 +NODE* 8) > RND(100) then
		DEST:=MAP(2 +NODE *8);
	if DEBUG then [TEXT(TV,"	*** DEBUG *** BOUNCE TO ");
		INTOUT(TV,DEST); CRLF(TV)];
	end;
end;


proc	TREASURE;	\FOUND TREASURE?
begin
if TRSNODE=NODE & (not CARRIED) & MOVTRS+5<=MOVCNT then 
	begin
	loop
		begin
		TEXT(TV,"Do you want to take it with you?  ");
		OPENI(KB);
		CHAR:=CHIN(KB) ! $20;
		if CHAR=^y then
		   [CARRIED:= true;
		   TEXT(TV,"OK, let's get out of here!"); CRLF(TV);
		   quit];
		if CHAR=^n then
		   [TEXT(TV,"We'll leave it here and you can explore some more.");
		   CRLF(TV);
		   \(DON'T KEEP ASKING HIM ABOUT THE TREASURE)
		   MOVTRS:=MOVCNT;
		   quit];
		TEXT(TV,"Well yes or no.  ");
		end;
	end;
end;


proc	PIRATE;	\PIRATE GRABS TREASURE
begin
if CARRIED & (not GRABBED) & NODE#HIDE2 & HIDE1#HIDE2 then
	begin
	\HE 'S (SOMEHOW) AT THE EXIT WITH THE TREASURE.  GRAB IT
	if NODE=16 then PCNTR:=160;
	\COUNT MOVES SINCE HITTING N/S TUNNEL WITH TREASURE
	if NODE=3 then PCNTR:=PCNTR +1;
	if PCNTR>0 then PCNTR:=PCNTR +1;
	\GIVE HIM A FEW MORE MOVES, THEN GRAB IT
	if PCNTR>=15 then
		begin
		TEXT(TV,"
Suddenly the pirate leaps out of the gloom and grabs the
treasure from you!  ^"HAH!^" he shouts, ^"Ya found me treasure,
did ya.  Well I'll hide it better this time.^" And he
disappears into the darkness with the treasure.
");
		GRABBED:=true;
		CARRIED:=false;
		TRSNODE:=HIDE2;
		end;
	end;
end;


begin	\MAIN PROC
\GIVE 'EM SOMETING TO READ WHILE I GET THE DATABASE SET UP
CHOUT(TV,$0C);
TEXT(TV,"		      -- Q U E S T --

You are walking through the woods, and you come across the
entrance to a cave, covered with brush.

It is said that many years ago a pirate hid his treasure
in these woods, but no one has ever found it.  It may still
be here, for all I know.
");

NODES:=43; HIDE1:=23; HIDE2:=12;
TRAIL:=RESERVE(NODES); MAP:=RESERVE(NODES *8 *INTSIZE);
SETUP;

TEXT(TV,"
When you answer a question, I look at only the first letter,
although you can type the whole word if you want.
");
INSTRUCTIONS;

loop	begin
	NODE:=5; MOVCNT:=0; MOVTRS:=0; CARRIED:=false;
	TRSNODE:=HIDE1; GRABBED:=false; PCNTR:=0;
	for J:=0,NODES -1 do TRAIL(J):=0;

	DESCRIBE;
	loop	begin
		MOVCNT:=MOVCNT +1;	\COUNT MOVES
		MOVE;
		TREASURE;	\CHECK FOR TREASURE
		PIRATE;	\CHECK FOR PIRATE
		if CARRIED & NODE=5 then quit;
		end;
	SCORE;
	TEXT(TV,"CONGRATULATIONS!  You got the treasure out in ");
	INTOUT(TV,MOVCNT); TEXT(TV," moves
and you got "); INTOUT(TV,POINTS +10);
	TEXT(TV," out of 100 possible points!
");
	loop
		begin
		TEXT(TV,"Want to hunt again?  ");
		OPENI(KB);
		CHAR:=CHIN(KB) ! $20;
		if CHAR=^y then quit;
		if CHAR=^n then return;
		CRLF(TV);
		end;
	CRLF(TV);
	end;
end;	\MAIN
