\R3d.xpl
\Random3D image generator

code
ABS=0,		RAN=1,		REM=2,		RESERVE=3,	SWAP=4,
EXTEND=5,	RESTART=6,	CHIN=7,		CHOUT=8,	CRLF=9,
INTIN=10,	INTOUT=11,	TEXT=12,	OPENI=13,	OPENO=14,
CLOSE=15,	ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,	FSET=24,
SETRUN=25,	HEXIN=26,	HEXOUT=27,	CHAIN=28,	FOPEN=29,
WRITE=30,	READ=31,	FCLOSE=32,	CHKKEY=33,	SOFTINT=34,
GETREG=35,	BLIT=36,	SOUND=39,	CLEAR=40,	POINT=41,
LINE=42,	MOVE=43,	READPIX=44,	SETVID=45;
code real	RLIN=47,	RLOUT=48,	FLOAT=49,	FIX=50;


int	DUMMY, COUNT, M, N;
int	COLOR, RANDOMLO, RANDOMHI, RANDOM32;

\def 	WIDTH=190, HEIGHT=190, DEPTH=40, DOTSIZE=4, THICK=10;
\def 	WIDTH=100, HEIGHT=100, DEPTH=20, DOTSIZE=4, THICK=10;
\def 	WIDTH=200, HEIGHT=80, DEPTH=40, DOTSIZE=6, THICK=3;
\def 	WIDTH=24*8, HEIGHT=24*3, DEPTH=20, DOTSIZE=6, THICK=3;
\def 	WIDTH=24*12, HEIGHT=24*5, DEPTH=60, DOTSIZE=6, THICK=3;
def 	WIDTH=24*12*2, HEIGHT=24*5*2, DEPTH=100, DOTSIZE=6, THICK=3;



proc FUSEDOTS;
\Draw two dots at the top edge to aid in fusing the image
int	I, J, CENTER, R, L;
begin
CENTER:= (WIDTH +DEPTH) /2;
L:= CENTER -DEPTH /2; R:= CENTER +DEPTH /2;
for J:= 0, DOTSIZE do
	[for I:= L, L +DOTSIZE do POINT(I, J, 1);
	for I:= R, R +DOTSIZE do POINT(I, J, 1);
	];
for J:= 0, DOTSIZE -5 do
	[for I:= L, L +DOTSIZE -4 do POINT(I+3, J+2, 0);
	for I:= R, R +DOTSIZE -4 do POINT(I+1, J+2, 0);
	];
end;	\FUSEDOTS



proc	IPLOT(X,Y,C);	\Interleave plot a dot after limit checking
int	X, Y, C;
begin
if X<WIDTH & X>DEPTH then
	POINT(X+THICK, Y+DOTSIZE+THICK, C);
end;	\PLOT



proc	OPLOT(X,Y,C); \Overlay plot a dot after limit checking
int	X, Y, C;
begin
POINT(X, Y+DOTSIZE, C);
end;	\PLOT



proc	BOX(X,Y,WIDTH,HEIGHT);	\Draw a box
int	X,Y,W,H;
begin
MOVE(X,Y);
LINE(X +W, Y,1);
LINE(X +W, Y +H, 1);
LINE(X, Y +H, 1);
LINE(X, Y, 1);
end;	\BOX



proc	IFRAME;		\Interleave frame it
int	I;
begin
for I:= 0, THICK do
	[BOX(I+DEPTH,  DOTSIZE+I,
		WIDTH -DEPTH +2*THICK -2*I,  HEIGHT +2*THICK -2*I);
	];
end;	\IFRAME



proc	OFRAME;		\Overlay frame it
begin
MOVE(0,DOTSIZE);
LINE(WIDTH +DEPTH,DOTSIZE,1);
LINE(WIDTH +DEPTH,HEIGHT +DOTSIZE,1);
LINE(0,HEIGHT +DOTSIZE,1);
LINE(0,DOTSIZE,1);
MOVE(-1,DOTSIZE -1);
LINE(WIDTH +DEPTH +1,DOTSIZE -1,1);
LINE(WIDTH +DEPTH +1,HEIGHT +DOTSIZE +1,1);
LINE(-1,HEIGHT +DOTSIZE +1,1);
LINE(-1,DOTSIZE -1,1);
end;	\FRAME



proc	IRECTANGLE(X,Y,Z,W,H);  \X, Y & Z origin, Width, Height
\Interleave fill a rectangle with random dots using the origin and
\size specified.
int	X, Y, Z, W, H;
int	XX, YY, ZZ, WW, HH, COLOR;
begin
WW:= X +W;   HH:= Y +H;
YY:= Y;
while YY <HH do
	[for XX:= X, WW do
		[COLOR:= RAN(2);
		if COLOR =0 then IPLOT(XX, YY, 0) else IPLOT(XX, YY, 1);
		if COLOR =0 then IPLOT(XX+Z, YY+1, 0)
			else IPLOT(XX+Z, YY+1, \2\1);
		];
	YY:= YY +2;
	];
end;	\IRECTANGLE



proc	ORECTANGLE(X,Y,Z,W,H);  \X, Y & Z origin, Width, Height
\Fill an overlayed rectangle with random dots using the origin and
\size specified.
int	X, Y, Z, W, H;
int	XX, YY, ZZ, WW, HH, COLOR;
begin
WW:= X +W; HH:= Y +H;
for YY:= Y, HH do
	[for XX:= X, WW do
		[COLOR:= RAN(2);
		OPLOT(XX, YY, COLOR);
\		if XX+Z<WW & XX+Z>X then
			if COLOR #0 then OPLOT(XX+Z, YY, COLOR);
		];
	];
end;	\ORECTANGLE



proc	MESSAGE1;
int	MESS1, I, X, Y;
begin
MESS1:=
 [3,1, 3,2, 3,3, 3,4, 3,5, 3,6, 3,7, 4,4, 5,4, 6,4, 7,1, 7,2, 7,3, 7,4, 7,5, 7,6, 7,7,
  10,4, 10,5, 10,6, 11,3, 11,5, 11,7, 12,3, 12,5, 12,7, 13,3, 13,5, 13,7, 14,4,
  19,1, 19,2, 19,3, 19,4, 19,5, 19,6, 19,7,
  26,1, 26,2, 26,3, 26,4, 26,5, 26,6, 26,7,
  31,4, 31,5, 31,6, 32,3, 32,7, 33,3, 33,7, 34,3, 34,7, 35,4, 35,5, 35,6,
  7,10, 7,12, 7,13, 7,14, 7,15, 7,16, 8,10, 8,13, 8,16, 9,10, 9,13, 9,16, 10,10, 10,13, 10,16, 11,11, 11,12, 11,14, 11,15,
  15,11, 15,13, 15,14, 15,15, 15,16,
  23,10, 23,11, 23,12, 23,13, 23,14, 23,15, 23,16,
  30,10, 30,11, 30,12, 30,13, 30,14, 30,15, 30,16,
  -1,-1		\Terminator
 ];

I:= 0;
X:= MESS1(I);   Y:= MESS1(I +1);
while X >=0 do
	[IRECTANGLE(X*WIDTH/48 +DEPTH, Y*WIDTH/48, DEPTH/2, 4, 4);
	I:= I +2;
	X:= MESS1(I);   Y:= MESS1(I+1);
	];
end;	\MESSAGE1



proc	MESSAGE;
int	MESS, I, X, Y;
begin
MESS:=
 [7,2, 7,3, 7,4, 7,5, 7,6, 8,1, 8,5, 8,7, 9,1, 9,4, 9,7, 10,1, 10,4, 10,7, 11,2, 11,5, 11,6,
 14,1, 14,2, 14,3, 14,4, 14,6, 15,1, 15,3, 15,7, 16,1, 16,3, 16,7, 17,1, 17,3, 17,7, 18,1, 18,4, 18,5, 18,6,
 21,2, 21,3, 21,4, 21,5, 21,6, 22,1, 22,5, 22,7, 23,1, 23,4, 23,7, 24,1, 24,3, 24,7, 25,2, 25,3, 25,4, 25,5, 25,6,
 28,2, 28,6, 28,7, 29,1, 29,5, 29,7, 30,1, 30,5, 30,7, 31,1, 31,4, 31,7, 32,2, 32,3, 32,7,
 3,11, 3,12, 3,13, 3,14, 3,15, 4,10, 4,16, 5,10, 5,14, 5,16, 6,10, 6,14, 6,16, 7,11, 7,14, 7,15,
 10,12, 10,13, 10,14, 10,15, 10,16, 11,13, 12,12, 13,12, 14,13,
 17,13, 17,14, 17,15, 18,12, 18,16, 19,12, 19,16, 20,12, 20,16, 21,13, 21,14, 21,15,
 24,12, 24,13, 24,14, 24,15, 25,16, 26,16, 27,15, 28,12, 28,13, 28,14, 28,15, 28,16,
 30,13, 30,14, 30,15, 30,16, 30,17, 30,18, 31,12, 31,15, 32,12, 32,16, 33,12, 33,16, 34,13, 34,14, 34,15
  -1,-1 \TERMINATOR
 ];

I:= 0;
X:= MESS(I);   Y:= MESS(I +1);
while X >=0 do
	[IRECTANGLE(X*WIDTH/48 +DEPTH, Y*WIDTH/48, DEPTH+1, 4*2, 4*2);
	I:= I +2;
	X:= MESS(I);   Y:= MESS(I+1);
	];
end;	\MESSAGE



begin	\MAIN
SETVID($11);
RANDOMLO:= 0; RANDOMHI:= 0; RANDOM32:= 1;	\ZERO RANDOM NUMBER

\Draw the background
IRECTANGLE(0 ,0, DEPTH, WIDTH, HEIGHT);	

\Draw a floating rectangle
IRECTANGLE(WIDTH /3, HEIGHT /5, DEPTH /2, WIDTH /4, HEIGHT /4);

\Wait for a key before exiting
OPENI(0);   DUMMY:= CHIN(1);
MESSAGE;
\Wait for a key before exiting
OPENI(0);   DUMMY:= CHIN(1);
IFRAME;
FUSEDOTS;

\Wait for a key before exiting
OPENI(0);   DUMMY:= CHIN(1);
SETVID(3);
end;	\MAIN
