

\IBM PC XPL CODE SET FOR XPL V5.6I

include \CXPL\CODESI.XPL;

define MAXWIND=5;

integer ACTWIND;

integer MAXX,MAXY,ORX,ORY;

real XSCALE,YSCALE,XOFF,YOFF;

integer X,VIDMOD,C;


external RANDOM;

procedure RAND(R);
int R;return RANDOM(R);


procedure WINDOW(X1,Y1,X2,Y2);
\OPEN A WINDOW
\ X1Y1= LOWER LEFT CORNER
\ X2Y2= UPPER RIGHT CORNER
integer X1,Y1,X2,Y2;
begin
MOVE(X1,Y1);
LINE(X2,Y1,1);LINE(X2,Y2,1);
LINE(X1,Y2,1);LINE(X1,Y1,1);
MAXX(ACTWIND):=ABS(X2-X1);MAXY(ACTWIND):=ABS(Y2-Y1);
ORX(ACTWIND):=X1;ORY(ACTWIND):=Y1;
end;



procedure OPOINT(X,Y,C);
\PLACE POINT, REFERENCED TO ORIGIN
integer X,Y,C;
POINT(ORX(ACTWIND)+X,ORY(ACTWIND)-Y,C);



procedure OLINE(X,Y,C);
\DRAW LINE, REFERRENCE TO ORIGIN
integer X,Y,C;
LINE(ORX(ACTWIND)+X,ORY(ACTWIND)-Y,C);



procedure OMOVE(X,Y);
\MOVE, REFERENCED TO ORIGIN
integer X,Y;
MOVE(ORX(ACTWIND)+X,ORY(ACTWIND)-Y);



procedure RLINE(X,Y,C);
\DRAW SCALED AND OFFSET LINE
real X,Y;
integer C;
OLINE(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)),C);



procedure RPOINT(X,Y,C);
\PLACE SCALED AND OFFSET POINT
real X,Y;
integer C;
OPOINT(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)),C);



procedure RMOVE(X,Y);
\MOVE SCALED AND OFFSET
real X,Y;
OMOVE(FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND)),
	FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND)));


procedure SYMBOL(T,X,Y);
\PLACE A SYMBOL IN WINDOW
\SYMBOL TYPE IN T
real X,Y;
integer T,X1,Y1,SHAPE;
begin
SHAPE:=[
[[2,2],[2,-2],[-2,-2],[-2,2],[2,2]], \SQUARE
[[0,2],[2,0],[0,-2],[-2,0],[0,2]], \DIAMOND
[[2,2],[-2,-2],[2,-2],[-2,2],[2,2]] \X
];
if T>=3 then T:=0;

X1:=FIX((X-XOFF(ACTWIND))*XSCALE(ACTWIND));
Y1:=FIX((Y-YOFF(ACTWIND))*YSCALE(ACTWIND));
OMOVE(X1+SHAPE(T,0,0),Y1+SHAPE(T,0,1));
OLINE(X1+SHAPE(T,1,0),Y1+SHAPE(T,1,1),1);
OLINE(X1+SHAPE(T,2,0),Y1+SHAPE(T,2,1),1);
OLINE(X1+SHAPE(T,3,0),Y1+SHAPE(T,3,1),1);
OLINE(X1+SHAPE(T,4,0),Y1+SHAPE(T,4,1),1);
end;


procedure VGRID(X,R1,R2);
\DRAW VERTICAL GRID
\NUMBER OF LINES IN X
\START AND END OF SCALE IN R1 AND R2
integer X;
real R1,R2,DL;
integer O,I;
begin
XSCALE(ACTWIND):=FLOAT(MAXX(ACTWIND))/(R2-R1);
XOFF(ACTWIND):=R1;

O:=MAXX(ACTWIND)/X;
for I:=1,X do
	begin
	OMOVE(I*O,0);
	OLINE(I*O,MAXY(ACTWIND),1);
	end;


FORMAT(2,1);
DL:=(R2-R1)/FLOAT(X);
for I:=0,X do
	begin
	CURSOR((I*O+ORX(ACTWIND))/8-5,(ORY(ACTWIND)/8)+1);
	RLOUT(0,R1);
	R1:=R1+DL;
	end;
end;




procedure HGRID(Y,R1,R2);
\DRAW VERTICAL GRID
\NUMBER OF LINES IN X
\START AND END OF SCALE IN R1 AND R2
integer Y;
real R1,R2,DL;
integer O,I;
begin
YSCALE(ACTWIND):=FLOAT(MAXY(ACTWIND))/(R2-R1);
YOFF(ACTWIND):=R1;

O:=MAXY(ACTWIND)/Y;
for I:=1,Y do
	begin
	OMOVE(0,O*I);
	OLINE(MAXX(ACTWIND),O*I,1);
	end;

FORMAT(2,1);
DL:=(R2-R1)/FLOAT(Y);
for I:=0,Y do
	begin
	CURSOR((ORX(ACTWIND)/8)-5,(ORY(ACTWIND)-(O*I))/8);
	RLOUT(0,R1);
	R1:=R1+DL;
	end;
end;



procedure TEST0;
int X,Y,W,B;
begin
SETVID(3);
TEXT(0,"
=-=-=-=-=-=-=-= STRIPE TEST =-=-=-=-=-=-=-=-=
  Each stripe is one pixel wider than the
  last. Look for patterns in the stripes.");
C:=CHIN(1);

B:=0;
SETVID(VIDMOD);
for W:=2,639 do
	begin
	CURSOR(B/8,23);
	INTOUT(0,W);
	for Y:=0,175 do
	for X:=B,B+W do
		begin
		POINT(X,Y,RAND(2));
		if CHKKEY then [Y:=200;X:=640;W:=640;];
		end;
	B:=B+W;
	if B+W > 639 then
		begin	
		B:=0;
		X:=CHIN(1);
		SETVID(VIDMOD);
		end;
	end;
SETVID(3);
end;



procedure ENHANCE(X1,Y1,X2,Y2);
int X1,Y1,X2,Y2,X,Y,S,C,L;
begin
for Y:=Y1+1,Y2-1 do
for X:=X1+1,X2-1 do
	begin
	S:=READPIX(X-1,Y-1)+READPIX(X,Y-1)+READPIX(X+1,Y-1)+
	READPIX(X-1,Y)+READPIX(X,Y)+READPIX(X+1,Y)+
	READPIX(X-1,Y+1)+READPIX(X,Y+1)+READPIX(X+1,Y+1);
	if S>4 then POINT(X,Y,1) else POINT(X,Y,0);
	if CHKKEY then if CHIN(1)=$1B then return false;
	end;
return true;
end;


procedure TEST1;
real X,Y;
int I,J,S;
begin
SETVID(3);
TEXT(0,"
=-=-=-=-=-=-=-= SNOW TEST =-=-=-=-=-=-=-=-=
  Snow test. Thousands of points counted
  in upper left hand corner. Hit any key
  to enhance the pattern. Look for patterns
  in the snow.");
C:=CHIN(1);
ACTWIND:=0;
SETVID(VIDMOD);
WINDOW(50,190,630,0);
VGRID(5,0.,1.0);
HGRID(5,0.,1.0);

CURSOR(0,0);
for I:=1,200 do
	begin
	CURSOR(0,0);INTOUT(0,I);
	for J:=1,1000 do
		begin
		X:=FLOAT(RAND(10000))/10000.0;
		Y:=FLOAT(RAND(10000))/10000.0;
		RPOINT(X,Y,1);
		if CHKKEY then [I:=10000;J:=10000;];
		end;
	end;
while ENHANCE(50,0,630,190) do;
SETVID(3);
end;



procedure TEST2;
define MAX=32766,OFF=100.0;
real AVERAGE,SUM,YMIN,YMAX,N;
int R,I;
begin
SETVID(3);
TEXT(0,"
=-=-=-=-=-=-=-= AVERAGE TEST =-=-=-=-=-=-=-=-=
  Upper graph shows random points, lower
  shows median value of all points. Median
  should be half of 32k. Look for offset
  and cycles in the median.");
C:=CHIN(1);

YMIN:=FLOAT(MAX)/2.0 - OFF;
YMAX:=FLOAT(MAX)/2.0 + OFF;

OPENI(0);
SETVID(VIDMOD);

ACTWIND:=0;
WINDOW(50,100,620,5);
VGRID(2,0.,FLOAT(MAX)*2.0);
HGRID(2,0.,FLOAT(MAX));

ACTWIND:=1;
WINDOW(50,190,620,112);
HGRID(2,YMIN,YMAX);
VGRID(2,0.0,FLOAT(MAX)*2.0);

SUM:=0.0;
N:=1.0;
loop
	begin
	R:=RAND(MAX);
	SUM:=SUM+FLOAT(R);
	AVERAGE:=SUM/N;
	ACTWIND:=0;
	RPOINT(N,FLOAT(R),1);
	ACTWIND:=1;
	if AVERAGE<YMAX & AVERAGE>YMIN then RPOINT(N,AVERAGE,1);
	N:=N+1.0;
	if N> (FLOAT(MAX)*2.0) then quit;
	if CHKKEY then return;
	end;
I:=CHIN(1);
end;



procedure TEST3;
int X,Y,C;
begin
SETVID(3);
TEXT(0,"
=-=-=-=-=-=-=-= BROWNIAN MOTION =-=-=-=-=-=-=-=-=
  Dot should wander leaving no patterns. Dots are
  exclusive ORed, so any solid pattern that
  appears represents exact retrace of previous
  random series.");
C:=CHIN(1);
OPENI(0);
SETVID(VIDMOD);
X:=320;Y:=100;
loop
	begin
	POINT(X,Y,$81);
	Y:=Y+RAND(3)-1;
	X:=X+RAND(3)-1;
	if X<0 then X:=0; if Y<0 then Y:=0;
	if X>635 then X:=635; if Y>195 then Y:=195;

	if CHKKEY then return;
	end;
C:=CHIN(1);
end;





procedure CORRELATE;
\CALCULATE CORRELATION TRANSFORM
real VALUES,SUM,MAGNITUDE,MAG;
real MIN,MAX;
define SIZE=2048;
int I,J;
begin
SETVID(3);
TEXT(0,"
=-=-=-=-=-=-=-= AUTOCORRELATION =-=-=-=-=-=-=-=-=
  Upper graph shows random numbers, bottom graph
  shows autocorrelation. Except for one at the
  far left, there should be not peaks.");
C:=CHIN(1);


VALUES:=RLRES(SIZE);
MAGNITUDE:=RLRES(SIZE);
MAG:=FLOAT(SIZE)/4.0;

OPENI(0);
SETVID(VIDMOD);

ACTWIND:=0;
WINDOW(50,70,620,5);
VGRID(2,0.0,FLOAT(SIZE));
HGRID(2,-1.0,1.0);

ACTWIND:=1;
WINDOW(50,170,620,92);
VGRID(2,-10.0,FLOAT(SIZE)/2.0);
HGRID(2,-10.0,MAG);

ACTWIND:=0;
RMOVE(0.0,0.0);
for I:=0,SIZE-1 do
	begin
	VALUES(I):=FLOAT(RAND(20000))/10000.0-1.0;
	RLINE(FLOAT(I),VALUES(I),1);
	end;

MAX:=-9E100;
MIN:=9E100;
ACTWIND:=1;
RMOVE(0.0,0.0);
for I:=0,(SIZE/2)-1 do
	begin
	SUM:=0.0;
	for J:=0,SIZE-1 do SUM:=VALUES(J) * VALUES(REM( (J+I)/SIZE) ) +SUM;
	if SUM< MAG then RLINE(FLOAT(I),SUM,1) else RLINE(FLOAT(I),MAG,1);
	if SUM>MAX then if I#0 then
			begin
			MAX:=SUM;
			CURSOR(0,24);
			TEXT(0,"MAX: ");
			INTOUT(0,I);
			TEXT(0," - ");
			RLOUT(0,MAX);
			end;
	if SUM<MIN then if I#0 then
			begin
			MIN:=SUM;
			CURSOR(40,24);
			TEXT(0,"MIN: ");
			INTOUT(0,I);
			TEXT(0," - ");
			RLOUT(0,MIN);
			end;
	if CHKKEY then return;
	end;
end;



begin
MAXX:=RESERVE(MAXWIND*2);
MAXY:=RESERVE(MAXWIND*2);
ORX:=RESERVE(MAXWIND*2);
ORY:=RESERVE(MAXWIND*2);

XSCALE:=RLRES(MAXWIND);
YSCALE:=RLRES(MAXWIND);
XOFF:=RLRES(MAXWIND);
YOFF:=RLRES(MAXWIND);
VIDMOD:=6;

loop [TEST0;if CHIN(1)=$1B then quit;];
loop [TEST1;if CHIN(1)=$1B then quit;];
loop [TEST2;if CHIN(1)=$1B then quit;];
loop [TEST3;if CHIN(1)=$1B then quit;];
loop [CORRELATE;if CHIN(1)=$1B then quit;];

SETVID(3);
end;
