\RGB.XPL	DEC-07-99

inc	\CXPL\CODESI;
seg char Buf(1);
int	J, R, G, B;
real	T;

def	ColorBase = 255-6*6*6;

def	Black, Blue, Green, Cyan, Red, Magenta, Brown, White,	\Attribute colors
	Gray, LBlue, LGreen, LCyan, LRed, LMagenta, Yellow, BWhite; \ EGA palette



func real Rad(X);	\Convert degrees to radians
real	X;
return X /57.2957795130823;



proc	WaitVB;		 \Wait for beginning of next vertical blank
int	SR;
begin
SR:= Peek($40, $63) + $306;	\Port address of status register
if (SR & $39A) # $39A then return;
while Pin(SR, 0) & $08 do;	\Wait for no vertical blank
repeat until Pin(SR, 0) & $08;	\Wait for vertical blank
end;	\WaitVB;



proc	DoIt;
int	C, D, J, JJ, P;
int	R, G, B, Color;
real	Amp;
begin
\BACKGROUND

\WAVEFORM

for C:= 0, 2 do
	begin
	Amp:= Sin(T + Rad(Float(120*C)));

	P:= (Fix(30.0*Amp)+100)*320 + 200;

	\ C R G B
	\ 0 5 0 0
	\ 1 0 5 0
	\ 2 0 0 5

	for D:= -40, 40 do
		begin
		R:= -5 * (C=0);
		G:= -5 * (C=1);
		B:= -5 * (C=2);
		if R then R:= R - Abs(D/8);
		if G then G:= G - Abs(D/8);
		if B then B:= B - Abs(D/8);

		Color:= R*36 + G*6 + B;			\ + ColorBase;

		Buf(0, P+D*320):= Buf(0, P+D*320) + Color;
		end;
	end;
T:= T + 0.02;

\Move buf left one pixel
Blit(Buf(0), 1, Buf(0), 0, $FFFE);

\Clear last column
JJ:= 319;
for J:= 0, 199 do
	begin
	Buf(0, JJ):= ColorBase;
	JJ:= JJ + 320;
	end;

Blit(Buf(0), 0, $A000, 0, $FFFE);
WaitVB;
end;	\DoIt



proc	ShowColors;	\Show the color registers
int	X, Y, C;
begin
C:= 0;
for Y:= 0, 15 do
	begin
	for X:= 0, 15 do
		begin
		Attrib(C);
		Chout(6, $DB);
		Chout(6, $DB);
		C:= C + 1;
		end;
	Crlf(6);
	end;

\wait for keystroke
if Chin(1) then;


Chout(0, $C);
C:= ColorBase;
for Y:= 0, 18-1 do
	begin
	for X:= 0, 12-1 do
		begin
		Attrib(C);
		Chout(6, $DB);
		Chout(6, $DB);
		C:= C + 1;
		end;
	Crlf(6);
	end;

\wait for keystroke
if Chin(1) then;
end;	\ShowColors



begin	\Main
Buf(0):= Malloc($1000);			\64K
J:= 0;
repeat Buf(0, J):= ColorBase;   J:= J + 1 until J = 0;

Setvid($13);	\Set 320x200x256 colors and blank screen

\Set up color registers
Pout(ColorBase, $3C8, 0);
for R:= 0, 5 do
    for G:= 0, 5 do
	for B:= 0, 5 do
		begin
		Pout(R*7 + (if R>0 then 18 else 0), $3C9, 0);
		Pout(G*6 + (if G>0 then 12 else 0), $3C9, 0);
		Pout(B*8 + (if B>0 then 23 else 0), $3C9, 0);
		end;
\color = R*36 + G*6 + B + ColorBase
\where R,G,B vary between 0 and 5

\ShowColors;


T:= 0.0;
repeat DoIt until Chkkey;

if Chin(1) then;
Setvid($03);
end;	\Main
