\RPN.XPL
\RECURSIVE RPN EXPRESSION EVALUATOR

code RESERVE=3, INCHAR=7, OUTCHAR=8, CRLF=9, TEXT=12;

integer L, R, ATOM, LEVEL, EOL;
address LINE, RESULT;

procedure READ (STRING);	\inputs a line from keyboard
address STRING;				\into STRING.
integer P,CH;
begin P:=0;
CH:=INCHAR (0);
while CH # 13 \car. return\ do
	begin STRING(P):=CH;
	P:=P+1;
	CH:=INCHAR (0);
	end;
STRING(P):=EOL;
end;

procedure PRINT (CHAR);		\prints single character.
integer CHAR;
[OUTCHAR (0,CHAR)];

procedure WRITE (STRING);	\types string.
address STRING;
[TEXT (0,STRING)];

procedure WRITELN (STRING);	\types string followed by
address STRING;				\carriage return line feed.
begin TEXT (0,STRING);
CRLF (0);
end;

procedure NEXTATOM;		\gets next atom into ATOM
integer CHAR;			\ignoring spaces.
begin
CHAR:=LINE(L);L:=L+1;
while CHAR=^ \space\  do
	[CHAR:=LINE(L);L:=L+1];
ATOM:=CHAR;
end;

procedure OUTPUT (CHAR);	\puts character followed by
integer CHAR;				\space into RESULT
begin
RESULT(R):=CHAR;
RESULT(R+1):=^ ;	\space
R:=R+2;				\point to next unused byte
RESULT(R):=EOL;		\flag end of line
end;

procedure DISPLAY (INOUT,MESSAGE);
integer INOUT;
addr MESSAGE;
integer I;
begin 
if INOUT>0 then
		begin for I:=1, LEVEL do WRITE ("::>");
		LEVEL:=LEVEL+1;
		end
else	begin LEVEL:=LEVEL-1;
		for I:=1, LEVEL do WRITE ("::<");
		end;

PRINT(^ ); WRITE (MESSAGE); WRITE ("	ATOM IS ");
PRINT (^"); PRINT (ATOM); PRINT (^");
WRITE ("	RESULT IS "); WRITELN (RESULT);
for I:=1,200 do ;
end;

procedure EXPRESSION;
integer ADDOP;

procedure TERM;
integer MULTOP;

procedure FACTOR;
begin
DISPLAY (1,"Enter factor	");
if ATOM=^( then 
	begin NEXTATOM;
	EXPRESSION;
	end
else OUTPUT (ATOM);
NEXTATOM;
DISPLAY (-1,"Leave factor	");
end;

begin	\of term
DISPLAY (1,"Enter term		");
FACTOR;
while ATOM=^* ! ATOM=^/ do
	begin MULTOP:=ATOM;
	NEXTATOM; FACTOR;
	OUTPUT (MULTOP);
	end;
DISPLAY (-1,"Leave term		");
end;
                                                                
begin	\of expression
DISPLAY (1,"Enter expression	");
TERM;
while ATOM=^+ ! ATOM=^- do
	begin ADDOP:=ATOM;
	NEXTATOM; TERM;
	OUTPUT (ADDOP);
	end;
DISPLAY (-1,"Leave expression	");
end;

begin				\MAIN PROGRAM
EOL:=160;			\define end of line flag
LINE:=RESERVE (80);
RESULT:=RESERVE (80);
L:=0; R:=0;			\set pointers to start of LINE and RESULT
RESULT(0):=EOL;		\indicate result is empty
LEVEL:=0;			\used by DISPLAY

WRITE ("Please type expression. ");
READ (LINE); WRITELN (LINE);
NEXTATOM; EXPRESSION;
WRITE ("RPN equivalent is "); WRITELN (RESULT);
end;


