\SAND.XPL	MAY-03-94
\Spilling sand simulation

inc	\cxpl\codesi;

def	SandSize = 2000;	\Number of grains of sand
def	YMax = 200-1;		\Bottom line on screen
def	Intsize = 2;		\Number of bytes in an integer
int	SandX, SandY, SandC,	\Arrays: sand coordinates and color
	Mode,			\Video mode to be restored upon exit
	Cpureg,			\Address of CPU registers for BIOS calls
	I, J, X, Y;		\Scratch
seg addr Screen;		\For fast access to mode $13 screen


func	GetVid;			\Returns the current video mode
begin
Cpureg(0):= $0f00;		\Function $0f
Softint($10);			\Call BIOS routine
return Cpureg(0) & $ff;
end;	\GetVid


proc	WaitVB;			 \Wait for beginning of next vertical blank
begin				 \WARNING: even $3ba might not work for monochrome
while Pin($3da, 0) & $08 do;	 \Wait for no vertical blank
repeat until Pin($3da, 0) & $08; \Wait for vertical blank
end;	\WaitVB;


begin	\Main
Cpureg:= Getreg;
Mode:= Getvid;
Setvid($13);

SandX:= Reserve(SandSize*Intsize);
SandY:= Reserve(SandSize*Intsize);
SandC:= Reserve(SandSize*Intsize);
Screen:= Reserve(Intsize);
Screen(0):= $A000;

for I:= 0, SandSize-1 do		\Generate sand
	begin
	if I & 1 then
		[SandX(I):= 160;   SandY(I):= 1;   SandC(I):= 6]	\brown
	else	[SandX(I):= 173;   SandY(I):= 20;  SandC(I):= $e];	\yellow
	end;

Move(155, 40);   Line(180, 55, 1);	\Some interesting obstacles

Move(150, 70);   Line(170, 90, 1);
Move(150, 71);   Line(170, 91, 1);

Move(192, 70);   Line(172, 90, 1);
Move(192, 71);   Line(172, 91, 1);

loop begin
for I:= 0, SandSize-1 do
	begin
	X:= SandX(I);   Y:= SandY(I);		\Get initial position of grain
	if Y < YMax then			\It's not on the bottom
		begin
		if Screen(0, X+(Y+1)*320) = 0 then	\It's above empty loc
			SandY(I):= Y+1
		else	begin			\Can't fall straight down so
			J:= Ran(2);		\ randomly pick right or left
			if J = 0 then J:= -1;
			if Screen(0, X+J+(Y+1)*320) = 0 then
				[SandX(I):= X+J;   SandY(I):= Y+1];
			end;
		Screen(0, X+Y*320):= 0;		\Erase initial position
		Screen(0, SandX(I)+SandY(I)*320):= SandC(I);	\Draw in new posn
		end;
	end;	\for
WaitVB;
if CHKKEY then quit;
end;	\loop

Setvid(Mode);
end;	\Main
