\SC.XPL
\Display spherical coordinate systems

inc	\CXPL\CODESI;

int	Lat,	\Latitude
	YY,	\Vertical displacement of center of minor circle
	RR;	\Radius of minor circle
real	Tilt,	\Tilt about X axis
	R0;	\Radius of sphere (and great circle)


def	X0=800/2, Y0=600/2;
def	Black, Blue, Green, Cyan, Red, Magenta, Brown, White,	\Attribute colors
	Gray, LBlue, LGreen, LCyan, LRed, LMagenta, Yellow, BWhite; \ EGA palette



func real Rad(X);	\CONVERT FROM DEGREES TO RADIANS
real	X;
return X / 57.29577951;



proc	DrawCir(X, Y, R, T, C);
int	X, Y,	\center
	R,	\radius
	T,	\tilt about X axis (degrees)
	C;	\color
real	S,	\step
	R1, T1;
int	X1, Y1;	\coords
begin
S:= 0.0;
R1:= Float(R);
T1:= Cos(Rad(Float(T)));

X1:= Fix(R1 * Cos(Rad(S)));
Y1:= Fix( (R1 * Sin(Rad(S)) * T1));
Move(X0+X+X1, Y0-(Y+Y1));
loop	begin
	X1:= Fix(R1 * Cos(Rad(S)));
	Y1:= Fix( (R1 * Sin(Rad(S)) * T1));
	Line(X0+X+X1, Y0-(Y+Y1), C);
	S:= S + 1.0;
	if S >= 360.0 then quit;
	end;
end;	\DrawCir



begin	\Main
Setvid($6A);

R0:= 300.0;
Tilt:= 13.0;
Lat:= 0;
loop	begin
	YY:= Fix( R0 * Sin(Rad(Float(Lat))) * Cos(Rad(Tilt)) );
	RR:= Fix( R0 * Cos(Rad(Float(Lat))) );
	DrawCir(0, YY, RR, 90-Fix(Tilt), LBlue);

	Lat:= Lat + 10;
	if Lat >= +90 then quit;
	end;
if Chin(1) then;

Tilt:= Tilt - 35.2 + 90.0;
Lat:= 0;
loop	begin
	YY:= Fix( R0 * Sin(Rad(Float(Lat))) * Cos(Rad(Tilt)) );
	RR:= Fix( R0 * Cos(Rad(Float(Lat))) );
	DrawCir(0, YY, RR, 90-Fix(Tilt), LRed);

	Lat:= Lat + 10;
	if Lat >= +90 then quit;
	end;
if Chin(1) then;

Tilt:= Tilt + 90.0;
Lat:= -50;
loop	begin
	YY:= Fix( R0 * Sin(Rad(Float(Lat))) * Cos(Rad(Tilt)) );
	RR:= Fix( R0 * Cos(Rad(Float(Lat))) );
	DrawCir(0, YY, RR, 90-Fix(Tilt), Green);

	Lat:= Lat + 10;
	if Lat >= +90 then quit;
	end;
if Chin(1) then;

Setvid($03);
end;	\Main
