\SERTEST.XPL
\Simple Terminal Simulator

include C:\CXPL\CODESI.XPL;


char
	STRING;		\STRING FOR TESTING PURPOSES


integer 
	T,		\GLOBAL TEMPORARY

	COM,		\CURRENT COMMUNICATION CHANNEL
	BASE,		\BASE PORT ADDRESS OF SERIAL PORT
	DATA,		\SERIAL PORT DATA REGISTER
	STATUS,		\SERIAL PORT STATUS REGISTER
	MCONTROL,	\SERIAL PORT MODEM CONTROL REGISTER
	LCONTROL,	\SERIAL PORT LINE CONTROL REGISTER

	CPUREG;		\CPU REGISTER FOR DOS CALLS


procedure SINITIAL;
\INITIALIZE SERIAL PORT
integer TEMP;
begin
\SET TO 9600 BAUD 8N1
CPUREG(0):=$00E3;;
CPUREG(3):=COM;
SOFTINT($14);

\SET PORT BASE ADDRESS
case COM of
	0: BASE:=$3F8;
	1: BASE:=$2F8
else;
DATA:=BASE;
STATUS:=BASE+5;
MCONTROL:=BASE+4;
LCONTROL:=BASE+3;

\SELECT PRIMARY REGISTER SET
TEMP:=PIN(LCONTROL,0) & $7F;
POUT(TEMP,LCONTROL,0);
\TURN ON RTS AND DTR
POUT($03,MCONTROL,0);
end;


procedure SEROUT(CHAR);
\WRITE ONE SERIAL CHARACTER
integer CHAR;
begin
repeat until (PIN(STATUS,0) & $20) # 0;
POUT(CHAR,DATA,0);
end;



procedure SERTEST;
\TEST FOR SERIAL CHARACTER WAITING
return (PIN(STATUS,0) & 1) # 0;



procedure SERIN;
\READ ONE CHARACTER FROM PORT
begin
repeat until (PIN(STATUS,0) & 1) # 0;
return PIN(DATA,0) & $7F;
end;




procedure GETSSTR(S,L);
\READ SERIAL STRING INTO S, OF L CHARACTERS IN LENGTH
char S;
integer L,P;
begin
for P:=0,L-1 do
	begin
	repeat until (PIN(STATUS,0) & 1) # 0;
	S(P):= PIN(DATA,0) & $7F;
	end;
end;


begin
CPUREG:=GETREG;
STRING:=RESERVE(20);

COM:=0;			\SELECT COM1

SINITIAL;

TEXT(0,"SEND AND RECEIVE FROM SERIAL PORT");CRLF(0);
TEXT(0,"   ESC TO QUIT ");CRLF(0);CRLF(0);

loop
	begin
	if SERTEST then [T:=SERIN;CHOUT(0,T);];
	if CHKKEY then 
		begin
		T:=CHIN(1);
		if T=$1B then quit;
		SEROUT(T);
		end;
	end;
end;
