	page	59,130
;SHOWIMAG.ASM	NOV-29-95
;Loren Blaney

cseg	segment dword public 'code'
	assume cs:cseg

	public	ShowImage
	.386

;-------------------------------------------------------------------------------
;External XPL routine to quickly display an image that is being rotated about a
; vertical axis through its center.
; ShowImage(ImageData, K);
;
ShowImage:
	mov	bp,sp		;get arguments
	mov	ax,[bp+6]	;get ImageData
	mov	bp,[bp+4]	;get K
	movsx	ebp,bp

	push	ds		;save critical registers
	push	es

	mov	ds,ax		;point data segment to ImageData
	mov	ax,0a000h	;point extra segment to video memory
	mov	es,ax

;Register usage:
; ax  = Colors for two pixels
; bx  = Y * 320
; cx  = X (decrementing)
; edx = Accumulator for K's
; si  = Index into DataImage
; di  = Video memory pointer
; ebp = K, 4096/Cos(Ang), amount to move along image for each pixel of screen
; ds  = Segment address of start of DataImage
; es  = Segment address of Video Memory (A000h)

	imul	eax,ebp,-160	;eax:= K * -160
	add	eax,160*4096	; + 160 << 12
	mov	dword ptr cs:show07-4,eax	;self-modifying code
	jmp short $+2		;flush instruction pipeline

	cld			;for stosw instruction below
	xor	di,di		;start in upper-left corner of screen
	xor	bx,bx		;for Y:= 0, 200-1 do
show05:	mov	edx,12345678h	;self-modified code
show07:
	mov	cx,320/4	;for X:= 0, 320-1 do
	align	4		;speed-critical loop
show10:	xor	ax,ax		;Color:= 0;

	add	edx,ebp
	shld	esi,edx,20
	cmp	si,320
	jae short show30
	mov	al,[bx+si]	;Color:= ImageData(0,Y*320+C2);
show30:
	add	edx,ebp
	shld	esi,edx,20
	cmp	si,320
	jae short show40
	mov	ah,[bx+si]	;Color:= ImageData(0,Y*320+C2);
show40:	stosw			;es:di++ := ax   Screen(0,I):= Color;   I:= I +1

	xor	ax,ax		;Color:= 0;

	add	edx,ebp
	shld	esi,edx,20
	cmp	si,320
	jae short show130
	mov	al,[bx+si]	;Color:= ImageData(0,Y*320+C2);
show130:
	add	edx,ebp
	shld	esi,edx,20
	cmp	si,320
	jae short show140
	mov	ah,[bx+si]	;Color:= ImageData(0,Y*320+C2);
show140:stosw			;es:di++ := ax   Screen(0,I):= Color;   I:= I +1

	dec	cx		;next X
	jne short show10

	add	bx,320		;next Y
	cmp	bx,320*200
	jb short show05

	pop	es		;restore registers
	pop	ds
	retf	4		;drop 2 args

cseg	ends
	end
