\SHOWPCX.XPL	JUN-03-95
\Display a 320x200x256 .PCX file
\By Loren Blaney

\REVISIONS
\FEB-19-95: Original.
\JUN-03-95: Declared arrays.

inc	\CXPL\STDDEF.XPL;

int	DataSeg,	\Our data segment address
	OrigVidMode;	\Original video mode (to be restored)
char	Palette(256*3);	\256 color registers each color is 3 bytes (RGB)

\----------------------------------------------------------------------

proc	LoadImage(SegAddr);
\Read in a 320x200x256 .PCX file, decompress it, & put it into memory at SegAddr
int	SegAddr;\Segment address of location to put image (can be $a000)
seg char Image(1);
int	I, J,	\Index into Image
	Byte,	\Byte read from PCX file
	Cnt;	\Number of bytes to repeat
begin
Image(0):= SegAddr;
for I:= 0, 128-1 do J:= Chin(3);	\Skip header
J:= 0;
repeat	Byte:= Chin(3);			\Get byte from .PCX file
	if Byte < $C0 then
		begin
		Image(0,J):= Byte;
		J:= J +1;
		end
	else	begin			\Decompress multiple copies
		Cnt:= Byte & $3F;
		Byte:= Chin(3);
		for I:= 1, Cnt do
			begin
			Image(0,J):= Byte;
			J:= J +1;
			end;
		end;
until J = 320 *200;
end;	\LoadImage

\----------------------------------------------------------------------

proc	LoadPalette(Pal);
char	Pal;
int	I;
begin
I:= Chin(3);				\Skip $0C, start of pallette byte
for I:= 0, 256*3-1 do
	Pal(I):= Chin(3) >> 2;
end;	\LoadPalette

\----------------------------------------------------------------------

proc	DosOpen; \Open input file (with extension) specified on command line
int	Handle;				\File handle
char	CmdTail($80);			\Copy of command tail
begin
Blit(CpuReg(11), $81, DataSeg, CmdTail, $7F);	\Get copy of command tail

Handle:= Fopen(CmdTail, 0);		\Open file name for input
Fset(Handle, ^I);
Openi(3);
end;	\DosOpen

\======================================================================

begin	\Main
Cpureg:= Getreg;
DataSeg:= Cpureg(12);
DosOpen;		\Open .PCX file specified on command line

OrigVidMode:= GetVid;
SetVid($13);

LoadImage($A000);	\Load .PCX image directly onto video screen
LoadPalette(Palette);

\Set block of 256 color registers starting with register 0
CallInt($10, $1012, 0, 256, Palette, 0, 0, DataSeg);

WaitKey;

SetVid(OrigVidMode);
end;	\Main
