\SMALLADC.XPL
\READ TEMPERATURES WITH SEC BOARD


'CODE'	\COMPLETE SET, STANDARD XPLV5D INTRINSICS
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENIN=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;

'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;


'REAL'
	RES0,
	RES50,
	RATIO,
	BETA,
	RES;


'REAL' FAREN,CENT,KELVIN,VOLTS,DIVIDER,BVOLTS;



'ADDRESS'
	BOARD;	\MEMORY ADDRESS OF BOARD


'DEF'
	FF=$C;	\FORM FEED

'DEF'	ZERO=273.15;	\ABSOLUTE ZERO C


'INTEGER'
	CHAR,		\GLOBAL CHARACTER
	SLOT;		\CURRENT SLOT NUMBER


'PROCEDURE' CHECK;
'ADDRESS' KEY;
'BEGIN'
KEY:=$C000;
'RETURN' KEY(0)>$7F
'END';


'PROCEDURE' VALUES;
'BEGIN'
TEXT(0,"CHANGE PARAMETERS? ");
OPENIN(0);
'IF' CHIN(0)=^Y 'THEN'
	'BEGIN'
	TEXT(0,"ENTER RESISTANCE AT 0 C ");
	RES0:=RLIN(0);
	TEXT(0,"ENTER RESISTANCE AT 50 C ");
	RES50:=RLIN(0);
	RATIO:=RES0/RES50;
	BETA:=1./(1./ZERO-(1./(ZERO+50.)))*LN(RATIO);
	TEXT(0,"RATIO= ");
	RLOUT(0,RATIO);
	CRLF(0);
	TEXT(0,"BETA= ");
	RLOUT(0,BETA);
	CRLF(0);CRLF(0);
	TEXT(0,"ENTER DIVIDER RESISTOR ");
	DIVIDER:=RLIN(0);
	TEXT(0,"ENTER BASE VOLTAGE ");
	BVOLTS:=RLIN(0);
	'END'
'ELSE'
	'BEGIN'
	RES0:=9.4980E4;
	RES50:=10970.;
	BETA:=3810.5515;
	RATIO:=8.65816;
	DIVIDER:=20000.;
	BVOLTS:=4.9;
	'END';
'END';




'PROCEDURE' GETC;
CHAR:=CHIN(0);




'PROCEDURE' GETSLOT;	\READ SLOT NUMBER
'BEGIN'
TEXT(0,"ENTER SLOT NUMBER ");
SLOT:=INTIN(0);
'IF' SLOT<1 ! SLOT>7 'THEN'
	'BEGIN'
	TEXT(0,"INVALID SLOT NUMBER");
	CRLF(0);
	GETSLOT;
	'END';
BOARD:=(SLOT*16)+$C080;	\CONVERT TO BOARD ADDRESS
'END';




'PROCEDURE' READADC(CHAN);
'INTEGER' CHAN,DUMMY;
'BEGIN'
BOARD(CHAN):=DUMMY;
'RETURN' BOARD(CHAN);
'END';





'PROCEDURE' CONVERT(COUNT);
'INTEGER' COUNT;
'BEGIN'
'IF' COUNT=0 'THEN'
	'BEGIN'
	VOLTS:=1.;
	RES:=1.;
	CENT:=1.;
	KELVIN:=1.;
	FAREN:=1.;
	'RETURN'
	'END';	
VOLTS:=FLOAT(COUNT)*(BVOLTS/256.0);
RES:=(DIVIDER*(BVOLTS-VOLTS))/VOLTS;
KELVIN:=-1.*(1./((LN(RES0/RES)/BETA)-.00366032));
CENT:=KELVIN-ZERO;
FAREN:=(1.8*CENT)+32.0;
'END';



'PROCEDURE' FILTER;
'INTEGER' CHAN;
'REAL' OUT,W,NOW;
'BEGIN'
TEXT(0,"WEIGHT FACTOR");
W:=RLIN(0);
VALUES;
OUT:=RLRES(16);
'FOR' CHAN:=0,7 'DO' OUT(CHAN):=FLOAT(READADC(CHAN));

CHOUT(0,FF);
'FOR' CHAN:=0,7 'DO'
	'BEGIN'
	CURSOR(0,CHAN+2);
	TEXT(0,"CHANNEL: ");
	INTOUT(0,CHAN);
	'END';

OPENIN(0);
FORMAT(5,0);
'LOOP'
	'BEGIN'
	'FOR' CHAN:=0,7 'DO'
		'BEGIN'
		NOW:=FLOAT(READADC(CHAN));
		OUT(CHAN):=((OUT(CHAN)*W)+NOW)/(W+1.);
		CONVERT(FIX(OUT(CHAN)));
		CURSOR(15,CHAN+2);
		RLOUT(0,FAREN);
		'END';
	'IF' CHECK 'THEN' 'QUIT';
	'END';
'END';




'BEGIN'	\MAIN
GETSLOT;
'LOOP'
	'BEGIN'
	CHOUT(0,FF);
	FILTER;
	'END';
'END';
