\SNAKE.XPL	JAN-18-93
\Converted from a Pascal program

\Pascal needs to use ASCII better. This can be simplified by PLAYERTHING
\ = PLAYERCHAR.
\XPL needs to have records.
\The Pascal manual needs to explain what happens when you assign records.

inc	C:\CXPL\CODESI;

def	PLAYERCHAR    = ^I,
	SNAKECHAR     = ^S,
	MONEYCHAR     = ^$,
	DOORCHAR      = ^#,

	UPCOMMAND     = $0B,
	DOWNCOMMAND   = $0A,
	LEFTCOMMAND   = $08,
	RIGHTCOMMAND  = $15,

	SNAKELENGTH   =  5,	\Beware: Longer can cause PLACENEARBY to hang
	HEIGHT        = 23,	\= Actual height -1
	WIDTH         = 39,	\= Actual width -1
	CLEARSCREEN   = $0C,	\Form feed
	MONEYWORTH    = 25;

def	X=0, Y=1;	\XPL kludge to deal with coordinate records
			\(Could also use names like PLAYER_X, PLAYER_Y, etc.)
def	INTSIZE=2;	\Number of bytes in an integer

def \THING\ PLAYERTHING, SNAKETHING, MONEYTHING, DOORTHING, EMPTYTHING, SCORETHING;

int	SNAKE,		\Array(1..SNAKELENGTH) of coordinate

	PLAYER, MONEY, DOOR,	\Coordinate
	SCORE,
	LEFT,		\Boolean: Player has left through the door
	EATEN,		\Boolean: Player is eaten by snake

	SCREEN,		\Array(0..WIDTH, 0..HEIGHT) of THING

	LOOKSLIKE,	\Array(THING) of char (holds char that represents a thing)
	II;		\Scratch for MAIN



proc	SHOWCUR(FLAG);
int	FLAG;		\True = cursor on; False = cursor off
int	REG;		\Pointer to array of processor registers
begin
REG:= GETREG;
REG(0):= 0;		\Function $00
REG(0):= $0100;
REG(2):= if FLAG then $0607 else $2000;
SOFTINT($10);		\Call BIOS routine
end;	\SHOWCUR



func	GETKEY;		\Get character from keyboard
int	REG, CH;	\This is a low-level routine with no echo,
begin			\ no ctrl-C, and no cursor.
REG:= GETREG;
REG(0):= 0;		\Function $00
SOFTINT($16);		\Call BIOS routine
CH:= REG(0) & $FF;
if CH = 0 then
	begin			\Handle special keys
	case REG(0)>>8 of	\Arrows:
	  72:	CH:= $0B;	\ up
	  80:	CH:= $0A;	\ down
	  75:	CH:= $08;	\ left
	  77:	CH:= $15	\ right
	other	CH:= -(REG(0)>>8);
	end;
return CH;
end;	\GETKEY



function RAND(MIN, MAX);	\Returns a random integer between MIN and MAX
int	MIN, MAX;
begin
return MIN + RAN(MAX-MIN+1);
end;	\RAND



procedure INSTRUCTIONS;
int	ANSWER;
begin
TEXT(0, "Do you want instructions? ");
OPENI(0);
ANSWER:= CHIN(0);
while ANSWER#^y & ANSWER#^n & ANSWER#^Y & ANSWER#^N do
	begin
	TEXT(0, "Please enter ^"Yes^" or ^"No^".
");
	OPENI(0);
	ANSWER:= CHIN(0);
	end;
if ANSWER=^y ! ANSWER=^Y then
	begin
	TEXT(0,"
The object of SNAKE is to get as much money to the door as possible.
The snake tries to prevent you. As you get more money, he tries more
and more successfully. Use the arrow keys to move up, down, left and
right. You cannot move diagonally although the snake can.

Hit Enter to start.");

	OPENI(0);
	ANSWER:= CHIN(0);
	end;
end;	\INSTRUCTIONS



procedure INITIALIZE;	\Sets up all the variables
int	I, J;
begin
INSTRUCTIONS;
for I:= 0, WIDTH do
    for J:= 0, HEIGHT do
	SCREEN(I, J):= EMPTYTHING;
I:= RAN(0);
LOOKSLIKE(SNAKETHING):= SNAKECHAR;
LOOKSLIKE(PLAYERTHING):= PLAYERCHAR;
LOOKSLIKE(MONEYTHING):= MONEYCHAR;
LOOKSLIKE(EMPTYTHING):= ^ ;
LOOKSLIKE(DOORTHING):= DOORCHAR;
LEFT:= false;
EATEN:= false;
SCORE:= 0;
for I:= 0, 10 do		\SPACE ON SCREEN FOR DISPLAYING SCORE
	SCREEN(I, 0):= SCORETHING;
CHOUT(0, CLEARSCREEN);
end;	\INITIALIZE



function FREESPOT(POS);	\Returns true if the position is valid and empty
int	POS;	\Coordinate
begin
if POS(X)>=0 & POS(X)<=WIDTH & POS(Y)>=0 & POS(Y)<=HEIGHT then
	return SCREEN(POS(X), POS(Y)) = EMPTYTHING
else	return false;
end;	\FREESPOT



procedure MAKESPACE(NEWPOS, FORWHAT);	\Assigns an unused position for a thing
int	NEWPOS,		\Coordinate
	FORWHAT;	\Thing
begin
repeat	NEWPOS(X):= RAND(0, WIDTH-1);
	NEWPOS(Y):= RAND(0, HEIGHT-1);
until FREESPOT(NEWPOS);
CURSOR(NEWPOS(X), NEWPOS(Y));
CHOUT(0, LOOKSLIKE(FORWHAT));
SCREEN(NEWPOS(X), NEWPOS(Y)):= FORWHAT;
end;	\MAKESPACE



procedure PLACENEARBY(NEAR, COORD);
\This finds a free coordinate (NEAR) adjacent to COORD and places the snake 
\ there. Can also be on top of the player.
int	NEAR, COORD;	\Coordinates
int	DELTAX, DELTAY;
begin
repeat	repeat	DELTAX:= RAND(-1, 1);
		DELTAY:= RAND(-1, 1);
	until DELTAX#0 ! DELTAY#0;

	NEAR(X):= COORD(X) + DELTAX;
	NEAR(Y):= COORD(Y) + DELTAY;
until FREESPOT(NEAR)  !  NEAR(X)=PLAYER(X) & NEAR(Y)=PLAYER(Y);

CURSOR(NEAR(X), NEAR(Y));
SCREEN(NEAR(X), NEAR(Y)):= SNAKETHING;
CHOUT(0, LOOKSLIKE(SNAKETHING));
end;	\PLACENEARBY



procedure REMOVE(POS);
\Removes whatever is at the coordinates from the terminal screen and the
\ array screen.
int	POS;	\Coordinate
begin
CURSOR(POS(X), POS(Y));
CHOUT(0, ^ );
SCREEN(POS(X), POS(Y)):= EMPTYTHING;
end;	\REMOVE



procedure TAKEMONEY;
begin
SCORE:= SCORE + MONEYWORTH;

CURSOR(0, 0);
CHOUT(0, ^$);   INTOUT(0, SCORE);

SCREEN(MONEY(X), MONEY(Y)):= EMPTYTHING;
MAKESPACE(MONEY, MONEYTHING);
end;	\TAKEMONEY



procedure PLACEOBJECTS;
\Position all of the items in the game making sure that none overlap
int	SNAKEBODY;
begin
MAKESPACE(SNAKE(1), SNAKETHING);
for SNAKEBODY:= 2, SNAKELENGTH do
	PLACENEARBY(SNAKE(SNAKEBODY), SNAKE(SNAKEBODY-1));
MAKESPACE(PLAYER, PLAYERTHING);
MAKESPACE(MONEY, MONEYTHING);
MAKESPACE(DOOR, DOORTHING);
end;	\PLACEOBJECTS



procedure PLAYERMOVE;	\Get player's move from keyboard
int	COMMAND,	\Char
	OLDPOS;		\Coordinate
begin
OLDPOS:= RESERVE(2*INTSIZE);
OLDPOS(X):= PLAYER(X);   OLDPOS(Y):= PLAYER(Y);

COMMAND:= GETKEY;
case COMMAND of
  UPCOMMAND:	if PLAYER(Y) > 0 then PLAYER(Y):= PLAYER(Y) - 1;
  DOWNCOMMAND:	if PLAYER(Y) < HEIGHT then PLAYER(Y):= PLAYER(Y) + 1;
  LEFTCOMMAND:	if PLAYER(X) > 0 then PLAYER(X):= PLAYER(X) - 1;
  RIGHTCOMMAND:	if PLAYER(X) < WIDTH then PLAYER(X):= PLAYER(X) + 1
other;

if SCREEN(PLAYER(X), PLAYER(Y)) = SCORETHING then	\BOUNCE OFF SCORE
	[PLAYER(X):= OLDPOS(X);   PLAYER(Y):= OLDPOS(Y)]
else	begin
	REMOVE(OLDPOS);
	if PLAYER(X)=MONEY(X) & PLAYER(Y)=MONEY(Y) then
		TAKEMONEY
	else if PLAYER(X)=DOOR(X) & PLAYER(Y)=DOOR(Y) then
		LEFT:= true;

	CURSOR(PLAYER(X), PLAYER(Y));
	CHOUT(0, PLAYERCHAR);
	SCREEN(PLAYER(X), PLAYER(Y)):= PLAYERTHING;
	end;
end;	\PLAYERMOVE




function SIGN(I);
\Used by SNAKEMOVE to determine the direction toward the player
int	I;
begin
if I = 0 then return 0
else if I > 0 then return 1
else return -1;
end;	\SIGN




procedure SNAKEMOVE;
\Snake moves randomly at first, then it goes more directly toward player
int	NEWPOS,		\Coordinate
	BODYPART;
begin
NEWPOS:= RESERVE(2*INTSIZE);

if RAND(0, SCORE) <= 100 then
	PLACENEARBY(NEWPOS, SNAKE(1))
else	begin
	NEWPOS(X):= SNAKE(1,X) + SIGN(PLAYER(X)-SNAKE(1,X));
	NEWPOS(Y):= SNAKE(1,Y) + SIGN(PLAYER(Y)-SNAKE(1,Y));
	if SCREEN(NEWPOS(X),NEWPOS(Y))=EMPTYTHING !
	    NEWPOS(X)=PLAYER(X) & NEWPOS(Y)=PLAYER(Y) then
		begin
		CURSOR(NEWPOS(X), NEWPOS(Y));
		CHOUT(0, SNAKECHAR);
		SCREEN(NEWPOS(X), NEWPOS(Y)):= SNAKETHING;
		end
	else	PLACENEARBY(NEWPOS, SNAKE(1));
	end;
REMOVE(SNAKE(SNAKELENGTH));
if NEWPOS(X)=PLAYER(X) & NEWPOS(Y)=PLAYER(Y) then
	EATEN:= true;
for BODYPART:= -SNAKELENGTH, -2 do
	begin
	SNAKE(-BODYPART,X):= SNAKE(-BODYPART-1,X);
	SNAKE(-BODYPART,Y):= SNAKE(-BODYPART-1,Y);
	if SNAKE(-BODYPART,X)=PLAYER(X) & SNAKE(-BODYPART,Y)=PLAYER(Y) then
		EATEN:= true;
	end;
SNAKE(1,X):= NEWPOS(X);
SNAKE(1,Y):= NEWPOS(Y);
end;	\SNAKEMOVE



begin	\MAIN
SCREEN:= RESERVE((WIDTH+1)*INTSIZE);
for II:= 0, WIDTH do
	SCREEN(II):= RESERVE((HEIGHT+1)*INTSIZE);

SNAKE:= RESERVE((SNAKELENGTH+1)*INTSIZE);
for II:= 1, SNAKELENGTH do
	SNAKE(II):= RESERVE(2*INTSIZE);

PLAYER:= RESERVE(2*INTSIZE);
MONEY:= RESERVE(2*INTSIZE);
DOOR:= RESERVE(2*INTSIZE);

INITIALIZE;
SHOWCUR(false);
PLACEOBJECTS;
repeat	PLAYERMOVE;
	if ~LEFT then SNAKEMOVE;
until LEFT ! EATEN;
CURSOR(0, HEIGHT);
CRLF(0);
if LEFT then
	[TEXT(0, "You have escaped with $");   INTOUT(0, SCORE)]
else
	TEXT(0, "The snake has eaten you");
TEXT(0, ".
");
SHOWCUR(true);
end;	\MAIN
