
include C:\CXPL\CODESI.XPL;
include C:\CXPL\XPLDEFS.XPL;


int X,O,N;

\Variables for keyboard playing

int KEY,PORT;

define MaxActive=10;	\Maximum active keys at one time

int ActiveKeys;		\Array of keys that are down


\FOR READING IBK FILES

integer
	INHAND;

integer
	IBKBanks,	\Arrays of IBK register settings
	IBKNames;	\Arrays of IBK Bank names;	

integer
	TIMBRE;

\MUSIC CONSTANTS

integer
	CHROMATIC;	\Strings of note names
int
	BOTTOM;			\Bottom octave for musical scale

define	\Define note values
	NOTE_C,NOTE_CS,NOTE_D,NOTE_DS,NOTE_E,NOTE_F,
	NOTE_FS,NOTE_G,NOTE_GS,NOTE_A,NOTE_AS,NOTE_B;


\------------------------------------------------------------------------

define
	SB_MPUBASE=$330,	\MPU-401 base port address
	SB_MIXPORT=$220,	\Mixer port address	
	SB_BASE=$220,		\Sound blaster base port address

	MIX_REGISTER=SB_MIXPORT+$04,	\MIX Register port
	MIX_DATA=SB_MIXPORT+$05,	\MIX Data port

	DSP_RESET=SB_BASE+$06,		\DSP Reset port
	DSP_READ=SB_BASE+$0A,		\DSP Read data
	DSP_WRITE=SB_BASE+$0C,		\DSP Write data
	DSP_WSTATUS=SB_BASE+$0C,	\DSP Write status
	DSP_RSTATUS=SB_BASE+$0E,	\DSP Read status

	FM_STATUS=SB_BASE+$08,		\FM Status port
	FM_REGISTER=SB_BASE+$08,	\FM Register port
	FM_DATA=SB_BASE+$09;		\FM Data port


integer
	REG_ARRAY;		\Array of FM control register values


define	\Register index values
	FMR_20_A, FMR_20_B,
	FMR_40_A, FMR_40_B,
	FMR_60_A, FMR_60_B,
	FMR_80_A, FMR_80_B,
	FMR_E0_A, FMR_E0_B,
	FMR_08,FMR_BD,FMR_C0,
	FMR_01,
	MAXREG;



integer
	ModulateOffset,		\Modulator offsets for each channel
	CarrierOffset;		\Carrier offsets for each channel

integer
	ChanNote,		\Array of notes for each channel
	ChanOctave,		\Array of octaves for each channel
	ChanTime;		\Array of times for each channel to be on

define	MAXCHAN=9;		\Maximum number of channels

define	IntSize=2;

\------------------ LOW LEVEL SUPPORT ROUTINES -------------------------



procedure GETSTR(STR,LEN);
\DO CONTROLLED STRING INPUT
address STR;
integer LEN,PTR,C;
begin
OPENI(0);
PTR:=0;
loop
	begin
	C:=CHIN(1);
	case C of
	DEL: if PTR#0 then [CHOUT(0,BS);CHOUT(0,SP);CHOUT(0,BS);PTR:=PTR-1;];
	ESC: [PTR:=0; quit;];
	CR,0: quit
	else if PTR<LEN & C>$1F then [STR(PTR):=C;CHOUT(0,C);PTR:=PTR+1;];
	end;
if PTR>0 then STR(PTR-1):=STR(PTR-1) ! $80 else STR(0):=C ! $80;
end;


procedure Z2MCOPY(S1,S2);
\COPY ZERO TERMINATED STRING TO MSB TERMINATED
char S1,S2;
int P;
begin
for P:=0,32000 do
	begin
	S2(P):=S1(P);
	if S1(P)=0 then
		begin
		if P=0 then S2(0):=$A0
		else S2(P-1):=S2(P-1) ! $80;
		return;
		end;
	end;
end;


\------------------- Routines to read and write DSP ports --------------

procedure ReadDSP(Port);
\Read from specified port
int Port,C;
begin
for C:=0,1600 do if PIN(DSP_RSTATUS,0) & $80 then return PIN(Port,0); 
return 0;
end;


procedure WriteDSP(Port,Value);
\Read from specified port
int Port,Value,C;
begin
for C:=0,1600 do if PIN(DSP_WSTATUS,0) & $80 then [POUT(Value,Port,0); return;];
POUT(Value,Port,0);
end;

\------------------------------------------------------------------------


procedure ResetDSP;
\Reset the DSP chip
int C;
begin
POUT(1,DSP_RESET,0);
for C:=0,256 do;
POUT(0,DSP_RESET,0);
return ReadDSP(DSP_READ,0) = $AA;
end;


procedure real DSPVersion;
\Get DSP version number
begin
WriteDSP(DSP_WRITE,$E1);
return FLOAT(ReadDSP(DSP_READ,0)) +FLOAT(ReadDSP(DSP_READ,0))/100.0;
end;

\------------------- Mixer Control Routines ----------------------------


procedure SetMIXReg(Reg,Value);
\Set specified register REG to Value
int Reg,Value;int C,T;
begin
POUT(Reg,MIX_REGISTER,0);
POUT(Value,MIX_DATA,0);
end;



\-------------------- FM Chip Control Routines -------------------------

procedure GetFMType;
\Get FM chip type
return PIN($388,0);


procedure SetFMRegister(Reg,Value);
\Set specified register REG to Value
int Reg,Value;int C,T;
begin
POUT(Reg,FM_REGISTER,0);
for C:=1,6 do T:=PIN(FM_STATUS,0);
POUT(Value,FM_DATA,0);
for C:=1,35 do T:=PIN(FM_STATUS,0);
end;


procedure ResetFM;
\Reset all FM register
int R;
begin
for R:=-$F5,-2 do SetFMRegister(-R,0);
SetFMRegister($04,$06);
SetFMRegister($01,$20);
end;


procedure GotFM;
\Test for FM sound chip
int T1,T2,D;
begin
SetFMRegister($04,$60);
SetFMRegister($04,$80);
T1:=PIN(FM_STATUS,0);
SetFMRegister($02,$FF);
SetFMRegister($04,$21);
for D:=1,80 do;
T2:=PIN(FM_STATUS,0);
SetFMRegister($04,$60);
SetFMRegister($04,$80);
return ((T1 & $E0)=0) & ((T2 & $E0)=$C0);  
end;


\------------------- Music Routines ------------------------------------




procedure SETNOTES;
begin
CHROMATIC:=["C    ","C#/Db","D    ","D#/Eb","E    ","F    ",
            "F#/Gb","G    ","G#/Ab","A    ","A#/Bb","B    "];

BOTTOM:=[$156,$16B,$181,$198,$1B0,$1CA,$1E5,$202,$220,$241,$263,$287,$2A3];
end;


\------------------ Routine to control the volume ----------------------

procedure SetVolume;
int Master,FMVolume,C;
begin
Master:=4; FMVolume:=4;
CHOUT(0,FF);
TEXT(0,"
************** SET VOLUME ****************
M = Master Volume   F = FM Volume Q = Quit");
loop
	begin
	CURSOR(0,5);
	TEXT(0,"Master = ");
	INTOUT(0,Master);
	TEXT(0," FM = ");
	INTOUT(0,FMVolume);

	C:=CHIN(1);
	case C of
	^M: Master:=(Master+1) & 7;	
	^m: Master:=(Master-1) & 7;	
	^F: FMVolume:=(FMVolume+1) & 7;	
	^f: FMVolume:=(FMVolume-1) & 7;
	^Q,^q: quit
	other;	
	end;
Master:=Master<<1;
Master:=Master<<4 ! Master;
SetMIXReg($22,Master);

FMVolume:=FMVolume<<1;
FMVolume:=FMVolume<<4 ! FMVolume;
SetMIXReg($26,FMVolume);
end;



\------------------- FM Synthysis Routines -----------------------------



procedureFMDefaults;
\Set sound quality defaults
begin
REG_ARRAY(FMR_01):=$20;
REG_ARRAY(FMR_08):=0;
REG_ARRAY(FMR_BD):=0;

REG_ARRAY(FMR_20_A):=$01; REG_ARRAY(FMR_20_B):=$01;
REG_ARRAY(FMR_40_A):=$10; REG_ARRAY(FMR_40_B):=$00;
REG_ARRAY(FMR_60_A):=$F0; REG_ARRAY(FMR_60_B):=$F0;
REG_ARRAY(FMR_80_A):=$77; REG_ARRAY(FMR_80_B):=$77;
REG_ARRAY(FMR_E0_A):=0; REG_ARRAY(FMR_E0_B):=0;
REG_ARRAY(FMR_C0):=0;
end;



procedure ZeroChanArray;
\Zero out channel array
int Chan;
for Chan:=0,MAXCHAN-1 do ChanNote(Chan):=-1;



procedure SetTimbre(CHAN,ARRAY);
\Set sound quality for a channel
int CHAN,ARRAY;
int MO,CO;
begin
MO:=ModulateOffset(CHAN);
CO:=CarrierOffset(CHAN);
SetFMRegister($01,ARRAY(FMR_01));
SetFMRegister($08,ARRAY(FMR_08));
SetFMRegister($BD,ARRAY(FMR_BD));

SetFMRegister($20+MO,ARRAY(FMR_20_A));
SetFMRegister($20+CO,ARRAY(FMR_20_B));

SetFMRegister($40+MO,ARRAY(FMR_40_A));
SetFMRegister($40+CO,ARRAY(FMR_40_B));

SetFMRegister($60+MO,ARRAY(FMR_60_A));
SetFMRegister($60+CO,ARRAY(FMR_60_B));

SetFMRegister($80+MO,ARRAY(FMR_80_A));
SetFMRegister($80+CO,ARRAY(FMR_80_B));

SetFMRegister($E0+MO,ARRAY(FMR_E0_A));
SetFMRegister($E0+CO,ARRAY(FMR_E0_B));

SetFMRegister($C0,ARRAY(FMR_C0));
SetFMRegister($40+CO,ARRAY(FMR_40_B)+5);
end;




procedure SetChannel(Chan,Note,Octave,Array);
\Set sound channel
int Chan,Note,Octave,Array;
int F1,F2;
begin
SetTimbre(Chan,Array);
F1:=BOTTOM(Note);
F2:=SWAP(F1) & $03; F2:=F2 ! Octave <<2; F2:=F2 ! $20;
SetFMRegister($A0+Chan,F1);
SetFMRegister($B0+Chan,F2);
return F1;
end;


procedure ChanOff(Chan,Note,Octave);
\Turn specified channel off
int Chan,Note,Octave;
int F1,F2;
begin
F1:=BOTTOM(Note);
F2:=SWAP(F1) & $03; F2:=F2 ! Octave <<2;
SetFMRegister($A0+Chan,F1);
SetFMRegister($B0+Chan,F2);
end;




procedure PlayChord;
\Play chord in array
int Chan,F;
begin
for Chan:=0,MAXCHAN-1 do [INTOUT(0,ChanNote(Chan)); TEXT(0," ");];
CRLF(0);

for Chan:=0,MAXCHAN-1 do
if ChanNote(Chan)#-1 then
	begin
	F:=SetChannel(Chan,ChanNote(Chan),ChanOctave(Chan),REG_ARRAY);
	INTOUT(0,F);TEXT(0," ");
	end;
CRLF(0);
SOUND(0,ChanTime(0),5);
for Chan:=0,MAXCHAN-1 do
  if ChanNote(Chan)#-1 then [ChanOff(Chan,ChanNote(Chan),ChanOctave(Chan)); ChanNote(Chan):=-1;];
end;




\-----------------------------------------------------------------------


procedure GetNewScan;
\Wait for and return new scan code
begin
repeat PORT:=PIN($60,0);OPENI(0); until PORT#KEY;
KEY:=PORT;
return PORT;
end;


procedure ClearKeyTable;
int P;
for P:=0,10-1 do ActiveKeys(P):=-1;


procedure DoKey(Array);
\Decode and play one keyboard key
int Array;
int Scan,Note,Octave,DownFlag;


	procedure DoOct2;
	begin
	case Scan of
	$2C: [Note:=NOTE_C;Octave:=2;];
	$2D: [Note:=NOTE_D;Octave:=2;];
	$2E: [Note:=NOTE_E;Octave:=2;];
	$2F: [Note:=NOTE_F;Octave:=2;];
	$30: [Note:=NOTE_G;Octave:=2;];
	$31: [Note:=NOTE_A;Octave:=2;];
	$32: [Note:=NOTE_B;Octave:=2;];
	$33: [Note:=NOTE_C;Octave:=3;]
	other Note:=-1;
	end;

	procedure DoOct3;
	begin
	case Scan of
	$1E: [Note:=NOTE_C;Octave:=3;];
	$1F: [Note:=NOTE_D;Octave:=3;];
	$20: [Note:=NOTE_E;Octave:=3;];
	$21: [Note:=NOTE_F;Octave:=3;];
	$22: [Note:=NOTE_G;Octave:=3;];
	$23: [Note:=NOTE_A;Octave:=3;];
	$24: [Note:=NOTE_B;Octave:=3;];
	$25: [Note:=NOTE_C;Octave:=4;]
	other Note:=-1;
	end;

	procedure DoOct4;
	begin
	case Scan of
	$10: [Note:=NOTE_C;Octave:=4;];
	$11: [Note:=NOTE_D;Octave:=4;];
	$12: [Note:=NOTE_E;Octave:=4;];
	$13: [Note:=NOTE_F;Octave:=4;];
	$14: [Note:=NOTE_G;Octave:=4;];
	$15: [Note:=NOTE_A;Octave:=4;];
	$16: [Note:=NOTE_B;Octave:=4;];
	$17: [Note:=NOTE_C;Octave:=5;]
	other Note:=-1;
	end;

	procedure DoOct5;
	begin
	case Scan of
	$02: [Note:=NOTE_C;Octave:=5;];
	$03: [Note:=NOTE_D;Octave:=5;];
	$04: [Note:=NOTE_E;Octave:=5;];
	$05: [Note:=NOTE_F;Octave:=5;];
	$06: [Note:=NOTE_G;Octave:=5;];
	$07: [Note:=NOTE_A;Octave:=5;];
	$08: [Note:=NOTE_B;Octave:=5;];
	$09: [Note:=NOTE_C;Octave:=6;];
	$0A: [Note:=NOTE_D;Octave:=6;];
	$0B: [Note:=NOTE_E;Octave:=6;];
	$0C: [Note:=NOTE_F;Octave:=6;];
	$0D: [Note:=NOTE_G;Octave:=6;]
	other Note:=-1;
	end;


	procedure KeyOn;
	int P;
	begin
	for P:=0,MaxActive-1 do if ActiveKeys(P)=Scan then return;
	P:=0;
	while ActiveKeys(P)#-1 do
		begin
		P:=P+1;
		if P>=MaxActive then return;
		end;
	ActiveKeys(P):=Scan;
	SetChannel(P,Note,Octave,Array);
	end;


	procedure KeyOff;
	int P;
	begin
	P:=0;
	while ActiveKeys(P)#Scan do
		begin
		P:=P+1;
		if P>=MaxActive then return;
		end;
	ActiveKeys(P):=-1;
	ChanOff(P,Note,Octave);
	end;


	procedure ShowKeys;
	int P;
	begin
	TEXT(0,"Note: ");TEXT(0,Chromatic(Note));
	TEXT(0,"  Octave: ");INTOUT(0,OCTAVE);
	CRLF(0);CRLF(0);

	for P:=0,MaxActive-1 do
		begin
		INTOUT(0,P);
		TEXT(0," - ");
		HEXOUT(0,ActiveKeys(P));
		CRLF(0)
		end;
	end;

begin
Scan:=GetNewScan;
CURSOR(0,4);HEXOUT(0,Scan);TEXT(0,"  ");
DownFlag:=Scan<$80;
Scan:=Scan & $7F;
case of
Scan>=$2C: DoOct2;
Scan>=$1E: DoOct3;
Scan>=$10: DoOct4;
Scan>=$2: DoOct5
other return Scan;

if Note>-1 then
	begin
	if DownFlag then KeyOn
	else KeyOff;
	end;

CURSOR(0,6);
SHOWKEYS;
OPENI(0);
return Scan;
end;



procedure KEYBOARD(Array);
int Array;
int Char,Scan;
begin
CHOUT(0,FF);
TEXT(0,"ESCAPE TO EXIT");
PORT:=PIN($60,0); KEY:=PORT;
ClearKeyTable;
repeat until DoKey(Array)=1;
ResetFM;
end;

\---------------- Adjust Register Values -------------------------------

procedure CopyArray(A1,A2);
\Copy A1 into A2
int A1,A2,P;
for P:=0,MAXREG-1 do A2(P):=A1(P);



procedure ShowRegisters(Array);
\Show register values
int Array;
begin
TEXT(0,"1. FMR_20_A= ");HEXOUT(0,Array(FMR_20_A));CRLF(0);
TEXT(0,"2. FMR_20_B= ");HEXOUT(0,Array(FMR_20_B));CRLF(0);
TEXT(0,"3. FMR_40_A= ");HEXOUT(0,Array(FMR_40_A));CRLF(0);
TEXT(0,"4. FMR_40_B= ");HEXOUT(0,Array(FMR_40_B));CRLF(0);
TEXT(0,"5. FMR_60_A= ");HEXOUT(0,Array(FMR_60_A));CRLF(0);
TEXT(0,"6. FMR_60_B= ");HEXOUT(0,Array(FMR_60_B));CRLF(0);
TEXT(0,"7. FMR_80_A= ");HEXOUT(0,Array(FMR_80_A));CRLF(0);
TEXT(0,"8. FMR_80_B= ");HEXOUT(0,Array(FMR_80_B));CRLF(0);

TEXT(0,"9. FMR_E0_A= ");HEXOUT(0,Array(FMR_E0_A));CRLF(0);
TEXT(0,"10. FMR_E0_B= ");HEXOUT(0,Array(FMR_E0_B));CRLF(0);
TEXT(0,"11. FMR_C0= ");HEXOUT(0,Array(FMR_C0));CRLF(0);

TEXT(0,"12. FMR_01= ");HEXOUT(0,Array(FMR_01));CRLF(0);
TEXT(0,"13. FMR_08= ");HEXOUT(0,Array(FMR_08));CRLF(0);
TEXT(0,"14. FMR_BD= ");HEXOUT(0,Array(FMR_BD));CRLF(0);
TEXT(0,"

M= MODIFY         P=PLAY NOTE
S= SAVE REGISTERS Q= QUIT
");
end;


procedure RegModify(Reg,Val,Array);
\Modify specified register
int Reg,Val,Array;
begin
case Reg of
1: Array(FMR_20_A):=Val;
2: Array(FMR_20_B):=Val;
3: Array(FMR_40_A):=Val;
4: Array(FMR_40_B):=Val;
5: Array(FMR_60_A):=Val;
6: Array(FMR_60_B):=Val;
7: Array(FMR_80_A):=Val;
8: Array(FMR_80_B):=Val;
9: Array(FMR_E0_A):=Val;
10: Array(FMR_E0_B):=Val;
11: Array(FMR_C0):=Val;

12: Array(FMR_01):=Val;
13: Array(FMR_08):=Val;
14: Array(FMR_BD):=Val 
other;
end;



procedure DoRegister(Array);
\Set one register
int Array;
int REG;
begin
TEXT(0,"SELECT REGISTER TO MODIFY");
REG:=INTIN(0);
if REG>=1 & REG<=14 then
	begin
	TEXT(0,"ENTER VALUE IN HEX: ");
	RegModify(Reg,HEXIN(0),Array);
	end;
end;


fproc DISTIMBRE;


procedure SetRegisters;
\Set sound quality defaults
int C,TempArray;


	procedure PlayOldNew;
	int UseTemp;
	begin
	CHOUT(0,FF);
	TEXT(0,"*** PLAY NOTES ***");CRLF(0);
	TEXT(0,"Shift =  Old Sound");CRLF(0);
	TEXT(0,"Escape = Exit");CRLF(0);
	UseTemp:=false;	
	ClearKeyTable;
	loop
		begin
		CURSOR(0,3);
		TEXT(0,if UseTemp then "New Sound" else "Old Sound");
		case DoKey(if UseTemp then TempArray else REG_ARRAY) of
		$2A,$36: UseTemp:=not UseTemp;
		1: quit
		other;
		end;
	ResetFM;
	end;

begin
TempArray:=RESERVE(MAXREG*2);
CopyArray(REG_ARRAY,TempArray);
loop
	begin
	CHOUT(0,FF);
	DISTIMBRE;CRLF(0);
	ShowRegisters(TempArray);
	C:=CHIN(1);
	case C of
	^M,^m: DoRegister(TempArray);
	^S,^s: CopyArray(TempArray,REG_ARRAY);
	^P,^p: PlayOldNew;
	^Q,^q: quit
	other;
	end;
end;

\------------------ ROUTINES TO READ AN IBK FILE -----------------------


procedure READIBK;
char FNAME;
int P1,P2,T;
char TEMP;
begin
FNAME:=RESERVE(80);
TEMP:=RESERVE(9);
CHOUT(0,FF);
TEXT(0,"ENTER .IBK FILENAME: ");
GETSTR(FNAME,80);
INHAND:=FOPEN(FNAME,0);
FSET(INHAND,^I);
OPENI(DISK);
for P1:=0,128-1 do
 for P2:=0,16-1 do IBKBanks(P1,P2):=CHIN(DISK);

for P1:=0,4-1 do T:=CHIN(DISK);

for P1:=0,128-1 do
	begin
	for P2:=0,9-1 do TEMP(P2):=CHIN(DISK);
	Z2MCOPY(TEMP,IBKNames(P1));
	end;
end;



procedure DISTIMBRE;
\Display current timbre
begin
if TIMBRE=-1 then TEXT(0,"Default Timbre")
else [INTOUT(0,TIMBRE); TEXT(0,"-"); TEXT(0,IBKNames(TIMBRE));];
end;


procedure SELECTIBK;
int P1,TIMB;
begin
CHOUT(0,FF);
for P1:=0,128-1 do
	begin
	CURSOR(13*(P1/22),REM(P1/22));
	INTOUT(0,P1); TEXT(0,"-"); TEXT(0,IBKNames(P1));
	end;
CURSOR(0,23);DISTIMBRE;
CURSOR(0,24);TEXT(0,"SELECT TIMBRE: ");
TIMB:=INTIN(0);
if TIMB>=0 & TIMB<=127 then
	begin
	REG_ARRAY(FMR_20_A):=IBKBanks(TIMB,4);
	REG_ARRAY(FMR_20_B):=IBKBanks(TIMB,5);
	REG_ARRAY(FMR_40_A):=IBKBanks(TIMB,6);
	REG_ARRAY(FMR_40_B):=IBKBanks(TIMB,7);
	REG_ARRAY(FMR_60_A):=IBKBanks(TIMB,8);
	REG_ARRAY(FMR_60_B):=IBKBanks(TIMB,9);
	REG_ARRAY(FMR_80_A):=IBKBanks(TIMB,10);
	REG_ARRAY(FMR_80_B):=IBKBanks(TIMB,11);
	REG_ARRAY(FMR_E0_A):=IBKBanks(TIMB,12);
	REG_ARRAY(FMR_E0_B):=IBKBanks(TIMB,13);
	REG_ARRAY(FMR_C0):=IBKBanks(TIMB,14);

	REG_ARRAY(FMR_08):=$00;
	REG_ARRAY(FMR_BD):=$00;
	REG_ARRAY(FMR_01):=$20;
	TIMBRE:=TIMB;
	end;
end;


\-----------------------------------------------------------------------


procedure TESTPLAY;
begin
TEXT(0,"C Arpeggio");CRLF(0);
ChanNote(0):=NOTE_C; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_E; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_G; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;

TEXT(0,"F Arpeggio");CRLF(0);
ChanNote(0):=NOTE_F; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_A; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_C; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;

TEXT(0,"G Arpeggio");CRLF(0);
ChanNote(0):=NOTE_G; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_B; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_D; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;

TEXT(0,"G7 Arpeggio");CRLF(0);
ChanNote(0):=NOTE_G; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_B; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_D; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;
ChanNote(0):=NOTE_F; ChanOctave(0):=3;ChanTime(0):=5;
PLAYCHORD;

TEXT(0,"C Chord");CRLF(0);
ChanNote(0):=NOTE_C; ChanOctave(0):=3;ChanTime(0):=10;
ChanNote(1):=NOTE_E; ChanOctave(1):=3;
ChanNote(2):=NOTE_G; ChanOctave(2):=3;
PLAYCHORD;

TEXT(0,"F Chord");CRLF(0);
ChanNote(0):=NOTE_F; ChanOctave(0):=3;ChanTime(0):=10;
ChanNote(1):=NOTE_A; ChanOctave(1):=3;
ChanNote(2):=NOTE_C; ChanOctave(2):=3;
PLAYCHORD;

TEXT(0,"G Chord");CRLF(0);
ChanNote(0):=NOTE_G; ChanOctave(0):=3;ChanTime(0):=10;
ChanNote(1):=NOTE_B; ChanOctave(1):=3;
ChanNote(2):=NOTE_D; ChanOctave(2):=3;
PLAYCHORD;

TEXT(0,"G7 Chord");CRLF(0);
ChanNote(0):=NOTE_G; ChanOctave(0):=3;ChanTime(0):=10;
ChanNote(1):=NOTE_B; ChanOctave(1):=3;
ChanNote(2):=NOTE_D; ChanOctave(2):=3;
ChanNote(3):=NOTE_F; ChanOctave(3):=3;
PLAYCHORD;

TEXT(0,"C Chord");CRLF(0);
ChanNote(0):=NOTE_C; ChanOctave(0):=3;ChanTime(0):=10;
ChanNote(1):=NOTE_E; ChanOctave(1):=3;
ChanNote(2):=NOTE_G; ChanOctave(2):=3;
PLAYCHORD;
end;


procedure MENU;
int COM;
begin
CHOUT(0,FF);
TEXT(0,"CURRENT TIMBRE= ");DISTIMBRE;CRLF(0);

TEXT(0,"

F = READ IBK FILE 
I = SELECT IBK TIMBRE
K = PLAY KEYBOARD NOTES
P = PLAY TEST SEQUENCE
S = SET REGISTERS
R = RESET REGISTERS
V = SET VOLUME LEVELS
Q = QUIT

CHOOSE ONE: ");
COM:=CHIN(1);
case COM of
^F,^f: READIBK;
^I,^i: SELECTIBK;
^K,^k: KEYBOARD(REG_ARRAY);
^P,^p: TESTPLAY;
^R,^r: FMDefaults;
^S,^s: SetRegisters;
^V,^v: SetVolume;
^Q,^q: return true
other;
return false;
end;


begin
ActiveKeys:=RESERVE(MaxActive*2);

IBKBanks:=RESERVE(128*2);
IBKNames:=RESERVE(128*2);
for X:=0,128-1 do
	begin
	IBKBanks(X):=RESERVE(16*2);
	IBKNames(X):=RESERVE(9);
	end;

REG_ARRAY:=RESERVE(MAXREG*2);
TIMBRE:=-1;
SETNOTES;
ModulateOffset:=[$00,$01,$02,$08,$09,$0A,$10,$11,$12];
CarrierOffset:= [$03,$04,$05,$0B,$0C,$0D,$13,$14,$15];
ChanNote:=RESERVE(MAXCHAN*IntSize);
ChanOctave:=RESERVE(MAXCHAN*IntSize);
ChanTime:=RESERVE(MAXCHAN*IntSize);
ZeroChanArray;
FMDefaults;

if GotFM then TEXT(0,"FM Chip Installed") else TEXT(0,"No FM Chip Installed");
CRLF(0);

if ResetDSP then TEXT(0,"DSP Reset") else TEXT(0,"Unable to Reset DSP");
CRLF(0);

FORMAT(5,2);
TEXT(0,"Version Number = ");RLOUT(0,DSPVersion);CRLF(0);
TEXT(0,"FM TYPE= ");HEXOUT(0,GetFMType);CRLF(0);
ResetFM;
TEXT(0,"Hit Any Key");
X:=CHIN(1);

repeat until MENU;
ResetFM;
end;
