
\PRINTER HANDLER AND SPOOLER FOR IBM COMPATABLE PRINTERS

include \CXPL\CODESI.XPL;

integer
	VIDMODE,	\CURRENT VIDEO MODE
	COLOR,		\FLAGS COLOR MONITOR AVAILABLE	
	BAR,		\MENU STRUCTURE FOR HIGHLIGHTING
	GLOBAL,		\GLOBAL COMMAND
	COM;		\CURRENT GLOBAL COMMAND


define
	EOF=$1A,	\END OF FILE
	ESC=$1B,	\ESCAPE
	CR=$0D,		\CARRIAGE RETURN
	LF=$0A,		\LINE FEED
	SP=$20,		\SPACE
	TAB=$09,	\TAB CHARACTER
	FF=$0C,		\FORM FEED
	LFARROW=75,	\LEFT ARROW KEY
	RTARROW=77,	\RIGHT ARROW KEY
	UPARROW=72,	\UP ARROW KEY
	DNARROW=80;	\DOWN ARROW KEY

\DOS VARIABLES

integer
	PSEG,		\CURRENT PSP SEGMENT
	DSEG,		\CURRENT DATA SEGMENT
	CPUREG,		\SYSTEM INFO ARRAY
	INHAND,		\CURRENT INPUT HANDLE
	OTHAND;		\CURRENT OUTPUT HANDLE

address
	FNAME,		\FILE NAME WHEN SUBMITTED TO QUE
	SNAME,		\NAME AND PATH OF SPOOL FILE
	TAIL,		\HOLDS THE COMMAND TAIL
	TLEN;		\HOLDS THE TAIL LENGTH


\TIME STAMP VARIABLES

integer
	DAY,YEAR,MONTH,			\TIME
	DATE,HOUR,MINUTE,SECOND;	\DATE

\PRINTER VARIABLES

integer
	COLLUM,		\CURRENT COLLUMN
	TEMP,		\TEMPORARY STORAGE
	CHAR,		\GLOBAL CHARACTER
	LINECOUNT,	\HOLDS CURRENT LINE POSITION
	PGCTR,		\HOLDS PAGE NUMBER
	PLENGTH,	\LENGTH OF PAGE
	COPCTR;		\COUNTS NUMBER OF COPIES


def	\STANDADRD DEVICE CHANNELS 

	TV=0,		\VIDEO CHANNEL
	PRI=2,		\PRINTER CHANNEL
	DISK=3;		\DISK CHANNEL

\WORKING DEVICE CHANNELS

integer
	IDEV,		\INPUT DEVICE
	ODEV;		\OUTPUT DEVICE


def	\PAGE CONSTANTS

	FLENGTH=66;	\LENGTH OF FORM


integer IOWN;	\INTEGER PARAMETER ARRAY
define		\INTEGER PARAMETERS POINTERS

	COPIES,	\NUMBER OF COPIES TO PRINT
	EXTRA,	\FLAGS EXTRA FORM FEED AT END OF PRINT
	STARPG,	\STARTING PAGE NUMBER
	PGFLG,	\FLAGS NUMBER PAGES
	GAP,	\GAP BETWEEN FORMS
	LMAR,	\LEFT MARGIN
	RMAR,	\RIGHT MARGIN
	CPI,	\CHARACTERS PER INCH
	MODE,	\PRINTER MODE
	SPOOL,	\SPOOL FILE TO DISK
	DODATE,	\PRINT DATE ON DOCUMENT
	FONT;	\FONT

\BASE LOCATION FOR MENU ITEMS

define
	BASEX=8,BASEY=7;	\COORDINATE OF MENU BASE




procedure SCOMP(S1,S2);
\COMPARE STRINGS
char S1,S2;
int I;
for I:=0,32767 do
[if S1(I)#S2(I) then return false;
if S1(I)>$7F then return true];


procedure SCOPY(S1,S2);
\COPY STRINGS S2 INTO S1
char S1,S2;
int I;
for I:=0,32767 do
[S1(I):=S2(I);if S1(I)>$7F then return];



procedure STRLEN(S);
\FIND STRING LENGTH
char S;
int I;
for I:=0,32767 do
if S(I)>$7F then return I+1;


procedure SAPPEND(S1,S2);
\APPEND STRING S2 TO S1
char S1,S2;
int L;
begin
L:=STRLEN(S1);
if L>0 then S1(L-1):=S1(L-1) & $7F;
SCOPY(S1+L,S2);
end;


procedure EMPHASIZE(S,N,F,B);
\OUTPUT STRING AND EMPHASIZE THE SPECIFIED CHARACTER
char  S;int N,F,B;
int C,P;
begin
for P:=0,32000 do
	begin
	C:=S(P);
	if P=N then [ATTRIB(F);CHOUT(6,C & $7F);]
	       else [ATTRIB(B);CHOUT(6,C & $7F);];
	if C>$7F then return;
	end;
end;



procedure BLANK;
CHOUT(0,FF);



procedure GETDATE;
\GET SYSTEM TIME AND DATE
begin
CPUREG:=GETREG;
CPUREG(0):=$2A00;
SOFTINT($21);
DAY:=CPUREG(0)&$FF;
YEAR:=CPUREG(2);
MONTH:=SWAP(CPUREG(3))&$FF;
DATE:=CPUREG(3)&$FF;
CPUREG(0):=$2C00;
SOFTINT($21);
HOUR:=SWAP(CPUREG(2))&$FF;
MINUTE:=CPUREG(2)&$FF;
SECOND:=SWAP(CPUREG(3))&$FF;
end;



procedure INT2(I);
\OUTPUT INTEGER LEFT JUSTIFIED WITH ZEROS
int I;
begin
if I<10 then CHOUT(ODEV,^0);
INTOUT(ODEV,I);
end;




procedure SPTEST;
\TEST IF RESIDENT PART OF SPOOLER IS PRESENT
begin
CPUREG(0):=$0100;
SOFTINT($2F);
case CPUREG(0) & $FF of
	0:	begin
		CRLF(0);CRLF(0);
		TEXT(0,"!! RESIDENT PART OF SPOOLER NOT INSTALLED !!");CRLF(0);
		TEXT(0,"      PLEASE INSTALL (print /d:prn)");CRLF(0);
		return false;
		end;

	1:	begin
		CRLF(0);CRLF(0);
		TEXT(0,"!! RESIDENT PART OF SPOOLER CANNOT BE INSTALLED ");CRLF(0);
		TEXT(0,"           DO NOT USE SPOOLING MODE");CRLF(0);
		CRLF(0);
		return false;
		end;
	$FF: return true
else;
end;



procedure SETFNAME;
\USE TIME TO CREATE A UNIQUE FILENAME
begin
FNAME(0):=^F;
FNAME(1):=^0 + (HOUR/10);
FNAME(2):=^0 + REM(0);
FNAME(3):=^0 + (MINUTE/10);
FNAME(4):=^0 + REM(0);
FNAME(5):=^0 + (SECOND/10);
FNAME(6):=^0 + REM(0) ! $80;
end;


procedure SUBMIT;
\ROUTINE TO SUBMIT A FILE TO RESIDENT PART OF SPOOLER
char PACKET;
integer FADDR,L;
begin
if not IOWN(SPOOL) then return;

L:=STRLEN(SNAME);
if L>0 then SNAME(L-1):=SNAME(L-1) & $7F;
SNAME(L):=0;

PACKET:=RESERVE(5);
FADDR:=PACKET+1;

PACKET(0):=0;
FADDR(0):=SNAME;
FADDR(1):=DSEG;

CPUREG(0):=$0101;
CPUREG(9):=DSEG;
CPUREG(3):=PACKET;
SOFTINT($2F);
end;



\------------------- MENU ROUTINES -------------------------------------


procedure EXTKEY;
\READ KEY BOARD, EXTENDED CODES ARE NEGATED
integer C;
[C:=CHIN(1);return if C=0 then -CHIN(1) else C;];



procedure MENU(M,C);
\PROCEDURE TO PUT UP A MENU AND HIGHLIGHT BARS
\THE MENU IS PASSED THE STRUCTURE M, STARTING BAR IN C
\RETURN THE VALUE OF THE BAR SELECTED
integer M,C,P;


	procedure ADVANCE;
	\ADVANCE MENU BAR
	begin
	HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2), if COLOR then $17 else $07);
	P:=P+1;
	if M(P,0)=0 then P:=0;
	HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2), if COLOR then $70 else $7F );
	end;


	procedure BACKUP;
	\BACKUP MENU BAR
	begin
	HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2), if COLOR then $17 else $07);
	if P=0 then repeat P:=P+1 until M(P,0)=0;
	P:=P-1;
	HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2), if COLOR then $70 else $7F);
	end;


begin
\DISPLAY MENU ITEMS
P:=0;
while M(P,0)#0 do
	[CURSOR(M(P,1),M(P,2));	TEXT(6,M(P,0));	P:=P+1;];

\DECODE KEYS AND HIGHLIGHT MENU ITEMS
CURSOR(0,24);
P:=C;
HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2), if COLOR then $70 else $7F);
loop
	begin
	GLOBAL:=EXTKEY;
	case GLOBAL of
	ESC,^P,^p,^+,^-: return P;
	CR:	[GLOBAL:=^+;return P;];
	TAB:		ADVANCE;
	-LFARROW:	BACKUP;
	-UPARROW: 	BACKUP;
	-RTARROW:	ADVANCE;
	-DNARROW:	ADVANCE
	else;
	end;
end;




procedure INCDEC(C,P);
\INCREMENT OR DECREMENT BASE ON C
int C,P;
begin
if C=^+ then IOWN(P):=IOWN(P)+1
else IOWN(P):=if IOWN(P)<=1 then 1  else IOWN(P)-1;
end;



procedure DISMODE(M);
\DISPLAY PRINTER MODE
int M,MODE;
begin
MODE:=["Draft         ","Letter Quality","Super LQ      "];
TEXT(0,MODE(M));
end;


procedure NEXTMODE;
\ADVANCE PRINT MODE SETTING
IOWN(MODE):=if IOWN(MODE)>=2 then 0 else IOWN(MODE)+1;



procedure NEXTCPI;
\ADVANCE CHAR PER INCH SETTING;
begin
case IOWN(CPI) of
	10: [IOWN(CPI):=12;IOWN(RMAR):=96;];
	12: [IOWN(CPI):=15;IOWN(RMAR):=120;];
	15: [IOWN(CPI):=17;IOWN(RMAR):=137;];
	17: [IOWN(CPI):=20;IOWN(RMAR):=160;];
	20: [IOWN(CPI):=10;IOWN(RMAR):=80;]
else;
end;



procedure DISFONT(F);
\DISPLAY FONT TYPE
int F,FONTS;
begin
FONTS:=["Roman   ","SanSerif","Courier ",
	"Prestige","Script  ","Orator  ",
	"Bold    "];
TEXT(0,FONTS(F));
end;



procedure YESNO(B);
\DISPLAY BOOLEAN AS YES OR NO
int B;
TEXT(6,if B then "YES" else "NO ");




procedure NEXTFONT;
\ADVANCE FONT SETTING
begin
IOWN(FONT):=if IOWN(FONT)>=6 then 0 else IOWN(FONT)+1;
IOWN(MODE):=1;
end;



procedure FINTOUT(I);
\OUTPUT A FORMATED INTEGER
int I;
[INTOUT(6,I);TEXT(6,"   ");];




procedure PARMENU;
begin
BLANK;
ATTRIB(if COLOR then $17 else $07);
SETWIND(0,0,80,25,$100,false);
RAWTEXT(6,"
ͻ
                       PRINTER HANDLER PROGRAM                             
                                                                           
   Arrows move highlight bar    -     Plus, Minus and Enter change values  
Ķ
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
ͼ
 ");
end;



procedure DISPARM;
\DISPLAY PRINT PARAMETERS
define MARGIN=BASEX+40;
begin
CURSOR(MARGIN,BASEY+2);FINTOUT(IOWN(CPI));
CURSOR(MARGIN,BASEY+3);DISMODE(IOWN(MODE));
CURSOR(MARGIN,BASEY+4);DISFONT(IOWN(FONT));
CURSOR(MARGIN,BASEY+5);FINTOUT(IOWN(COPIES));
CURSOR(MARGIN,BASEY+6);YESNO(IOWN(DODATE));
CURSOR(MARGIN,BASEY+7);YESNO(IOWN(PGFLG));
CURSOR(MARGIN,BASEY+8);FINTOUT(IOWN(STARPG));
CURSOR(MARGIN,BASEY+9);FINTOUT(IOWN(LMAR));
CURSOR(MARGIN,BASEY+10);FINTOUT(IOWN(RMAR));
CURSOR(MARGIN,BASEY+11);FINTOUT(IOWN(GAP));
CURSOR(MARGIN,BASEY+12);YESNO(IOWN(EXTRA));
CURSOR(MARGIN,BASEY+13);YESNO(IOWN(SPOOL));
end;



procedure MAKEMENU;
\CREATE MENU STRUCTURE
begin
\EACH CONSIST OF:
\ 1. MENU ITEM STRING
\ 2. X,Y LOCATION OF STRING
\ 3. LENGTH OF HIGHLIGHT BAR
BAR:=[
[" START PRINTING [P]   ",BASEX,BASEY,20],	\11

[" PITCH (CHAR/IN)     ",BASEX,BASEY+2,20],	\7
[" PRINT MODE          ",BASEX,BASEY+3,20],	\8
[" FONT                ",BASEX,BASEY+4,20],	\5
[" COPIES              ",BASEX,BASEY+5,20 ],	\0
[" PRINT DATE           ",BASEX,BASEY+6,20],	\10

[" NUMBER PAGES        ",BASEX,BASEY+7,20],	\2
[" STARTING PAGE       ",BASEX,BASEY+8,20],	\3
[" LEFT MARGIN         ",BASEX,BASEY+9,20],	\5
[" RIGHT MARGIN        ",BASEX,BASEY+10,20],	\6
[" GAP BETWEEN PAGE    ",BASEX,BASEY+11,20],	\4
[" EXTRA FORM FEED     ",BASEX,BASEY+12,20],	\1
[" SPOOL PRINTING       ",BASEX,BASEY+13,20],	\9

[" ABORT [Esc]          ",BASEX,BASEY+15,20],	\12
[0]];
end;



procedure SETLOOP;
\CALL SETUP TILL SATISFIED
integer COM;
begin
COM:=0;
BLANK;
MAKEMENU;
PARMENU;
loop
	begin
	DISPARM;
	COM:=MENU(BAR,COM);
	case GLOBAL of
	ESC: return false;		\Escape also aborts
	^P,^p: quit			\'P' also prints
	other case COM of
	0: quit;				\Print
	1: NEXTCPI;				\Characters per inch
	2: NEXTMODE;				\Mode
	3: NEXTFONT;				\Font
	4: INCDEC(GLOBAL,COPIES);		\Number of copies
	5: IOWN(DODATE):=not IOWN(DODATE);	\Date

	6: IOWN(PGFLG):=not IOWN(PGFLG);	\Page numbers
	7: INCDEC(GLOBAL,STARPG);		\Starting page number
	8: INCDEC(GLOBAL,LMAR);			\Left margin
	9: INCDEC(GLOBAL,RMAR);			\Right margin
	10: INCDEC(GLOBAL,GAP);			\Gap between forms
	11: IOWN(EXTRA):=not IOWN(EXTRA); 	\Form feed
	12: IOWN(SPOOL):=not IOWN(SPOOL);	\Spool listing
	13: return false			\Abort
	other;
	end;
PLENGTH:=FLENGTH-IOWN(GAP);
return true;
end;





procedure DEFAULT;
\INITIALIZE PARAMETERS
begin
IOWN:=	[
	1,	\NUMBER OF COPIES TO PRINT
	false,	\FLAGS EXTRA FORM FEED AT END OF PRINT
	1,	\STARTING PAGE NUMBER
	true,	\FLAGS NUMBER PAGES
	4,	\GAP BETWEEN FORMS
	5,	\LEFT MARGIN
	79,	\RIGHT MARGIN
	10,	\CHARACTERS PER INCH
	0,	\PRINT MODE
	true,	\SPOOL FLAG
	true,	\PRINT DATE
	0];	\TYPE FONT
end;






procedure SETPRINTER;
\PRINTER SPECIFIC SETUP ROUTINE
integer I;
begin
OPENO(ODEV);

\INITIALIZE PRINTER
CHOUT(ODEV,^@);
\CLEAR PRINTER BUFFER
CHOUT(ODEV,$18);

\NO AUTO FORM FEED
CHOUT(ODEV,ESC);CHOUT(ODEV,^O);

\SET CHARACTERS PER INCH
CHOUT(ODEV,$12);
case IOWN(CPI) of
	10: [CHOUT(ODEV,ESC);CHOUT(ODEV,^P);];
	12: [CHOUT(ODEV,ESC);CHOUT(ODEV,^M);];
	15: [CHOUT(ODEV,ESC);CHOUT(ODEV,^g);];
	17: [CHOUT(ODEV,ESC);CHOUT(ODEV,^P);CHOUT(ODEV,$0F);];
	20: [CHOUT(ODEV,ESC);CHOUT(ODEV,^M);CHOUT(ODEV,$0F);]
else;

\SET PRINTER MODE
CHOUT(ODEV,ESC);
CHOUT(ODEV,^x);
CHOUT(ODEV,IOWN(MODE));

\SET FONT STYPEL
CHOUT(ODEV,ESC);
CHOUT(ODEV,^k);
CHOUT(ODEV,IOWN(FONT));


\SET NEW MARGIN
CHOUT(ODEV,ESC);CHOUT(ODEV,^l);CHOUT(ODEV,IOWN(LMAR));
CHOUT(ODEV,ESC);CHOUT(ODEV,^Q);CHOUT(ODEV,IOWN(RMAR));

end;



procedure CLEARP;
begin

\RESET TO 10 CHARACTERS PER INCH
CHOUT(ODEV,$12);CHOUT(ODEV,ESC);CHOUT(ODEV,^P);

\RESET PRINTER MODE TO DRAFT
CHOUT(ODEV,ESC);CHOUT(ODEV,^x);CHOUT(ODEV,0);

\SET FONT TYPE TO ROMAN
CHOUT(ODEV,ESC);CHOUT(ODEV,^k);CHOUT(ODEV,0);

\SET NEW MARGIN TO 0,80
CHOUT(ODEV,ESC);CHOUT(ODEV,^l);CHOUT(ODEV,0);
CHOUT(ODEV,ESC);CHOUT(ODEV,^Q);CHOUT(ODEV,80);

if IOWN(SPOOL) then
	begin
	CHOUT(ODEV,EOF);
	CLOSE(ODEV);
	FCLOSE(OTHAND);
	end;
end;


procedure SKIP;
\DO NEW LINE ON PRINTER
begin
CHOUT(ODEV,CR);
CHOUT(ODEV,LF);
LINECOUNT:=LINECOUNT-1;
end;



proc PAGE;
\PUT HEADING AT TOP OF NEW PAGE
int X,C;
begin
PGCTR:=PGCTR+1;
C:=IOWN(RMAR)-IOWN(LMAR);
for X:=1,C-10 do CHOUT(ODEV,SP);
TEXT(ODEV,"PAGE ");INTOUT(ODEV,PGCTR);
SKIP;
SKIP;
end;



procedure TOPFORM;
\MOVE TO TOP OF PAGE
begin
CHOUT(ODEV,FF);
LINECOUNT:=FLENGTH;
end;




proc DOFORM;
\HANDLE NEW PAGE
begin
TOPFORM;
if IOWN(PGFLG) then PAGE;
end;



proc GETC;
\GET GLOBAL CHARACTER FROM DISK
begin
CHAR:=CHIN(IDEV);
while CHAR=FF & LINECOUNT>=PLENGTH do CHAR:=CHIN(IDEV);
end;



procedure RESLINE;
\RESET LINE PARAMETERS
begin
if LINECOUNT<=IOWN(GAP) then DOFORM;
COLLUM:=IOWN(LMAR);
end;



procedure ENDLINE;
\HANDLE END OF LINE
begin
CHOUT(ODEV,CHAR);
LINECOUNT:=LINECOUNT-1;
RESLINE;
end;


procedure PRINTDATE;
\PRINT DATE STAMP AT TOP OF PAGE
integer C,I;
begin
\PUT AT CENTER OF SCREEN
C:=(IOWN(RMAR)-IOWN(LMAR)-10)/2;
for I:=1,C do CHOUT(ODEV,SP);

INT2(MONTH);CHOUT(ODEV,^,);
INT2(DATE);CHOUT(ODEV,^,);
INT2(YEAR);TEXT(ODEV,"   " );

\INT2(HOUR);CHOUT(ODEV,^:);
\INT2(MINUTE);CHOUT(ODEV,^:);
\INT2(SECOND);
SKIP;SKIP;
end;



procedure PRINT;
\PRINT A FILE
begin
COLLUM:=IOWN(LMAR);
PGCTR:=IOWN(STARPG);
OPENI(IDEV);
SKIP;
if IOWN(DODATE) then PRINTDATE;
SKIP;
loop
	begin
	GETC;
	case CHAR of
	LF: ENDLINE;
	FF: DOFORM;
	EOF: quit
	else 
		begin
		CHOUT(ODEV,CHAR);
		COLLUM:=COLLUM+1;
		if COLLUM>IOWN(RMAR) then [SKIP;RESLINE];
		end;
	end;
if not IOWN(SPOOL) then TOPFORM;
end;

procedure GETPSP;
\GET COMMAND TAIL FROM PSP
begin
BLIT(PSEG,$80,DSEG,TLEN,79);
if TLEN(0)>79 then TLEN(0):=79;
end;



procedure SETIHAND(S);
\SETUP INPUT FILE HANDLE
char S;
begin
TRAP($FFFB);
INHAND:=FOPEN(S,0);
TRAP($FFFF);
if GETERR#0 then [TEXT(0,"UNABLE TO OPEN FILE");CRLF(0);ABORT;];
FSET(INHAND,^I);
end;



procedure SETOHAND(S);
\SETUP OUTPUT FILEHANLE
char S;
begin
TRAP($FFFB);
OTHAND:=FOPEN(S,1);
TRAP($FFFF);
if GETERR#0 then return false;
FSET(OTHAND,^O);
return true;
end;



procedure UNSPOOL;
\UNDO SPOOL AS A RESULT OF SPOOL ERRORS
begin
CRLF(0);CRLF(0);CRLF(0);
TEXT(0,"SINCE SPOOLING IS INOPERABLE");CRLF(0);
TEXT(0,"FILE WILL BE SENT DIRECTLY TO PRINTER");CRLF(0);
CRLF(0);
IOWN(SPOOL):=false;
ODEV:=PRI;
end;



procedure SETSPOOL;
\SETUP SPOOL FILES
begin
if not IOWN(SPOOL) then
	begin
	ODEV:=PRI;
	return;
	end;

if not SPTEST then [UNSPOOL;return;];

\SET UP SPOOL FILE NAME
SETFNAME;
SCOPY(SNAME,"C:\PQUE\");
SAPPEND(SNAME,FNAME);
SAPPEND(SNAME,".LST");

if not SETOHAND(SNAME) then
	begin
	CRLF(0);CRLF(0);CRLF(0);
	TEXT(0,"!! UNABLE TO OPEN SPOOL FILE !!");CRLF(0);
	TEXT(0,"   SUBDIRECTORY MAY NOT EXIST");CRLF(0);
	UNSPOOL;
	return;
	end;

ODEV:=DISK;
end;



procedure SETFILES;
\ROUTINE TO SETUP FILES
begin
GETPSP;
SETIHAND(TAIL);
SETSPOOL;
end;


begin	\MAIN
CPUREG:=GETREG;
DSEG:=CPUREG(12);
PSEG:=CPUREG(11);

FNAME:=RESERVE(8);
SNAME:=RESERVE(80);
TLEN:=RESERVE(80);
TAIL:=TLEN+1;

LINECOUNT:=FLENGTH;

CPUREG(0):= $0F00;
SOFTINT($10);
VIDMODE:=CPUREG(0) & $FF;
case VIDMODE of 0,2,7: COLOR:=false
other COLOR:=true;


GETDATE;

BLANK;
DEFAULT;
if not SETLOOP then [BLANK;exit;];
BLANK;
SETFILES;
IDEV:=DISK;

if not IOWN(SPOOL) then 
	begin
	TEXT(TV,"ALIGN FORMS, THEN TYPE RETURN ");
	CRLF(0);CRLF(0);
	OPENI(TV);
	TEMP:=CHIN(TV);
	end;

SETPRINTER;

for COPCTR:=1,IOWN(COPIES) do PRINT;
if IOWN(EXTRA) then TOPFORM;
CLEARP;
SUBMIT;
BLANK;
end;
