\SQ.XPL		NOV-85		VERSION 1.8
\SQUASH UTILITY FOR APEX, V1.8

code
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7,		CHOUT=8,	CRLF=9,		INTIN=10,
INTOUT=11,	TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	ABORT=16,	SPACE=18,	FWRITE=30,
FREAD=31,	BLIT=32;

\THE DIRECTORY:
addr	FNAME,		\THE NAME AND EXTENSION FOR EACH FILE
	FSTAT,		\THE STATUS FOR EACH FILE
	STAB,		\SORT TABLE, ORDER IN ASCENDING "FBLK"S
	NUMVAL,		\LAST ELEMENT OF "STAB" ARRAY (MAXSTB)
	DIRCHG,		\"$A5" INDICATES DIRECTORY NEEDS TO BE SORTED
	PRDEV,		\DEFAULT DEVICE NUMBER
	DFNAME,		\THE DEFAULT FILE NAME AND EXTENTION
	TITLE,		\TITLE OF THE VOLUME
	UNUSED,		\UNUSED SPACE
	FLAGS;		\I.E: PACK, BACKUP, CHECK, UNLOCKED, SEARCH, ABORT
\INTEGER ARRAYS IN THE DIRECTORY:
int	FBLK,		\THE FIRST BLOCK OF EACH FILE
	LBLK,		\THE LAST BLOCK
	FEMBLK,		\EMPTY BLOCKS FILE LIST (FIRST BLOCK)
	LEMBLK,		\ (LAST BLOCK) SORTED LARGEST SIZE FIRST
	PMAXB,		\MAXIMUM BLOCK NUMBER (= UNIT SIZE -1)
	APEXID,		\A 4-BYTE VALUE USED TO RECOGNIZE AN APEX DISK
	VOLUME,		\UNIQUE VOLUME (DIRECTORY) ID NUMBER
	DIRDAT,		\DIRECTORY DATE (SYSTEM DATE)
	FDATE;		\DATE FOR EACH FILE

\THE SYSTEM GLOBALS:
int	DEVICE,
	DIRSIZ,		\DIR SIZE
	DIRBLK,		\WHERE DIRECT IS
	USERBLK,	\FIRST USER BLOCK
	FIRBLK,		\FIRST BLOCK OF FILE
	LASBLK,		\LAST BLOCK OF FILE
	FLNO,		\NUMBER OF FILE
	MAXBLK,		\HIGHEST BLOCK
	MAXFL,		\HIGHEST FILE NO
	CHAR,		\INPUT CHARACTER
	SWITCH,		\USER FILE SWITCH
	ARG1,		\USER ARGUMENT
	ARG2,		\USER ARGUMENT
	SPECIAL,	\SPECIAL BITS IN PROGRAM FILE REQUEST
	SYSDAT,		\SYSTEM DATE
	INSIZE,		\SIZE OF LAST OPENED INFILE
	INDATE,		\DATE OF LAST INFILE
	MAXSTB,		\SIZE OF STAB
	FILENO;		\RUN FILE NUMBER

int	DIRLEN;		\ARRAY: LENGTHS (IN WORDS) OF SEGMENTS OF THE DIRECTORY
def	MAXSEG=10;	\THE LAST SEGMENT (ELEMENT) IN "DIRLEN"
def	EXTPAT=$A5;	\FLAG PATTERN INDICATING EXTENDED DIR IS USED

\FOR MAIN:
int	II,UBL;

\FILE STATUS IN THE DIRECTORY
def	NULL=0,TENTATIVE=255,REPLACE=254,VALID=1;



proc	MOVIT(AB1,AB2,LEN);	\MOVE "LEN" WORDS INTO B1 FROM B2
int	AB1,AB2,LEN,LEN2;	\B1 & B2 ARE LEFT POINTING TO THE LAST POSITION
int	B1, B2, I;
begin
B1:=AB1(0);
B2:=AB2(0);
LEN2:=LEN+LEN;
BLIT(B1, B2, LEN2);
AB1(0):=B1 + LEN2;
AB2(0):=B2 + LEN2;
end;	\MOVIT



proc	GETDIR(DEV, BAKDIR);	\READ IN THE DIRECTORY
int	DEV, BAKDIR;
int	I, EXTDIR, BASE1, BASE2, BASE3;
begin
EXTDIR:=RESERVE(1024);

\READ THE EXTENDED DIR INTO "EXTDIR"
FREAD(DEV, if BAKDIR then 5 else 1, EXTDIR, DIRSIZ);

\READ PRIMARY DIRECTORY INTO THE BIG DIRECTORY SPACE
FREAD(DEV, if BAKDIR then 13 else 9, FNAME, DIRSIZ);

\MERGE THE EXTENDED DIRECTORY INTO THE PRIMARY DIRECTORY
BASE1:=FNAME+528;	\(FSTAT)
BASE2:=EXTDIR+528;
BASE3:=FSTAT;
for I:=0,MAXSEG do
	begin
	MOVIT(addr BASE3, addr BASE1, DIRLEN(I));
	MOVIT(addr BASE3, addr BASE2, DIRLEN(I));
	end;
BLIT(FNAME+528, EXTDIR, 528);

MAXFL:=if FLAGS(7)=EXTPAT then 95 else 47;
end;	\GETDIR




proc	PUTDIR(DEV, BAKDIR);	\WRITE THE DIRECTORY
int	DEV, BAKDIR;
int	I, EXTDIR, BASE1, BASE2, BASE3;
begin
EXTDIR:=RESERVE(1024);

\SEPARATE THE BIG DIR INTO THE PRIMARY DIR AND THE EXTENDED DIR
BLIT(EXTDIR, FNAME+528, 528);
BASE1:=FNAME+528;
BASE2:=EXTDIR+528;
BASE3:=FSTAT;
for I:=0,MAXSEG do
	begin
	MOVIT(addr BASE1, addr BASE3, DIRLEN(I));
	MOVIT(addr BASE2, addr BASE3, DIRLEN(I));
	end;

\IF EXTENDED DIR IS USED THEN WRITE "EXTDIR" INTO THE EXTENDED DIR
if FLAGS(7)=EXTPAT then
	FWRITE(DEV, if BAKDIR then 5 else 1, EXTDIR, DIRSIZ);

\WRITE THE PRIMARY DIR
FWRITE(DEV, if BAKDIR then 13 else 9, FNAME, DIRSIZ);

\NOW FIX THE BIG DIR
BLIT(FNAME+528, EXTDIR, 528);
end;	\PUTDIR



proc	WRTDIR;
addr	PARM;
int	BITS;
define	UNTUPD=$67;		\UNITS NEEDING ATTENTION
begin
PARM:=$BF00;
BITS:=[$01,$02,$04,$08,$10,$20,$40,$80];
PARM(UNTUPD):=PARM(UNTUPD)!BITS(DEVICE);
DIRCHG(0):=$A5;
APEXID(0):=$7061; APEXID(1):=$7865;
PUTDIR(DEVICE,false);
end;	\WRTDIR



proc	PRINT(FILE);
int	FILE,MIN,MAX,K,SIZE;
begin
for K:=0,7 do CHOUT(0,FNAME(FILE*11+K));
CHOUT(0,^.);
for K:=8,10 do CHOUT(0,FNAME(FILE*11+K));
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
SIZE:=MAX-MIN+1;
TEXT(0,"  ");INTOUT(0,SIZE);
if SIZE<10 then CHOUT(0,^ );
if SIZE<100 then CHOUT(0,^ );
CHOUT(0,^ );
INTOUT(0,MIN);
end;	\PRINT



proc	RDDIR;
begin
GETDIR(DEVICE,false);
MAXBLK:=PMAXB(0);
end;	\RDDIR



proc	SORT;		\BUBBLE SORT THE FILES INTO ASCENDING FBLK
int	I,J,T;
begin
J:=0;
for I:=0,MAXFL do
    if FSTAT(I)=VALID then
	[STAB(J):=I; J:=J+1];
MAXSTB:=J-1;
for I:=0,MAXSTB-1 do
if FBLK(STAB(I+1))<FBLK(STAB(I)) then
	\WE ARE OUT OF ORDER SO...
	begin
	J:=I;
	repeat begin
		T:=STAB(J);
		STAB(J):=STAB(J+1);
		STAB(J+1):=T;
		J:=J-1;
		end
	until (FBLK(STAB(J))<FBLK(STAB(J+1)))!(J<0);
	end;
end;	\SORT



proc	COPY(FROM,TO,SIZE);
int	FROM,TO,SIZE,BUFSIZ;
addr	BUFFER;
begin
BUFSIZ:=SPACE/256-4;
if BUFSIZ<=0 then BUFSIZ:=127;
BUFFER:=RESERVE(BUFSIZ*256);
while SIZE>BUFSIZ do
	begin
	FREAD(DEVICE,FROM,BUFFER,BUFSIZ);
	FWRITE(DEVICE,TO,BUFFER,BUFSIZ);
	FROM:=FROM+BUFSIZ;
	TO:=TO+BUFSIZ;
	SIZE:=SIZE-BUFSIZ;
	end;
FREAD(DEVICE,FROM,BUFFER,SIZE);
FWRITE(DEVICE,TO,BUFFER,SIZE);
end;	\COPY



proc	MOVE(I);
int	I,FBL,LBL,SIZ,FL;
begin
FL:=STAB(I);
FBL:=FBLK(FL);
LBL:=LBLK(FL);
SIZ:=LBL-FBL+1;
if UBL<FBL then
	begin
	TEXT(0,"MOVING: "); PRINT(FL);
	TEXT(0,"  TO  "); INTOUT(0,UBL);
	CRLF(0);
	COPY(FBL,UBL,SIZ);
	FBLK(FL):=UBL;
	LBLK(FL):=UBL+SIZ-1;
	WRTDIR;
	end;
UBL:=LBLK(FL)+1;
end;	\MOVE



begin	\MAIN PROC
DIRLEN:=[24, 48, 48, 6, 6, 24, 8, 16, 16, 48, 4];
DIRBLK:=9;
DIRSIZ:=4;
USERBLK:=17;

MAXFL:=95;	\SELECT SO THAT DIRSIZ IS RIGHT
				\RESERVE THE ARRAYS
II:=(MAXFL+1)*2;
				\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(II);
LBLK:=RESERVE(II);
				\BLOCK 3
FEMBLK:=RESERVE(24);
LEMBLK:=RESERVE(24);
STAB:=RESERVE(MAXFL+1);
NUMVAL:=RESERVE(1);
DIRCHG:=RESERVE(1);
PRDEV:=RESERVE(1);
PMAXB:=RESERVE(2);
DFNAME:=RESERVE(11);
UNUSED:=RESERVE(16);
TITLE:=RESERVE(64);
UNUSED:=RESERVE(24);
APEXID:=RESERVE(4);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
UNUSED:=RESERVE(32);
FDATE:=RESERVE(II);
FLAGS:=RESERVE(16);

TEXT(0,"-- DISK SQUASH, V1.8 --
UNIT? ");
DEVICE:=INTIN(0);
CRLF(0);

RDDIR;
SORT;
UBL:=USERBLK;
for II:=0,MAXSTB do MOVE(II);
WRTDIR;
PUTDIR(DEVICE,true);		\WRITE THE BACKUP DIR TOO
TEXT(0,"ALL DONE");
end;	\MAIN
