\STUDENT.XPL	AUG-26-90
\In this program the fundamental unit of data is the English word.
\Sentences are handled as linked lists of words.

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
	GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
	SCAN=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
	CHAIN=28,	OPENF=29,	WRITE=30,	READ=31,
	\TESTPT=32,\	FGET=33,	\FASAVE=34,\	FSAVE=35,
	BLIT=36,	BUTTON=37,	JOYSTICK=38,	\SOUND=39,\
	CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
	\SCREEN=44,\	\BLOCK=45,\	FIX=50,		BACKUP=64,
	WAITVB=107,
	BITMAP=108,	BITMAP2=109,	VIEW=110,	PALETTE=111,
	CARRY=112,	PEEK_W=113,	POKE_W=114,	PEEK_L=115,
	POKE_L=116,	SWAP_W=117,	EXT_L=118,	CURSOR1=119,
	BUTES1=120,	SHOCUR1=121,	DEVINFO=122,	UNTINFO=123,
	BUTES=124,	GETKEY=125,	KEYHIT=126,	SHOCUR=127;

def	BEL=$07, TAB=$09, CR=$0D, EOF=$1A, ESC=$1B, SP=$20;
def	TV=0, INDEV=3;
def	INTSIZE=4;
def	INF=$7FFFFFFF, NIL=0;

int	SENTENCE,
	NEWSEN,
	KNOWLEDGE,
	SRAM,
	DD,
	DD1,
	BLUE,
	;
addr	TOPMEM,		\Top of usable memory (heap) space +1
	RAM;		\Pointer to allocated heap space



func	ALLOCATE(AMOUNT);
\This reserves memory, but, unlike the RESERVE intrinsic, this doesn't
\ relinquish the space when the calling procedure returns.
int	AMOUNT;
addr	TEMP;
begin
TEMP:= RAM;
RAM:= RAM + AMOUNT;			\Reserve bytes
if RAM >= TOPMEM then
	begin
	CHOUT(TV, BEL);
	CRLF(TV);   TEXT(TV, "OUT OF BRAIN CELLS (I.E. RAM)");   CRLF(TV);
	exit;
	end;
return TEMP;
end;	\ALLOCATE



func	INSERT(A, L);	\Insert atom A at the head of the linked list L
int	A, L;		\This returns the new head of the list, thus the
int	L2, I;		\ form of the call is: L:= INSERT(A, L);
begin
L2:= ALLOCATE(2*INTSIZE);
\The 68000 requires even addresses for pointers to words
if L2 & 1 then [L2:= L2 +1;   I:= ALLOCATE(1)];

L2(0):= A;
L2(1):= L;
return L2;
end;	\INSERT



proc	PRINT(DEV, L);	\Print the linked list L on the specified device
int	DEV, L;		\This prints the last atom first
begin
if L # NIL then
	begin
	PRINT(DEV, L(1));
	TEXT(DEV, L(0));
	CHOUT(DEV, SP);
	end;
end;	\PRINT



proc	STRCOPY(A, B);	\Copy string A into B (includes string terminator)
addr	A, B;
int	I;
begin
for I:= 0, INF do
	[B(I):= A(I);
	if A(I) = 0 then return];
end;	\STRCOPY



func	STREQU(A, B);	\Returns 'true' if string A is equal to B.
\Note that strings must be the same length to be equal.
addr	A, B;
int	I;
begin
for I:= 0, INF do
	[if A(I) # B(I) then return false;
	if A(I) = 0 then return true];
end;	\STREQU



func	MEMBER(A, L);	\Returns 'true' if atom A is in linked list L
int	A, L;
begin
loop	[if L = NIL then return false;
	if STREQU(A, L(0)) then return true;
	L:= L(1)];
end;	\MEMBER



func	SEARCH(L1, L2);	\Search for list L1 in L2. Returns 'true' if found.
int	L1, L2;
int	L10, L20;
begin
if L1=NIL ! L2=NIL then return false;
L10:= L1;   L20:= L2;
loop	begin
	if STREQU(L1(0), L2(0)) then
		begin			\words match
		L1:= L1(1);		\get next atom
		L2:= L2(1);
		if L1 = NIL then return true;
		if L2 = NIL then return false;
		end
	else	begin			\words don't match
		L20:= L20(1);
		if L20 = NIL then return false;
		L1:= L10;
		L2:= L20;
		end;
	end;
end;	\SEARCH



func	SIZEOF(L);	\Returns the number of items in a linked list
int	L;
int	I;
begin
for I:= 0, INF do
	[if L = NIL then return I;
	L:= L(1)];
end;	\SIZEOF



func	COPYOF(L);	\Make a copy of the linked list L
\WARNING: This does not copy the atoms only the list of pointers.
int	L;
int	L2;

	proc	COPY(L);
	int	L;
	begin
	if L # NIL then
		begin
		COPY(L(1));
		L2:= INSERT(L(0), L2);
		end;
	end;	\COPY

begin
L2:= NIL;
COPY(L);
return L2;
end;	\COPYOF



func	GETSEN(DEV);
\Read in a sentence and return a pointer to its list of words.
\Currently, sentences must be terminated with a period.
int	DEV;
int	CH, L, L2;


	func	GETWORD;
	int	I;
	addr	WD, WD2;
	begin
	WD:= RESERVE(80);
	repeat CH:= CHIN(DEV); until CH#SP & CH#CR & CH#TAB;
	I:= 0;
	loop	begin
		if CH>=^a & CH<=^z then CH:= CH & $DF;	\Convert to uppercase
		if (CH<^A ! CH>^Z) & (CH<^0 ! CH>^9) then quit;
	\	if CH=SP ! CH=^, ! CH=^. ! CH=CR then quit;
		WD(I):= CH;
		if I < 80-1 then I:= I +1;
		CH:= CHIN(DEV);
		end;
	WD(I):= 0;		\TERMINATE STRING
	WD2:= ALLOCATE(I+1);
	STRCOPY(WD, WD2);
	return WD2;
	end;	\GETWORD


begin	\GETSEN
L:= NIL;
loop	begin
	L:= INSERT(GETWORD, L);
	if CH=^. ! CH=^? ! CH=^! then quit;
	end;
return L;
end;	\GETSEN



proc	DUMP(DEV, L);	\Print a list of lists on the specified device
int	DEV, L;		\This prints the last list first
begin
if L # NIL then
	begin
	DUMP(DEV, L(1));
	PRINT(DEV, L(0));
	CRLF(DEV);
	end;
end;	\DUMP



begin	\MAIN
RAM:= RESERVE(FREE-4000);		\Reserve memory for tree & lists
TOPMEM:= RESERVE(0);			\Pointer to top of usable memory

TEXT(TV,"
-- STUDENT, V0.0 --
");

OPENI(INDEV);
KNOWLEDGE:= NIL;
TEXT(TV, "READING...
");
loop	begin
	SRAM:= RAM;
	SENTENCE:= GETSEN(INDEV);	\Read in a sentence of the input file
	\PRINT(TV, SENTENCE);   CRLF(TV);

	\INTOUT(0, SIZEOF(SENTENCE));   CRLF(0);
	if SIZEOF(SENTENCE) <= 1 then quit;

	\If the sentence contains "is" or "are" then save the sentence
	if MEMBER("IS", SENTENCE) ! MEMBER("ARE", SENTENCE) then
		KNOWLEDGE:= INSERT(SENTENCE, KNOWLEDGE)
	else RAM:= SRAM;	\Discard the garbage
	end;

\Print all saved sentences
CRLF(TV);
DUMP(TV, KNOWLEDGE);

TEXT(TV, "
THAT WAS VERY IN-TER-ES-TING!
");

TEXT(TV, "
GO AHEAD, ASK ME A QUESTION ABOUT THE STUFF I JUST READ.
");
loop	begin
	SRAM:= RAM;
	SENTENCE:= GETSEN(0);	\FOR EXAMPLE: WHAT IS BLUE?

	\Assume first word is "WHAT"
	\Assume second word is "IS"
	\Search KNOWLEDGE for string following "IS" (BLUE)
	\SENTENCE(1):= NIL;

	\Go back until "IS" is found then replace it with NIL
	NEWSEN:= COPYOF(SENTENCE);
	DD:= NEWSEN;
	\PRINT(TV, NEWSEN);
	loop	begin
		if DD = NIL then quit;
		DD1:= DD(1);
		if DD1 = NIL then quit;
		if STREQU(DD1(0), "IS") ! STREQU(DD1(0), "ARE") then
			begin
			DD(1):= NIL;
			quit;
			end;
		DD:= DD1;
		end;

	DD:= KNOWLEDGE;
	loop	begin
		if DD = NIL then
			begin
			TEXT(TV, "I DON'T KNOW. TELL ME ");
			PRINT(TV, SENTENCE);
			CHOUT(TV, ^?);
			CRLF(TV);

			RAM:= SRAM;		\Discard question

			SENTENCE:= GETSEN(0);	\For example: The ball is blue.
			KNOWLEDGE:= INSERT(SENTENCE, KNOWLEDGE);
			quit;
			end;

		if SEARCH(NEWSEN, DD(0)) then	\If found then print KNOWLEDGE item
			begin
			PRINT(TV, DD(0));
			CHOUT(TV, ^.);
			CRLF(TV);

			RAM:= SRAM;		\Discard question

			quit;			\(Might have multiple answers
			end;			\ but don't say "I DON'T KNOW)

		DD:= DD(1);
		end;
	end;
end;	\MAIN
