\TRANTEST.XPL	APR-12-91
\XPL TRANSCENDENTAL FUNCTION TESTER

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	FIX=50,		GETKEY=125,	KEYHIT=126;
code real		RLRES=46,	RLIN=47,	RLOUT=48,
	FLOAT=49,	RLABS=51,	FORMAT=52,	SQRT=53,
	LN=54,		EXP=55,		SIN=56,		ATAN2=57,
	MOD=58,		LOG=59,		COS=60,		TAN=61,
	ASIN=62,	ACOS=63;

def	DEV=0;		\OUTPUT DEVICE



proc	SQRTTST;
int	I,J,K,N;
real	X,Y,Z,XMAX,ERRMAX,ERR;
begin
TEXT(DEV,"SQRT TEST...
");
FORMAT(0,20);
ERRMAX:= -1.0;
for N:= 1,1000 do
	begin
	I:= RAN(32767)-16000;
	J:= RAN(32767)-16000;
	Y:= FLOAT(J)/512.;
	X:= FLOAT(I)*EXP(Y);
	if X#0.0 then ERR:= RLABS((SQRT(X*X)-RLABS(X))/X);
	if ERR>ERRMAX then
		begin
		ERRMAX:= ERR;
		XMAX:= X;
		end;
	end;
TEXT(DEV,"MAX ERROR:	"); RLOUT(DEV,ERRMAX); CRLF(DEV);
TEXT(DEV,"X AT MAX ERROR:	"); RLOUT(DEV,XMAX); CRLF(DEV);
CRLF(DEV);

\X:= -99.99983E-6;
\TEXT(DEV,"X:		"); RLOUT(DEV,X); CRLF(DEV);
\TEXT(DEV,"X*X:		"); RLOUT(DEV,X*X); CRLF(DEV);
\TEXT(DEV,"SQRT(X*X):	"); RLOUT(DEV,SQRT(X*X)); CRLF(DEV);
\CRLF(DEV);
end;	\SQRTTST



proc	LNEXPTST;
int	I,J,K;
real	X,Y,Z,ERR,ERRMAX,XMAX,YMAX,ZMAX;
begin
TEXT(DEV, "LN/EXP TEST...
");
ERRMAX:= -1.0;
for I:= 1,1000 do
	begin
	J:= RAN(14000)-7000;
	X:= FLOAT(J)/1E6;
	ERR:= RLABS(LN(EXP(X))-X);
	if ERR>ERRMAX then
		begin
		ERRMAX:= ERR;
		XMAX:= X;
		end;
	end;
FORMAT(0,20);
TEXT(DEV,"MAX ERROR:	"); RLOUT(DEV,ERRMAX); CRLF(DEV);
TEXT(DEV,"X AT MAX ERROR:	"); RLOUT(DEV,XMAX); CRLF(DEV);
TEXT(DEV,"EXP(XMAX):	"); RLOUT(DEV,EXP(XMAX)); CRLF(DEV);
TEXT(DEV,"LN(EXP(XMAX)):	"); RLOUT(DEV,LN(EXP(XMAX))); CRLF(DEV);
CRLF(DEV);
end;	\LNEXPTST



proc	MODTST;
int	I,J,K;
real	X,Y,Z;
begin
TEXT(DEV, "MODULO TEST...
");
FORMAT(10,20);
loop	begin
	X:= RLIN(0);
	Y:= RLIN(0);
	Z:= MOD(X, Y);

	RLOUT(DEV,X); CRLF(DEV);
	RLOUT(DEV,Y); CRLF(DEV);
	RLOUT(DEV,Z); CRLF(DEV);
	end;
end;	\MODTST



proc	SINCOSTST;
int	I,J,K,N;
real	X,Y,Z,XMAX,YMAX,ZMAX,ERRMAX,ERR;
begin
TEXT(DEV,"SIN/COS TEST...
");
FORMAT(0,20);
ERRMAX:= 0.0;
for I:= -1000, 1000 do
	begin
	X:= FLOAT(I)/635.;	\-PI/2..+PI/2
	Y:= SIN(X);
	Y:= Y*Y;
	Z:= COS(X);
	Z:= Z*Z;
	ERR:= RLABS(Y +Z -1.0);
	if ERR>ERRMAX then
		begin
		ERRMAX:= ERR;
		XMAX:= X;
		YMAX:= Y;
		ZMAX:= Z;
		end;
	end;
TEXT(DEV,"MAX ERROR:	"); RLOUT(DEV,ERRMAX); CRLF(DEV);
TEXT(DEV,"X AT MAX ERROR:	"); RLOUT(DEV,XMAX); CRLF(DEV);
TEXT(DEV,"Y AT MAX ERROR:	"); RLOUT(DEV,YMAX); CRLF(DEV);
TEXT(DEV,"Z AT MAX ERROR:	"); RLOUT(DEV,ZMAX); CRLF(DEV);
CRLF(DEV);
end;	\SINCOSTST



proc	TANATANTST;
int	I, J, K;
real	X, Y, Z, ERRMAX, XMAX, ERR;
begin
TEXT(DEV, "TAN/ATAN TEST...
");
FORMAT(0, 20);
ERRMAX:= 0.0;
for I:= -500, 500 do
	begin
	X:= FLOAT(I) /320.0;		\-PI/2..+PI/2
	ERR:= RLABS(ATAN2(TAN(X), 1.) - X);
	if ERR>ERRMAX then
		[ERRMAX:= ERR;
		XMAX:= X];
	end;
TEXT(DEV,"MAX ERROR:	"); RLOUT(DEV,ERRMAX); CRLF(DEV);
TEXT(DEV,"X AT MAX ERROR:	"); RLOUT(DEV,XMAX); CRLF(DEV);
CRLF(DEV);
end;	\TANATANTST



proc	ATAN2TST;
int 	I,J,K;
real 	X,Y,Z,ERRMAX, XMAX, ERR;
begin 
TEXT(DEV,"ATAN2 TEST...
");
loop 	begin 
	X:= RLIN(0);
	Y:= RLIN(0);
	RLOUT(DEV,ATAN2(Y,X)); CRLF(DEV);
	end;
end;	\ATAN2TST



proc	SAVAGE;
int	I;
real	A;
begin
TEXT(DEV, "SAVAGE TEST...
");
FORMAT(18, 20);
A:= 1.0;
for I:= 1, 2499 do
	A:= TAN(ATAN2( EXP(LN(SQRT(A*A))), 1.0 )) +1.0;
RLOUT(DEV, A);
CRLF(DEV);
end;	\SAVAGE



begin	\MAIN
OPENO(DEV);
TEXT(DEV, "TRANSCENDENTAL FUNCTION TESTER, V1.0
");

SQRTTST;
LNEXPTST;
\MODTST;
SINCOSTST;
TANATANTST;
\ATAN2TST;
SAVAGE;

TEXT(DEV, "ALL DONE
");
CLOSE(DEV);
end;	\MAIN
