\XPLV4B - SEP 1978
\Modified 12-16-80 by Dana Trout for nicer tie-in with CP/M

\	COPYRIGHT P.J.R.BOYLE. 1977,78

\THIS VERSION MUST BE COMPILED BY V4 OR ITSELF
\THE CODE IT PRODUCES REQUIRES I2LV4B EXTENTIONS.

\THESE ARE THE REQUIRED MACHINE LANGUAGE FUNCTIONS:
code	ABS=0,		RANDOM=1,	REMAIN=2,	RESERVE=3,
	SWAP=4,		EXTEND=5,	SHORT=6,	CHARIN=7,
	CHAROUT=8,	CRLF=9,		NUMIN=10,	NUMOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	PRCALL=17,	SPACE=18,	RERUN=19,
	GETHEAP=20,	SETHEAP=21,	SETRUN=22,

			HEXBYT=57, 	MAKEFCB=58,	HEXIN=59,
	HEXOUT=60,	MLCALL=61,	PORTOUT=62,	PORTIN=63;


\RESERVED WORD HASHES\
'DEFINE'
ENDSYM=28261,	INTSYM=28265,	BEGSYM=25954,	PROCYM=29296,
ADRSYM=25697,	IFSYM=26217,	THENYM=26740,	ELSEYM=27749,
WHILYM=26743,	DOSYM=28516,	CODSYM=28515,	QUITYM=30065,
LOOPYM=28524,	REPSYM=25970,	LESYM=25964,	GESYM=25959,
GETSYM=25971,	FORSYM=28518,	NOTSYM=28526,	FPRSYM=28774,
UNTSYM=28277,	EXTSYM=30821,	TRUSYM=29300,	FALSYM=24934,
DEFSYM=25956,	ISSYM=29545,	IPNTYM=28777,	IOWNYM=28521,

\OTHER CONSTANTS
	SYMAX=200,	\MAX NUMBER OF SYMBOLS
	EOFSYM=26,	\CTRL-Z
	EMPTY=$FF,	\NULL POINTER

\ASCII CHARACTERS
SPACH=32,	LFCH=10,	RETCH=13,
FFCH=12,	TABCH=9;

\CODES FOR IDENTIFIER TYPES FOR IDTYP
'DEFINE'UNDEF,		\UNDEFINED
	INTVAR,		\INTEGER VARIABLE
	ADDVAR,		\ADDRESS VARIABLE
	FPRNAM,		\FOREWARD PROCEDURE
	PROCNAM,	\PROCEDURE
	INTPROC,	\INTRINSIC PROCEDURE
	FLTVAR,		\FLOATING VARIABLE
	BLKNAM,		\DEFERRED BLOCK
	IPTVAR,		\INTEGER POINTER
	IOWVAR,		\OWN VARIABLE
	CONNAM;		\CONSTANT NAME

\CODES FOR ATOM TYPES FOR ATYPE
'DEFINE'SPECIAL,	\RESERVED WORDS, FUNNY CHARS ETC.
	IDENTIFIER,	\AN IDENTIFIER
	CONSTANT;	\A CONSTANT


\THESE ARE PUT TOGETHER TO MAKE THEM EASIER FOR GETCHX
'INTEGER'
	CHAR,	\CURRENT CHARACTER BUFFER. MOST OF THE TIME
		\IT CONTAINS THE TERMINATOR OF THE CURRENT ATOM
	CC,	\INDEX TO CURRENT CHARACTER IN THE INPUT LINE
	LL,	\LENGTH OF THE CURRENT INPUT LINE
	STRFLG,	\BOOLEAN- STRING FLAG
	CASEIN,	\BOOLEAN- CASE SWITCH
	ALPHA,	\BOOLEAN- CURRENT CHAR IS ALPHABETIC
	NUMBER,	\BOOLEAN- CURRENT CHAR IS NUMERIC
	ALFNUM,	\BOOLEAN- ALPHA OR NUMBER
	LSTDEV,	\LISTING DEVICE NUMBER
	SRCDEV;	\SOURCE INPUT DEVICE NUMBER
'ADDRESS'
	LINE;	\SOURCE INPUT LINE BUFFER

'INTEGER'
\INTEGER VARIABLES FOR ACTUAL PROCESSING
	ATOM,	\PRESENT ATOM DESCRIPTOR
		\CONTAINS RESERVED WORD HASH OR THE ASCII FOR
		\A SPECIAL CHARACTER. 0 IF THE ATOM IS A
		\CONSTANT OR IDENTIFIER
	ATYPE,	\PRESENT ATOM TYPE DESCRIPTOR
	IDTYP,	\PRESENT IDENTIFIER TYPE DESCRIPTOR
	LEV,	\LEVEL OF CURRENT IDENTIFIER
	VAL,	\VALUE OR ADDRESS OF CURRENT IDENTIFIER
	IATOM,	\VALUE OF CURRENT CONSTANT
	SYMNUM,	\NUMBER IN SYMTAB OF CURRENT IDENT
	NOSYM,	\NUMBER OF SYMBOLS IN SYMBOL TABLE
	LEVEL,	\LEVEL OF CURRENT PROCEDURE
	T,	\GENERAL TEMPORARY
	PC,	\THE RELATIVE PROGRAM COUNTER
	DX,	\HEAP SPACE REQUIREMENT COUNTER
	FIXCNT,	\COUNT OF THE NUMBER OF OUTSTANDING QUITS
	BINDEV, \BINARY OUTPUT DEVICE
	OLDPC,	\SAVE SPACE FOR PC
	HASH;	\CURRENT IDENTIFIER HASH

'ADDRESS'
	IDNAM,	\CURRENT IDENTIFIER NAME
	SYMBOL,	\SYMBOL TABLE
	SYMTYP,	\SYMBOL TYPE DESCRIPTORS
	SYMLEV,	\SYMBOL LEVELS
	SYMPNT,	\SYMBOL LIST LINKAGE POINTERS
	BOX;	\HASH BOXES (SYMBOL LIST HEADERS)

\INTEGER ARRAYS:
'INTEGER'
	SYMVAL,	\SYMBOL VALUES OR ADDRESSES
	FIXES;	\QUIT FIXES STILL OUTSTANDING

\PROCEDURES NEEDED AT LEVEL 1
'FPROC'
	ERROR,INCH,GETCH,RATOM,GEN,FIX,LOOKUP,
	INSERT,PROCAL,BOOLEXP,ASSIGN,STAMNT,PROGRAM,
	OPENFILES;

'BEGIN'\MAIN PROGRAM\

\INITIALISE IO DEVICES
OPENI(0);OPENO(0);
CRLF(0);
TEXT(0,"XPL0 V4B - SEP 1978");
CRLF(0);
TEXT(0,"CP/M version  Latest revision 12-16-80");
CRLF(0);

\RESERVE ARRAYS\
LINE:=RESERVE(80);
IDNAM:=RESERVE(6);
SYMBOL:=RESERVE(6*SYMAX);
SYMTYP:=RESERVE(SYMAX);
SYMVAL:=RESERVE(2*SYMAX);
SYMLEV:=RESERVE(SYMAX);
SYMPNT:=RESERVE(SYMAX);
BOX:=RESERVE(64);
FIXES:=RESERVE(20);


BINDEV:=7;			\unprompted floppy disk
LSTDEV:=0;			\console
SRCDEV:=7;			\unprompted floppy disk
if LSTDEV#0 then OPENO(LSTDEV);
OPENFILES;

\PRESET SOME THINGS\

CHAR:=RETCH;		CASEIN:='FALSE';	CC:=1;
LL:=0;			STRFLG:='FALSE';	PC:=0;
LEVEL:=0;		NOSYM:=0;		FIXCNT:=0;
GETCH;
RATOM;
\ZERO THE SYMBOL TABLE
'FOR'T:=0,5'DO'IDNAM(T):=^ ;
'FOR'T:=0,63'DO'BOX(T):=EMPTY;

PROGRAM;

'WHILE'NOSYM>0'DO'
	[NOSYM:=NOSYM-1;
	'IF'SYMTYP(NOSYM)=FPRNAM'THEN'ERROR(66)];
'IF'ATOM=^;'THEN'RATOM;
'IF'ATOM#EOFSYM'THEN'ERROR(61);

CRLF(0);
TEXT(0,"PROGRAM LENGTH: ");
NUMOUT(0,PC+1);
CRLF(0);
CLOSE(LSTDEV);
CHAROUT(BINDEV,^$);
CLOSE(BINDEV);

'END';\OF MAIN


procedure OPENFILES;  \--------------------------------------------

define	CPMIO=5;

integer	CHAR,
	REGPAIR,
	FILENOTFOUND,
	I;

address	STRING,
	REGIMAG,
	REGRTN,
	READFCB,
	WRITEFCB;

begin
READFCB:=1430;			\location of the read file control block
WRITEFCB:=1470;			\location of the write file control block
REGRTN:=624;			\location of reg image return area
REGIMAG:=RESERVE(8);		\set aside 8 bytes for reg image
REGPAIR:=REGIMAG;	\REGPAIR let's us access a register pair at a time
STRING:=RESERVE(20);

FILENOTFOUND:=true;
repeat
begin
	CRLF(0);
	TEXT(0,"Enter file name");
	I:=0;
	repeat
	 	begin
	 	CHAR:=CHARIN(0);
		\convert filename to upper case
		if CHAR >= ^a & CHAR <= ^z then CHAR:=CHAR-^a+^A;
	 	STRING(I):=CHAR;
	 	I:=I+1;
	 	end
	until CHAR=^. ! CHAR=13\carriage return\;
	if CHAR#13 then
	 	begin
	 	repeat CHAR:=CHARIN(0) until CHAR=13;	\empty input buffer
	 	end;
	STRING(I-1):=^.;		\make read file extension .XPL
	STRING(I):=^X;
	STRING(I+1):=^P;
	STRING(I+2):=^L;
	STRING(I+3):=0;			\terminate the string with a null
	MAKEFCB(READFCB,STRING);
	STRING(I):=^I;			\make write file extension .I2L
	STRING(I+1):=^2;
	MAKEFCB(WRITEFCB,STRING);
	REGIMAG(3):=17;			\search for filename
	REGPAIR(2):=SWAP(READFCB);
	MLCALL(CPMIO,REGIMAG);
	if REGRTN(1)#255 then FILENOTFOUND:=false
	 	else
	 	begin
	 	TEXT(0,"File not on disk: try again");
	 	CRLF(0);
	 	end;
end
until FILENOTFOUND=false;
OPENI(7);				\open read file
OPENO(7);				\delete any file with same name as
					\write file then open write file
end;\OPENFILES\

			'PROCEDURE'ERROR(ERRNO);

define	CPMIO=5;
integer	ERRNO,
	REGPAIR,
	FILENOTFOUND,
	CHAR,
	I;
address	ECLASS,
	STRING,
	REGIMAG,
	REGRTN,
	READFCB,
	WRITEFCB;

'FPROC'ERRMES;
\+++++++++++
procedure FINDERROR;
integer I;

procedure FINDBACK;	\----------------------------------------

begin
loop
	begin
	CHAR:=CHARIN(3);	\look for backslash
	if CHAR=^\ then quit;
	end;
CHAR:=CHARIN(3);		\get first char following backslash
end;	\  FINDBACK

procedure GETCLASS;	\-----------------------------------------
integer	I;

begin
CHAR:=CHARIN(3);
if CHAR=^\ then
	begin	\end of table
	CRLF(0);
	TEXT(0,"Undocumented error");
	CRLF(0);
	ABORT;
	end
else
	begin
	ECLASS(0):=CHAR;
	I:=1;
	repeat
		begin
		ECLASS(I):=CHARIN(3);
		I:=I+1;
		end
	until ECLASS(I-1)=^\;	\class terminated by backslash
	CHAR:=CHARIN(3);	\get first char after backslash
	if CHAR=^\ then GETCLASS;
	end;
end;	\GETCLASS

begin	\  FINDERROR	------------------------------------------
loop
	begin
	FINDBACK;		\find first backslash and read following char
	if CHAR=^\ then GETCLASS;  \either error class or end of error table

\the character in CHAR is the first digit of an error number
	I:=CHAR-^0;
	CHAR:=CHARIN(3);
	if CHAR>=^0 & CHAR<=^9
		then
		begin
			I:=10*I+CHAR-^0;
			CHAR:=CHARIN(3);	\point to first char of msg
		end;
	if I=ERRNO then quit;
	end;
end;	\FINDERROR

procedure PRINTERROR;	\---------------------------------------
integer	I;

begin
CRLF(0);
I:=0;
loop
	begin
	if ECLASS(I)=^\ then quit;
	CHAROUT(0,ECLASS(I));
	I:=I+1;
	end;
loop
	begin
	CHAR:=CHARIN(3);
	if CHAR=^\ then quit;
	CHAROUT(0,CHAR);
	end;
end;	\PRINTERROR

\+++++++++++
'BEGIN'\ERROR
CLOSE(BINDEV);
ERRMES(LSTDEV);
'IF'LSTDEV#0'THEN'ERRMES(0);

READFCB:=1430;			\location of the read file control block
WRITEFCB:=1470;			\location of the write file control block
REGRTN:=624;			\location of reg image return area
REGIMAG:=RESERVE(8);		\set aside 8 bytes for reg image
REGPAIR:=REGIMAG;	\REGPAIR lets us access a register pair at a time
STRING:="V4BERROR.MSG        ";
STRING(12):=0;			\terminate the string with a null
FILENOTFOUND:=true;
MAKEFCB(READFCB,STRING);
REGIMAG(3):=17;			\search for filename
REGPAIR(2):=SWAP(READFCB);
MLCALL(CPMIO,REGIMAG);
if REGRTN(1)#255 then FILENOTFOUND:=false;
if FILENOTFOUND=false then OPENI(7)	\open the file if it's there
	else ABORT;
ECLASS:=RESERVE(256);	\set up string space for error class message
FINDERROR;
PRINTERROR;
ABORT;
end;

		'PROCEDURE'ERRMES(DEV);
'INTEGER'DEV;

'BEGIN'
CRLF(DEV);
TEXT(DEV,"***** ERROR NO ");
NUMOUT(DEV,ERRNO);
TEXT(DEV," *****");
CRLF(DEV);
'FOR'T:=0,LL'DO'CHAROUT(DEV,LINE(T));
CRLF(DEV);
'FOR'T:=0,CC-3'DO'
	'IF'LINE(T)#TABCH'THEN'CHAROUT(DEV,SPACH)
	'ELSE'CHAROUT(DEV,TABCH);
CHAROUT(DEV,^^);
CRLF(DEV);
'END';

\DONE ERROR

			'PROCEDURE'INCH;

'FPROC'INCHX,PUTX;

'BEGIN'\INCH
\TAKE OUT LINE FEEDS, FORM FEEDS AND COMMENTS
INCHX;
'IF'STRFLG'THEN'['IF'CHAR=^"'THEN'STRFLG:='FALSE']
'ELSE'	'BEGIN'
	'WHILE'(CHAR=LFCH)!(CHAR=FFCH)'DO'PUTX;
	'IF'CHAR=^\'THEN'
		'BEGIN'
		\IGNORE COMMENTS
		'REPEAT'PUTX'UNTIL'(CHAR=^\)!(CHAR=RETCH);
		PUTX;
		'END';
	'IF'CHAR=^"'THEN'STRFLG:='TRUE';
	'END'
'END'\INCH\;

		'PROCEDURE'INCHX;
'BEGIN'
'IF'CHAR#EOFSYM'THEN'CHAR:=CHARIN(SRCDEV)
'ELSE''IF'STRFLG'THEN'ERROR(63);
'IF'CHAR=^^'THEN'
	'BEGIN'
	CHAROUT(LSTDEV,CHAR);
	CHAR:=CHARIN(SRCDEV)!128;
	'END';
'END';

		'PROCEDURE'PUTX;
'IF'(CHAR#RETCH)'THEN'
	['IF'CHAR#LFCH'THEN'CHAROUT(LSTDEV,CHAR&127);INCHX];

\DONE INCH

			'PROCEDURE'GETCH;

'BEGIN'\GETCH
'IF' CC>LL 'THEN'
	'BEGIN'
	CRLF(LSTDEV);
	LL:=0;
	CC:=0;
	INCH;
	'WHILE'(CHAR#RETCH)&(CHAR#EOFSYM)
	'DO'
		'BEGIN'
		LINE(LL):=CHAR;
		CHAROUT(LSTDEV,CHAR&127);
		INCH;
		LL:=LL+1;
		'IF'LL>79'THEN'ERROR(1);
		'END';
	LINE(LL):=CHAR;
	'END';
CHAR:=LINE(CC);
CC:=CC+1;
'IF'CHAR=\SINGLE QUOTE\39'THEN'
	'BEGIN'
	CASEIN:='NOT'CASEIN;
	CHAR:=^ ;
	'END';

\SWITCH CASE IF CASEIN IS 'TRUE'\
'IF'CASEIN&(CHAR>=^A)&(CHAR<=^Z)
	'THEN'CHAR:=CHAR+32;

ALPHA:=((CHAR>=^A)&(CHAR<=^Z)) ! 
    ((CHAR>=\LOWER CASE A\97)&(CHAR<=\LOWER CASE Z\122));
NUMBER:=(CHAR>=^0)&(CHAR<=^9);
ALFNUM:=ALPHA!NUMBER;

'END'\GETCH\;



			'PROCEDURE'RATOM;

'INTEGER'LEN;

'BEGIN'\READ IN AN ATOM\
'WHILE'
   (CHAR=SPACH)!(CHAR=RETCH)!(CHAR=TABCH)
'DO'GETCH;
'IF'(CHAR>=\LOW A\97)&(CHAR<=\LOW Z\122)'THEN'(RESWRD)
'ELSE''IF'ALPHA'THEN'(IDENTDO)
'ELSE''IF'NUMBER'THEN'(CONSTDO)
'ELSE''IF'CHAR=^$'THEN'(HEXCONST)
'ELSE'(SPECCHAR);

\PARTS OF RATOM

RESWRD'IS'
	'BEGIN'
	\RESERVED WORD\
	ATOM:=CHAR;
	GETCH;
	ATOM:=ATOM+SWAP(CHAR);
	'WHILE'ALPHA'DO'GETCH;
	ATYPE:=SPECIAL;
	'END';

IDENTDO'IS'
	'BEGIN'
	\IDENTIFIER\
	LEN:=0;HASH:=0;
	'WHILE'ALFNUM'DO'
		'BEGIN'
		'IF'CHAR>=\LOW A\97'THEN'ERROR(64);
		'IF'LEN<6'THEN'
			'BEGIN'
			IDNAM(LEN):=CHAR;
			HASH:=HASH+CHAR;
			LEN:=LEN+1;
			'END';
		GETCH;
		'END';
	'FOR'LEN:=LEN,5'DO'
		'BEGIN'
		IDNAM(LEN):=^ ;
		HASH:=HASH+^ ;
		'END';
	ATYPE:=IDENTIFIER;
	ATOM:=0;
	HASH:=HASH&63;
	'END';

CONSTDO'IS'
	'BEGIN'
	\CONSTANT\
	IATOM:=0;
	'WHILE'NUMBER'DO'
		[IATOM:=IATOM*10+CHAR-^0;GETCH];
	ATYPE:=CONSTANT;
	ATOM:=0;
	'END';

HEXCONST'IS'
	'BEGIN'\HEXADECIMAL CONSTANT
	GETCH;
	IATOM:=0;
	'LOOP'	'BEGIN'
		'IF'CHAR>=^0 & CHAR<=^9'THEN'
			IATOM:=IATOM*16+CHAR-^0
		'ELSE''IF'CHAR>=^A & CHAR<=^F'THEN'
			IATOM:=IATOM*16+CHAR-^A+10
		'ELSE''QUIT';
		GETCH;
		'END';
	ATYPE:=CONSTANT;
	ATOM:=0;
	'END';

SPECCHAR'IS'
	'BEGIN'
	\SPECIAL CHARACTER\
	'IF'LINE(CC)=^='THEN'
		'BEGIN'
		'IF'CHAR=^:'THEN'
			[GETCH;ATOM:=GETSYM]
		'ELSE''IF'CHAR=^>'THEN'
			[GETCH;ATOM:=GESYM]
		'ELSE''IF'CHAR=^<'THEN'
			[GETCH;ATOM:=LESYM]
		'ELSE'ATOM:=CHAR;
		'END'
	'ELSE'ATOM:=CHAR;
	ATYPE:=SPECIAL;
	GETCH;
	'END';

'END'\OF RATOM\;

			'PROCEDURE'GEN(OP,LEV,VAL,CL);

'INTEGER'OP,LEV,VAL,CL;

'BEGIN'\GEN\
\THE ENCODING OF THE CLASS, CL IS A 4 BIT BINARY CODE...
\0:=OP CODE ONLY, 1 BYTE
\2:=OP WITH ONE BYTE VALUE
\3:=OP WITH VALUE, 3 BYTES
\7:=OP WITH ADDRESS, 3 BYTES
\10:=OP WITH LEVEL AND ONE BYTE OFFSET (IN VAL)
\15:=OP WITH LEVEL AND ADDRESS, 4 BYTES
'IF'PC#OLDPC'THEN'[CRLF(BINDEV);CHAROUT(BINDEV,^;);HEXOUT(BINDEV,PC)];
'IF'(OP=1)&(LEV=0)'THEN'
	'BEGIN'
	\MAGIC OPCODE
	HEXBYT(BINDEV,VAL/2!128);\SHORT GLOBAL LOAD
	PC:=PC+1;
	'END'
'ELSE'	'BEGIN'
	\NOT SPECIAL
	HEXBYT(BINDEV,OP);PC:=PC+1;
	'IF'CL&8'THEN'[HEXBYT(BINDEV,LEV);PC:=PC+1];
	'IF'CL&4'THEN'
		'BEGIN'
		CHAROUT(BINDEV,^*);
		HEXOUT(BINDEV,VAL);
		PC:=PC+2;
		'END'
	'ELSE'
		'BEGIN'
		'IF'CL&2'THEN'[HEXBYT(BINDEV,VAL);PC:=PC+1];
		'IF'CL&1'THEN'[HEXBYT(BINDEV,SWAP(VAL));PC:=PC+1];
		'END';
	'END';
OLDPC:=PC;
'END'\GEN\;



			'PROCEDURE'FIX(I);

'INTEGER'I,J;
'BEGIN'\FIX FORWARD REFRENCES\
CRLF(BINDEV);CHAROUT(BINDEV,^^);
HEXOUT(BINDEV,I+1);
'END'\FIX\;



			'PROCEDURE'LOOKUP;

'INTEGER'I,K,PNTR;

'BEGIN'\LOOKUP
PNTR:=BOX(HASH);
'LOOP'
	'BEGIN'
	'IF'PNTR=EMPTY'THEN'[IDTYP:=UNDEF;'QUIT'];
	I:=0;
	K:=PNTR;
	'WHILE'(IDNAM(I)=SYMBOL(K))&(I<6)
		'DO'[I:=I+1;K:=K+SYMAX];
	'IF'I=6'THEN'
		'BEGIN'
		IDTYP:=SYMTYP(PNTR);
		VAL:=SYMVAL(PNTR);
		LEV:=SYMLEV(PNTR);
		SYMNUM:=PNTR;
		'QUIT';
		'END';
	PNTR:=SYMPNT(PNTR);
	'END';
'END';\LOOKUP


			'PROCEDURE'INSERT(STYP,SLEV,SVAL);

'INTEGER'STYP,SLEV,SVAL,I,K;

'BEGIN'\INSERT\
LOOKUP;
'IF'(IDTYP#UNDEF)&(LEV=LEVEL)'THEN'ERROR(11);
'IF'NOSYM>=SYMAX'THEN'ERROR(3);
K:=NOSYM;
'FOR'I:=0,5'DO'
	'BEGIN'
	SYMBOL(K):=IDNAM(I);
	K:=K+SYMAX;
	'END';
SYMLEV(NOSYM):=SLEV;
SYMVAL(NOSYM):=SVAL;
SYMTYP(NOSYM):=STYP;
SYMPNT(NOSYM):=BOX(HASH);
BOX(HASH):=NOSYM;
NOSYM:=NOSYM+1;
'END'\INSERT\;

			'PROCEDURE'PROCAL;

'INTEGER'SVAL,SLEV,ACNT;

'BEGIN'
'IF'IDTYP=PROCNAM ! IDTYP=FPRNAM'THEN'(PROCCALL)
'ELSE''IF'IDTYP=INTPROC'THEN'(INTCALL);

\PARTS OF PROCAL

PROCCALL'IS'
	'BEGIN'
	\PROCEDURE CALL\
	SVAL:=VAL;
	SLEV:=LEV+2;
	RATOM;
	ACNT:=0;
	'IF'ATOM=^('THEN'
		'BEGIN'
		ACNT:=0;
		'REPEAT'[RATOM;BOOLEXP;ACNT:=ACNT+2]
		'UNTIL'ATOM#^,;
		'IF'ATOM#^)'THEN'ERROR(44);
		RATOM;
		'END';
	'IF'ATOM=GETSYM'THEN'[RATOM;BOOLEXP;ACNT:=ACNT+2];
	'IF'ACNT>0'THEN'GEN(\ARG\10,0,ACNT-1,2);
	GEN(\CAL\5,SLEV,SVAL,15);
	'END';

INTCALL'IS'
	'BEGIN'
	\INTRINSIC CALL\
	SVAL:=VAL;
	RATOM;
	'IF'ATOM=^('THEN'
		'BEGIN'
		'REPEAT'[RATOM;BOOLEXP]
		'UNTIL'ATOM#^,;
		'IF'ATOM#^)'THEN'ERROR(44);
		RATOM;
		'END';
	'IF'ATOM=GETSYM'THEN'[RATOM;BOOLEXP];
	GEN(\CML\12,0,SVAL,2);
	'END';

'END';

			'PROCEDURE'BOOLEXP;

'INTEGER'OP,P1,P2;
'FPROC'EXPRESSION,LOGEXP;

'BEGIN'\BOOLEXP\
'IF'ATOM=IFSYM'THEN'(CONDEXP)
'ELSE''IF'ATOM=NOTSYM'THEN'
	[RATOM;BOOLEXP;GEN(\NOT\28,0,0,0)]
'ELSE'LOGEXP;
'WHILE'(ATOM=^!)!(ATOM=^&)'DO'
	'BEGIN'
	OP:=ATOM;
	RATOM;
	LOGEXP;
	'IF'OP=^!'THEN'GEN(\OR\26,0,0,0)
	'ELSE'GEN(\AND\27,0,0,0);
	'END';

CONDEXP'IS'
	'BEGIN'
	RATOM;
	BOOLEXP;\THE CONDITION
	P1:=PC;
	GEN(\JPC\8,0,0,7);
	'IF'ATOM#THENYM'THEN'ERROR(22);
	RATOM;
	BOOLEXP;\TRUE CASE
	'IF'ATOM#ELSEYM'THEN'ERROR(30);
	P2:=PC;
	GEN(\JMP\7,0,0,7);
	FIX(P1);
	RATOM;
	BOOLEXP;\FALSE CASE
	FIX(P2);	
	'END';

'END'\BOOLEXP\;



		'PROCEDURE'EXPRESSION;

'INTEGER'OP;
'FPROC'FACTOR,TERM;

'BEGIN'\EXPRESS\
'WHILE'ATOM=^+'DO'RATOM;
'IF'ATOM=^-'THEN'
	[RATOM;EXPRESSION;GEN(\NEG\17,0,0,0)]
'ELSE'TERM;
'WHILE'(ATOM=^+)!(ATOM=^-)'DO'
	'BEGIN'
	OP:=ATOM;
	RATOM;
	TERM;
	'IF'OP=^+'THEN'GEN(\ADD\13,0,0,0)
	'ELSE'GEN(\SUB\14,0,0,0);
	'END';
'END'\EXPRES\;

	'PROCEDURE'FACTOR;

'INTEGER'SVAL,SLEV,SPC,SCHAR;

'BEGIN'\FACTOR\
'IF'ATYPE=SPECIAL'THEN'(DOSPEC)
'ELSE''IF'ATYPE=CONSTANT'THEN'(DOINTCON)
'ELSE'(DOIDENT);

\PARTS OF FACTOR:

DOSPEC'IS'
	'BEGIN'
	'IF'ATOM=^('THEN'(DOSUBEXP)
	'ELSE''IF'ATOM=^"'THEN'(DOSTRING)
	'ELSE''IF'ATOM=ADRSYM'THEN'(DOADRS)
	'ELSE''IF'ATOM=TRUSYM'THEN'
		GEN(\IMS\36,0,(0=0),2)
	'ELSE''IF'ATOM=FALSYM'THEN'
		GEN(\IMS\36,0,(0=1),2)
	'ELSE''IF'ATOM>128'THEN'
		GEN(\IMS\36,0,ATOM&127,2)
	'ELSE'ERROR(26);
	RATOM;
	'END';

\PARTS OF DOSPEC:

DOSUBEXP'IS'
	'BEGIN'
	\PARENTHESIZED EXPRESSION\
	RATOM;
	BOOLEXP;
	'IF'ATOM#^)'THEN'ERROR(44);
	'END';

DOSTRING'IS'
	'BEGIN'
	\STRING CONSTANT\
	SVAL:=PC;
	GEN(\JMP\7,0,0,7);
	SPC:=PC;
	CRLF(BINDEV);CHAROUT(BINDEV,^;);HEXOUT(BINDEV,PC);
	'WHILE'CHAR#^"'DO'
		'BEGIN'
		HEXBYT(BINDEV,CHAR&127);
		PC:=PC+1;
		SCHAR:=CHAR;
		GETCH;
		'END';
	CRLF(BINDEV);CHAROUT(BINDEV,^;);HEXOUT(BINDEV,PC-1);
	HEXBYT(BINDEV,SCHAR!128);
	GETCH;
	FIX(SVAL);
	GEN(\IMM\11,0,SPC,7);
	'END';

DOADRS'IS'
	'BEGIN'
	RATOM;
	'IF'ATYPE#IDENTIFIER'THEN'ERROR(45);
	LOOKUP;
	'IF'(IDTYP=INTVAR)!(IDTYP=ADDVAR)
		'THEN'GEN(\ADR\33,LEV,VAL,10)
	'ELSE''IF'IDTYP=IOWVAR'THEN'GEN(\IMM\11,0,VAL,7)
	'ELSE'ERROR(43);
	'END';

DOINTCON'IS'
	'BEGIN'
	\LITERAL INTEGER CONSTANT\
	'IF'ABS(IATOM)<128'THEN'GEN(\IMS\36,0,IATOM,2)
	'ELSE'GEN(\IMM\11,0,IATOM,3);
	RATOM;
	'END';

DOIDENT'IS'
	'BEGIN'
	\IDENTIFIER\
	LOOKUP;
	'IF'IDTYP=UNDEF'THEN'ERROR(10);
	'IF'IDTYP=INTVAR'THEN'(DOINTVAR)
	'ELSE''IF'IDTYP=ADDVAR'THEN'(DOADVAR)
	'ELSE''IF'IDTYP=IPTVAR'THEN'(DOIPVAR)
	'ELSE''IF'IDTYP=IOWVAR'THEN'(DOIWVAR)
	'ELSE''IF'IDTYP>=FPRNAM & IDTYP<=INTPROC'THEN'
		'BEGIN'\PROCEDURE CALL
		SVAL:=IDTYP;
		PROCAL;
		'IF'SVAL#5'THEN'GEN(\LOD\1,0,0,10);
		'END'
	'ELSE''IF'IDTYP=CONNAM'THEN'
		'BEGIN'\CONSTANT
		'IF'ABS(VAL)<128'THEN'GEN(\IMS\36,0,VAL,2)
		'ELSE'GEN(\IMM\11,0,VAL,3);
		RATOM;
		'END'
	'ELSE'ERROR(27);
	'END'\IDENTIFIER\;

\PARTS OF DOIDENT:

DOINTVAR'IS'
	'BEGIN'
	\INTEGER VARIABLE\
	GEN(\LOD\1,LEV,VAL,10);
	RATOM;
	'IF'ATOM=^('THEN'
		'BEGIN'\IT IS INDEXED
		'REPEAT''BEGIN'
			RATOM;
			BOOLEXP;\INDEXES
			GEN(\DBI\32,0,0,0);
			'END'
		'UNTIL'ATOM#^,;
		'IF'ATOM#^)'THEN'ERROR(44);
		RATOM;
		'END';
	'END';

DOADVAR'IS'
	'BEGIN'
	\ADDRESS VARIABLE\
	RATOM;
	'IF'ATOM#^('THEN'GEN(\LOD\1,LEV,VAL,10)
	'ELSE'
		'BEGIN'
		\ARRAY ELEMENT REFRENCE\
		SLEV:=LEV;
		SVAL:=VAL;
		RATOM;
		EXPRESSION;\INDEX\
		'IF'ATOM#^)'THEN'ERROR(44);
		GEN(\LDX\2,SLEV,SVAL,10);
		RATOM;
		'END';
	'END';

DOIPVAR'IS'
	'BEGIN'
	GEN(\LOD\1,LEV,VAL,10);
	GEN(\LDI\34,0,0,0);
	RATOM;
	'END';

DOIWVAR'IS'
	'BEGIN'
	GEN(\LDA\35,0,VAL,7);
	RATOM;
	'IF'ATOM=^('THEN'
		'BEGIN'
		'REPEAT''BEGIN'
			RATOM;
			BOOLEXP;
			GEN(\DBI\32,0,0,0);
			'END'
		'UNTIL'ATOM#^,;
		'IF'ATOM#^)'THEN'ERROR(44);
		RATOM;
		'END';
	'END';

'END'\FACT\;

	'PROCEDURE'TERM;

'INTEGER'OP;

'BEGIN'\TERM\
FACTOR;
'WHILE'(ATOM=^*)!(ATOM=^/)'DO'
	'BEGIN'
	OP:=ATOM;
	RATOM;
	FACTOR;
	'IF'OP=^*'THEN'GEN(\MUY\15,0,0,0)
	'ELSE'GEN(\DIV\16,0,0,0);
	'END';
'END'\TERM\;

\DONE EXPRESSION

		'PROCEDURE'LOGEXP;

'INTEGER'OP;

'BEGIN'\LOGEXP\
EXPRESSION;
'IF'	(ATOM=^=)!(ATOM=^#)!(ATOM=^>)!
	(ATOM=^<)!(ATOM=GESYM)!(ATOM=LESYM)
'THEN'	'BEGIN'
	OP:=ATOM;RATOM;EXPRESSION;
	'IF'OP=^='THEN'GEN(\EQ\18,0,0,0)
	'ELSE''IF'OP=^#'THEN'GEN(\NE\19,0,0,0)
	'ELSE''IF'OP=^>'THEN'GEN(\GT\21,0,0,0)
	'ELSE''IF'OP=^<'THEN'GEN(\LT\23,0,0,0)
	'ELSE''IF'OP=GESYM'THEN'GEN(\GE\20,0,0,0)
	'ELSE'GEN(\LE\22,0,0,0);
	'END';
'END'\LOGEXP\;

\DONE BOOLEXP

			'PROCEDURE'ASSIGN;

'INTEGER'SVAL,SLEV,OP,SPC;
'DEFINE'INTSTOR,BYTIND,INTIND;\TYPE OF STORE

'BEGIN'
\INCLUDES PROC CALLS\
'IF'ATYPE#IDENTIFIER'THEN'ERROR(20);
LOOKUP;

'IF'IDTYP=UNDEF'THEN'ERROR(10);
'IF'IDTYP>=FPRNAM & IDTYP<=INTPROC'THEN'PROCAL
'ELSE''IF'IDTYP=BLKNAM'THEN'(BLKSPEC)
'ELSE''BEGIN'\TRUE ASSIGN\
	SLEV:=LEV;
	SVAL:=VAL;
	'IF'IDTYP=INTVAR'THEN'(INTSTR)
	'ELSE''IF'IDTYP=ADDVAR'THEN'(BYTSTR)
	'ELSE''IF'IDTYP=IPTVAR'THEN'(IPTSTR)
	'ELSE''IF'IDTYP=IOWVAR'THEN'(IOWSTR);
	'IF'ATOM#GETSYM'THEN'ERROR(21);
	RATOM;
	BOOLEXP;
	'IF'OP=INTSTOR'THEN'GEN(\STO\3,SLEV,SVAL,10)
	'ELSE''IF'OP=BYTIND'THEN'GEN(\STX\4,SLEV,SVAL,10)
	'ELSE'GEN(\STD\31,0,0,0);
	'END'\TRUE ASSIGN\;

BLKSPEC'IS'
	'BEGIN'\DEFERRED BLOCK SPECIFICATION
	SVAL:=VAL;
	SPC:=PC;
	RATOM;
	'IF'ATOM#ISSYM'THEN'ERROR(29);
	GEN(\JMP\7,0,0,7);\JMP AROUND IT
	FIX(SVAL);\POINT CALL HERE
	SYMTYP(SYMNUM):=UNDEF;\USED UP
	RATOM;
	STAMNT;
	GEN(\JMP\7,0,SVAL+3,7);\RETURN
	FIX(SPC);
	'END';

INTSTR'IS'
	'BEGIN'
	RATOM;
	'IF'ATOM=^('THEN'
		'BEGIN'\INDEXED INTEGER
		GEN(\LOD\1,SLEV,SVAL,10);
		RATOM;\EAT THE PAREN
		BOOLEXP;\FIRST INDEX
		'WHILE'ATOM=^,'DO'
			'BEGIN'
			GEN(\DBI\32,0,0,0);
			RATOM;\THE COMMA
			BOOLEXP;\NEXT INDEX
			'END';
		GEN(\DBA\30,0,0,0);
		'IF'ATOM#^)'THEN'ERROR(44);
		\WE HAVE ITS ADDRESS ON STACK
		OP:=INTIND;
		RATOM;\MOVE TO THE :=
		'END'
	'ELSE'OP:=INTSTOR;\STORE INTO VARIABLE\
	'END';

BYTSTR'IS'
	'BEGIN'\STORE TO BYTE\
	RATOM;
	'IF'ATOM=^('THEN'
		'BEGIN'
		OP:=BYTIND;
		RATOM;
		BOOLEXP;
		'IF'ATOM#^)'THEN'ERROR(44);
		RATOM;
		'END'
	'ELSE'OP:=INTSTOR;
	'END'\BYTE STORE\;

IPTSTR'IS'
	'BEGIN'
	GEN(\LOD\1,SLEV,SVAL,10);
	OP:=INTIND;
	RATOM;
	'END';

IOWSTR'IS'
	'BEGIN'
	RATOM;
	OP:=INTIND;
	'IF'ATOM=^('THEN'
		'BEGIN'
		GEN(\LDA\35,0,SVAL,7);
		RATOM;\PAST PAREN
		BOOLEXP;
		'WHILE'ATOM=^,'DO'
			'BEGIN'
			GEN(\DBI\32,0,0,0);
			RATOM;\THE COMMA
			BOOLEXP;\NEXT INDEX
			'END';
		GEN(\DBA\30,0,0,0);
		'IF'ATOM#^)'THEN'ERROR(44);
		RATOM;\TO THE :=
		'END'
	'ELSE'GEN(\IMM\11,0,SVAL,7);
	'END';

'END'\PROC ASSIGN\;

			'PROCEDURE'STAMNT;

'INTEGER'P2,P3,SFIXS,SLEV,SVAL;

'BEGIN'\STAMNT\
'IF'(ATOM=BEGSYM)!(ATOM=^[)'THEN'(BLKSMT)
'ELSE''IF'ATOM=QUITYM'THEN'(QUITSMT)
'ELSE''IF'ATOM=REPSYM'THEN'(REPSMT)
'ELSE''IF'ATOM=IFSYM'THEN'(IFSMT)
'ELSE''IF'ATOM=WHILYM'THEN'(WHILSMT)
'ELSE''IF'ATOM=EXTSYM'THEN'(EXITSMT)
'ELSE''IF'ATOM=LOOPYM'THEN'(LOOPSMT)
'ELSE''IF'ATOM=FORSYM'THEN'(FORSMT)
'ELSE''IF'ATOM=^('THEN'(DEFSMT)
'ELSE''IF'
	(ATOM=ELSEYM)!(ATOM=^;)!
	(ATOM=^])!(ATOM=ENDSYM)
	'THEN'\NULL STATEMENT\
'ELSE''IF'ATOM=EOFSYM'THEN'ERROR(62)
'ELSE' ASSIGN;

BLKSMT'IS'
	'BEGIN'\BLOCK STATEMENT\
	'REPEAT'[RATOM;STAMNT]'UNTIL'ATOM#^;;
	'IF'ATOM=EOFSYM'THEN'ERROR(62);
	'IF'(ATOM#ENDSYM)&(ATOM#^])'THEN'ERROR(20);
	RATOM;
	'END';

QUITSMT'IS'
	'BEGIN'
	'IF'FIXCNT>9'THEN'ERROR(4);
	FIXES(FIXCNT):=PC;
	FIXCNT:=FIXCNT+1;
	GEN(\JMP\7,0,0,7);
	RATOM;
	'END';

REPSMT'IS'
	'BEGIN'
	P2:=PC;
	RATOM;
	STAMNT;
	'IF'ATOM#UNTSYM'THEN'ERROR(28);
	RATOM;
	BOOLEXP;
	GEN(\JPC\8,0,P2,7);
	'END';

IFSMT'IS'
	'BEGIN'
	\IF STATEMENT\
	RATOM;
	BOOLEXP;
	P3:=PC;
	GEN(\JPC\8,0,0,7);
	'IF'ATOM#THENYM'THEN'ERROR(22);
	RATOM;
	STAMNT;
	'IF'ATOM=ELSEYM'THEN'
		'BEGIN'
		P2:=PC;
		GEN(\JMP\7,0,0,7);
		FIX(P3);
		P3:=P2;
		RATOM;
		STAMNT;
		'END';
	FIX(P3);
	'END';

WHILSMT'IS'
	'BEGIN'
	\WHILE STATEMENT\
	RATOM;
	P2:=PC;
	BOOLEXP;
	P3:=PC;
	GEN(\JPC\8,0,0,7);
	'IF'ATOM#DOSYM'THEN'ERROR(23);
	RATOM;
	STAMNT;
	GEN(\JMP\7,0,P2,7);
	FIX(P3);
	'END';

EXITSMT'IS'
	'BEGIN'\EXIT STATEMENT
	RATOM;
	'IF'(ATOM#ELSEYM)&(ATOM#^;)&
	(ATOM#^])&(ATOM#ENDSYM)'THEN'
		'BEGIN'
		BOOLEXP;
		GEN(\STO\3,0,0,10);
		'END';
	GEN(\RET\6,0,0,0);
	'END';

LOOPSMT'IS'
	'BEGIN'
	\LOOP STATEMENT\
	SFIXS:=FIXCNT;
	RATOM;
	P2:=PC;
	STAMNT;
	GEN(\JMP\7,0,P2,7);
	'WHILE'FIXCNT>SFIXS'DO'
		'BEGIN'
		FIXCNT:=FIXCNT-1;
		FIX(FIXES(FIXCNT));
		'END';
	'END';

FORSMT'IS'
	'BEGIN'
	\FOR STATEMENT\
	RATOM;
	'IF'ATYPE#IDENTIFIER'THEN'ERROR(43);
	LOOKUP;
	'IF'IDTYP#INTVAR'THEN'ERROR(43);
	SLEV:=LEV;
	SVAL:=VAL;
	RATOM;
	'IF'ATOM#GETSYM'THEN'ERROR(21);
	RATOM;
	BOOLEXP;
	GEN(\STO\3,SLEV,SVAL,10);
	'IF'ATOM#^,'THEN'ERROR(24);
	RATOM;
	BOOLEXP;
	'IF'ATOM#DOSYM'THEN'ERROR(23);
	GEN(\LOD\1,SLEV,SVAL,10);
	P2:=PC;
	GEN(\FOR\24,0,0,7);
	RATOM;
	STAMNT;
	GEN(\INC\25,SLEV,SVAL,10);
	GEN(\JMP\7,0,P2,7);
	FIX(P2);
	'END';

DEFSMT'IS'
	'BEGIN'
	RATOM;
	'IF'ATYPE#IDENTIFIER'THEN'ERROR(45);
	INSERT(BLKNAM,0,PC);
	GEN(\JMP\7,0,0,7);
	RATOM;
	'IF'ATOM#^)'THEN'ERROR(44);
	RATOM;
	'END';

'END'\STATEMENT\;

			'PROCEDURE'PROGRAM;

'INTEGER'P1,TEMAT,REFCNT;
'DEFINE'ANYTYPE,FOREWARD;
'FPROC'FPRDEF,PRODEF,INTDEF,ADRDEF,CONDEF,CODDEF,IPTDEF,IOWDEF;

'BEGIN'\PROC PROGRAM\
'IF'LEVEL=0'THEN'DX:=2'ELSE'DX:=0;
P1:=PC;
REFCNT:=0;
GEN(\JMP\7,0,0,7);
'WHILE'
(ATOM=CODSYM)!(ATOM=INTSYM)!(ATOM=ADRSYM)!
(ATOM=DEFSYM)!(ATOM=IOWNYM)!(ATOM=IPNTYM)
'DO'
	'IF'ATOM=CODSYM'THEN'[RATOM;CODDEF]
	'ELSE''IF'ATOM=INTSYM'THEN'[RATOM;INTDEF]
	'ELSE''IF'ATOM=ADRSYM'THEN'[RATOM;ADRDEF]
	'ELSE''IF'ATOM=IPNTYM'THEN'[RATOM;IPTDEF]
	'ELSE''IF'ATOM=IOWNYM'THEN'[RATOM;IOWDEF]
	'ELSE'[RATOM;CONDEF];
'WHILE'ATOM=PROCYM ! ATOM=FPRSYM 'DO'
	'BEGIN'
	TEMAT:=ATOM;
	RATOM;
	'IF'ATYPE#IDENTIFIER'THEN'ERROR(45);
	'IF'TEMAT=PROCYM'THEN'PRODEF(ANYTYPE)'ELSE'FPRDEF;
	'IF'ATOM#^;'THEN'ERROR(41);
	RATOM;
	'END';
'IF'PC=P1+3'THEN'PC:=P1
'ELSE'FIX(P1);
'IF'DX#0'THEN'GEN(\SPI\9,0,DX,2);
STAMNT;
GEN(\RET\6,0,0,0);
'IF'FIXCNT#0'THEN'ERROR(60);
'WHILE'REFCNT>0'DO'
	'BEGIN'
	'IF'ATOM#^;'THEN'ERROR(41);
	RATOM;\PAST THE SEMI
	'IF'ATOM#PROCYM'THEN'ERROR(66);
	RATOM;\TO THE NAME
	'IF'ATYPE#IDENTIFIER'THEN'ERROR(45);
	PRODEF(FOREWARD);
	'END';
'END'\PROGRAM\;

		'PROCEDURE'FPRDEF;

'BEGIN'
'REPEAT''BEGIN'
	INSERT(FPRNAM,LEVEL,PC);
	GEN(\JMP\7,0,0,7);
	REFCNT:=REFCNT+1;
	RATOM;
	'IF'ATOM=^,'THEN'RATOM;
	'END'
'UNTIL'ATYPE#IDENTIFIER;
'END';\FPRDEF


		'PROCEDURE'PRODEF(TYPE);

'INTEGER'TYPE,P2,CDX,HASH,I,K,STYP;

'BEGIN'
\PROCEDURE DECLARATION\
LOOKUP;
'IF'IDTYP=FPRNAM 'THEN'
	'BEGIN'\FIX FORWARD PROCEDURE
	'IF'LEVEL#LEV'THEN'ERROR(65);
	FIX(VAL);
	SYMVAL(SYMNUM):=PC;
	SYMTYP(SYMNUM):=PROCNAM;
	REFCNT:=REFCNT-1;
	'END'
'ELSE'['IF'TYPE=ANYTYPE'THEN'INSERT(PROCNAM,LEVEL,PC)
	'ELSE'ERROR(66)];
LEVEL:=LEVEL+2;
'IF'LEVEL>14'THEN'ERROR(5);
P2:=NOSYM;
CDX:=DX;
\NOW EAT THE ARGUMENT LIST AS A COMMENT
'WHILE'ATOM#^;'DO'RATOM;
RATOM;
PROGRAM;
DX:=CDX;
\NOW RESTORE SYMBOL TABLE TO PREVIOUS LEVEL
'WHILE'NOSYM>P2'DO'
	'BEGIN'
	NOSYM:=NOSYM-1;
	HASH:=0;
	K:=NOSYM;
	'FOR'I:=0,5'DO'[HASH:=HASH+SYMBOL(K);K:=K+SYMAX];
	BOX(HASH&63):=SYMPNT(NOSYM);
	STYP:=SYMTYP(NOSYM);
	'IF'STYP=FPRNAM ! TYPE=BLKNAM'THEN'ERROR(66);
	'END';
LEVEL:=LEVEL-2;
'END'\PROCEDURE DEFINITION\;

		'PROCEDURE'CONDEF;

'INTEGER'COUNTER,SIGN;

'BEGIN'
\DEFINE CONSTANT NAMES\
COUNTER:=0;
'WHILE'ATYPE=IDENTIFIER'DO'
	'BEGIN'
	RATOM;
	'IF'ATOM#^='THEN'
		'BEGIN'
		INSERT(CONNAM,0,COUNTER);
		COUNTER:=COUNTER+1;
		'END'
	'ELSE'	'BEGIN'
		RATOM;
		'IF'ATOM=^-'THEN'[SIGN:=-1;RATOM]
		'ELSE'SIGN:=1;
		'IF'ATYPE#CONSTANT'THEN'ERROR(42);
		INSERT(CONNAM,0,IATOM*SIGN);
		RATOM;
		'END';
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;
'END'\CONSTANT DEFINITION\;


		'PROCEDURE'CODDEF;

'BEGIN'
\DEFINE MACHINE LANGUAGE INTRINSIC NAMES\
'WHILE'ATYPE=IDENTIFIER'DO'
	'BEGIN'
	RATOM;
	'IF'ATOM#^='THEN'ERROR(40);
	RATOM;
	'IF'ATYPE#CONSTANT'THEN'ERROR(42);
	'IF'(IATOM<0)!(IATOM>63)
		'THEN'ERROR(6);
	INSERT(INTPROC,0,IATOM+64);
	RATOM;
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;
'END'\FUNCTION NAME DEFINITION\;

		'PROCEDURE'INTDEF;

'BEGIN'
\DEFINE INTEGER VARIABLES\
'WHILE'ATYPE=IDENTIFIER'DO'
	'BEGIN'
	INSERT(INTVAR,LEVEL,DX);
	DX:=DX+2;
	RATOM;
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;
'END'\INTEGER DEFINITION\;


		'PROCEDURE'ADRDEF;

'BEGIN'
\DEFINE ADDRESS VARIABLES\
'WHILE'ATYPE=IDENTIFIER'DO'
	'BEGIN'
	INSERT(ADDVAR,LEVEL,DX);
	DX:=DX+2;
	RATOM;
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;
'END'\ADDRESS DEFINITION\;

		'PROCEDURE'IPTDEF;

'BEGIN'
\DEFINE INTEGER POINTER VARIABLES\
'WHILE'ATYPE=IDENTIFIER'DO'
	'BEGIN'
	INSERT(IPTVAR,LEVEL,DX);
	DX:=DX+2;
	RATOM;
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;
'END'\INT POINTER DEFINITION\;


		'PROCEDURE'IOWDEF;

'INTEGER'K,N,TPC,I;

'BEGIN'
\DEFINE OWN VARIABLES\
'WHILE'ATYPE=IDENTIFIER'DO'
	'BEGIN'
	INSERT(IOWVAR,0,PC);
	RATOM;
	CRLF(BINDEV);
	'IF'ATOM=^('THEN'(OWNARRAY)
	'ELSE'[HEXOUT(BINDEV,0);PC:=PC+2];
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;

OWNARRAY'IS'
	'BEGIN'
	CHAROUT(BINDEV,^*);
	HEXOUT(BINDEV,PC+2);
	PC:=PC+2;
	K:=1;
	RATOM;\PAST THE PAREN
	'IF'ATYPE#CONSTANT'THEN'ERROR(42);
	N:=IATOM;\FIRST DIMEN
	RATOM;
	'WHILE'ATOM=^,'DO'
		'BEGIN'
		CRLF(BINDEV);
		RATOM;\PAST THE COMMA
		'IF'ATYPE#CONSTANT'THEN'ERROR(42);
		TPC:=PC+K*N*2;
		'FOR'I:=1,K*N'DO'
			'BEGIN'
			CHAROUT(BINDEV,^*);
			HEXOUT(BINDEV,TPC);
			PC:=PC+2;
			TPC:=TPC+IATOM*2;
			'END';
		K:=K*N;
		N:=IATOM;
		RATOM;\PAST THIS DIMEN
		'END';
	PC:=PC+K*N*2;\THE ACTUAL SPACE
	'IF'ATOM#^)'THEN'ERROR(44);
	RATOM;
	'END';

'END'\OWN DEFINITION\;

\DONE PROGRAM

\DONE MAIN
