\VESAINFO.XPL	JUL-25-99
\VESA CONFIGURATION INFO BY LOREN BLANEY
\YOU'LL PROBABLY WANT TO REDIRECT THE OUTPUT TO THE PRINTER LIKE SO:
\   VESA > PRN     or    VESA | MORE
\
\REVISIONS:
\AUG-09-93, Original.
\JUL-25-99, Added comments stating that this only works for 16-bit XPL.

inc	C:\CXPL\CODESI;	\Include code definitions for intrinsic routines

def	NUL=$00, BEL=$07, BS=$08, TAB=$09, LF=$0A, FF=$0C,	\Control chars
	CR=$0D, EOF=$1A, ESC=$1B, SP=$20;

int	CPUREG;	\Address of CPU register array (from GETREG)
int	DATASEG;

def	AX, BX, CX, DX, DI, SI, BP, CF, CS, DS, SS, ES;		\GETREG registers


char	BUF;
int	II, JJ, SEG, OFF, CH;

\----------------------------------------------------------------------

proc	GETINFO(MODE);		\Return super VGA info
int	MODE;
char	BUF;
int	I;
begin
BUF:= RESERVE(256);
for I:= 0, 255 do BUF(I):= 0;

CPUREG(AX):= $4F01;
CPUREG(CX):= MODE;	\MODE NUMBER RETURNED BY $4F00
CPUREG(ES):= DATASEG;
CPUREG(DI):= BUF;
SOFTINT($10);
TEXT(0, "STATUS IN AX REGISTER:		$");
HEXOUT(0, CPUREG(AX));
CRLF(0);
CRLF(0);

TEXT(0, "MODE ATTRIBUTES:		$");
HEXOUT(0, BUF(0));
TEXT(0, "
   BIT:	0 = SUPPORTED IN H/W		3 = COLOR/MONO ($3D4/$3B4)
  	1 = EXTENDED INFO AVAIL (BELOW)	4 = GRAPHICS/TEXT
	2 = SUPPORTED BY BIOS
");

TEXT(0, "WINDOW 'A' ATTRIBUTES:		$");
HEXOUT(0, BUF(2));
TEXT(0, "
   BIT:	0 = SUPPORTED	1 = READABLE	2 = WRITABLE
");

TEXT(0, "WINDOW 'B' ATTRIBUTES:		$");
HEXOUT(0, BUF(3));
TEXT(0, "
   BIT:	0 = SUPPORTED	1 = READABLE	2 = WRITABLE
");

TEXT(0, "WINDOW GRANULARITY (KB):	");
I:= BUF+4;
INTOUT(0, I(0));
CRLF(0);

TEXT(0, "WINDOW SIZE (KB):		");
I:= BUF+6;
INTOUT(0, I(0));
CRLF(0);

TEXT(0, "WINDOW 'A' START SEGMENT:	$");
I:= BUF+8;
HEXOUT(0, I(0));
CRLF(0);

TEXT(0, "WINDOW 'B' START SEGMENT:	$");
I:= BUF+10;
HEXOUT(0, I(0));
CRLF(0);

TEXT(0, "POINTER TO WINDOW FUNCTION 05:	$");
I:= BUF+14;
HEXOUT(0, I(0));
CHOUT(0,^:);
I:= BUF+12;
HEXOUT(0, I(0));
CRLF(0);

TEXT(0, "BYTES PER (LOGICAL) SCAN LINE:	");
I:= BUF+16;
INTOUT(0, I(0));
CRLF(0);

TEXT(0, "
EXTENDED INFORMATION
~~~~~~~~~~~~~~~~~~~~
HORIZONTAL RESOLUTION:		");
I:= BUF+18;
INTOUT(0, I(0));
CRLF(0);

TEXT(0, "VERTICAL RESOLUTION:		");
I:= BUF+20;
INTOUT(0, I(0));
CRLF(0);

TEXT(0, "CHARACTER CELL WIDTH:		");
INTOUT(0, BUF(22));
CRLF(0);

TEXT(0, "CHARACTER CELL HEIGHT:		");
INTOUT(0, BUF(23));
CRLF(0);

TEXT(0, "NUMBER OF MEMORY PLANES:	");
INTOUT(0, BUF(24));
CRLF(0);

TEXT(0, "BITS PER PIXEL:			");
INTOUT(0, BUF(25));
CRLF(0);

TEXT(0, "NUMBER OF BANKS:		");
INTOUT(0, BUF(26));
CRLF(0);

TEXT(0, "MEMORY MODEL TYPE:		");
I:= ["TEXT MODE", "CGA GRAPHICS", "HERCULES GRAPHICS",
	"4-PLANE PLANAR", "PACKED PIXEL", "NON-CHAIN 2, 256 COLOR",
	"DIRECT COLOR", "YUV"];
TEXT(0, I(BUF(27)&7) );
CRLF(0);

TEXT(0, "BANK SIZE (KB):			");
INTOUT(0, BUF(28));
CRLF(0);

TEXT(0, "NUMBER OF IMAGES:		");
INTOUT(0, BUF(29));
CRLF(0);
CRLF(0);

TEXT(0, "SIZE OF DIRECT COLOR RED MASK:	");
INTOUT(0, BUF(31));
CRLF(0);
TEXT(0, "POSITION OF LSB OF RED MASK:	");
INTOUT(0, BUF(32));
CRLF(0);
TEXT(0, "SIZE OF GREEN MASK:		");
INTOUT(0, BUF(33));
CRLF(0);
TEXT(0, "LSB OF GREEN MASK:		");
INTOUT(0, BUF(34));
CRLF(0);
TEXT(0, "SIZE OF BLUE MASK:		");
INTOUT(0, BUF(35));
CRLF(0);
TEXT(0, "LSB OF BLUE MASK:		");
INTOUT(0, BUF(36));
CRLF(0);
TEXT(0, "SIZE OF RESERVED MASK:		");
INTOUT(0, BUF(37));
CRLF(0);
TEXT(0, "LSB OF RESERVED MASK:		");
INTOUT(0, BUF(38));
CRLF(0);
TEXT(0, "DIRECT COLOR MODE ATTRIBUTES:	");
INTOUT(0, BUF(39));
TEXT(0, "
   BIT:	0 = COLOR RAMP IS PROGRAMMABLE/FIXED
	1 = BITS IN RESERVED FIELD ARE USABLE");
CRLF(0);
CRLF(0);
end;	\GETINFO

\----------------------------------------------------------------------

begin	\MAIN
CPUREG:= GETREG;
DATASEG:= CPUREG(12);

BUF:= RESERVE(256);
for II:= 0, 255 do BUF(II):= 0;

TEXT(0, "-- VESA SUPER VGA BIOS EXTENSION CONFIGURATION --
                VERSION 1.2

");
CPUREG(AX):= $4F00;
CPUREG(ES):= DATASEG;
CPUREG(DI):= BUF;
SOFTINT($10);

if CPUREG(AX) # $004F then
	[TEXT(0, "VESA IS NOT PRESENT.
");   exit];

\SIGNATURE
TEXT(0, "SIGNATURE: ");
for II:= 0, 3 do
	CHOUT(0, BUF(II));
CRLF(0);

\VERSION
TEXT(0, "VESA VERSION: ");
INTOUT(0, BUF(5));
CHOUT(0, ^.);
INTOUT(0, BUF(4));
CRLF(0);

\OEM STRING POINTER (ONLY WORKS FOR 16-BIT XPL)
TEXT(0, "OEM: ");
II:= BUF+6;
OFF:= II(0);
SEG:= II(1);
loop	begin
	CH:= PEEK(SEG, OFF);
	if CH = 0 then quit;
	CHOUT(0, CH);
	OFF:= OFF +1;
	end;
CRLF(0);

\CAPABILITIES:
TEXT(0, if BUF(10) & 1 then "DAC WIDTH IS SWITCHABLE"
else "DAC WIDTH IS FIXED AT 6 BITS PER PRIMARY COLOR");
CRLF(0);

\VIDEO MODE POINTER
\LIST OF SUPER VGA SUPPORTED MODE NUMBERS
TEXT(0, "SUPPORTED SUPER VGA MODES (HEX):
");
II:= BUF+14;
OFF:= II(0);
SEG:= II(1);	\ONLY WORKS FOR 16-BIT XPL
loop	begin
	II:= PEEK(SEG, OFF);
	OFF:= OFF +1;
	JJ:= PEEK(SEG, OFF);
	OFF:= OFF +1;
	II:= II ! SWAP(JJ);
	if II = $FFFF then quit;
	CHOUT(0, TAB);   HEXOUT(0, II);
	CRLF(0);
	end;

\TOTAL MEMORY (NUMBER OF 64K BLOCKS)
TEXT(0, "NUMBER OF 64K BLOCKS OF MEMORY: ");
II:= BUF+18;
INTOUT(0, II(0));
CRLF(0);

\TEXT(0, "ANY KEY TO CONTINUE...");
\OPENI(0);
\II:= CHIN(1);

\DUMP
\TEXT(0, "
\
\DUMP OF VIDEO INFO BLOCK:
\");
\for II:= 0, 255 do
\	begin
\	HEXOUT(0, BUF(II)); TEXT(0, " ");
\	if (II & $0F)= $0F then CRLF(0);
\	end;
\CRLF(0);


\LIST OF SUPER VGA SUPPORTED MODE NUMBERS
TEXT(0, "
INFO FOR SUPPORTED SUPER VGA MODES
");
II:= BUF+14;
OFF:= II(0);
SEG:= II(1);
loop	begin
	II:= PEEK(SEG, OFF);
	OFF:= OFF +1;
	JJ:= PEEK(SEG, OFF);
	OFF:= OFF +1;
	II:= II ! SWAP(JJ);
	if II = $FFFF then quit;
	TEXT(0, "----------------------------------------------------------------------
MODE: ");
	HEXOUT(0, II);
	CRLF(0);
	GETINFO(II);
	end;
CRLF(0);
CRLF(0);
end;	\MAIN
