	page	59,130
;VSHOW.ASM	JUL-28-99
;External routines for 3D.XPL by Loren Blaney
;
;Revisions:
;FEB-05-96, Original (for XPL4)
;JUL-28-99, Modify for XPLP (and TASM 3.1)

;WARNING: Registers are not preserved in these routines.

	.386
cseg	segment dword public use32 'code'
	assume cs:cseg,ds:dseg


dseg	segment	dword public use32 'data'
vpage	dw	?	;Particular chunk of video RAM that is currently accessable
			; Each Page contains WinSize KB of video RAM.
dseg	ends

	public	VShow

;-------------------------------------------------------------------------------
;Display 640x480x8 image at specified address
; VShow(ScreenBuf, GranShift);
;
VShow:
	mov	eax,[esp+4]	;get GranShift



; debug	mov	byte ptr cs:setp10-1,al	;modify code
;	mov	eax,[esp+8]	;get address of ScreenBuf
	mov	esi,[esp+8]	;get address of ScreenBuf

;Convert ScreenBuf, which is an offset from DataSeg to an absolute
; address, then convert this absolute address to an absolute segment
; address (and hope ScreenBuf starts on a paragraph boundary).
;ds:= (ds<<4+eax)>>4
;	xor	edx,edx
;	mov	dx,ds
;	shl	edx,4
;	add	eax,edx
;	shr	eax,4
;	mov	ds,ax		;point data segment to ScreenBuf

;	mov	ax,0a000h	;point extra segment to video memory
;	mov	es,ax

;Register usage:
; esi = Index into ScreenBuf
; edi  = Video memory pointer

;; ds  = Segment address of start of ScreenBuf
;; es  = Segment address of Video Memory (A000h)

;	cld			;for stosw instruction below
	mov	vpage,0		;Page:= 0;

	call	setpage

;	xor	esi,esi

	mov	dx,4
show110:mov	ecx,16384	;65536/4  TASM 3.1 bug
;show110:mov	ecx,32768	;65536/2  TASM 3.1 bug
;	xor	edi,edi		;start in upper-left corner of screen
	mov	edi,0a0000h	;start in upper-left corner of screen

;	db	067h		;address size prefix for 32 bits
;				;(otherwise si is used instead of esi)
;	rep movsd		;es:[edi++] := ds:[esi++]  ecx--

	test	ecx,ecx
	je	short show125
show120:mov	eax,[esi]
	add	esi,4
	mov	fs:[edi],eax
	add	edi,4
	dec	ecx
	jne	short show120
show125:
	inc	vpage		;Page:= Page +1;
	call	setpage
	dec	dx
	jne	show110

	mov	ecx,45056/4
;	mov	ecx,45056/2
;	xor	edi,edi		;start in upper-left corner of screen
	mov	edi,0a0000h	;start in upper-left corner of screen

;	db	067h		;address size prefix for 32 bits
;				;(otherwise si is used instead of esi)
;	rep movsd		;es:[edi++] := ds:[esi++]  ecx--

	test	ecx,ecx
	je	short show135
show130:mov	eax,[esi]
	add	esi,4
	mov	fs:[edi],eax
	add	edi,4
	dec	ecx
	jne	short show130
show135:
	ret	2*4		;drop 2 args

;-------------------------------------------------------------------------------
;CallInt($10, $4F05, 0, 0, WinSize/GranSize*Page);
;
setpage:
	push	bx		;save registers
	push	dx

	mov	ax,4f05h	;next page
	xor	bx,bx		;window A
	mov	dx,vpage
	shl	dx,4		;modified code, GranShift
setp10:
	int	10h		;Softint($10);

	pop	dx		;restore registers
	pop	bx
	ret

;-------------------------------------------------------------------------------
;Get necessary information for mode $101
;
;getinfo:
;	mov	ax,seg info	;Cpureg(11\ES\):= DataSeg;
;	mov	es,ax
;	mov	ax,4f01h	;Cpureg(0\AX\):= $4F01;
;	mov	cx,0101h	;Cpureg(2\CX\):= $101;
;	mov	di,offset info	;Cpureg(4\DI\):= Info;
;	int	10h		;Softint($10);
;
;	mov	ax,[di]+6	;WinSize:= Info(6) + Info(7)<<8;
;	mov	winsize,ax
;	shl	ax,10		;WS1024:= WinSize * 1024; (64*1024 overflow is ok)
;	mov	ws1024,ax
;	mov	ax,[di]+4	;GranSize:= Info(4) + Info(5)<<8;
;	mov	gransize
;	ret

;-------------------------------------------------------------------------------
;Draw a horizontal line
; HLine(ScreenBuf, X0, Y0, X1, C);
;	 20        16  12   8  4
;
	public	HLine
HLine:	mov	ecx,[esp+8]	;X1
	sub	ecx,[esp+16]	;X0
	inc	ecx		;length of line including end point

	mov	edi,[esp+12]	;Y0, index for ScreenBuf
	imul	edi,640		;*VWidth
	add	edi,[esp+16]	;+X0

	mov	esi,[esp+4]	;color
	mov	eax,[esp+20]	;ScreenBuf
;	push	es		;save critical register

;Convert ScreenBuf, which is an offset from DataSeg to an absolute
; address, then convert this absolute address to an absolute segment
; address (and hope ScreenBuf starts on a paragraph boundary).
;es:= (ds<<4+eax)>>4
;	xor	edx,edx
;	mov	dx,ds
;	shl	edx,4
;	add	eax,edx
;	shr	eax,4
;	mov	es,ax		;point extra segment to ScreenBuf

	add	edi,eax		;add ScreenBuf

	mov	ax,si		;color
	mov	ah,al		;make 4 copies of color for double-word store
	mov	dx,ax
	shl	eax,16
	mov	ax,dx

	mov	edx,ecx		;save length
	and	ecx,03h		;
;	db	067h		;address size prefix for 32-bit addresss
;	rep stosb		;es:[edi++] := al   ecx--

	test	ecx,ecx
	je	short hl15
hl10:	mov	[edi],al
	inc	edi
	dec	ecx
	jne	short hl10
hl15:

	mov	ecx,edx		;restore length
	shr	ecx,2		;divide length by 4 for double-word store
;	db	067h		;address size prefix for 32-bit addresss
;	rep stosd		;es:[edi++] := eax   ecx--


	test	ecx,ecx
	je	short hl25
hl20:	mov	[edi],eax
	add	edi,4
	dec	ecx
	jne	short hl20
hl25:

;	pop	es
	ret	5*4		;drop 5 args

;-------------------------------------------------------------------------------
;Given R, G, B, and Palette return the closest color register
;ColorReg:= BestColor(Palette, R, G, B);
;                     16       12 8  4
; Register usage:
;  ax = DR, DG, DB,	Difference in red, green, and blue
;  ax = D,		Difference in combined colors
;  ch = SJ		Saved index of closest color (returned output)
;  cl = J,		Color register index [0..255]
;  dx = scratch
;  si = Palette(J3),
;  di = Min,		Difference in combined colors of closest color
;
smcode	equ	12h		;constant for a byte of self-modifying code

	public	BestColor
BestColor:
	mov	si,[esp+16]	;Palette
	mov	al,[esp+12]	;Red
	mov	byte ptr cs:smc10-1,al	;modify code
	mov	al,[esp+8]	;Green
	mov	byte ptr cs:smc20-1,al	;modify code
	mov	al,[esp+4]	;Blue
	mov	byte ptr cs:smc30-1,al	;modify code
	jmp short $+2		;flush instruction pipeline for modified code

	mov	di,7fffh	;Min:= $7FFF;	(64^2 *3 = 12288)
	cld			;J3:= J+J+J;
	sub	cx,cx		;for J:= 0, 255 do
bc10:	lodsb			;al <- ds:[si++]
	sub	al,smcode	;DR:= (Palette(J3) - R) ^2;
smc10:	imul	al
	mov	dx,ax

	lodsb			;al <- ds:[si++]
	sub	al,smcode	;DR:= (Palette(J3) - R) ^2;
smc20:	imul	al
	add	dx,ax

	lodsb			;al <- ds:[si++]
	sub	al,smcode	;DR:= (Palette(J3) - R) ^2;
smc30:	imul	al
	add	dx,ax		;D:= DR*DR + DG*DG + DB*DB;

	cmp	dx,di		;if D < Min then
	jge	bc20
	mov	ch,cl		;SJ:= J; save closest color register
	mov	di,dx		;Min:= D;
	test	di,di
	je	bc30		;if D = 0 then exit
bc20:
	inc	cl		;Next J
	jne	bc10
bc30:
	movzx	eax,ch		;return SJ, the closest color register
	mov	[esp+16],eax
	ret	3*4		;drop 3 args

cseg	ends
	end
