\WHIRL.XPL	8/2/93
\Richard Ottosen
\Version of Whirlygig that uses PIC as serial to parallel convertor

include C:\cxpl\CODESI.XPL;

def	BS= $08,	\Back Space
	CR= $0D,	\Carriage Return
	FF= $0C,	\Form Feed
	SP= $20;	\Space

def	FONTWIDTH=6, FONTHIEGHT=7;


int		DEV, DUMMY, M, C, X, Y, SPEED, DELAY;
int \array\	FONT, CPUREG;
char		MESSAGE;		
real		REALDUMMY;

proc SHOCUR(FLAG);	\Turn flashing cursor on and off
int	FLAG;		\True = cursor on and False = cursor off
begin
CPUREG:= GETREG;
CPUREG(0):= $0100;
CPUREG(2):= if FLAG then $067 else $2000;
SOFTINT($10);
end;

proc	PRINTR(STRING);
int	STRING;
begin
TEXT(DEV,STRING);
CRLF(DEV);
end;


\
\Return True if a bit at a POSITION in PATTERN is set
\
proc	BIT(PATTERN,POSITION);
int	PATTERN,POSITION;
int	MASK;
begin
MASK:= [1,2,4,8,16,32,64,128];
return if (PATTERN &MASK (POSITION )) #0 then true else false;
end;	\BIT


proc	INPUT;		\Input a string
int	I, C;
begin
OPENI(DEV);
I:= 0;
repeat
	C:= CHIN(DEV);
	MESSAGE(I):= C;
	I:= I +1;
until C =CR;
MESSAGE(I -2):= MESSAGE(I-2) ! $80; \Terminate the string
end;	\INPUT


proc	PLOTCOLUMN(BAR, X, Y);
int	B, X, Y;
int	ROW;
begin
for ROW:= 0,7 do
	[CURSOR(X, Y +ROW);
	CHOUT(DEV,SP);
	if BIT(B, ROW)
		then CHOUT(DEV,^*) else CHOUT(DEV,SP);
	];
end;	\PLOTCOLUMN


proc	PLOTCHAR(CHAR, X, Y);
int	C, X, Y;
int	COL, ROW;
begin
for COL:= 0,4 do
	PLOTCOLUMN(FONT(C -SP, COL), X +COL *2, Y);
end;	\PLOTCHAR


proc	SHOW(STRING);
char	S;
int	MM;
begin
MM:= 0;
while S(MM) <=127 do
	[PLOTCHAR(S(MM), MM *FONTWIDTH *2, 10);
	MM:= MM +1;
	];
if (S(MM) &127) #CR then
	PLOTCHAR(S(MM) &127, MM *FONTWIDTH *2, 10) \Show terminating character
	else 
	PLOTCHAR(SP, MM *FONTWIDTH *2, 10) \Show terminating character
end;	\SHOW


proc	SCROLL(STRING);
char	S;
int	COL;
int	MM, LENGTH, OFFSET, W, SIZE;
int\array\ BUFFER;
begin
BUFFER:= RESERVE(255 *FONTWIDTH *2);	\Lots more than 1 line
LENGTH:= 0;
while S(LENGTH) <=127 do
	[LENGTH:= LENGTH +1;
	];
S(LENGTH):= S(LENGTH) &127;	\Clear string termination bit
for MM:= 0, LENGTH do
	[for COL:= 0, FONTWIDTH -2 do
		[
		BUFFER(MM * (FONTWIDTH) +COL):= FONT(S(MM) -SP, COL);
		];
	BUFFER(MM *FONTWIDTH +FONTWIDTH -1):= 0; \Blank column between characters
	];

SIZE:= FONTWIDTH *(LENGTH +1);
loop begin
	for OFFSET:= 0, SIZE -1 do
		[for W:= 0, 79 /2 do	\width of screen
			[PLOTCOLUMN(BUFFER(REM((OFFSET +W) /SIZE)), W *2, 10);
			];
		for DELAY:= 0, SPEED do [REALDUMMY:= 1.111 *1.111];
		if CHKKEY then quit;
		];
end; \loop
end;	\SCROLL



\======================================================================
begin	\MAIN

\
\THIS FORMAT USES THE FIRST BYTE OF EACH LETTER FOR THE LEFT
\ COLUMN. THE LEAST SIGNIFICANT BIT IS THE TOP. BIT 6 REPRESENTS
\ THE BASE LINE. LOWERCASE LETTERS WITH DECENDERS (I.E: g, j, p,
\ q, y) USE BIT 7.
\
FONT:=	[
	    [	$00, $00, $00, $00, $00	],	\SPACE
	    [	$00, $00, $5F, $00, $00	],	\!
	    [	$00, $07, $00, $07, $00	],	\"
	    [	$14, $7F, $14, $7F, $14	],	\#
	    [	$24, $2A, $7F, $2A, $12	],	\$
	    [	$23, $13, $08, $64, $62	],	\%
	    [	$36, $49, $56, $20, $50	],	\&
	    [	$00, $00, $07, $00, $00	],	\'
	    [	$00, $1C, $22, $41, $00	],	\(
	    [	$00, $41, $22, $1C, $00	],	\)
	    [	$22, $14, $7F, $14, $22	],	\*

	    [	$08, $08, $3E, $08, $08	],	\+
	    [	$00, $40, $30, $00, $00	],	\,
	    [	$08, $08, $08, $08, $08	],	\-
	    [	$00, $00, $40, $00, $00	],	\.
	    [	$20, $10, $08, $04, $02	],	\/
	    [	$3E, $51, $49, $45, $3E	],	\0
	    [	$00, $42, $7F, $40, $00	],	\1  MSB           LSB
	    [	$62, $51, $49, $49, $46	],	\2   . * * . . . * .
	    [	$21, $41, $49, $4D, $33	],	\3   . * . * . . . *
	    [	$18, $14, $12, $7F, $10	],	\4   . * . . * . . *
	    [	$27, $45, $45, $45, $39	],	\5   . * . . * . . *
	    [	$3C, $4A, $49, $49, $31	],	\6   . * . . . * * .
	    [	$01, $71, $09, $05, $03	],	\7
	    [	$36, $49, $49, $49, $36	],	\8
	    [	$46, $49, $49, $29, $1E	],	\9
	    [	$00, $00, $14, $00, $00	],	\:
	    [	$00, $40, $34, $00, $00	],	\\
	    [	$08, $14, $22, $41, $00	],	\<
	    [	$14, $14, $14, $14, $14	],	\=
	    [	$00, $41, $22, $14, $08	],	\>
	    [	$02, $01, $59, $05, $02	],	\?
	    [	$3E, $41, $5D, $59, $4E	],	\@
	    [	$7C, $12, $11, $12, $7C	],	\A
	    [	$7F, $49, $49, $49, $36	],	\B
	    [	$3E, $41, $41, $41, $22	],	\C
	    [	$7F, $41, $41, $41, $3E	],	\D
	    [	$7F, $49, $49, $49, $41	],	\E
	    [	$7F, $09, $09, $09, $01	],	\F
	    [	$3E, $41, $41, $51, $71	],	\G
	    [	$7F, $08, $08, $08, $7F	],	\H
	    [	$00, $41, $7F, $41, $00	],	\I
	    [	$20, $40, $40, $40, $3F	],	\J
	    [	$7F, $08, $14, $22, $41	],	\K
	    [	$7F, $40, $40, $40, $40	],	\L
	    [	$7F, $02, $0C, $02, $7F	],	\M
	    [	$7F, $04, $08, $10, $7F	],	\N
	    [	$3E, $41, $41, $41, $3E	],	\O
	    [	$7F, $09, $09, $09, $06	],	\P
	    [	$3E, $41, $51, $21, $5E	],	\Q
	    [	$7F, $09, $19, $29, $46	],	\R
	    [	$26, $49, $49, $49, $32	],	\S
	    [	$01, $01, $7F, $01, $01	],	\T
	    [	$3F, $40, $40, $40, $3F	],	\U
	    [	$1F, $20, $40, $20, $1F	],	\V
	    [	$7F, $20, $18, $20, $7F	],	\W
	    [	$63, $14, $08, $14, $63	],	\X
	    [	$03, $04, $78, $04, $03	],	\Y
	    [	$61, $51, $49, $45, $43	],	\Z
	    [	$7F, $7F, $41, $41, $41	],	\[
	    [	$02, $04, $08, $10, $20	],	\\
	    [	$41, $41, $41, $7F, $7F	],	\]
	    [	$10, $08, $04, $08, $10	],	\^
	    [	$40, $40, $40, $40, $40	],	\_
	    [	$00, $01, $02, $04, $00	],	\`
	    [	$24, $54, $54, $78, $40	],	\a
	    [	$7F, $44, $44, $44, $38	],	\b
	    [	$38, $44, $44, $44, $44	],	\c
	    [	$38, $44, $44, $44, $7F	],	\d
	    [	$38, $54, $54, $54, $58	],	\e
	    [	$08, $7E, $09, $09, $02	],	\f
	    [	$18, $A4, $A4, $A4, $78	],	\g
	    [	$7F, $04, $04, $04, $78	],	\h
	    [	$00, $44, $7D, $40, $00	],	\i
	    [	$40, $80, $80, $7D, $00	],	\j
	    [	$7F, $10, $28, $44, $00	],	\k
	    [	$00, $41, $7F, $40, $00	],	\l
	    [	$7C, $04, $3C, $04, $78	],	\m
	    [	$7C, $04, $04, $04, $78	],	\n
	    [	$38, $44, $44, $44, $38	],	\o
	    [	$FC, $24, $24, $24, $18	],	\p
	    [	$18, $24, $24, $24, $FC	],	\q
	    [	$7C, $08, $04, $04, $08	],	\r
	    [	$48, $54, $54, $54, $24	],	\s
	    [	$04, $04, $3F, $44, $44	],	\t
	    [	$3C, $40, $40, $40, $7C	],	\u
	    [	$1C, $20, $40, $20, $1C	],	\v
	    [	$3C, $40, $38, $40, $3C	],	\w
	    [	$44, $28, $10, $28, $44	],	\x
	    [	$8C, $50, $20, $10, $0C	],	\y
	    [	$44, $64, $54, $4C, $44	],	\z
	    [	$08, $3E, $41, $41, $00	],	\{
	    [	$00, $00, $77, $00, $00	],	\|
	    [	$00, $41, $41, $3E, $08	],	\}
	    [	$08, $04, $08, $10, $08	],	\~
	    [	$55, $2A, $55, $2A, $55	]	\RUBOUT
	];

\
\Main continues...
\

MESSAGE:= RESERVE(255);	\Lots more than 1 line

DEV:=0;
CHOUT(DEV,FF); CRLF(DEV); CRLF(DEV);
PRINTR("             ==============================================");
PRINTR("             =                                            =");
PRINTR("             =        Whilrly-Gig message program         =");
PRINTR("             =                                            =");
PRINTR("             ==============================================");
CRLF(DEV);	CRLF(DEV);
CRLF(DEV); CRLF(DEV);

SHOCUR(true);
CURSOR(0,20);
TEXT(DEV,"What speed for scroll? (1000) ");
SPEED:= INTIN(DEV);	CRLF(DEV);

CURSOR(0,20); TEXT(DEV,"					"); CRLF(DEV);
SHOCUR(false);
SCROLL("6502 Group   ");

loop begin
SHOCUR(true);
CURSOR(0,20);
TEXT(DEV,"What speed for scroll? (1000) ");
SPEED:= INTIN(DEV);	CRLF(DEV);

TEXT(DEV,"Input a message (80 characters max.)");	CRLF(DEV);
INPUT;
		\Input a message

SHOCUR(false);
CHOUT(DEV,FF);	\Clear the screen

\SHOW(MESSAGE);
SCROLL(MESSAGE);

\SHOW("Whirly");
\SCROLL("Whirly Gig--");



CRLF(DEV);
CURSOR(0,20);
TEXT(DEV,"Quit y/n? ");
OPENI(0); DUMMY:= CHIN(0);
if (DUMMY =^y) ! (DUMMY =^Y) then [SHOCUR(true); quit;];
\loop\ end

end;	\MAIN
