include \CXPL\CODESI.XPL;


integer
	
	BAR,	\MENU STRUCTURE FOR HIGHLIGHTING
	BAR1,	\MENU STRUCTURE FOR PULL DOWN WINDOWS
	COM,	\CURRENT GLOBAL COMMAND
	COM1;	\CURRENT PULL DOWN COMMAND
integer
	CPUREG,		\CPU REGISTER FOR SOFTWARE INTERRUPTS
	DSEG,		\CURRENT DATA SEGMENT
	VIDMODE,	\CURRENT VIDEO MODE
	VIDPAGE;	\CURRENT VIDEO MODE

define
	SCREENSIZE=4000,	\SIZE OF A SCREEN
 	MAXSCREENS=4;		\MAX SCREEN DEPTH

integer
	PIXEL,			\ARRAY FOR SCREEN VALUES
	SCRPTR;			\POINTER FOR EACH SCREEN



define
	CR=$0D,		\CARRIAGE RETURN
	TAB=$09,	\TAB CHARACTER
	FF=$0C,		\FORM FEED
	LFARROW=75,	\LEFT ARROW KEY
	RTARROW=77,	\RIGHT ARROW KEY
	UPARROW=72,	\UP ARROW KEY
	DNARROW=80;	\DOWN ARROW KEY

\integer C,X1,Y1,X2,Y2,MODE;

\-------------------- SUPPORT ROUTINES --------------------------------

procedure EXTKEY;
\READ KEY BOARD, EXTENDED CODES ARE NEGATED
integer C;
[C:=CHIN(1);return if C=0 then -CHIN(1) else C;];



procedure BLANK;
\BLANK SCREEN
CHOUT(0,FF);


procedure SHADOW(X1,Y1,X2,Y2);
\PUT SHADOW ON THE EDGE OF WINDOW
integer X1,Y1,X2,Y2;
begin
HILIGHT(X2+1,Y1+1,X2+2,Y2+1,$08);
HILIGHT(X1+1,Y2+1,X2+2,Y2+1,$08);
end;

\--------------------- CODE FOR INDIVIDUAL WINDOWS ---------------------




procedure WAIT;
int C;
begin
ATTRIB($52);
SETWIND(5,20,20,20,1,true);
TEXT(6,"   HIT ANY KEY");
C:=CHIN(1);
ATTRIB($07);
SETWIND(5,20,20,20,1,true);
OPENO(6);
end;


procedure RAWIND;
begin
BLANK;
CURSOR(0,0);
RAWTEXT(0,"
ͻ
               RAW TEXT MODE    
               BLOCK DRAWINGS   
                                
            ͹
                                
               DEVICE CHANNEL   
                                
                     0          
                                
ͼ
 ");
WAIT;
OPENO(6);
ATTRIB($17);
RAWTEXT(6,"
ͻ
               RAW TEXT MODE    
               BLOCK DRAWINGS   
                                
            ͹
                                
               DEVICE CHANNEL   
                                
                     6          
                                
ͼ
 ");
WAIT;
OPENO(6);
end;



procedure WUNFILL(X,Y);
int X,Y, C;
begin
BLANK;
ATTRIB($17);
SETWIND(X,Y,X+21,Y+2,1,true);
TEXT(6," UNFILLED WINDOW");CRLF(6);
TEXT(6,"    ESC TO EXIT");
ATTRIB($04);
SETWIND(X,Y+3,X+21,Y+11,0,false);
loop
	begin
	C:=CHIN(1);
	if C=$1B then quit;
	CHOUT(6,C);
	end;
OPENO(6);
end;



procedure WSCROLL(X,Y);
int X,Y, C;
begin
ATTRIB($70);
SETWIND(X,Y,X+22,Y+12,1,true);

ATTRIB($20);
SETWIND(X+1,Y+1,X+21,Y+2,1,true);
TEXT(6," SCROLL MODE WINDOW");CRLF(6);
TEXT(6,"    ESC TO EXIT");
ATTRIB($47);
SETWIND(X+1,Y+3,X+21,Y+11,0,true);
loop
	begin
	C:=CHIN(1);
	if C=$1B then quit;
	CHOUT(6,C);
	end;
ATTRIB($07);
SETWIND(X,Y,X+22,Y+12,0,true);
OPENO(6);
end;



procedure WWRAP(X,Y);
int X,Y, C;
begin

ATTRIB($70);
SETWIND(X,Y,X+22,Y+12,1,true);

ATTRIB($47);
SETWIND(X+1,Y+1,X+21,Y+2,1,true);
TEXT(6," WRAP MODE WINDOW");CRLF(6);
TEXT(6,"    ESC TO EXIT");
ATTRIB($20);
SETWIND(X+1,Y+3,X+21,Y+11,1,true);
loop
	begin
	C:=CHIN(1);
	if C=$1B then quit;
	CHOUT(6,C);
	end;
ATTRIB($07);
SETWIND(X,Y,X+22,Y+12,0,true);
OPENO(6);
end;



procedure WCLIP(X,Y);
int X,Y, C;
begin

ATTRIB($40);
SETWIND(X,Y,X+22,Y+12,1,true);

ATTRIB($20);
SETWIND(X+1,Y+1,X+21,Y+2,1,true);
TEXT(6," CLIP MODE WINDOW");CRLF(6);
TEXT(6,"    ESC TO EXIT");
ATTRIB($17);
SETWIND(X+1,Y+3,X+21,Y+11,2,true);
loop
	begin
	C:=CHIN(1);
	if C=$1B then quit;
	CHOUT(6,C);
	end;
ATTRIB($07);
SETWIND(X,Y,X+22,Y+12,0,true);
OPENO(6);
end;



procedure WMOVE(X,Y);
int X,Y, C,DX,DY;
begin
BLANK;
X:=0;Y:=0;
DX:=1;DY:=1;
loop
	begin
	ATTRIB($17);
	SETWIND(X,Y,X+22,Y+12,$100,true);

	RAWTEXT(6,"   ͻ ");CRLF(6);
	RAWTEXT(6," Ķ MOVING WINDOW  ");CRLF(6);
	RAWTEXT(6,"   ͼ ");CRLF(6);
	CRLF(6);
	   TEXT(6,"     TO MOVE WINDOW ");CRLF(6);
	   TEXT(6,"       HIT ANY KEY ");CRLF(6);
	CRLF(6);
	   TEXT(6,"       ESC TO QUIT ");
	CURSOR(0,25);
	C:=CHIN(1);
	if C=$1B then quit;
	ATTRIB($07);
	SETWIND(X,Y,X+22,Y+12,1,true);
	X:=X+DX;Y:=Y+DY;
	if (X+22)>=80 then [X:=X-1;DX:=-DX;];
	if X<0 then [X:=0;DX:=-DX;];
	if (Y+12)>=25 then [Y:=Y-1;DY:=-DY;];
	if Y<0 then [Y:=0;DY:=-DY;];
	end;
OPENO(6);
end;



procedure WECHO(X,Y);
int X,Y, C;
begin
ATTRIB($30);
SETWIND(X,Y,X+22,Y+12,1,true);

ATTRIB($20);
SETWIND(X+1,Y+1,X+21,Y+2,1,true);
TEXT(6," ECHO INTO WINDOW");CRLF(6);
TEXT(6,"    ESC TO EXIT");
ATTRIB($47);
SETWIND(X+1,Y+3,X+21,Y+11,0,true);

loop
	begin
	C:=CHIN(6);
	if C=$1B then quit;
	end;
ATTRIB($07);
SETWIND(X,Y,X+22,Y+12,0,true);
OPENO(6);
end;



procedure WSPEED(X,Y);
int X,Y, C;
begin
CHOUT(0,$0C);
ATTRIB($10);
SETWIND(X+1,Y+1,X+22+1,Y+12+1,1,true);

ATTRIB($70);
SETWIND(X,Y,X+22,Y+12,1,true);

ATTRIB($20);
SETWIND(X+1,Y+1,X+21,Y+2,1,true);
TEXT(6," CTRL-S TO PAUSE");CRLF(6);
TEXT(6,"    ESC TO EXIT");
ATTRIB($47);
SETWIND(X+1,Y+3,X+21,Y+11,0,true);

loop
	begin
	if CHKKEY then [C:=CHIN(1);if C=$1B then quit;];
	CHOUT(6,C);
	C:=C+1;
	end;
ATTRIB($07);
OPENO(6);
end;

\-------- CODE FOR OVERLAID WINDOWS ----------------------------

procedure SETPAGE;
\SET PROPER PAGE FOR CURRENT VIDEO MODE
begin
CPUREG(0):=$0F00;
SOFTINT($10);
VIDMODE:=CPUREG(0) & $FF;
case VIDMODE of
	3: VIDPAGE:=$B800;
	7: VIDPAGE:=$B000
else VIDPAGE:=$B800;
end;


procedure SAVEWIND;
\SAVE CURRENT SCREEN
begin
if SCRPTR>=MAXSCREENS then return false;
BLIT(VIDPAGE,0,DSEG,PIXEL+(SCRPTR*SCREENSIZE),4000);
SCRPTR:=SCRPTR+1;
return true;
end;



procedure RESWIND;
\RESTORE LAST SCREEN
begin
if SCRPTR<=0 then return false;
SCRPTR:=SCRPTR-1;
BLIT(DSEG,PIXEL+(SCRPTR*SCREENSIZE),VIDPAGE,0,4000);
return true;
end;



procedure SETWIND0(F);
\SET UP WINDOW 0
int F;
integer X1,Y1,X2,Y2;
char STR1,STR2;
begin
STR1:="
        CTRL-U = MOVE UP A WINDOW     CTRL-D= MOVE DOWN WINDOW
                             CTRL-X = EXIT";

STR2:="

     These screens demonstrate overlaid windows. Press Control-U to
     observe the next layer of window. With overlaid windows, the
     information under the window is saved and when the window is removed
     the information is intact. This is very memory intensive because
     every character and the attribute for every character must be saved.
     This is 4000 character for a full 80 by 25 screen. If you have four
     layers of windows it will cost you 16K.";

X1:=0;Y1:=0;X2:=79;Y2:=24;
if F then
	begin
	ATTRIB($20);
	SETWIND(X1,Y1,X2,Y2,0,true);
	TEXT(6,STR1);
	ATTRIB($17);
	SETWIND(X1+2,Y1+3,X2-2,Y2-1,0,true);
	TEXT(6,STR2);
	end;
ATTRIB($17);
SETWIND(X1+2,Y1+3,X2-2,Y2-1,0,false);
end;



procedure SETWIND1(F);
\SET UP WINDOW 1
int F;
integer X1,Y1,X2,Y2;
begin
X1:=3;Y1:=4;X2:=61;Y2:=20;
if F then
	begin
	ATTRIB($70);
	SETWIND(X1,Y1,X2,Y2,0,true);
	TEXT(6,"      SHADOWED WINDOW FOR EFFECT");
	end;
ATTRIB($30);
SETWIND(X1+2,Y1+1,X2-2,Y2-1,0,F);
if F then SHADOW(X1,Y1,X2,Y2);

end;



procedure SETWIND2(F);
\SET UP WINDOW 2
int F;
integer X1,Y1,X2,Y2;
begin
X1:=5;Y1:=5;X2:=40;Y2:=15;
if F then
	begin
	ATTRIB($50);
	SETWIND(X1,Y1,X2,Y2,0,true);
	TEXT(6,"     Another Cute Little Window");
	end;
ATTRIB($70);
SETWIND(X1+2,Y1+1,X2-2,Y2-1,0,true);
if F then SHADOW(X1,Y1,X2,Y2);
end;




procedure UPWINDOW;
\MOVE UP ONE WINDOW LEVEL
int R;
begin
case SCRPTR of
	0: [R:=SAVEWIND;SETWIND0(true);];
	1: [R:=SAVEWIND;SETWIND1(true);];
	2: [R:=SAVEWIND;SETWIND2(true);]
else;
end;




procedure DNWINDOW;
\MOVE DOWN ONE WINDOW LEVEL
int R;
begin
case SCRPTR of
	3: [R:=RESWIND;SETWIND1(false)];
	2: [R:=RESWIND;SETWIND0(false)]
else;
end;


procedure OVERLAID;
\DEMONSTRATE OVERLAID WINDOWS
integer C;
begin
CPUREG:=GETREG;
DSEG:=CPUREG(12);
SETPAGE;

PIXEL:=RESERVE(MAXSCREEN*SCREENSIZE);
SCRPTR:=0;

UPWINDOW;
loop
	begin
	C:=CHIN(6);
	case C of
		^U-$40:UPWINDOW;
		^D-$40:DNWINDOW;
		^X-$40: [while RESWIND do;quit;]
	else;
	end;
OPENO(6);
end;

\-------- CODE FOR PULL DOWN WINDOWS -------------------------------


fprocedure MENU;


procedure DUMMY(X,Y);
int X1,Y1,X2,Y2,C,P;
int SUB;


	procedure MAKESUB;
	\MAKE A SUBMENU
	begin
	SUB:=[
	[" TEST  1",0,0,10],
	[" TEST  2",0,0,10],
	[" TEST  3",0,0,10],
	[" QUIT   ",0,0,10],
	[0]];
	end;


begin
X2:=X1+15;Y2:=Y1+12;

ATTRIB($70);
SETWIND(X1,Y1,X2,Y2,1,true);

ATTRIB($20);
SETWIND(X1+1,Y1+1,X2-1,Y1+2,1,true);
TEXT(6," TEST WINDOW");
ATTRIB($17);
SETWIND(X1+1,Y1+3,X2-1,Y2-1,0,true);
SHADOW(X1,Y1,X2,Y2);

MAKESUB;
P:=0;
while SUB(P,0)#0 do
	begin
	SUB(P,1):=X1+2;
	SUB(P,2):=Y1+P+4;
	P:=P+1;
	end;
C:=0;
repeat C:=MENU(SUB,C) until C=3;
ATTRIB($07);
OPENO(6);
end;

procedure PULLMAIN;
\PUT UP BASIC PULL DOWN SCREEN
begin
ATTRIB($17);
SETWIND(0,0,80,25,$100,false);
RAWTEXT(6,"
ͻ
                                                                           
Ķ
                                                                           
                                                                           
                                                                           
                           PULL DOWN WINDOWS                               
                                                                           
Ķ
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
ͼ
 ");
end;




procedure MAKEPMENU;
\CREATE PULL DOWN MENU STRUCTURE
begin
BAR1:=[
[" TEST NUMBER 1",3,2,15],
[" TEST NUMBER 2",21,2,15],
[" TEST NUMBER 3",39,2,15],
["    QUIT     ",57,2,15],
[0]];
end;



procedure PULLDOWN;
\DEMONSTRATE PULLDOWN MENUS
begin
MAKEPMENU;
COM1:=0;
BLANK;
loop
	begin
	PULLMAIN;
	COM1:=MENU(BAR1,COM1);
	case COM1 of
		0: DUMMY(3,4);
		1: DUMMY(21,4);
		2: DUMMY(39,4);
		3: quit
	else;
	end;
OPENO(6);
end;



\-------- CODE FOR MENU AND HIGHLIGHTED BARS -------------------------

procedure MENU(M,C);
\PROCEDURE TO PUT UP A MENU AND HIGHLIGHT BARS
\THE MENU IS PASSED THE STRUCTURE M, STARTING BAR IN C
\RETURN THE VALUE OF THE BAR SELECTED
integer M,C,P;


	procedure ADVANCE;
	\ADVANCE MENU BAR
	begin
	HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2),$17);
	P:=P+1;
	if M(P,0)=0 then P:=0;
	HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2),$70);
	end;


	procedure BACKUP;
	\BACKUP MENU BAR
	begin
	HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2),$17);
	if P=0 then repeat P:=P+1 until M(P,0)=0;
	P:=P-1;
	HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2),$70);
	end;


begin
\DISPLAY MENU ITEMS
P:=0;
while M(P,0)#0 do
	[CURSOR(M(P,1),M(P,2));	TEXT(6,M(P,0));	P:=P+1;];

\DECODE KEYS AND HIGHLIGHT MENU ITEMS
CURSOR(0,24);
P:=C;
HILIGHT(M(P,1),M(P,2),M(P,1)+M(P,3),M(P,2),$70);
loop
	begin
	case EXTKEY of
	CR:		return P;
	TAB:		ADVANCE;
	-LFARROW:	BACKUP;
	-UPARROW: 	BACKUP;
	-RTARROW:	ADVANCE;
	-DNARROW:	ADVANCE
	else;
	end;
end;



procedure MAIN;
begin
BLANK;
ATTRIB($17);
SETWIND(0,0,80,25,$100,false);
RAWTEXT(6,"
ͻ
                       XPL WINDOW DEMO PROGRAM                             
                                                                           
   ARROWS MOVE HIGHLIGHT BAR    -     YOU CAN TYPE INTO MOST WINDOWS       
Ķ
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
                                                                           
ͼ
 ");
end;



procedure MAKEMENU;
\CREATE MENU STRUCTURE
begin
\EACH CONSIST OF:
\ 1. MENU ITEM STRING
\ 2. X,Y LOCATION OF STRING
\ 3. LENGTH OF HIGHLIGHT BAR
BAR:=[
["  RAW TEXT DRAWING",10,8,20],		\0
["  UNFILLED WINDOW ",10,9,20],		\1
["  SCROLLED WINDOWS",10,10,20],	\2
["  WRAPPED WINDOWS ",10,11,20],	\3
["  CLIPPED WINDOWS ",10,12,20],	\4

["  MOVING WINDOWS  ",45,8,20],		\5
["  ECHOED WINDOWS  ",45,9,20],		\6
["  SPEED WINDOWS   ",45,10,20],	\7
["  OVERLAID WINDOWS",45,11,20],	\8
["  PULLDOWN WINDOWS",45,12,20],	\9

["       QUIT       ",28,13,20],	\10
[0]];
end;



begin
MAKEMENU;
COM:=0;

WAIT;
loop
	begin
	MAIN;
	COM:=MENU(BAR,COM);
	case COM of
		0: RAWIND;
		1: WUNFILL(0,0);
		2: WSCROLL(0,0);
		3: WWRAP(10,10);
		4: WCLIP(10,10);
		5: WMOVE;
		6: WECHO(5,5);
		7: WSPEED(5,5);
		8: OVERLAID;
		9: PULLDOWN;
		10: quit
	else;
	end;

CHOUT(0,$0C);
end;
