\WIRE.XPL
\WIRE LIST PROCESSOR: JUNE 1979

'CODE'
ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		ABORT=16,	EXTEN=5,	SHORT=6,
CHIN=7,		CHOUT=8,	CRLF=9,		INNUM=10,
NUMOUT=11,	TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	CALL=17,	SPACE=18,	RERUN=1,
SETSP=21,	ADC=22,		CURSOR=23,	SPEAK=24;

'DEFINE'CR=$D,TAB=$9,SP=$20,NULL=$FF,LF=$A,EOF=$1A;
'INTEGER'LASTCH,CHAR,TOTW,TOTP;

'INTEGER'ODEV,IDEV,I,J,K,NP,M,NC,DESIG,NS,NW,COMP,KP;
\ARRAYS:
'ADDRESS'COMSPC,SIGSPC,COPY,PNTR;
'INTEGER'COMPLST,SIGLST;

'PROCEDURE'GETCH;
'INTEGER'CHAR;
'BEGIN'
'REPEAT'
	'BEGIN'
	CHAR:=CHIN(IDEV);
	CHOUT(0,CHAR);
	'END'
'UNTIL'CHAR#LF;
'EXIT'CHAR;
'END';

'PROCEDURE'NUMIN;
'INTEGER'NUM;
'BEGIN'
LASTCH:=GETCH;
'WHILE'LASTCH<^0 ! LASTCH>^9 'DO' LASTCH:=GETCH;
NUM:=0;
'WHILE'LASTCH>=^0 & LASTCH<=^9 'DO'
	'BEGIN'
	NUM:=NUM*10+LASTCH-^0;
	LASTCH:=GETCH;
	'END';
'EXIT'NUM;
'END';






'PROCEDURE'ERROR(N);
'ADDRESS'N;
'BEGIN'
CRLF(0);
TEXT(0,"USER ERROR: ");TEXT(0,N);
CRLF(0);
ABORT;
'END';




'PROCEDURE'READCOMP;
'INTEGER'N,CHAR,NUM,M;

'BEGIN'\READ IN A COMPONENT SPEC
CHAR:=GETCH;
'IF'CHAR=CR'THEN''EXIT''FALSE';
COMSPC(0):=CHAR;\FIRST BYTE OF DESIGNATOR
NUM:=NUMIN;\COMPONENT NUMBER
'IF'NUM<0 ! NUM>255 'THEN' ERROR("BAD COMPONENT NUMBER");
COMSPC(1):=NUM;\AS 2ND BYTE OF DESIGNATOR
N:=2;\COMPONENT NAME INDEX
'REPEAT'\READ COMPONENT NAME
	'BEGIN'
	CHAR:=GETCH;
	'IF'CHAR#TAB & N<=9'THEN'
		[COMSPC(N):=CHAR;N:=N+1];
	'END'
'UNTIL'CHAR=TAB;
'FOR'N:=N,9'DO'COMSPC(N):=SP;
NUM:=NUMIN;\READ # OF PINS
'IF'NUM>40 ! NUM<1 'THEN' ERROR("ILLEGAL # OF PINS");
COMSPC(10):=NUM;
'FOR'N:=0,NUM-1'DO'
	'BEGIN'
	M:=11+N*2;
	COMSPC(M):=0;\LEVEL
	COMSPC(M+1):=NULL;\SIGNAL
	'END';
'EXIT''TRUE';
'END';

'PROCEDURE'READDESIG;
'INTEGER'CHAR,NUM;
'BEGIN'
CHAR:=GETCH;
'WHILE'CHAR<^A ! CHAR>^Z 'DO'CHAR:=GETCH;
NUM:=NUMIN;
'IF'NUM<0 ! NUM>255 'THEN'ERROR("ILLEGAL DESIGNATOR NUMBER");
DESIG:=NUM*256+CHAR;
'END';


'PROCEDURE'FINDDESIG;
'INTEGER'I;
'BEGIN'
I:=0;
'LOOP'	'BEGIN'
	'IF'I>=NC'THEN''QUIT';
	'IF'DESIG=COMPLST(I,0)'THEN''QUIT';
	I:=I+1;
	'END';
'IF'I>=NC'THEN'ERROR("COMPONENT NOT DEFINED");
'EXIT'I;
'END';
			

'PROCEDURE'READSIG;
'INTEGER'I,M,NW,CHAR,COMPNO,NUM;
'ADDRESS'PNTR;
'BEGIN'
CHAR:=GETCH;
'IF'CHAR=CR'THEN''EXIT''FALSE';

I:=0;
'WHILE'CHAR#TAB & I<=7 'DO'
	'BEGIN'
	SIGSPC(I):=CHAR;
	CHAR:=GETCH;
	I:=I+1;
	'END';

'FOR'I:=I,7'DO'SIGSPC(I):=SP;

NW:=0;
'LOOP'
	'BEGIN'
	READDESIG;
	COMPNO:=FINDDESIG;
	M:=9+NW*2;
	SIGSPC(M):=COMPNO;
	PNTR:=COMPLST(COMPNO);
	NUM:=NUMIN;
	'IF'NUM<1 ! NUM>PNTR(10) 'THEN'
		ERROR("NO SUCH PIN ON THE DEVICE");
	SIGSPC(M+1):=NUM;
	M:=10+NUM*2;
	'IF'PNTR(M)#NULL'THEN'ERROR("SIGNAL CONFLICT")
	'ELSE'PNTR(M):=NS;
	NW:=NW+1;
	'IF'LASTCH=^;'THEN''QUIT';
	'IF'NW>150'THEN'ERROR("TOO MANY CONNECTIONS");
	'END';
SIGSPC(8):=NW;
'REPEAT'CHAR:=GETCH'UNTIL'CHAR=CR;
'EXIT''TRUE';
'END';


'PROCEDURE'PINOUT(J);
'INTEGER'J;
'ADDRESS'PNTR,SIGSPC;
'BEGIN';
TEXT(ODEV,"PIN ");
NUMOUT(ODEV,J);
CHOUT(ODEV,TAB);
J:=J-1;
PNTR:=COMSPC(12+J*2);
'IF'PNTR=NULL'THEN'
	TEXT(ODEV,"NO CONNECTION")
'ELSE''BEGIN'
	SIGSPC:=SIGLST(PNTR);
	'FOR'K:=0,7'DO'CHOUT(ODEV,SIGSPC(K));
	'END';
'END';








'BEGIN'\MAIN
INITI(0);
TEXT(0,"WIRE LIST PROCESSOR V1.0, JUNE 1979");
CRLF(0);TEXT(0,"DEVICES (OUT,IN)?");
ODEV:=INNUM(0);
IDEV:=INNUM(0);
INITI(IDEV);
INITO(ODEV);
CRLF(0);
COMSPC:=RESERVE(91);\40 PINS ALLOWED
COMPLST:=RESERVE(300);\150 COMONENTS
SIGSPC:=RESERVE(209);\100 CONNECTIONS PER WIRE ALLOWED
SIGLST:=RESERVE(300);\150 SIGNALS

CHAR:=GETCH;
'WHILE'CHAR#CR'DO'\PRINT TITLE
	'BEGIN'
	CHOUT(ODEV,CHAR);
	CHAR:=GETCH;
	'END';
CRLF(ODEV);
CRLF(ODEV);


TOTP:=0;\PIN TOTAL
TOTW:=0;\WIRE TOTAL

NC\COMPONENT INDEX\:=0;


'LOOP'
	'BEGIN'
	I:=READCOMP;
	'IF''NOT'I'THEN''QUIT';
	'IF'NC>150'THEN'ERROR("TOO MANY COMPONENTS");
	NP:=COMSPC(10);
	TOTP:=TOTP+NP;
	M:=11+NP*2;
	COPY:=RESERVE(M);
	'FOR'I:=0,M-1'DO'COPY(I):=COMSPC(I);
	COMPLST(NC):=COPY;
	NC:=NC+1;
	'END';

CRLF(0);
NS:=0;
'LOOP'	'BEGIN'
	'IF''NOT'READSIG'THEN''QUIT';
	NW:=SIGSPC(8);
	'IF'NW>0'THEN'TOTW:=TOTW+NW-1;
	M:=9+NW*2;
	COPY:=RESERVE(M);
	'FOR'I:=0,M-1'DO'COPY(I):=SIGSPC(I);
	SIGLST(NS):=COPY;
	NS:=NS+1;
	'END';


TEXT(ODEV,"NUMBER OF COMPONENTS: ");NUMOUT(ODEV,NC);CRLF(ODEV);
TEXT(ODEV,"NUMBER OF PINS:       ");NUMOUT(ODEV,TOTP);CRLF(ODEV);
TEXT(ODEV,"NUMBER OF WIRES:      ");NUMOUT(ODEV,TOTW);CRLF(ODEV);
TEXT(ODEV,"NUMBER OF SIGNALS:    ");NUMOUT(ODEV,NS);CRLF(ODEV);
CRLF(ODEV);



CRLF(0);TEXT(0,"WRITING..");
TEXT(ODEV,"COMPONENT LIST");CRLF(ODEV);
TEXT(ODEV,"--------------");
CRLF(ODEV);
'FOR'M:=0,NC-1'DO'
	'BEGIN'
	COMSPC:=COMPLST(M);
	CRLF(ODEV);
	CHOUT(ODEV,COMSPC(0));
	NUMOUT(ODEV,COMSPC(1));
	CHOUT(ODEV,TAB);
	'FOR'I:=2,9'DO'CHOUT(ODEV,COMSPC(I));
	CHOUT(ODEV,TAB);
	NUMOUT(ODEV,COMSPC(10));
	'END';
CRLF(ODEV);CRLF(ODEV);
TEXT(0,"SIGNAL LIST..");
TEXT(ODEV,"SIGNAL LIST");CRLF(ODEV);
TEXT(ODEV,"-----------");
CRLF(ODEV);
'FOR'M:=0,NS-1'DO'
	'BEGIN'
	SIGSPC:=SIGLST(M);
	CRLF(ODEV);CRLF(ODEV);
	'FOR'I:=0,7'DO'CHOUT(ODEV,SIGSPC(I));
	CHOUT(ODEV,SP);
	NW:=SIGSPC(8);
	'FOR'I:=0,NW-1'DO'
		'BEGIN'
		'IF'REM(I/6)=0 & I#0 'THEN'
			'BEGIN'
			CRLF(ODEV);
			CHOUT(ODEV,TAB);
			CHOUT(ODEV,SP);
			'END';
		COMP:=SIGSPC(9+I*2);
		PNTR:=COMPLST(COMP);
		CHOUT(ODEV,PNTR(0));NUMOUT(ODEV,PNTR(1));
		CHOUT(ODEV,^.);
		NUMOUT(ODEV,SIGSPC(10+I*2));
		'IF'I#NW-1'THEN'CHOUT(ODEV,TAB);
		'END';
	'END';
		
\NOW PRINT DEVICE VS SIGNAL

TEXT(0,"COMPONENTS..");
CRLF(ODEV);CRLF(ODEV);

TEXT(ODEV,"DEVICE - SIGNAL LIST");CRLF(ODEV);
TEXT(ODEV,"--------------------");
CRLF(ODEV);

'FOR'I:=0,NC-1'DO'\EACH COMPONENT
	'BEGIN'
	CRLF(ODEV);
	CRLF(ODEV);
	COMSPC:=COMPLST(I);
	CHOUT(ODEV,TAB);
	CHOUT(ODEV,COMSPC(0));
	NUMOUT(ODEV,COMSPC(1));
	CHOUT(ODEV,TAB);
	'FOR'J:=2,9'DO'CHOUT(ODEV,COMSPC(J));
	CRLF(ODEV);
	NP:=COMSPC(10);
	KP:=NP/2;
	'IF'COMSPC(0)=^I'THEN'
		'BEGIN'\IN IC PIN ORDER
		'FOR'J:=1,KP'DO'
			'BEGIN'
			CRLF(ODEV);
			PINOUT(J);
			CHOUT(ODEV,TAB);
			PINOUT(NP+1-J);
			'END';
		'END'
	'ELSE''IF'KP*2=NP & NP>=8 'THEN'
		'BEGIN'\CONNECTOR ORDER
		'FOR'J:=1,KP'DO'
			'BEGIN'
			CRLF(ODEV);
			PINOUT(J*2-1);
			CHOUT(ODEV,TAB);
			PINOUT(J*2);
			'END';
		'END'
	'ELSE'	'BEGIN'\ROW ORDER
		'FOR'J:=1,NP'DO'
			'BEGIN'
			CRLF(ODEV);
			PINOUT(J);
			'END';
		'END';
	'END';






TEXT(0,"CLOSING.");
CRLF(ODEV);
CHOUT(ODEV,EOF);
CLOSE(ODEV);



'END';
