\XPL0 COMPILER		AUG-07-91	VERSION 6.2
\COPYRIGHT 1989 P.J.R. BOYLE
\FLOATING POINT VERSION BY LOREN BLANEY

\THIS VERSION RUNS ON THE IBM PC
\% IBM CHANGES MARKED WITH THIS (%) CHARACTER

\REVISION HISTORY:
\JAN-01-89, MODIFIED FOR USE ON 68000, BASED ON VERSION DATED MAY-15-84.
\ THIS VERSION RUNS ON THE 68000 BUT PRODUCES I2L CODE FOR A 6502.
\JAN-13-89, FIXED BUG WHEN THERE ARE MORE THAN 10 QUITS IN A LOOP, LB.
\FEB-02-90, VER 5.7, ADDED SHIFT AND XOR OPERATORS, ~ = 'NOT', SPED UP
\ COMPILES BY REMOVING 'CASE SHIFT', LB.
\MAY-90, VERSION 6.0, LB.
\JUL-09-90, MODIFIED TO RUN ON THE PC.
\AUG 91, V6.2, MODIFIED TO PRODUCE 6502 FLOATS. ALSO ADDED INCLUDES. PB.
\ ALSO FIXED BUG INVOLVING OPTIMIZED PROCEDURES AND OPTIMIZED ADDRESSING
\ OF LOCALS. LB.

\WARNINGS:
\THIS VERSION 6 OF THE COMPILER PRODUCES I2L CODE WHICH IS INCOMPATABLE WITH
\ ALL PREVIOUS VERSIONS OF THE INTERPRETER.
\"GLOBAL 0" ACTUALLY HAS AN OFFSET OF 1 TO MAKE IT ODD, WHICH THE INTERPRETER
\ USES TO DISTINGUISH IT FROM A LOCAL.

\CONTENTS:
\ MAIN--DISPLAY TITLE AND INITIALIZE
\	ERROR--DISPLAY ERROR MESSAGE AND OPTIONALLY CONTINUE
\	GETCH--GET A CHARACTER FROM THE SOURCE DEVICE
\	RATOM--READ AN ATOM FROM SOURCE DEVICE
\	SKIPIT--SKIP STATEMENT FOR ERRORS
\	HEXB--OUTPUT A HEX BYTE (IN ASCII) TO BINARY DEVICE
\	GEN--OUTPUT I2L CODE TO BINARY DEVICE
\	FIX--CHANGE A SPECIFIC I2L LOCATION TO THE CURRENT PC
\	LOOKUP--LOOK UP AN IDENTIFIER NAME IN THE SYMBOL TABLE
\	INSERT--INSERT AN IDENTIFIER INTO THE SYMBOL TABLE
\	GETCON--GET A CONSTANT (EITHER VALUE OR NAME)
\	PROCAL--PROCEDURE CALLS
\	BOOLEXP--GENERATE I2L CODE FOR A BOOLEAN EXPRESSION
\		FACTOR--GENERATE CODE FOR A FACTOR
\			STRCON--TEXT STRING CONSTANT
\			STR2CON--COMPACT TEXT STRING CONSTANT
\			ARRAYCON--CONSTANT ARRAY
\			SPECFAC--SPECIAL FACTORS (addr,STRING)
\			IDFAC--IDENTIFIER FACTORS
\				FUNCTION--PROCEDURE AS A FACTOR
\		SHIFTEXP: GENERATE CODE FOR A SHIFT (E.G: A<<B)
\		TERM--GENERATE CODE FOR A TERM (E.G. A*B)
\			TERMX--
\		ALGEXP--ALGEBRAIC EXPRESSION (E.G. A+B)
\			ALGX--
\		LOGEXP--LOGICAL EXPRESSION (E.G. A=B)
\			LOGX--
\		BOOLTERM--BOOLEAN TERM (E.G. A&B)
\	SSTATEMENT--(FOR 'QUIT'S IN 'CASE' STATEMENTS)
\		STATEMENT--PARSE AND GENERATE CODE
\			ASSIGN--ASSIGNMENT STATEMENTS
\				ASSX--
\			CASER--CASE STATEMENTS
\				CASER2--
\	PROCEDURE--PARSE AND GENERATE CODE
\		CODDEC--'CODE' DECLARATION
\		CONDEC--'DEFINE' DECLARATION
\		VARDEC--'INT','REAL', AND 'ADDR' DECLARATIONS
\		EXTDEC--'EXTERNAL' PROCEDURE DECLARATION
\		FPRDEC--FORWARD PROCEDURE DECLARATIONS
\		PROCDEC--'PROCEDURE' DECLARATIONS

code	ABS=0		REM=2		RESERVE=3	SWAP=4
	CHIN=7		CHOUT=8		CRLF=9		INTIN=10
	INTOUT=11	TEXT=12		OPENI=13	OPENO=14
	CLOSE=15	TRAP=17		GETERR=22	FSET=24,
	FOPEN=29,	FCLOSE=32,	GETREG=35,	BLIT=36;			\%

code real	FLOAT=49	RLRES=46	RLOUT=48;

def	TV=0, KB=0, NULDEV=7, EOF=$1A, BEL=$07, CR=$0D, EOL=$0A; \I/O STUFF
def	INTSIZE=2,	\NUMBER OF BYTES IN AN INTEGER
			\IF CROSS-COMPILER THIS IS THE SIZE OF HOST NOT TARGET
	RLSIZE=5,	\%NO. OF BYTES IN A REAL NUMBER. (WARNING: SHOULD BE ODD
			\GLOBAL ZERO INTEGERS START AT 1. ALLOCATE ENOUGH ROOM.)
	SIGCHAR=8,	\NO. OF SIGNIFICANT CHARS IN AN IDENTIFIER
	SYMAX=1000,	\SIZE OF THE SYMBOL TABLE
	RLMAX=100,	\SIZE OF REAL-CONSTANT SYMBOL TABLE
	QUITMAX=100;	\MAXIMUM NO. OF 'QUIT'S IN A 'LOOP'

int	CHAR;	\CURRENT CHARACTER.  MOST OF THE TIME IT
		\ CONTAINS THE TERMINATOR OF THE CURRENT ATOM

int	ERRCNT	\ERROR COUNTER
	OPTION	\DEFAULT OPTION ARRAY.  WARNING: NOT ROMMABLE
	LSTDEV	\LISTING OUTPUT DEVICE NUMBER
	SRCDEV	\SOURCE INPUT DEVICE NUMBER
	BINDEV	\BINARY OUTPUT DEVICE NUMBER
	ATOM	\PRESENT ATOM DESCRIPTOR
		\CONTAINS RESERVED WORD HASH OR THE ASCII FOR A SPECIAL
		\ CHARACTER; 0 IF THE ATOM IS A CONSTANT OR AN IDENTIFIER
	ATYPE;	\PRESENT ATOM TYPE DESCRIPTOR
def	\ATYPE\ SPECIAL,IDENTIFIER,INTCON,REALCON;
addr	IDENT;	\ARRAY--CURRENT IDENTIFIER NAME
int	HASH	\CURRENT IDENTIFIER HASH CODE
	IATOM;	\VALUE OF CURRENT INTEGER CONSTANT

int	IDTYPE;	\PRESENT IDENTIFIER TYPE DESCRIPTOR
def	UNDEF=0,	\UNDEFINED ID (NO. ORDER IS CRITICAL)
	ADDRVAR=1,	\ADDRESS VARIABLE ID (TYPE = INTEGER)
	INVAR=3,	\INTEGER VARIABLE ID (ODD NOS.=INTEGER)
	RLVAR=4,	\REAL VARIABLE ID
	INCON=5,	\INTEGER CONSTANT ID
	RLCON=6,	\REAL CONSTANT ID
	INPROC=7,	\INTEGER PROCEDURE ID
	RLPROC=8,	\REAL PROCEDURE ID
	INFPROC=9,	\INTEGER FORWARD PROCEDURE ID
	RLFPROC=10,	\REAL FORWARD PROCEDURE ID
	INOPT=11,	\INTEGER OPTIMIZED PROCEDURE ID
	RLOPT=12,	\REAL OPTIMIZED PROCEDURE ID
	ININT=13,	\INTEGER INTRINSIC ID
	RLINT=14,	\REAL INTRINSIC ID
	INEXT=15,	\INTEGER EXTERNAL PROCEDURE ID
	RLEXT=16;	\REAL EXTERNAL PROCEDURE ID

int	LEV	\LEVEL OF CURRENT IDENTIFIER
	VAL	\VALUE OR ADDRESS OF CURRENT IDENTIFIER
	SYMNUM	\POSITION IN "SYMTBL" OF CURRENT IDENTIFER
	FACTYP;	\FACTOR (OR OPERAND) TYPE (REAL OR INTEGER)
def	\FACTYP\ REAL,INTEGER;
int	FIXES	\ARRAY--'QUIT' FIXES STILL OUTSTANDING
	PC	\THE I2L PROGRAM COUNTER
	OLDPC	\PC VARIABLE USED BY PROCEDURE "GEN"
	LASTOP	\LAST OPCODE GENERATED BY "GEN"
	LLASTOP	\PRECEDING OPCODE GENERATED BY "GEN"
	LASTVAL	\LAST "VAL" GENERATED BY "GEN"
	LLASTVAL\PRECEDING "VAL" GENERATED BY "GEN"
	OPTIMIZE \FLAG: DO OPTIMIZATIONS
	LEVEL	\STATIC LEVEL OF CURRENT PROCEDURE
	NOSYM	\CURRENT NUMBER OF SYMBOLS IN SYMBOL TABLE
	FIXCNT	\COUNT OF THE NUMBER OF OUTSTANDING 'QUIT'S
	STKLOD	\NO. OF INTEGERS LEFT ON STACK BY 'FOR' ! 'CASE'
	OPTPROC	\BOOLEAN--GENERATE AN OPTIMIZED PROCEDURE CALL
	NORLSY	\CURRENT NUMBER OF REAL CONSTANTS IN TABLE
	I;	\SCRATCH
addr	HEXDIGIT; \ARRAY OF HEX DIGITS (0 - F)
	\ -- SYMBOL TABLE ARRAYS --
addr	SYMBOL	\IDENTIFIER NAME (IDENT)
	SYMTYP;	\TYPE DESCRIPTORS (IDTYPE)
int	SYMVAL;	\VALUE OR ADDRESS (VAL)
addr	SYMLEV;	\LEVEL (LEV)
int	SYMPNT;	\LIST LINKAGE POINTERS

int	BOX;	\HASH BOXES (SYMBOL LIST HEADERS)
real	RLATOM;	\REAL CONSTANT FROM PROC "RATOM"
real	RLTBL;	\REAL CONSTANT TABLE

\%%% VARIABLES FOR IBM DISKIO %%%%
int	SYSINF,		\POINTER SYSTEM TO INFO
	INHAND,		\INPUT HANDLE
	OUTHAND;	\OUTPUT HANDLE
int	HANPTR,OLDHAND;
def	HANMAX=8;


def		\RESERVED WORD HASHES
ADRSYM=25797,	BEGSYM=26057,	CASEYM=25046,	CODSYM=28615,
DEFSYM=26058,	DOSYM=28516,	ELSEYM=27864,	ENDSYM=28361,
EXITYM=30926,	EXTNYM=30937,	FALSYM=25042,	FFUNYM=26331,
FORSYM=28632,	FPRSYM=28888,	FUNSYM=30164,	GESYM=25959,
GETSYM=26075,	IFSYM=26217,	INTSYM=28381,	LESYM=25964,
LOOPYM=28635,	NOTSYM=28642,	OFSYM=26223,	PROCYM=29407,
QUITYM=30170,	REALYM=26067,	REPSYM=26082,	RETSYM=26086,
THENYM=26841,	TRUSYM=29417,	UNTSYM=28393,	WHILYM=26848,
CHARYM=26820,	EPRSYM=28887,	EFUNYM=26330,	LNKSYM=27098,
OTHSYM=29911,	LSLSYM=29656,	LSRSYM=29662,	INCSYM=28364;



proc	ERROR; int N;	\SEND ERROR MESSAGE TO THE TV
int	ERR,CH,I,QUIT;
addr	STRING;
def	MAXERR=70;	\MAXIMUM ERROR NUMBER
begin
ERR:=RESERVE((MAXERR+1)*INTSIZE);
for I:=0,MAXERR do ERR(I):="?";		\UNUSED ERROR NOS. = "?"

ERR(1):="TOO MANY VARIABLES";
ERR(2):="TOO MANY REAL CONSTANT NAMES";
ERR(3):="TOO MANY NAMES";
ERR(4):="TOO MANY 'QUITS'";
ERR(5):="TOO MANY STATIC LEVELS";
ERR(6):="NUMBER OUT OF RANGE";
ERR(7):=ERR(6);				\FOR INTRINSIC DECLARATIONS
ERR(10):="UNDECLARED NAME";
ERR(11):="NAME ALREADY DECLARED";
ERR(20):="ILLEGAL START OF A STATEMENT";\IN "ASSIGN"
ERR(21):="^":=^"*";
ERR(22):="'THEN'*";
ERR(23):="'DO'*";
ERR(24):="^",^"*";
ERR(26):="ILLEGAL FACTOR";		\UNRECOGNIZABLE SPECIAL FACTOR
ERR(27):="STATEMENT STARTING WITH A CONSTANT"; \IN "ASSIGN"
ERR(28):="'UNTIL'*";
ERR(29):="'OTHER'*";
ERR(30):="'ELSE'*";
ERR(31):="DIGIT*";
ERR(33):="INTEGER VARIABLE*";		\IN A 'FOR' STATEMENT
ERR(40):="^"=^"*";
ERR(41):="^";^"*";
ERR(42):="CONSTANT*";			\IN "GETCON"
ERR(43):="VARIABLE*";			\FOR AN 'ADDR' OPERATOR
ERR(44):="^")^"*";
ERR(45):="NAME*";
ERR(46):="MIXED MODE";
ERR(47):="INTEGER*";
ERR(48):="'OF'*";
ERR(49):="^":^"*";
ERR(50):="^"]^"*";
ERR(51):="NO ARGUMENTS DECLARED";
ERR(52):="STATEMENT STARTING WITH 'ELSE'";
ERR(53):="STATEMENT STARTING WITH 'OTHER'";
ERR(60):="'QUIT' NOT IN A 'LOOP'";
ERR(61):="EOF*";
ERR(62):="EOF INSIDE A BLOCK";
ERR(63):="EOF INSIDE A STRING";
ERR(64):="ILLEGAL CHARACTER IN A STRING";
ERR(65):="'FPROC' & ITS 'PROC' NOT AT SAME LEVEL";
ERR(66):="'FPROC' REFERENCE NOT FOUND";
ERR(67):="'PROC' OR 'FUNC'*";
ERR(68):="'EPROC'S AND 'LINK'S MUST BE GLOBAL";
ERR(69):="INCLUDES NEST TOO DEEP";
ERR(70):="BAD FILE SPEC";


if LSTDEV=8 then
	begin
	OPENI(8);
	loop	begin
		I:=CHIN(8);
		if I=EOF then quit;
		CHOUT(0,I);
		end;
	CRLF(0);
	end;

CHOUT(TV,BEL);
TEXT(TV,"
***** ERROR NO. "); INTOUT(TV,N); TEXT(TV," *****
");
STRING:=ERR(N);
I:=0;
QUIT:= false;
loop	[CH:=STRING(I);		\OUTPUT MESSAGE
	if CH>=$80 then [QUIT:=true; CH:=CH &$7F];
	if CH=^* then TEXT(TV," EXPECTED BUT NOT FOUND")
		else CHOUT(TV,CH);
	if QUIT then quit;
	I:=I+1];
CRLF(TV);
TEXT(TV,"ATTEMPT TO CONTINUE (Y/N)? ");
OPENI(KB);
if (CHIN(KB) !$20) =^n then [CLOSE(LSTDEV); exit];
BINDEV:=NULDEV;		\THERE SHALL BE NO OUTPUT FILE
ERRCNT:=ERRCNT+1;
end;	\ERROR

\----------------------------------------------------------------------

proc	GETCH;	\GET A CHARACTER FROM THE SOURCE DEVICE
\ FILTERS OUT COMMENTS.
\(THIS PROCEDURE IS OPTIMIZED FOR SPEED.)
begin
CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
while CHAR=^\ do			\FILTER OUT COMMENTS
	begin
	loop	[CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
		case CHAR of
		  EOL:	quit;
		  ^\:	quit;
		  EOF:	return
		other	];
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	end;
end;	\GETCH

\-------------- ROUTINES TO HANDLE INCLUDES ---------------


procedure FALLBACK;
\TERMINATE AN INCLUDE AND
\FALL BACK TO PREVIOUS HANDLE
begin
HANPTR:=HANPTR-1;
FCLOSE(INHAND);
INHAND:=OLDHAND(HANPTR);
\ONLY THE MAIN FILE GETS A BIG BUFFERS
FSET(INHAND,if HANPTR=0 then ^I else ^i);
end;


procedure INCLUDE;
\SET UP AN INCLUDE FILE
char NAME; define NAMMAX=80;
integer NEWHAND;

	procedure GETNAME;
	integer EXTFLG, I,K;
	char DEFEXT;
	begin
	DEFEXT:=".XPL";
	EXTFLG:=false;

	\EAT LEADING SPACES AND CONTROL CHARS
	while CHAR<=$20 do [if CHAR=EOF then ERROR(61);GETCH;];

	\COPY FILE NAME INTO 'NAME'
	K:=0;
	loop	begin
		case CHAR of
		^. : EXTFLG:=true;
		EOL: return false;
		^; : quit else;

		NAME(K):=CHAR;
		K:=K+1;
		if K>=NAMMAX  then return false;
		GETCH;
		end;

	\DEAL WITH EMPTY FILENAME
	if K=0 then return false;

	\DEAL WITH DEFAULT EXTENTIONS
	if EXTFLG then NAME(K-1):=NAME(K-1) ! $80
	else
		begin
		if (K+4)>=NAMMAX then return false;
		for I:=0,3 do NAME(K+I):=DEFEXT(I);
		end;
	return true;
	end;


begin\INCLUDE
NAME:=RESERVE(NAMMAX);
if HANPTR>=HANMAX then
	[ERROR(69);while CHAR#^; & CHAR#EOF do GETCH;return;];
if not GETNAME then
	[ERROR(70);while CHAR#^; & CHAR#EOF do GETCH;return;];


\OPEN FILE
TRAP($FFFB);
NEWHAND:=FOPEN(NAME,0);
TRAP($FFFF);
if GETERR=3 then [ERROR(70);return;];

\SAVE OLD FILE HANDLE ON STACK
OLDHAND(HANPTR):=INHAND;
HANPTR:=HANPTR+1;
INHAND:=NEWHAND;

\INCLUDE FILES ALWAYS USE SMALL BUFFERS
FSET(INHAND,^i);

TEXT(0,"INCLUDING-");
TEXT(0,NAME);CRLF(0);
end;

\----------------------------------------------------------


'PROCEDURE'NEGFLOAT;
'INT'M0,M1,EXP;
'CHAR'IB;
'REAL'X;


        procedure COMPMAN;
        \Compliment Mantissa
        begin
	'IF'(M1=$FFFF)&(M0=$7FFF)'THEN'	\SPECIAL CASE OF -1
		'BEGIN'
		M1:=0;
		M0:=$4000;
		EXP:=EXP+1;
		'RETURN';
		'END';
        M0:=not M0;M1:=not M1;
        if M1<0 then if (M1+1)>=0 then M0:=M0+1;
        M1:=M1+1;
        end;
 
 
        procedure NORMAL;
        \Normalize to Apple standard
        begin
        while ((M0 & $C000)=0) ! ((M0 & $C000)=$C000) do
                begin
                \M0:=M0<<1;
		M0:=M0+M0;
                if M1<0 then M0:=M0 ! 1;
                \M1:=M1<<1;
                M1:=M1+M1;
		EXP:=EXP-1;
                end;
        end;


'BEGIN'
IB:='ADDR'RLATOM;
M0:=SWAP(IB(1))+IB(2);
M1:=SWAP(IB(3))+IB(4);
EXP:=IB(0);
COMPMAN;
NORMAL;
IB(0):=EXP;
IB(1):=SWAP(M0);IB(2):=M0;
IB(3):=SWAP(M1);IB(4):=M1;
IB(5):=0;
IB(6):=0;
IB(7):=0;
'END';



procedure REFLOAT;
\CONVERT IBM REAL TO APPLE REAL
\LARRY FISH'S VERSION

int EXP,M0,M1,SIGN;
char IB;
int IW;


'FUNCTION'LSHIFT(I,N);
'INT'I,N;
'INT'J;
'BEGIN'
'FOR'J:=1,N'DO'I:=I*2;
'RETURN'I;
'END';

'FUNCTION'RSHIFT(I,N);
'INT'I,N;
'INT'J;
'BEGIN'
'FOR'J:=1,N'DO'
	'BEGIN'
	'IF'I<0'THEN'
		'BEGIN'
		I:='NOT'I;
		I:=I/2;
		I:=('NOT'I)&$7FFF;
		'END'
	'ELSE'I:=I/2;
	'END';
'RETURN'I;
'END';

 
        procedure COMPMAN;
        \Compliment Mantissa
        begin
        M0:=not M0;M1:=not M1;
        if M1<0 then if (M1+1)>=0 then M0:=M0+1;
        M1:=M1+1;
        end;
 
 
        procedure NORMAL;
        \Normalize to Apple standard
        begin
        while ((M0 & $C000)=0) ! ((M0 & $C000)=$C000) do
                begin
                \M0:=M0<<1;
		M0:=LSHIFT(M0,1);
                if M1<0 then M0:=M0 ! 1;
                \M1:=M1<<1;
                M1:=LSHIFT(M1,1);
		EXP:=EXP-1;
                end;
        end;
 
 
 
begin
IB:=addr RLATOM;     \Make a byte pointer to IBM real
IW:=addr RLATOM;     \Make a word pointer to IBM real
 
\Zero is a special case
if RLATOM=0.0 then 
	'BEGIN'
	IW(0):=$0080;
	IW(1):=0;
	IW(2):=0;
	IW(3):=0;
	return;
	'END';
 
\Get the sign
SIGN:=IW(0)<0;
 
\Unbias exponent
\EXP:=(($7FF0 & IW(0)) >> 4) - $3FF;
EXP:= RSHIFT ($7FF0 & IW(0),4) - $3FF;
if EXP>127 ! EXP<-128 then
        [TEXT(0,"EXPONENT TOO BIG");CRLF(0);return];
 
\Handle mantissa and implied leading 1 bit
\M0:=(($0F & IW(0))<<10) ! (IW(1)>>6) ! $4000; 
M0:= LSHIFT($0F & IW(0),10) ! RSHIFT(IW(1),6) ! $4000; 
 
\Handle rest of  mantissa
\M1:=(IW(1)<<10) ! (IW(2)>>6);
M1:=LSHIFT(IW(1),10) ! RSHIFT(IW(2),6);
 
\Bias exponent
EXP:=EXP+$80;
 
\Complement if negative
if SIGN then
        begin
        COMPMAN;
        NORMAL;
        end;
 
IB(0):=EXP;
IB(1):=SWAP(M0);IB(2):=M0;
IB(3):=SWAP(M1);IB(4):=M1;
IB(5):=0;
IB(6):=0;
IB(7):=0;
end;


\----------------------------------------------------------


proc	RATOM;		\READ AN ATOM
\OUTPUTS:  ATOM, ATYPE, IDENT, HASH, IATOM, CHAR, RLATOM.
\ (THIS PROCEDURE IS OPTIMIZED FOR SPEED.)
int	LEN,NEG,EXP,I,INTOVF;
real	FRACT,DENOM;


	proc	RFRACT;	\READ THE FRACTIONAL PART OF A REAL NO.
	begin
	ATYPE:=REALCON; ATOM:=0;
	repeat GETCH until CHAR#^_;
	FRACT:=FLOAT(0); DENOM:=FLOAT(10);	\(10.0 IS NOT SO PORTABLE)
	while CHAR>=^0 & CHAR<=^9 do
		[FRACT:=FRACT +FLOAT(CHAR-^0) /DENOM;
		DENOM:=DENOM*FLOAT(10);
		repeat GETCH until CHAR#^_];
	RLATOM:=RLATOM +FRACT;
	end;	\RFRACT



	proc	REXP;	\READ AN EXPONENT IF ANY
	if CHAR=^E then
		begin
		ATYPE:=REALCON;
		repeat GETCH until CHAR#^_;
		if CHAR=^- then [NEG:=true; repeat GETCH until CHAR#^_]
		else NEG:=false;
		if CHAR=^+ then repeat GETCH until CHAR#^_;
		EXP:=0;
		if CHAR<^0 ! CHAR>^9 then ERROR(31);
		while CHAR>=^0 & CHAR<=^9 do
			[EXP:=EXP *10 +CHAR-^0;   repeat GETCH until CHAR#^_];
		if NEG then EXP:= -EXP;
		while EXP>0 do
			[RLATOM:=RLATOM *FLOAT(10); EXP:=EXP-1];
		while EXP<0 do
			[RLATOM:=RLATOM /FLOAT(10); EXP:=EXP+1];
		end;	\REXP

begin	\RATOM
while CHAR<=$20\SPACE\ do
	begin	\SKIP SPACES, TABS, RETURNS, LF'S, & FF'S, ETC.
		\DON'T GO PAST EOF

	if CHAR=EOF then if HANPTR>0 then FALLBACK
		else  [ATYPE:=SPECIAL; ATOM:=EOF; return];
	GETCH;
	end;
if CHAR>=^a then if CHAR<=^z then			\RESERVED WORD
	[ATYPE:=SPECIAL;
	ATOM:=CHAR; GETCH;
	ATOM:=ATOM+SWAP(CHAR); GETCH;
	if CHAR>=^a & CHAR<=^z then [ATOM:=ATOM+CHAR; GETCH];
	while CHAR>=^a & CHAR<=^z do GETCH;
	case ATOM of
	TRUSYM: [ATYPE:=INTCON; ATOM:=0; IATOM:=true];
	FALSYM:	[ATYPE:=INTCON; ATOM:=0; IATOM:=false];
	INCSYM: [INCLUDE;GETCH;RATOM]
	else;
	return];
if CHAR>=^A then if CHAR<=^Z ! CHAR=^_ then		\IDENTIFIER
	begin
	ATYPE:=IDENTIFIER; ATOM:=0;
	IDENT(0):=CHAR; HASH:=CHAR; GETCH;
	LEN:=1;
	loop	begin
		if CHAR>=^a & CHAR<=^z then CHAR:=CHAR & $DF;	\UPPERCASE
		case of
		  CHAR>=^A & CHAR<=^Z,  CHAR>=^0 & CHAR<=^9,  CHAR=^_:
			begin
			if LEN <SIGCHAR then
				[IDENT(LEN):=CHAR;
				HASH:=HASH+CHAR;
				LEN:=LEN+1];
			GETCH;
			end
		other quit;
		end;
	for LEN:=LEN,SIGCHAR-1 do
		[IDENT(LEN):=^ ; HASH:=HASH+^ ];
	HASH:=HASH & $FF;
	return;
	end;
if CHAR>=^0 then if CHAR<=^9 then			\UNSIGNED INTEGER
	begin
	ATYPE:=INTCON;		\ASSUME INTEGER UNTIL SHOWN OTHERWISE
	ATOM:=0;
	INTOVF:= false;
	IATOM:=CHAR-^0;
	repeat GETCH until CHAR#^_;
	loop	begin
		I:=IATOM;
		if CHAR<^0 ! CHAR>^9 then quit;
		I:=IATOM*10+CHAR-^0;
		if IATOM>3276 ! IATOM=3276 & CHAR>^7 then	\"I" OVERFLOWED
			[INTOVF:= true; quit];			\ OK IF IT'S A REAL
		IATOM:=I;
		repeat GETCH until CHAR#^_;
		end;
	RLATOM:=FLOAT(IATOM);
	IATOM:=I;	\GET POSSIBLE LEGAL VALUE OF 32768 (AS IN -32768)
	while CHAR>=^0 & CHAR<=^9 do	\MORE DIGITS MUST BE REAL
		[RLATOM:=RLATOM*FLOAT(10) + FLOAT(CHAR-^0);
		repeat GETCH until CHAR#^_];
	if CHAR=^. then RFRACT;				\UNSIGNED REAL
	REXP;
	REFLOAT;
	return;
	end;
case CHAR of
  ^.:	[RLATOM:=FLOAT(0);				\UNSIGNED REAL
	RFRACT;
	REXP;
	REFLOAT;
	return];
  ^$:	begin						\UNSIGNED HEX INTEGER
	ATYPE:=INTCON; ATOM:=0;
	repeat GETCH until CHAR#^_;
	case of
	  CHAR>=^0 & CHAR<=^9: IATOM:=CHAR-^0;
	  CHAR>=^A & CHAR<=^F: IATOM:=CHAR-$37;
	  CHAR>=^a & CHAR<=^f: IATOM:=CHAR-$57
	other [\DIGIT EXPECTED\ ERROR(31); return];
	loop	[repeat GETCH until CHAR#^_;
		case of
		  CHAR>=^0 & CHAR<=^9: I:=CHAR-^0;
		  CHAR>=^A & CHAR<=^F: I:=CHAR-$37;
		  CHAR>=^a & CHAR<=^f: I:=CHAR-$57
		other return;
		if IATOM>$FFF then ERROR(6);
		IATOM:=IATOM*16+I];
	end;
  ^^:	[ATYPE:=INTCON;			\META CHARACTER = INTEGER CONSTANT
	ATOM:=0;
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	IATOM:=CHAR;
	GETCH;
	return];
  ^",^':[ATYPE:=SPECIAL;				\SPECIAL CHARACTER
	ATOM:=CHAR;	\(' AND BACKSLASH HAVE NO EFFECT IN STRINGS)
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	return]
other;
ATYPE:=SPECIAL;						\SPECIAL CHARACTER
ATOM:=CHAR;
GETCH;
case CHAR of
  ^=:	case ATOM of
	  ^::	[GETCH; ATOM:=GETSYM];
	  ^>:	[GETCH; ATOM:=GESYM];
	  ^<:	[GETCH; ATOM:=LESYM]
	other;
  ^<:	[if ATOM = ^< then [GETCH; ATOM:= LSLSYM]];
  ^>:	[if ATOM = ^> then [GETCH; ATOM:= LSRSYM]]
other;
end;	\RATOM

\----------------------------------------------------------------------

proc	SKIPIT;
\SKIP THE REST OF A STATEMENT FOR ERROR RECOVERY
begin
while ATOM#EOF & ATOM#^; & ATOM#ENDSYM & ATOM#^] &
	ATOM#BEGSYM & ATOM#^[ do RATOM;
end;	\SKIPIT



proc	HEXB; int I;	\OUTPUT HEX BYTE (OPTIMIZED FOR SPEED)
begin
CHOUT(BINDEV,HEXDIGIT(I>>4 &$0F));
CHOUT(BINDEV,HEXDIGIT(I &$0F));
end;	\HEXB



proc	HEXOUT; int I;	\OUTPUT HEX WORD TO "BINDEV"
begin
HEXB(SWAP(I));
HEXB(I);
end;	\HEXOUT

\----------------------------------------------------------------------

fproc	GENIMM, GENJMP;

proc	GEN; int OP,LEV,VAL,CL;	\GENERATE INSTRUCTION
int	I;
addr	A;



proc BACKUP; int N;
begin
PC:=PC-N; LASTOP:=-1;
end;	\BACKUP



func	COMBINED(N);	\RETURNS 'TRUE' IF CONSTANTS ARE COMBINED
int	N;
begin
case OP of
  \ADD\$0D:	[BACKUP(N);   GENIMM(LLASTVAL +LASTVAL)];
  \SUB\$0E:	[BACKUP(N);   GENIMM(LLASTVAL -LASTVAL)];
  \MUL\$0F:	[BACKUP(N);   GENIMM(LLASTVAL *LASTVAL)];
  \(CAN'T OPTIMIZE DIVIDE BECAUSE WE MIGHT NEED REMAINDER)
  \EQ\$12:	[BACKUP(N);   GENIMM(LLASTVAL =LASTVAL)];
  \NE\$13:	[BACKUP(N);   GENIMM(LLASTVAL #LASTVAL)];
  \GE\$14:	[BACKUP(N);   GENIMM(LLASTVAL >=LASTVAL)];
  \GT\$15:	[BACKUP(N);   GENIMM(LLASTVAL >LASTVAL)];
  \LE\$16:	[BACKUP(N);   GENIMM(LLASTVAL <=LASTVAL)];
  \LT\$17:	[BACKUP(N);   GENIMM(LLASTVAL <LASTVAL)];
  \OR\$1A:	[BACKUP(N);   GENIMM(LLASTVAL !LASTVAL)];
  \AND\$1B:	[BACKUP(N);   GENIMM(LLASTVAL &LASTVAL)];
  \EOR\$1D:	[BACKUP(N);   GENIMM(LLASTVAL |LASTVAL)];
  \DBA\$1E:	[BACKUP(N);   GENIMM(LLASTVAL +LASTVAL<1)];
  \LSL\$3E:	[BACKUP(N);   GENIMM(LLASTVAL <<LASTVAL)];
  \LSR\$3F:	[BACKUP(N);   GENIMM(LLASTVAL >>LASTVAL)]
other return false;
return true;
end;	\COMBINE



begin	\GEN
if OPTIMIZE then
	begin
	case LASTOP of		\DON'T GENERATE CODE THAT WILL NEVER BE EXECUTED
	  \EXT\$00, \RET\$06, \JMP\$07, \BRA\$23, \RTS\$27: return;
	  \IMM\$0B:		\TRY TO COMBINE TWO CONSTANTS
		case LLASTOP of
		  \IMM\$0B:	if COMBINED(3+3) then return;
		  \SIM\$24:	if COMBINED(3+2) then return
		other if LLASTOP>=$40 & LLASTOP<=$7F \SSIM\ then 
				if COMBINED(3+1) then return;
	  \SIM\$24:
		case LLASTOP of
		  \IMM\$0B:	if COMBINED(2+3) then return;
		  \SIM\$24:	if COMBINED(2+2) then return
		other if LLASTOP>=$40 & LLASTOP<=$7F \SSIM\ then 
				if COMBINED(2+1) then return
	other if LASTOP>=$40 & LASTOP<=$7F \SSIM\ then 
		case LLASTOP of
		  \IMM\$0B:	if COMBINED(1+3) then return;
		  \SIM\$24:	if COMBINED(1+2) then return
		other if LLASTOP>=$40 & LLASTOP<=$7F \SSIM\ then 
				if COMBINED(1+1) then return;

	if LASTOP =\SSIM-1\$40 then	\A &$FFFF =A, ETC.
		case OP of
		  \AND\$1B: [BACKUP(1); return];
		  \EOR\$1D: [BACKUP(1); GEN(\NOT\$1C,0,0,0); return]
		other;
	if LASTOP =\SSIM0\$41 then	\A +0 =A, ETC.
		case OP of \ADD\$0D, \SUB\$0E, \OR\$1A, \EOR\$1D, \DBA\$1E,
			\LSL\$3E, \LSR\$3F: [BACKUP(1); return]
		other;

	case OP of
	  \JPC\$08:	\JUMP ON FALSE (=0)
		case LASTOP of
		  \IMM\$0B:	[BACKUP(3); if LASTVAL then else GENJMP(VAL); ret];
		  \SIM\$24:	[BACKUP(2); if LASTVAL then else GENJMP(VAL); ret]
		other if LASTOP>=$40 & LASTOP<=$7F \SSIM\ then 
				[BACKUP(1); if LASTVAL then else GENJMP(VAL); ret];
	  \MUL\$0F:
		if LASTOP=\SSIM1\$42 then [BACKUP(1); return];
		\(CAN'T OPTIMIZE DIVIDE BECAUSE WE MIGHT NEED REMAINDER)
	  \NEG\$11:
		case LASTOP of
		  \NEG\$11:	[BACKUP(1); return];
		  \IMM\$0B:	[BACKUP(3); GENIMM(-LASTVAL); return];
		  \SIM\$24:	[BACKUP(2); GENIMM(-LASTVAL); return]
		other if LASTOP>=$40 & LASTOP<=$7F \SSIM\ then 
					[BACKUP(1); GENIMM(-LASTVAL); return];
	  \NOT\$1C:
		case LASTOP of
		  \NOT\$1C:	[BACKUP(1); return];
		  \IMM\$0B:	[BACKUP(3); GENIMM(~LASTVAL); return];
		  \SIM\$24:	[BACKUP(2); GENIMM(~LASTVAL); return]
		other if LASTOP>=$40 & LASTOP<=$7F \SSIM\ then 
					[BACKUP(1); GENIMM(~LASTVAL); return];
	  \RTS\$27:
		if LASTOP = \JSR\$26 then	\PJMP
			[BACKUP(3); GENJMP(LASTVAL); return];
	  \STO2\$3C:
		if LASTOP>=$80 & (LASTOP&$7F)=VAL then [BACKUP(1); return]
		\A:= A; (OCCURS WHEN RETURNING A CALL TO A FUNCTION)
	other;
	end;

if PC #OLDPC then [CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(PC)];

\THE ENCODING OF THE CLASS, CL, IS AN 8-BIT BINARY CODE.
\0 = OPCODE ONLY, 1 BYTE
\2 = OPCODE WITH ONE-BYTE VALUE
\3 = OPCODE WITH TWO-BYTE VALUE (3 BYTES TOTAL)
\7 = OPCODE WITH ADDRESS (TO BE RELOCATED BY LOADER), 3 BYTES
\10 = OPCODE WITH LEVEL AND ONE-BYTE OFFSET (IN VAL)
\15 = OPCODE WITH LEVEL AND ADDRESS, 4 BYTES
\16 = IMMF OPCODE WITH "RLSIZE" BYTES OF VALUE
\32 = CONSTANT REAL ARRAY POINTER
\64 = OPCODE WITH BASE RELATIVE ADDRESS, 3 BYTES
HEXB(OP); PC:=PC+1;
if CL&8 then [HEXB(LEV); PC:=PC+1];
if CL&4 then [CHOUT(BINDEV,^*); HEXOUT(VAL); PC:=PC+2]	\HIGH BYTE, LOW BYTE
else	begin
	if CL&2 then [HEXB(VAL); PC:=PC+1];		\LOW BYTE
	if CL&1 then [HEXB(SWAP(VAL)); PC:=PC+1];	\HIGH BYTE
	end;

if CL=16 then		\IMMF--LOAD IMMEDIATE REAL NO. (RLATOM)
	[A:=addr RLATOM;  \TO ACCESS INDIVIDUAL BYTES IN RLATOM
	for I:=0,RLSIZE-1 do HEXB(A(I));
	PC:=PC+RLSIZE];
if CL&32 then	\OUTPUT DUMMY BYTES FOR CONSTANT REAL ARRAY POINTERS
	for I:=3,RLSIZE do [HEXB(0); PC:=PC+1];
if CL=64 then [CHOUT(BINDEV,^#); HEXOUT(VAL); PC:=PC+2];
OLDPC:=PC;
LLASTOP:= LASTOP;
LASTOP:= OP;
LLASTVAL:= LASTVAL;
LASTVAL:= VAL;
end;	\GEN

\----------------------------------------------------------------------

proc	GENLOD; int LEV, VAL;	\GENERATE INTEGER LOAD INSTRUCTION (LOD)
begin
case of
  VAL<=$7F & LEV=LEVEL & (VAL&$01)=0 & ~OPTPROC,	\ONE-BYTE LOCAL LOAD
  VAL<=$7F & LEV=0 & (VAL&$01)\#0\:	\ONE-BYTE GLOBAL LOAD
	GEN($80!VAL,0,0,0)
other	GEN(\LOD\$01,LEV,VAL,10);	\THREE-BYTE LOAD
end;	\GENLOD



proc	GENLDX; int LEV, VAL;	\GENERATE INDEXED LOAD INSTRUCTION (LDX)
begin
case of
  LEV=LEVEL & (VAL&$01)=0 & ~OPTPROC,	\TWO-BYTE LOCAL INDEXED LOAD
  LEV=0 & (VAL&$01)\#0\:		\TWO-BYTE GLOBAL INDEXED LOAD
	GEN(\LDX2\$22,0,VAL,2)
other	GEN(\LDX\$02,LEV,VAL,10);	\THREE-BYTE INDEXED LOAD
end;	\GENLDX



proc	GENSTO; int LEV, VAL;	\GENERATE STORE INSTRUCTION (STO)
begin
case of
  LEV=LEVEL & (VAL&$01)=0 & ~OPTPROC,	\TWO-BYTE LOCAL STORE
  LEV=0 & (VAL&$01)\#0\:		\TWO-BYTE GLOBAL STORE
	GEN(\STO2\$3C,0,VAL,2)
other	GEN(\STO\$03,LEV,VAL,10);	\THREE-BYTE STORE
end;	\GENSTO



proc	GENSTX; int LEV, VAL;	\GENERATE INDEXED STORE INSTRUCTION (STX)
begin
case of
  LEV=LEVEL & (VAL&$01)=0 & ~OPTPROC,	\TWO-BYTE LOCAL INDEXED STORE
  LEV=0 & (VAL&$01)\#0\:		\TWO-BYTE GLOBAL INDEXED STORE
	GEN(\STX2\$3D,0,VAL,2)
other	GEN(\STX\$04,LEV,VAL,10);	\THREE-BYTE INDEXED STORE
end;	\GENSTX



proc	GENJMP; int VAL;	\GENERATE JUMP OR BRANCH INSTRUCTION (JMP ! BRA)
\IF VAL = 0 THEN IT IS ASSUMED THAT THE LOCATION IS A FORWARD REFERENCE THAT
\ WILL BE "FIXED" LATER.
int	REL;
begin
REL:=PC -VAL;	\CALCULATE RELATIVE ADDRESS BACK (REL=0 IS AN INFINITE LOOP)
if REL>=0 & REL<=$FF & VAL#0 then
	GEN(\BRA\$23,0,REL,2)
else 	GEN(\JMP\$07,0,VAL,7);
end;	\GENJMP



proc	GENIMM; int VAL;	\GENERATE IMMEDIATE LOAD INSTRUCTION
begin
if ABS(VAL)<128 & VAL#$8000 then
	begin
	if VAL>=-1 & VAL<=$3E then 
		GEN(\SSIM\$41+VAL,0,VAL,0)	\SHORT, SHORT IMMEDIATE
	else GEN(\SIM\$24,0,VAL,2);		\SHORT IMMEDIATE
	end
else GEN(\IMM\$0B,0,VAL,3);			\16-BIT IMMEDIATE
end;	\GENIMM

\----------------------------------------------------------------------

proc	FIX; int I;	\FIX FORWARD REFERENCES
begin
CRLF(BINDEV);
if PC#OLDPC then
	[CHOUT(BINDEV,^;); HEXOUT(PC);
	OLDPC:=PC;
	CRLF(BINDEV)];
CHOUT(BINDEV,^^); HEXOUT(I+1);
LASTOP:=-1;		\DON'T OPTIMIZE CODE (JMP MAY ENTER HERE, ETC)
end;	\FIX



proc	LOOKUP;		\LOOKUP IDENTIFIER IN SYMBOL TABLE
\INPUTS: IDENT, HASH
\OUTPUTS: IDTYPE, VAL, LEV, SYMNUM.
\IF TWO IDENTIFIERS OF THE SAME NAME ARE IN THE SYMBOL TABLE
\ THEN THE MOST RECENT ENTRY IS USED.
int	I,K,PNTR;
begin
PNTR:=BOX(HASH);
loop	begin
	if PNTR=\EMPTY\-1 then [IDTYPE:=UNDEF; quit];
	I:=0; K:=PNTR;
	while IDENT(I)=SYMBOL(K) & I<SIGCHAR do
		[I:=I+1; K:=K+SYMAX];
	if I=SIGCHAR then	\FOUND
		[IDTYPE:=SYMTYP(PNTR);
		VAL:=SYMVAL(PNTR);
		LEV:=SYMLEV(PNTR);
		SYMNUM:=PNTR;		\(FOR FORWARD PROC)
		quit];
	PNTR:=SYMPNT(PNTR);
	end;
end;	\LOOKUP



proc	INSERT; int STYP,SLEV,SVAL;
\INSERT THE CURRENT IDENTIFIER INTO THE SYMBOL TABLE
\INPUTS:  STYP, SLEV, SVAL, IDENT, HASH, NOSYM, SYMBOL, & BOX.
int	I,K;
begin
LOOKUP;
if IDTYPE#UNDEF then if LEV=LEVEL then \COLLISION\ ERROR(11);
if NOSYM>=SYMAX then \TABLE FULL\ [ERROR(3); NOSYM:=SYMAX-1];
K:=NOSYM;
for I:=0,SIGCHAR-1 do [SYMBOL(K):=IDENT(I); K:=K+SYMAX];
SYMTYP(NOSYM):=STYP;
SYMLEV(NOSYM):=SLEV;
SYMVAL(NOSYM):=SVAL;
SYMPNT(NOSYM):=BOX(HASH);		\LINK BACK
BOX(HASH):=NOSYM;
NOSYM:=NOSYM+1;
end;	\INSERT

\----------------------------------------------------------------------

proc	GETCON;	\GET A CONSTANT--EITHER BY VALUE OR BY NAME
int	NEG;
begin
if ATOM=^+ then RATOM;
if ATOM=^- then [NEG:=true; RATOM] else NEG:=false;
case ATYPE of
  INTCON: [if NEG then IATOM:=-IATOM; FACTYP:=INTEGER];
  REALCON:[if NEG then NEGFLOAT; FACTYP:=REAL];
IDENTIFIER:
	begin
	LOOKUP;
	case IDTYPE of
	  INCON:[IATOM:=if NEG then -VAL else VAL;
		FACTYP:=INTEGER];
	  RLCON:[RLATOM:=RLTBL(VAL);
		 if NEG then NEGFLOAT;
		 FACTYP:=REAL]
	other	ERROR(42);
	end
other	ERROR(42);
end;	\GETCON



fproc	BOOLEXP;



proc	PROCAL;
int	SVAL,SLEV,ARGCNT,SID;
begin
SVAL:=VAL; SLEV:=LEV; SID:=IDTYPE;
RATOM;
ARGCNT:=0;
if ATOM=^( then
	begin
	repeat	[RATOM; 
		BOOLEXP;
		ARGCNT:=ARGCNT +(if FACTYP=INTEGER then
			2 else RLSIZE)]	\INTSIZE CAN BE DIFFERENT FOR CROSS COMPILERS
	until ATOM#^,;
	if ATOM#^) then ERROR(44) else RATOM;
	end;
case of
  SID>=INPROC & SID<=RLFPROC:		\NORMAL PROCEDURE CALL
	begin
	if ARGCNT >=$20 then
		[GEN(\ARG\$0A, 0, ARGCNT, 2);
		GEN(\CAL\$05, (SLEV+2)<<4, SVAL, 15)]
	else	GEN(\CAL\$05, (SLEV+2)<<4 ! ARGCNT, SVAL, 15);
	end;
  SID=ININT ! SID=RLINT:		\INTRINSIC PROCEDURE CALL
	GEN(\CML\$0C,0,SVAL,2);
  SID=INOPT ! SID=RLOPT:		\OPTIMIZED PROCEDURE CALL
	[if ARGCNT>0 then \NO ARGS DECLARED\ ERROR(51);
	GEN(\JSR\$26,0,SVAL,7)]
other	GEN(\ECL\$29,0,SVAL,3);  	\EXTERNAL PROCEDURE CALL
end;	\PROCAL

\----------------------------------------------------------------------

proc	BOOLEXP;	\BOOLEAN EXPRESSION
\OUTPUTS FACTOR TYPE (FACTYP)
int	P1,P2,SFACTYP;



proc	FACTOR;



func	STRCON;		\STRING CONSTANT FUNCTION
int	SPC,SCHAR;
begin
SPC:=PC;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(PC);
while CHAR#^" do
	begin
	case CHAR of
	  ^^:	[CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR)]; \(BETTER NOT BE AN EOF)
	  EOF:	[ERROR(63); exit]
	other	[];
	HEXB(CHAR); PC:=PC+1;
	SCHAR:=CHAR;
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	end;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(PC-1);
HEXB(SCHAR!$80);
GETCH;
FACTYP:=INTEGER;
return SPC;		\RETURN STARTING ADDRESS OF STRING
end;	\STRCON



func	STR2CON;	\COMPACTED STRING CONSTANT
int	SPC;
int	CH, MODE, NEWMODE, CNT, WD, LASTCHAR, REPCNT;


	proc	OUTPUT(C);
	int	C;
	begin
	WD:= WD + C *CNT;
	CNT:=CNT *40;
	if CNT=\64000\$FA00 ! C=39 then
		[HEXB(WD); HEXB(SWAP(WD));
		PC:=PC+2;
		WD:=0; CNT:=1];
	end;	\OUTPUT



	proc	DOREPEATS;	\CODE:   30 31 32 33 34 35 36 37 38 39
	int	C;		\REPEATS: 2  3  4  5  6  7  8  9 10 TERM
	begin
	while REPCNT>=2 do
		[OUTPUT(38);		\MODE 2
		C:=REPCNT;
		if C >10 then C:= 10;	\MAXIMUM IS 10
		REPCNT:= REPCNT -C;
		OUTPUT(C+28)];
	if REPCNT=1 then	\SIMPLY OUTPUT LAST CHARACTER AGAIN
		[if NEWMODE=2 then OUTPUT(38);	\MODE 2 IS FOR ONE CHAR ONLY
		OUTPUT(CH);
		REPCNT:=0];
	end;	\DOREPEATS


begin	\STR2CON
SPC:=PC; WD:=0; CNT:=1; MODE:=0; LASTCHAR:=-1; REPCNT:=0;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(PC);
while CHAR#^' do
	begin
	if CHAR=^^ then [CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR)];

	if CHAR=LASTCHAR then
		REPCNT:=REPCNT+1	\COUNT TIMES LAST CHAR IS REPEATED
	else	begin
		DOREPEATS;
		case of		\CONVERT CHAR TO RADIX-40 CODE
		  CHAR=EOF: [ERROR(63); exit];
		  CHAR=^ :  [CH:=36;		NEWMODE:=MODE];
		  CHAR<=CR: [CH:=CHAR-BEL;	NEWMODE:=2];
		  CHAR<=^%: [CH:=CHAR-^!+7;	NEWMODE:=2];
		  CHAR<=^/: [CH:=CHAR-^&;	NEWMODE:=1];
		  CHAR<=^9: [CH:=CHAR-^0;	NEWMODE:=0];
		  CHAR<=^@: [CH:=CHAR-^:+12;	NEWMODE:=2];
		  CHAR<=^Z: [CH:=CHAR-^A+10;	NEWMODE:=0];
		  CHAR<=^`: [CH:=CHAR-^[+19;	NEWMODE:=2];
		  CHAR<=^z: [CH:=CHAR-^a+10;	NEWMODE:=1];
		  CHAR<=^~: [CH:=CHAR-^{+25;	NEWMODE:=2]
		other \ILLEGAL CHARACTER IN A COMPRESSED STRING\ ERROR(64);

		if NEWMODE=2 then OUTPUT(38)	\MODE 2 IS FOR ONE CHAR ONLY
		else if NEWMODE # MODE then [OUTPUT(37); MODE:=NEWMODE];
		OUTPUT(CH);
		end;
	LASTCHAR:= CHAR;
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	end;
DOREPEATS;
OUTPUT(39);		\TERMINATOR
GETCH;
FACTYP:=INTEGER;
return SPC;		\RETURN STARTING ADDRESS OF STRING
end;	\STR2CON



func	ARRAYCON;	\CONSTANT ARRAYS
int	THISEL, NEXTEL, PNTR, SPC, I, INDIRECT, SFACTYP, FIRST;
def	NULL= -1;
addr	ENTRY, R;
begin
PNTR:=RESERVE(3*INTSIZE);
THISEL:=PNTR;
THISEL(0):=NULL;

FIRST:= true;
repeat	RATOM;
	INDIRECT:=true;
	case ATOM of
	  ^[:	ENTRY:=ARRAYCON;
	  ^":	ENTRY:=STRCON;
	  ^':	ENTRY:=STR2CON
	other	begin
		INDIRECT:=false;
		GETCON;
		if FACTYP=INTEGER then ENTRY:=IATOM
		else	[ENTRY:=RESERVE(RLSIZE);  \FACTYP=REAL
			R:=addr RLATOM;
			for I:=0,RLSIZE-1 do ENTRY(I):=R(I)];
		end;
	NEXTEL:=RESERVE(3*INTSIZE);
	THISEL(1):=ENTRY;
	THISEL(2):=INDIRECT;
	THISEL(0):=NEXTEL;
	NEXTEL(0):=NULL;
	THISEL:=NEXTEL;
	RATOM;

	if FACTYP#SFACTYP & ~FIRST then ERROR(46);	\MIXED MODE
	SFACTYP:= FACTYP;
	FIRST:= false;
until ATOM # ^,;

if ATOM # ^] then ERROR(50);
SPC:=PC;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(PC);
while PNTR(0)#NULL do		\DUMP LIST
	begin
	ENTRY:=PNTR(1);
	if FACTYP=INTEGER then
		begin
		if PNTR(2) \INDIRECT\ then
			[CHOUT(BINDEV,^*); HEXOUT(ENTRY)]
		else	[HEXB(ENTRY); HEXB(SWAP(ENTRY))];
		PC:=PC+2;
		end
	else	begin	\(FACTYP=REAL)
		if PNTR(2) \INDIRECT\ then
			[CHOUT(BINDEV,^*); HEXOUT(ENTRY);
			for I:=1,RLSIZE-2 do HEXB(0)]
		else for I:=0,RLSIZE-1 do HEXB(ENTRY(I));
		PC:=PC+RLSIZE;
		end;
	PNTR:=PNTR(0);
	end;
return SPC;	\RETURN STARTING ADDRESS OF ARRAY
end;	\ARRAYCON



proc	SPECFAC;	\SPECIAL CHARACTER FACTOR
int	SVAL,SPC,R;
begin
case ATOM of
  ^(:	[RATOM;					\PARENTHESIZED EXPRESSION
	BOOLEXP;	\(FACTOR TYPE IS UNCHANGED)
	if ATOM#^) then ERROR(44)];
  ^":	[LASTOP:=-1; SPC:=PC;			\STRING CONSTANT
	GEN(\JSR\$26,0,0,7);	\JSR = JMP + IMM
	SVAL:=STRCON;
	FIX(SPC)];
  ^':	[LASTOP:=-1; SPC:=PC;			\STRING CONSTANT
	GEN(\JSR\$26,0,0,7);	\JSR = JMP + IMM
	SVAL:=STR2CON;
	FIX(SPC)];
  ^[:	[LASTOP:=-1; SPC:=PC;			\CONSTANT ARRAY
	GENJMP(0);		\(JSR WON'T WORK FOR REALS AND MULTIDIMENSIONS)
	SVAL:=ARRAYCON;
	FIX(SPC);
	if FACTYP=INTEGER then GEN(\IMM\$0B,0,SVAL,7)
	else	\FACTYP=REAL
		[R:=addr RLATOM;	\CONVERT AN INTEGER
		R(0):=SVAL;		\ POINTER INTO A REAL
		GEN(\FIMM\$2C,0,SVAL,36)]];\ POINTER IN RLATOM
 ADRSYM:begin					\GET ABSOLUTE HEAP ADDRESS
	RATOM;
	if ATYPE#IDENTIFIER then ERROR(45);
	LOOKUP;
	case IDTYPE of
	  INVAR, ADDRVAR, RLVAR:
		GEN(\ADR\$21,LEV,VAL,10);
	  UNDEF:ERROR(10)	\(UNDECLARED NAME)
	other ERROR(43);	\(VARIABLE EXPECTED)
	FACTYP:=INTEGER;
	end
other \ILLEGAL FACTOR\ ERROR(26);
RATOM;
end;	\SPECFAC



proc	IDFAC;		\IDENTIFIER FACTOR
int	SLEV,SVAL,SID;
begin	\IDFAC
LOOKUP;
SID:=IDTYPE;
case IDTYPE of
UNDEF:	ERROR(10);
INVAR, RLVAR:		\VARIABLE
	begin
	if SID=INVAR then
		GENLOD(LEV,VAL)
	else	GEN(\FLOD\$2A,LEV,VAL,10);
	RATOM;
	if ATOM=^( then				\IT IS INDEXED
		begin
		repeat	[RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47);
			GEN(if SID=INVAR then \DBX\$20 else \TRI\$3A,0,0,0)]
		until ATOM#^, ;
		if ATOM#^) then ERROR(44) else RATOM;
		end;
	end;
ADDRVAR: begin		\ADDRESS VARIABLE
	RATOM;
	if ATOM#^( then GENLOD(LEV,VAL)
	else	begin		\ARRAY ELEMENT REFERENCE
		SLEV:=LEV; SVAL:=VAL;
		RATOM;
		BOOLEXP; 	\INDEX
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#^) then ERROR(44) else RATOM;
		GENLDX(SLEV,SVAL);
		end;
	end;
INCON:	begin		\INTEGER CONSTANT IDENTIFIER
	GENIMM(VAL);
	RATOM;
	end;
RLCON:	begin		\REAL CONSTANT IDENTIFIER
	RLATOM:=RLTBL(VAL); GEN(\FIMM\$2C,0,0,16);
	RATOM;
	end
other	begin		\PROCEDURES USED AS FUNCTIONS (BY DEFAULT)
	PROCAL;
	if SID<ININT then
		if SID&1 then GENLOD(0,1)	\GET VALUE RETURNED IN GLOBAL 0
		else GEN(\FLOD\$2A,0,0,10);
	end;
FACTYP:=if SID & 1 then INTEGER else REAL; \ODD IDS ARE INTEGER
end;	\IDFAC



begin	\FACTOR
while ATOM=^+ do RATOM;			\IGNORE UNARY "+"
if ATOM=^- then				\UNARY "-"
	[RATOM;
	FACTOR;
	GEN(if FACTYP=INTEGER then \NEG\$11 else \FNEG\$31,0,0,0)]
else	case ATYPE of
	SPECIAL:SPECFAC;
	INTCON:	[FACTYP:=INTEGER;	\INTEGER CONSTANT
		GENIMM(IATOM);
		RATOM];
	REALCON:[FACTYP:=REAL;		\REAL CONSTANT
		GEN(\FIMM\$2C,0,0,16);
		RATOM]
	other	IDFAC;	\ATYPE = IDENTIFIER (BY DEFAULT)
end;	\FACTOR



proc	SHIFTEXP;

	proc SHIFTX; int INOP;
	[if FACTYP # INTEGER then \INTEGER EXPTECTED\ ERROR(47);
	RATOM; FACTOR;
	if FACTYP # INTEGER then ERROR(47);
	GEN(INOP, 0, 0, 0)];

begin	\SHIFTEXP
FACTOR;
case ATOM of
  LSLSYM: SHIFTX(\LSL\$3E);		\ <<
  LSRSYM: SHIFTX(\LSR\$3F)		\ >>
other;
end;	\SHIFTEXP



proc	TERM;
int	SFACTYP;

	proc TERMX; int INOP,RLOP;
	[RATOM; SHIFTEXP;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(if FACTYP=INTEGER then INOP else RLOP,0,0,0)];

begin	\TERM
SHIFTEXP;
SFACTYP:=FACTYP;
loop	case ATOM of
	  ^*:	TERMX(\MUL\$0F,\FMUL\$2F);
	  ^/:	TERMX(\DIV\$10,\FDIV\$30)
	other	quit;
end;	\TERM



proc	ALGEXP;		\ALGEBRAIC EXPRESSION
int	SFACTYP;

	proc ALGX; int INOP,RLOP;
	[RATOM; TERM;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(if FACTYP=INTEGER then INOP else RLOP,0,0,0)];

begin	\ALGEXP
TERM;
SFACTYP:=FACTYP;
loop	case ATOM of
	  ^+:	ALGX(\ADD\$0D,\FADD\$2D);
	  ^-:	ALGX(\SUB\$0E,\FSUB\$2E)
	other	quit;
end;	\ALGEXP



proc	LOGEXP;		\LOGICAL EXPRESSION
int	SFACTYP;

	proc	LOGX; int INOP,RLOP;
	[RATOM; ALGEXP;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(if FACTYP=INTEGER then INOP else RLOP,0,0,0);
	FACTYP:=INTEGER];

begin	\LOGEXP
if ATOM=NOTSYM ! ATOM=^~ then		\UNARY 'NOT' OPERATOR
	[RATOM; LOGEXP;
	if FACTYP#INTEGER then ERROR(47);
	GEN(\NOT\$1C,0,0,0)]
else	[ALGEXP;
	SFACTYP:=FACTYP;
	case ATOM of
	  ^=:	LOGX(\EQ\$12,\FEQ\$32);
	  ^#:	LOGX(\NE\$13,\FNE\$33);
	  ^>:	LOGX(\GT\$15,\FGT\$35);
	  ^<:	LOGX(\LT\$17,\FLT\$37);
	  GESYM:LOGX(\GE\$14,\FGE\$34);
	  LESYM:LOGX(\LE\$16,\FLE\$36)
	other];
end;	\LOGEXP



proc	BOOLTERM;	\BOOLEAN "&" EXPRESSIONS
begin
LOGEXP;
loop	[if ATOM=^& then [RATOM; LOGEXP; GEN(\AND\$1B,0,0,0)]
		else quit;
	if FACTYP#INTEGER then ERROR(47)];
end;



proc BEXPX; int INOP;
begin
if FACTYP # INTEGER then \INTEGER EXPTECTED\ ERROR(47);
RATOM; BOOLTERM;
if FACTYP # INTEGER then ERROR(47);
GEN(INOP, 0, 0, 0);
end;	\BEXPX



begin	\BOOLEXP
if ATOM=IFSYM then			\'IF' EXPRESSION
	[RATOM; BOOLEXP;
	LASTOP:=-1; P1:=PC;
	GEN(\JPC\$08,0,0,7);
	if ATOM#THENYM then ERROR(22);
	RATOM; BOOLEXP; SFACTYP:=FACTYP;
	if ATOM#ELSEYM then ERROR(30);
	LASTOP:=-1; P2:=PC;
	GENJMP(0); FIX(P1);
	RATOM; BOOLEXP;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	FIX(P2)]
else	begin			\BOOLEAN "!" (OR) AND "|" (XOR) EXPRESSIONS
	BOOLTERM;
	loop	case ATOM of
		  ^!:	BEXPX(\OR\$1A);
		  ^|:	BEXPX(\EOR\$1D)
		other quit;
	end;
end;	\BOOLEXP

\----------------------------------------------------------------------

proc	SSTATEMENT; int SSTK;	\(FOR 'QUIT'S IN 'CASE' STMNTS)



proc	STATEMENT;
int	P2,P3,SFIXS,SLEV,SVAL,SFACTYP,I,KILL;



proc	ASSIGN;		\ASSIGNMENT STATEMENT
\ (ALSO INCLUDES PROCEDURE CALLS)

	proc	ASSX;
	[if ATOM#GETSYM then ERROR(21);
	RATOM;
	BOOLEXP];	\RIGHT-HAND SIDE OF ASSIGNMENT

begin	\ASSIGN
if ATYPE#IDENTIFIER then
	\BAD START OF A STATEMENT\ [ERROR(20); SKIPIT; return];
LOOKUP; if IDTYPE=UNDEF then [ERROR(10); SKIPIT; return];
SLEV:=LEV; SVAL:=VAL;	\SAVE THESE FOR "GEN." AN INTERIM
			\ BOOLEXP MAY CHANGE LEV & VAL
if IDTYPE>=INPROC & IDTYPE<=RLEXT then PROCAL
else if IDTYPE=INVAR ! IDTYPE=RLVAR then
	begin
	SFACTYP:=if IDTYPE=INVAR then INTEGER else REAL;
	RATOM;
	if ATOM=^( then			\INDEXED
		begin
		GENLOD(SLEV,SVAL);
		RATOM;
		BOOLEXP;		\1ST INDEX
		if FACTYP#INTEGER then ERROR(47);
		while ATOM=^, do	\MULTIPLE INDEXING
			[GEN(if SFACTYP=INTEGER then \DBX\$20
				else \TRX\$39,0,0,0);
			RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47)];
		GEN(if SFACTYP=INTEGER then \DBA\$1E
			else \TRA\$38,0,0,0);
		if ATOM#^) then ERROR(44) else RATOM;
		ASSX;	\TOS NOW POINTS TO ARRAY ELEMENT
		GEN(if SFACTYP=INTEGER then \STD\$1F else \STT\$3B,0,0,0);
		end
	else	begin
		ASSX;
		if SFACTYP=INTEGER then
			GENSTO(SLEV,SVAL)
		else	GEN(\FSTO\$2B,SLEV,SVAL,10);
		end;

	if FACTYP#SFACTYP then \MIXED MODE\ ERROR(46);
	end
else if IDTYPE=ADDRVAR then		\ADDRESS VARIABLE
	begin
	RATOM;
	if ATOM=^( then				\INDEXED
		[RATOM;
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#^) then ERROR(44) else RATOM;
		ASSX;
		GENSTX(SLEV,SVAL)]
	else	[ASSX; GENSTO(SLEV,SVAL)];
	if FACTYP#INTEGER then \MIXED MODE\ ERROR(46);
	end
else \STATEMENT STARTING WITH A CONSTANT\ [ERROR(27); SKIPIT];
end;	\ASSIGN



proc	CASER; int TYPE;
int	SPC1,SPC2,SPC3;



proc	CASER2;
begin
RATOM;
BOOLEXP;
if FACTYP#INTEGER then ERROR(47);
LASTOP:=-1; SPC1:=PC;
GEN(TYPE,0,0,7);
if ATOM=^, then				\MULTIPLE LABELS
	[LASTOP:=-1; SPC3:=PC;
	repeat	RATOM;			\FOR MORE THAN 2 LABELS
		if SPC3=PC then GEN(\JMP\$07,0,SPC3,7)	\2 JUMPS TO STATEMENT
		else GENJMP(SPC3);
		FIX(SPC1);
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		LASTOP:=-1; SPC1:=PC;
		GEN(TYPE,0,0,7);
	until ATOM#^,;
	FIX(SPC3)];
if ATOM#^: then [ERROR(49); SKIPIT; return];
RATOM;
STATEMENT;
end;	\CASER2



begin	\CASER
CASER2;
LASTOP:=-1; SPC2:=PC;
GENJMP(0);		\JUMP OUT OF CASE STATEMENT
FIX(SPC1);
while ATOM=^; do
	[CASER2;
	GENJMP(SPC2);		\2 JUMP EXIT (BACK THEN OUT)
	FIX(SPC1)];
if ATOM#OTHSYM then ERROR(29);
RATOM;
STATEMENT;
FIX(SPC2);
end;	\CASER



begin	\STATEMENT
case ATOM of
BEGSYM,^[:
	begin
	RATOM;
	loop	begin
		if ATOM=ELSEYM then [ERROR(52); RATOM];
		if ATOM=OTHSYM then [ERROR(53); RATOM];
		STATEMENT;
		case ATOM of
		  ^;:	RATOM;
		  ENDSYM:quit;
		  ^]:	quit;
		  EOF:	[ERROR(62); exit]
		other	\SEMI EXPECTED\ ERROR(41);
		end;
	RATOM;		\READ PAST THE 'END'
	end;
CASEYM:	begin				\CASE STATEMENT
	RATOM;
	if ATOM=OFSYM then CASER(\JPC\$08)
	else	begin
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#OFSYM then [ERROR(48); SKIPIT; return];
		STKLOD:=STKLOD+1;
		CASER(\CJP\$25);
		GEN(\DRP\$28,0,0,0);
		STKLOD:=STKLOD-1;
		end;
	end;
QUITYM:	begin				\QUIT STATEMENT
	for I:=SSTK,STKLOD-1 do GEN(\DRP\$28,0,0,0);
	if FIXCNT >= QUITMAX then [ERROR(4); FIXCNT:=QUITMAX-1];
	LASTOP:=-1; FIXES(FIXCNT):=PC; FIXCNT:=FIXCNT+1;
	GENJMP(0);	\(WILL BE "FIXED" AT END OF 'LOOP')
	RATOM;
	end;
IFSYM:	begin				\IF STATEMENT
	RATOM;
	BOOLEXP;
	KILL:=OPTIMIZE & LASTOP=\SSIM0\$41;
	SFIXS:=FIXCNT;
	LASTOP:=-1; P3:=PC;
	GEN(\JPC\$08,0,0,7);
	if ATOM#THENYM then [ERROR(22); SKIPIT; return];
	RATOM;
	STATEMENT;
	if ATOM=ELSEYM then
		[KILL:=false;
		LASTOP:=-1; P2:=PC;
		GENJMP(0);
		FIX(P3);
		P3:=P2;
		RATOM;
		STATEMENT];
	FIX(P3);
	if KILL & SFIXS=FIXCNT then PC:=P3-1;	\ALSO ELIMINATE SSIM0
	end;
REPSYM:	begin				\REPEAT STATEMENT
	LASTOP:=-1; P2:=PC;
	repeat RATOM; STATEMENT until ATOM#^;;
	if ATOM#UNTSYM then [ERROR(28); SKIPIT; return];
	RATOM;
	BOOLEXP;
	GEN(\JPC\$08,0,P2,7);
	end;
WHILYM:	begin				\WHILE STATEMENT
	RATOM;
	LASTOP:=-1; P2:=PC;
	BOOLEXP;
	KILL:= OPTIMIZE & LASTOP=\SSIM0\$41;
	SFIXS:=FIXCNT;
	LASTOP:=-1; P3:=PC;
	GEN(\JPC\$08,0,0,7);
	if ATOM#DOSYM then [ERROR(23); SKIPIT; return];
	RATOM;
	STATEMENT;
	GENJMP(P2);
	FIX(P3);
	if KILL & SFIXS=FIXCNT then PC:= P2;
	end;
RETSYM:	begin				\RETURN STATEMENT
	RATOM;
	for I:=0,STKLOD-1 do GEN(\DRP\$28,0,0,0);
	if ATOM#ELSEYM & ATOM#OTHSYM & ATOM#^; & ATOM#^] &
	    ATOM#ENDSYM & ATOM#UNTSYM then	\STORE THE RETURNED
		[BOOLEXP;			\ VALUE IN GLOBAL #0
		if FACTYP=INTEGER then GENSTO(0,1)
		else GEN(\FSTO\$2B,0,0,10)];
	GEN(if OPTPROC then \RTS\$27 else \RET\$06,0,0,0);
	end;
LOOPYM:	begin				\LOOP STATEMENT
	SFIXS:=FIXCNT;
	RATOM;
	LASTOP:=-1; P2:=PC;
	SSTATEMENT(STKLOD);
	GENJMP(P2);
	while FIXCNT>SFIXS do	\FIX THE JUMPS FOR THE 'QUIT'S
		[FIXCNT:=FIXCNT-1; FIX(FIXES(FIXCNT))];
	end;
FORSYM:	begin				\FOR STATEMENT
	RATOM;
	if ATYPE#IDENTIFIER then [ERROR(33); SKIPIT; return];
	LOOKUP;
	if IDTYPE=UNDEF then ERROR(10)
	else if IDTYPE#INVAR & IDTYPE#ADDRVAR then ERROR(33);
	SLEV:=LEV; SVAL:=VAL;
	RATOM;
	if ATOM#GETSYM then [ERROR(21); SKIPIT; return];
	RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	GENSTO(SLEV,SVAL);
	if ATOM#^, then [ERROR(24); SKIPIT; return];
	RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	if ATOM#DOSYM then [ERROR(23); SKIPIT; return];
	GENLOD(SLEV,SVAL);
	LASTOP:=-1; P2:=PC;
	GEN(\FOR\$18,0,0,7);
	RATOM;
	STKLOD:=STKLOD+1;
	STATEMENT;
	STKLOD:=STKLOD-1;
	GEN(\INC\$19,SLEV,SVAL,10);	\5-BYTE INSTRUCTION (INC +JMP)
	CHOUT(BINDEV,^*); HEXOUT(P2); PC:=PC+2; OLDPC:=PC; \LASTOP=INC
	FIX(P2);
	end;
EXITYM:	[RATOM; GEN(\EXT\$00,0,0,0)];	\EXIT STATEMENT
ELSEYM:	[];				\NULL STATEMENT
OTHSYM:	[];
^;:	[];
^]:	[];
ENDSYM:	[];
UNTSYM:	[];
EOF:	[]		\(THIS IS MOSTLY AN ACADEMIC POINT)
other	ASSIGN;
end;	\STATEMENT



begin	\SSTATEMENT
\TRICK TO ADJUST STACK (WITH DRP'S) WHEN A 'QUIT' IS IN
\ A 'CASE' STATEMENT.
STATEMENT;
end;	\SSTATEMENT

\----------------------------------------------------------------------

proc	PROCEDURE; int SSNOX;	\"SSNO" FROM "PROCDEC" FOR OPTIMIZED PROCEDURES
int	SLEVEL,		\SAVE LEVEL (COMPLICATED BY OPTIMIZED PROCEDURES)
	P1,DX,		\HEAP SPACE REQUIREMENT COUNTER
	FPBASE,		\PC AT END OF DECLARATIONS
	FPROCNT;	\COUNT OF PENDING FORWARD PROCEDURES



proc	CODDEC;		\DECLARE INTRINSIC NAMES
int	SID;
begin
SID:=ININT;		\DEFAULT IS INTEGER INTRINSIC
RATOM;
if ATOM=REALYM then [SID:=RLINT; RATOM]
	else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON; if FACTYP#INTEGER then ERROR(47);
	if IATOM<0 ! IATOM>127 then ERROR(7);
	INSERT(SID,LEVEL,IATOM);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\CODDEC



proc	CONDEC;		\DECLARE CONSTANT NAMES
int	CNTR,SSNO;
begin
RATOM;
CNTR:=0;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	begin
	RATOM;
	if ATOM#^= then [INSERT(INCON,LEVEL,CNTR); CNTR:=CNTR+1]
	else	begin
		SSNO:=NOSYM;
		INSERT(INCON,LEVEL,NORLSY);	\INSERT ID NOW
		RATOM;			\ FIX UP PARMS LATER
		GETCON;
		if FACTYP=INTEGER then SYMVAL(SSNO):=IATOM
		else		\FACTYP=REAL
			[SYMTYP(SSNO):=RLCON;
			if NORLSY>=RLMAX then
				[ERROR(2); NORLSY:=RLMAX-1];
			RLTBL(NORLSY):=RLATOM;
			NORLSY:=NORLSY+1];
		RATOM;
		end;
	if ATOM#^, then [if ATOM#^; then ERROR(24)]
	else RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\CONDEC



proc	VARDEC; int TYPE;  \DECLARE VARIABLES--INT, REAL & ADDR
begin
RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[INSERT(TYPE,LEVEL,DX);
	DX:=DX +(if TYPE=RLVAR then RLSIZE else 2);  \2#INTSIZE FOR CROSS COMPILERS
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\VARDEC



proc	EXTDEC;		\DECLARE EXTERNAL PROCEDURES
int	SID;
begin
SID:=INEXT;		\DEFAULT IS INTEGER EXTERNAL PROCEDURE
RATOM;
if ATOM=REALYM then [SID:=RLEXT; RATOM]
else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON; if FACTYP#INTEGER then ERROR(47);
	INSERT(SID,LEVEL,IATOM);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\EXTDEC



proc	FPRDEC; int OPTYPE;	\DECLARE FORWARD REFERENCED PROCEDURES
int	SID;
begin
SID:=INFPROC;		\DEFAULT IS INTEGER FORWARD PROCEDURE
RATOM;
if ATOM=REALYM then [SID:=RLFPROC; RATOM]
else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	INSERT(SID,LEVEL,PC);
	LASTOP:=-1;
	GEN(\JMP\$07,0,PC,OPTYPE);
	FPROCNT:=FPROCNT+1;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\FPRDEC



proc	PROCDEC; int CANOPT;		\DECLARE PROCEDURE NAMES
int	SNOSYM,HASH,I,K,SID,SSNO,SNORL;
begin
SID:=INPROC;			\TYPED PROCEDURE (FOR FUNCTIONS)
RATOM;
if ATOM=REALYM then [SID:=RLPROC; RATOM]
else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45) else LOOKUP;
if IDTYPE=INFPROC ! IDTYPE=RLFPROC then
	\PROCEDURE HAS BEEN PREVIOUSLY DECLARED BY A 'FPROC' OR 'FFUNCT'
	[if LEVEL#LEV then ERROR(65);
	FIX(VAL);	\('FPROC' & 'PROC' MUST BE SAME SCOPE)
	SYMVAL(SYMNUM):=PC;
	SYMTYP(SYMNUM):=if IDTYPE=INFPROC then INPROC
		else RLPROC;
	if SID#SYMTYP(SYMNUM) then \MIXED MODE\ ERROR(46);
	if VAL>=FPBASE then FPROCNT:=FPROCNT-1;
	OPTPROC:=false]
else [SSNO:=NOSYM; INSERT(SID,LEVEL,PC); OPTPROC:=CANOPT];

\ASSUME FOR NOW THAT PROCEDURE IS NOT OPTIMIZED AND MOVE DOWN A LEVEL
SLEVEL:=LEVEL;
LEVEL:=LEVEL+2; if LEVEL>14 then ERROR(5);
					\EAT THE ARGUMENT LIST AS A COMMENT
while CHAR#^; & CHAR#\CR\$0D do GETCH;	\SPECIAL COMMENT STOPS ON CR
if CHAR#^; then ERROR(41);
GETCH; RATOM;

SNOSYM:=NOSYM; SNORL:=NORLSY;
PROCEDURE(SSNO);	\PASS LOCATION OF PROC NAME IN CASE IT IS OPTIMIZED
if ATOM#^; then ERROR(41) else RATOM;
while NOSYM>SNOSYM do	\RESTORE SYMBOL TABLE TO PREVIOUS LEVEL
\I.E. REMOVE THE IDENTIFIERS WHICH WERE LOCAL TO THIS PROCEDURE
	[NOSYM:=NOSYM-1;
	HASH:=0; K:=NOSYM;
	for I:=0,SIGCHAR-1 do
		[HASH:=HASH+SYMBOL(K); K:=K+SYMAX];
	BOX(HASH &$FF):=SYMPNT(NOSYM)];
NORLSY:=SNORL;
LEVEL:=SLEVEL;
end;	\PROCDEC



begin	\PROCEDURE
DX:=if LEVEL=0 then RLSIZE else 0; \SAVE HEAP SPACE FOR GLOBAL 0
LASTOP:=-1; P1:=PC;
GENJMP(0);
loop	case ATOM of
	INTSYM:	VARDEC(INVAR);
	ADRSYM, CHARYM:	VARDEC(ADDRVAR);
	REALYM:	VARDEC(RLVAR);
	CODSYM:	CODDEC;
	EXTNYM:	EXTDEC;
	DEFSYM:	CONDEC;
	EPRSYM, EFUNYM:	if LEVEL=0 then FPRDEC(64)
			else [ERROR(68); SKIPIT]
	other	quit;
FPROCNT:=0;
FPBASE:=PC;
loop	case ATOM of
	LNKSYM: [if LEVEL#0 then ERROR(68);
		CHOUT(BINDEV,^%);
		RATOM;
		case ATOM of PROCYM,FUNSYM:PROCDEC(false)
		other ERROR(67)];
	PROCYM,FUNSYM:	PROCDEC(true);
	FPRSYM,FFUNYM:	FPRDEC(7)		\'FPROC' CANNOT PRECEDE A 'DEF'
	other	quit;
\IF THERE IS NOTHING TO JUMP OVER THEN ELIMINATE THE JUMP
if PC=P1+3 then [LASTOP:=-1; PC:=P1] else FIX(P1);
			\RESERVE SPACE FOR LOCAL VARIABLES
if DX>0 then		\THIS PROCEDURE HAS LOCAL VARIABLES
	[GEN(\HPI\$09,0,DX,2); OPTPROC:=false;
	if DX>=$100 then \TOO MANY VARIABLES\ ERROR(1)]; \ONE-BYTE OF OFFSET
if OPTPROC then
	[SYMTYP(SSNOX):= if SYMTYP(SSNOX)=INPROC then INOPT else RLOPT;
	LEVEL:= LEVEL -2];	\SAME LEVEL AS NESTING PROCEDURE (TRICKY!)

SSTATEMENT(STKLOD);	\(STKLOD WILL ALWAYS BE ZERO HERE)

GEN(if OPTPROC then \RTS\$27 else \RET\$06,0,0,0);

if FIXCNT#0 then \SOME 'QUIT'S NOT IN A 'LOOP'\ ERROR(60);
if FPROCNT#0 then \UNRESOLVED FWD REFERENCES\ ERROR(66);
end;	\PROCEDURE

\----------------------------------------------------------------------

\%%% ROUTINES TO OPEN IBM FILES %%%

procedure IBMOPEN;
integer PSEG,CSEG,SWT;
addres TAIL,TLEN;

	procedure MAKUP(C);	\CONVERT C TO UPPERCASE
	int C;
	return if C>=^a & C<=^z then C-$20 else C;


	procedure GETSWT;	\FIND, REMOVE AND RETURN SWITCH
	integer P,T;
	begin
	for P:=0,TLEN(0) do if TAIL(P)=^/ then
		begin
		TAIL(P):=$20;
		if P<TLEN(0) then
			begin
			T:=TAIL(P+1);
			TAIL(P+1):=$20;
			return MAKUP(T);
			end;
		end;
	return 0;
	end;	\GETSWT



	procedure PARSE;
	\PARSE COMMAND TAIL AND SET I/O HANDLES
	address EXT1,EXT2;
	integer P,EFLG,I;
	begin
	EXT1:=".XPL";EXT2:=".I2L";

	P:=0;
	EFLG:=false;
	\PARSE COMMAND TAIL FOR EXTENTION

	loop
		begin
		if TAIL(P)=^. then
			begin
			EFLG:=true;
			quit;
			end;
		P:=P+1;
		if P>=TLEN(0) then
			begin
			EFLG:=false;
			quit;
			end;
		end;

	\SET EXTENTION AND INPUT HANDLE
	if not EFLG then
		for I:=0,3 do TAIL(P+I):=EXT1(I);
	INHAND:=FOPEN(TAIL,0);

	\SET EXTENTION AND OUTPUT HANDLE
	for I:=0,3 do TAIL(P+I):=EXT2(I);
	OUTHAND:=FOPEN(TAIL,1);
	end;



begin	\OF IBMOPEN

\GET COMMAND TAIL FROM PSP
TLEN:=RESERVE(80);
TAIL:=TLEN+1;
SYSINF:=GETREG;
PSEG:=SYSINF(11);
CSEG:=SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);
if TLEN(0)>79 then TLEN(0):=79;

\LIST TO SCREEN IF /L SWITCH
SWT:=GETSWT;
if SWT=^L then OPTION(1):=0;

\DISABLE OPTIMIZE IF /O SWITCH
if SWT=^O then OPTION(3):=false;

\PARSE COMMAND LINE AND SET HANDLES
PARSE;

\%OPEN FILES
FSET(INHAND,^I);
FSET(OUTHAND,^O);
end;

\----------------------------------------------------------------------

begin	\MAIN--DISPLAY TITLE AND INITIALIZE
IDENT:=RESERVE(SIGCHAR);
FIXES:=RESERVE(QUITMAX*INTSIZE);
SYMBOL:=RESERVE(SIGCHAR*SYMAX);	\SYMBOL TABLE
SYMTYP:=RESERVE(SYMAX);
SYMVAL:=RESERVE(SYMAX*INTSIZE);
SYMLEV:=RESERVE(SYMAX);
SYMPNT:=RESERVE(SYMAX*INTSIZE);
BOX:=RESERVE(256*INTSIZE);	\HASH TABLE
RLTBL:=RLRES(RLMAX);
HEXDIGIT:="0123456789ABCDEF ";	\(BEWARE OF SET MSB)

OLDHAND:=RESERVE(HANMAX*2);
HANPTR:=0;

IBMOPEN;				\%

OPTION:=[3,8,3,true];	\DEFAULT OPTIONS: BINARY, LIST, SOURCE DEVICES, OPTIMIZE
TEXT(TV,"
-- XPL0 COMPILER, VER 6.2-PCx6502 --
");
\CHANGE DEFAULTS (N/Y)? ");
\if (CHIN(KB) !$20) =^y then
\	[TEXT(TV,"DEVICE NUMBERS (BINARY, LIST, SOURCE)?
\");
\	OPTION(0):=INTIN(KB); OPTION(1):=INTIN(KB);
\	OPTION(2):=INTIN(KB);
\	TEXT(TV,"OPTIMIZE (N/Y)? ");
\	OPENI(KB);
\	OPTION(3):= (CHIN(KB) !$20) = ^y];

BINDEV:=OPTION(0); LSTDEV:=OPTION(1); SRCDEV:=OPTION(2);
OPTIMIZE:= OPTION(3);

OPENO(BINDEV); OPENO(LSTDEV); OPENI(SRCDEV);
if not OPTIMIZE then TEXT(TV,"non-optimized
");
PC:=0; LEVEL:=0;			\INITIALIZE SOME STUFF
OLDPC:=-1; STKLOD:=0; NOSYM:=0; NORLSY:=0; FIXCNT:=0;
for I:=0,255 do BOX(I):=\EMPTY\-1;	\ZERO THE SYMBOL TABLE
ERRCNT:=0;

GETCH; RATOM;
OPTPROC:=false;		\(FOR SEVERAL REASONS)
PROCEDURE(0);		\COMPILE MAIN PROCEDURE, I.E. THE PROGRAM
while ATOM=^; do RATOM;
if ATOM#EOF then \MORE CODE AFTER END\ [ERROR(61); PROCEDURE(0)];
CHOUT(BINDEV,^$);

TEXT(TV,"
PROGRAM LENGTH:  "); INTOUT(TV,PC+1); TEXT(TV,"
ERRORS DETECTED: "); INTOUT(TV,ERRCNT); CRLF(TV);
CLOSE(BINDEV); CLOSE(LSTDEV);
CLOSE(LSTDEV);
FCLOSE(OUTHAND);			\% CLOSE IBM FILES
FCLOSE(INHAND);
end;	\MAIN
