\XCOM.XPL
\XMODEM FILE TRANSFERE PROGRAM
\COPYRIGHT 1989 LARRY FISH

\IBM PC XPL CODE SET FOR XPL V5.6I

code
ABS=0, 		RAN=1, 		REM=2, 		RESERVE=3, 
SWAP=4, 	EXTEND=5, 	RESTART=6, 	CHIN=7, 
CHOUT=8, 	CRLF=9, 	INTIN=10, 	INTOUT=11, 
TEXT=12, 	OPENI=13, 	OPENO=14, 	CLOSE=15, 
ABORT=16, 	TRAP=17, 	FREE=18, 	RERUN=19, 
GETHP=20, 	SETHP=21, 	GETERR=22, 	CURSOR=23, 
FSET=24, 	SETRUN=25, 	HEXIN=26, 	HEXOUT=27, 
CHAIN=28, 	FOPEN=29, 	WRITE=30, 	READ=31, 
FCLOSE=32, 	CHKKEY=33, 	SOFTINT=34, 	GETREG=35, 
BLIT=36, 	PEEK=37, 	POKE=38, 	SOUND=39, 
CLEAR=40, 	POINT=41, 	LINE=42, 	MOVE=43, 
READPIX=44, 	SETVID=45	FIX=50, 	POUT=64, 
PIN=65, 	INTRET=66, 	EXTJMP=67, 	EXTCAL=68;

int	HAND, 		\FILE HANDLE
	BTABLE, 	\TABLE OF BAUD RATES
	BAUD;		\CURRENT BAUD RATER POINTER

int	CPUREG, 	\SYSTEM INFORMATION
	I, 		\GLOBAL TEMPORARY
	A1, A2, 	\ERROR ARGUMENTS
	ERRCOD, 	\ERROR CODE
	CHECK, 		\CURRENT CHECKSUM
	AFLAG, 		\FLAG TO ABORT OPERATION
	EOFLAG, 	\END OF FILE FLAG
	BLKCNT, 	\BLOCK COUNT
	BPTR;		\BLOCK PTR

addr	NFILE, 		\GLOBAL FILE NAME
	BUFFER;		\FILE BUFFER

define	FAIL=$FFFF, 	\HANDSHAKE FAILURE
	BUFSIZ=128;	\BUFFER SIZE

\ASCII CHARACTERS
define	FF=$0C, 	\FORM FEED
	BEL=7, 		\BELL
	CAN=$18, 	\CANCEL
	CR=$0D, 	\CARRIAGE RETURN
	LF=$0A, 	\LINE FEED
	BS=$08, 	\BACK SPACE
	ESC=$1B, 	\ESCAPE
	EOF=$1A, 	\END OF FILE
	SOH=$01, 	\START OF HEADER
	EOT=$04, 	\END OF TRANSMISSION
	ACK=$06, 	\ACKNOWLEDGE
	NAK=$15;	\NEGATIVE ACKNOWLEDGE

int	FILESPEC;	\HOLDS FILE SPECS

define	MAXFIL=20, 	\MAXIUM FILES
	NAMSIZ=50;	\CHARACTERS IN FILE NAME



proc	GETSTR(S, L);
addr	S;
int	L;
int	X;
begin
OPENI(0);
X:= 0;
loop	begin
	S(X):= CHIN(0);
	if S(X)=CR then quit;
	X:= X+1;
	if X=L then quit;	
	end;	
if X#0 then S(X-1):= S(X-1) !$80
else S(X):= $A0;
end;	\GETSTR



proc	GETNAME(S);
int	S;
begin
CHOUT(0, FF);
TEXT(0, "

ENTER FILE NAME ");
GETSTR(S, 40);
end;	\GETNAME



proc	SEROUT(C);
\SEND SERIAL CHAR
int	C;
begin
CHOUT(4, C);
end;	\SEROUT



proc	SERSTR(S);
addr	S;
int	P;
begin
P:= 0;
loop	begin
	SEROUT(S(P) & $7F);
	if S(P) > $7F then quit;
	P:= P +1;
	end;
end;	\SERSTR



proc	DISKERR(S);
int	S, I;
begin
CHOUT(0, BEL);
CRLF(0);
TEXT(0, S);   CRLF(0);
TEXT(0, "hit any key");   CRLF(0);
I:= CHIN(1);
end;	\DISKERR



proc	SERIN;
\GET SERIAL CHAR
addr	B;
begin
B:= CPUREG;
repeat	CPUREG(0):= $0200;
	CPUREG(3):= 0;
	SOFTINT($14);
until CPUREG(0) < $7FFF;
return B(0);
end;	\SERIN



proc	SOTEST;
\CHECK SERIAL OUT NOT BUSY
begin
CPUREG(0):= $0300;
CPUREG(3):= 0;
SOFTINT($14);
return (CPUREG(0) & $0010) #0;
end;	\SOTEST



proc	SINTEST;
\CHECK FOR SERIAL CHAR
begin
CPUREG(0):= $0300;
CPUREG(3):= 0;
SOFTINT($14);
return (CPUREG(0) & $0100) #0;
end;	\SINTEST

\---------------------------------------------------------------

proc	SETSER;		\SET BAUD RATE, 8 BITS 1 STOP
begin
CPUREG(0):= BTABLE(BAUD, 1) ! $03;
CPUREG(3):= 0;
SOFTINT($14);
end;	\SETSER



proc	NEWSER;		\CHANGE SERIAL SETTINGS
int C;
begin
CHOUT(0, FF);
TEXT(0, "

************ SERIAL CARD SETUP

hit any key to change, <RETURN> to set

");
loop	begin
	CURSOR(0, 15);
	TEXT(0, "BAUD RATE ");
	INTOUT(0, BTABLE(BAUD, 0));
	TEXT(0, "  ");
	if CHIN(1)=CR then quit;
	BAUD:= if BAUD>=4 then 0 else BAUD+1;
	end;
SETSER;
end;	\NEWSER



proc	COMTEST;
int	C;
begin
CHOUT(0, FF);
TEXT(0, "

       TERMINAL TEST MODE

       hit <ESC> to stop

");
OPENI(0);
CHOUT(0, $1E);
CHOUT(0, BS);
loop	begin
	if CHKKEY then
		begin
		C:= CHIN(1);
		if C=ESC then quit;
		if SOTEST then SEROUT(C);
		end;
	if SINTEST then
		begin
		C:= SERIN;
		CHOUT(0, C);
		if C=CR then CHOUT(0, LF);
		CHOUT(0, $1E);
		CHOUT(0, BS);
		end;
	end;
end;	\COMTEST

\--------------------------------------------------------------

proc	GETHAND;	\GET HANDSHAKE OR ABORT
int	C;
begin
loop	begin
	if SINTEST then
		begin
		C:= SERIN;
		case C of ACK, NAK: return C other;
		end;
	if CHKKEY then if CHIN(1)=ESC then
		begin
		AFLAG:= true;		
		return false;
		end;
	end;
end;	\GETHAND



proc	GETBUFFER;	\FILL BUFFER FROM
int	C;
begin
TRAP($FFFB);
for BPTR:= 0, BUFSIZ-1 do
	begin
	C:= CHIN(3);
	EOFLAG:= C=EOF;
	BUFFER(BPTR):= C;
	if EOFLAG then return true;
	end;
TRAP($FFFF);
if GETERR=3 then [DISKERR("DISK ERROR");   return false];
return true;
end;	\GETBUFFER



proc	SENDBLOCK;
int	C;
begin
repeat	CHECK:= 0;
	SEROUT(SOH);
	SEROUT(BLKCNT);
	SEROUT(not BLKCNT);
	for BPTR:= 0, BUFSIZ-1 do
		begin
		C:= BUFFER(BPTR);
		CHECK:= (CHECK+C)&$FF;
		SEROUT(BUFFER(BPTR));
		end;
	SEROUT(CHECK);
until GETHAND=ACK ! AFLAG;
end;	\SENDBLOCK



proc	SENDFILE(FNAME);
addr	FNAME;
begin
TEXT(0, "

***** SENDING FILE

<ESC> to abort


FILE= ");
TEXT(0, FNAME);
TRAP($FFFB);
HAND:= FOPEN(FNAME, 0);
TRAP($FFFF);
if GETERR=3 then [DISKERR("UNABLE TO OPEN FILE");   return false];
FSET(HAND, ^I);
OPENI(3);
BLKCNT:= 1;
AFLAG:= false;
EOFLAG:= false;
repeat if AFLAG then return
until GETHAND=NAK;
loop	begin		
	CURSOR(0, 15);TEXT(0, "SENDING BLOCK # ");INTOUT(0, BLKCNT);
	if not  GETBUFFER then return;
	SENDBLOCK;
	if AFLAG then return;
	if EOFLAG then quit;
	BLKCNT:= BLKCNT+1;
	end;
repeat SEROUT(EOT) until GETHAND=ACK;
FCLOSE(HAND);
end;	\SENDFILE

\-----------------------------------------------------------------

proc	WAIT;		\WAIT FOR INPUT, TIMEOUT OR ABORT
			\RETURN FLAG IF FAILURE
int	T;
define TIMEOUT=4000;
begin
for T:= 0, TIMEOUT do
	begin
	if CHKKEY then
		if CHIN(1)=ESC then [AFLAG:= true;   return FAIL];
	if SINTEST then return SERIN;
	end;
return FAIL;
end;	\WAIT



proc	SAVEBUFFER;
begin
for BPTR:= 0, BUFSIZ-1 do CHOUT(3, BUFFER(BPTR));
end;	\SAVEBUFFER



proceddure GETBLOCK;	\GET A BLOCK, RETURN FALSE IF BAD
int	BC1, BC2, CHK;
begin
BC1:= SERIN;
BC2:= SERIN;
for BPTR:= 0, BUFSIZ-1 do BUFFER(BPTR):= SERIN;
CHK:= SERIN;

A1:= BC1;   A2:= BLKCNT;
if A1 #A2  then [ERRCOD:= 1;   return false];
A1:= BC2;   A2:= BLKCNT;
if (not A1 & $FF) #A2 then [ERRCOD:= 2;   return false];
CHECK:= 0;
for BPTR:= 0, BUFSIZ-1 do
	CHECK:= (CHECK+BUFFER(BPTR)) & $FF;
A1:= CHK;A2:= CHECK;
if CHK#CHECK then
	[ERRCOD:= 3;   return false];
return true;
end;	\GETBLOCK



proc	GETFILE(FNAME);
addr	FNAME;
int	SHAKE, B;
begin
TEXT(0, "

***** RECIEVING FILE

<ESC> to abort

FILE= ");
TEXT(0, FNAME);
TRAP($FFFB);
HAND:= FOPEN(FNAME, 1);
TRAP($FFFF);
if GETERR=3 then [DISKERR("UNABLE TO OPEN FILE");   return false];
FSET(HAND, ^O);
OPENO(3);
ERRCOD:= 0;
AFLAG:= false;
BLKCNT:= 1;
SHAKE:= NAK;
loop	begin
	CURSOR(0, 16);TEXT(0, "READ BLOCK ");INTOUT(0, BLKCNT);
	SEROUT(SHAKE);
	B:= WAIT;
	while B#SOH do
		begin
		SHAKE:= NAK;
		if B=EOT then quit;
		if AFLAG then return false;		
		SEROUT(SHAKE);
		B:= WAIT;
		end;
	if GETBLOCK then
		begin
		SAVEBUFFER;
		SHAKE:= ACK;
		BLKCNT:= BLKCNT+1;
		end
	else	begin
		CURSOR(0, 17);TEXT(0, "BAD BLOCK ");INTOUT(0, ERRCOD);
		TEXT(0, " ");INTOUT(0, A1);TEXT(0, " ");INTOUT(0, A2);
		if AFLAG then return false;
		SHAKE:= NAK;
		end;
	end;
SEROUT(ACK);
CHOUT(3, EOF);
CLOSE(3);
FCLOSE(HAND);
return true;
end;

\---------------------------------------------------------------

proc	NEXTNAME(S);
addr	S;
int	C, P;
begin
P:= 0;
loop	begin
	repeat if CHKKEY then if CHIN(1)=ESC then return false;
	until SINTEST;
	case SERIN of
	  ^!:	quit;
	  ^#:	return false
	other;
	end;
repeat [SEROUT(^!);S(P):= SERIN] until S(P)#^!;
loop	begin
	if S(P)=CR then quit;
	P:= P+1;
	if P =NAMSIZ then quit;
	S(P):= SERIN;
	end;
if P>0 then S(P-1):= S(P-1) ! $80
else return false;
return true;
end;



proc	BREAD;
begin
CHOUT(0, FF);
TEXT(0, "

************** BATCH FILE READ

");
while NEXTNAME(NFILE) do
	begin
	CURSOR(0, 15);
	GETFILE(NFILE);
	end;
end;	\BREAD

\--------------------------------------------------------------

proc	NDISPLAY;
int	P;
begin
CHOUT(0, FF);
for P:= 0, MAXFIL-1 do
	begin
	INTOUT(0, P);
	TEXT(0, ": ");
	if FILESPEC(P, 0)#0 then TEXT(0, FILESPEC(P));
	CRLF(0);	
	end;
end;	\NDISPLAY



proc	ADDFILE;
int	N;
begin
repeat
	begin
	TEXT(0, "ENTER NUMBER ");
	N:= INTIN(0);
	end
until N>=0 & N<=MAXFIL;
TEXT(0, "ENTER NAME ");
GETSTR(FILESPEC(N));
end;	\ADDFILE



proc	DELFILE;
int	N;
begin
repeat	TEXT(0, "ENTER NUMBER ");
	N:= INTIN(0);
until N>=0 & N<=MAXFIL;
TEXT(0, "ENTER NAME ");
FILESPEC(N, 0):= 0;
end;	\DELFILE



proc	ENTERNAMES;
int	P, N;
begin
loop	begin
	NDISPLAY;
	TEXT(0, "A=ADD FILE, D=DELETE, Z=ZERO, Q=QUIT ");
	CRLF(0);
	case CHIN(1) of
	  ^A, ^a:	ADDFILE;
	  ^D, ^d:	DELFILE;
	  ^Z, ^z:	for P:= 0, MAXFIL-1 do FILESPEC(P, 0):= 0;
	  ^Q, ^q:	quit
	other;
	end;
end;	\ENTERNAMES



proc	BWRITE;
int	F;
begin
ENTERNAMES;
for F:= 0, MAXFIL-1 do
	if FILESPEC(F, 0)#0 then
		begin
		loop
			begin
			SEROUT(^!);
			if CHKKEY then if CHIN(1)=ESC then return;
			if SINTEST then if SERIN=^! then quit;
			end;
		SERSTR(FILESPEC(F));
		SEROUT(CR);
		CHOUT(0, FF);
		SENDFILE(FILESPEC(F));
		end;
SEROUT(^#);   SEROUT(^#);
end;

\---------------------------------------------------------------

proc	MENU;
int	COM;
begin
CHOUT(0, FF);
TEXT(0, "

***** XMODEM COMMUNICATION PROGRAM *****
******* COPYRIGHT 1989 LARRY FISH ******
");

TEXT(0, "   BAUD RATE - ");
INTOUT(0, BTABLE(BAUD, 0));   CRLF(0);   CRLF(0);

TEXT(0, "

0) QUIT
1) SET SERIAL PORT
2) COMMUNICATION TEST
3) SEND FILE
4) RECIEVE FILE
5) BATCH RECIEVE
6) BATCH SEND

SELECT ONE: ");

COM:= INTIN(0);
case COM of
  0:	ABORT;
  1:	NEWSER;
  2:	COMTEST;
  3:	[GETNAME(NFILE);   CHOUT(0, FF);   SENDFILE(NFILE)];
  4:	[GETNAME(NFILE);   CHOUT(0, FF);   GETFILE(NFILE)];
  5:	BREAD;
  6:	BWRITE
other;
end;	\MENU



begin	\MAIN
CPUREG:= GETREG;
FILESPEC:= RESERVE(MAXFIL*2);
for I:= 0, MAXFIL-1 do FILESPEC(I):= RESERVE(NAMSIZ);
NFILE:= RESERVE(NAMSIZ);
for I:= 0, MAXFIL-1 do FILESPEC(I, 0):= 0;

BTABLE:=[[300, $40],
	[1200, $80],
	[2400, $A0],
	[4800, $C0],
	[9600, $E0]];
BUFFER:= RESERVE(BUFSIZ);
BAUD:= 2;
SETSER;
loop MENU;
end;	\MAIN
