
\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,	MOD=58,		LOG=59,		COS=60,
TAN=61,		ASIN=62,	ACOS=63;






integer YEAR,MONTH,DATE,DAY;
integer HOUR,MINUTE,SECOND,HUNDTH;

integer CPUREG;


integer FREQ,LEN,VOL;


integer H0, STARTX, STARTY;
integer I, N, H, X, Y, X0, Y0;
integer WHITE,BLACK,COMPLEMENT,GMODE;


procedure ESCAPE;
\QUICK CHECK FOR ESCAPE
integer C;
begin
if CHKKEY then if CHIN(1)=$1B then return true;
return false;
end;



procedure LOGO;
integer I;
begin
CURSOR(1,1);for I:=1,78 do CHOUT(1,$B2);
CURSOR(1,23);for I:=1,78 do CHOUT(1,$B2);
for I:=1,23 do [CURSOR(1,I);CHOUT(1,$B2)];
for I:=1,23 do [CURSOR(78,I);CHOUT(1,$B2)];
end;





procedure BLOCK;
integer X1,Y1,X2,Y2,C,T,INC;
begin
C:=RAN(3)+1;
X1:=RAN(320);X2:=RAN(320);
Y1:=RAN(200);Y2:=RAN(200);
if X1>X2 then [T:=X1;X1:=X2;X2:=T;];
if Y1>Y2 then [T:=Y1;Y1:=Y2;Y2:=T;];

MOVE(X1,Y1);LINE(X1,Y2,C);
LINE(X2,Y2,C);LINE(X2,Y1,C);
LINE(X1,Y1,C);
T:=RAN(2);
if T then
	begin
	repeat
		begin
		X1:=X1+1;
		MOVE(X1,Y1);LINE(X1,Y2,C);
		end
	until X1>=X2;
	end
else
	begin
	repeat
		begin
		Y1:=Y1+1;
		MOVE(X1,Y1);LINE(X2,Y1,C);
		end
	until Y1>=Y2;
	end;
end;



procedure GBLOCK;
integer I;
begin
SETVID(4);
repeat BLOCK until CHKKEY;
end;



procedure PAUSE;
integer X;
begin
CHOUT(0,7);
X:=CHIN(1);
end;


procedure HILBERT;
\HILBERT CURVE, ORDER 6

fproc A, B, C, D;


procedure A (I);
integer I;
begin
if I>0 then
	begin
	D(I-1);
	X:=X-H;
	LINE(X,Y,WHITE);
	A(I-1);
	Y:=Y-H;
	LINE(X,Y,WHITE);
	A(I-1); 
	X:=X+H; 
	LINE(X,Y,WHITE);
	B(I-1);
	end;
end;

procedure B (I);
integer I;
begin
if I>0 then
	begin
	C(I-1); 
	Y:=Y+H;
	LINE(X,Y,WHITE);
	B(I-1);
	X:=X+H; 
	LINE(X,Y,WHITE);
	B(I-1);
	Y:=Y-H;
	LINE(X,Y,WHITE);
	A(I-1);
	end;
end;

procedure C (I);
integer I;
begin
if I>0 then
	begin
	B(I-1);
	X:=X+H;
	LINE(X,Y,WHITE);
	C(I-1);
	Y:=Y+H;
	LINE(X,Y,WHITE);
	C(I-1);
	X:=X-H;
	LINE(X,Y,WHITE);
	D(I-1);
	end;
end;

procedure D (I);
integer I;
begin
if I>0 then
	begin
	A(I-1);
	Y:=Y-H;
	LINE(X,Y,WHITE);
	D(I-1);
	X:=X-H;
	LINE(X,Y,WHITE);
	D(I-1);
	Y:=Y+H;
	LINE(X,Y,WHITE);
	C(I-1);
	end;
end;

begin \OF HILBERT
H0:=192;
STARTX:=280/2;
STARTY:=192/2;
N:=6;
SETVID(GMODE);
H:=H0;
X0:=STARTX;
Y0:=STARTY;

for I:=1,N do
	begin
	H:=H/2;
	X0:=X0+(H/2);
	Y0:=Y0+(H/2);
	X:=X0;
	Y:=Y0;
	MOVE(X,Y);
	
	\DRAW CURVE OF ORDER I
	A (I);
	end;
PAUSE;
end;



procedure SERPINSKI;
\SERPINSKI CURVE

fproc A, B, C, D;


procedure A (I);
integer I;
begin
if I>0 then
    begin
    A(I-1);
    X:=X+H;
    Y:=Y-H;
    LINE(X,Y,WHITE);
    B(I-1);
    X:=X+2*H;
    LINE(X,Y,WHITE);
    D(I-1);
    X:=X+H;
    Y:=Y+H;
    LINE(X,Y,WHITE);
    A(I-1)
    end;
end;

procedure B (I);
integer I;
begin
if I>0 then
    begin
    B(I-1);
    X:=X-H;
    Y:=Y-H;
    LINE(X,Y,WHITE);
    C(I-1);
    Y:=Y-2*H;
    LINE(X,Y,WHITE);
    A(I-1);
    X:=X+H;
    Y:=Y-H;
    LINE(X,Y,WHITE);
    B(I-1)
    end
end;

procedure C (I);
integer I;
begin
if I>0 then
    begin
    C(I-1);
    X:=X-H;
    Y:=Y+H;
    LINE(X,Y,WHITE);
    D(I-1);
    X:=X-2*H;
    LINE(X,Y,WHITE);
    B(I-1);
    X:=X-H;
    Y:=Y-H;
    LINE(X,Y,WHITE);
    C(I-1);
    end
end;

procedure D (I);
integer I;
begin
if I>0 then
    begin
    D(I-1);
    X:=X+H;
    Y:=Y+H;
    LINE(X,Y,WHITE);
    A(I-1);
    Y:=Y+2*H;
    LINE(X,Y,WHITE);
    C(I-1);
    X:=X-H;
    Y:=Y+H;
    LINE(X,Y,WHITE);
    D(I-1)
    end
end;

begin \of SERPINSKI
H0:=192;
N:=4;
SETVID(GMODE);
H:=H0/4;
X0:=H*3;
Y0:=H*3;
for I:=1,N do
	begin
	X0:=X0-H;
	H:=H/2;
	Y0:=Y0+H;
	X:=X0;
	Y:=Y0;
	MOVE(X,Y);
	
	\DRAW CURVE OF ORDER I
	A(I);
	X:=X+H;
	Y:=Y-H;
	LINE(X,Y,WHITE);
	B(I);
	X:=X-H;
	Y:=Y-H;
	LINE(X,Y,WHITE);
	C(I);
	X:=X-H;
	Y:=Y+H;
	LINE(X,Y,WHITE);
	D(I);
	X:=X+H;
	Y:=Y+H;
	LINE(X,Y,WHITE);
	end;
PAUSE;
end;



procedure PRETTYX;
\PRETTY X DEMO


integer I;



procedureVECTOR(X,Y);
integerX,Y;
begin
LINE(X,Y,COMPLEMENT);
end;


procedureLOGO1;
integerI,DATA,SIZE;
begin
DATA:=[
	[10,150,35,40],
	[35,40,60,150],
	[23,100,47,100],
	[80,150,80,40],
	[80,40,130,40],
	[130,40,130,100],
	[130,100,80,100],
	[150,150,150,40],
	[150,40,200,40],
	[150,100,200,100],
	[150,150,200,150],
	[220,150,270,40],
	[220,40,270,150]
	];
SIZE:=13;
forI:=0,SIZE-1do
	begin
	MOVE(DATA(I,0),DATA(I,1));
	VECTOR(DATA(I,2),DATA(I,3));
	end;
end;

procedureLOGO2;
integerI,DATA,SIZE;
begin
DATA:=[
	[10,150,60,40],
	[10,40,60,150],
	[80,150,80,40],
	[80,40,130,40],
	[130,40,130,100],
	[130,100,80,100],
	[150,40,150,150],
	[150,150,200,150],
	[220,40,220,150],
	[220,150,260,150],
	[260,150,260,40],
	[260,40,220,40],
	[220,150,260,40]
	];
SIZE:=13;
forI:=0,SIZE-1do
	begin
	MOVE(DATA(I,0),DATA(I,1));
	VECTOR(DATA(I,2),DATA(I,3));
	end;
end;

procedurePAT1;
integerX,Y;
begin
forY:=0,191do[MOVE(0,Y);VECTOR(279,191-Y)];
forX:=1,278do[MOVE(279-X,0);VECTOR(X,191)];
end;

procedurePAT2;
integerX,Y,X2,Y2;
begin
Y:=0;
forX:=0,191do
	begin
	X2:=279-X;
	Y:=Y+1;
	Y2:=191-Y;
	MOVE(X,Y);
	VECTOR(X2,Y);
	VECTOR(X2,Y2);
	VECTOR(X,Y2);
	VECTOR(X,Y);
	end;
end;


begin\MAIN
SETVID(GMODE);
PAT1;
LOGO1;
PAT2;
PAT1;
forI:=0,16000do;
LOGO1;
forI:=0,8000do;
LOGO2;
PAT2;
forI:=0,16000do;
PAUSE;
end;





procedure GDEMO;
begin
CLEAR;
CURSOR(0,10);
TEXT(0,"
		*** GRAPHICS TEST FOR IBM XPL ***

		SELECT M=MEDIUM RES, H=HIGH RES ");
LOGO;
repeat
	begin
	GMODE:=CHIN(1);
	if GMODE=^h then GMODE:=^H;
	if GMODE=^m then GMODE:=^M;
	end
until (GMODE=^M) ! (GMODE=^H);

if GMODE=^M then
	begin
	GMODE:=4;
	WHITE:=3;
	end
else
	begin
	GMODE:=6;
	WHITE:=1;
	end;


BLACK:=0;
COMPLEMENT:=$80 ! WHITE;

HILBERT;
SERPINSKI;
PRETTYX;
GBLOCK;
SETVID(3);
end;





procedure SLIDE;
begin
FREQ:=11900;
LEN:=1;
repeat
	begin
	SOUND($FF,LEN,FREQ);
	FREQ:=FREQ-700;
	end
until FREQ<50;
end;


procedure BUBBLES;
integer I;
begin
LEN:=2;
loop	begin
	FREQ:=RAN(11000)+100;
	SOUND($FF,LEN,FREQ);
	if CHKKEY then quit;
	end;
end;


procedure NOISE;
begin
CLEAR;
LOGO;
CURSOR(20,12);
TEXT(0,"HIT ANY KEY TO STOP");
SLIDE;
BUBBLES;
SLIDE;
end;




procedure SYSINFO;
integer TYPE,STAT1,STAT2,R,C;

procedure NEXTROW;
[CURSOR(C,R);R:=R+1;];


procedure MALOC;
integer PSP,DOSINFO,CODSEG,ENDSEG,TOTAL;
begin
PSP:=0;
DOSINFO:=GETREG;
CODSEG:=DOSINFO(8);
ENDSEG:=PSP(2);
TOTAL:=ENDSEG-CODSEG;

NEXTROW;
TEXT(0,"CURRENT SEGMENT = ");
HEXOUT(0,CODSEG);
CRLF(0);
NEXTROW;

TEXT(0,"END SEGMENT = ");
HEXOUT(0,ENDSEG);
CRLF(0);

NEXTROW;
TEXT(0,"TOTAL = ");
HEXOUT(0,TOTAL);
CRLF(0);
end;


begin
TYPE:=PEEK($F000,$FFFE);
STAT1:=PEEK($40,$10);STAT2:=PEEK($40,$11);
C:=10;R:=3;

NEXTROW;
TEXT(0,"COMPUTER TYPE: ");
case TYPE of
	$FF: TEXT(0,"PC");
	$FE: TEXT(0,"XT");
	$FD: TEXT(0,"PCjr");
	$FC: TEXT(0,"AT")
else TEXT(0,"UNKOWN");

NEXTROW;
TEXT(0,"THERE ARE ");
if STAT1 & 1 then INTOUT(0,((STAT1/64)&3)+1)
else TEXT(0,"NO");
TEXT(0," DISK DRIVES");

NEXTROW;
TEXT(0,"THERE IS ");
if STAT1 & 2 then TEXT(0,"A")
else TEXT(0,"NO");
TEXT(0," MATH COPROCESSOR PRESENT");

NEXTROW;
TEXT(0,"THERE ARE ");
INTOUT(0,((STAT2/2)&7));
TEXT(0," SERIAL DEVICES");

NEXTROW;
TEXT(0,"THERE ARE ");
INTOUT(0,((STAT2/64)&3));
TEXT(0," PARALLEL DEVICES");

MALOC;
end;





procedure GETDATE;
\GET SYSTEM DATE
begin
CPUREG:=GETREG;
CPUREG(0):=$2A00;
SOFTINT($21);
DAY:=CPUREG(0)&$FF;
YEAR:=CPUREG(2);
MONTH:=SWAP(CPUREG(3))&$FF;
DATE:=CPUREG(3)&$FF;
end;


procedure GETIME;
\GET SYSTEM DATE
begin
CPUREG:=GETREG;
CPUREG(0):=$2C00;
SOFTINT($21);
HOUR:=SWAP(CPUREG(2))&$FF;
MINUTE:=CPUREG(2)&$FF;
SECOND:=SWAP(CPUREG(3))&$FF;
HUNDTH:=CPUREG(3)&$FF;
end;


procedure DISTIME;
\DISPLAY TIME AND DATE
begin
CLEAR;
LOGO;
SYSINFO;
CURSOR(12,15);
TEXT(0,"* ESC TO QUIT *");
loop
	begin
	GETDATE;
	GETIME;
	CURSOR(10,17);
	INTOUT(1,MONTH);TEXT(0," ");
	INTOUT(1,DATE);TEXT(0," ");
	INTOUT(1,YEAR);TEXT(0," - ");
	INTOUT(1,HOUR);TEXT(0,":");
	INTOUT(1,MINUTE);TEXT(0,":");
	INTOUT(1,SECOND);TEXT(0," ");
	INTOUT(1,HUNDTH);
	CRLF(1);
	if ESCAPE then quit;
	end;
end;



procedure SAVAGE;
integer I;
real A;
begin
FORMAT(10,20);
A:=1.0;
CHOUT(0,$0C);
for I:=1,2499 do
	begin
	A:=TAN(ATAN2(EXP(LN(SQRT(A*A))),1.))+1.0;
	RLOUT(0,A);
	CRLF(0);
	end;
RLOUT(0,A);
CRLF(0);
end;


procedure MENU;
integer COM;
begin
CLEAR;
CURSOR(0,5);
TEXT(0,"
			**** IBM XPL DEMO PROGRAM ****

			 T) SYSTEM INFORMATION
			 G) GRAPHICS DEMO
			 S) SOUND DEMO
			 H) TOWERS OF HANOI
			 B) BLOCKAGE GAME
			 R) SAVAGE BENCHMARK
");
LOGO;
loop
	begin
	CURSOR(16,20);
	TEXT(0,"SELECT: ");
	COM:=CHIN(1);
	if (COM>=^a) & (COM<=^z) then COM:=COM-$20;
	case COM of
		^G: [GDEMO;quit;];
		^S: [NOISE;quit;];
		^B: [CHAIN("BLOCK.COM");quit;];
		^H: [CHAIN("HANOID0.COM");quit;];
		^R: [SAVAGE;quit;];
		^T: [DISTIME;quit;]
	else;
	end;

end;



begin
loop MENU;
end;
