

\**** XEDIBM .XPL Version 1.8 ***
\(See HELP and INITIALIZE)
\By Richard Ottosen, Loren Blaney and Larry Fish
\This is a version of VED/MRED written in XPL to run on the PC under MS-DOS.
\
\REVISION HISTORY:
\ NOV-84, Original version, R.O.
\ JUL-02-90, Modified to run on PC using 16-bit XPL, L.B.
\ AUG-90, Enhanced PC version, Assembly Language screen handling, L.F.

\NOTES:
\See HELP for the directions.
\
\
\This text editor is always in insert mode. Characters can be rapidly inserted
\ because the text in the edit buffer is split at the point where the cursor
\ is. Inserted characters are simply stored in the split -- the rest of the
\ text does not need to be moved.
\
\If the screen looks like this:
\
\ The quick brown fox jumps over the lazy dog.
\			 ^
\			Displayed cursor
\
\The edit buffer will look like this:
\
\ The quick brown fox jum................................ps over the lazy dog.
\		         ^				 ^
\		        CINX			        C2INX
\
\If an "X" is inserted, the screen will look like this:
\
\ The quick brown fox jumXps over the lazy dog.
\			  ^
\			Displayed cursor
\
\ and the edit buffer will look like this:
\
\ The quick brown fox jumX...............................ps over the lazy dog.
\		          ^				 ^
\		        CINX			        C2INX
\
\When CINX = C2INX, the edit buffer is full and no more characters can be
\ inserted.

code
ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	GETERR=22,
CURSOR=23,	FSET=24,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	POKE=38,	FCLOSE=32,
KEYHIT=33,	SOFTINT=34,	GETREG=35,	BLITX=36,
PEEK=37,	ATTRIB=69,	SETWIND=70,	RAWTEXT=71,
MALLOC=73,	TRAPC=75,	TESTC=76;

def	INTSIZE=2;	\number of bytes in an integer
def	TV=1, PR=2;	\I/O device numbers


def	\Define extended key codes

	FN1KEY=59,	FN2KEY=60,	FN3KEY=61,	FN4KEY=62,
	FN5KEY=63,	FN6KEY=64,	FN7KEY=65,	FN8KEY=66,
	FN9KEY=67,	FN10KEY=68,	HOMKEY=71,	ENDKEY=79,
	PUPKEY=73,	PDNKEY=81,	UPAKEY=72,	DNAKEY=80,
	LFAKEY=75,	RTAKEY=77,	INSKEY=82,	DELKEY=83,
	SHFTAB=15;

define	\Define extended key codes with ALT key down

	ALTFN1=104,	ALTFN5=108,	ALTR=19,	ALTF=33,
	ALTB=48;

def	\Define extended key codes with the CONTROL key press

	CTRLPGDOWN=118,	CTRLEND=117;

def	CTRLA= $01,	CTRLB= $02,	CTRLC= $03,	CTRLD= $04,
	CTRLE= $05,	CTRLF= $06,	CTRLG= $07,	CTRLH= $08,
	CTRLI= $09,	CTRLJ= $0A,	CTRLK= $0B,	CTRLL= $0C,
	CTRLM= $0D,	CTRLN= $0E,	CTRLO= $0F,	CTRLP= $10,
	CTRLQ= $11,	CTRLR= $12,	CTRLS= $13,	CTRLT= $14,
	CTRLU= $15,	CTRLV= $16,	CTRLW= $17,	CTRLX= $18,
	CTRLY= $19,	CTRLZ= $1A,

	BEL= $07,	TAB= $09,	LF= $0A,	FF= $0C,
	CR= $0D,	EOF= $1A,	ESC= $1B,	DEL= $7F,

	SP= $20,	\space char
	SPIND= ^_,	\indicator for a space when showing control chars
	WILDCH= CTRLW;	\wild character matches anything in a search

def	XBUFSIZ= 32000,	\scoop (X register) buffer size
	PAD= 3000,	\space left when reading in a file
	COLMAX= 255,	\maximum possible column (with horz scrolling)
	MAXMARK=2,	\number of active markers
	DBUFSIZ= 256;	\size of deferred command (line) buffer
			\WARNING: status display assumes 80 columns and
			\ HELP menus assume 24 lines

int	CINX,		\char position index (in text buffer)
	C2INX,		\second char position index
	SCINX,		\saved char pointers for OOPS command
	SC2INX,
	DINX,		\array: index for command line buffer (points to end +1)
	XINX,		\index for X register (scoop)
	CHAR,		\holds character struck on keyboard
	CURH,		\horizontal posn of cursor from last CR. This is COL:
			\ on the status line, (0 through COLMAX).
	CURL,		\line on the screen where the cursor is currently
	BASELINE,	\base line count for counting lines in a document
	CURLINE,	\screen line where the edit-buffer cursor appears
	REALCOL,	\actual screen column, command line etc.
	LEFTCOL,	\column number of the left-most displayed char
			\ (= number of chars scrolled off of left edge)
	RIGHTCOL,	\column number + 1 of the right-most displayed char
	BUFSIZ,		\size of edit buffer (bytes)

	CUTFLAG,	\flags text cutting is enabled
	XFLAG,		\scoop (X reg) is enabled
	EOFFLAG,	\EOF is read from input file
	CLOSFLAG,	\output file has been closed
	ERRFLAG,	\error flag used for terminating command-line loop

	DBUF,		\array of buffers: deferred command (line) buffer
	DN,		\current DBUF [0-9]
	REMAIN,		\remaining char space
	II,		\scratch for MAIN
	WIDTH,		\number of chars per line
	HEIGHT,		\number of lines on the screen
	SLENGTH,	\number of character on the update screen
	OLDCUR,		\cursor type upon entry to editor

	CUTPTR1,	\pointers for cutting text from buffer
	CUTPTR2,
	CUTCOL1,	\column values for cutting text from buffer
	CUTCOL2,

	BOXCHAR,	\array of box graphics characters
	BOXMODE,	\current box style

	MRKPTR1,	\input pointer for marker array
	MRKPTR2,	\output pointer for marker array
	MARKER,		\array of text markers
	SCRSEG,		\segment of address of current screen
	STATATT,	\attribute for status line
	HELPATT,	\attribute for help menu
	CURCOLOR,	\color of cursor
	CYCFLAG,	\flag command line cycling
	BREAKFLAG,	\flags break key struck
	STRIPFLAG,	\flags LF should be stripped
	WRKCOL,		\working column for UPLINE and DOWNLINE
	EPTR,		\pointer for expression evaluator
	GLOBAL;		\global for expression evaluation

addr	BUFFER;		\main text buffer

seg addr
	XBUFFER;	\scoop buffer (X register)

addr
	HEXSTR,		\string of hex characters for display
	STATCOND,	\status condition message string (8 chars max)
	TICKMARKS,	\ruler tick marks
	SSTR;		\search string, must be global because of XPL bug

int	PARAMS;		\initialization parameters (can be saved with program)
def	\PARAMS\	\note: order must agree with constant array
	COLDFLAG,	\true if not a restart
	LEFTMARGIN,	\left margin column position
	RIGHTMARGIN,	\right margin column position (last char is in this col)
	BELLCOL,	\column for end-of-line bell
	PARAINDENT,	\number of spaces to indent the beginning of paragraphs
	S1FLAG,		\ignore upper/lower case in searches
	S2FLAG,		\search backwards
	SHOWFLAG,	\show the control chars
	WRAPFLAG,	\flag line wrap around mode
	OVERFLAG;	\flag overwrite insert mode

int	CPUREG,		\pointer to system info
	PSPSEG,		\address of PSP segment (for file I/O)
	DATASEG,	\address of data segment (heap & stack)
	INHAND,		\input file handle
	OUTHAND,	\output file handle
	HAVEINFILE;	\flag: input file exists
addr	INFILE,		\input file name
	OUTFILE,	\output file name
	OUTTEMP,	\temporary output file name (.$$$)
	OUTBACK;	\backup output file name (.BAK)
def	NAMESIZE=40;	\maximum number of characters in a file name


\Structure to pass parameters to and from screen update routine

integer WSTRUC;		\Structure array
define			\Structure entries
	WSEG,		\Segment of screen window
	BSTART,		\Start of text buffer
	BEND,		\End of text buffer
	BPTR1,		\First text pointer
	BPTR2,		\Second text pointer
	BCOLLUM,	\Current column
	LWIND,		\Current left screen window
	RWIND,		\Current right screen window
	SHOWALL,	\Show all controls
	SCRLEN,		\Number of bytes in update part of screen
	LINLEN,		\Number of character per line
	LBEFORE,	\Number of lines before the cursor
	CURATT,		\Current cursor attribute

	STRUCSIZE;	\Size of structure !! MUST BE LAST ITEM !!

\----------------------------------------------------------------------


external SCREEN;	\Assembly language to update screen

external LCOUNT;	\Assembly language to count lines


proc	BLIT(FROM, TO, SIZE);	\Convert BLIT to PC form
int	FROM, TO, SIZE;
begin
BLITX(DATASEG, FROM, DATASEG, TO, SIZE);
end;	\BLIT

procedure CURSON;
\Turn on flashing cursor
begin
CPUREG(0):= $0100;			\turn on flashing cursor
CPUREG(2):= $000D;
SOFTINT($10);
end;


procedure CURSOFF;
\Turn off flashing cursor
begin
CPUREG(0):= $0100;			\turn off flashing cursor
CPUREG(2):= $2000;
SOFTINT($10);
end;


procedure RESTCUR;
\Restore normal cursor
begin
CPUREG(0):= $0100;
CPUREG(2):= OLDCUR;
SOFTINT($10);
end;


procedure SAVECUR;
\Save cursor
begin
CPUREG(0):= $0300;
SOFTINT($10);
OLDCUR:=CPUREG(2);
end;





procedure KEYINX;
\Get char from keyboard, lowest level
begin
\BIOS level input call
CPUREG(0):= 0;
SOFTINT($16);
CHAR:= CPUREG(0) & $FF;

\Make extended keys negative
return if CHAR =0 then -SWAP(CPUREG(0)) else CHAR;
end;



func	KEYIN;		\Get a character from the keyboard, with cursor
\Inputs: CURH, LEFTCOL.
int	CHAR, H;
begin
H:=CURH -LEFTCOL;
if H<0 then H:= 0;
if H > WIDTH-1 then H:= WIDTH-1;
CURSOR(H, CURL);

CURSON;
CHAR:=KEYINX;					\get the character
CURSOFF;
CURLINE:= (HEIGHT -6);			\put cursor on 3rd line from bottom
					\ (in case HEIGHT changed)
return CHAR;
end;	\KEYIN

\----------------------------------------------------------------------


proc	WAIT;		\position cursor and wait for key
begin
CURSOR(0,HEIGHT-1);
TEXT(0,"                                            (ESC to abort, any key to continue)");
CURL:= HEIGHT-1;   CURH:= 78;	\set cursor position for KEYIN
repeat until KEYIN;
end;


proc	HELP(DEV);	\Show/print HELP screen
\(DON'T straighten up the text until you see what "^" does.)
int	DEV;
begin
if DEV#PR then [ATTRIB(HELPATT); CHOUT(0, FF);] else OPENO(DEV);
RAWTEXT(DEV, "XED, V1.8  -- IMMEDIATE COMMANDS --
ͻ
        MOVE                                 ADDITIONAL CHARACTERS          
 ^^A  -  Ahead a character             ^^I  -  Tab                            
 ^^Q  -  Back a character              ^^U  -  Indent Under line above        
 ^^N  -  Ahead to Next word            ^^L  -  Form feed (new page)           
 ^^B  -  Back a word                   ^^Z  -  Shift case and move ahead      
 ^^S  -  Ahead a line                  ^^T  -  Display control chars (on/off) 
 ^^W  -  Back a line                   ^^^^  -  Always insert next keystroke   
 ^^J  -  Jump ahead a page (PgDn)                                            
 ^^K  -  Kick back a page (PgUp)              SCOOP                          
 ^^D  -  Ahead to end of text buffer   ^^R  -  Start (or Resume) a scoop-up   
 ^^E  -  Back to start of text buffer  ^^F  -  Finish a scoop-up              
                                      ^^Y  -  Insert scoop and erase it      
Ķ
        DELETE                               COMMAND LINE                   
 BS  -  Back a character (^^H)         Esc -  Enter command-line mode        
 ^^C  -  Back a word                   ^^G  -  Re-execute command line (Go)   
 ^^X  -  Back a line                   ^^V  -  Copy command line into text    
 ^^O  -  Undelete (Oops!)              ^^P  -  Select command line (0-9)      
 DEL -  Forward a character           ^^]  -  Change search case sensitivity 
                                      ^^_  -  Reverse search direction       
ͼ
(^^ = Ctrl key) ");

if DEV#PR then [WAIT;CHOUT(0, FF);if CHAR=ESC then return;]
else [CRLF(DEV);CRLF(DEV);CRLF(DEV);];	\DEV = 2, the printer


RAWTEXT(DEV,"  -- EXTENDED - KEY IMMEDIATE COMMANDS --
ͻ
 F1  -  Last command line           F6  -  Remargin paragraph   
 F2  -  Next command line           F7  -  Display line number  
 F3  -  Toggle line wrap mode       F8  -  Erase scoop register 
 F4  -  Get next buffer from disk   F9  -  Put a marker in text 
 F5  -  Insert scoop register       F10 -  Go to last marker    
Ķ
 ALT - F1  -  Display Help Menu                                  
 ALT - F5  -  Block Insert scoop register                        
 Alt - R     -  Turn on Blocked Text Scoop                       
 Alt - F     -  Capture Blocked Text                             
 Alt - B     -  Toggle Block Graphic Characters                  
Ķ
 Control-Pg Down - Move buffer ahead one line                    
 Control-End     - Move buffer ahead one page                    
Ķ
 INS -  Toggle insert/overwrite                                 
ͼ
Fn = FUNCTION key ");

if DEV#PR then [WAIT;CHOUT(0, FF);if CHAR=ESC then return;]
else [CRLF(DEV);CRLF(DEV);CRLF(DEV);];	\DEV = 2, the printer


RAWTEXT(DEV,"  -- COMMAND-LINE COMMANDS --
ͻ
       DELETE                               SEARCH                       
 D  -  Back a character              S  -  For string (^^W = wild)        
 R  -  Rest of line                  N  -  Entire file (N text buffers)  
 E  -  Erase scoop                   F  -  Find and replace              
 Z  -  Zap back to last form feed    +- -  Forces search forward/back    
 K  -  Kill entire text buffer      ĺ
Ĵ          MISCELLANY                 
       INSERT                        /  -  List help summary on printer  
 I  -  String                        L  -  List text buffer on printer   
 X  -  Scoop                         M  -  Margin (left, right) or (bell)
 H  -  Hex value                     Y  -  Center line                   
                                     V  -  Copy text into command line   
Ĵ J  -  Re-execute command line (Jump)
      FILES                          P  -  Execute any command line (0-9)
 G  -  Get next text buffer          Esc - Command separator             
 A  -  Append from input file        Esc Esc - Execute command line      
 W  -  Write to output file          { } - Enclose a loop                
 O  -  Open input and output files   #   - Execute infinitely            
 C  -  Close output file             ;   - Terminate a loop              
 U  -  Go to DOS                                                         
ͼ
 ");

if DEV#PR then [WAIT;CHOUT(0, FF);if CHAR=ESC then return;]
else [CRLF(DEV);CRLF(DEV);CRLF(DEV);];	\DEV = 2, the printer


RAWTEXT(DEV," MORE: -- COMMAND-LINE COMMANDS --
ͻ
       EXPRESSIONS                          QUIT                          
 () -  Enclose an expression         T  -  Terminate and discard text     
 [] -  Enclose conditional           Q  -  Quit and save text             
 ^^  -  Return ASCII value of char.                                        
 .  -  Return cursor location       Ķ
 @  -  Value of char. under cursor            USES GLOBAL VARIABLE        
 %  -  Value of global variable      BA -  Insert global as ASCII         
 K  -  Value of Keyboard Key         BH -  Insert global as hex           
 Z  -  Value of free space           BD -  Insert global as decimal       
 C  -  Cursor column number          BS -  Display global on status line  
 +- -  Add and subtract                                                   
 */ -  Multiply and divide                                                
 &! -  AND and OR                    BT -  Converts scoop text to decimal 
 \  -  Remainder                     BX -  Converts scoop text to hex     
 <> -  Greater than, less than                                            
 #= -  Not equal, equal              :  -  Move cursor to loc. in global  
 >= -  Greater than or equal         _  -  Set iteration to global        
 <= -  Less than or equal                                                 
 $  -  Hexadecimal constant                                               
ͼ
 ");
if DEV # PR then WAIT
else	CLOSE(DEV);
end;	\HELP

\----------------------------------------------------------------------

proc	DORULER;	\Display normal ruler
\Inputs: LEFTCOL, RIGHTCOL, TICKMARKS
int	I, AT, LM, RM, BL, IN;
begin
ATTRIB(STATATT);
\show the relative position in the file
\AT:= CINX *WIDTH /( (BUFSIZ -(C2INX -CINX)) +1) + LEFTCOL;
AT:= CINX /((BUFSIZ -(C2INX -CINX)) /WIDTH +1) + LEFTCOL;
LM:= PARAMS(LEFTMARGIN);
RM:= PARAMS(RIGHTMARGIN);
BL:= PARAMS(BELLCOL);
IN:= PARAMS(PARAINDENT) +LM;
for I:= LEFTCOL, RIGHTCOL-1 do
	begin
	case I of
	 AT:	CHOUT(6, $02\$DB\);
	 BL:	if PARAMS(WRAPFLAG) then CHOUT(6,$04) else CHOUT(6,^^);
	 IN:	CHOUT(6, ^/);
	 LM,RM:	CHOUT(6, ^|)
	other CHOUT(6, TICKMARKS(I));
	end;
ATTRIB($07);
end;	\SHOWRULER


procedure SHOWRULER;
\Display ruler
int I;
begin
if KEYHIT then return;
CURSOR(0,HEIGHT-3);
if RIGHTCOL<COLMAX then DORULER
else for I:=LEFTCOL, RIGHTCOL-1 do CHOUT(TV,^-);
end;


\----------------------------------------------------------------------

proc	SHOWCMDLINE;	\Display the command line (DBUF, up to DINX)
\Inputs:  DINX, DBUF, DN.
\Outputs: CURH, CURL.
int	I, H, S;
begin
if KEYHIT then return;
H:=0;
CURSOR(0, HEIGHT-2);
ATTRIB($07);			\Set normal attribute
S:=if DINX(DN)>=WIDTH then DINX(DN)-WIDTH else 0;
for I:= S, DINX(DN)-1 do
	begin
	if DBUF(DN,I) < $20 then
		begin
		ATTRIB($70);			\Set inverse attribute
		CHOUT(6, DBUF(DN,I)+$40);
		ATTRIB($07);
		end
	else	CHOUT(6, DBUF(DN,I));
	H:= H +1;
	end;

CURH:= H;   CURL:= HEIGHT-2;		\tell KEYIN where the cursor is
					\ (kludge to help ENTERCMDLINE)
if KEYHIT then return;
while H<WIDTH do			\blank rest of command line
	begin
	CHOUT(6, SP);
	H:= H +1;
	end;
end;	\SHOWCMDLINE

\----------------------------------------------------------------------

proc	SHOWSTATUS;	\Display the status line at the bottom of the screen
\illegal?  CMD: 0   SCOOP: 2000    S#s > ins + REM: 12345   AT: 12345  COL: 123
\WARNINGS: This routine assumes an 80-column screen.
\ If "CMD:" is moved then SELCMD should also be changed.
\Inputs: CINX, C2INX, CURH, DN, XINX, STATCOND.
int	I, J, CH;

	proc	NUMOUT(NUM, SIZE);
	\Display a left-justified number in a field represented by SIZE
	\I.e: a 3-digit field is represented by SIZE = 100.
	int	NUM, SIZE;
	begin
	INTOUT(6, NUM);
	if NUM=0 then NUM:=1;
	while SIZE > NUM do
		[CHOUT(6, SP);
		if NUM>= 1000 then return;	\KLUDGE FOR 16-BIT XPL
		NUM:= NUM *10];
	end;	\NUMOUT


begin	\SHOWSTATUS
if KEYHIT then return;
CURSOR(0, HEIGHT-1);
ATTRIB(STATATT);

for I:= 0, 7 do				\show status message, make sure old
	[CH:= STATCOND(I);		\ message is erased, and don't flicker
	J:= I;
	if CH>=$80 then [CH:= CH & $7F;   I:= 7];
	CHOUT(6, CH)];
for I:= J+1, 10 do CHOUT(6, SP);

TEXT(6, "CMD: ");
NUMOUT(DN, 1000);

TEXT(6, "SCOOP: ");
NUMOUT(XBUFSIZ-XINX, 10000);

if KEYHIT then [ATTRIB($07);return;];
if WIDTH =40 then return;

TEXT(6, "   S");
CHOUT(6, if PARAMS(S1FLAG) then ^= else ^#);
TEXT(6,"s ");
CHOUT(6, if PARAMS(S2FLAG) then $1B else $1A);

if PARAMS(OVERFLAG) then
	begin
	ATTRIB(STATATT ! $80);
	TEXT(6," OVR ");
	ATTRIB(STATATT);
	end
else TEXT(6," ins ");
if BOXMODE=0 then CHOUT(6,$20) else CHOUT(6,BOXCHAR(BOXMODE,5));
TEXT(6, " REM: ");
NUMOUT(C2INX -CINX, 10000);

TEXT(6, "   AT: ");
NUMOUT(CINX, 10000);

TEXT(6, "  COL: ");
NUMOUT(REALCOL, 10000);
if WIDTH>80 then for I:=80,WIDTH-1 do CHOUT(6,$20);
ATTRIB($07);
end;	\SHOWSTATUS

\----------------------------------------------------------------------


procedure SETSTRUC;
\Setup the structure for screen update
begin
WSTRUC(BPTR1):=BUFFER+CINX;
WSTRUC(BPTR2):=BUFFER+C2INX;
WSTRUC(SHOWALL):=PARAMS(SHOWFLAG);
WSTRUC(CURATT):=CURCOLOR;
end;


procedure GETSTRUC;
\Return structure values from screen update
begin
REALCOL:=WSTRUC(BCOLLUM);
CURH:=REALCOL;
LEFTCOL:=WSTRUC(LWIND);
RIGHTCOL:=WSTRUC(RWIND);
end;


proc	DISPLAY;	\Display the edit buffer for current cursor position
int C,H;
\Outputs: LEFTCOL, RIGHTCOL, CURH, CURL

begin	\DISPLAY
SETSTRUC;
SCREEN(WSTRUC);
GETSTRUC;
if CURH = PARAMS(BELLCOL) then CHOUT(TV,BEL);
SHOWRULER;			\(inputs LEFTCOL from DISPLAY)
SHOWSTATUS;

\Replace the block with the character under the cursor:
\CURSOR(if CURH<WIDTH then CURH else WIDTH-1, CURL);
end;	\DISPLAY

\----------------------------------------------------------------------

proc	SETSTAT(STR, FLAG);	\Set status condition
addr	STR, FLAG;		\STR may have 8 characters maximum
\Inputs:  ERRFLAG.
\Outputs: STATCOND, ERRFLAG.
begin
if not ERRFLAG ! not FLAG then	\don't set condition if we already have
	begin			\ an error -- only clear it
	STATCOND:= STR;
	ERRFLAG:= FLAG;
	end;
end;	\SETSTAT

\========================== BASIC COMMANDS ==============================

proc GETCOLLUM;
\calculate current column number
\DISPLAY normally does this, but during macros, display is not updated
int C,H,CLINE,I;
begin
C:= CINX;
while BUFFER(C-1)#CR & C>0 do C:= C-1;
CLINE:= C;
H:= 0;
for I:= CLINE, CINX-1 do
	begin
	if BUFFER(I) = TAB then if not PARAMS(SHOWFLAG) then H:= H ! 7;
	H:= H +1;
	end;
REALCOL:=H;
end;



proc	SAVEPTRS;	\Save edit-buffer pointers in case he screws up.
\Deleted characters reside in the gap and they can be restored simply by
\ restoring the edit pointers. These pointers are saved whenever a command,
\ such as a cursor move, messes up the gap.
begin
SCINX:= CINX;
SC2INX:= C2INX;
end;	\SAVEPTRS



proc	OOPS;		\undo previous deletes (you can also undo this command)
int	T;
begin
\restore pointers back to last saved position
if CINX # SCINX ! C2INX#SC2INX then [CINX:=SCINX; C2INX:=SC2INX;]	
else SETSTAT("nothing?",true);
end;	\OOPS



proc ADDMARGIN(P);
int P,SPS;
\add a margin at point P
begin
SPS:=PARAMS(LEFTMARGIN);
if (CINX+SPS)>=C2INX then [SETSTAT("full",true);return;];
BLIT(BUFFER+P,BUFFER+P+SPS,CINX-P);
CINX:=CINX+SPS;
for P:=P,P+SPS-1 do BUFFER(P):=SP;
end;



proc	WRAPLINE;	\wrap end of current line on to next
int P,C,TABS,SPS;
begin
P:=CINX;
for C:=1,16 do
	begin
	if P<=0 then return;
	P:=P-1;
	if BUFFER(P)=SP then
		begin
		BUFFER(P):=CR;
		ADDMARGIN(P+1);
		return;
		end;
	end;
end;


proc	INSERT(CHAR);	\Insert a char into the edit buffer
int	CHAR;
begin
if CINX <C2INX then			\if there's room...
	begin
	BUFFER(CINX):= CHAR;
	CINX:= CINX+1;
	if PARAMS(OVERFLAG) then
		if C2INX < BUFSIZ & BUFFER(C2INX) # CR & CHAR # CR then C2INX:=C2INX+1;
	if PARAMS(WRAPFLAG) then
	   if CURH>PARAMS(RIGHTMARGIN) then [if CHAR#CR then WRAPLINE;]
		else if CHAR=CR then ADDMARGIN(CINX);		
	SAVEPTRS;
	end
else SETSTAT("full?",true);
end;	\INSERT

\----------------------------------------------------------------------


procedure MOVECUR(LOC);
\Move to location LOC within text buffer
int LOC,SIZE,C;
begin
if LOC > ((BUFSIZ-C2INX) + CINX) then return false;
if LOC = CINX then return true;
if LOC<CINX then
	begin
	SIZE:=CINX - LOC;
	BLIT(BUFFER+LOC,BUFFER+(C2INX-SIZE),SIZE);
	C2INX:=C2INX - SIZE;
	CINX:=LOC;
	end
else
	begin
	SIZE:=LOC-CINX;
	BLIT(BUFFER+C2INX,BUFFER+CINX,SIZE);
	CINX:=CINX+SIZE;
	C2INX:=C2INX+SIZE;
	end;
return true;
end;



proc	DELCHAR;	\Delete back one char
begin
if CINX>0 then
	begin
	CINX:= CINX-1;
	if XFLAG then			\scoop-up buffer is on
		begin
		if XINX<XBUFSIZ then
			begin
			XBUFFER(0,XINX):= BUFFER(CINX);
			XINX:= XINX+1;
			end
		else	begin
			SETSTAT("full?",true);
			CINX:= CINX+1;	\delete failed, undo it
			end;
		end
	end
else SETSTAT("start?",true);
end;	\DELCHAR

proc	DELETE;
\delete or blank depending up over write flag
begin
\if overwrite mode blank with a space
DELCHAR;
if PARAMS(OVERFLAG) then
 if not ERRFLAG & BUFFER(CINX)#CR then [C2INX:= C2INX-1;BUFFER(C2INX):= SP;];
end;


proc DELFOR;	\Delete forward one character
begin
if C2INX<BUFSIZ then C2INX:=C2INX+1
else SETSTAT("end?",true);
end;



proc	DELWORD;	\Delete back one word
int	CH;
begin
repeat	DELCHAR;			\delete all word separators
	CH:=BUFFER(CINX);
until CH#CR & CH#SP & CH#TAB ! ERRFLAG;

loop	begin				\delete the word
	CH:=BUFFER(CINX-1);
	if CH=CR ! CH=SP ! CH=TAB ! ERRFLAG then quit;
	DELCHAR;
	if CINX = 0 then quit;
	end;
end;	\DELWORD



proc	DELLINE;	\Delete back one line
begin
repeat DELCHAR until BUFFER(CINX-1)=CR ! CINX=0 ! ERRFLAG;
end;	\DELLINE			(ERRFLAG? because XREG might be full)



proc	DELALL;		\Delete the entire edit buffer (kill)
begin			\Notice that the scoop is not used here.
CINX:=0;
C2INX:=BUFSIZ;
end;	\DELALL



proc	ZAP;		\Delete back to previous form feed or start
begin			\ (the form feed is not deleted)
repeat DELCHAR until BUFFER(CINX-1)=FF ! CINX=0 ! ERRFLAG;
end;	\ZAP

\----------------------------------------------------------------------

proc	BACKCHAR;	\Move back one char in buffer
begin
DELCHAR;				\Move CINX back, checking for XREG, etc.
if not ERRFLAG then			\if the delete succeeded then...
	begin
	C2INX:= C2INX-1;
	BUFFER(C2INX):= BUFFER(CINX);
	SAVEPTRS;
	end;
end;	\BACKCHAR



proc	BACKWORD;
\Move back to the start of the current word or the previous word
int	CH;
begin
repeat	BACKCHAR;			\back over all word separators
	CH:=BUFFER(CINX);
until CH#CR & CH#SP & CH#TAB ! ERRFLAG;

loop	begin
	CH:=BUFFER(CINX-1);
	if CH=CR ! CH=SP ! CH=TAB ! ERRFLAG then quit;
	BACKCHAR;
	if CINX = 0 then quit;
	end;
end;	\BACKWORD


procedure BACKLX;
\Standard back up a line, handling scoop problems with no limit
repeat BACKCHAR until BUFFER(CINX-1)=CR ! CINX=0 ! ERRFLAG;



proc	BACKLINE;
\Move back to the start of the current line or the previous line
integer LIMIT,SIZE,P,C;
begin
if XFLAG then BACKLX
else
	begin
	if CINX=0 then [SETSTAT("start?",true);return;];
	LIMIT:=if CINX>256 then 255 else CINX-1;
	P:=CINX-1;
	loop [for C:=1,LIMIT do	[if BUFFER(P-1)=CR then quit; P:=P-1;]; quit;];
	SIZE:=CINX-P;
	BLIT(BUFFER+P,BUFFER+(C2INX-SIZE),SIZE);
	C2INX:=C2INX-SIZE;
	CINX:=P;
	SAVEPTRS;
	end;
end;	\BACKLINE


proc	BACKPAGE;	\Move backward one page
int	I;
begin
if BUFFER(CINX-1) # CR then BACKLINE;
for I:=1,HEIGHT-3 do BACKLINE;
end;	\BACKPAGE



proc	BACKALL;	\Move to the beginning of buffer
begin
if XFLAG then repeat BACKCHAR until CINX=0 ! ERRFLAG
else	begin
	BLIT(BUFFER, BUFFER +C2INX -CINX, CINX);
	C2INX:= C2INX - CINX;
	CINX:= 0;
	SAVEPTRS;
	end;
end;	\BACKALL

\----------------------------------------------------------------------

proc	FWDCHAR;	\Move forward one char in buffer
begin
if C2INX<BUFSIZ then
	begin
	BUFFER(CINX):= BUFFER(C2INX);
	CINX:= CINX+1;   C2INX:= C2INX+1;
	if XFLAG then
		if XINX>0 then XINX:= XINX-1
		else XFLAG:=false;
	SAVEPTRS;
	end
else SETSTAT("end?",true);
end;	\FWDCHAR



proc	FWDWORD;	\Move to the start of the next word
\Note: This routine gives an error when moving to an EOF (not just beyond it)
int	CH;
begin
repeat	FWDCHAR;			\Move forward to word separator
	CH:=BUFFER(C2INX);
until CH=CR ! CH=SP ! CH=TAB ! ERRFLAG;

repeat	FWDCHAR;			\Move forward to non-word separator
	CH:=BUFFER(C2INX);
until CH#CR & CH#SP & CH#TAB ! ERRFLAG;
end;	\FWDWORD


procedure FWDLX;
\Do standard line forward, handling scoop and no limit
 repeat FWDCHAR until BUFFER(CINX-1)=CR ! ERRFLAG;


proc	FWDLINE;	\Move to the start of the next line
integer LIMIT,P,SIZE;
begin
if XFLAG then FWDLX
else
	begin
	if C2INX>=BUFSIZ then [SETSTAT("end?",true);return;];
	LIMIT:=if (BUFSIZ-C2INX)>256 then C2INX+255 else BUFSIZ-1;
	loop 
		begin
		for P:=C2INX,LIMIT do if BUFFER(P)=CR then quit;
		P:=P-1;
		quit;
		end;	
	SIZE:=(P+1)-C2INX;
	BLIT(BUFFER+C2INX,BUFFER+CINX,SIZE);
	C2INX:=P+1;
	CINX:=CINX+SIZE;
	SAVEPTRS;
	end;
end;	\FWDLINE



proc	FWDPAGE;	\Move forward one page
int	I;
begin
for I:=1,HEIGHT-3 do FWDLINE;
end;	\FWDPAGE



proc	FWDALL;		\Move to the end of buffer
int	I;
begin
if XFLAG then				\If the X reg was on, it's gone now
	[XINX:=0;   XFLAG:=false];
BLIT(BUFFER +C2INX, BUFFER +CINX, BUFSIZ -C2INX);
CINX:= CINX + BUFSIZ - C2INX;
C2INX:= BUFSIZ;
SAVEPTRS;
end;	\FWDALL

\----------------------------------------------------------------------

proc	COLUMNMOVE(WC);
int	WC,C;
\move cursor forward to column WC
begin
for C:=0,WC-1 do
	begin
	if ERRFLAG then return C;
	case BUFFER(C2INX) of
	TAB: C:=(C ! 7); CR : return C+1 other;
	FWDCHAR;
	end;
return C+1;
end;
  


proc	UPLINE;
\Move back one line to same column
begin
if CINX=0 then [SETSTAT("start",true);return;];
if CURH>256 then [BACKLINE;return;];
if BUFFER(CINX-1) # CR then BACKLINE;
BACKLINE;
if ERRFLAG then return;
if WRKCOL<0 then WRKCOL:=REALCOL;
COLUMNMOVE(WRKCOL);
end;


proc DOWNLINE;
\Move forward one line to same column
begin
FWDLINE;
if WRKCOL<0 then WRKCOL:=REALCOL;
if ERRFLAG then return 1;
if CURH>256 then return WRKCOL+1;
return COLUMNMOVE(WRKCOL);
end;




procedure DISLINES;
\Display the number of lines above cursor
int L,P;
begin
L:=LCOUNT(BUFFER,BUFFER+CINX)+BASELINE;
OPENO(8);
INTOUT(8,L+1);
P:=-1;
repeat [P:=P+1;HEXSTR(P):=CHIN(8);] until HEXSTR(P)=EOF;
if P>0 then HEXSTR(P-1):=HEXSTR(P-1) ! $80 else HEXSTR(0):=$A0;
SETSTAT(HEXSTR,false);
end;



\----------------------------------------------------------------------


proc	DELREST;	\Delete the rest of a line
begin
loop	begin
	if C2INX < BUFSIZ then C2INX:= C2INX +1
	else [SETSTAT("end?", true);   quit];
	if BUFFER(C2INX-1) = CR then quit;
	end;
end;	\DELREST



proc	FLIPCASE;
\Flip the case of the letter at the cursor and move forward
int	CH;
begin
CH:=BUFFER(C2INX);
if C2INX<BUFSIZ & ((CH>=^A & CH<=^Z) ! (CH>=^a & CH<=^z)) then
	begin
	CH:= CH + (if CH >=^a then -$20 else $20);
	BUFFER(C2INX):=CH;
	FWDCHAR;
	end
else	begin
	FWDCHAR;
	SETSTAT("letter?",true);
	end;
end;	\FLIPCASE



proc	LIST;		\List edit buffer on printer
int	C, CH;
begin
OPENO(PR);
FWDALL;
C:= 0;
while C < CINX do
	begin
	CH:= BUFFER(C);
	C:= C+1;

	if CH>=$21 then CHOUT(PR, CH)		\handle most characters
	else	begin
		if PARAMS(SHOWFLAG) then	\show normally hidden ctrl chars
			begin
			if CH = SP then CHOUT(PR, SPIND)
			else	begin
				CHOUT(PR, ^^);	\convert BEL into "^G", etc.
				CHOUT(PR, CH+$40);
				end;
			if CH = CR then CRLF(PR);
			end
		else	if CH = CR then CRLF(PR) else CHOUT(PR, CH);
		end;
	end;
CRLF(PR);				\do not close because of form feed
end;	\LIST

\----------------------------------------------------------------------

proc	XON;		\Turn on scoop (X reg)
begin
XFLAG:= true;
CUTFLAG:=false;
SETSTAT("scoop",false);			\(Show it right away)
end;	\XON



proc	XOFF;		\Turn off scoop (X reg)
begin
XFLAG:= false;
SETSTAT("ok",false);			\(show it right away)
end;	\XOFF



proc	COPYX;		\Copy scoop (X reg) into the edit buffer
\Note that the order of the text in XREG is backwards.
int	X;
begin
XFLAG:=false;				\make sure it's off
X:= XINX;
while X >0 do
	begin
	X:= X-1;
	INSERT(XBUFFER(0,X));
	end;
end;	\COPYX



procedure BLOCKIN;
\Insert X-Register block mode
int X,C,P;
begin
XFLAG:=false;
X:=XINX;
loop
	begin
	loop
		begin
		X:=X-1;
		if XBUFFER(0,X)=CR then
			[if C2INX>=BUFSIZ then INSERT(CR); quit;];
		INSERT(XBUFFER(0,X));
		if X<1 then quit;
		end;
	if X<1 then quit;
	C:=DOWNLINE;
	for P:=C,WRKCOL do INSERT(SP);
	end;
end;



procedure CUTON;
\Turn on text cutting
begin
CUTFLAG:=true;
XFLAG:=false;
SETSTAT("cut",false);
CUTPTR1:=CINX;
CUTCOL1:=REALCOL;
end;



procedure CUTTEXT;
\Cutout a block of text along row/column lines
integer C1,C2,P1,P2;
begin
if not CUTFLAG then return;
CUTFLAG:= false;
SETSTAT("ok",false);

CUTPTR2:=CINX;
if CUTPTR1=CUTPTR2 then return;

CUTCOL2:=REALCOL;
if CUTPTR1>CUTPTR2 then [P1:=CUTPTR2; P2:=CUTPTR1;]
		else [P1:=CUTPTR1; P2:=CUTPTR2;];
if CUTCOL1>CUTCOL2 then [C1:=CUTCOL2; C2:=CUTCOL1;]
		else [C1:=CUTCOL1; C2:=CUTCOL2;];

MOVECUR(P2);
repeat
	begin
	GETCOLLUM;
	XFLAG:=REALCOL>C1 & REALCOL<=C2 ! BUFFER(CINX-1)=CR;
	BACKCHAR;
	end
until CINX=P1;
XFLAG:=false;
end;


\----------------------------------------------------------------------

func	INHEX(D);	\Insert literal hex value
int	D;
int	H;


	func	HEX(CH);	\Return the hex value
	int	CH;		\hex digit in ASCII
	begin
	case of
	  CH>=^0 & CH<=^9:	return CH-$30;
	  CH>=^A & CH<=^F:	return CH-$37;
	  CH>=^a & CH<=^f:	return CH-$57
	other SETSTAT("hex?",true);
	end;	\HEX


begin	\INHEX
H:= HEX(DBUF(DN,D));
H:= H*$10 + HEX(DBUF(DN,D+1));
if not ERRFLAG then INSERT(H);

return D +2;				\return index to next command
end;	\INHEX



func	INSTRING(D);	\Insert a string
int	D;		\index into DBUF points to string
int	CH;
begin
loop	begin
	CH:= DBUF(DN,D);
	if CH = ESC then return D;	\return index to next command
	INSERT(CH);
	D:= D +1;
	end;
end;	\INSTRING

\----------------------------------------------------------------------

func	SEARCH(D);	\Forward search edit buffer for string.
int	D;		\Index of first string character on command line (DBUF)
			\Returns index to next command (failed or not)
\Inputs: DBUF, DN, CINX, C2INX
int	CH1, S1F, SP;
int	I, C, T;


func	LOWER(CH);	\Shift to lowercase if PARAMS(S1FLAG) is true
int	CH;
begin
if S1F then
	if CH>=^A & CH<=^Z then
		return CH ! $20;
return CH;
end;	\LOWER



proc	FWDSEARCH;	\Forward search edit buffer for string.
begin
C:= C2INX+SP;				\start searching from the cursor
T:=0;
I:= SP;					\point to first char in string
loop	begin
	case SSTR(I) of
	  WILDCH, LOWER(BUFFER(C+T)):
		begin			\it matches
		I:= I+1;		\try next string character
		T:= T+1;
		if SSTR(I) = ESC then	\the entire string matches
			begin
			C:= C +T;		\point to end of string
			if C > BUFSIZ then	\(ignore garbage beyond buffer)
				[SETSTAT("none?",true);   quit];

			\Move cursor forward to end of matching string:
			BLIT(BUFFER +C2INX, BUFFER +CINX, C -C2INX);
			CINX:= CINX + C -C2INX;
			C2INX:=C;
			SAVEPTRS;
			quit;
			end;
		end
	other	begin			\it doesn't match
		C:= C +1;		\move forward in edit buffer
		if C >= BUFSIZ then	\all done? then not found
			[SETSTAT("none?",true);   quit];

		\Fast scan for first character (CH1):
		\Wild characters are ignored
		loop	begin
			if S1F then	\if s = S then
			    for C:= C, BUFSIZ do
				[if (BUFFER(C) ! $20) = CH1 then quit]
				\(good candidate -- it's rechecked above)
			else
			    for C:= C, BUFSIZ do
				if BUFFER(C) = CH1 then quit;
			quit;		\quit if end of buffer
			end;

		I:= SP;			\point to first char in string
		T:=0;
		end;
	end;	\LOOP
end;	\FWDSEARCH



proc	BACKSEARCH;	\Backward search edit buffer for string.
begin
C:= CINX -I -1;			\searching from the cursor - string length -1
I:= SP;					\point to first char in string
T:=0;
loop	begin
	case SSTR(I) of
	  WILDCH, LOWER(BUFFER(C+T)):
		begin			\it matches
		I:= I+1;		\try next string character
		T:= T+1;
		if SSTR(I) = ESC then	\the entire string matches
			begin
			if (C-SP) < 0 then	\(ignore garbage in front of buffer)
				[SETSTAT("none?",true);   quit];
			C:= C +T;		\point to end of string

			\Move cursor backward to end of matching string:
			BLIT(BUFFER+C, BUFFER+C2INX-(CINX-C), CINX-C);

			C2INX:= C2INX -(CINX -C);
			CINX:= CINX -(CINX -C);
			SAVEPTRS;
			quit;
			end;
		end
	other	begin			\it doesn't match
		C:= C -1;		\move backward in edit buffer
		if C < 0 then		\all done? then not found
			[SETSTAT("none?",true);   quit];

		\Fast scan for first character (CH1):
		\Wild characters are ignored
		\-C is a trick to fake: "for C:= C downto 0"
		loop	begin
			if S1F then	\if s = S then
			    for C:= -C, 0 do
				[if (BUFFER(-C) ! $20) = CH1 then quit]
				\(good candidate -- it's rechecked above)
			else
			    for C:= -C, 0 do
				if BUFFER(-C) = CH1 then quit;
			quit;		\quit if start of buffer
			end;
		C:= -C;			\get positive C
		I:= SP;			\point to first char in string
		T:=0;
		end;
	end;	\LOOP
end;	\BACKSEARCH



begin	\SEARCH
\Check for null string (no can handle)
if DBUF(DN,D) = ESC then [SETSTAT("null?",true);   return D];

S1F:= PARAMS(S1FLAG);
I:=0; SP:=-1;
loop	begin
	SSTR(I):= LOWER(DBUF(DN,D));		\work with a copy of the string
	if SSTR(I) = ESC then quit;
	if SSTR(I)#WILDCH then if SP<0 then SP:=I;	\find first non-wild card
	I:= I +1;
	D:= D +1;
	end;
\handle string with all wild cards
if SP=-1 then SP:=0;

CH1:= SSTR(SP);
if S1F then CH1:= CH1 ! $20;
if PARAMS(S2FLAG) then BACKSEARCH else FWDSEARCH;
return D;
end;	\SEARCH



procedure XSEARCH(C,D);
\Do search, change direction based upon C
int C,D;
begin
case C of
^+: PARAMS(S2FLAG):=false;
^-: PARAMS(S2FLAG):=true
other;
return SEARCH(D);
end;



proc	REPLACE(D);	\Replace one string with another
int	D;
int	DX,C;
begin
DX:=SEARCH(D);			\Find string
if ERRFLAG then
	begin
	repeat DX:=DX+1 until DBUF(DN,DX)=ESC;
	return DX;
	end;
for C:=1,DX-D do DELCHAR;	\Delete it
DX:=INSTRING(DX+1);		\Replace it
return DX;
end;

\----------------------------------------------------------------------

proc	INDENT;		\Indent current line same as the preceding one
int	COL,		\The column number to indent to
	C,		\temporary index into text buffer
	TABS, SPS,	\number of tabs and spaces to insert
	I;		\scratch
begin
\Move to the beginning of the previous line:
if BUFFER(CINX-1) = CR then BACKLINE
else	[BACKLINE;   BACKLINE];

\Move the column counter according to the previous line's leading tabs
\ and spaces. (If the cursor was on the first line in the buffer, then
\ COL = 0)
TABS:=0;SPS:=0;
if not ERRFLAG then			\it was not on the first line
	begin				\count the number of columns the
	C:=C2INX;			\ previous line is indented
	loop	begin
		case BUFFER(C) of
		  SP:	SPS:= SPS + 1;
		  TAB:	TABS:=TABS + 1
		other quit;
		C:= C+1;
		end;

	\Move back to the beginning of the current line
	FWDLINE;
	end
else SETSTAT("ok",false);

\Delete all initial tabs and spaces on the current line:
loop	begin
	case BUFFER(C2INX) of
	  SP, TAB: if C2INX < BUFSIZ then [FWDCHAR;   DELCHAR] else quit
	other quit;
	end;

\Insert tabs and spaces to move to the column determined above
for I:=1,TABS do INSERT(TAB);
for I:=1,SPS do INSERT(SP);
\(leave cursor at the first displayable character)
end;	\INDENT



proc	CENTER;		\Center the current line between margins
int	COL,		\The column number to indent to
	C,		\temporary index into text buffer
	TABS, SPS,	\number of tabs and spaces to insert
	I;		\scratch
begin
\Move to the beginning of the line:
if BUFFER(CINX-1)#CR & CINX>0 then BACKLINE;

\Delete all initial tabs and spaces on the line:
loop	begin
	case BUFFER(C2INX) of
	  SP, TAB: if C2INX < BUFSIZ then [FWDCHAR;   DELCHAR] else quit
	other quit;
	end;

\Count the number of printable characters remaining on the line:
C:= C2INX;
COL:= 0;
loop	begin
	if BUFFER(C)=CR ! C>=BUFSIZ then quit;
	if BUFFER(C) >= SP & BUFFER(C) <= $7E then COL:= COL +1;
	C:= C +1;
	end;

\Calculate amount to indent line:
COL:= (PARAMS(RIGHTMARGIN) -PARAMS(LEFTMARGIN) -COL +1) /2;

\Insert tabs and spaces:
SPS:= COL;
for I:=1,SPS do INSERT(SP);
\(leave cursor at the first displayable character)
end;	\CENTER

\----------------------------------------------------------------------


procedure DROPMARK;
\Save a marker of the current location
begin
MARKER(MRKPTR1):=CINX;
MRKPTR2:=MRKPTR1;
MRKPTR1:=if MRKPTR1>=MAXMARK-1 then 0 else MRKPTR1+1;
end;



procedure LASTMARK;
\Move cursor to last location
begin
if not MOVECUR(MARKER(MRKPTR2)) then SETSTAT("range?",true);
MRKPTR2:=if MRKPTR2<=0 then MAXMARK-1 else MRKPTR2-1;
end;

\----------------------------------------------------------------------

procedure DOMARGIN;
\Do actual remargining
int
	WT,		\hold wrap mode
	OT,		\hold overwrite flag
	COL,		\column
	I,		\scratch
	TABS,		\number of tabs
	SPS;		\number of spaces
begin
WT:=PARAMS(WRAPFLAG);		\wrap mode must be off
PARAMS(WRAPFLAG):=false;
OT:=PARAMS(OVERFLAG);		\overwrite must be off
PARAMS(OVERFLAG):=false;


if CINX>0 then BACKCHAR;		\(margin back)

\Move to the end of the paragraph (2 CR's or end of buffer):
loop	begin
	if C2INX >= BUFSIZ then quit;
	if BUFFER(C2INX) = CR then
		begin
		FWDCHAR;
		if BUFFER(C2INX)=CR ! C2INX>=BUFSIZ then
			[BACKCHAR;   BACKCHAR;   quit];
		end;
	FWDCHAR;
	end;
	\C2INX points to the last letter of the paragraph
SETSTAT("ok",false);		\(in case there are 2 CR's at the beginning)

\Move to the start of the paragraph replacing CR's and tabs with spaces:
loop	begin
	if BUFFER(C2INX) = TAB then BUFFER(C2INX):= SP;
	if BUFFER(C2INX) = CR then
		begin
		if CINX<=0 then [FWDCHAR;   quit];
		BACKCHAR;
		if BUFFER(C2INX)=CR then [FWDCHAR;   FWDCHAR;   quit];
		FWDCHAR;
		BUFFER(C2INX):= SP;
		end;
	if CINX<=0 then quit;
	BACKCHAR;
	end;
SETSTAT("ok",false);

\Move to the end of the paragraph deleting multiple spaces:
while BUFFER(C2INX) = SP do		\delete any spaces at the beginning
	[FWDCHAR;   DELCHAR];
loop	begin
	if BUFFER(C2INX) = SP then
		begin
		FWDCHAR;
		while BUFFER(C2INX) = SP do
			[FWDCHAR;   DELCHAR];
		end;
	if BUFFER(C2INX)=CR ! C2INX>=BUFSIZ then quit;
	FWDCHAR;
	end;
SETSTAT("ok",false);

\Move to the start of the paragraph (now only one line long):
BACKLX;
SETSTAT("ok",false);

COL:= PARAMS(LEFTMARGIN) +PARAMS(PARAINDENT);	\the first line can be indented
loop	begin
	\insert tabs and spaces to get to the left margin:

	SPS:= COL;
	for I:=1,SPS do INSERT(SP);
	INSERT(CR);			\insert a fake CR to mark our place
	\(This is required if we have a word longer than a line and we are
	\ are indenting with spaces.)

	\Move to the right margin +1:
	loop	begin
		if COL > PARAMS(RIGHTMARGIN) then quit;
		FWDCHAR;		\(sets ERRFLAG at end of buffer)
		if BUFFER(C2INX) = CR ! ERRFLAG then	\all done
			begin
			SETSTAT("ok",false);		\in case of ERRFLAG
			BACKLX;			\back up to fake CR
			DELCHAR;			\eat it
			FWDLX;			\move to new line
			FWDCHAR;
			PARAMS(WRAPFLAG):=WT;	\restore wrap mode
			PARAMS(OVERFLAG):=OT;	\restore overwrite
			return;
			end;

		if BUFFER(C2INX) >= $20 & BUFFER(C2INX) <= $7E then
			COL:= COL +1;	\don't count ctrl chars
		end;

	\Move back to previous space and replace it with a CR:
	loop	begin
		if BUFFER(C2INX) = SP then
			[BUFFER(C2INX):= CR;   quit];

		\Deal with case where a word is longer than a line:
		if BUFFER(C2INX) = CR then	\(our fake CR)
			repeat	begin
				FWDCHAR;
				if BUFFER(C2INX) = SP then
					[BUFFER(C2INX):= CR;   quit];
				if BUFFER(C2INX) = CR ! ERRFLAG then quit;
				end;
			until false;
		BACKCHAR;
		if ERRFLAG then quit;
		end;

	if ERRFLAG then quit;
	BACKLX;			\back up to fake CR
	DELCHAR;			\eat it
	FWDLX;			\move to new line
	COL:= PARAMS(LEFTMARGIN);
	end;
PARAMS(WRAPFLAG):=WT;		\restore wrap mode
PARAMS(OVERFLAG):=OT;		\restore overwrite
end;	\DOMARGIN



func	MARGIN(D);	\Re-margin paragraph (or get bell column)
int	D;		\index to arguments (if any)
int	LM, RM,		\left & right margin columns
	BELLFLAG;	\this is a bell set command (not a margin)


	func	NUMIN;
	\Get positive integer from command line and return its value
	\Also moves D to the char terminating the number
	int	NUM, CH;
	begin
	NUM:= 0;
	CH:= DBUF(DN,D);
	while CH = SP do		\Eat leading spaces
		begin
		D:= D+1;
		CH:= DBUF(DN,D);
		end;
	while CH>=^0 & CH<=^9 do
		begin
		NUM:= NUM *10 + (CH -^0);
		if NUM < 0 then [SETSTAT("number?",true);   return 0];
		D:= D+1;
		CH:= DBUF(DN,D);
		end;
	return NUM;
	end;	\NUMIN


	proc GETARGS;
	\Get arguments to margin command
	begin				\we have arguments -- go get 'em
	if DBUF(DN,D)=^( then D:= D +1;	\parentheses are optional
	LM:= NUMIN;			\get the new left margin column
	BELLFLAG:= false;		\assume it is not a bell setting
	if DBUF(DN,D)=^, ! DBUF(DN,D)=SP then [D:= D +1;   RM:= NUMIN]
	else BELLFLAG:= true;
	if DBUF(DN,D)=^, ! DBUF(DN,D)=SP then
		[D:= D +1;   PARAMS(PARAINDENT):= NUMIN];
	if DBUF(DN,D)=^) then D:= D +1;	\parentheses are optional
	if BELLFLAG then		\only one argument means set bell
		[PARAMS(BELLCOL):= LM;   return D+1];	\ and we're done
	PARAMS(LEFTMARGIN):= LM;	\set new left and right margin columns
	PARAMS(RIGHTMARGIN):= RM;
	end;	\GETARGS


begin	\MARGIN
if DBUF(DN,D)>= ^0 & DBUF(DN,D)<= ^9 ! DBUF(DN,D)=^( then [GETARGS; return D;];
DOMARGIN;
return D;
end;	\MARGIN



proc	CONSETUP;
\Setup to Interpret the text in XREG as a number
\Note that the order of the text in XREG is backwards.
int	P,C;
def XMAX=80;
begin
OPENO(8);
C:=if XINX<XMAX then XINX else XMAX;
for P:=-(C-1),0 do CHOUT(8,XBUFFER(0,-P));
CHOUT(8,CR);
end;	\CONSETUP



proc	CONX2DEC;
\Interpret the text in XREG as a decimal number
begin
CONSETUP;
GLOBAL:=INTIN(8);
end;	\CONX2DEC



proc	CONX2HEX;
\Interpret the text in XREG as a hex number
begin
CONSETUP;
GLOBAL:=HEXIN(8);
end;	\CONX2DEC


proc DISHEX;
\display GLOBAL as hex on command line
int P;
begin
OPENO(8);
HEXOUT(8,GLOBAL);
for P:=0,3 do HEXSTR(P):=CHIN(8);
HEXSTR(3):=HEXSTR(3) ! $80;
SETSTAT(HEXSTR,false);
end;


proc DECINS;
\insert GLOBAL as hex string
int C;begin
OPENO(8);
INTOUT(8,GLOBAL);
loop [C:=CHIN(8);if C=EOF then quit;INSERT(C);];
end;


proc HEXINS;
\insert GLOBAL as hex string
int C;begin
OPENO(8);
HEXOUT(8,GLOBAL);
loop [C:=CHIN(8);if C=EOF then quit;INSERT(C);];
end;



proc GLOBCOM(D);
\commands display or insert GLOBAL
int D;
begin
case DBUF(DN,D) of
	^X,^x: CONX2HEX;
	^T,^t: CONX2DEC;
	^S,^s: DISHEX;
	^A,^a: INSERT(GLOBAL);
	^D,^d: DECINS;
	^H,^h: HEXINS
else;
return D+1;
end;

\============================ I/O COMMANDS ==============================


proc GOTODOS;
\call comspec and go to DOS
char COMSPEC,CSTR;
int P1,P2;
seg char ENV;

	procedure FINDSPEC;
	\find the compsec
	int P1,P2,F1,F2;
	begin
	F2:=false; P2:=0;
	for P1:=0,32766 do
		begin
		F1:=F2;	F2:=ENV(0,P1)=0;
		if F1 & F2 then return -1;
		if (CSTR(P2) & $7F) = ENV(0,P1) then
			[if CSTR(P2)>$7F then return P1+1; P2:=P2+1;]
		else P2:=0;
		end;
	return -1;
	end;


	procedure SETSPEC;
	\Setup comspec
	begin
	P1:=FINDSPEC;
	if P1<0 then COMSPEC:="COMMAND.COM"
	else for P2:=0,79 do [COMSPEC(P2):=ENV(0,P1+P2);
			     if COMSPEC(P2)=0 then return;];
	end;

begin
CSTR:="COMSPEC=";
COMSPEC:=RESERVE(80);
ENV:=RESERVE(2);
ENV(0):=PEEK(PSPSEG,$2C) ! SWAP(PEEK(PSPSEG,$2D));
SETSPEC;
POKE(PSPSEG,$80,0);
RESTCUR;
CHOUT(0,FF);
TEXT(0,"Going to DOS, Type: EXIT to return to XED");CRLF(0);
CHAIN(COMSPEC);
SAVECUR;
CURSOFF;
CHOUT(0,FF);
end;


procedure ABANDON;	\abandon input and output files
begin
if HAVEINFILE then FCLOSE(INHAND);
FCLOSE(OUTHAND);
CPUREG(\AX\0):= $4100;			\DEL OUTFILE.$$$
CPUREG(\DS\9):= DATASEG;
CPUREG(\DX\3):= OUTTEMP;
SOFTINT($21);
end;


proc	COPYNAME(FROM, TO, EXT);
\Copy file name from FROM to TO and replace any existing extention with EXT
addr	FROM, TO,	\Strings are terminated by 0 and must be <= NAMESIZE long
	EXT;		\Extension started with "." and terminated with an
			\ unused char with MSB set
int	I, J, CH;
begin
I:= 0;
loop	begin
	CH:= FROM(I);
	if CH=^. ! CH=0 then quit;
	TO(I):= CH;
	if I < NAMESIZE-1 then I:= I +1;
	end;
for J:= 0, 3 do
	begin
	TO(I):= EXT(J);
	if I < NAMESIZE-1 then I:= I +1;
	end;
TO(I):= 0;
end;	\COPYNAME



proc	OPENALL;	\Open input and files based on OUTFILE and INFILE
int P;
begin
if OUTFILE(0) =0 then			\if no outfile then use the infile
	for P:= 0, NAMESIZE-1 do
		OUTFILE(P):= INFILE(P);
COPYNAME(OUTFILE, OUTTEMP, ".$$$ ");	\set up other output file names
COPYNAME(OUTFILE, OUTBACK, ".BAK ");

TRAP(false);
INHAND:= FOPEN(INFILE, 0);		\get input and output handles
HAVEINFILE:= GETERR =0;
\if no input file then set flag so we don't attempt to read from it

OUTHAND:= FOPEN(OUTTEMP, 1);
if GETERR #0 then return false;
TRAP(true);
if HAVEINFILE then FSET(INHAND, ^I);
FSET(OUTHAND, ^O);
return true;
end;


proc	DOSOPEN;	\Routine to open MS-DOS files
int	INX;		\index into TAIL
addr	TAIL, TLEN;


	procedure GETSWT;
	\Find, remove and return switches
	integer P,T;
	begin
	for P:=0,TLEN(0) do if TAIL(P)=^/ then
		begin
		TAIL(P):=$20;
		if P<TLEN(0) then [T:=TAIL(P+1); TAIL(P+1):=$20; return T;];
		end;
	return 0;
	end;


	procedure DOSWITCH;
	\Handle switches on the command line
	begin
	STRIPFLAG:=true;
	loop case GETSWT of
		^L,^l: STRIPFLAG:=false
		other quit;
	end;


	procc	GETNAME(NAME);
	\Inputs: INX, TAIL, NAMESIZE
	addr	NAME;
	int	I, CH;
	begin
	while TAIL(INX) =SP do INX:= INX +1;
	I:= 0;
	repeat	CH:= TAIL(INX);
		INX:= INX +1;
		if CH=SP ! CH=CR then CH:= 0;	\terminate NAME with 0
		NAME(I):= CH;
		if I < NAMESIZE-1 then I:= I +1;
	until CH =0;
	end;	\GETNAME

begin	\DOSOPEN
TLEN:= RESERVE(80);			\get command tail from PSP
TAIL:= TLEN +1;
BLITX(PSPSEG, $80, DATASEG, TLEN, 79);
if TLEN(0)>79 then TLEN(0):= 79;

DOSWITCH;

INX:= 0;
GETNAME(INFILE);			\fatal error if no file specified
if INFILE(0) =0 then
	begin
	CHOUT(0,FF);
	TEXT(0, "No output file specified");
	CRLF(0);
	exit;
	end;;

INX:= INX -1;
GETNAME(OUTFILE);
if not OPENALL then [CHOUT(0,FF);TEXT(0, "Bad output file");CRLF(0);exit;];
end;	\DOSOPEN



proc	DOSCLOSE;	\Close MS-DOS files
begin
TRAP(false);
FCLOSE(OUTHAND);
if HAVEINFILE then FCLOSE(INHAND);

CPUREG(\AX\0):= $4100;			\DEL OUTFILE.BAK
CPUREG(\DS\9):= DATASEG;
CPUREG(\DX\3):= OUTBACK;
SOFTINT($21);				\(.BAK file might not exist)

CPUREG(\AX\0):= $5600;			\REN OUTFILE.EXT OUTFILE.BAK
CPUREG(\DS\9):= DATASEG;
CPUREG(\DX\3):= OUTFILE;
CPUREG(\ES\11):= DATASEG;
CPUREG(\DI\4):= OUTBACK;
SOFTINT($21);

CPUREG(\AX\0):= $5600;			\REN OUTFILE.$$$ OUTFILE.EXT
CPUREG(\DS\9):= DATASEG;
CPUREG(\DX\3):= OUTTEMP;
CPUREG(\ES\11):= DATASEG;
CPUREG(\DI\4):= OUTFILE;
SOFTINT($21);
TRAP(true);
if GETERR then SETSTAT("disk ?",true);
end;	\DOSCLOSE

\----------------------------------------------------------------------

proc	OPENFILES;	\Open the files
begin
DOSOPEN;		\open MS-DOS files
TRAP(false);
if HAVEINFILE then OPENI(3);
OPENO(3);
BASELINE:=0;
TRAP(true);
if GETERR then SETSTAT("disk ?",true);
EOFFLAG:= ~HAVEINFILE;
end;	\OPENFILES


proc	REWIND;		\rewind files
int X;
begin
TRAP(false);
if HAVEINFILE then OPENI(3);
OPENO(3);
BASELINE:=0;
TRAP(true);
if GETERR then SETSTAT("disk ?",true) else EOFFLAG:= ~HAVEINFILE;
end;


proc	OCMD(D);	\Handle "O" command
int D,P;
begin
if DBUF(DN,D)=^" & D<DINX(DN) then
	begin
	P:=0;
	loop 
		begin
		D:=D+1;
		if D > DINX(DN) then [SETSTAT("no ^"",true); return D;];
		INFILE(P):=DBUF(DN,D);
		if INFILE(P)=^" then [INFILE(P):=0;quit;];
		P:=P+1;
		if P>=NAMESIZE	! D > DINX(DN) then [SETSTAT("no ^"",true); return D;];
		end;
	D:=D+1;
	REWIND;
	ABANDON;
	OUTFILE(0):=0;
	if not  OPENALL then [SETSTAT("disk-o?",true);return D;];
	TRAP(false);
	if HAVEINFILE then OPENI(3);
	OPENO(3);
	BASELINE:=0;
	TRAP(true);
	if GETERR then SETSTAT("disk ?",true);
	EOFFLAG:= ~HAVEINFILE;
	end
else REWIND;
return D;
end;


proc	APPEND;		\Append input file to edit buffer
int	CH, LIMIT,T;
def	LLIMIT=256;	\Limit looking for last CR

	procedure NOSTRIP;
	\read file, leaving Line Feeds
	int P;
	begin
	for CINX:=CINX,LIMIT do		\read first part of file fast
			begin
			CH:= CHIN(3);
			case of
			GETERR: [SETSTAT("disk i?",false); TRAP(true); return;];
			CH=EOF:	[EOFFLAG:= true; SETSTAT("eof",false);
				TRAP(true); return;]
			other;		
			BUFFER(CINX):= CH;
			end;
	for P:=1,LLIMIT do	\Read last part, looking for CR to stop on
		begin
		if CINX >= C2INX then [SETSTAT("full?",true); return];
		CH:= CHIN(3);
		case of
		CH=EOF: [EOFFLAG:= true; SETSTAT("eof",false); return];
		GETERR: [SETSTAT("disk-i?",true);return;]
		other;
		BUFFER(CINX):= CH; CINX:= CINX+1;
		if CH = CR then return;	\stop at the end of a line
		end;
	end;




	procedure DOSTRIP;
	\read file, stripping out Line Feeds
	int P;
	begin
	for CINX:=CINX,LIMIT do		\read first part of file fast
			begin
			repeat CH:= CHIN(3) until CH # LF;
			case of
			GETERR: [SETSTAT("disk i?",false); TRAP(true); return;];
			CH=EOF:	[EOFFLAG:= true; SETSTAT("eof",false);
				TRAP(true); return;]
			other;		
			BUFFER(CINX):= CH;
			end;
	for P:=1,LLIMIT do	\Read last part, looking for CR to stop on
		begin
		if CINX >= C2INX then [SETSTAT("full?",true); return];
		repeat CH:= CHIN(3) until CH # LF;
		case of
		CH=EOF: [EOFFLAG:= true; SETSTAT("eof",false); return];
		GETERR: [SETSTAT("disk-i?",true);return;]
		other;
		BUFFER(CINX):= CH; CINX:= CINX+1;
		if CH = CR then return;	\stop at the end of a line
		end;
	end;


begin
T:=if PAD>(XINX+1024) then PAD else XINX+1024;
LIMIT:= C2INX -T;
TRAP(false);

if EOFFLAG then SETSTAT("eof?",true)
else if STRIPFLAG then DOSTRIP else NOSTRIP;

SAVEPTRS;
TRAP(true);
end;	\APPEND



procedure WRITE2CURSOR;	\Write chars from start to cursor
int	I, CH;
begin
BASELINE:=BASELINE+LCOUNT(BUFFER,BUFFER+CINX);
TRAP(false);
for I:= 0, CINX-1 do
	begin
	CH:= BUFFER(I);
	CHOUT(3, CH);
	if CH = CR then
	if GETERR then
		begin
		SETSTAT("disk-o?",true);
		TRAP(true);
		return false;
		end
	else  CHOUT(3, LF);
	end;
TRAP(true);
return true;
end;


proc	WRITEBUF;	\Write the edit buffer to the output disk file
begin
if not CLOSFLAG then
	begin
	FWDALL;
	WRITE2CURSOR;
	end
else SETSTAT("closed?",true);
end;	\WRITEBUF



proc	NEXTBUF;	\Get next buffer-full (ESC-G)
begin
WRITEBUF;
if not ERRFLAG then
	begin
	DELALL;
	APPEND;
	end;
end;	\NEXTBUF



proc	SHUFFLE(N);	\Read and Write N line into and out of editor
int	N, CH, C;

	procedure MOVELINES;
	\Write and delete first line, read in last line
	int P;
	begin
	XFLAG:=false;
	CUTFLAG:=false;
	BACKALL;
	FWDLINE;
	WRITE2CURSOR;
	CINX:=0;
	FWDALL;	
	P:=0;
	loop		\Read last part, looking for CR to stop on
		begin
		if CINX >= C2INX then [SETSTAT("full?",true); quit];
		repeat CH:= CHIN(3) until CH # LF;
		case of
		CH=EOF: [EOFFLAG:= true; SETSTAT("eof",false); quit];
		GETERR: [SETSTAT("disk-i?",true);quit;]
		other;
		BUFFER(CINX):= CH; CINX:= CINX+1; P:=P +1;
		\stop at the end of a line or at limit
		if CH = CR ! P>256 then quit;
		end;
	end;

begin
TRAP(false);
C:=1;
loop
	begin
	if EOFFLAG then [SETSTAT("eof?",true); quit;];
	MOVELINES;
	C:=C+1;
	if C>N then quit;
	end;
SAVEPTRS;
TRAP(true);
end;	\SHUFFLE



func	BUFSEARCH(D);	\Forward search N buffers for string
int	D;
int	DX, S2F;
begin
S2F:= PARAMS(S2FLAG);			\Save current search direction
PARAMS(S2FLAG):= false;			\Set to forward search
loop	begin
	DX:= SEARCH(D);
	if ERRFLAG then			\We didn't find it in this buffer
		begin
		if not EOFFLAG then
			[SETSTAT("ok",false);	\clear ERRFLAG from search
			NEXTBUF;
			SETSTAT("ok",false);	\clear possible eof flag
			BACKALL]
		else quit;		\(leaves last buffer in memory)
		end
	else quit;			\found it, stop looking
	end;
PARAMS(S2FLAG):= S2F;			\Restore search direction
return DX;				\return index to next command
end;	\BUFSEARCH



proc	QUIT;		\Output the buffer and remaining input file to disk
int	CH;
begin
if not CLOSFLAG then			\save file to disk
	begin
	WRITEBUF;
	if ERRFLAG then return;			\no exit if any error
	if not EOFFLAG then			\if we haven't encountered an EOF
		begin				\ shuffle the in file to the out file
		TRAP(false);
		CH:= CHIN(3);
		if CH # LF then CHOUT(3,CH);	\first char cannot be LF
		loop	begin
			CH:= CHIN(3);
			if CH = EOF then quit;
			if GETERR then [SETSTAT("disk ?",true);	TRAP(true);return;];
			CHOUT(3, CH);
			end;
		EOFFLAG:= true;			\(in case we don't exit)
		end;
	CHOUT(3,EOF);
	CLOSE(3);
	TRAP(true);
	CLOSFLAG:= true;
	DOSCLOSE;
	end;
CHOUT(0, FF);
RESTCUR;
exit;
end;	\QUIT



proc	TERMINATE;	\Terminate editor and Trash output file
int T;
begin
TRAP(false);		\Ignore errors here
ABANDON;
TRAP(true);
T:=GETERR;
CHOUT(0, FF);
RESTCUR;
ABORT;
end;	\TERMINATE


\======================= EXPRESSION EVALUATIOR ==========================


procedure GETCH;
begin
if EPTR >= DINX(DN) then 
	begin
	SETSTAT("expr?",true);
	CHAR:=^);
	end
else
	begin
	CHAR:=DBUF(DN,EPTR);
	EPTR:= EPTR +1;
	end;
end;



proc	SKIPTAB;	\Skip tabs and spaces in LINEBUF
begin
while CHAR=TAB ! CHAR=SP do GETCH;
end;	\SKIPTAB



proc	GETCHX;		\Get next character, ignoring any space characters
begin
repeat GETCH until CHAR#SP;
end;	\GETCHX



procedure UNDERC;
\GET CHARACTER UNDER CURSOR
int VAL;
begin
if C2INX<BUFSIZ then VAL:=BUFFER(C2INX)
else [SETSTAT("end?",true);VAL:=0;];
GETCH;
return VAL;
end;


procedure GETASCI;
int VAL;
begin
GETCH;
VAL:=CHAR;
GETCH;
return VAL;
end;


func	GETDEC;
\Read in a decimal string and return its value
\Terminate on first non-numer
int	VAL;
begin
VAL:= CHAR -^0;
GETCH;
if CHAR>=^a & CHAR<=^z then CHAR:=CHAR-$20;	\shift to uppercase
loop	begin
	if CHAR<^0 ! CHAR>^9 then quit;
	VAL:= VAL *10 +CHAR -^0;
	GETCH;
	end;
return VAL;
end;	\GETDEC



func	GETHEX;		\Return the value of a hex string, e.g: $1AC4
int	VAL, I;
begin
GETCH;					\Skip the "$"
if CHAR>=^a & CHAR<=^z then CHAR:=CHAR-$20;
case of
  CHAR>=^0 & CHAR<=^9: VAL:= CHAR-^0;
  CHAR>=^A & CHAR<=^F: VAL:= CHAR-$37
other [SETSTAT("hex?",true); return 0];
loop	begin
	GETCH;
	if CHAR>=^a & CHAR<=^z then CHAR:=CHAR-$20;
	case of
	  CHAR>=^0 & CHAR<=^9: I:= CHAR-^0;
	  CHAR>=^A & CHAR<=^F: I:= CHAR-$37
	other quit;
	VAL:= VAL <<4 +I;
	end;
return VAL;
end;	\GETHEX



\----------------------------------------------------------------------

func	EXPRESSION;	\Returns the value of an expression
int	VAL;


func	FACTOR;		\Returns the value of a factor
int	VAL, I, NEG;
begin
while CHAR = ^+ do GETCHX;		\Ignore unary "+"
NEG:=false;
while CHAR =^- do			\Unary "-"
	[GETCHX; NEG:=not NEG];

if CHAR>=^0 & CHAR<=^9 then	\Unsigned integer
	VAL:= GETDEC

else case CHAR of
  ^(:	begin				\Subexpression
	GETCHX;
	VAL:= EXPRESSION;
	if CHAR#^) then SETSTAT("expr?",true);
	GETCHX;
	end;

  ^K,^k: [DISPLAY; OPENI(0); VAL:=CHIN(1); GETCH;];

  ^Z,^z: [VAL:=C2INX-CINX;GETCH;];	\Get buffer free space

  ^C,^c: [GETCOLLUM;VAL:=REALCOL;GETCH;]; \Get value of global variable

  ^%:	[VAL:=GLOBAL;GETCH;];		\Get value of global variable

  ^$:	VAL:=GETHEX;			\Unsigned hex integer

  ^^:	VAL:=GETASCI;			\String constant

  ^@:	VAL:=UNDERC;			\Character under cursor

  ^.:	[VAL:=CINX;GETCHX]		\Cursor position


other	SETSTAT("syntax",true);

SKIPTAB;	\Identifiers, numbers, etc. may terminate with a space or tab
return if NEG then -VAL else VAL;
end;	\FACTOR



func	TERM;		\Returns FACTOR * FACTOR, etc.
int	VAL;
begin
VAL:= FACTOR;
loop	case CHAR of
	  ^*:	[GETCHX; VAL:= VAL * FACTOR];
	  ^/:	[GETCHX; VAL:= VAL / FACTOR];
	  ^\:	[GETCHX; VAL:= REM(VAL / FACTOR)]	\Modulo
	other	quit;
return VAL;
end;	\TERM



proc	ALGEXP;		\Returns TERM + TERM, etc.
int	VAL;
begin
VAL:= TERM;
loop	case CHAR of
	  ^+:	[GETCHX; VAL:= VAL + TERM];
	  ^-:	[GETCHX; VAL:= VAL - TERM]
	other	quit;
return VAL;
end;	\ALGEXP



func	LOGEXP;		\Returns a boolean, e.g: ALGEXP < ALGEXP
int	VAL;
begin
if CHAR=^~ then				\Unary 'NOT' operator
	begin
	GETCHX;
	VAL:= not LOGEXP;
	end
else	begin
	VAL:= ALGEXP;
	case CHAR of
	 ^=:	[GETCHX; VAL:= VAL = ALGEXP];
	 ^#:	[GETCHX; VAL:= VAL # ALGEXP];
	 ^>:	begin
		GETCHX; if CHAR#^= then VAL:= VAL > ALGEXP
		else [GETCHX; VAL:= VAL >= ALGEXP];
		end;
	 ^<:	begin
		GETCHX; if CHAR#^= then VAL:= VAL < ALGEXP
		else [GETCHX; VAL:= VAL <= ALGEXP];
		end
	other;
	end;
return VAL;
end;	\LOGEXP



func	BOOLTERM;	\Returns LOGEXP & LOGEXP
int	VAL;
begin
VAL:= LOGEXP;
loop	begin
	if CHAR=^& then
		[GETCHX; VAL:= VAL & LOGEXP]
	else quit;
	end;
return VAL;
end;	\BOOLTERM



begin	\EXPRESSION
SKIPTAB;				\Must not have a tab or space
VAL:= BOOLTERM;
loop	begin
	if CHAR=^! then
		[GETCHX; VAL:= VAL ! BOOLTERM]
	else quit;
	end;
return VAL;
end;	\EXPRESSION


proc	EVAL(D);
int D;
\evaluate expression pointed to by D
begin
EPTR:=D;
TRAP($FFFE);
GETCH;
GLOBAL:=EXPRESSION;
TRAP($FFFF);
if GETERR # 0 then SETSTAT("div -0",true);
if CHAR # ^) then SETSTAT("expr?",true);
return EPTR;
end;


\=========================== MACRO COMMANDS =============================

proc	CMD2TXT;	\Copy command line to text buffer
int	I;
begin
for I:= 0, DINX(DN)-1 do
	INSERT(DBUF(DN,I));
end;	\CMD2TXT



proc	TXT2CMD;	\Copy text into command line
int	C, D;
begin
C:=C2INX;
D:=0;
loop	begin
	DBUF(DN,D):= BUFFER(C);
	C:= C+1;
	D:= D+1;

	if D>=2 then if DBUF(DN,D-1)=ESC & DBUF(DN,D-2)=ESC then
		[DINX(DN):= D;   quit];

	if C>=BUFSIZ ! D>=DBUFSIZ then
		[SETSTAT("esc esc?",true);
		quit];
	end;
SHOWCMDLINE;
end;	\TXT2CMD



proc	SELCMD;		\Select a command line [0-9]
int	N;
begin
\Get the number of the command line.
\Move cursor to status line.
CURL:= HEIGHT -1;   CURH:= 16;
N:= KEYIN;
if N>=^0 & N<=^9 then [DN:= N -^0;   SHOWCMDLINE]
else SETSTAT("number?",true);
CYCFLAG:=false;
end;	\SELCMD


proc	INCCMD;		\Increment the command line number
begin
DN:=if DN>=9 then 0 else DN+1;
CYCFLAG:=true;
SHOWCMDLINE;
end;

proc	DECCMD;		\Decrement the command line number
begin
DN:=if DN<=0 then 9 else DN-1;
SHOWCMDLINE;
end;


\============================ GET COMMANDS ==============================

proc	BADCMD;		\Handle unimplemented commands
SETSTAT("illegal?",true);



proc	DOEXTCMD(CH);	\Execute an extended key commands
int	CH;		\ or insert the text character (CH)
begin
CH:=-CH;		\Extened are negated, so fix
case CH of
RTAKEY: FWDCHAR;
ENDKEY: FWDALL;
HOMKEY: BACKALL;
DELKEY: DELFOR;
PDNKEY: FWDPAGE;
PUPKEY: BACKPAGE;
LFAKEY: BACKCHAR;
DNAKEY: [DOWNLINE;return;];
UPAKEY: [UPLINE;return;];
SHFTAB: INDENT;
INSKEY: PARAMS(OVERFLAG):=not PARAMS(OVERFLAG);
ALTB:   BOXMODE:=if BOXMODE>=4 then 0 else BOXMODE+1;
ALTR:   CUTON;
ALTF:   CUTTEXT;
FN1KEY: [DECCMD; SETSTAT("ok",true);];

FN2KEY: [INCCMD; SETSTAT("ok",true);];
FN3KEY: begin
	PARAMS(WRAPFLAG):=not PARAMS(WRAPFLAG);
	if PARAMS(WRAPFLAG) then 
		if CURH>=PARAMS(BELLCOL) then WRAPLINE;
	SHOWRULER;
	end;
FN4KEY: [NEXTBUF;BACKALL;];
CTRLPGDOWN: SHUFFLE(1);
CTRLEND: SHUFFLE(22);
FN5KEY: COPYX;
ALTFN5: BLOCKIN;
FN6KEY: MARGIN;
FN7KEY: DISLINES;
FN8KEY: XINX:=0;
FN9KEY: DROPMARK;
FN10KEY: LASTMARK;
ALTFN1: HELP(6)
other INSERT(CHAR);
WRKCOL:=-1;	\flag new column
end;	\DOEXTCMD





proc	DOIMMCMD(CH);	\Execute an immediate command (control character)
int	CH;		\ or insert the text character (CH)
begin
\For speed and clarity, handle extended keys separately
if CH<0 then DOEXTCMD(CH)
else begin
 case CH of
 CTRLA:	FWDCHAR;
 CTRLB:	BACKWORD;
 CTRLC:	DELWORD;
 CTRLD:	FWDALL;
 CTRLE:	BACKALL;
 CTRLF:	XOFF;
 CTRLG:	SETSTAT("use J?",true);		\(recursion can overflow stack)
 CTRLH: DELETE;
\CTRLI is a TAB
 CTRLJ:	FWDPAGE;
 CTRLK:	BACKPAGE;
\CTRLL is a FF
\CTRLM is a CR
 CTRLN:	FWDWORD;
 CTRLO:	OOPS;
 CTRLP:	SELCMD;
 CTRLQ:	BACKCHAR;
 CTRLR:	XON;
 CTRLS:	FWDLINE;
 CTRLT:	PARAMS(SHOWFLAG):= not PARAMS(SHOWFLAG);
 CTRLU: INDENT;
 CTRLV:	CMD2TXT;
 CTRLW:	BACKLINE;
 CTRLX:	DELLINE;
 CTRLY:	[COPYX;   XINX:=0];
 CTRLZ:	FLIPCASE;
\CTRL@\$00: INSERT(SP);			\because of the (un)Wyse terminal
\CTRL[ IS AN ESC
\CTRL\ $1C: BADCMD;	\SWAPCURSORS;
\CTRL]\$1D: PARAMS(S1FLAG):= not PARAMS(S1FLAG);
\CTRL^\$1E: INSERT(KEYINX);		\insert next character literally
\CTRL_\$1F: PARAMS(S2FLAG):= not PARAMS(S2FLAG)
 other INSERT(CH);
 WRKCOL:=-1;	\flag new column
 end;
end;	\DOIMMCMD

\----------------------------------------------------------------------

proc CONDITIONAL(D);
\handle conditionals
int D,BC,P;
begin
if GLOBAL then return D;	\if true just return and execute block
\SKIP TO MATCHING BRACKET
BC:=1;
for P:=D,DINX(DN)-1 do	\scan for loop terminator
	case DBUF(DN,P) of
		^] : [BC:=BC-1;if BC<1 then return P+1;];
		^[ : BC:=BC+1
	else;
SETSTAT("missing ]",true);
return P;
end;



proc	DOCMDLINE(D);	\Execute a deferred command (from the command line)
int	DS;		\Starting index to command line buffer

define HUGE=32760;	\largest constant for 'for' loop

int	I, J, CH,
	OLDCH,		\last command for detecting meta (^)
	D,		\working index to command line buffer
	DX,		\index pointer to next command
	COUNT;		\repeat count
			\Note that groups of commands can be repeated, each
			\ group is separated by an ESC.


	proc	CALLCMD;	\call a command line (recursive)
	int	CMD, SDN;
	begin
	CMD:= DBUF(DN,D+1) -^0;		\get the command-line number
	if CMD>=0 & CMD<=9 then
		begin
		SDN:= DN;		\save current command line
		DN:= CMD;		\execute called command line
		DOCMDLINE(0);
		SETSTAT("ok", false);	\don't stop now
		DN:= SDN;		\resume current command line
		end
	else	SETSTAT("number?", true);
	DX:= D +1;			\skip the command-line number
	end;	\CALLCMD


	proc	LOOP;
	\execute code inside a loop (recursive)
	begin
	DX:=DOCMDLINE(D+1);
	\Abort for loop if error
	if ERRFLAG then
		[I:=HUGE; if not BREAKFLAG then SETSTAT("ok",false);];
	end;


begin	\DOCMDLINE
COUNT:=0;
WRKCOL:=-1;
OLDCH:=0;
D:= DS;
loop	begin				\loop over all chars in cmd line
	if D >= DINX(DN) then quit;
	OLDCH:=CH;
	CH:= DBUF(DN,D);

	if CH>=^0 & CH<=^9 then		\if numeric get repeat count
		begin
		COUNT:= 0;
		while CH>=^0 & CH<=^9 do	\get repeat count
			begin
			COUNT:= COUNT *10 + (CH -^0);
			if COUNT < 0 then [SETSTAT("number?",true);   quit];
			D:= D+1;
			CH:= DBUF(DN,D);
			end;
		end;
	if COUNT <1 then COUNT:= 1;	\do it at least once

	if CH=^# then
		begin
		COUNT:=HUGE;		\use huge number
		D:= D+1;
		CH:= DBUF(DN,D);
		end;


	if CH>=^a & CH<=^z then		\convert to uppercase if no meta
		if OLDCH # ^^ then CH:= CH-$20;

	DX:= D +1;			\assume a one-char command

	\Execute the command COUNT number of times:
	for I:= 1,COUNT do
		begin
		COUNT:=0;
		if (CH<$20 & CH#ESC & CH#CR) ! CH=$7F then DOIMMCMD(CH)
		else
		case CH of
		  ^A:	APPEND;			\DEFERRED COMMANDS
		  ^B:	DX:=GLOBCOM(D+1);	\display or insert GLOBAL
		  ^C:	[CHOUT(3, EOF);   CLOSE(3);   CLOSFLAG:= true;  DOSCLOSE];
		  ^D:	DELCHAR;		\(inserting DEL is awkward)
		  ^E:	XINX:= 0;		\empty scoop
		  ^F:	DX:=REPLACE(D+1);	\Replace string
		  ^G:	NEXTBUF;		\read next text buffer
		  ^H:	DX:= INHEX(D+1);	\insert literal hex
		  ^I:	DX:= INSTRING(D+1);	\insert string
		  ^J:	DX:= DS;		\restart command line
		  ^K:	DELALL;			\kill entire buffer
		  ^L:	LIST;			\list on printer
		  ^M:	DX:= MARGIN(D+1);	\remargin
		  ^N:	DX:= BUFSEARCH(D+1);	\search "N" buffers
		  ^O:	DX:=OCMD(D+1);		\open or rewind files
		  ^P:	CALLCMD;		\call another command line
		  ^Q:	QUIT;			\save file and return to Apex
		  ^R:	DELREST;		\delete the rest of a line
		  ^S:	DX:= XSEARCH(OLDCH,D+1);	\search for string
		  ^T:	TERMINATE;		\terminate & trash output file
		  ^U:	[GOTODOS;SHOWCMDLINE;];	\go to MS-DOS
		  ^V:	[TXT2CMD;   quit];	\text to command line
		  ^W:	WRITEBUF;		\write edit buffer to disk
		  ^X:	COPYX;			\copy scoop (X register)
		  ^Y:	CENTER;			\center a line of text
		  ^Z:	ZAP;			\delete back to form feed
		  ^(:   DX:=EVAL(D+1);		\evaluate an expression
		  ^{:   LOOP;			\start of a loop
		  ^}:	return D+1;		\end of a loop
		  ^;:   SETSTAT("no loop",true);\forced exit from loop
		  ^::   MOVECUR(GLOBAL);	\move cursor to GLOBAL
		  ^_:	COUNT:=GLOBAL;		\set count to GLOBAL value
		  ^[:   if COUNT>1 then SETSTAT("[] > 1",true)
			else DX:=CONDITIONAL(D+1);	\execute block conditionally
		  ^?:	[HELP(6); SHOWCMDLINE];	\show help messages
		  ^/:	HELP(PR);		\print help messages
		  ^]:   [];			\null if executed
		  SP,CR:[];			\inert chars (for readability)
		  ^-,^+:[];			\sometimes arguments
		  ESC:	[]			\(command separator)
		other BADCMD;

		\one break should abort out of deepest recursions
		if TESTC  then [OPENI(0);BREAKFLAG:=true;SETSTAT("break",true);];

		if ERRFLAG then
			begin
			for D:=DX,DINX(DN)-1 do	\scan for loop terminator
				if DBUF(DN,D)=^} then return D+1;
			quit;
			end;
		end;	\for loop

	D:= DX;				\point to next command in line buffer
	end;	\loop
end;	\DOCMDLINE

\----------------------------------------------------------------------

proc	ENTERCMDLINE;	\Enter and execute a command line
int	CH, SDINX;
begin
if CYCFLAG then [INCCMD;SHOWSTATUS;];
DBUF(DN,0):= ESC;			\store and echo the escape key
DINX(DN):= 1;
LEFTCOL:=0;
SDINX:= 0;

\Display a temporary cursor in the body of the text:
CURSOR(if CURH<WIDTH then CURH else WIDTH-1, CURL);
CHOUT(TV, $DB);				\ %%%
SHOWCMDLINE;				\show ESC and cleared command line
					\this also sets the cursor position
repeat	begin
	CH:= KEYIN;
	case CH of
	-ALTFN1: [HELP(6); DISPLAY];
	CTRLH: if DINX(DN) > 0 then DINX(DN):= DINX(DN) -1;
	CTRLX: DINX(DN):= 0;

	CTRLO:	if SDINX = 0 then
			begin		\OOPS! Undelete command line
			SDINX:= DINX(DN);
			DINX(DN):= 0;		\move forward until esc, esc
			repeat DINX(DN):= DINX(DN) +1;
			until (DBUF(DN,DINX(DN)-1) =ESC &
				DBUF(DN,DINX(DN)) =ESC) ! DINX(DN) >=DBUFSIZ;
			SHOWCMDLINE;
			return;
			end
		else	begin		\put things back (toggle CTRL-O)
			\DINX(DN):= SDINX;
			\SDINX:= 0;
			end;
	\CTRL^\$1E:
		begin			\literal insert
		CH:= KEYIN;
		if DINX(DN) < DBUFSIZ then
			[DBUF(DN,DINX(DN)):= CH;   DINX(DN):= DINX(DN) +1]
		else SETSTAT("length?",true);	\(do not exit loop!)
		end
	other	begin
		if DINX(DN) < DBUFSIZ then
			[DBUF(DN,DINX(DN)):= CH;   DINX(DN):= DINX(DN) +1]
		else SETSTAT("length?",true);	\(do not exit loop!)
		end;
	SHOWCMDLINE;
	SHOWSTATUS;
	end;
until (CH=ESC & DBUF(DN,DINX(DN)-2)=ESC) ! DINX(DN)=0;	\ESC ESC or empty

DOCMDLINE(0);
end;	\ENTERCMDLINE

\----------------------------------------------------------------------

proc	INITIALIZE;	\First-time (cold-start) initialization
int	I,J;
addr	STR;
begin
CINX:=0;				\empty main buffer
C2INX:= BUFSIZ;
SAVEPTRS;
XINX:= 0;				\empty X buffer (register)
XFLAG:= false;
CUTFLAG:=false;

SETSTAT("ok",false);			\init status display and ERRFLAG

CURLINE:= (HEIGHT -6);			\put cursor on 3rd line from bottom
CURH:=0;   CURL:=CURLINE;		\init cursor position
REALCOL:=0;
\Put starting message in command buffer and display it while we wait:
\ (Note that <ESC>- will not execute.)
STR:="    -- XED, Version 1.8 --                    For help type: <ESC>?<ESC><ESC> ";
for DN:=0, 9 do				\init empty (esc, esc is for OOPS)
	begin
	DINX(DN):= 0;
	for I:=0, DBUFSIZ-1 do
		DBUF(DN, I):= ESC;
	end;
DN:= 0;
I:= 0;
repeat	DBUF(DN, I):= STR(I);
	I:= I +1;
until STR(I) >= $80;			\note that the string will not execute
DINX(DN):= I;
CHOUT(0, FF);
SHOWCMDLINE;

\Set up ruler display:
for I:= 0, COLMAX do TICKMARKS(I):= ^-;
for I:= 5, COLMAX do [TICKMARKS(I):= ^+;   I:= I +9];
J:= ^0;
for I:= 0, COLMAX do
	[TICKMARKS(I):= J;
	J:= J +1;
	if J = ^: then J:= ^A;
	I:= I +9];

OPENFILES;
APPEND;
SAVEPTRS;
PARAMS(COLDFLAG):= false;		\indicate we're initialized
end;	\INITIALIZE


procedure SETVIDEO;
\Do video specific setup
int REGLEN;
begin
CPUREG(0):= $0F00;	\set screen dimensions according to current display mode
SOFTINT($10);
CHAR:= CPUREG(0) & $FF;
WIDTH:= CPUREG(0) >>8;
REGLEN:=PEEK(0,$44C) ! SWAP(PEEK(0,$44D));
HEIGHT:=PEEK(0,$484);
HEIGHT:=if HEIGHT<23 ! HEIGHT>64 then 25 else HEIGHT+1;
case CPUREG(0) & $FF of
  $02:	[SCRSEG:=$B800;STATATT:=$70;HELPATT:=$0F;CURCOLOR:=$F0;];
  $03:	[SCRSEG:=$B800;STATATT:=$17;HELPATT:=$0B;CURCOLOR:=$C0;];
  $07:  [SCRSEG:=$B000;STATATT:=$70;HELPATT:=$0F;CURCOLOR:=$F0;];
  $23:  [SCRSEG:=$B800;STATATT:=$17;HELPATT:=$0B;CURCOLOR:=$C0;];
  $27:  [SCRSEG:=$B000;STATATT:=$17;HELPATT:=$0B;CURCOLOR:=$C0;];
  $33:	[SCRSEG:=$B800;STATATT:=$17;HELPATT:=$0B;CURCOLOR:=$C0;];
  $37:	[SCRSEG:=$B000;STATATT:=$17;HELPATT:=$0B;CURCOLOR:=$C0;]
other	[SCRSEG:=$B800;STATATT:=$17;HELPATT:=$0B;CURCOLOR:=$C0;];

SLENGTH:=(WIDTH*(HEIGHT-3))*2;
WSTRUC(WSEG):=SCRSEG;
WSTRUC(BSTART):=BUFFER;
WSTRUC(BEND):=BUFFER+BUFSIZ;
WSTRUC(SCRLEN):=SLENGTH;
WSTRUC(LINLEN):=WIDTH;
WSTRUC(LBEFORE):=HEIGHT-(HEIGHT/5);
SETWIND(0,0,WIDTH-1,HEIGHT-1,$102,false);
end;


\----------------------------------------------------------------------

begin	\MAIN
INFILE:= RESERVE(NAMESIZE);		\reserve all the arrays here
OUTFILE:= RESERVE(NAMESIZE);
OUTTEMP:= RESERVE(NAMESIZE);
OUTBACK:= RESERVE(NAMESIZE);

XBUFFER:=RESERVE(2);
XBUFFER(0):=MALLOC((XBUFSIZ>>4)+1);

HEXSTR:=RESERVE(10);
DINX:= RESERVE(10*INTSIZE);
DBUF:= RESERVE(10*INTSIZE);
for II:= 0,9 do DBUF(II):= RESERVE(DBUFSIZ*INTSIZE);
TICKMARKS:= RESERVE(COLMAX+1);
SSTR:= RESERVE(DBUFSIZ);
BUFSIZ:= 32750;	\FREE - 2000;
\BUFSIZ:= BUFSIZ - REM(BUFSIZ/1000);	\\round down to even 1000
BUFFER:= RESERVE(BUFSIZ);
MARKER:=RESERVE(2*MAXMARK);
WSTRUC:=RESERVE(2*STRUCSIZE);

GLOBAL:=0;
WRKCOL:=-1;
MRKPTR1:=0;
MRKPTR2:=0;
for II:=0,MAXMARK-1 do MARKER(II):=0;

CPUREG:= GETREG;
PSPSEG:= CPUREG(11);
DATASEG:= CPUREG(12);

SAVECUR;
SETVIDEO;

CLOSFLAG:= false;	\(ED can be restarted with a new output file)
BOXMODE:=0;		\Start with box mode off

PARAMS:=
	[true,		\COLDFLAG
	0,		\LEFTMARGIN
	72,		\RIGHTMARGIN
	72,		\BELLCOL
	0,		\PARAINDENT
	false,		\S1FLAG
	false,		\S2FLAG
	false,		\SHOWFLAG
	false,		\WRAPFLAG
	false];		\OVERWRITE FLAG

BOXCHAR:=[[0],			\Build box character set
[196,192,193,217,195,197,180,218,194,191,179],
[205,212,207,190,198,216,181,213,209,184,179],
[196,211,208,189,199,215,182,214,210,183,186],
[205,200,202,188,204,206,185,201,203,187,186]
];


CYCFLAG:=true;
if PARAMS(COLDFLAG) then INITIALIZE	\is this a restart?
else [CHOUT(0, FF);   SHOWCMDLINE];
TRAPC(true);
CURSOFF;

loop	begin
	DISPLAY;			\display the text
	CHAR:= KEYINX;			\wait for key if not already struck
	case of				\init status display
	XFLAG: SETSTAT("scoop",false);
	CUTFLAG: SETSTAT("cut",false)
	other SETSTAT("ok",false);	
	BREAKFLAG:=false;		\no breaks at this point

	if BOXMODE then		\translate box mode characters
		case of
		CHAR>=^0 & CHAR<=^9: CHAR:=BOXCHAR(BOXMODE,CHAR-^0);
		CHAR=^+: CHAR:=BOXCHAR(BOXMODE,10)
		other;

	if CHAR = ESC then ENTERCMDLINE		\enter and execute a command line
	else if CHAR = CTRLG then DOCMDLINE(0)	\(not allowed in deferred mode)
	else DOIMMCMD(CHAR);			\do immediate command or insert char
	end;
end;	\MAIN
