\XPL4 example of accessing extended memory.

inc	\cxpl\codesi;

int
	Cpureg,
	DataSeg,
	Seg, Off,
	Han,
	EMB,
	I, J;
char	A;

def	AX, BX, CX, DX, DI, SI, BP, CF, CS, DS, SS, ES;		\Getreg registers
def	IntSize= 4;		\Number of bytes in an integer (2 or 4)



func CallInt(Int, AX, BX, CX, DX, BP, DS, ES); \Call software interrupt
int	Int, AX, BX, CX, DX, BP, DS, ES; \(Unused arguments need not be passed)
begin
Cpureg:= Getreg;
Cpureg(0):= AX;
Cpureg(1):= BX;
Cpureg(2):= CX;
Cpureg(3):= DX;
Cpureg(6):= BP;
Cpureg(9):= DS;
Cpureg(11):= ES;
Softint(Int);
return Cpureg(0);		\return AX register
end;	\CallInt



begin	\Main
Cpureg:= Getreg;
DataSeg:= Cpureg(12);

\Is an XMS driver present?
if (CallInt($2f, $4300) & $ff) = $80 then
	begin
	CallInt($2f, $4310);
	Seg:= Cpureg(ES);
	Off:= Cpureg(BX);

	\Get XMS version number
	Cpureg(AX):= 0;
	Extcal(Seg, Off);
	Hexout(0, Cpureg(AX));
	Crlf(0);

	\is the A20 line enabled?
	Cpureg(AX):= $0700;
	Extcal(Seg, Off);
	if (Cpureg(BX)&$FF) = 0 then
		Text(0, if Cpureg(AX)\#0\ then "Enabled" else "Disabled")
	else	[Text(0, "Query failed. Error: $"); Hexout(0, Cpureg(BX))];
	Crlf(0);

	\How big is the largest free extended memory block?
	Cpureg(AX):= $0800;
	Extcal(Seg, Off);
	Text(0, "Largest block (KB):     "); Intout(0, Cpureg(AX)); Crlf(0);
	Text(0, "Total free memory (KB): "); Intout(0, Cpureg(DX)); Crlf(0);
	Crlf(0);

	\Allocate a chunk of extended memory
	Cpureg(AX):= $0900;
	Cpureg(DX):= 100;		\100KB = 100 *1024 = 102,400
	Extcal(Seg, Off);
	if Cpureg(AX) = 0 then
		[Text(0, "Allocate Error: "); Intout(0, Cpureg(BX)&$ff);  Crlf(0)]
	else	begin
		Han:= Cpureg(DX);

		\Lock EMB
		Cpureg(AX):= $0c00;
		Cpureg(DX):= Han;
		Extcal(Seg, Off);
		if Cpureg(AX) = 0 then
			[Text(0, "Lock Error: "); Intout(0, Cpureg(BX)&$ff);  Crlf(0)]
		else	begin
			EMB:= Cpureg(DX)<<16 + Cpureg(BX);
			Hexout(0, EMB);
			Crlf(0);

			\Local enable A20 line
			Cpureg(AX):= $0500;
			Extcal(Seg, Off);

			\Use EMB
			A:= EMB - DataSeg *16;
			for I:= 0, 100000-1 do A(I):= I;
			J:= 0;
			for I:= 0, 100000-1 do J:= J + A(I);
			Intout(0, J);
			Crlf(0);

			\Local disable A20 line
			Cpureg(AX):= $0600;
			Extcal(Seg, Off);

			\Unlock EMB
			Cpureg(AX):= $0d00;
			Cpureg(DX):= Han;
			Extcal(Seg, Off);
			end;


		\Free EMB
		Cpureg(AX):= $0a00;
		Cpureg(DX):= Han;
		Extcal(Seg, Off);
		end;
	end
else	Text(0,"No XMS driver
");
end;	\Main
