\XPL0.XPL		VER 5.6-D	9-4-86
\XPL0 COMPILER
\COPYRIGHT 1984 P.J.R. BOYLE
\FLOATING POINT VERSION BY LOREN BLANEY

\ADDED INCLUDES...PJB
\FALLBACK FIX, EXTENDED SYMBOL TABLE...PJB
\WARNING: THIS VERSION PRODUCES I2L CODE WHICH IS INCOMPATABLE WITH
\ VERSIONS 5F AND 4D (BECAUSE OF GLOBAL LOAD OPCODE AND INTRINSIC DISPATCH).

\CONTENTS:
\ MAIN--DISPLAY TITLE AND INITIALIZE
\	ERROR--DISPLAY ERROR MESSAGE AND OPTIONALLY CONTINUE
\	GETCH--GET A CHARACTER FROM THE SOURCE DEVICE
\	RATOM--READ AN ATOM FROM SOURCE DEVICE
\	SKIPIT--SKIP STATEMENT FOR ERRORS
\	HEXB--OUTPUT A HEX BYTE (IN ASCII) TO BINARY DEVICE
\	GEN--OUTPUT I2L CODE TO BINARY DEVICE
\	FIX--CHANGE A SPECIFIC I2L LOCATION TO THE CURRENT PC
\	LOOKUP--LOOK UP AN IDENTIFIER NAME IN THE SYMBOL TABLE
\	INSERT--INSERT AN IDENTIFIER INTO THE SYMBOL TABLE
\	GETCON--GET A CONSTANT (EITHER VALUE OR NAME)
\	PROCAL--PROCEDURE CALLS
\	BOOLEXP--GENERATE I2L CODE FOR A BOOLEAN EXPRESSION
\		FACTOR--GENERATE CODE FOR A FACTOR
\			STRCON--TEXT STRING CONSTANT
\			ARRAYCON--CONSTANT ARRAY
\			SPECFAC--SPECIAL FACTORS (addr,STRING)
\			IDFAC--IDENTIFIER FACTORS
\				FUNCTION--PROCEDURE AS A FACTOR
\		TERM--GENERATE CODE FOR A TERM (E.G. A*B)
\			TERMX--
\		ALGEXP--ALGEBRAIC EXPRESSION (E.G. A+B)
\			ALGX--
\		LOGEXP--LOGICAL EXPRESSION (E.G. A=B)
\			LOGX--
\		BOOLTERM--BOOLEAN TERM (E.G. A&B)
\	SSTATEMENT--(FOR 'QUIT'S IN 'CASE' STATEMENTS)
\		STATEMENT--PARSE AND GENERATE CODE
\			ASSIGN--ASSIGNMENT STATEMENTS
\				ASSX--
\			CASER--CASE STATEMENTS
\				CASER2--
\	PROCEDURE--PARSE AND GENERATE CODE
\		CODDEC--'CODE' DECLARATION
\		CONDEC--'DEFINE' DECLARATION
\		VARDEC--'INT','REAL', AND 'ADDR' DECLARATIONS
\		EXTDEC--'EXTERNAL' PROCEDURE DECLARATION
\		FPRDEC--FORWARD PROCEDURE DECLARATIONS
\		PROCDEC--'PROCEDURE' DECLARATIONS

code	\THE REQUIRED INTRINSICS:
ABS=0		REM=2		RESERVE=3	SWAP=4
CHIN=7		CHOUT=8		CRLF=9		INTIN=10
INTOUT=11	TEXT=12		OPENI=13	OPENO=14
CLOSE=15	SCAN=24		FREAD=31;

code real	FLOAT=49,	RLRES=46;

def	TV=0, KB=0, BINDEV=3, LSTDEV=0;
def	EOF=$1A, BEL=$07, EOL=$0A; \I/O STUFF

def	SYMAX=1000	\SIZE OF THE SYMBOL TABLE
	RLMAX=100	\SIZE OF REAL-CONSTANT SYMBOL TABLE
	RLSIZE=5	\NO. OF BYTES IN A REAL NUMBER
	CODOFF=0	\OFFSET FOR INTRINSIC ROUTINES
	SIGCHAR=6	\NO. OF SIGNIFICANT CHARS IN AN IDENT
	QUITMAX=10;	\MAXIMUM NO. OF 'QUIT'S IN A 'LOOP'

int	ERRCNT	\ERROR COUNTER
	CHAR	\CURRENT CHARACTER.  MOST OF THE TIME IT
		\ CONTAINS THE TERMINATOR OF THE CURRENT ATOM
	CASEIN	\BOOLEAN--UPPER/LOWER CASE FOR (') COMMANDS
	ATOM	\PRESENT ATOM DESCRIPTOR
		\CONTAINS RESERVED WORD HASH OR THE ASCII FOR
		\ A SPECIAL CHARACTER; 0 IF THE ATOM IS A
		\ CONSTANT OR AN IDENTIFIER
	ATYPE;	\PRESENT ATOM TYPE DESCRIPTOR
def	\ATYPE\ SPECIAL,IDENTIFIER,INTCON,REALCON;
char	IDENT;	\ARRAY--CURRENT IDENTIFIER NAME
int	HASH	\CURRENT IDENTIFIER HASH CODE
	IATOM;	\VALUE OF CURRENT INTEGER CONSTANT
real	RLATOM;	\REAL CONSTANT FROM PROC "RATOM"

int	IDTYPE;	\PRESENT IDENTIFIER TYPE DESCRIPTOR
def	UNDEF=0		\UNDEFINED ID (NO. ORDER IS CRITICAL)
	ADDRVAR=1	\ADDRESS VARIABLE ID (TYPE = INTEGER)
	INVAR=3		\INTEGER VARIABLE ID (ODD NOS.=INTEGER)
	RLVAR=4		\REAL VARIABLE ID
	INCON=5		\INTEGER CONSTANT ID
	RLCON=6		\REAL CONSTANT ID
	INPROC=7	\INTEGER PROCEDURE ID
	RLPROC=8	\REAL PROCEDURE ID
	INFPROC=9	\INTEGER FORWARD PROCEDURE ID
	RLFPROC=10	\REAL FORWARD PROCEDURE ID
	INOPT=11	\INTEGER OPTIMIZED PROCEDURE ID
	RLOPT=12	\REAL OPTIMIZED PROCEDURE ID
	ININT=13	\INTEGER INTRINSIC ID
	RLINT=14	\REAL INTRINSIC ID
	INEXT=15	\INTEGER EXTERNAL PROCEDURE ID
	RLEXT=16;	\REAL EXTERNAL PROCEDURE ID

int	LEV	\LEVEL OF CURRENT IDENTIFIER
	VAL	\VALUE OR ADDRESS OF CURRENT IDENTIFIER
	SYMNUM	\POSITION IN "SYMTBL" OF CURRENT IDENTIFER
	FACTYP;	\FACTOR (OR OPERAND) TYPE (REAL OR INTEGER)
def	\FACTYP\ REAL,INTEGER;
int	FIXES	\ARRAY--'QUIT' FIXES STILL OUTSTANDING
	PC	\THE I2L PROGRAM COUNTER
	OLDPC	\PC VARIABLE USED BY PROCEDURE "GEN"
	LEVEL	\STATIC LEVEL OF CURRENT PROCEDURE
	NOSYM	\CURRENT NUMBER OF SYMBOLS IN SYMBOL TABLE
	FIXCNT	\COUNT OF THE NUMBER OF OUTSTANDING 'QUIT'S
	STKLOD	\NO. OF INTEGERS LEFT ON STACK BY 'FOR' ! 'CASE'
	OPTPROC	\BOOLEAN--GENERATE AN OPTIMIZED PROCEDURE CALL
	NORLSY	\CURRENT NUMBER OF REAL CONSTANTS IN TABLE
	I;	\SCRATCH
char	HEXDIGIT; \ARRAY OF HEX DIGITS (0 - F)

	\ -- SYMBOL TABLE ARRAYS --
char	SYMBOL	\IDENTIFIER NAME (IDENT)
	SYMTYP;	\TYPE DESCRIPTORS (IDTYPE)
int	SYMVAL;	\VALUE OR ADDRESS (VAL)
char	SYMLEV;	\LEVEL (LEV)
int	SYMPNT;	\LIST LINKAGE POINTERS
int	BOX;	\HASH BOXES (SYMBOL LIST HEADERS)
real	RLTBL;	\REAL CONSTANT TABLE
def	EMPTY=$FFFF;

char	SAVEBUF;	\CIRCULAR BUFFER KEEPING LAST 256 CHARACTERS FOR ERRORS.
int	SPTR;	\CURRENT POINTER INTO SAVEBUF
int	UNIT,
	FBLK,LBLK,	\ARRAYS DESCRIBING POSITION OF OUTER INCLUDE FILES
	INCNO,	\KEEPS TRACK OF THE DEPTH OF THE INCLUDE NESTING
	INCPNT,	\THE POINTER TO THE NEXT VALID BYTE IN INCBUF
	INCSAV,MEM,
	INCMAX;	\THE MAX INDEX OF INCBUF

char INCBUF;

def		\RESERVED WORD HASHES
ADRSYM=25797	BEGSYM=26057	CASEYM=25046	CODSYM=28615
DEFSYM=26058	DOSYM=28516	ELSEYM=27864	ENDSYM=28361
EXITYM=30926	EXTNYM=30937	FALSYM=25042	FFUNYM=26331
FORSYM=28632	FPRSYM=28888	FUNSYM=30164	GESYM=25959
GETSYM=26075	IFSYM=26217	INTSYM=28381	LESYM=25964
LOOPYM=28635	NOTSYM=28642	OFSYM=26223	PROCYM=29407
QUITYM=30170	REALYM=26067	REPSYM=26082	RETSYM=26086
THENYM=26841	TRUSYM=29417	UNTSYM=28393	WHILYM=26848
CHARYM=26820	EPRSYM=28887	EFUNYM=26330	LNKSYM=27098
OTHSYM=29911	INCSYM=28364;



proc	ERROR(N);
\DISPLAY ERROR MESSAGE AND OPTIONALLY CONTINUE
int N;
int	ERR,CH,I,K;
char	STRING;
def	MAXERR=69;	\MAXIMUM ERROR NUMBER
begin \ERROR
\FIRST WE DUMP THE SAVE BUFFER
K:=SPTR;
while SAVEBUF(K)#EOL do K:=(K+1)&$FF;
repeat begin
	CHOUT(LSTDEV,SAVEBUF(K));
	K:=(K+1)&$FF;
	end
until K=SPTR;

ERR:=RESERVE((MAXERR+1)*2);
for I:=0,MAXERR do ERR(I):="? ";	\UNUSED ERROR NOS. ="?"

ERR(1):="TOO MANY VARIABLES IN SCOPE ";
ERR(2):="TOO MANY REAL CONSTANT NAMES ";
ERR(3):="SYMBOL TABLE FULL ";
ERR(4):="TOO MANY 'QUITS' ";
ERR(5):="TOO MANY STATIC LEVELS ";
ERR(6):="NUMBER OUT OF RANGE ";
ERR(7):=ERR(6);		\FOR INTRINSIC DECLARATIONS
ERR(10):="UNDECLARED NAME ";
ERR(11):="NAME ALREADY DECLARED ";
ERR(20):="ILLEGAL START OF A STATEMENT ";	\IN "ASSIGN"
ERR(21):="^":=^"* ";
ERR(22):="'THEN'* ";
ERR(23):="'DO'* ";
ERR(24):="^",^"* ";
ERR(26):="ILLEGAL FACTOR ";	\UNRECOGNIZABLE SPECIAL FACTOR
ERR(27):="STATEMENT STARTING WITH A CONSTANT "; \IN "ASSIGN"
ERR(28):="'UNTIL'* ";
ERR(29):="'OTHER'* ";
ERR(30):="'ELSE'* ";
ERR(31):="DIGIT* ";
ERR(33):="INTEGER VARIABLE* ";	\IN A 'FOR' STATEMENT
ERR(40):="^"=^"* ";
ERR(41):="^";^"* ";
ERR(42):="CONSTANT* ";		\IN "GETCON"
ERR(43):="VARIABLE* ";		\FOR AN 'ADDR' OPERATOR
ERR(44):="^")^"* ";
ERR(45):="NAME* ";
ERR(46):="MIXED MODE ";
ERR(47):="INTEGER* ";
ERR(48):="'OF'* ";
ERR(49):="^":^"* ";
ERR(50):="^"]^"* ";
ERR(51):="NO ARGUMENTS DECLARED ";
ERR(52):="STATEMENT STARTING WITH 'ELSE' ";
ERR(53):="STATEMENT STARTING WITH 'OTHER' ";
ERR(60):="'QUIT' NOT IN A 'LOOP' ";
ERR(61):="EOF* ";
ERR(62):="EOF INSIDE A BLOCK ";
ERR(63):="EOF INSIDE A STRING ";
ERR(65):="'FPROC' & ITS 'PROC' NOT AT SAME LEVEL ";
ERR(66):="'FPROC' REFERENCE NOT FOUND ";
ERR(67):="'PROC' OR 'FUNC'* ";
ERR(68):="'EPROC'S AND 'LINK'S MUST BE GLOBAL ";
ERR(69):="'INCLUDE'S NEST TOO DEEP ";

CHOUT(TV,BEL); CHOUT(TV,$0A);	\(DAMN LINEFEEDS!)
CRLF(TV);
TEXT(TV,"***** ERROR NO. "); INTOUT(TV,N); TEXT(TV," *****");
CRLF(TV);
if N<=MAXERR then
	begin
	STRING:=ERR(N);
	I:=0;
	loop	[CH:=STRING(I);		\OUTPUT MESSAGE
		if CH>=$80 then quit;
		if CH=^* then TEXT(TV," EXPECTED BUT NOT FOUND")
		else CHOUT(TV,CH);
		I:=I+1];
	end;
CRLF(TV);
TEXT(TV,"ATTEMPT TO CONTINUE? ");
OPENI(KB);
if CHIN(KB)=^N then [CLOSE(LSTDEV); exit];
ERRCNT:=ERRCNT+1;
end;	\ERROR



\---------INCLUDE.XPL: CODE RELATED TO THE INCLUDE FUNCTION --------------------
\
\THIS CODE EXPORTS THESE PROCEDURES:
\	FETCH	(GET A RAW BYTE OF SOURCE)
\	GETCH	(GET A BYTE OF PROGRAM SOURCE)
\	INCLUDE (PROCESS AN INCLUDE STATEMENT)
\
\ This code also maintains the SAVE buffer which logs processed characters
\ for use in the error routine.
\
\LATEST MOD: FIX THE FALLBACK BUG 9-3-86
\
\------------------------------------------------------------------------------


proc FETCH;	\GET ANOTHER BYTE FROM CURRENT INPUT STREAM
\USED BY GETCH AND OTHER PLACES WHERE THE INPUT MUST BE RAW
\KEEP OPTIMIZED FOR SPEED


proc READMORE;	\READ ANOTHER BUFFER-FULL INTO INCBUF FROM CURRENT FILE
int N,NBLK;
begin
if FBLK<=LBLK then
	begin
	NBLK:=(INCMAX+1)/256;
	if FBLK+NBLK>LBLK then N:=LBLK-FBLK+1
	else N:=NBLK;
	FREAD(UNIT,FBLK,INCBUF,N);
	FBLK:=FBLK+NBLK;
	end
else INCBUF(0):=EOF;
INCPNT:=0;
end;

proc FALLBACK;	\RE-READ AN OLD FILE AND REPOSITION INCPNT WITHIN IT
int N,NBLK;
begin
INCNO:=INCNO-1;
FBLK:=INCSAV(INCNO,0);
LBLK:=INCSAV(INCNO,1);
INCPNT:=INCSAV(INCNO,2);
UNIT:=INCSAV(INCNO,3);
NBLK:=(INCMAX+1)/256;
FBLK:=FBLK-NBLK;
if FBLK+NBLK>LBLK then N:=LBLK-FBLK+1
else N:=NBLK;
FREAD(UNIT,FBLK,INCBUF,N);
FBLK:=FBLK+NBLK;
CHAR:=EOL;	\DUMMY - IT WILL FALL BACK ON THE NEXT
end;


begin \FECTH
if INCPNT>INCMAX then READMORE;
CHAR:=INCBUF(INCPNT);
INCPNT:=INCPNT+1;
if CHAR=EOF then
if INCNO>0 then FALLBACK;	\IF INCNO=0 THEN ITS A HARD EOF
SAVEBUF(SPTR):=CHAR;
SPTR:=(SPTR+1)&$FF;
end;\FETCH


proc	GETCH;	\GET A CHARACTER FROM SOURCE
\ FILTERS OUT COMMENTS AND DOES CASE SHIFT.
\(THIS PROCEDURE WAS OPTIMIZED FOR SPEED.)
begin
FETCH;
while CHAR=^\ do			\FILTER OUT COMMENTS
	begin
	FETCH;
	if CHAR=^* then
		begin
		loop	begin	\LONG COMMENT
			FETCH;
			case CHAR of
			EOF:	quit;
			^*:	begin
				FETCH;
				if (CHAR=^\)!(CHAR=EOF) then quit;
				end
			else;					
			end;
		end
	else	loop	begin
			case CHAR of
			EOL:	quit;
			^\:	quit;
			EOF:	quit
			else;
			FETCH;
			end;
	FETCH;
	end;
if CHAR=^' then [CASEIN:= not CASEIN; CHAR:=^ ]	\SHIFT CASE
else if CASEIN then	\SWITCH TO LOWER CASE IF CASEIN IS TRUE
	[if CHAR>=^A & CHAR<=^Z then CHAR:=CHAR+32];
end;	\GETCH



proc INCLUDE;	\PROCESSES "INCLUDE" STATEMENTS
int DUNIT,DFBLK,DLBLK;

procedure DOFILE; \EXTRACT FILE NAME AND LOOK IT UP
int	BLOCK;
char	BUF;

procedure GETNAM(NAME);	\EXTRACT FILE NAME FROM SOURCE INTO "NAME"
char NAME;
int I,K;
addr DEFDEV;

proc SAVE(CH);	\INSERT A CHARACTER INTO CIRCULAR LISTING BUFFER
int CH;
begin
SAVEBUF(SPTR):=CH;
SPTR:=(SPTR+1)&$FF;
end;


begin	\GETNAM
DEFDEV:=$BF77;
DUNIT:=DEFDEV(0);

for I:=0,11 do NAME(I):=^ ;
NAME(8):=^X;
NAME(9):=^P;
NAME(10):=^L;

while CHAR<=$20\SPACE\ do
	begin	\SKIP SPACES, TABS, RETURNS, LF'S, & FF'S, ETC.
		\DON'T GO PAST EOF
	if CHAR=EOF then ERROR(61);
	GETCH;
	end;

if (CHAR>=^0)&(CHAR<=^9) then
	begin
	DUNIT:=CHAR&$7;
	GETCH;
	GETCH;
	end;
K:=0;
loop	begin
	if (CHAR=^.)!(CHAR=^;) then quit;
	NAME(K):=CHAR;
	K:=K+1;
	if K>7 then quit;
	GETCH;
	end;
for K:=K,7 do NAME(K):=^ ;

if CHAR=^. then
	loop	begin
		GETCH;
		if CHAR=^; then quit;
		NAME(K):=CHAR;
		K:=K+1;
		if K>10 then quit;
		end;
while CHAR#^; do
	begin
	if CHAR=EOL then [ERROR(41); exit];\MUST EXIT OR IT MAY LOOP
	GETCH;
	end;
SAVE($A);SAVE($D);	\FOR PRETTYNESS ONLY
end;	\GETNAM


begin	\DOFILE
BUF:=RESERVE(12);
BLOCK:=RESERVE(4);
GETNAM(BUF);

BUF(11):=$80+^ ;
TEXT(0,"INCLUDING-");
INTOUT(0,DUNIT);CHOUT(0,^:);TEXT(0,BUF);CRLF(0);

SCAN(DUNIT,BLOCK,BUF);
DFBLK:=BLOCK(0);
DLBLK:=BLOCK(1);
end;	\DOFILE


begin \INCLUDE
if INCNO>7 then
	begin
	ERROR(69);
	while CHAR#^; do GETCH;
	return;
	end;

DOFILE;
INCSAV(INCNO,0):=FBLK;		\save our current point
INCSAV(INCNO,1):=LBLK;
INCSAV(INCNO,3):=UNIT;
INCSAV(INCNO,2):=INCPNT;

FBLK:=DFBLK;			\setup for new file
LBLK:=DLBLK;
UNIT:=DUNIT;
INCNO:=INCNO+1;
INCPNT:=INCMAX+1;		\mark it empty
end;

\----------------------------------------------------------------------


proc	RATOM;		\READ AN ATOM
\OUTPUTS:  ATOM, ATYPE, IDENT, HASH, IATOM, CHAR, RLATOM.
\ (THIS PROCEDURE IS OPTIMIZED FOR SPEED.)
int	LEN,NEG,EXP,I;
real	FRACT,DENOM;

	proc	RFRACT;	\READ THE FRACTIONAL PART OF A REAL NO.
	begin
	ATYPE:=REALCON; ATOM:=0;
	GETCH;
	FRACT:=FLOAT(0); DENOM:=FLOAT(10);	\(10.0 IS NOT SO PORTABLE)
	while CHAR>=^0 & CHAR<=^9 do
		[FRACT:=FRACT +FLOAT(CHAR-^0) /DENOM;
		DENOM:=DENOM*FLOAT(10);
		GETCH];
	RLATOM:=RLATOM +FRACT;
	end;	\RFRACT


	proc	REXP;	\READ AN EXPONENT IF ANY
	if CHAR=^E then
		begin
		ATYPE:=REALCON;
		GETCH;
		if CHAR=^- then [NEG:=true; GETCH]
			else NEG:=false;
		if CHAR=^+ then GETCH;
		EXP:=0;
		if CHAR<^0 ! CHAR>^9 then ERROR(31);
		while CHAR>=^0 & CHAR<=^9 do
			[EXP:=EXP *10 +CHAR-^0; GETCH];
		if NEG then EXP:= -EXP;
		while EXP>0 do
			[RLATOM:=RLATOM *FLOAT(10); EXP:=EXP-1];
		while EXP<0 do
			[RLATOM:=RLATOM /FLOAT(10); EXP:=EXP+1];
		end;	\REXP

begin	\RATOM
while CHAR<=$20\SPACE\ do
	begin	\SKIP SPACES, TABS, RETURNS, LF'S, & FF'S, ETC.
		\DON'T GO PAST EOF
	if CHAR=EOF then [ATYPE:=SPECIAL; ATOM:=EOF; return];
	GETCH;
	end;
if CHAR>=^a then if CHAR<=^z then		\RESERVED WORD
	[ATYPE:=SPECIAL;
	ATOM:=CHAR; GETCH;
	ATOM:=ATOM+SWAP(CHAR); GETCH;
	if CHAR>=^a & CHAR<=^z then [ATOM:=ATOM+CHAR; GETCH];
	while CHAR>=^a & CHAR<=^z do GETCH;
	if ATOM=TRUSYM then
		[ATYPE:=INTCON; ATOM:=0; IATOM:=true; return];
	if ATOM=FALSYM then
		[ATYPE:=INTCON; ATOM:=0; IATOM:=false];
	if ATOM=INCSYM then [INCLUDE;GETCH;RATOM];	
	return];
if CHAR>=^A then if CHAR<=^Z then		\IDENTIFIER
	begin
	ATYPE:=IDENTIFIER; ATOM:=0;
	IDENT(0):=CHAR; HASH:=CHAR; GETCH;
	LEN:=1;
	loop case of
	CHAR>=^A & CHAR<=^Z,  CHAR>=^0 & CHAR<=^9,  CHAR=^_ :
		begin
		if LEN <SIGCHAR then
			[IDENT(LEN):=CHAR;
			HASH:=HASH+CHAR;
			LEN:=LEN+1];
		GETCH;
		end
	else quit;
	for LEN:=LEN,SIGCHAR-1 do
		[IDENT(LEN):=^ ; HASH:=HASH+^ ];
	HASH:=HASH & $FF;
	return;
	end;
if CHAR>=^0 then if CHAR<=^9 then	\UNSIGNED INTEGER
	begin
	ATYPE:=INTCON;		\ASSUME INTEGER UNTIL SHOWN OTHERWISE
	ATOM:=0;
	IATOM:=CHAR-^0; GETCH;
	loop	begin
		I:=IATOM;
		if CHAR<^0 ! CHAR>^9 then quit;
		I:=IATOM*10+CHAR-^0;
		if I<0\INTEGER OVERFLOW\ then quit;
		IATOM:=I;
		GETCH;
		end;
	RLATOM:=FLOAT(IATOM);
	IATOM:=I;		\(CAN'T FLOAT(32768))
	while CHAR>=^0 & CHAR<=^9 do	\MORE DIGITS MUST BE REAL
		[RLATOM:=RLATOM*FLOAT(10) + FLOAT(CHAR-^0);
		GETCH];
	if CHAR=^. then RFRACT;		\UNSIGNED REAL
	REXP;
	if ATYPE=INTCON & IATOM<0 & IATOM#$8000 then ERROR(6);
	return;
	end;
case CHAR of
^.:	[RLATOM:=FLOAT(0);			\UNSIGNED REAL
	RFRACT;
	REXP;
	return];
^$:	begin				\UNSIGNED HEX INTEGER
	ATYPE:=INTCON; ATOM:=0;
	GETCH;
	case of
	CHAR>=^0 & CHAR<=^9: IATOM:=CHAR-^0;
	CHAR>=^A & CHAR<=^F: IATOM:=CHAR-$37
	else [\DIGIT EXPECTED\ ERROR(31); return];
	loop	[GETCH;
		case of
		CHAR>=^0 & CHAR<=^9: I:=CHAR-^0;
		CHAR>=^A & CHAR<=^F: I:=CHAR-$37
		else return;
		if IATOM>$FFF then ERROR(6);
		IATOM:=IATOM*16+I];
	end;
^^:	[ATYPE:=INTCON;	\META CHARACTER = INTEGER CONSTANT
	ATOM:=0;
	FETCH;
	IATOM:=CHAR;
	GETCH;
	return];
^":	[ATYPE:=SPECIAL;		\SPECIAL CHARACTER
	ATOM:=CHAR;\(' AND BACKSLASH HAVE NO EFFECT IN STRINGS)
	FETCH;
	return]
else;
ATYPE:=SPECIAL;				\SPECIAL CHARACTER
ATOM:=CHAR;
GETCH;
if CHAR=^= then
	case ATOM of
	^::	[GETCH; ATOM:=GETSYM];
	^>:	[GETCH; ATOM:=GESYM];
	^<:	[GETCH; ATOM:=LESYM]
	else;
end;	\RATOM



proc	SKIPIT;
\SKIP THE REST OF A STATEMENT FOR ERROR RECOVERY
while ATOM#EOF & ATOM#^; & ATOM#ENDSYM & ATOM#^] &
	ATOM#BEGSYM & ATOM#^[ do RATOM;


proc	HEXB(I);	\OUTPUT HEX BYTE (OPTIMIZED FOR SPEED)
int I;
begin
CHOUT(BINDEV,HEXDIGIT( (I&$FF)/16 ));
CHOUT(BINDEV,HEXDIGIT(REM(0)));
end;	\HEXB


proc HEXOUT(D,I);	\OUTPUT A HEX WORD
int D,I;
begin
HEXB(SWAP(I));HEXB(I);
end;

proc	GEN(OP,LEV,VAL,CL);	\GENERATE I2L OP CODE
int OP,LEV,VAL,CL;
int	I;
char	A;
begin
\THE ENCODING OF THE CLASS, CL, IS AN 8-BIT BINARY CODE.
\0 = OPCODE ONLY, 1 BYTE
\2 = OPCODE WITH ONE BYTE VALUE
\3 = OPCODE WITH VALUE, 3 BYTES
\7 = OPCODE WITH ADDRESS (TO BE RELOCATED BY LOADER), 3 BYTES
\10 = OPCODE WITH LEVEL AND ONE BYTE OFFSET (IN VAL)
\15 = OPCODE WITH LEVEL AND ADDRESS, 4 BYTES
\16 = IMMF OPCODE WITH "RLSIZE" BYTES OF VALUE
\32 = CONSTANT REAL ARRAY POINTER
\64 = OPCODE WITH BASE RELATIVE ADDRESS, 3 BYTES
if PC#OLDPC then [CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(BINDEV,PC)];

if OP=1 & LEV=0 & VAL<$80 then  \SHORT GLOBAL LOAD (MAGIC OPCODE)
	[HEXB(VAL!$80); PC:=PC+1]
else	begin
	HEXB(OP); PC:=PC+1;
	if CL&8 then [HEXB(LEV); PC:=PC+1];
	if CL&4 then [CHOUT(BINDEV,^*); HEXOUT(BINDEV,VAL); PC:=PC+2]
	else	begin
		if CL&2 then [HEXB(VAL); PC:=PC+1];
		if CL&1 then [HEXB(SWAP(VAL)); PC:=PC+1];
		end;
	end;
if CL=16 then		\IMMF--LOAD IMMEDIATE REAL NO. (RLATOM)
	[A:=addr RLATOM;  \TO ACCESS INDIVIDUAL BYTES IN RLATOM
	for I:=0,RLSIZE-1 do HEXB(A(I));
	PC:=PC+RLSIZE];
if CL&32 then	\OUTPUT DUMMY BYTES FOR CONSTANT REAL ARRAY POINTERS
	for I:=3,RLSIZE do [HEXB(0); PC:=PC+1];
if CL=64 then [CHOUT(BINDEV,^#); HEXOUT(BINDEV,VAL); PC:=PC+2];
OLDPC:=PC;
end;	\GEN



proc	FIX(I);	\FIX FORWARD REFERENCES
int I;
begin
CRLF(BINDEV);
if PC#OLDPC then
	[CHOUT(BINDEV,^;); HEXOUT(BINDEV,PC);
	OLDPC:=PC;
	CRLF(BINDEV)];
CHOUT(BINDEV,^^); HEXOUT(BINDEV,I+1);
end;	\FIX



proc	LOOKUP;		\LOOKUP IDENTIFIER IN SYMBOL TABLE
\INPUTS: IDENT, HASH
\OUTPUTS: IDTYPE, VAL, LEV, SYMNUM.
\IF TWO IDENTIFIERS OF THE SAME NAME ARE IN THE SYMBOL TABLE
\ THEN THE MOST RECENT ENTRY IS RETURNED.
int	I,K,PNTR;
begin
PNTR:=BOX(HASH);
loop	begin
	if PNTR=EMPTY then [IDTYPE:=UNDEF; quit];
	I:=0; K:=PNTR;
	while IDENT(I)=SYMBOL(K) & I<SIGCHAR do
		[I:=I+1; K:=K+SYMAX];
	if I=SIGCHAR then	\FOUND
		[IDTYPE:=SYMTYP(PNTR);
		VAL:=SYMVAL(PNTR);
		LEV:=SYMLEV(PNTR);
		SYMNUM:=PNTR;		\(FOR FORWARD PROC)
		quit];
	PNTR:=SYMPNT(PNTR);
	end;
end;	\LOOKUP



proc	INSERT(STYP,SLEV,SVAL);
int STYP,SLEV,SVAL;
\INSERT THE CURRENT IDENTIFIER INTO THE SYMBOL TABLE
\INPUTS:  STYP, SLEV, SVAL, IDENT, HASH, NOSYM, SYMBOL, & BOX.
int	I,K;
begin
LOOKUP;
if IDTYPE#UNDEF then if LEV=LEVEL then \COLLISION\ ERROR(11);
if NOSYM>=SYMAX then \TABLE FULL\ [ERROR(3); NOSYM:=SYMAX-1];
K:=NOSYM;
for I:=0,SIGCHAR-1 do [SYMBOL(K):=IDENT(I); K:=K+SYMAX];
SYMTYP(NOSYM):=STYP;
SYMLEV(NOSYM):=SLEV;
SYMVAL(NOSYM):=SVAL;
SYMPNT(NOSYM):=BOX(HASH);		\LINK BACK
BOX(HASH):=NOSYM;
NOSYM:=NOSYM+1;
end;	\INSERT



proc	GETCON;	\GET A CONSTANT--EITHER LITERAL OR DEREFERENCE A NAME
int	NEG;
begin
if ATOM=^+ then RATOM;
if ATOM=^- then [NEG:=true; RATOM] else NEG:=false;
case ATYPE of
INTCON:	[if NEG then IATOM:=-IATOM; FACTYP:=INTEGER];
REALCON:[if NEG then RLATOM:=-RLATOM; FACTYP:=REAL];
IDENTIFIER:
	begin
	LOOKUP;
	case IDTYPE of
	INCON:	[IATOM:=if NEG then -VAL else VAL;
		FACTYP:=INTEGER];
	RLCON:	[RLATOM:=if NEG then-RLTBL(VAL)else RLTBL(VAL);
		FACTYP:=REAL]
	else	ERROR(42);
	end
else	ERROR(42);
end;	\GETCON


\------------------ BOOLEXP.XPL: EXPERSSION EVALUATION ------------------------
\
\ THIS CODE EXPORTS ONLY THE PROCEDURES:
\	BOOLEXP		PROCESS AN GENERAL EXPRESSION
\	PROCAL		PROCESS A PROCEDURE CALL (STATEMENT OR FACTOR)
\
\------------------------------------------------------------------------------


fproc	BOOLEXP;	\REQUIRED BECAUSE PROCAL AND BOOLEXP RECURSE


proc	PROCAL;	\PROCESS A PROCEDURE REFERENCE (RECURSES WITH BOOLEXP)
int	SVAL,SLEV,ARGCNT,SID;
begin
SVAL:=VAL; SLEV:=LEV; SID:=IDTYPE;
RATOM;
ARGCNT:=0;
if ATOM=^( then
	begin
	repeat	[RATOM; 
		BOOLEXP;
		ARGCNT:=ARGCNT +(if FACTYP=INTEGER then
			2 else RLSIZE)]
	until ATOM#^,;
	if ATOM#^) then ERROR(44) else RATOM;
	end;
case of
SID>=INPROC & SID<=RLFPROC:	\NORMAL PROCEDURE CALL
	[if ARGCNT>0 then GEN(\ARG\10,0,ARGCNT-1,2);
	GEN(\CAL\5,SLEV+2,SVAL,15)];
SID=ININT ! SID=RLINT:		\INTRINSIC PROCEDURE CALL
	GEN(\CML\12,0,SVAL,2);
SID=INOPT ! SID=RLOPT:		\OPTIMIZED PROCEDURE CALL
	[if ARGCNT>0 then \NO ARGS DECLARED\ ERROR(51);
	GEN(\JSR\38,0,SVAL,7)]
else	GEN(\ECL\41,0,SVAL,3);  \EXTERNAL PROCEDURE CALL
end;	\PROCAL



proc	BOOLEXP;	\THE MOST GENERAL EXPRESSION FORM
\OUTPUTS FACTOR OF KNOWN TYPE (SETS THE GLOBAL "FACTYP")
int	P1,P2,SFACTYP;



proc	FACTOR;		\THE LEAST GENERAL EXPRESSION ELEMENT
\---- THE FOLLOWING PROCEDURES DEAL WITH THE SPECIAL FACTOR TYPES -----


func	STRCON;		\STRING CONSTANT FUNCTION
int	SPC,SCHAR;
begin
SPC:=PC;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(BINDEV,PC);
while CHAR#^" do
	begin			\(GETCH--OPTIMIZED FOR SPEED)
	case CHAR of
	^^:	FETCH;
	EOF:	[ERROR(63); exit]
	else	[];
	HEXB(CHAR); PC:=PC+1;
	SCHAR:=CHAR;
	FETCH;
	end;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(BINDEV,PC-1);
HEXB(SCHAR!$80);
GETCH;
FACTYP:=INTEGER;
return SPC;	\RETURN STARTING ADDRESS OF STRING
end;	\STRCON



func	ARRAYCON;	\CONSTANT ARRAYS
int	THISEL,NEXTEL,PNTR,SPC,I,INDIRECT,SFACTYP;
def	NULL=$FFFF;
char	ENTRY,R;

	proc ARRAYX;	\(THIS MUST BE AN OPTIMIZED PROCEDURE
	begin		\ FOR THE RESERVE TO WORK PROPERLY.)
	RATOM;
	INDIRECT:=true;
	case ATOM of
	^[:	ENTRY:=ARRAYCON;
	^":	ENTRY:=STRCON
	else	begin
		INDIRECT:=false;
		GETCON;
		if FACTYP=INTEGER then ENTRY:=IATOM
		else	[ENTRY:=RESERVE(RLSIZE);  \FACTYP=REAL
			R:=addr RLATOM;
			for I:=0,RLSIZE-1 do ENTRY(I):=R(I)];
		end;
	NEXTEL:=RESERVE(6);
	THISEL(1):=ENTRY;
	THISEL(2):=INDIRECT;
	THISEL(0):=NEXTEL;
	NEXTEL(0):=NULL;
	THISEL:=NEXTEL;
	RATOM;
	end;

begin	\ARRAYCON
PNTR:=RESERVE(6);
THISEL:=PNTR;
THISEL(0):=NULL;
ARRAYX;
while ATOM=^, do
	[SFACTYP:=FACTYP;
	ARRAYX;
	if FACTYP#SFACTYP then \MIXED MODE\ ERROR(46)];
if ATOM#^] then ERROR(50);
SPC:=PC;
CRLF(BINDEV); CHOUT(BINDEV,^;); HEXOUT(BINDEV,PC);
while PNTR(0)#NULL do		\DUMP LIST
	begin
	ENTRY:=PNTR(1);
	if FACTYP=INTEGER then
		begin
		if PNTR(2) \INDIRECT\ then
			[CHOUT(BINDEV,^*); HEXOUT(BINDEV,ENTRY)]
		else	[HEXB(ENTRY); HEXB(SWAP(ENTRY))];
		PC:=PC+2;
		end
	else	begin	\(FACTYP=REAL)
		if PNTR(2) \INDIRECT\ then
			[CHOUT(BINDEV,^*); HEXOUT(BINDEV,ENTRY);
			for I:=1,RLSIZE-2 do HEXB(0)]
		else for I:=0,RLSIZE-1 do HEXB(ENTRY(I));
		PC:=PC+RLSIZE;
		end;
	PNTR:=PNTR(0);
	end;
return SPC;	\RETURN STARTING ADDRESS OF ARRAY
end;	\ARRAYCON



proc	SPECFAC;	\SPECIAL CHARACTER FACTOR
int	SVAL,SPC,R;
begin
case ATOM of
^(:	[RATOM;			\PARENTHESIZED EXPRESSION
	BOOLEXP;	\(FACTOR TYPE IS UNCHANGED)
	if ATOM#^) then ERROR(44)];
^":	[SPC:=PC;		\STRING CONSTANT
	GEN(\JMP\7,0,0,7);
	SVAL:=STRCON;
	FIX(SPC);
	GEN(\IMM\11,0,SVAL,7)];
^[:	[SPC:=PC;		\CONSTANT ARRAY
	GEN(\JMP\7,0,0,7);
	SVAL:=ARRAYCON;
	FIX(SPC);
	if FACTYP=INTEGER then GEN(\IMM\11,0,SVAL,7)
	else	\FACTYP=REAL
		[R:=addr RLATOM;	\CONVERT AN INTEGER
		R(0):=SVAL;		\ POINTER INTO A REAL
		GEN(\IMMF\$2C,0,SVAL,36)]];\ POINTER IN RLATOM
ADRSYM:	begin			\GET ABSOLUTE HEAP ADDRESS
	RATOM;
	if ATYPE#IDENTIFIER then ERROR(45);
	LOOKUP;
	case IDTYPE of
		INVAR, ADDRVAR, RLVAR: GEN(\ADR\33,LEV,VAL,10);
		UNDEF: ERROR(10)	\(UNDECLARED NAME)
	else ERROR(43);	\(VARIABLE EXPECTED)
	FACTYP:=INTEGER;
	end
else \ILLEGAL FACTOR\ ERROR(26);
RATOM;
end;	\SPECFAC



proc	IDFAC;		\IDENTIFIER FACTOR
int	SLEV,SVAL,SID;
begin	\IDFAC
LOOKUP;
SID:=IDTYPE;
case IDTYPE of
UNDEF:	ERROR(10);
INVAR, RLVAR:		\VARIABLE
	begin
	GEN(if SID=INVAR then \LOD\1 else\LODF\$2A,LEV,VAL,10);
	RATOM;
	if ATOM=^( then				\IT IS INDEXED
		begin
		repeat	[RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47);
			GEN(if SID=INVAR then \DBI\32
				else \TRI\$3A,0,0,0)]
		until ATOM#^, ;
		if ATOM#^) then ERROR(44) else RATOM;
		end;
	end;
ADDRVAR: begin		\ADDRESS VARIABLE
	RATOM;
	if ATOM#^( then GEN(\LOD\1,LEV,VAL,10)
	else	begin		\ARRAY ELEMENT REFERENCE
		SLEV:=LEV; SVAL:=VAL;
		RATOM;
		BOOLEXP; 	\INDEX
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#^) then ERROR(44) else RATOM;
		GEN(\LDX\2,SLEV,SVAL,10);
		end;
	end;
INCON:	begin	\INTEGER CONSTANT IDENTIFIER
	if ABS(VAL)<128 & VAL#$8000 then GEN(\IMS\36,0,VAL,2)
		else GEN(\IMM\11,0,VAL,3);
	RATOM;
	end;
RLCON:	begin	\REAL CONSTANT IDENTIFIER
	RLATOM:=RLTBL(VAL); GEN(\IMMF\$2C,0,0,16);
	RATOM;
	end
else	begin	\PROCEDURES USED AS FUNCTIONS (BY DEFAULT)
	PROCAL;
	if SID<ININT then
		GEN(if SID&1 then\LOD\1 else\LODF\$2A,0,0,10);
	end;
FACTYP:=if SID & 1 then INTEGER else REAL; \ODD IDS ARE INTEGER
end;	\IDFAC


begin	\FACTOR
while ATOM=^+ do RATOM;			\IGNORE UNARY "+"
if ATOM=^- then				\UNARY "-"
	[RATOM;
	FACTOR;
	GEN(if FACTYP=INTEGER then \NEG\17
		else \NEGF\$31,0,0,0)]
else	case ATYPE of
	SPECIAL:SPECFAC;
	INTCON:	[FACTYP:=INTEGER;	\INTEGER CONSTANT
		if ABS(IATOM)<128 & IATOM#$8000 then
			GEN(\IMS\36,0,IATOM,2)
			else GEN(\IMM\11,0,IATOM,3);
		RATOM];
	REALCON:[FACTYP:=REAL;		\REAL CONSTANT
		GEN(\IMMF\$2C,0,0,16);
		RATOM]
	else	IDFAC;	\ATYPE = IDENTIFIER (BY DEFAULT)
end;	\FACTOR


\NOW THE NESTED TOP DOWN PARSER FOR EXPESSION FORMS:


proc	TERM;		\MPY OR DIV OF FACTORS
int	SFACTYP;

	proc TERMX; int INOP,RLOP;
	[RATOM; FACTOR;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(if FACTYP=INTEGER then INOP else RLOP,0,0,0)];

begin	\TERM
FACTOR;
SFACTYP:=FACTYP;
loop	case ATOM of
	^*:	TERMX(\MUL\15,\MULF\$2F);
	^/:	TERMX(\DIV\16,\DIVF\$30)
	else	quit;
end;	\TERM


proc	ALGEXP;		\ALGEBRAIC EXPR = ADD OR SUB OF TERMS
int	SFACTYP;

	proc ALGX; int INOP,RLOP;
	[RATOM; TERM;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(if FACTYP=INTEGER then INOP else RLOP,0,0,0)];

begin	\ALGEXP
TERM;
SFACTYP:=FACTYP;
loop	case ATOM of
	^+:	ALGX(\ADD\13,\ADDF\$2D);
	^-:	ALGX(\SUB\14,\SUBF\$2E)
	else	quit;
end;	\ALGEXP


proc	LOGEXP;		\LOGICAL EXPRESSION = COMPARISON OF ALGEXP'S
int	SFACTYP;

	proc	LOGX; int INOP,RLOP;
	[RATOM; ALGEXP;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(if FACTYP=INTEGER then INOP else RLOP,0,0,0);
	FACTYP:=INTEGER];

begin	\LOGEXP
if ATOM=NOTSYM then		\UNARY 'NOT' OPERATOR
	[RATOM; LOGEXP;
	if FACTYP#INTEGER then ERROR(47);
	GEN(\NOT\28,0,0,0)]
else	[ALGEXP;
	SFACTYP:=FACTYP;
	case ATOM of
	^=:	LOGX(\EQ\18,\EQF\$32);
	^#:	LOGX(\NE\19,\NEF\$33);
	^>:	LOGX(\GT\21,\GTF\$35);
	^<:	LOGX(\LT\23,\LTF\$37);
	GESYM:	LOGX(\GE\20,\GEF\$34);
	LESYM:	LOGX(\LE\22,\LEF\$36)
	else];
end;	\LOGEXP


proc	BOOLTERM;	\BOOLEAN "&" EXPRESSIONS
begin
LOGEXP;
loop	[if ATOM=^& then [RATOM; LOGEXP; GEN(\AND\27,0,0,0)]
		else quit;
	if FACTYP#INTEGER then ERROR(47)];
end;


begin	\BOOLEXP = BOOLEAN "OR" EXPRESSIONS
if ATOM=IFSYM then			\'IF' EXPRESSION
	begin
	RATOM;				\skip over the "if"
	BOOLEXP;			\form the condition expression
	P1:=PC;				\remember the PC for the jump:
	GEN(\JPC\8,0,0,7);		\jump over the then part if false
	if ATOM#THENYM then ERROR(22);	\must be the word "then"
	RATOM;				\skip over the "then" word
	BOOLEXP;			\form the "then" expression
	SFACTYP:=FACTYP;		\remember the type for mixed mode test
	if ATOM#ELSEYM then ERROR(30);	\must be an "else" part
	P2:=PC;				\remember PC for jump around else
	GEN(\JMP\7,0,0,7);		\generate the jump over else part
	FIX(P1);			\make the false jump come here
	RATOM;				\skip over the word "else"
	BOOLEXP;			\form the "else" expression
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	FIX(P2);			\make the "then' jump come here
	end

else	begin			\BOOLEAN "!" (OR) EXPRESSIONS
	BOOLTERM;				\the first component
	loop	begin				\subsequent optional components
		if ATOM=^! then			\if there is another component
			begin
			RATOM;			\skip over the "!"
			BOOLTERM;		\form the next component
			GEN(\OR\26,0,0,0);	\and or them together.
			end
		else quit;
		if FACTYP#INTEGER then ERROR(47); \can only "or" integers.
		end;
	end;
end;	\BOOLEXP


\-------------------- THE STATEMENT PROCESSOR --------------------------------

proc	SSTATEMENT(SSTK);
int SSTK;	\(FOR 'QUIT'S IN 'CASE' STMNTS)


proc	STATEMENT;
int	P2,P3,SFIXS,SLEV,SVAL,SFACTYP,I;


proc	ASSIGN;		\ASSIGNMENT OR PROCEDURE CALL STATEMENT

	proc	ASSX;
	[if ATOM#GETSYM then ERROR(21);
	RATOM;
	BOOLEXP];	\RIGHT-HAND SIDE OF ASSIGNMENT

begin	\ASSIGN
if ATYPE#IDENTIFIER then
	\BAD START OF A STATEMENT\ [ERROR(20); SKIPIT; return];
LOOKUP; if IDTYPE=UNDEF then [ERROR(10); SKIPIT; return];
SLEV:=LEV; SVAL:=VAL;	\SAVE THESE FOR "GEN." AN INTERIM
			\ BOOLEXP MAY CHANGE LEV & VAL
if IDTYPE>=INPROC & IDTYPE<=RLEXT then PROCAL
else if IDTYPE=INVAR ! IDTYPE=RLVAR then
	begin
	SFACTYP:=if IDTYPE=INVAR then INTEGER else REAL;
	RATOM;
	if ATOM=^( then			\INDEXED
		begin
		GEN(\LOD\1,SLEV,SVAL,10);
		RATOM;
		BOOLEXP;		\1ST INDEX
		if FACTYP#INTEGER then ERROR(47);
		while ATOM=^, do	\MULTIPLE INDEXING
			[GEN(if SFACTYP=INTEGER then \DBI\32
				else \TRX\$39,0,0,0);
			RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47)];
		GEN(if SFACTYP=INTEGER then \DBA\30
			else \TRA\$38,0,0,0);
		if ATOM#^) then ERROR(44) else RATOM;
		ASSX;	\TOS NOW POINTS TO ARRAY ELEMENT
		GEN(if SFACTYP=INTEGER then \STD\31
			else \STT\$3B,0,0,0);
		end
	else	[ASSX;
		GEN(if SFACTYP=INTEGER then \STO\3
			else \STOF\$2B,SLEV,SVAL,10)];
	if FACTYP#SFACTYP then \MIXED MODE\ ERROR(46);
	end
else if IDTYPE=ADDRVAR then		\ADDRESS VARIABLE
	begin
	RATOM;
	if ATOM=^( then				\INDEXED
		[RATOM;
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#^) then ERROR(44) else RATOM;
		ASSX;
		GEN(\STX\4,SLEV,SVAL,10)]
	else	[ASSX;
		GEN(\STO\3,SLEV,SVAL,10)];
	if FACTYP#INTEGER then \MIXED MODE\ ERROR(46);
	end
else \STATEMENT STARTING WITH A CONSTANT\ [ERROR(27); SKIPIT];
end;	\ASSIGN


proc	CASER(TYPE);	\CONVENIENT SUB-PART OF CASE STATEMENT PROCESSING
int TYPE;
int SPC1,SPC2,SPC3;


proc	CASER2;		\PROCESS ONE "CASE" OF A CASE STATEMENT
begin
RATOM;
BOOLEXP;
if FACTYP#INTEGER then ERROR(47);
SPC1:=PC;
GEN(TYPE,0,0,7);
if ATOM=^, then				\MULTIPLE LABELS
	[SPC3:=PC;
	repeat	RATOM;	\FOR MORE THAN 2 LABELS
		GEN(\JMP\7,0,SPC3,7);	\2 JUMPS TO STATEMENT
		FIX(SPC1);
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		SPC1:=PC;
		GEN(TYPE,0,0,7);
	until ATOM#^,;
	FIX(SPC3)];
if ATOM#^: then [ERROR(49); SKIPIT; return];
RATOM;
STATEMENT;
end;	\CASER2


begin	\CASER
CASER2;
SPC2:=PC;
GEN(\JMP\7,0,0,7);		\JUMP OUT OF CASE STATEMENT
FIX(SPC1);
while ATOM=^; do
	[CASER2;
	GEN(\JMP\7,0,SPC2,7);	\2 JUMP EXIT (BACK THEN OUT)
	FIX(SPC1)];
if ATOM#ELSEYM & ATOM#OTHSYM then ERROR(29);
RATOM;
STATEMENT;
FIX(SPC2);
end;	\CASER


begin	\STATEMENT
case ATOM of
BEGSYM,^[:
	begin
	RATOM;
	loop	begin
		if ATOM=ELSEYM then [ERROR(52); RATOM];
		if ATOM=OTHSYM then [ERROR(53); RATOM];
		STATEMENT;
		case ATOM of
		^;:	RATOM;
		ENDSYM:	quit;
		^]:	quit;
		EOF:	[ERROR(62); exit]
		else	\SEMI EXPECTED\ ERROR(41);
		end;
	RATOM;		\READ PAST THE 'END'
	end;
CASEYM:	begin				\CASE STATEMENT
	RATOM;
	if ATOM=OFSYM then CASER(\JPC\8)
	else	begin
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#OFSYM then [ERROR(48); SKIPIT; return];
		STKLOD:=STKLOD+1;
		CASER(\CJP\37);
		GEN(\DRP\40,0,0,0);
		STKLOD:=STKLOD-1;
		end;
	end;
QUITYM:	begin
	for I:=SSTK,STKLOD-1 do GEN(\DRP\40,0,0,0);
	if FIXCNT>QUITMAX then [ERROR(4); FIXCNT:=QUITMAX-1];
	FIXES(FIXCNT):=PC;		\QUIT STATEMENT
	FIXCNT:=FIXCNT+1;
	GEN(\JMP\7,0,0,7);   \(WILL BE "FIXED" AT END OF 'LOOP')
	RATOM;
	end;
IFSYM:	begin				\IF STATEMENT
	RATOM;
	BOOLEXP;
	P3:=PC;
	GEN(\JPC\8,0,0,7);
	if ATOM#THENYM then [ERROR(22); SKIPIT; return];
	RATOM;
	STATEMENT;
	if ATOM=ELSEYM then
		[P2:=PC;
		GEN(\JMP\7,0,0,7);
		FIX(P3);
		P3:=P2;
		RATOM;
		STATEMENT];
	FIX(P3);
	end;
REPSYM:	[P2:=PC;			\REPEAT STATEMENT
	repeat RATOM; STATEMENT until ATOM#^;;
	if ATOM#UNTSYM then [ERROR(28); SKIPIT; return];
	RATOM;
	BOOLEXP;
	GEN(\JPC\8,0,P2,7)];
WHILYM:	[RATOM;				\WHILE STATEMENT
	P2:=PC;
	BOOLEXP;
	P3:=PC;
	GEN(\JPC\8,0,0,7);
	if ATOM#DOSYM then [ERROR(23); SKIPIT; return];
	RATOM;
	STATEMENT;
	GEN(\JMP\7,0,P2,7);
	FIX(P3)];
RETSYM:	begin				\RETURN STATEMENT
	RATOM;
	for I:=0,STKLOD-1 do GEN(\DRP\40,0,0,0);
	if ATOM#ELSEYM & ATOM#OTHSYM & ATOM#^; & ATOM#^] &
	    ATOM#ENDSYM & ATOM#UNTSYM then	\STORE THE RETURNED
		[BOOLEXP;		\ VALUE IN GLOBAL #0
		if FACTYP=INTEGER then GEN(\STO\3,0,0,10)
			else GEN(\STOF\$2B,0,0,10)];
	GEN(if OPTPROC then \RTS\39 else \RET\6,0,0,0);
	end;
LOOPYM:	begin				\LOOP STATEMENT
	SFIXS:=FIXCNT;
	RATOM;
	P2:=PC;
	SSTATEMENT(STKLOD);
	GEN(\JMP\7,0,P2,7);
	while FIXCNT>SFIXS do	\FIX THE JUMPS FOR THE 'QUIT'S
		[FIXCNT:=FIXCNT-1; FIX(FIXES(FIXCNT))];
	end;
FORSYM:	begin				\FOR STATEMENT
	RATOM;
	if ATYPE#IDENTIFIER then [ERROR(33); SKIPIT; return];
	LOOKUP;
	if IDTYPE=UNDEF then ERROR(10)
		else if IDTYPE#INVAR then ERROR(33);
	SLEV:=LEV; SVAL:=VAL;
	RATOM;
	if ATOM#GETSYM then [ERROR(21); SKIPIT; return];
	RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	GEN(\STO\3,SLEV,SVAL,10);
	if ATOM#^, then [ERROR(24); SKIPIT; return];
	RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	if ATOM#DOSYM then [ERROR(23); SKIPIT; return];
	GEN(\LOD\1,SLEV,SVAL,10);
	P2:=PC;
	GEN(\FOR\24,0,0,7);
	RATOM;
	STKLOD:=STKLOD+1;
	STATEMENT;
	STKLOD:=STKLOD-1;
	GEN(\INC\25,SLEV,SVAL,10); GEN(\JMP\7,0,P2,7);
	FIX(P2);
	\NOTE: THE INTERPRETER SPEEDS UP THINGS BY ASSUMING THAT "INC"
	\ WILL ALWAYS BE FOLLOWED BY A "JMP" GOING BACK TO THE "FOR"
	end;
EXITYM:	[RATOM; GEN(\EXT\0,0,0,0)];	\EXIT STATEMENT
ELSEYM:	[];				\NULL STATEMENT
OTHSYM:	[];
^;:	[];
^]:	[];
ENDSYM:	[];
UNTSYM:	[];
EOF:	[]		\(THIS IS MOSTLY AN ACADEMIC POINT)
else	ASSIGN;
end;	\STATEMENT


begin	\SSTATEMENT
\THIS DOUBLE EMBEDDED PROCEDURE IS JUST A DEVICE TO MAKE THE STACK DEPTH
\A RECURSIVE INSTANCE VARIABLE WHICH REMAINS TRUE THROUGH RECURSIVE CALLS
\TO STATEMENT. THIS ALLOWS US TO CORRECT IT WITH THE RIGHT "DRPS" IF WE
\ENCOUNTER A "QUIT".

STATEMENT;

end;

\----------------------------------------------------------------------

proc	PROCEDURE;	\PROCESS A PROCEDURE DECLARATION

int	P1,DX,		\HEAP SPACE REQUIREMENT COUNTER
	FPROCNT;	\COUNT OF PENDING FORWARD PROCEDURES


proc	CODDEC;		\DECLARE INTRINSIC NAMES
int	SID;
begin
SID:=ININT;		\DEFAULT IS INTEGER INTRINSIC
RATOM;
if ATOM=REALYM then [SID:=RLINT; RATOM]
	else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON; if FACTYP#INTEGER then ERROR(47);
	if IATOM<0 ! IATOM>127 then ERROR(7);
	INSERT(SID,LEVEL,IATOM+CODOFF);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\CODDEC


proc	CONDEC;		\DECLARE CONSTANT NAMES
int	CNTR,SSNO;
begin
RATOM;
CNTR:=0;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	begin
	RATOM;
	if ATOM#^= then [INSERT(INCON,LEVEL,CNTR); CNTR:=CNTR+1]
	else	begin
		SSNO:=NOSYM;
		INSERT(INCON,LEVEL,NORLSY);	\INSERT ID NOW
		RATOM;			\ FIX UP PARMS LATER
		GETCON;
		if FACTYP=INTEGER then SYMVAL(SSNO):=IATOM
		else		\FACTYP=REAL
			[SYMTYP(SSNO):=RLCON;
			if NORLSY>=RLMAX then
				[ERROR(2); NORLSY:=RLMAX-1];
			RLTBL(NORLSY):=RLATOM;
			NORLSY:=NORLSY+1];
		RATOM;
		end;
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\CONDEC


proc	VARDEC(TYPE);  \DECLARE VARIABLES OF KNOWN TYPE
int TYPE;
begin
RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[INSERT(TYPE,LEVEL,DX);
	DX:=DX +(if TYPE=RLVAR then RLSIZE else 2);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\VARDEC


proc	EXTDEC;		\DECLARE EXTERNAL PROCEDURES
int	SID;
begin
SID:=INEXT;		\DEFAULT IS INTEGER EXTERNAL PROCEDURE
RATOM;
if ATOM=REALYM then [SID:=RLEXT; RATOM]
	else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON; if FACTYP#INTEGER then ERROR(47);
	INSERT(SID,LEVEL,IATOM);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\EXTDEC


proc	FPRDEC(OPTYPE);	\DECLARE FORWARD OR EXTERNAL PROCEDURES
int OPTYPE;		\can be 7 (normal) or 64 (base relative)
\This handles both forward and external declarations.
\if OPTYPE=7 then its a forward proc and we generate a jump
\that will be fixed to point to a later point within this module
\hence its address will be normally specified.
\However, if it is an external declaration (OPTYPE=64) then
\we generate the jump to the corresponding open jump in the parent.
\see doc on separate compiles to flesh out comprehension here.
int	SID;
begin
SID:=INFPROC;		\DEFAULT IS INTEGER FORWARD PROCEDURE
RATOM;
if ATOM=REALYM then [SID:=RLFPROC; RATOM]
	else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	INSERT(SID,LEVEL,PC);
	GEN(\JMP\7,0,PC,OPTYPE);
	FPROCNT:=FPROCNT+1;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\FPRDEC


proc	PROCDEC(CANOPT);		\DECLARE ACTUAL PROCEDURE
int	CANOPT;				\BOOL- CAN WE OPTIMIZE?
int	SNOSYM,HASH,I,K,SID,SSNO,SNORL;
begin
SID:=INPROC;			\TYPED PROCEDURE (FOR FUNCTIONS)
RATOM;
if ATOM=REALYM then [SID:=RLPROC; RATOM]
	else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45) else LOOKUP;
if IDTYPE=INFPROC ! IDTYPE=RLFPROC then		\WAS DECLARED FOREWARD
	begin
	if LEVEL#LEV then ERROR(65);	\('FPROC' & 'PROC' MUST BE SAME SCOPE)
	FIX(VAL);			\make its entry jump come here
	SYMVAL(SYMNUM):=PC;
	SYMTYP(SYMNUM):=if IDTYPE=INFPROC then INPROC else RLPROC;
	if SID#SYMTYP(SYMNUM) then \MIXED MODE\ ERROR(46);
	FPROCNT:=FPROCNT-1;
	OPTPROC:=false
	end
else [SSNO:=NOSYM; INSERT(SID,LEVEL,PC); OPTPROC:=CANOPT];

LEVEL:=LEVEL+2; if LEVEL>14 then ERROR(5);
			\EAT THE ARGUMENT LIST AS A COMMENT
while CHAR#^; & CHAR#\CR\$0D do GETCH;	\SPECIAL COMMENT STOPS ON CR
if CHAR#^; then ERROR(41);
GETCH; RATOM;

SNOSYM:=NOSYM; SNORL:=NORLSY;
PROCEDURE;
if ATOM#^; then ERROR(41) else RATOM;
if OPTPROC then SYMTYP(SSNO):= if SID=INPROC then INOPT
	else RLOPT;

\RESTORE SYMBOL TABLE TO PREVIOUS LEVEL:
\I.E. REMOVE THE IDENTIFIERS WHICH WERE LOCAL TO THIS PROCEDURE
while NOSYM>SNOSYM do
	begin
	NOSYM:=NOSYM-1;		\back to last valid symbol
	HASH:=0;		\we need to determine its hash value
	K:=NOSYM;
	for I:=0,SIGCHAR-1 do	\by scanning through its name
		begin
		HASH:=HASH+SYMBOL(K);
		K:=K+SYMAX;
		end;
	HASH:=HASH&$FF;
	BOX(HASH):=SYMPNT(NOSYM);	\and backup the pointer
	end;
NORLSY:=SNORL;

LEVEL:=LEVEL-2;
end;	\PROCDEC


begin	\PROCEDURE
DX:= if LEVEL=0 then RLSIZE else 0; \SAVE HEAP SPACE FOR FUNC RETURN
P1:=PC;GEN(\JMP\7,0,0,7);

FPROCNT:=0;				\counter for forward procs
loop	case ATOM of			\normal local symbols
	INTSYM:	VARDEC(INVAR);
	ADRSYM:	VARDEC(ADDRVAR);
	CHARYM:	VARDEC(ADDRVAR);
	REALYM:	VARDEC(RLVAR);
	CODSYM:	CODDEC;
	EXTNYM:	EXTDEC;
	DEFSYM:	CONDEC;
	EPRSYM, EFUNYM:	if LEVEL=0 then FPRDEC(64) \with external jump
			else [ERROR(68); SKIPIT];
	LNKSYM: [if LEVEL#0 then ERROR(68);
		CHOUT(BINDEV,^%);
		RATOM;
		case ATOM of PROCYM,FUNSYM:PROCDEC(false)
		else ERROR(67)];
	PROCYM,FUNSYM:	PROCDEC(true);
	FPRSYM,FFUNYM:	FPRDEC(7)	\with internal jump
	else	quit;

\IF THERE IS NOTHING TO JUMP OVER THEN ELIMINATE THE JUMP
if PC=P1+3 then PC:=P1 else FIX(P1);

\RESERVE SPACE FOR LOCAL VARIABLES
if DX>0 then
	[GEN(\HPI\9,0,DX,2); OPTPROC:=false;
	if DX>255 then \TOO MANY VARIABLES\ ERROR(1)];

\PROCESS THE BODY OF THE PROCEDURE
SSTATEMENT(STKLOD);	\(STKLOD WILL ALWAYS BE ZERO HERE)

GEN(if OPTPROC then \RTS\39 else \RET\6,0,0,0);	\INSERT ITS RETURN

if FIXCNT#0 then \SOME 'QUIT'S NOT IN A 'LOOP'\ ERROR(60);
if FPROCNT#0 then \UNRESOLVED FWD REFERENCES\ ERROR(66);
end;	\PROCEDURE

\----------------------------------------------------------------------


begin	\MAIN--DISPLAY TITLE AND INITIALIZE
IDENT:=RESERVE(SIGCHAR);
FIXES:=RESERVE(2*QUITMAX);
SYMBOL:=RESERVE(SIGCHAR*SYMAX);	\SYMBOL TABLE
SYMTYP:=RESERVE(SYMAX);
SYMVAL:=RESERVE(SYMAX*2);
SYMLEV:=RESERVE(SYMAX);
SYMPNT:=RESERVE(SYMAX*2);
BOX:=RESERVE(512);		\HASH TABLE
RLTBL:=RLRES(RLMAX);
HEXDIGIT:="0123456789ABCDEF ";
INCSAV:=RESERVE(16);
for I:=0,7 do INCSAV(I):=RESERVE(8);
SAVEBUF:=RESERVE(256);


TEXT(TV,"-- XPL0 COMPILER, VER 5.6D --");CRLF(TV);
TEXT(TV," COPYRIGHT 1986 P.J.R. BOYLE");CRLF(TV);

OPENO(BINDEV); OPENO(LSTDEV); 

CRLF(TV);
CASEIN:=false; PC:=0; LEVEL:=0;		\INITIALIZE SOME STUFF

INCNO:=0;
MEM:=$BF00;
FBLK:=MEM($78/2);			\begin with apex input file
LBLK:=MEM($7A/2);
UNIT:=MEM($7E/2)&$F;

INCBUF:=MEM($3A/2);			\INCLUDE BUFFER = APEX INPUT BUFFER
INCMAX:=MEM($3C/2)-INCBUF;
INCPNT:=INCMAX+1;			\say it's empty

for I:=0,255 do SAVEBUF(I):=0;		\INIT SAVE BUFFER
SAVEBUF(0):=EOL;
SPTR:=1;

OLDPC:=$FFFF; STKLOD:=0; NOSYM:=0; NORLSY:=0; FIXCNT:=0;
for I:=0,255 do BOX(I):=EMPTY;	\ZERO THE SYMBOL TABLE
ERRCNT:=0;

GETCH; RATOM;
OPTPROC:=false;		\(FOR 2 REASONS)
PROCEDURE;		\COMPILE MAIN PROCEDURE, I.E. THE PROGRAM
while ATOM=^; do RATOM;
if ATOM#EOF then \MORE CODE AFTER END\ [ERROR(61); PROCEDURE];
CHOUT(BINDEV,^$);

CRLF(TV);
TEXT(TV,"PROGRAM LENGTH:  "); INTOUT(TV,PC+1);
CRLF(TV);
TEXT(TV,"ERRORS DETECTED: "); INTOUT(TV,ERRCNT); CRLF(TV);
if ERRCNT=0 then CLOSE(BINDEV);
CLOSE(LSTDEV);
end;	\MAIN
