\XPLTEST.XPL	MAR-06-96
\FUNDAMENTAL XPL TESTS

inc	\CXPL\CODESI;

def	DEV=0;		\OUTPUT DEVICE
def	BEL=7;
int	ERRFLG,
	AARDVARK, AARDVARC;	\TEST FOR AT LEAST 8 SIGNIFICANT CHARACTERS



proc	ERROR(STR_);	\DISPLAY ERROR MESSAGE
addr	STR_;
begin
CHOUT(DEV, BEL);
TEXT(DEV, "ERROR: ");
TEXT(DEV, STR_);
CRLF(DEV);
ERRFLG:= true;
end;	\ERROR



func	ONE;		\RETURN THE VALUE 1 THE HARD WAY
int	N;
begin
N:= FIX(SQRT(4.0)-1.0);
return N;
end;	\ONE


func	TWO;		\RETURN THE VALUE 2 THE HARD WAY
begin
return ONE<<ONE;
end;	\TWO



proc	IF;
int	N, C, D, K;
def	A=-3, BEL=A, E=^e, F=$65, G=true, H=false, L=$8000;
def	X, Y, Z;		\SCOPE RULES FOR DEFINE
real	RA, RB;
begin
TEXT(DEV, "IF/CASE TESTS...
");
if (-1-2)*--2#-6 then ERROR("(-1-2)*--2#-6") else;
if BEL#A then ERROR("DEFINE");	\Spaces not required to separate reserved words
if E#F then ERROR("DEFINE") else;
if H then ERROR("DEFINE");
if-1#G then ERROR("-1 # true");
if L#-32768 then ERROR("L # -32768");
if Y#1 then ERROR("Y # 1");
if -30000 >= 30000 then ERROR("-30000 >= 30000 ");
if -3*4/6+5-1#2!7<7>>6 then ERROR("-3*4/6+5-1#2!7<7>>6");
N:= if X<=Z then 1 else -1;
if N<0 then ERROR("X <= Z");

N:= 60;
C:= N +N +N +0;
if C*C/N/N # 3*3 then ERROR("N+N+N");
if C-C then ERROR("C-C") else;
if C#C then ERROR("C#C") else;	\compare same value
if 3#3 then ERROR("3#3") else;	\COMPARE CONSTANTS
if false then ERROR("if false") else;
if false then ERROR("if false");

if C/1 # C then ERROR("C/1");
if REM(0) then ERROR("REM(C/1)");

\TEST ALL BITS IN A BOOLEAN
if $8000 then else ERROR("IF: $8000");
if $0400 then else ERROR("IF: $0400");
if $0020 then else ERROR("IF: $0020");
if $0001 then else ERROR("IF: $0001");

\TEST CASE STATEMENTS
RA:= 1234.0;
RB:= RA;
case true of
 RA=RB:	[];
 RA#RB:	ERROR("REAL CASE")
other ERROR("REAL CASE");

RA:= -1.0;
case of
 RA=RB:	ERROR("REAL CASE");
 RA#RB:	[]
other ERROR("REAL CASE");

case TWO of
ONE+ONE:	[];
TWO-ONE:	ERROR("CASE FUNCTIONS")
other ERROR("CASE FUNCTIONS");

case of
ONE-ONE:	ERROR("CASE FUNCTIONS");
TWO-ONE:	[]
other ERROR("CASE FUNCTIONS");

\COMPARE IF AND CASE
N:= -5;
loop	begin
	case N of
	  -3:	D:=-3;
	  -2:	D:=N;
	  0:	D:=0;
	  -1,1,3: D:=N;
	  2:	D:=2
	other	D:=5;

	case of
	  N=-3:	K:=-3;
	  N=-2:	K:=N;
	  N=0:	K:=0;
	  N=-1,N=1,N=3: K:=N;
	  N=2:	K:=2
	other	K:=5;

	if N=-3 then C:=-3
	else if N=-2 then C:=N
	else if N=0 then C:=0
	else if N=-1 ! N=1 ! N=3 then C:=N
	else if N=2 then C:=2
	else C:=5;

	if C#D ! C#K then ERROR("IF/CASE");

	case N of
	  6: loop return	\loop in a case in a loop
	other N:= N+1;
	end;
\NOTE ABOVE RETURN--NO CODE SHOULD FOLLOW THIS POINT
end;	\IF



proc	FOR;		\FORTST.XPL
int	I, J, C;

	proc	Frog;
	for I:= 1, 10 do
		if I = 7 then return;

begin
TEXT(DEV, "FOR TESTS...
");
\REPEAT TEST
C:=0;
I:= -20;
repeat	C:= C+1;
	I:= I+1;
until I>20;
if C # 41 then ERROR("REPEAT: C # 41");

\WHILE TEST
C:=0;
I:= -20;
while I#20 do
	[I:= I+1;
	C:= C+1];
if C # 40 then ERROR("WHILE: C # 40");

\LOOP TEST
C:=0;
I:= -20;
loop	begin
	C:= C+1;
	I:= I+1;
	if I=20 then quit;
	end;
if C # 40 then ERROR("LOOP: C # 40");

\FOR TEST
for I:= 1,20 do [];
if I#21 then ERROR("FOR: I # 21");

for I:= 1,20 do AARDVARK:=0;
if I#21 then ERROR("FOR: I # 21");

for I:= 20,19 do ERROR("for I:= 20,19 do");
if I#20 then ERROR("FOR: I # 20");

C:= 0;
for I:= -20000, 20000 do
	begin
	I:= I +99;
	C:= C +1;
	end;
if I # 20100 then ERROR("FOR: I # 20100");
if C # 401 then ERROR("FOR: C # 401");

for I:= 1, 10 do
	begin
	J:= 3;
	while J do
		begin
		C:= I;
\When register variable in I (CX) is pending (because of the while loop),
\the actual memory value that the register variable shadows must be
\fetched because the register could get bombed later in the while loop.
\But if the actual memory value is fetched the register value must be
\bombed otherwise the actual memory value will not be incremented at end
\of the for loop.
		J:= J-1;
		end;
	end;
if C # 10 then ERROR("FOR: REGISTER VARIABLE C # 10");

loop	begin
	for I:= 0, 10 do
		if I= 5 then quit;
	end;
if I # 5 then ERROR("QUIT OUT OF A FOR");

Frog;
if I # 7 then ERROR("RETURN OUT OF A FOR");

for I:= -20000, 20000 do
	return;
ERROR("RETURN IN FOR LOOP IGNORED");
end;	\FOR



proc	ARGUMENT;
int	I, J;

	ffunc	ZERO;

	func	SUM();
	int	A,B;
	int	C,D,E,F,G,H,I,J;
	begin
	return A+B+C+ZERO+D+E+F+G+H+I+J;
	end;

	func	ZERO();		\FUNCTION WITH NO LOCAL VARIABLES
	return 0;

begin
TEXT(DEV, "ARGUMENT TESTS...
");
I:= SUM(1,2,3,4,5, SUM(ZERO,1,2,3,4,5,6,7,8,9), 6,7,8,9);
if I # 1+2+3+4+5+0+1+2+3+4+5+6+7+8+9+6+7+8+9 then ERROR("ARGUMENT");
end;	\ARGUMENT



proc	COMPARE;
real	X,Y;
int	I,J,N;

	proc	CMPERROR;
	begin
	ERROR("COMPARE");
	INTOUT(DEV,I); CHOUT(DEV,9);
	INTOUT(DEV,J); CRLF(DEV);
	RLOUT(DEV,X); CHOUT(DEV,9);
	RLOUT(DEV,Y); CRLF(DEV);
	end;	\CMPERROR

begin
TEXT(DEV, "COMPARE TESTS...
");
FORMAT(0,10);
for N:=1,1000 do
	begin
	I:=RAN(100)-50;
	J:=RAN(100)-50;
	I:=I*600;
	J:=J*600;
	X:=FLOAT(I); Y:=FLOAT(J);
	if (I=J)#(X=Y) then CMPERROR;
	if (I#J)#(X#Y) then CMPERROR;
	if (I>J)#(X>Y) then CMPERROR;
	if (I<J)#(X<Y) then CMPERROR;
	if (I>=J)#(X>=Y) then CMPERROR;
	if (I<=J)#(X<=Y) then CMPERROR;
	end;
end;	\COMPARE



proc	CONARRAY;
int	I, J, K, L, A, B, C;
real	X;
begin
TEXT(DEV, "ARRAY TESTS...
");
A:=[ [700, 701, 702],
     [710, 711, 712],
     [720, 721, 722],
     [730, 731, 732] ];

X:=[ [700., 701., 702.],
     [710., 711., 712.],
     [720., 721., 722.],
     [730., 731., 732.] ];

B:= addr A;
C:= addr B;
C(0,0,3,2):= 12345;
X(3,2):= 12345.0;

for I:=0, 3 do
    for J:=0, 2 do
	begin
	if A(I,J)#FIX(X(I,J)) ! A(2,1)#721 ! A(3,2)#12345 then
		begin
		ERROR("CONSTANT ARRAY");
		for K:=0, 3 do
			begin
			for L:=0, 2 do
				[INTOUT(DEV, A(K, L)); TEXT(DEV, "   ")];
			CRLF(DEV);
			end;
		CRLF(DEV);   CRLF(DEV);

		FORMAT(0,13);
		for K:=0, 3 do
			begin
			for L:=0, 2 do
				[RLOUT(DEV, X(K, L)); TEXT(DEV, "   ")];
			CRLF(DEV);
			end;
		CRLF(DEV);   CRLF(DEV);
		return;
		end;
	end;
end;	\CONARRAY



proc	SHIFT;
int	A, B, C, M, N;

	proc	SHERROR;
	begin
	ERROR("SHIFT");
	\A = $XXXX	B = $XXXX	C = $XXXX
	TEXT(DEV, "A = $"); HEXOUT(DEV, A);
	TEXT(DEV, "	B = $"); HEXOUT(DEV, B);
	TEXT(DEV, "	C = $"); HEXOUT(DEV, C);
	CRLF(DEV);
	end;

begin
TEXT(DEV, "SHIFT TESTS...
");

A:= $0F00;
B:= $00A0;
C:= A >> 3;
if C # $01E0 then ERROR("SHIFT A>>3");
C:= B >> 1;
if C # $0050 then ERROR("SHIFT B>>1");
C:= $FF00 >> 9;
if C # $007F then ERROR("SHIFT $FF00>>9");
C:= A >> 0;
if C # A then ERROR("SHIFT A>>0");

C:= A << 5;
if C # $E000 then ERROR("SHIFT A<<5");
C:= B << 1;
if C # $0140 then ERROR("SHIFT B<<1");
C:= $0FF0 << 9;
if C # $E000 then ERROR("SHIFT $0FF0<<9");
A:= A << 0;
if A # $0F00 then ERROR("SHIFT A<<0");

for N:=1,1000 do
	begin
	A:= RAN($7FFF);		\NOTE THAT "A" IS POSITIVE
	B:= RAN(32);

	C:= 1;
	for M:=1, B do
		C:= C +C;

	if A<<B # A*C then SHERROR;

	if C>0 then
	    if A>>B # A/C then SHERROR;
	end;
end;	\SHIFT



proc	LOGICAL;
int	A, B, N;

	proc	LOGERROR;
	begin
	ERROR("LOGICAL EXPRESSION");
	\A = $XXXX	B = $XXXX
	TEXT(DEV, "A = $"); HEXOUT(DEV, A);
	TEXT(DEV, "	B = $"); HEXOUT(DEV, B);
	CRLF(DEV);
	end;

begin
TEXT(DEV, "LOGICAL TESTS...
");
for N:=1,1000 do
	begin
	A:= RAN($7FFF);
	B:= RAN($7FFF);
	if (A|B) # (A&~B ! ~A&B) then LOGERROR;
	end;
end;	\LOGICAL



proc	STRING;
char	A, P, S;
int	I;
begin
TEXT(DEV, "STRING TESTS...
");
A:= "_ELLO "+2;
if A(2) # ^O then ERROR("STRING ADDRESS + CONSTANT");
S:= A-2;
A(-2):= ^h;
S(0):= S(0) -$20;
I:= 0;
for P:= A-2, A+2 do
	begin
	if P(0) # S(I) then ERROR("P(0) # S(I)");
	I:= I +1;
	end;
end;	\STRING



proc	MISC;
real	X,Y,Z;
int	I,J,K;
real	CT, ST;
begin
TEXT(DEV, "MISC TESTS...
");

TRAP(false);
J:= 0;
J:= I /0;
TRAP(true);
if GETERR=0 \! J#$7FFF \ then ERROR("DIVIDE BY ZERO");

FORMAT(10,10);
OPENI(8); OPENO(8);
X:= 123.456;
RLOUT(8,X); CRLF(8);
if RLABS(X-RLIN(8)) > .0001 then ERROR("RLOUT 123.456");

OPENI(8); OPENO(8);
X:= 43210.9;
RLOUT(8,X); CRLF(8);
if RLABS(X-RLIN(8)) > .01 then ERROR("RLOUT 43210.9");

OPENI(8); OPENO(8);
X:= 65535.0;
RLOUT(8,X); CRLF(8);
if RLABS(X-RLIN(8)) > .01 then ERROR("RLOUT 65535.0");

OPENI(8); OPENO(8);
X:= 65536.1;
RLOUT(8,X); CRLF(8);
if RLABS(X-RLIN(8)) > .01 then ERROR("RLOUT 65536.1");

OPENI(8); OPENO(8);
X:= 65537.2;
RLOUT(8,X); CRLF(8);
if RLABS(X-RLIN(8)) > .01 then ERROR("RLOUT 65537.2");

TEXT(DEV, "DOES 65537.2 = ");
RLOUT(DEV,X); CRLF(DEV);

OPENI(8); OPENO(8);
K:= 12345;
INTOUT(8,K); CRLF(8);
if K # INTIN(8) then ERROR("INTOUT 12345");

OPENI(8); OPENO(8);
K:= 32766;
INTOUT(8,K); CRLF(8);
if K # INTIN(8) then ERROR("INTOUT 32766");

OPENI(8); OPENO(8);
K:= 32767;
INTOUT(8,K); CRLF(8);
if K # INTIN(8) then ERROR("INTOUT 32767");

OPENI(8); OPENO(8);
K:= -32767;
INTOUT(8,K); CRLF(8);
if K # INTIN(8) then ERROR("INTOUT -32767");

OPENI(8); OPENO(8);
K:= -32768;
INTOUT(8,K); CRLF(8);
if K # INTIN(8) then ERROR("INTOUT -32768");

CT:= 5.0;  ST:= 4.0;
OPENI(8); OPENO(8);
RLOUT(8, if CT#0.0 then ST else CT);
CRLF(8);
if RLIN(8) # ST then ERROR("if true then ST else CT");
end;	\MISC



proc	SIEVE;		\Eratosthenes Sieve prime number program
define	SIZE = 8190;
addr	FLAGS;
integer	I, PRIME, K, COUNT, ITER;

begin
TEXT(DEV, "SIEVE TEST...
");
FLAGS:= RESERVE(SIZE+1);		\Allocate array space
COUNT:= 0;				\Prime counter
for I:= 0, SIZE do
	FLAGS(I):= true;		\Set flags all true
for I:= 0, SIZE do
    if FLAGS(I) then			\Found a prime
	begin
	PRIME:= I+I+3;			\Twice the index + 3
	\INTOUT(DEV, PRIME);   CRLF(DEV);
	K:= I + PRIME;			\First multiple to kill
	while K <= SIZE do
		begin
		FLAGS(K):= false;	\Zero a non-prime
		K:= K + PRIME; 		\Next multiple
		end;
	COUNT:= COUNT + 1;		\Primes found
	end;

if COUNT # 1899 then
	begin
	ERROR("SIEVE");
	INTOUT(DEV, COUNT);   TEXT(DEV, " PRIMES.  SHOULD BE 1899.
");
	end;
end;	\SIEVE



begin	\MAIN
OPENO(DEV);
TEXT(DEV, "XPL TESTER...
");
ERRFLG:= false;

IF;
FOR;
ARGUMENT;
COMPARE;
CONARRAY;
SHIFT;
LOGICAL;
STRING;
MISC;
SIEVE;
TEXT(DEV, "ALL DONE
");
if ~ERRFLG then TEXT(DEV, "NO ERRORS DETECTED
");
CLOSE(DEV);
exit;
end	\MAIN (no semi and no crlf i.e: eof in a comment)