\XPLV3C.XPL - THE FIRST VERSION IN V3 SYNTAX-JAN 1978


\	COPYRIGHT P.J.R.BOYLE. 1977,78

\THIS IS THE RESIDENT VERSION OF THE TRANSLATOR/EXECUTIVE.
\IT READS SOURCE CODE FROM AN INPUT DEVICE AND STORES THE
\RESULTING I2L CODE IN ONE OF ITS OWN ARRAYS, WHICH IT THEN
\EXECUTES. A SYSTEM FLAG, MANIPULATED BY THE RERUN AND
\ISRUN FUNCTIONS, IS USED TO DECIDE WETHER TO ASK FOR A
\NEW SOURCE OR REEXECUTE AN ALREADY RESIDENT USER PROGRAM.
\BOMBING THIS FLAG IS SOMETHING THE USER DOES EXTERNALLY.

\IT HAS BEEN SHORTENED AS MUCH AS IS REASONABLE. ALSO IT
\JUST STOPS AFTER THE FIRST SYNTAX ERROR
\(ERROR RETRACE IS TOO COSTLY).

\IN MANY CASES CONSTANTS ARE USED RATHER THAN MORE READABLE
\PRESET VARIABLES IN ORDER TO KEEP THE TOTAL NUMBER OF
\SYMBOLS REASONABLE.
\THE MAXIMUM NUMBER OF SYMBOLS IN SCOPE AT ONE TIME IS SET
\BY THE GLOBAL CONSTANT SYMAX - IT IS 64 IN THIS VERSION.
\VARIABLES AND TABLE SPACE USED BY THE COMPILER PORTION ARE
\RETURNED FOR USE AS USER STACK SPACE BEFORE INVOKING THE USER
\PROGRAM.

\LISTING AND ERROR MESSAGE PRINTOUTS HAVE BEEN DRASTICALLY
\REDUCED BUT EXPERIENCE SHOWS THAT THIS IS NOT TOO HARD TO
\LIVE WITH. THE USER MUST GET USED TO DEBUGGING AT THE XPL
\LEVEL RATHER THAN AT THE I2L LEVEL. THIS IS DONE BY INSERTING
\DIAGNOSTIC PRINTS IN THE FLOW OF THE PROGRAM.

\THESE ARE THE REQUIRED MACHINE LANGUAGE FUNCTIONS:
'CODE'

RESERVE=3,	SWAP=4,		CHIN=7,		CHOUT=8,
SKIP=9,		READ=10,	WRITE=11,	TEXT=12,
OPENI=13,	OPENO=14,	CLOSE=15,	ABORT=16,
CALL=17,	SPACE=18,	RERUN=19,	SETSP=21,
ISRUN=25;

\THE MOST GLOBAL VARIABLES:
'INTEGER'

USERSPACE,		\THE SIZE OF THE USER SPACE
SYMAX;			\THE SIZE OF THE SYMBOL TABLE

'ADDRESS'

USER;	\THIS IS THE SPACE INTO WHICH THE USER PROGRAM IS PLACED





'PROCEDURE'COMPILE;
\THIS PROCEDURE IS ALMOST ALL OF THE PROGRAM

'INTEGER'
TRUE,		FALSE,

\VARIABLES TO HOLD RESERVED WORD HASHES
ENDSYM,		BEGSYM,		INTSYM,		PROCYM,
ADRSYM,		IFSYM,		THENYM,		ELSEYM,
WHILYM,		DOSYM,		CODSYM,		QUITYM,
LOOPYM,		RETSYM,		GESYM,		LESYM,
EOFSYM,		GETSYM,		FORSYM,		NOTSYM;

'INTEGER'
\INTEGER VARIABLES FOR ACTUAL PROCESSING

	ATOM,	\PRESENT ATOM DESCRIPTOR
		\CONTAINS RESERVED WORD HASH OR THE ASCII FOR
		\A SPECIAL CHARACTER. 0 IF THE ATOM IS A
		\CONSTANT OR IDENTIFIER
	ATYPE,	\PRESENT ATOM TYPE DESCRIPTOR:
		\0 FOR RESERVED WORDS OR SPECIAL CHARACTERS
		\1 FOR IDENTIFIERS
		\2 FOR CONSTANTS
	IDTYP,	\PRESENT IDENTIFIER TYPE DESCRIPTOR:
		\0= UNDEFINED
		\1= INTEGER VARIABLE
		\2= ADDRESS VARIABLE
		\4= PROCEDURE NAME
		\5= MACHINE LANGUAGE FUNCTION NAME
	LEV,	\LEVEL OF CURRENT IDENTIFIER
	VAL,	\VALUE OR ADDRESS OF CURRENT IDENTIFIER
	IATOM,	\VALUE OF CURRENT CONSTANT
	NOSYM,	\NUMBER OF SYMBOLS IN SYMBOL TABLE
	LEVEL,	\LEVEL OF CURRENT PROCEDURE
	CHAR,	\CURRENT CHARACTER BUFFER. MOST OF THE TIME
		\IT CONTAINS THE TERMINATOR OF THE CURRENT ATOM
	CC,	\INDEX TO CURRENT CHARACTER IN THE INPUT LINE
	LL,	\LENGTH OF THE CURRENT INPUT LINE
	T,	\GENERAL TEMPORARY
	PC,	\THE RELATIVE PROGRAM COUNTER
	DX,	\HEAP SPACE REQUIREMENT COUNTER
	STRFLG,	\BOOLEAN- STRING FLAG
	FIXCNT,	\COUNT OF THE NUMBER OF OUTSTANDING QUITS
	CASEIN,	\BOOLEAN- CASE SWITCH
	ALPHA,	\BOOLEAN- CURRENT CHAR IS ALPHABETIC
	NUMBER,	\BOOLEAN- CURRENT CHAR IS NUMERIC
	ALFNUM,	\BOOLEAN- ALPHA OR NUMBER
	LSTDEV,	\LISTING DEVICE NUMBER
	SRCDEV,	\SOURCE INPUT DEVICE NUMBER
	HASH;	\CURRENT IDENTIFIER HASH
'ADDRESS'

	LINE,	\SOURCE INPUT LINE BUFFER
	IDENT,	\CURRENT IDENTIFIER NAME
	SYMBOL,	\SYMBOL TABLE
	SYMTYP,	\SYMBOL TYPE DESCRIPTORS
	SYMLEV,	\SYMBOL LEVELS
	SYMVAL,	\SYMBOL VALUES OR ADDRESSES
	SYMPNT,	\SYMBOL LIST LINKAGE POINTERS
	FIXES,	\QUIT FIXES STILL OUTSTANDING
	BOX;	\HASH BOXES (SYMBOL LIST HEADERS)


'PROCEDURE'ERROR(I);
'INTEGER' I;


'PROCEDURE'ERRMES(DEV);
'INTEGER'DEV;
'BEGIN'
SKIP(DEV);
TEXT(DEV,"***** ERROR NO ");
WRITE(DEV,I);
TEXT(DEV," *****");
SKIP(DEV);
'FOR'T:=0,LL'DO'CHOUT(DEV,LINE(T));
SKIP(DEV);
'FOR'T:=0,CC-3'DO'
	'IF'LINE(T)#\TAB\9'THEN'CHOUT(DEV,^ )
	'ELSE'CHOUT(DEV,\TAB\9);
CHOUT(DEV,\UPARROW\28);
SKIP(DEV);
'END';

'BEGIN'\ERROR
ERRMES(LSTDEV);
'IF'LSTDEV#0'THEN'ERRMES(0);
CLOSE(LSTDEV);
ABORT;
'END';\ERROR


'PROCEDURE'INCH;

'PROCEDURE'INCHX;
'BEGIN'
'IF'CHAR#EOFSYM'THEN'CHAR:=CHIN(SRCDEV)
'ELSE''IF'STRFLG'THEN'ERROR(63);
'IF'CHAR=^^'THEN'
	'BEGIN'
	CHOUT(LSTDEV,CHAR);
	CHAR:=CHIN(SRCDEV)!128;
	'END';
'END';\INCH

'PROCEDURE'PUTX;
'IF'(CHAR#\RET\13)'THEN'
	['IF'CHAR#\LF\10'THEN'CHOUT(LSTDEV,CHAR&127);INCHX];

'BEGIN'\INCH
\TAKE OUT LINE FEEDS, FORM FEEDS AND COMMENTS
INCHX;
'IF'STRFLG'THEN'['IF'CHAR=^"'THEN'STRFLG:=FALSE]
'ELSE'	'BEGIN'
	'WHILE'
	  (CHAR=\LF\10)!(CHAR=\FF\12)'DO'PUTX;
	'IF'CHAR=^\'THEN'
		'BEGIN'
		\IGNORE COMMENTS
		PUTX;
		'WHILE'(CHAR#^\)&(CHAR#\RET\13)'DO'PUTX;
		PUTX;
		'END';
	'IF'CHAR=^"'THEN'STRFLG:=TRUE;
	'END'
'END'\INCH\;



'PROCEDURE'GETCH;
'BEGIN'\GETCH
'IF' CC>LL 'THEN'
	'BEGIN'
	SKIP(LSTDEV);
	LL:=0;
	CC:=0;
	INCH;
	'WHILE'(CHAR#\RET\13)&(CHAR#EOFSYM)
	'DO'
		'BEGIN'
		LINE(LL):=CHAR;
		CHOUT(LSTDEV,CHAR&127);
		INCH;
		LL:=LL+1;
		'IF'LL>79'THEN'ERROR(1);
		'END';
	LINE(LL):=CHAR;
	'END';
CHAR:=LINE(CC);
CC:=CC+1;
'IF'CHAR=\SINGLE QUOTE\39'THEN'
	'BEGIN'
	CASEIN:='NOT'CASEIN;
	CHAR:=^ ;
	'END';

\SWITCH CASE IF CASEIN IS TRUE\
'IF'CASEIN&(CHAR>=^A)&(CHAR<=^Z)
	'THEN'CHAR:=CHAR+32;

'IF'((CHAR>=^A)&(CHAR<=^Z)) !
    ((CHAR>=\LOWER CASE A\97)&(CHAR<=\LOWER CASE Z\122))
	'THEN'ALPHA:=TRUE
	'ELSE'ALPHA:=FALSE;

'IF'(CHAR>=^0)&(CHAR<=^9)
	'THEN'NUMBER:=TRUE
	'ELSE'NUMBER:=FALSE;

'IF'ALPHA!NUMBER'THEN'ALFNUM:=TRUE'ELSE'ALFNUM:=FALSE;

'END'\GETCH\;



'PROCEDURE'RATOM;
'INTEGER'LEN;

'BEGIN'\READ IN AN ATOM\
'WHILE'
   (CHAR=^ )!(CHAR=\RET\13)!(CHAR=\TAB\9)
'DO'GETCH;

'IF'(CHAR>=\LOWER CASE A\97)&(CHAR<=\LOWER CASE Z\122)'THEN'
	'BEGIN'
	\RESERVED WORD\
	ATOM:=CHAR;
	GETCH;
	ATOM:=(ATOM+SWAP(CHAR));
	'WHILE'ALPHA'DO'GETCH;
	ATYPE:=0;
	'END'

'ELSE''IF'ALPHA'THEN'
	'BEGIN'
	\IDENTIFIER\
	LEN:=0;HASH:=0;
	'WHILE'ALFNUM'DO'
		'BEGIN'
		'IF'CHAR>=\LOWER CASE A\97'THEN'ERROR(64);
		'IF'LEN<6'THEN'
			'BEGIN'
			IDENT(LEN):=CHAR;
			HASH:=HASH+CHAR;
			LEN:=LEN+1;
			'END';
		GETCH;
		'END';
	'FOR'LEN:=LEN,5'DO'
		'BEGIN'
		IDENT(LEN):=^ ;
		HASH:=HASH+^ ;
		'END';
	ATYPE:=1;
	ATOM:=0;
	HASH:=HASH&63;
	'END'

'ELSE''IF'NUMBER'THEN'
	'BEGIN'
	\CONSTANT\
	IATOM:=0;
	'WHILE'NUMBER'DO'
		[IATOM:=IATOM*10+CHAR-^0;GETCH];
	ATYPE:=2;
	ATOM:=0;
	'END'
'ELSE'
	'BEGIN'
	\SPECIAL CHARACTER\
	'IF'LINE(CC)=^='THEN'
		'BEGIN'
		'IF'CHAR=^:'THEN'
			[GETCH;ATOM:=GETSYM]
		'ELSE''IF'CHAR=^>'THEN'
			[GETCH;ATOM:=GESYM]
		'ELSE''IF'CHAR=^<'THEN'
			[GETCH;ATOM:=LESYM]
		'ELSE'ATOM:=CHAR;
		'END'
	'ELSE'ATOM:=CHAR;
	ATYPE:=0;
	GETCH;
	'END';
'END'\OF RATOM\;




'PROCEDURE'INSBIN(I);
'INTEGER'I;

'BEGIN'\INSBIN\
'IF'PC>USERSPACE'THEN'ERROR(2);
USER(PC):=I;
PC:=PC+1;
'END'\INSBIN\;



'PROCEDURE'GEN(OP,LEV,VAL,CL);
'INTEGER'OP,LEV,VAL,CL;

'BEGIN'\GEN\
\THE ENCODING OF THE CLASS, CL IS A 4 BIT BINARY CODE...
\0:=OP CODE ONLY, 1 BYTE
\2:=OP WITH ONE BYTE VALUE
\3:=OP WITH VALUE, 3 BYTES
\7:=OP WITH ADDRESS, 3 BYTES
\10:=OP WITH LEVEL AND ONE BYTE OFFSET (IN VAL)
\15:=OP WITH LEVEL AND ADDRESS, 4 BYTES
INSBIN(OP);
'IF'CL&8'THEN'INSBIN(LEV);
'IF'CL&4'THEN'VAL:=VAL+USER;
'IF'CL&2'THEN'INSBIN(VAL);
'IF'CL&1'THEN'INSBIN(SWAP(VAL));
'END'\GEN\;


'PROCEDURE'FIX(I);
'INTEGER'I,J;

'BEGIN'\FIX FORWARD REFRENCES\
J:=PC+USER;
USER(I+1):=J;
USER(I+2):=SWAP(J);
'END'\FIX\;



'PROCEDURE'LOOKUP;
'INTEGER'I,K,PNTR;

'BEGIN'\LOOKUP
PNTR:=BOX(HASH);
'LOOP'
	'BEGIN'
	'IF'PNTR=\EMPTY\255'THEN'[IDTYP:=0;'QUIT'];
	I:=0;
	K:=PNTR;
	'WHILE'(IDENT(I)=SYMBOL(K))&(I<6)
		'DO'[I:=I+1;K:=K+SYMAX];
	'IF'I=6'THEN'
		'BEGIN'
		IDTYP:=SYMTYP(PNTR);
		VAL:=SYMVAL(PNTR)+SWAP(SYMVAL(PNTR+SYMAX));
		LEV:=SYMLEV(PNTR);
		'QUIT';
		'END';
	PNTR:=SYMPNT(PNTR);
	'END';

'END';\LOOKUP




'PROCEDURE'INSERT(STYP,SLEV,SVAL);
'INTEGER'STYP,SLEV,SVAL,I,K;

'BEGIN'\INSERT\
LOOKUP;
'IF'(IDTYP#0)&(LEV=LEVEL)'THEN'ERROR(11);
'IF'NOSYM>=SYMAX'THEN'ERROR(3);
K:=NOSYM;
'FOR'I:=0,5'DO'
	'BEGIN'
	SYMBOL(K):=IDENT(I);
	K:=K+SYMAX;
	'END';
SYMLEV(NOSYM):=SLEV;
SYMVAL(NOSYM):=SVAL;
SYMVAL(NOSYM+SYMAX):=SWAP(SVAL);
SYMTYP(NOSYM):=STYP;
SYMPNT(NOSYM):=BOX(HASH);
BOX(HASH):=NOSYM;
NOSYM:=NOSYM+1;
'END'\INSERT\;





'PROCEDURE'INTDEF;
'BEGIN'
\DEFINE INTEGER VARIABLES\
'WHILE'ATYPE=1'DO'
	'BEGIN'
	INSERT(1,LEVEL,DX);
	DX:=DX+2;
	RATOM;
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;
'END'\INTEGER DEFINITION\;


'PROCEDURE'ADRDEF;
'BEGIN'
\DEFINE ADDRESS VARIABLES\
'WHILE'ATYPE=1'DO'
	'BEGIN'
	INSERT(2,LEVEL,DX);
	DX:=DX+2;
	RATOM;
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;
'END'\ADDRESS DEFINITION\;

'PROCEDURE'CODDEF;
'BEGIN'
\DEFINE MACHINE LANGUAGE FUNCTION NAMES\
'WHILE'ATYPE=1'DO'
	'BEGIN'
	RATOM;
	'IF'ATOM#^='THEN'ERROR(40);
	RATOM;
	'IF'ATYPE#2'THEN'ERROR(42);
	'IF'(IATOM<0)!(IATOM>63)
		'THEN'ERROR(6);
	INSERT(5,0,IATOM+64);
	RATOM;
	'IF'ATOM=^,'THEN'RATOM;
	'END';
'IF'ATOM#^;'THEN'ERROR(41);
RATOM;
'END'\FUNCTION NAME DEFINITION\;


'PROCEDURE'BOOLEXP;
'INTEGER'OP;


'PROCEDURE'EXPRESSION;
'INTEGER'OP;


'PROCEDURE'FACTOR;
'INTEGER'SVAL,SLEV,SPC,SCHAR;

'BEGIN'\FACTOR\
'IF'ATYPE=0'THEN'
	'BEGIN'
	'IF'ATOM=^('THEN'
		'BEGIN'
		\PARENTHESIZED EXPRESSION\
		RATOM;
		BOOLEXP;
		'IF'ATOM#^)'THEN'ERROR(44);
		'END'
	'ELSE''IF'ATOM=^"'THEN'
		'BEGIN'
		\STRING CONSTANT\
		SVAL:=PC;
		GEN(\JMP\7,0,0,7);
		SPC:=PC;
		'WHILE'CHAR#^"'DO'
			'BEGIN'
			INSBIN(CHAR&127);
			SCHAR:=CHAR;
			GETCH;
			'END';
		PC:=PC-1;
		INSBIN(SCHAR+128);
		GETCH;
		FIX(SVAL);
		GEN(\IMM\11,0,SPC,7);
		'END'
	'ELSE''IF'(ATOM>=128)&(ATOM<256)'THEN'
		GEN(\IMM\11,0,ATOM&127,3)
	'ELSE'ERROR(26);
	RATOM;
	'END'

'ELSE''IF'ATYPE=2'THEN'
	'BEGIN'
	\LITERAL INTEGER CONSTANT\
	GEN(\IMM\11,0,IATOM,3);
	RATOM;
	'END'
'ELSE'
	'BEGIN'
	\IDENTIFIER\
	LOOKUP;
	'IF'IDTYP=0'THEN'ERROR(10);
	'IF'IDTYP=1'THEN'
		'BEGIN'
		\INTEGER VARIABLE\
		GEN(\LOD\1,LEV,VAL,10);
		RATOM;
		'END'
	'ELSE''IF'IDTYP=2'THEN'
		'BEGIN'
		\ADDRESS VARIABLE\
		RATOM;
		'IF'ATOM#^('THEN'GEN(\LOD\1,LEV,VAL,10)
		'ELSE'
			'BEGIN'
			\ARRAY ELEMENT REFRENCE\
			SLEV:=LEV;
			SVAL:=VAL;
			RATOM;
			EXPRESSION;\INDEX\
			'IF'ATOM#^)'THEN'ERROR(44);
			GEN(\LDX\2,SLEV,SVAL,10);
			RATOM;
			'END';
		'END'
	'ELSE''IF'IDTYP=5'THEN'
		'BEGIN'
		\FUNCTION\
		SVAL:=VAL;
		RATOM;
		'IF'ATOM=^('THEN'
			'BEGIN'
			RATOM;
			BOOLEXP  \FIRST ARG\;
			'WHILE'ATOM=^,'DO'
				[RATOM;BOOLEXP];
			'IF'ATOM#^)'THEN'ERROR(44);
			RATOM;
			'END';
		GEN(\CML\12,0,SVAL,2);
		'END'
	'ELSE'ERROR(27);
	'END'\IDENTIFIER\;
'END'\FACT\;



'PROCEDURE'TERM;
'INTEGER'OP;

'BEGIN'\TERM\
FACTOR;
'WHILE'(ATOM=^*)!(ATOM=^/)'DO'
	'BEGIN'
	OP:=ATOM;
	RATOM;
	FACTOR;
	'IF'OP=^*'THEN'GEN(\MUY\15,0,0,0)
	'ELSE'GEN(\DIV\16,0,0,0);
	'END';
'END'\TERM\;


'BEGIN'\EXPRESS\
'WHILE'ATOM=^+'DO'RATOM;
'IF'ATOM=^-'THEN'
	[RATOM;EXPRESSION;GEN(\NEG\17,0,0,0)]
'ELSE'TERM;
'WHILE'(ATOM=^+)!(ATOM=^-)'DO'
	'BEGIN'
	OP:=ATOM;
	RATOM;
	TERM;
	'IF'OP=^+'THEN'GEN(\ADD\13,0,0,0)
	'ELSE'GEN(\SUB\14,0,0,0);
	'END';
'END'\EXPRES\;




'PROCEDURE'LOGEXP;
'INTEGER'OP;

'BEGIN'\LOGEXP\
EXPRESSION;
'IF'	(ATOM=^=)!(ATOM=^#)!(ATOM=^>)!
	(ATOM=^<)!(ATOM=GESYM)!(ATOM=LESYM)
'THEN'	'BEGIN'
	OP:=ATOM;RATOM;EXPRESSION;
	'IF'OP=^='THEN'GEN(\EQ\18,0,0,0)
	'ELSE''IF'OP=^#'THEN'GEN(\NE\19,0,0,0)
	'ELSE''IF'OP=^>'THEN'GEN(\GT\21,0,0,0)
	'ELSE''IF'OP=^<'THEN'GEN(\LT\23,0,0,0)
	'ELSE''IF'OP=GESYM'THEN'GEN(\GE\20,0,0,0)
	'ELSE'GEN(\LE\22,0,0,0);
	'END';
'END'\LOGEXP\;




'BEGIN'\BOOLEXP\
'IF'ATOM=NOTSYM'THEN'
	[RATOM;BOOLEXP;GEN(\NOT\28,0,0,0)]
'ELSE'LOGEXP;
'WHILE'(ATOM=^!)!(ATOM=^&)'DO'
	'BEGIN'
	OP:=ATOM;
	RATOM;
	LOGEXP;
	'IF'OP=^!'THEN'GEN(\OR\26,0,0,0)
	'ELSE'GEN(\AND\27,0,0,0);
	'END';
'END'\BOOLEXP\;

'PROCEDURE'ASSIGN;
'INTEGER'SVAL,SLEV,OP,ACNT;

'BEGIN'
\INCLUDES PROC CALLS\

'IF'ATYPE#1'THEN'ERROR(20);
LOOKUP;
'IF'IDTYP=0'THEN'ERROR(10);
'IF'IDTYP=4'THEN'
	'BEGIN'
	\PROCEDURE CALL\
	SVAL:=VAL;
	SLEV:=LEV+2;
	RATOM;
	'IF'ATOM=^('THEN'
		'BEGIN'
		ACNT:=1;
		RATOM;
		BOOLEXP\FIRST ARG\;
		'WHILE'ATOM=^,'DO'
			[RATOM;BOOLEXP;ACNT:=ACNT+2];
		'IF'ATOM#^)'THEN'ERROR(44);
		RATOM;
		GEN(\ARG\10,0,ACNT,2);
		'END';
	GEN(\CAL\5,SLEV,SVAL,15);
	'END'
'ELSE''IF'IDTYP=5'THEN'
	'BEGIN'
	\MACHINE ROUTINE CALL\
	SVAL:=VAL;
	RATOM;
	'IF'ATOM=^('THEN'
		'BEGIN'
		RATOM;
		BOOLEXP   \FIRST ARG\;
		'WHILE'ATOM=^,'DO'
			[RATOM;BOOLEXP];
		'IF'ATOM#^)'THEN'ERROR(44);
		RATOM;
		'END';
	GEN(\CML\12,0,SVAL,2);
	'END'

'ELSE'
	'BEGIN'\TRUE ASSIGN\
	SLEV:=LEV;
	SVAL:=VAL;
	'IF'IDTYP=1'THEN'
		'BEGIN'
		\STORE INTO VARIABLE\
		OP:=1;
		RATOM;
		'END'
	'ELSE''IF'IDTYP=2'THEN'
		'BEGIN'
		\STORE TO ARRAY\
		RATOM;
		'IF'ATOM=^('THEN'
			'BEGIN'
			OP:=2;
			RATOM;
			BOOLEXP;
			'IF'ATOM#^)'THEN'ERROR(44);
			RATOM;
			'END'
		'ELSE'OP:=1;
		'END'\ARRAY STORE\;
	'IF'ATOM#GETSYM'THEN'ERROR(21);
	RATOM;
	BOOLEXP;
	'IF'OP=1'THEN'GEN(\STO\3,SLEV,SVAL,10)
	'ELSE'GEN(\STX\4,SLEV,SVAL,10);
	'END'\TRUE ASSIGN\;
'END'\PROC ASSIGN\;



'PROCEDURE'STAMNT;
'INTEGER'P2,P3,SFIXS,SLEV,SVAL;

'BEGIN'\STAMNT\
'IF'(ATOM=BEGSYM)!(ATOM=^[)'THEN'
	'BEGIN'\BLOCK STATEMENT\
	RATOM;
	STAMNT;
	'WHILE'ATOM=^;'DO'
		[RATOM;STAMNT];
	'IF'ATOM=EOFSYM'THEN'ERROR(62);
	'IF'(ATOM#ENDSYM)&(ATOM#^])'THEN'ERROR(25);
	RATOM;
	'END'
'ELSE''IF'ATOM=QUITYM'THEN'
	'BEGIN'
	'IF'FIXCNT>9'THEN'ERROR(4);
	FIXES(2*FIXCNT):=PC;
	FIXES(2*FIXCNT+1):=SWAP(PC);
	FIXCNT:=FIXCNT+1;
	GEN(\JMP\7,0,0,7);
	RATOM;
	'END'
'ELSE''IF'ATOM=IFSYM'THEN'
	'BEGIN'
	\IF STATEMENT\
	RATOM;
	BOOLEXP;
	P3:=PC;
	GEN(\JPC\8,0,0,7);
	'IF'ATOM#THENYM'THEN'ERROR(22);
	RATOM;
	STAMNT;
	'IF'ATOM=ELSEYM'THEN'
		'BEGIN'
		P2:=PC;
		GEN(\JMP\7,0,0,7);
		FIX(P3);
		P3:=P2;
		RATOM;
		STAMNT;
		'END';
	FIX(P3);
	'END'
'ELSE''IF'ATOM=WHILYM'THEN'
	'BEGIN'
	\WHILE STATEMENT\
	RATOM;
	P2:=PC;
	BOOLEXP;
	P3:=PC;
	GEN(\JPC\8,0,0,7);
	'IF'ATOM#DOSYM'THEN'ERROR(23);
	RATOM;
	STAMNT;
	GEN(\JMP\7,0,P2,7);
	FIX(P3);
	'END'


'ELSE''IF'ATOM=RETSYM'THEN'
	\RETURN STATEMENT\
	[RATOM;GEN(\RET\6,0,0,0)]
'ELSE''IF'ATOM=LOOPYM'THEN'
	'BEGIN'
	\LOOP STATEMENT\
	SFIXS:=FIXCNT;
	RATOM;
	P2:=PC;
	STAMNT;
	GEN(\JMP\7,0,P2,7);
	'WHILE'FIXCNT>SFIXS'DO'
		'BEGIN'
		FIXCNT:=FIXCNT-1;
		FIX(FIXES(2*FIXCNT)+SWAP(FIXES(2*FIXCNT+1)));
		'END';
	'END'
'ELSE''IF'ATOM=FORSYM'THEN'
	'BEGIN'
	\FOR STATEMENT\
	RATOM;
	'IF'ATYPE#1'THEN'ERROR(43);
	LOOKUP;
	'IF'IDTYP#1'THEN'ERROR(43);
	SLEV:=LEV;
	SVAL:=VAL;
	RATOM;
	'IF'ATOM#GETSYM'THEN'ERROR(21);
	RATOM;
	BOOLEXP;
	GEN(\STO\3,SLEV,SVAL,10);
	'IF'ATOM#^,'THEN'ERROR(24);
	RATOM;
	BOOLEXP;
	'IF'ATOM#DOSYM'THEN'ERROR(23);
	GEN(\LOD\1,SLEV,SVAL,10);
	P2:=PC;
	GEN(\FOR\24,0,0,7);
	RATOM;
	STAMNT;
	GEN(\INC\25,SLEV,SVAL,10);
	GEN(\JMP\7,0,P2,7);
	FIX(P2);
	'END'
'ELSE''IF'
	(ATOM=ELSEYM)!(ATOM=^;)!
	(ATOM=^])!(ATOM=ENDSYM)
	'THEN'\NULL STATEMENT\
'ELSE''IF'ATOM=EOFSYM'THEN'ERROR(62)
'ELSE' ASSIGN;
'END'\STATEMENT\;



'PROCEDURE'PROGRAM;
'INTEGER'P1;

'PROCEDURE'PRODEF;
'INTEGER'P2,CDX,HASH,I,K;

'BEGIN'
\PROCEDURE DECLARATION\
INSERT(4,LEVEL,PC);
LEVEL:=LEVEL+2;
'IF'LEVEL>14'THEN'ERROR(5);
P2:=NOSYM;
CDX:=DX;
\NOW EAT THE ARGUMENT LIST AS A COMMENT
'WHILE'ATOM#^;'DO'RATOM;
RATOM;
PROGRAM;
DX:=CDX;
\NOW RESTORE SYMBOL TABLE TO PREVIOUS LEVEL
'WHILE'NOSYM>P2'DO'
	'BEGIN'
	NOSYM:=NOSYM-1;
	HASH:=0;
	K:=NOSYM;
	'FOR'I:=0,5'DO'[HASH:=HASH+SYMBOL(K);K:=K+SYMAX];
	BOX(HASH&63):=SYMPNT(NOSYM);
	'END';

LEVEL:=LEVEL-2;
'IF'ATOM#^;'THEN'ERROR(25);
RATOM;
'END'\PROCEDURE DEFINITION\;


'BEGIN'\PROC PROGRAM\
DX:=0;
P1:=PC;
GEN(\JMP\7,0,0,7);
'WHILE'(ATOM=CODSYM)!(ATOM=INTSYM)!(ATOM=ADRSYM)
'DO'
	'IF'ATOM=CODSYM'THEN'[RATOM;CODDEF]
	'ELSE''IF'ATOM=INTSYM'THEN'[RATOM;INTDEF]
	'ELSE'[RATOM;ADRDEF];
'WHILE'ATOM=PROCYM'DO'[RATOM;PRODEF];
'IF'PC=P1+3'THEN'PC:=P1
'ELSE'FIX(P1);
'IF'DX#0'THEN'GEN(\SPI\9,0,DX,2);
STAMNT;
GEN(\RET\6,0,0,0);
'IF'FIXCNT#0'THEN'ERROR(60);
'END'\PROGRAM\;




'BEGIN'\COMPILE\

EOFSYM:=\CTRL-Z\26;

\RESERVE ARRAYS\
LINE:=RESERVE(80);
IDENT:=RESERVE(6);
SYMBOL:=RESERVE(6*SYMAX);
SYMTYP:=RESERVE(SYMAX);
SYMVAL:=RESERVE(2*SYMAX);
SYMLEV:=RESERVE(SYMAX);
SYMPNT:=RESERVE(SYMAX);
BOX:=RESERVE(64);
FIXES:=RESERVE(20);

\RESERVED WORD HASHES\
ENDSYM:=28261;	INTSYM:=28265;	BEGSYM:=25954;	PROCYM:=29296;
ADRSYM:=25697;	IFSYM:=26217;	THENYM:=26740;	ELSEYM:=27749;
WHILYM:=26743;	DOSYM:=28516;	CODSYM:=28515;	QUITYM:=30065;
LOOPYM:=28524;	RETSYM:=25970;	LESYM:=25964;	GESYM:=25959;
GETSYM:=25971;	FORSYM:=28518;	NOTSYM:=28526;

SKIP(0);
TEXT(0,"GIVE DEVICES <LIST,SOURCE>");
LSTDEV:=READ(0);
SRCDEV:=READ(0);
OPENO(LSTDEV);
OPENI(SRCDEV);

\PRESET SOME THINGS\

TRUE:=(0=0);		FALSE:=(0=1);
CHAR:=\RET\13;		CASEIN:=FALSE;		CC:=1;
LL:=0;			STRFLG:=FALSE;		PC:=0;
LEVEL:=0;		NOSYM:=0;		FIXCNT:=0;


GETCH;
RATOM;
\ZERO THE SYMBOL TABLE
'FOR'T:=0,5'DO'IDENT(T):=^ ;
'FOR'T:=0,63'DO'BOX(T):=\EMPTY\255;

PROGRAM;

'IF'ATOM=^;'THEN'RATOM;
'IF'ATOM#EOFSYM'THEN'ERROR(61);

SKIP(0);
TEXT(0,"PROGRAM LENGTH: ");
WRITE(0,PC+1);
SKIP(0);
CLOSE(LSTDEV);
USERSPACE:=PC+1;
TEXT(0,"(CR) TO EXECUTE");
OPENI(0);
T:=CHIN(0);

'END'\COMPILE\;


'BEGIN'\MAIN PROGRAM\


\INITIALISE IO DEVICES
OPENI(0);OPENO(0);
SKIP(0);
TEXT(0,"XPL0 V3C - JAN 1978");
SYMAX:=64;

\COMPILE PROGRAM IF NECCESARY
'IF'RERUN=0'THEN'
	'BEGIN'
	USERSPACE:=SPACE-(SYMAX*11+500);
	SKIP(0);
	TEXT(0,"USER SPACE =");
	WRITE(0,USERSPACE);
	USER:=RESERVE(USERSPACE);
	COMPILE;
	SETSP(USER+USERSPACE);
	ISRUN;
	'END'
'ELSE'USER:=RESERVE(USERSPACE);

\RUN THE USER PROGRAM
CHOUT(0,\FF\12);
CALL(USER);

'END';
