\XTOC.XPL	MAR-19-91
\CONVERT XPL SOURCE TO C SOURCE
\COPYRIGHT LARRY FISH 1989

\REVISION HISTORY:
\MAR-19-91, REVISED BY LB

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUTX=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXTX=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
	GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
	FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
	CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
	FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
	BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
	CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
	READPIX=44,	SETVID=45	FIX=50,		POUT=64,
	PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68;

	\VARIABLES FOR IBM DISKIO
int	SYSINF,		\POINTER SYSTEM TO INFO
	INHAND,		\INPUT HANDLE
	OUTHAND;	\OUTPUT HANDLE

int	PFLAG,		\FLAG: PREAMBLE HAS BEEN OUTPUTTED
	LPTR,		\LOOK AHEAD POINTER
	IDEV,		\INPUT DEVICE CHANNEL
	ODEV,		\OUTPUT DEVICE CHANNEL
	LOWSWT,		\FLAG: CASE SWITCH (')
	EOFLG,		\FLAGS END OF FILE
	CHAR;		\GLOBAL INPUT CHARACTER

addr	LOOK,		\ARRAY: LOOK AHEAD CHARACTERS
	IDENT;		\ARRAY: IDENTIFIER FROM GETIDENT

	\ASCII CHARACTERS 
def	BEL=$07, BS=$08, TAB=$09, LF=$0A, FF=$0C, CR=$0D,
	EOF=$1A, ESC=$1B, SP=$20, DEL=$7F;



proc	NOTES;
begin
TEXTX(0,"		-- XPL TO C CONVERTER, V1.1 --

This program does the bulk of the work in converting XPL to C.
However, it doesn't handle everything, for example:
   Intrinsics
   Array reserves
   Procedure nesting
   Parenthesis after procedure calls
   Square brackets around indexs in array variables
   Case statements
   Bit operators (& !)

Converting...");
end;	\NOTES



proc	CHOUT(D,C);	\CHOUT WITH SHIFT TO LOWERCASE
int	D,C;
CHOUTX(D, if C>=^A & C<=^Z then C+$20 else C);



proc	TEXT(D, S);	\TEXT WITH SHIFT TO LOWERCASE
int	D;
addr	S;
int	I,C;
begin
for I:= 0, 32000 do
	begin
	C:= S(I);
	if C >= $80 then [C:= C &$7F;   I:= 32000];
	CHOUT(D, C);
	end;
end;	\TEXT

\----------------------------------------------------------------------

func	STRCMP(S1,S2);	\RETURNS 'TRUE' IF STRINGS MATCH
addr	S1,S2;
int	I;
for I:= 0,32000 do
	[if S1(I)#S2(I) then return false;
	if S1(I)>$7F then return true];



func	ISUPPER(C);	\TEST FOR UPPERCASE
int	C;
return (C>=^A) & (C<=^Z);



func	ISLOWER(C);	\TEST FOR LOWERCASE
int	C;
return (C>=^a) & (C<=^z);



func	ISDIGIT(C);	\TEST FOR DIGIT
int	C;
return (C>=^0) & (C<=^9);



func	ISALPHA(C);	\TEST FOR ALPHA
int	C;
return ISLOWER(C) ! ISUPPER(C);



func	ISALPHANUM(C);	\TEST FOR ALPHA NUMERIC
int	C;
return ISALPHA(C) ! ISDIGIT(C);



proc	GETC;		\GET "CHAR" FROM INPUT DEVICE
begin
if EOFLG then return;
if LPTR>0 then
	[LPTR:= LPTR-1;   CHAR:= LOOK(LPTR)]
else 	CHAR:= CHIN(IDEV);
EOFLG:= CHAR=EOF;
end;	\GETC



proc	PUTBACK(C);	\PUT BACK A CHARACTER
int	C;
begin
LOOK(LPTR):= C;
LPTR:= LPTR+1;
end;	\PUTBACK



proc	DOCOMMENT;	\PASS COMMENT TO OUTPUT DEVICE
begin
TEXT(ODEV,"/* ");
loop	begin
	GETC;
	if EOFLG then return;
	if (CHAR=^\) ! (CHAR=CR) then quit;
	if ISUPPER(CHAR) then CHAR:= CHAR+$20;
	CHOUT(ODEV,CHAR);
	end;
TEXT(ODEV," */");
if CHAR=CR then CHOUT(ODEV,CR);
end;	\DOCOMMENT



proc	GETCC;		\GET "CHAR", PERFORM CASE SWITCH, AND SKIP COMMENTS
begin
loop	begin
	GETC;
	while CHAR=^' do [LOWSWT:= not LOWSWT;   GETC];
	if EOFLG then return;
	if LOWSWT & ISUPPER(CHAR) then CHAR:= CHAR+$20;
	if CHAR=^\ then DOCOMMENT else quit;
	end;
end;	\GETCC



proc	FINISH;		\SKIP TO NON-ALPHANUMERIC CHARACTER
begin
repeat	GETCC;
	if EOFLG then return;
until not ISALPHANUM(CHAR);
PUTBACK(CHAR);				\WARNING
end;	\FINISH



proc	GETIDENT;	\READ IN IDENTIFIER AND PUT IT INTO "IDENT"
int	P;
begin
while not ISUPPER(CHAR) do GETCC;	\SKIP TO UPPERCASE CHARACTER
P:= 0;
loop	begin
	IDENT(P):= CHAR;
	GETCC;
	if not ISALPHANUM(CHAR) then quit;
	P:= P+1;
	end;
IDENT(P):= IDENT(P)!$80;		\TERMINATE STRING
end;	\GETIDENT



proc	PASS;		\PASS ALPHANUMERIC STRING TO OUTPUT DEVICE
begin
GETCC;
while ISALPHANUM(CHAR) do
	begin
	if EOFLG then return;
	CHOUT(ODEV,CHAR);
	GETCC;	
	end;
end;	\PASS



proc	PASSTO(T);	\PASS INPUT STREAM UNTIL CHARACTER "T" TO OUTPUT
int	T;
begin
GETCC;
while CHAR#T do
	begin
	if EOFLG then return;
	CHOUT(ODEV,CHAR);
	GETCC;	
	end;
end;	\PASSTO



proc	DOMETA;		\CONVERT ^X TO 'X'
begin
TEXT(ODEV,"'");
GETC;
CHOUT(ODEV,CHAR);
TEXT(ODEV,"'");
end;	\DOMETA



proc	PASSNUMBER;	\PASS AND CONVERT NUMERIC VALUES
begin
repeat	GETCC;
	if EOFLG then return
until CHAR#SP & CHAR#TAB & CHAR#CR & CHAR#LF & CHAR#FF;

case CHAR of
  ^$:	TEXT(ODEV,"0x");
  ^^:	DOMETA
other CHOUT(ODEV,CHAR);
PASS;
end;	\PASSNUMBER



func	MATCH(S);	\RETURNS 'TRUE' IF INPUT MATCHES STRING "S"
addr	S;
addr	M;
int	I,P;
begin
M:= RESERVE(8);
P:= 0;
loop	begin
	M(P):= CHAR;
	if S(P)>$7F then quit;
	P:= P+1;
	GETCC;
	end;
M(P):= M(P)!$80;
if STRCMP(S,M) then return true;

for I:= 0,P do CHOUT(ODEV,M(I)&$7F);
return false;
end;	\MATCH



proc	DOSTRING;	\PASS A STRING TO OUTPUT DEVICE
begin
CHOUT(ODEV,CHAR);
repeat	GETC;
	if CHAR=CR then TEXT(ODEV,"\n");
	while CHAR=^^ do
		[CHOUT(ODEV,^%);   GETC;   CHOUT(ODEV,CHAR);   GETC];
	CHOUT(ODEV,CHAR);
until CHAR=^" ! EOFLG;
end;	\DOSTRING



func	LOWTRANS;	\TRANSLATE LOWERCASE STRINGS
int	O1,O2,O3;
begin
O1:= CHAR;
GETCC;   O2:= CHAR;
GETCC;   O3:= CHAR;
case of
  O1=^f & O2=^a & O3=^l:	\false
	begin
	FINISH;
	TEXT(ODEV,"FALSE");
	return true;	
	end;
  O1=^t & O2=^r & O3=^u:	\true
	begin
	FINISH;
	TEXT(ODEV,"TRUE");
	return true;
	end;
  O1=^n & O2=^o & O3=^t:	\not
	begin
	TEXT(ODEV,"!");
	return true;
	end
other	begin
	PUTBACK(O3);
	PUTBACK(O2);
	PUTBACK(O1);
	CHAR:= O1;
	return false;
	end;
end;	\LOWTRANS



func	TRANSLATE;	\TRANSLATE 
begin
if ISLOWER(CHAR) then return LOWTRANS
else	begin
	case CHAR of
	  ^":	DOSTRING;
	  ^>:	begin
		GETCC;
		if CHAR=^= then TEXT(ODEV,">=")
		else [PUTBACK(CHAR);   CHOUT(ODEV,^>)];
		end;
	  ^<:	begin
		GETCC;
		if CHAR=^= then TEXT(ODEV,"<=")
		else [PUTBACK(CHAR);   CHOUT(ODEV,^<)];
		end;
	  ^[:	TEXT(ODEV,"{");
	  ^]:	TEXT(ODEV,"}");
	  ^=:	TEXT(ODEV,"==");
	  ^#:	TEXT(ODEV,"!=");
	  ^$:	TEXT(ODEV,"0x");
	  ^!:	TEXT(ODEV,"||");	\or ! (bit operators)
	  ^&:	TEXT(ODEV,"&&");	\or &
	  ^~:	TEXT(ODEV,"!");		\or ~
	  ^|:	TEXT(ODEV,"^^");
	  ^^:	DOMETA
	other	CHOUT(ODEV,CHAR);
	end;
return true;
end;	\TRANSLATE



proc	EXPRESSION(T);		\TRANSLATE AND PASS EXPRESSION TO OUTPUT
int	T;
begin
loop	begin
	repeat GETCC until CHAR#CR & CHAR#LF;
	if EOFLG then return;
	if CHAR=T then quit;
	if not TRANSLATE then quit;
	end;
end;	\EXPRESSION

\----------------------------------------------------------------------

proc	DEFDEC;
int	DEFNUM;
begin
if not MATCH("def") then return;
FINISH;
DEFNUM:= 0;
repeat
\	while not ISALPHA(CHAR) do
\		[if CHAR#^, then CHOUT(ODEV,CHAR);   GETCC];
	GETIDENT;
	while CHAR#^= & CHAR#^, & CHAR#^; do GETCC;
	CRLF(ODEV);
	TEXT(ODEV,"#define ");
	TEXT(ODEV,IDENT);
	CHOUT(ODEV,TAB);
	if CHAR=^= then PASSNUMBER
	else [INTOUT(ODEV,DEFNUM);   DEFNUM:= DEFNUM+1];
until CHAR=^;;
end;	\DEFDEC



proc	ADDDEC;
begin
if MATCH("add") then
	begin
	FINISH;
	TEXT(ODEV,"char");
	end;
end;	\ADDDEC



proc	PRODEC;
begin
if MATCH("pro") then
	begin
	FINISH;
	GETIDENT;
	TEXT(ODEV,"void	");
	TEXT(ODEV,IDENT);
	if CHAR=^( then
		begin
		CHOUT(ODEV,^();
		PASSTO(^;)
		end
	else TEXT(ODEV,"(void)");
	end;
end;	\PRODEC



proc	DOBEGIN;
begin
if CHAR=^[ then CHOUT(ODEV,^{)
else if MATCH("beg") then
	begin
	FINISH;
	CHOUT(ODEV,^{);
	end;
end;	\DOBEGIN



proc	DOIF;
begin
if MATCH("if") then
	begin
	TEXT(ODEV,"if (");
	GETCC;   if CHAR#SP then PUTBACK;
	EXPRESSION(^t);
	if MATCH("the") then
		begin
		FINISH;
		TEXT(ODEV,")");
		end;
	end;
end;	\DOIF



proc	INTDEC;
begin
if MATCH("int") then
	begin
	FINISH;
	TEXT(ODEV,"int");
	end;
end;	\INTDEC



proc	DOI;
int	O1,O2;
begin
O1:= CHAR;
GETCC;
O2:= CHAR;
PUTBACK(O2);
CHAR:= O1;
case O2 of
  ^n:	INTDEC;
  ^f:	DOIF
other CHOUT(ODEV,CHAR);
end;	\DOI



proc	DOFOR;
begin
if MATCH("for") then
	begin
	TEXT(ODEV,"for (");
	GETCC;   if CHAR#SP then PUTBACK;
	GETIDENT;
	TEXT(ODEV,IDENT);
	GETCC;
	CHOUT(ODEV,^=);
	EXPRESSION(^,);
	TEXT(ODEV,"; ");
	TEXT(ODEV,IDENT);
	TEXT(ODEV,"<=");
	EXPRESSION(^d);
	if MATCH("do") then
		begin
		TEXT(ODEV,"; ");
		TEXT(ODEV,IDENT);		
		TEXT(ODEV,"++)");
		end;
	end;
end;	\DOFOR



proc	FPRODEC;
begin
if MATCH("fpr") then
	begin
	FINISH;
	while CHAR#^; do GETCC;
	end;
end;	\FPRODEC



proc	FUNDEC;
begin
if MATCH("fun") then
	begin
	FINISH;
	GETIDENT;
	TEXT(ODEV,"int	");
	TEXT(ODEV,IDENT);
	if CHAR=^( then
		begin
		CHOUT(ODEV,^();
		PASSTO(^;)
		end
	else TEXT(ODEV,"(void)");
	end;
end;	\FUNDEC



proc	DOF;
int	O1,O2;
begin
O1:= CHAR;
GETCC;
O2:= CHAR;
PUTBACK(O2);
CHAR:= O1;
case  O2 of
	^o:DOFOR;
	^p:FPRODEC;
	^u:FUNDEC
other CHOUT(ODEV,CHAR);
end;	\DOF



proc	REALDEC;
begin
if MATCH("rea") then
	begin
	TEXT(ODEV,"double");
	FINISH;
	end;
end;	\REALDEC



proc	DOREPEAT;
begin
if MATCH("rep") then
	begin
	FINISH;
	TEXT(ODEV,"do {");
	end;
end;	\DOREPEAT



proc	DORETURN;
begin
if MATCH("ret") then
	begin
	FINISH;
	TEXT(ODEV,"return (");
	GETCC;   if CHAR#SP then PUTBACK;
	EXPRESSION(^;);
	TEXT(ODEV,");");
	end;
end;	\DORETURN



proc	DOR;
int	O1,O2,O3;
begin
O1:= CHAR;
GETCC;O2:= CHAR;
GETCC;O3:= CHAR;
PUTBACK(O3);
PUTBACK(O2);
CHAR:= O1;
case  O3 of
	^p:DOREPEAT;
	^a:REALDEC;
	^t:DORETURN
other CHOUT(ODEV,CHAR);
end;	\DOR



proc	DOQUIT;
begin
if MATCH("qui") then
	begin
	FINISH;
	TEXT(ODEV,"break");
	end;
end;	\DOQUIT



proc	PREAMBLE;
begin
if PFLAG then return;
TEXT(ODEV,"
#define TRUE	1
#define FALSE	0
");
PFLAG:= true;
end;	\PREAMBLE



proc	CODDEC;
begin
TEXT(ODEV,"/*
c");
PASSTO(^;);
TEXT(ODEV,"
*/");
PREAMBLE;
end;	\CODDEC



proc	CHARDEC;
begin
if MATCH("cha") then
	begin
	FINISH;
	TEXT(ODEV,"char");
	end;
end;	\CHARDEC



proc	DOCASE;
begin
if MATCH("cas") then
	begin
	FINISH;
	TEXT(ODEV,"switch (");
	GETCC;   if CHAR#SP then PUTBACK;
	EXPRESSION(^o);
	FINISH;
	TEXT(ODEV,") {");
	end;
end;	\DOCASE



proc	DOC;
int	O1,O2;
begin
O1:= CHAR;
GETCC;
O2:= CHAR;
PUTBACK(O2);
CHAR:= O1;
case  O2 of
	^o: CODDEC;
	^h: CHARDEC;
	^a: DOCASE
other CHOUT(ODEV,CHAR);
end;	\DOC



proc	DOEND;
begin
if CHAR=^] then CHOUT(ODEV,^})
else if MATCH("end") then CHOUT(ODEV,^});
end;	\DOEND



proc	DOELSE;
begin
if MATCH("els") then
	begin
	FINISH;
	TEXT(ODEV,"; else");
	end;
end;	\DOELSE



proc	DOE;
int	O1,O2;
begin
O1:= CHAR;
GETCC;
O2:= CHAR;
PUTBACK(O2);
CHAR:= O1;
case  O2 of
	^l: DOELSE;
	^n: DOEND
other CHOUT(ODEV,CHAR);
end;	\DOE



proc	DOASSIGN;
begin
if MATCH(":=") then
	begin
	TEXT(ODEV,"=");
	EXPRESSION(^;);
	if CHAR=^; then CHOUT(ODEV,^;);
	end;
end;	\DOASSIGN



proc	DOUNTIL;
begin
if MATCH("unt") then
	begin
	FINISH;
	TEXT(ODEV,"} while (!(");
	GETCC;   if CHAR#SP then PUTBACK;
	EXPRESSION(^;);
	TEXT(ODEV,"));");
	end;
end;	\DOUNTIL



proc	DOLOOP;
begin
if MATCH("loo") then
	begin
	FINISH;
	TEXT(ODEV,"while (TRUE)");
	FINISH;
	end;
end;	\DOLOOP



proc	DOWHILE;
begin
if MATCH("whi") then
	begin
	FINISH;
	TEXT(ODEV,"while (");
	GETCC;   if CHAR#SP then PUTBACK;
	EXPRESSION(^d);
	FINISH;
	TEXT(ODEV,")");
	end;
end;	\DOWHILE



proc	DOOTHER;
begin
if MATCH("oth") then
	begin
	FINISH;
	TEXT(ODEV,"default");
	end;
end;	\DOOTHER



proc	DECODE;
begin
GETCC;
if EOFLG then return;
case CHAR of
  ^a:	ADDDEC;
  ^b,^[:DOBEGIN;
  ^c:	DOC;
  ^d:	DEFDEC;
  ^e:	DOE;
  ^f:	DOF;
  ^i:	DOI;
  ^l:	DOLOOP;
  ^o:	DOOTHER;
  ^p:	PRODEC;
  ^q:	DOQUIT;
  ^r:	DOR;
  ^u:	DOUNTIL;
  ^w:	DOWHILE;
  ^]:	DOEND;
  ^":	DOSTRING;
  ^^:	DOMETA;
  ^::	DOASSIGN
other CHOUT(ODEV,CHAR);
end;	\DECODE



proc	CONVERT;	\CONVERT XPL TO C
begin
repeat DECODE until EOFLG;
end;	\CONVERT

\-------------------- ROUTINES TO OPEN IBM FILES --------------------

proc	IBMOPEN;
int	PSEG,CSEG;
addr	TAIL,TLEN;


	func	MAKUP(C);		\CONVERT C TO UPPERCASE
	int	C;
	return if C>=^a & C<=^z then C-32 else C;



	proc	PARSE;		\PARSE COMMAND TAIL AND SET I/O HANDLES
	addr	EXT1,EXT2;
	int	P,EFLG,I;
	begin
	EXT1:= ".XPL";   EXT2:= ".C  ";

	P:= 0;
	EFLG:= false;

	loop	begin			\PARSE COMMAND TAIL FOR EXTENTION
		if TAIL(P)=^. then
			begin
			EFLG:= true;
			quit;
			end;
		P:= P+1;
		if P>=TLEN(0) then
			begin
			EFLG:= false;
			quit;
			end;
		end;

	if not EFLG then		\SET EXTENTION AND INPUT HANDLE
		for I:= 0, 3 do TAIL(P+I):= EXT1(I);
	INHAND:= FOPEN(TAIL,0);

	for I:= 0, 3 do TAIL(P+I):= EXT2(I); \SET EXTENTION AND OUTPUT HANDLE
	OUTHAND:= FOPEN(TAIL,1);
	end;


begin	\IBMOPEN
TLEN:= RESERVE(80);	\GET COMMAND TAIL FROM PSP
TAIL:= TLEN+1;
SYSINF:= GETREG;
PSEG:= SYSINF(11);
CSEG:= SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);
if TLEN(0)>79 then TLEN(0):= 79;

PARSE;			\PARSE COMMAND LINE AND SET HANDLES

FSET(INHAND,^I);	\OPEN FILES
FSET(OUTHAND,^O);
end;	\IBMOPEN

\----------------------------------------------------------------------

begin	\MAIN
SYSINF:= GETREG;
IDENT:= RESERVE(20);
LOOK:= RESERVE(20);

LPTR:= 0;
LOWSWT:= false;
PFLAG:= false;

NOTES;

IDEV:= 3;   ODEV:= 3;
IBMOPEN;
OPENI(IDEV);   OPENO(ODEV);
EOFLG:= false;

CONVERT;

CHOUT(ODEV,EOF);
CLOSE(ODEV);
FCLOSE(OUTHAND);
FCLOSE(INHAND);
end;	\MAIN
