\ZOOM.XPL	JUL-05-92

include	\CXPL\CODESI;

ext	ZOOMEXT;

int	CPUREG,
	MODE,
	;
seg addr IMAGE, SCREEN;

def	ESC=$1B;



func	GETVID;		\Returns the current video mode
begin			\Requires: CPUREG:= GETREG;
CPUREG(0):= $0F00;	\AX function $0F
SOFTINT($10);		\Call BIOS routine
return CPUREG(0) & $FF;
end;	\GETVID



proc	PALETTE(N, R, G, B);	\Set color register N
int	N,		\Register to set
	R, G, B;	\Red, Green, and Blue [0..255]
begin			\Requires: CPUREG:= GETREG;
CPUREG(0):= $1010;		\AX function $10, subfunction $10
CPUREG(1):= N;			\BX select color register
CPUREG(2):= G<<8 ! (B&$FF);	\CX green<<8 blue
CPUREG(3):= R<<8;		\DX red<<8
SOFTINT($10);			\Call BIOS routine
end;	\PALETTE



proc	FIXPALETTE;	\Make palette registers correspond to DAC registers
int	N;
begin			\Requires: CPUREG:= GETREG;
for N:= 0, 15 do
	begin
	CPUREG(0):= $1000;	\AX function $10, subfunction $00
	CPUREG(1):= N<<8!N;	\BX DAC and palette registers
	SOFTINT($10);		\Call BIOS routine
	end;
end;	\FIXPALETTE



proc	WAITVB;		\Wait for the beginning of the next vertical blank
def	CRTCSTAT= $3DA;		\For monochrome use $3BA
begin
while PIN(CRTCSTAT, 0) & $08 do;	\Wait for no vertical blank
repeat until PIN(CRTCSTAT, 0) & $08;	\Wait for vertical blank
end;	\WAITVB;



func	OPENMOUSE;	\Reset mouse and get status
int	FLAG;
begin			\Requires: CPUREG:= GETREG;
CPUREG(0):= $0000;
SOFTINT($33);		\Call BIOS routine

CPUREG(0):= $0007;	\horizontal limits
CPUREG(2):= 0;
CPUREG(3):= 640;
SOFTINT($33);		\Call BIOS routine


CPUREG(0):= $0008;	\vertical limits
CPUREG(2):= -$100;
CPUREG(3):= $1000;
SOFTINT($33);		\Call BIOS routine




return;

FLAG:= CPUREG(0);	\False if no mouse
if FLAG then
	begin		\Show mouse pointer
	CPUREG(0):= $0001;
	SOFTINT($33);	\Call BIOS routine
	end;
return FLAG;		\Return false if no mouse
end;	\OPENMOUSE



proc	MOUSE(N);
int	N;		\0 = X coordinate; 1 = Y coordinate
begin			\Requires: CPUREG:= GETREG
CPUREG(0):= $0003;
SOFTINT($33);		\Call BIOS routine
return if N then CPUREG(3) else CPUREG(2);
end;	\MOUSE



proc	BUTTON(N);
int	N;		\0 = left; 1 = right
int	M;
begin			\Requires: CPUREG:= GETREG
CPUREG(0):= $0003;
SOFTINT($33);		\Call BIOS routine
M:= CPUREG(1);
return if N then (M&2)=2 else (M&1)=1;
end;	\BUTTON

\======================================================================

proc	GETIMAGE;
int	HAND,
	I, J, R, G, B;
begin
IMAGE(0):= MALLOC(320/16*200);
HAND:= FOPEN("IMAGE.BMP", 0);
FSET(HAND, ^I);
OPENI(3);

for I:= 0, $39 do J:= CHIN(3);	\skip header
FIXPALETTE;
for I:= 1, $FF do		\read in colors
	begin
	B:= CHIN(3) >>2;
	G:= CHIN(3) >>2;
	R:= CHIN(3) >>2;
	J:= CHIN(3);
	PALETTE(I, R, G, B);	\Set color register
	end;

I:= 320 *200;
repeat	I:= I -1;
	J:= CHIN(3);
	SCREEN(0, I):= J;
	IMAGE(0, I):= J;
until I = 0;

FCLOSE(HAND);
end;	\GETIMAGE



proc	DOZOOM;
int	ZOOM, I;
begin
OPENMOUSE;
I:= 30;
loop	begin
\	WAITVB;
	ZOOM:= $100 +MOUSE(1);
\	ZOOM:= I;
\	I:= I +1;
\	if I> 500 then quit;	\I:= 30;
	ZOOMEXT(MOUSE(0)-320, IMAGE(0), ZOOM);
	if CHKKEY then
		if CHIN(1) = ESC then quit;
	if BUTTON(0) then quit;
	end;
end;	\DOZOOM



begin	\MAIN
CPUREG:= GETREG;

IMAGE:= RESERVE(2);
SCREEN:= RESERVE(2);
SCREEN(0):= $A000;

MODE:= GETVID;
SETVID($13);

GETIMAGE;
DOZOOM;

SETVID(MODE);
end;	\MAIN
