
\PROGRAM TO HANDLE APROTEK 1000 PROM BLASTER

include C:\CXPL\CODESI.XPL;


int	INHAND,OUTHAND;		\File handles
char	FNAME;			\Current file name
define	FNMMAX=80;		\File name size


integer
	PSIZE,	\PROM SIZE
	ERRFLG,	\ERROR FLAG
	BPTR,	\BUFFER POINTER
	BUFSIZ,	\SIZE BUFFER RESERVE
	SLOT,	\SLOT FOR SERIAL CARD
	DSK,	\DISK CHANNEL
	BYTE,	\GLOBAL BYTE
	DC;	\GLOBAL CHAR FROM DISK

define
	KAY=1024;


address
	BUFFER;		\ROM DATA BUFFER


define	\SOME CHARACTERS

	BEL=7,		\BELL CHARACTER
	ESC=$1B,	\ESCAPE
	DEL=$7F,	\DELETE
	SP=$20,		\SPACE
	BS=8,		\BACKSPACE
	FF=$0C,		\FORM FEED
	EOF=$1A,	\END OF FILE
	CTC=3,		\CONTROL-C
	CR=$0D,		\CARRIAGE RETURN
	LF=$0A;		\LINE FEED



integer
	COMPORT,	\CURRENT SERIAL COMPORT
	CPUREG;		\CPU REGISTER FOR DOS CALLS

integer
	BAUD,		\DEFAULT BAUD RATE
	BTABLE;		\BAUD RATE TABLE

integer 
	BASE,		\BASE PORT ADDRESS OF SERIAL PORT
	DATA,		\SERIAL PORT DATA REGISTER
	STATUS,		\SERIAL PORT STATUS REGISTER
	MCONTROL,	\SERIAL PORT MODEM CONTROL REGISTER
	LCONTROL;	\SERIAL PORT LINE CONTROL REGISTER




procedure GETSTR(S,L);
\RETURN OF STRING OF L LENGTH
char S;int L,P;
begin
OPENI(0);
loop [for P:=0,L-1 do [S(P):=CHIN(0);if S(P)=CR then quit;];quit;];
if P>0 then S(P-1):=S(P-1) ! $80 else S(0):=SP!$80;
end;




procedure SETSER;
\SET SERIAL PORT
integer TEMP;
begin
CPUREG(0):=BTABLE(BAUD,1);;
CPUREG(3):=COMPORT;
SOFTINT($14);

\SET PORT BASE ADDRESS
case COMPORT of
	0: BASE:=$3F8;
	1: BASE:=$2F8
else;
DATA:=BASE;
STATUS:=BASE+5;
MCONTROL:=BASE+4;
LCONTROL:=BASE+3;

\SELECT PRIMARY REGISTER SET
TEMP:=PIN(LCONTROL,0) & $7F;
POUT(TEMP,LCONTROL,0);
\TURN ON RTS AND DTR
POUT($03,MCONTROL,0);
end;



procedure SEROUT(CHAR);
\WRITE ONE SERIAL CHARACTER
integer CHAR;
begin
repeat until (PIN(STATUS,0) & $20) # 0;
POUT(CHAR,DATA,0);
end;



procedure SERTEST;
\TEST FOR SERIAL CHARACTER WAITING
return (PIN(STATUS,0) & 1) # 0;



procedure SERIN;
\READ ONE CHARACTER FROM PORT
begin
repeat until (PIN(STATUS,0) & 1) # 0;
return PIN(DATA,0);
end;




procedure GETCONFIG;
begin
CHOUT(0,$0C);
COMPORT:=COMPORT+1;
loop
	begin
	CHOUT(0,$0C);
	CURSOR(20,10);
	TEXT(0,"COM PORT: ");
	INTOUT(0,COMPORT);
	if CHIN(1)=CR then quit;
	COMPORT:=if COMPORT=4 then 1 else COMPORT+1;
	end;

COMPORT:=COMPORT-1;

loop
	begin
	CHOUT(0,$0C);
	CURSOR(20,10);
	TEXT(0,"BAUD RATE: ");
	INTOUT(0,BTABLE(BAUD,0));
	if CHIN(1)=CR then quit;
	BAUD:=BAUD+1;
	if BTABLE(BAUD,0)=0 then BAUD:=0;	
	end;
SETSER;
end;


procedure GETDC;
DC:=CHIN(DSK);



procedure BLANK;
CHOUT(0,FF);



procedure WAIT;
integer X;
begin
TEXT(0,"HIT ANY KEY ");
X:=CHIN(1);
end;



procedure NIBBLE(C);
integer C;
return if C>=^A then C-^A+10 else C-^0;



procedure GETBYT;
begin
BYTE:=NIBBLE(DC);
GETDC;
BYTE:=(16*BYTE)+NIBBLE(DC);
end;


procedure GETWRD;
integer W;
begin
GETDC;
GETBYT;
W:=BYTE;
GETDC;
GETBYT;
return SWAP(W)+BYTE;
end;



procedure BYTOUT(D,B);
integer D,B;

procedure HEXC(C);
integer C;
begin
C:=C&$F;
return if C>9 then C-10+^A else C+^0;
 end;


begin
CHOUT(D,HEXC(B/16));
CHOUT(D,HEXC(B));
end;



procedure COMTST;
integer X;
begin
repeat
	begin
	SEROUT($AA);
	X:=SERIN;
	CHOUT(0,^*);
	end
until CHKKEY;
X:=CHIN(1);
end;



procedure GETIFILE;
\Get input file
begin
BLANK;
TEXT(0,"ENTER INPUT FILE NAME (BIN): ");
GETSTR(FNAME,FNMMAX);
INHAND:=FOPEN(FNAME,0);
FSET(INHAND,^I);
end;



procedure GETOFILE;
\Get output file
begin
BLANK;
TEXT(0,"ENTER OUTPUT FILE NAME (BIN): ");
GETSTR(FNAME,FNMMAX);
OUTHAND:=FOPEN(FNAME,1);
FSET(OUTHAND,^O);
end;



procedure FILLBUF;
integer BASE;
begin
GETIFILE;
OPENI(DSK);
GETDC;
if DC#^* then
	begin
	TEXT(0,"!!NO BASE ADDRESS!!");
	return;
	end;
BASE:=GETWRD;
BPTR:=0;
loop
	begin
	GETDC;
	if DC=^* then
		begin
		TEXT(0,"old PTR=");
		INTOUT(0,BPTR);
		BPTR:=GETWRD-BASE;
		GETDC;
		TEXT(0,"  new PTR=");
		INTOUT(0,BPTR);CRLF(0);
		end;
	if BPTR>=BUFSIZ ! DC=EOF then quit;
	GETBYT;
	BUFFER(BPTR):=BYTE;
	BPTR:=BPTR+1;
	end;
CRLF(0);CRLF(0);
TEXT(0,"FINAL size= ");
INTOUT(0,BPTR);CRLF(0);
FCLOSE(INHAND);
end;



procedure DISERR(ADD,GOOD,BAD);
integer ADD,GOOD,BAD;
begin
CURSOR(0,20);
TEXT(0,"ADDRESS=");
HEXOUT(0,ADD);
TEXT(0,"  GOOD=");
HEXOUT(0,GOOD);
TEXT(0,"BAD=");
HEXOUT(0,BAD);
CRLF(0);
end;



procedure ETEST;
integer X,C;
begin
BLANK;
TEXT(0,"
*** TEST FOR GOOD  ERASE ***

   TURN off EPROM POWER SWITCH

   SET TO read MODE

   TURN on EPROM POWER SWITCH

");
WAIT;
ERRFLG:=false;
for X:=0,PSIZE-1 do
	begin
	SEROUT($FF);
	C:=SERIN;
	if C#$FF then
		begin
		DISERR(X,$FF,C);
		ERRFLG:=true;
		end;
	CURSOR(5,18);
	INTOUT(0,X);
	end;
if ERRFLG then TEXT(0,"ERASE errors!!")
else TEXT(0,"good ERASE");
CRLF(0);

end;



procedure VERIFY;
integer X,C;
begin
BLANK;
TEXT(0,"
*** VERIFY GOOD BLAST ***

   TURN off EPROM POWER SWITCH

   SET TO read MODE

   TURN on EPROM POWER SWITCH
");
WAIT;
ERRFLG:=false;
for X:=0,PSIZE-1 do
	begin
	SEROUT($FF);
	C:=SERIN;
	if C#BUFFER(X) then
		begin
		DISERR(X,BUFFER(X),C);
		ERRFLG:=true;
		end;
	CURSOR(5,18);
	INTOUT(0,X);
	end;
CRLF(0);
if ERRFLG then TEXT(0,"BLAST errors!!")
else TEXT(0,"good BLAST");
CRLF(0);
end;





procedure BLAST;
integer X,D;
begin
BLANK;
TEXT(0,"
*** BLAST ROM ***


   TURN off EPROM POWER SWITCH

   SET TO write MODE

   TURN on EPROM POWER SWITCH

");
WAIT;
for X:=0,PSIZE-1 do
	begin
	SEROUT(BUFFER(X));
	D:=SERIN;
	CURSOR(5,18);
	INTOUT(0,X);
	end;
CRLF(0);
end;



procedure REDROM;
integer X,C;
begin
BLANK;
TEXT(0,"
*** READ ROM ***

   TURN off EPROM POWER SWITCH

   SET TO read MODE

   TURN on EPROM POWER SWITCH

");
WAIT;
for X:=0,PSIZE-1 do
	begin
	SEROUT($FF);
	C:=SERIN;
	BUFFER(X):=C;
	CURSOR(5,18);
	INTOUT(0,X);
	end;
CRLF(0);
end;



procedure PRESET;
integer X,C,V;
begin
BLANK;
TEXT(0,"
*** PRESET BUFFER ***

ENTER VALUE TO PRESET IN hex");
V:=HEXIN(0);
WAIT;
for X:=0,PSIZE-1 do BUFFER(X):=V;
CRLF(0);
end;




procedure AWRITE;
integer X,C;
begin
GETOFILE;
BLANK;
TEXT(0,"
*** WRITE ARRAY TO DISK ***
");
WAIT;
OPENO(DSK);
TEXT(DSK,"*0000");
for X:=0,PSIZE-1 do BYTOUT(DSK,BUFFER(X));
CHOUT(DSK,EOF);
CLOSE(DSK);
FCLOSE(OUTHAND);
CRLF(0);
end;



procedure MENU;
integer COM;
begin
WAIT;
BLANK;
TEXT(0,"

**** APOTECK BLASTER ****

1) TEST ERASED
2) READ FILE FROM DISK
3) BLAST ROM
4) VERIFY BLAST

5) COMMUNICATION TEST
6) READ ROM INTO ARRAY
7) PRESET ARRAY

8) WRITE ARRAY TO DISK

select ONE 
");
COM:=INTIN(0);
case COM of
	1: ETEST;
	2: FILLBUF;
	3: BLAST;
	4: VERIFY;
	5: COMTST;
	6: REDROM;
	7: PRESET;
	8: AWRITE

else;
end;



procedure SETUP;
begin
BLANK;
SETSER;
TEXT(0,"

ENTER PROM SIZE IN K

   2716  =  2K
   2732  =  4K
   2764  =  8K
   27128 =  16K

");
PSIZE:=INTIN(0)*KAY;
end;


procedure INSTRUCTS;
begin
BLANK;
RAWTEXT(6,"
    ͻ
                                                                         
                   PROGRAM TO BLAST ROMS IN THE APROTECK 1000            
                               EPROM PROGRAMMER                          
    Ķ
                                                                         
                 NOTE: Programmer plugs directly into modem cable.       
                                                                         
                                                                         
                                                                         
                                                                         
                                                                         
                                                                         
                                                                         
    ͼ ");
CRLF(0);
WAIT;
end;








begin	\MAIN
CPUREG:=GETREG;
FNAME:=RESERVE(FNMMAX);
BTABLE:=[[110,$03],[150,$23],[300,$43],
	[1200,$83],[2400,$A3],[4800,$C3],[9600,$E3],[0,0]];

BUFSIZ:=16*1024;
BUFFER:=RESERVE(BUFSIZ);
BAUD:=6;
COMPORT:=1;
INSTRUCTS;

SETSER;
SETUP;
DSK:=3;

loop MENU;
end;
